ASPx.IS(function(ASPx, dx, DevExpress){
(function module(ASPx, options) {
ASPx.modules.Classes = module;
ASPx.classesScriptParsed = false;
ASPx.documentLoaded = false; 
ASPx.CallbackType = {
 Data: "d",
 Common: "c"
};
ASPx.callbackState = {
 aborted: "aborted",
 inTurn: "inTurn",
 sent: "sent"
};
var ASPxClientEvent = ASPx.CreateClass(null, {
 constructor: function() {
  this.handlerInfoList = [];
  this.firingIndex = -1;
 },
 AddHandler: function(handler, executionContext) {
  if(typeof(executionContext) == "undefined")
   executionContext = null;
  this.RemoveHandler(handler, executionContext);
  var handlerInfo = ASPxClientEvent.CreateHandlerInfo(handler, executionContext);
  this.handlerInfoList.push(handlerInfo);
 },
 RemoveHandler: function(handler, executionContext) {
  this.removeHandlerByCondition(function(handlerInfo) {
   return handlerInfo.handler == handler && 
    (!executionContext || handlerInfo.executionContext == executionContext);
  });
 },
 removeHandlerByCondition: function(predicate) {
   for(var i = this.handlerInfoList.length - 1; i >= 0; i--) {
   var handlerInfo = this.handlerInfoList[i];
   if(predicate(handlerInfo)) {
    ASPx.Data.ArrayRemoveAt(this.handlerInfoList, i);
    if(i <= this.firingIndex)
     this.firingIndex--;
   }
  }
 },
 removeHandlerByControlName: function(controlName) {
  this.removeHandlerByCondition(function(handlerInfo) {
   return handlerInfo.executionContext &&  
    handlerInfo.executionContext.name === controlName;
  });
 },
 ClearHandlers: function() {
  this.handlerInfoList.length = 0;
 },
 FireEvent: function(obj, args) {
  for(this.firingIndex = 0; this.firingIndex < this.handlerInfoList.length; this.firingIndex++) {
   var handlerInfo = this.handlerInfoList[this.firingIndex];
   handlerInfo.handler.call(handlerInfo.executionContext, obj, args);
  }
 },
 InsertFirstHandler: function(handler, executionContext){
  if(typeof(executionContext) == "undefined")
   executionContext = null;
  var handlerInfo = ASPxClientEvent.CreateHandlerInfo(handler, executionContext);
  ASPx.Data.ArrayInsert(this.handlerInfoList, handlerInfo, 0);
 },
 IsEmpty: function() {
  return this.handlerInfoList.length == 0;
 }
});
ASPxClientEvent.CreateHandlerInfo = function(handler, executionContext) {
 return {
  handler: handler,
  executionContext: executionContext
 };
};
var ASPxClientEventArgs = ASPx.CreateClass(null, {
 constructor: function() {
 }
});
ASPxClientEventArgs.Empty = new ASPxClientEventArgs();
var ASPxClientCancelEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(){
  this.constructor.prototype.constructor.call(this);
  this.cancel = false;
 }
});
var ASPxClientProcessingModeEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(processOnServer){
  this.constructor.prototype.constructor.call(this);
  this.processOnServer = !!processOnServer;
 }
});
var ASPxClientProcessingModeCancelEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(processOnServer){
  this.constructor.prototype.constructor.call(this, processOnServer);
  this.cancel = false;
 }
});
var OrderedMap = ASPx.CreateClass(null, {
 constructor: function(){
  this.entries = {};
  this.firstEntry = null;
  this.lastEntry = null;
 },
 add: function(key, element) {
  var entry = this.addEntry(key, element);
  this.entries[key] = entry;
 },
 remove: function(key) {
  var entry = this.entries[key];
  if(entry === undefined)
   return;
  this.removeEntry(entry);
  delete this.entries[key];
 },
 clear: function() {
  this.markAllEntriesAsRemoved();
  this.entries = {};
  this.firstEntry = null;
  this.lastEntry = null;
 },
 get: function(key) {
  var entry = this.entries[key];
  return entry ? entry.value : undefined;
 },
 forEachEntry: function(processFunc, context) {
  context = context || this;
  for(var entry = this.firstEntry; entry; entry = entry.next) {
   if(entry.removed)
    continue;
   if(processFunc.call(context, entry.key, entry.value))
    return;
  }
 },
 addEntry: function(key, element) {
  var entry = { key: key, value: element, next: null, prev: null };
  if(!this.firstEntry)
   this.firstEntry = entry;
  else {
   entry.prev = this.lastEntry;
   this.lastEntry.next = entry;
  }
  this.lastEntry = entry;
  return entry;
 },
 removeEntry: function(entry) {
  if(this.firstEntry == entry)
   this.firstEntry = entry.next;
  if(this.lastEntry == entry)
   this.lastEntry = entry.prev;
  if(entry.prev)
   entry.prev.next = entry.next;
  if(entry.next)
   entry.next.prev = entry.prev;
  entry.removed = true;
 },
 markAllEntriesAsRemoved: function() {
  for(var entry = this.firstEntry; entry; entry = entry.next)
   entry.removed = true;
 }
});
var CollectionBase = ASPx.CreateClass(null, {
 constructor: function(){
  this.elementsMap = new OrderedMap();
  this.isASPxClientCollection = true;
 },
 Add: function(key, element) {
  this.elementsMap.add(key, element);
 },
 Remove: function(key) {
  this.elementsMap.remove(key);
 },
 Clear: function(){
  this.elementsMap.clear();
 },
 Get: function(key){
  return this.elementsMap.get(key);
 }
});
(function garbageCollector(ASPx, options) {
 ASPx.modules.garbageCollector = garbageCollector;
 var interval = options.GCCheckInterval;
 window.setInterval(collectObjects, interval);
 function canCollectObjects() {
  if (!ASPx.GetControlCollection) return false;
  var collection = ASPx.GetControlCollection();
  return collection && !collection.InCallback();
 }
 function collectObjects() {
  if (!canCollectObjects()) return;
  ASPx.GetControlCollectionCollection().RemoveDisposedControls();
  if(typeof(ASPx.GetStateController) != "undefined")
   ASPx.GetStateController().RemoveDisposedItems();
  if(ASPx.TableScrollHelperCollection)
   ASPx.TableScrollHelperCollection.RemoveDisposedObjects();
  if(ASPx.Ident.scripts.ASPxClientRatingControl)
   ASPxClientRatingControl.RemoveDisposedElementUnderCursor();
  var postHandler = ASPx.GetPostHandler();
  if(postHandler)
   postHandler.RemoveDisposedFormsFromCache();
 }
})(ASPx, options);
var ControlTree = ASPx.CreateClass(null, {
 constructor: function(controlCollection, container, controlFilter) {
  this.container = container;
  this.domMap = { };
  this.rootNode = this.createNode(null, null);
  this.createControlTree(controlCollection, container, controlFilter);
 },
 createControlTree: function(controlCollection, container, controlFilter) {
  controlCollection.ProcessControlsInContainer(container, function(control) {
   control.RegisterInControlTree(this);
  }.aspxBind(this), controlFilter);
  var fixedNodes = [];
  var fixedNodesChildren = [];
  for(var domElementID in this.domMap) {
   if(!this.domMap.hasOwnProperty(domElementID)) continue;
   var node = this.domMap[domElementID];
   var controlOwner = node.control ? node.control.controlOwner : null;
   if(controlOwner && this.domMap[controlOwner.name])
    continue;
   if(this.isFixedNode(node))
    fixedNodes.push(node);
   else {
    var parentNode = this.findParentNode(domElementID);
    parentNode = parentNode || this.rootNode;
    if(this.isFixedNode(parentNode))
     fixedNodesChildren.push(node);
    else {
     var childNode = node.mainNode || node;
     this.addChildNode(parentNode, childNode);
    }
   }
  }
  for(var i = fixedNodes.length - 1; i >= 0; i--)
   this.insertChildNode(this.rootNode, fixedNodes[i], 0);
  for(var i = fixedNodesChildren.length - 1; i >= 0; i--)
   this.insertChildNode(this.rootNode, fixedNodesChildren[i], 0);
 },
 findParentNode: function(id) {
  var element = document.getElementById(id).parentNode;
  while(element && element.tagName !== "BODY") {
   if(element.id) {
    var parentNode = this.domMap[element.id];
    if(parentNode)
     return parentNode;
   }
   element = element.parentNode;
  }
  return null;
 },
 addChildNode: function(node, childNode) {
  if(!childNode.parentNode) {
   node.children.push(childNode);
   childNode.parentNode = node;
  }
 },
 insertChildNode: function(node, childNode, index) {
  if(!childNode.parentNode) {
   ASPx.Data.ArrayInsert(node.children, childNode, index);
   childNode.parentNode = node;
  }
 },
 addRelatedNode: function(node, relatedNode) {
  this.addChildNode(node, relatedNode);
  relatedNode.mainNode = node;
 },
 isFixedNode: function(node) {
  var control = node.mainNode ? node.mainNode.control : node.control;
  return control && control.HasFixedPosition();
 },
 createNode: function(domElementID, control) {
  var node = {
   control: control,
   children: [],
   parentNode: null,
   mainNode: null
  };
  if(domElementID)
   this.domMap[domElementID] = node;
  return node;
 }
});
var ControlAdjuster = ASPx.CreateClass(null, {
 constructor: function() {
 },
 adjustControlsInHierarchy: function(controlCollection, adjustFunc, container, collapseControls, controlFilter) {
  var controlTree = new ASPx.ControlTree(controlCollection, container, controlFilter);
  this.adjustControlsInTree(controlTree.rootNode, adjustFunc, container, collapseControls);
 },
 adjustControlsInTree: function(treeNode, adjustFunc, container, collapseControls) {
  var observer = _aspxGetDomObserver();
  observer.pause(container, true);
  var documentScrollInfo;
  if(collapseControls) {
   documentScrollInfo = ASPx.GetOuterScrollPosition(document.body);
   this.collapseControls(treeNode);
  }
  var adjustNodes = [], 
   autoHeightNodes = [];
  var requireReAdjust = this.forEachControlCore(treeNode, collapseControls, adjustFunc, adjustNodes, autoHeightNodes);
  if(requireReAdjust)
   this.forEachControlsBackward(adjustNodes, collapseControls, adjustFunc);
  else {
   for(var i = 0, node; node = autoHeightNodes[i]; i++)
    node.control.AdjustAutoHeight();
  }
  if(collapseControls)
   ASPx.RestoreOuterScrollPosition(documentScrollInfo);
  observer.resume(container, true);
 },
 forEachControlCore: function(node, collapseControls, processFunc, adjustNodes, autoHeightNodes) {
  var requireReAdjust = false,
   size, newSize;
  if(node.control) {
   var checkReadjustment = collapseControls && node.control.IsControlCollapsed() && node.control.CanCauseReadjustment();
   if(checkReadjustment)
    size = node.control.GetControlPercentMarkerSize(false, true);
   if(node.control.IsControlCollapsed() && !node.control.IsExpandableByAdjustment())
    node.control.ExpandControl();
   node.control.isInsideHierarchyAdjustment = true;
   processFunc(node.control);
   node.control.isInsideHierarchyAdjustment = false;
   if(checkReadjustment) {
    newSize = node.control.GetControlPercentMarkerSize(false, true);
    requireReAdjust = size.width !== newSize.width;
   }
   if(node.control.sizingConfig.supportAutoHeight)
    autoHeightNodes.push(node);
   node.control.ResetControlPercentMarkerSize();
  }
  for(var childNode, i = 0; childNode = node.children[i]; i++)
   requireReAdjust = this.forEachControlCore(childNode, collapseControls, processFunc, adjustNodes, autoHeightNodes) || requireReAdjust;
  adjustNodes.push(node);
  return requireReAdjust;
 },
 forEachControlsBackward: function(adjustNodes, collapseControls, processFunc) {
  for(var i = 0, node; node = adjustNodes[i]; i++)
   this.forEachControlsBackwardCore(node, collapseControls, processFunc);
 },
 forEachControlsBackwardCore: function(node, collapseControls, processFunc) {
  if(node.control)
   processFunc(node.control);
  if(node.children.length > 1) {
   for(var i = 0, childNode; childNode = node.children[i]; i++) {
    if(childNode.control)
     processFunc(childNode.control);
   }
  }
 },
 collapseControls: function(node) {
  for(var childNode, i = 0; childNode = node.children[i]; i++)
   this.collapseControls(childNode);
  if(node.control && node.control.NeedCollapseControl())
   node.control.CollapseControl();
 }
});
var controlAdjuster = null;
function GetControlAdjuster() {
 if(!controlAdjuster)
  controlAdjuster = new ControlAdjuster();
 return controlAdjuster;
}
function _aspxFunctionIsInCallstack(currentCallee, targetFunction, depthLimit) {
 var candidate = currentCallee;
 var depth = 0;
 while(candidate && depth <= depthLimit) {
  candidate = candidate.caller;
  if(candidate == targetFunction)
   return true;
  depth++;
 }
 return false;
}
ASPx.attachToReady(aspxClassesWindowOnLoad);
function aspxClassesWindowOnLoad(){
 ASPx.documentLoaded = true;
 _aspxMoveLinkElements();
 _aspxSweepDuplicatedLinks();
 ResourceManager.SynchronizeResources();
 var externalScriptProcessor = GetExternalScriptProcessor();
 if(externalScriptProcessor)
  externalScriptProcessor.ShowErrorMessages();
 ASPx.AccessibilityUtils.initialize();
 ASPx.GetControlCollection().Initialize();
 _aspxInitializeScripts();
 _aspxInitializeLinks();
 _aspxInitializeFocus();
 ASPx.GetControlCollection().FinalizeInitialization();
}
Ident = { };
Ident.IsDate = function(obj) {
 return obj && obj.constructor == Date;
};
Ident.IsRegExp = function(obj) {
 return obj && obj.constructor === RegExp;
};
Ident.IsArray = function(obj) {
 return obj && obj.constructor == Array;
};
Ident.IsASPxClientCollection = function(obj) {
 return obj && obj.isASPxClientCollection;
};
Ident.IsASPxClientControl = function(obj) {
 return obj && obj instanceof ASPxClientControlBase;
};
Ident.IsASPxClientEdit = function(obj) {
 return obj && obj.isASPxClientEdit;
};
Ident.IsFocusableElementRegardlessTabIndex = function (element) {
 var tagName = element.tagName;
 return tagName == "TEXTAREA" || tagName == "INPUT" || tagName == "A" ||
  tagName == "SELECT" || tagName == "IFRAME" || tagName == "OBJECT" || tagName == "BUTTON";
};
Ident.isDialogInvisibleControl = function(control) {
 return !!ASPx.Dialog && ASPx.Dialog.isDialogInvisibleControl(control);
};
Ident.isBatchEditUnusedEditor = function(control) {
 return !!ASPx.BatchEditHelper && ASPx.BatchEditHelper.isBatchEditUnusedEditor(control);
};
Ident.scripts = {};
if(ASPx.IsFunction(window.WebForm_InitCallbackAddField)) {
 (function() {
  var original = window.WebForm_InitCallbackAddField;
  window.WebForm_InitCallbackAddField = function(name, value) {
   if(typeof(name) == "string" && name)
    original.apply(null, arguments);
  };
 })();
}
ASPx.FireDefaultButton = function(evt, buttonID) {
 if(_aspxIsDefaultButtonEvent(evt, buttonID)) {
  var defaultButton = ASPx.GetElementById(buttonID);
  if(defaultButton && defaultButton.click) {
   if(ASPx.IsFocusable(defaultButton))
    defaultButton.focus();
   ASPx.Evt.DoElementClick(defaultButton);
   ASPx.Evt.PreventEventAndBubble(evt);
   return false;
  }
 }
 return true;
};
function _aspxIsDefaultButtonEvent(evt, defaultButtonID) {
 if(evt.keyCode != ASPx.Key.Enter)
  return false;
 var srcElement = ASPx.Evt.GetEventSource(evt);
 if(!srcElement || srcElement.id === defaultButtonID)
  return true;
 var tagName = srcElement.tagName;
 var type = srcElement.type;
 return tagName != "TEXTAREA" && tagName != "BUTTON" && tagName != "A" &&
  (tagName != "INPUT" || type != "checkbox" && type != "radio" && type != "button" && type != "submit" && type != "reset");
}
var PostHandler = ASPx.CreateClass(null, {
 constructor: function() {
  this.Post = new ASPxClientEvent();
  this.PostFinalization = new ASPxClientEvent();
  this.observableForms = [];
  this.dxCallbackTriggers = {};
  this.lastSubmitElementName = null;
  this.beforeOnSubmit = function() { };
  this.ReplaceGlobalPostFunctions();
  this.HandleDxCallbackBeginning();
  this.HandleMSAjaxRequestBeginning();
 },
 Update: function() {
  this.ReplaceFormsSubmit(true);
 },
 ProcessPostRequest: function(ownerID, isCallback, isMSAjaxRequest, isDXCallback) {
  this.cancelPostProcessing = false;
  this.isMSAjaxRequest = isMSAjaxRequest;
  if(this.SkipRaiseOnPost(ownerID, isCallback, isDXCallback))
   return;
  var args = new PostHandlerOnPostEventArgs(ownerID, isCallback, isMSAjaxRequest, isDXCallback);
  this.Post.FireEvent(this, args);
  this.cancelPostProcessing = args.cancel;
  if(!args.cancel)
   this.PostFinalization.FireEvent(this, args);
 },
 SkipRaiseOnPost: function(ownerID, isCallback, isDXCallback) { 
  if(!isCallback)
   return false;
  var dxOwner = isDXCallback && ASPx.GetControlCollection().GetByName(ownerID);
  if(dxOwner) {
   this.dxCallbackTriggers[dxOwner.uniqueID] = true;
   return false;
  }
  if(this.dxCallbackTriggers[ownerID]) {
   this.dxCallbackTriggers[ownerID] = false;
   return true;
  }
  return false;
 },
 ReplaceGlobalPostFunctions: function() {
  if(ASPx.IsFunction(window.__doPostBack))
   this.ReplaceDoPostBack();
  if(ASPx.IsFunction(window.WebForm_DoCallback))
   this.ReplaceDoCallback();
  if(ASPx.IsFunction(window.WebForm_ExecuteCallback))
   this.ReplaceExecuteCallback();
  this.ReplaceFormsSubmit();
 },
 HandleDxCallbackBeginning: function() {
  ASPx.GetControlCollection().BeforeInitCallback.AddHandler(function(s, e) {
   aspxRaisePostHandlerOnPost(e.callbackOwnerID, true, false, true); 
  });
 },
 HandleMSAjaxRequestBeginning: function() {
  var pageRequestManager = ASPx.GetMSAjaxRequestManager();
  if(pageRequestManager != null && Ident.IsArray(pageRequestManager._onSubmitStatements)) {
   pageRequestManager._onSubmitStatements.unshift(function() {
    var postbackSettings = Sys.WebForms.PageRequestManager.getInstance()._postBackSettings;
    var postHandler = aspxGetPostHandler();
    aspxRaisePostHandlerOnPost(postbackSettings.asyncTarget, true, true);
    return !postHandler.cancelPostProcessing;
   });
  }
 },
 ReplaceDoPostBack: function() {
  var original = __doPostBack;
  __doPostBack = function(eventTarget, eventArgument) {
   var postHandler = aspxGetPostHandler();
   aspxRaisePostHandlerOnPost(eventTarget);
   if(postHandler.cancelPostProcessing)
    return;
   ASPxClientControl.postHandlingLocked = true;
   original(eventTarget, eventArgument);
   delete ASPxClientControl.postHandlingLocked;
  };
 },
 ReplaceDoCallback: function() {
  var original = WebForm_DoCallback;
  WebForm_DoCallback = function(eventTarget, eventArgument, eventCallback, context, errorCallback, useAsync) {
   var postHandler = aspxGetPostHandler();
   aspxRaisePostHandlerOnPost(eventTarget, true);
   if(postHandler.cancelPostProcessing)
    return;
   return original(eventTarget, eventArgument, eventCallback, context, errorCallback, useAsync);
  };
 },
 ReplaceExecuteCallback: function() {
  var original = WebForm_ExecuteCallback;
  var handler = this;
  WebForm_ExecuteCallback = function(callbackObject) {
   var isDxCallback = callbackObject && callbackObject.context && ASPx.GetControlCollection().Get(callbackObject.context) !== null;
   ASPx.callbackProcessed = false;
   original(callbackObject);
   if(isDxCallback && !ASPx.callbackProcessed) {
    var request = callbackObject.xmlRequest;
    if(handler.HasAppErrorOnCallback(request) && ASPxClientUtils.IsExists(callbackObject.eventCallback))
     callbackObject.eventCallback(handler.GetServerErrorText(), callbackObject.context);
   }
  };
 },
 HasAppErrorOnCallback: function(request) {
  if(!request) return false;
  var isServerError = request.status && request.status == 500;
  var pattern = /<html[^>]*>([\w|\W]*)<\/html>/im;
  var text = request.responseText;
  return isServerError && !!text && pattern.test(text);
 },
 GetServerErrorText: function() {
  return "Internal Server Error";
 }, 
 ReplaceFormsSubmit: function(checkObservableCollection) {
  for(var i = 0; i < document.forms.length; i++) { 
   var form = document.forms[i];
   if(checkObservableCollection && ASPx.Data.ArrayIndexOf(this.observableForms, form) >= 0)
    continue;
   if(form.submit)
    this.ReplaceFormSubmit(form);
   this.ReplaceFormOnSumbit(form);
   this.observableForms.push(form);
  }
 },
 ReplaceFormSubmit: function(form) {
  var originalSubmit = form.submit;
  form.submit = function() {
   var postHandler = aspxGetPostHandler();
   aspxRaisePostHandlerOnPost();
   if(postHandler.cancelPostProcessing)
    return false;
   var callee = arguments.callee;
   this.submit = originalSubmit;
   var submitResult = this.submit();
   this.submit = callee;
   return submitResult;
  };
  form = null;
 },
 ReplaceFormOnSumbit: function(form) {
  var originalSubmit = form.onsubmit;
  form.onsubmit = function() {
   var postHandler = aspxGetPostHandler();
   postHandler.beforeOnSubmit();
   if(postHandler.isMSAjaxRequest)
    postHandler.isMsAjaxRequest = false;
   else
    aspxRaisePostHandlerOnPost(postHandler.GetLastSubmitElementName());
   if(postHandler.cancelPostProcessing)
    return false;
   return ASPx.IsFunction(originalSubmit)
    ? originalSubmit.apply(this, arguments)
    : true;
  };
  form = null;
 },
 SetBeforeOnSubmit: function(action) {
  this.beforeOnSubmit = action;
 },
 SetLastSubmitElementName: function(elementName) {
  this.lastSubmitElementName = elementName;
 },
 GetLastSubmitElementName: function() {
  return this.lastSubmitElementName;
 },
 RemoveDisposedFormsFromCache: function(){
  for(var i = 0; this.observableForms && i < this.observableForms.length; i++){
   var form = this.observableForms[i];
   if(!ASPx.IsExistsElement(form)){
    ASPx.Data.ArrayRemove(this.observableForms, form);
    i--;
   }
  }
 }
});
function aspxRaisePostHandlerOnPost(ownerID, isCallback, isMSAjaxRequest, isDXCallback) {
 if(ASPxClientControl.postHandlingLocked) return;
 var postHandler = aspxGetPostHandler();
 if(postHandler)
  postHandler.ProcessPostRequest(ownerID, isCallback, isMSAjaxRequest, isDXCallback);
}
var aspxPostHandler;
function aspxGetPostHandler() {
 if(!aspxPostHandler)
  aspxPostHandler = new PostHandler();
 return aspxPostHandler;
}
var PostHandlerOnPostEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(ownerID, isCallback, isMSAjaxCallback, isDXCallback){
  this.constructor.prototype.constructor.call(this);
  this.ownerID = ownerID;
  this.isCallback = !!isCallback;
  this.isDXCallback = !!isDXCallback;
  this.isMSAjaxCallback = !!isMSAjaxCallback;
 }
});
var ResourceManager = {
 HandlerStr: "DXR.axd?r=",
 ResourceHashes: {},
 SynchronizeResources: function(method){
  if(!method){
   method = function(name, resource) { 
    this.UpdateInputElements(name, resource); 
   }.aspxBind(this);
  }
  var resources = this.GetResourcesData();
  for(var name in resources)
   if(resources.hasOwnProperty(name))
    method(name, resources[name]);
 },
 GetResourcesData: function(){
  return {
   DXScript: this.GetResourcesElementsString(_aspxGetIncludeScripts(), "src", "DXScript"),
   DXCss: this.GetResourcesElementsString(_aspxGetLinks(), "href", "DXCss")
  };
 },
 ParseBundleSrc: function(elements, urlAttr){
  var timeStamp = "";
  var resourceUrlArray = [];
  for(var i = 0; i < elements.length; i++) {
   var resourceUrl = ASPx.Attr.GetAttribute(elements[i], urlAttr);
   if(resourceUrl) {
    var pos = resourceUrl.indexOf(this.HandlerStr);
    if(pos > -1){
     var list = resourceUrl.substr(pos + this.HandlerStr.length);
     var ampPos = list.lastIndexOf("-");
     if(ampPos > -1) {
      timeStamp = list.substr(ampPos);
      list = list.substr(0, ampPos);
     }
     var indexes = list.split(",");
     for(var j = 0; j < indexes.length; j++) {
      resourceUrlArray.push(indexes[j]);
     }
    }
    else
     resourceUrlArray.push(resourceUrl);
   }
  }
  return {
   'resourceUrlArray': resourceUrlArray,
   'timeStamp': timeStamp
  };
 },
 GetResourceHashes: function (id) {
  if (!this.ResourceHashes[id])
   this.ResourceHashes[id] = {};
  return this.ResourceHashes[id];
 },
 GetResourcesElementsString: function (elements, urlAttr, id) {
  var hash = this.GetResourceHashes(id);
  var resourceUrlArray = this.ParseBundleSrc(elements, urlAttr).resourceUrlArray;
  for(var i = 0; i < resourceUrlArray.length; i++) {
   hash[resourceUrlArray[i]] = resourceUrlArray[i];
  }
  var array = [];
  for(var key in hash)
   if(hash.hasOwnProperty(key))
    array.push(key);
  return array.join(",");
 },
 GetNewResourcesElementString: function (element, urlAttr, id) {
  var originalUrl = ASPx.Attr.GetAttribute(element, urlAttr);
  var handlerStrIndex = originalUrl.indexOf(this.HandlerStr);
  var dxResources = handlerStrIndex > -1;
  if(!dxResources) return element[urlAttr];
  var hash = this.GetResourceHashes(id);
  var srcInfo = this.ParseBundleSrc([element], urlAttr);
  var resourceUrlArray = srcInfo.resourceUrlArray;
  var timeStamp = srcInfo.timeStamp;
  var newResourceArray = [];
  for(var i = 0; i < resourceUrlArray.length; i++) {
    if(!hash[resourceUrlArray[i]])
    newResourceArray.push(resourceUrlArray[i]);
  }
  var newResources = "";
  if(newResourceArray.length > 0) {
   var baseUrl = originalUrl.substr(0, handlerStrIndex);
   newResources = baseUrl + this.HandlerStr + newResourceArray.join(",") + timeStamp;
  }
  return newResources;
 },
 UpdateInputElements: function(typeName, list){
  for(var i = 0; i < document.forms.length; i++){
   var inputElement = document.forms[i][typeName];
   if(!inputElement)
    inputElement = this.CreateInputElement(document.forms[i], typeName);
   inputElement.value = list;
  }
 },
 CreateInputElement: function(form, typeName){
  var inputElement = ASPx.CreateHiddenField(typeName);
  form.appendChild(inputElement);
  return inputElement;
 }
};
ASPx.includeScriptPrefix = "dxis_";
ASPx.startupScriptPrefix = "dxss_";
var includeScriptsCache = {};
var createdIncludeScripts = [];
var appendedScriptsCount = 0;
var callbackOwnerNames = [];
var scriptsRestartHandlers = { };
function _aspxIsKnownIncludeScript(script) {
 return !!includeScriptsCache[script.src];
}
function _aspxCacheIncludeScript(script) {
 includeScriptsCache[script.src] = 1;
}
function _aspxProcessScriptsAndLinks(ownerName, isCallback) {
 if(!ASPx.documentLoaded) return; 
 _aspxProcessScripts(ownerName, isCallback);
 getLinkProcessor().process();
 ASPx.ClearCachedCssRules();
}
function _aspxGetStartupScripts(container) {
 return _aspxGetScriptsCore(ASPx.startupScriptPrefix, container);
}
function _aspxGetIncludeScripts() {
 return _aspxGetScriptsCore(ASPx.includeScriptPrefix);
}
function _aspxGetScriptsCore(prefix, container) {
 var result = [];
 var scripts;
 if(ASPx.IsExists(container))
  scripts = ASPx.GetNodesByTagName(container, "SCRIPT");
 else
  scripts = document.getElementsByTagName("SCRIPT");
 for(var i = 0; i < scripts.length; i++) {
  if(scripts[i].id.indexOf(prefix) == 0)
   result.push(scripts[i]);
 }
 return result;
}
function _aspxIsResourceLink(link) {
 if(typeof link !== "string")
  link = link.href;
 return link.toLowerCase().indexOf(ResourceManager.HandlerStr.toLowerCase()) >= 0;
}
function _aspxGetLinks(allLinks) {
 var result = [];
 var links = document.getElementsByTagName("LINK");
 for(var i = 0; i < links.length; i++) {
  if(allLinks || _aspxIsResourceLink(links[i]))
   result.push(links[i]);
 }
 return result;
}
function _aspxIsLinksLoaded() {
 var links = _aspxGetLinks(true);
 for(var i = 0, link; link = links[i]; i++)
  if(link.readyState && link.readyState.toLowerCase() == "loading")
    return false;
 return true;
}
function _aspxInitializeLinks() {
 var links = _aspxGetLinks(true);
 for(var i = 0; i < links.length; i++)
  links[i].loaded = true; 
}
var scriptExecutedAttrName = "data-executed";
var scriptDelayedExecutionAttrName = "data-dx-delayedeval";
ASPx.MarkInnerScriptBlocksAsDelayedExecution = function(scriptsContainer) {
 var scripts = scriptsContainer.querySelectorAll("script[id^=" + ASPx.startupScriptPrefix + "]");
 for(var i = 0; i < scripts.length; i++)
  ASPx.Attr.SetAttribute(scripts[i], scriptDelayedExecutionAttrName, true);
};
function isScriptExecuted(script) {
 return ASPx.Attr.GetAttribute(script, scriptExecutedAttrName);
}
function markScriptAsExecuted(script) {
 if(ASPx.Attr.GetAttribute(script, scriptDelayedExecutionAttrName))
  ASPx.Attr.RemoveAttribute(script, scriptDelayedExecutionAttrName);
 else
  ASPx.Attr.SetAttribute(script, scriptExecutedAttrName, true);
}
function _aspxInitializeScripts() {
 var scripts = _aspxGetIncludeScripts();
 for(var i = 0; i < scripts.length; i++)
  _aspxCacheIncludeScript(scripts[i]);   
 var startupScripts = _aspxGetStartupScripts();
 for(var i = 0; i < startupScripts.length; i++)
  markScriptAsExecuted(startupScripts[i]);
}
function _aspxSweepDuplicatedLinks() {
 var hash = { };
 var links = _aspxGetLinks();
 for(var i = 0; i < links.length; i++) {
  var href = links[i].href;
  if(!href)
   continue;
  if(hash[href]){
   if((ASPx.Browser.IE || !hash[href].loaded) && links[i].loaded) {
    ASPx.RemoveElement(hash[href]);
    hash[href] = links[i];
   }
   else
    ASPx.RemoveElement(links[i]);
  }
  else
   hash[href] = links[i];
 }
}
function _aspxSweepDuplicatedScripts() {
 var hash = { };
 var scripts = _aspxGetIncludeScripts();
 for(var i = 0; i < scripts.length; i++) {
  var src = scripts[i].src;
  if(!src) continue;
  if(hash[src])
   ASPx.RemoveElement(scripts[i]);
  else
   hash[src] = scripts[i];
 }
}
function _aspxAreScriptsEqual(script1, script2) {
 return script1.src == script2.src;
}
function _aspxProcessScripts(ownerName, isCallback) {
 var scripts = _aspxGetIncludeScripts();
 var previousCreatedScript = null;
 var firstCreatedScript = null;
 for(var i = 0; i < scripts.length; i++) {
  var script = scripts[i];
  if(script.src == "") continue; 
  if(_aspxIsKnownIncludeScript(script))
   continue;
  var getOnlyNewResources = true;
  var onlyNewScripts = ResourceManager.GetNewResourcesElementString(script, "src", "DXScript", getOnlyNewResources);
  if (onlyNewScripts == "")
   continue;
  var createdScript = document.createElement("script");
  ASPx.Attr.AppendScriptType(createdScript);
  createdScript.src = onlyNewScripts;
  createdScript.id = script.id;
  if(ASPx.Data.ArrayIndexOf(createdIncludeScripts, createdScript, _aspxAreScriptsEqual) >= 0)
   continue;
  createdIncludeScripts.push(createdScript);
  ASPx.RemoveElement(script);
  if(ASPx.Browser.IE && ASPx.Browser.Version < 9) {
   createdScript.onreadystatechange = new Function("ASPx.OnScriptReadyStateChangedCallback(this, " + isCallback + ");");
  } else if(ASPx.Browser.Edge || ASPx.Browser.WebKitFamily || (ASPx.Browser.Firefox && ASPx.Browser.Version >= 4) || ASPx.Browser.IE && ASPx.Browser.Version >= 9) {
   createdScript.onload = new Function("ASPx.OnScriptLoadCallback(this, " + isCallback + ");");
   if(firstCreatedScript == null)
    firstCreatedScript = createdScript;
   createdScript.nextCreatedScript = null;
   if(previousCreatedScript != null)
    previousCreatedScript.nextCreatedScript = createdScript;
   previousCreatedScript = createdScript;
  } else {
   createdScript.onload = new Function("ASPx.OnScriptLoadCallback(this);");
   ASPx.AppendScript(createdScript);
   _aspxCacheIncludeScript(createdScript);
  }
 }
 if(firstCreatedScript != null) {
  ASPx.AppendScript(firstCreatedScript);
  _aspxCacheIncludeScript(firstCreatedScript);
 }
 if(isCallback)
  callbackOwnerNames.push(ownerName);
 if(createdIncludeScripts.length == 0) {
  var newLinks = ASPx.GetNodesByTagName(document.body, "link");
  var needProcessLinks = isCallback && newLinks.length > 0;
  if(needProcessLinks)
   needProcessLinks = getLinkProcessor().addLinks(newLinks);
  if(!needProcessLinks)
   ASPx.FinalizeScriptProcessing(isCallback);
 }
}
ASPx.FinalizeScriptProcessing = function(isCallback) {
 createdIncludeScripts = [];
 appendedScriptsCount = 0;
 var linkProcessor = getLinkProcessor();
 if(linkProcessor.hasLinks())
  _aspxSweepDuplicatedLinks();
 linkProcessor.reset();
 _aspxSweepDuplicatedScripts();
 ResourceManager.SynchronizeResources();
 _aspxRunStartupScripts(isCallback);
};
var startupScriptsRunning = false;
function _aspxRunStartupScripts(isCallback, container) {
 startupScriptsRunning = true;
 try {
  _aspxRunStartupScriptsCore(container);
 }
 finally {
  startupScriptsRunning = false;
 }
 if(ASPx.documentLoaded) {
  ASPx.GetControlCollection().ProcessActionByPredicate(
   function(collection) { collection.InitializeElements(isCallback); },
   function(control) { return !ASPx.IsExists(container) || ASPx.GetIsParent(container, control.GetMainElement()); }
  );
  for(var key in scriptsRestartHandlers)
   if(scriptsRestartHandlers.hasOwnProperty(key))
    scriptsRestartHandlers[key]();
  if(isCallback)
   _aspxRunEndCallbackScript();
 }
}
function _aspxIsStartupScriptsRunning(isCallback) {
 return startupScriptsRunning;
}
function _aspxRunStartupScriptsCore(container) {
 var scripts = _aspxGetStartupScripts(container);
 var code;
 for(var i = 0; i < scripts.length; i++){
  var script = scripts[i];
  if(!isScriptExecuted(script)) {
   _aspxEnsureStartupScriptIsUnique(script.id); 
   code = ASPx.GetScriptCode(script);
   eval(code);
   markScriptAsExecuted(script);
  }
 }
}
function _aspxEnsureStartupScriptIsUnique(scriptId) {
 if(!scriptId)
  return;
 var scriptExecutedSelector = "script[" + scriptExecutedAttrName + "='true']#" + scriptId;
 ASPx.RemoveElement(document.querySelector(scriptExecutedSelector));
}
function _aspxRunEndCallbackScript() {
 while(callbackOwnerNames.length > 0) {
  var callbackOwnerName = callbackOwnerNames.pop();
  var callbackOwner = ASPx.GetControlCollection().Get(callbackOwnerName);
  if(callbackOwner)
   callbackOwner.DoEndCallback();
 }
}
ASPx.RunStartupScriptsCreatedOnClient = function(container) {
 _aspxRunStartupScriptsCore(container);
};
ASPx.OnScriptReadyStateChangedCallback = function(scriptElement, isCallback) {
 if(scriptElement.readyState == "loaded") {
  _aspxCacheIncludeScript(scriptElement);
  for(var i = 0; i < createdIncludeScripts.length; i++) {
   var script = createdIncludeScripts[i];
   if(_aspxIsKnownIncludeScript(script)) {
    if(!isScriptExecuted(script)) {
     markScriptAsExecuted(script);
     ASPx.AppendScript(script);
     appendedScriptsCount++;
    }
   } else
    break;
  }
  if(createdIncludeScripts.length == appendedScriptsCount)
   ASPx.FinalizeScriptProcessing(isCallback);
 }
};
ASPx.OnScriptLoadCallback = function(scriptElement, isCallback) {
 appendedScriptsCount++;
 if(scriptElement.nextCreatedScript) {
  ASPx.AppendScript(scriptElement.nextCreatedScript);
  _aspxCacheIncludeScript(scriptElement.nextCreatedScript);
 }
 if(createdIncludeScripts.length == appendedScriptsCount)
  ASPx.FinalizeScriptProcessing(isCallback);
};
function _aspxAddScriptsRestartHandler(objectName, handler) {
 scriptsRestartHandlers[objectName] = handler;
}
function _aspxMoveLinkElements() {
 var head = ASPx.GetNodesByTagName(document, "head")[0];
 var bodyLinks = ASPx.GetNodesByTagName(document.body, "link");
 if(head && bodyLinks.length > 0){
  var headLinks = ASPx.GetNodesByTagName(head, "link");
  var dxLinkAnchor = head.firstChild;
  for(var i = 0; i < headLinks.length; i++){
   if(_aspxIsResourceLink(headLinks[i]))
    dxLinkAnchor = headLinks[i].nextSibling;
  }
  while(bodyLinks.length > 0) 
   head.insertBefore(bodyLinks[0], dxLinkAnchor);
 }
}
var LinkProcessor = ASPx.CreateClass(null, {
 constructor: function() {
  this.loadedLinkCount = 0;
  this.linkInfos = [];
  this.loadingObservationTimerID = -1;
 },
 process: function() {
  if(this.hasLinks()) {
   if(this.isLinkLoadEventSupported())
    this.processViaLoadEvent();
   else
    this.processViaTimer();
  }
  else
   _aspxSweepDuplicatedLinks();
  _aspxMoveLinkElements();
 },
 addLinks: function(links) {
  var prevLinkCount = this.linkInfos.length;
  for(var i = 0; i < links.length; i++) {
   var link = links[i];
   if(link.loaded || link.rel != "stylesheet" || !_aspxIsResourceLink(link))
    continue;
   var linkInfo = {
    link: link,
    href: link.href
   };
   this.linkInfos.push(linkInfo);
  }
  return prevLinkCount != this.linkInfos.length;
 },
 hasLinks: function() {
  return this.linkInfos.length > 0;
 },
 reset: function() {
  this.linkInfos = [];
  this.loadedLinkCount = 0;
 },
 processViaLoadEvent: function() {
  var that = this;
  for(var i = 0, linkInfo; linkInfo = this.linkInfos[i]; i++) {
   if(ASPx.Browser.IE && ASPx.Browser.Version < 9)
    linkInfo.link.onreadystatechange = function() { that.onLinkReadyStateChanged(this); };
   else
    linkInfo.link.onload = this.onLinkLoad.aspxBind(this);
  }
 },
 isLinkLoadEventSupported: function() {
  return !(ASPx.Browser.Chrome && ASPx.Browser.MajorVersion < 19 || ASPx.Browser.Firefox && ASPx.Browser.MajorVersion < 9 ||
   ASPx.Browser.Safari && ASPx.Browser.MajorVersion < 6 || ASPx.Browser.AndroidDefaultBrowser && ASPx.Browser.MajorVersion < 4.4);
 },
 processViaTimer: function() {
  if(this.loadingObservationTimerID == -1)
   this.onLinksLoadingObserve();
 },
 onLinksLoadingObserve: function() {
  if(this.getIsAllLinksLoaded()) {
   this.loadingObservationTimerID = -1;
   this.onAllLinksLoad();
  }
  else
   this.loadingObservationTimerID = window.setTimeout(this.onLinksLoadingObserve.aspxBind(this), 100);
 },
 getIsAllLinksLoaded: function() {
  var styleSheets = document.styleSheets;
  var loadedLinkHrefs = { };
  for(var i = 0; i < styleSheets.length; i++) {
   var styleSheet = styleSheets[i];
   try {
    if(styleSheet.cssRules)
     loadedLinkHrefs[styleSheet.href] = 1;
   }
   catch(ex) { }
  }
  var loadedLinksCount = 0;
  for(var i = 0, linkInfo; linkInfo = this.linkInfos[i]; i++) {
   if(loadedLinkHrefs[linkInfo.href])
    loadedLinksCount++;
  }
  return loadedLinksCount == this.linkInfos.length;
 },
 onAllLinksLoad: function() {
  this.reset();
  _aspxSweepDuplicatedLinks();
  if(createdIncludeScripts.length == 0)
   ASPx.FinalizeScriptProcessing(true);
 },
 onLinkReadyStateChanged: function(linkElement) {
  if(linkElement.readyState == "complete")
   this.onLinkLoadCore(linkElement);
 },
 onLinkLoad: function(evt) {
  var linkElement = ASPx.Evt.GetEventSource(evt);
  this.onLinkLoadCore(linkElement);
 },
 onLinkLoadCore: function(linkElement) {
  if(!this.hasLinkElement(linkElement)) return;
  this.loadedLinkCount++;
  if(!ASPx.Browser.Firefox && this.loadedLinkCount == this.linkInfos.length || 
   ASPx.Browser.Firefox && this.loadedLinkCount == 2 * this.linkInfos.length) {
   this.onAllLinksLoad();
  }
 },
 hasLinkElement: function(linkElement) {
  for(var i = 0, linkInfo; linkInfo = this.linkInfos[i]; i++) {
   if(linkInfo.link == linkElement)
    return true;
  }
  return false;
 }
});
var linkProcessor = null;
function getLinkProcessor() {
 if(linkProcessor == null)
  linkProcessor = new LinkProcessor();
 return linkProcessor;
}
ASPx.LinkProcessor = LinkProcessor;
var IFrameHelper = ASPx.CreateClass(null, {
 constructor: function(params) {
  this.params = params || {};
  this.params.src = this.params.src || "";
  this.CreateElements();
 },
 CreateElements: function() {
  var elements = IFrameHelper.Create(this.params);
  this.containerElement = elements.container;
  this.iframeElement = elements.iframe;
  this.AttachOnLoadHandler(this, this.iframeElement);
  this.SetLoading(true);
  if(this.params.onCreate)
   this.params.onCreate(this.containerElement, this.iframeElement);
 },
 AttachOnLoadHandler: function(instance, element) {
  ASPx.Evt.AttachEventToElement(element, "load", function() {
   instance.OnLoad(element);
  });
 },
 OnLoad: function(element) {
  this.SetLoading(false, element);
  if(!element.preventCustomOnLoad && this.params.onLoad)
   this.params.onLoad();
 },
 IsLoading: function(element) {
  element = element || this.iframeElement;
  if(element)
   return element.loading;
  return false;
 },
 SetLoading: function(value, element) {
  element = element || this.iframeElement;
  if(element)
   element.loading = value;
 },
 GetContentUrl: function() {
  return this.params.src;
 },
 SetContentUrl: function(url, preventBrowserCaching) {
  if(url) {
   this.params.src = url;
   if(preventBrowserCaching)
    url = IFrameHelper.AddRandomParamToUrl(url);
   this.SetLoading(true);
   this.iframeElement.src = url;
  }
 },
 RefreshContentUrl: function() {
  if(this.IsLoading())
   return;
  this.SetLoading(true);
  var oldContainerElement = this.containerElement;
  var oldIframeElement = this.iframeElement;
  var postfix = "_del" + Math.floor(Math.random()*100000).toString();
  if(this.params.id)
   oldIframeElement.id = this.params.id + postfix;
  if(this.params.name)
   oldIframeElement.name = this.params.name + postfix;
  ASPx.SetStyles(oldContainerElement, { height: 0 });
  this.CreateElements();
  oldIframeElement.preventCustomOnLoad = true;
  oldIframeElement.src = ASPx.BlankUrl;
  window.setTimeout(function() {
   oldContainerElement.parentNode.removeChild(oldContainerElement);
  }, 10000); 
 }
});
IFrameHelper.Create = function(params) {
 var iframeHtmlStringParts = [ "<iframe frameborder='0'" ];
 if(params) {
  if(params.id)
   iframeHtmlStringParts.push(" id='", params.id, "'");
  if(params.name)
   iframeHtmlStringParts.push(" name='", params.name, "'");
  if(params.title)
   iframeHtmlStringParts.push(" title='", params.title, "'");
  if(params.scrolling)
   iframeHtmlStringParts.push(" scrolling='", params.scrolling, "'");
  if(params.src)
   iframeHtmlStringParts.push(" src='", params.src, "'");
 }
 iframeHtmlStringParts.push("></iframe>");
 var containerElement = ASPx.CreateHtmlElementFromString("<div style='border-width: 0px; padding: 0px; margin: 0px'></div>");
 var iframeElement = ASPx.CreateHtmlElementFromString(iframeHtmlStringParts.join(""));
 containerElement.appendChild(iframeElement);
 return {
  container: containerElement,
  iframe: iframeElement
 };
};
IFrameHelper.AddRandomParamToUrl = function(url) {
 var prefix = url.indexOf("?") > -1
  ? "&"
  : "?";
 var param = prefix + Math.floor(Math.random()*100000).toString();
 var anchorIndex = url.indexOf("#");
 return anchorIndex == -1
  ? url + param
  : url.substr(0, anchorIndex) + param + url.substr(anchorIndex);
};
IFrameHelper.GetWindow = function(name) {
 if(ASPx.Browser.IE)
  return window.frames[name].window;
 else{
  var frameElement = document.getElementById(name);
  return (frameElement != null) ? frameElement.contentWindow : null;
 }
};
IFrameHelper.GetDocument = function(name) {
 var frameElement;
 if(ASPx.Browser.IE) {
  frameElement = window.frames[name];
  return (frameElement != null) ? frameElement.document : null;
 }
 else {
  frameElement = document.getElementById(name);
  return (frameElement != null) ? frameElement.contentDocument : null;
 }
};
IFrameHelper.GetDocumentBody = function(name) {
 var doc = IFrameHelper.GetDocument(name);
 return (doc != null) ? doc.body : null;
};
IFrameHelper.GetDocumentHead = function (name) {
 var doc = IFrameHelper.GetDocument(name);
 return (doc != null) ? doc.head || doc.getElementsByTagName('head')[0] : null;
};
IFrameHelper.GetElement = function(name) {
 if(ASPx.Browser.IE)
  return window.frames[name].window.frameElement;
 else
  return document.getElementById(name);
};
var KbdHelper = ASPx.CreateClass(null, {
 constructor: function(control) {
  this.control = control;
 },
 Init: function() {
  KbdHelper.GlobalInit();
  var elements = this.getFocusableElements();
  for(var i = 0; i < elements.length; i++) {
   var element = elements[i];
   element.tabIndex = Math.max(element.tabIndex, 0);
   ASPx.Evt.AttachEventToElement(element, "click", function(e) { this.HandleClick(e); }.aspxBind(this));
   ASPx.Evt.AttachEventToElement(element, "focus", function(e) {    
    return this.onElementFocus(e);
   }.aspxBind(this));
   ASPx.Evt.AttachEventToElement(element, "blur", function () { this.onBlur(); }.aspxBind(this)); 
  }   
 },
 onElementFocus: function(e) {
  if(!this.CanFocus(e))
   return true;
  KbdHelper.active = this;
 },
 getFocusableElements: function() {
  return [this.GetFocusableElement()]; 
 },
 GetFocusableElement: function() { return this.control.GetMainElement(); },
 canHandleNoFocusAction: function() { 
  var focusableElements = this.getFocusableElements();
  for(var i = 0; i < focusableElements.length; i++) {
   if(focusableElements[i] === _aspxGetFocusedElement())
    return false;
  }
  return true;
 },
 RequirePreventScrollOnFocus: function() { return false; },
 CanFocus: function(e) {
  var tag = ASPx.Evt.GetEventSource(e).tagName;
  return !(tag === "A" || tag === "TEXTAREA" || tag === "INPUT" || tag === "SELECT" || tag === "IFRAME" || tag === "OBJECT");
 },
 HandleClick: function(e) {
  if(!this.CanFocus(e))
   return;
  this.Focus();
 },
 Focus: function() {
  var preventScroll = this.RequirePreventScrollOnFocus() && !ASPx.Browser.IE; 
  var savedDocumentScrollTop = preventScroll ? ASPx.GetDocumentScrollTop() : -1;
  try {
   this.GetFocusableElement().focus({ preventScroll: preventScroll });
  } catch(e) { }
  if(preventScroll && !this.IsNativePreventScrollOnFocusSupported() && savedDocumentScrollTop !== ASPx.GetDocumentScrollTop())
   ASPx.SetDocumentScrollTop(savedDocumentScrollTop);
 },
 IsNativePreventScrollOnFocusSupported: function() {
  if(this.isNativePreventScrollOnFocusSupported === undefined)
   this.isNativePreventScrollOnFocusSupported = this.CalcIsNativePreventScrollOnFocusSupported();
  return this.isNativePreventScrollOnFocusSupported;
 },
 CalcIsNativePreventScrollOnFocusSupported: function() {
  var result = false;
  try {
   ASPx.GetActiveElement().focus(Object.defineProperty({}, "preventScroll", { get: function() { result = true; } }));
  } catch(e) { result = false; }
  return result;
 },
 onBlur: function(){
  delete KbdHelper.active;
 },
 HandleKeyDown: function(e) { }, 
 HandleKeyPress: function(e) { }, 
 HandleKeyUp: function (e) { },
 HandleNoFocusAction: function(e) { },
 FocusByAccessKey: function () { }
});
KbdHelper.GlobalInit = function() {
 if(KbdHelper.ready)
  return;
 ASPx.Evt.AttachEventToDocument("keydown", KbdHelper.OnKeyDown);
 ASPx.Evt.AttachEventToDocument("keypress", KbdHelper.OnKeyPress);
 ASPx.Evt.AttachEventToDocument("keyup", KbdHelper.OnKeyUp);
 KbdHelper.ready = true; 
};
KbdHelper.swallowKey = false;
KbdHelper.accessKeys = { };
KbdHelper.ProcessKey = function(e, actionName) {
 if(!KbdHelper.active) 
  return;
 if (KbdHelper.active.canHandleNoFocusAction()) {
  KbdHelper.active["HandleNoFocusAction"](e, actionName);
  return;
 }
 var ctl = KbdHelper.active.control;
 if(ctl !== ASPx.GetControlCollection().Get(ctl.name)) {
  delete KbdHelper.active;
  return;
 }
 if(!KbdHelper.swallowKey) 
  KbdHelper.swallowKey = KbdHelper.active[actionName](e);
 if(KbdHelper.swallowKey)
  ASPx.Evt.PreventEvent(e);
};
KbdHelper.OnKeyDown = function(e) {
 KbdHelper.swallowKey = false;
 if(KbdHelper.TryAccessKey(KbdHelper.getKeyName(e)))
  ASPx.Evt.PreventEvent(e);
 else 
  KbdHelper.ProcessKey(e, "HandleKeyDown"); 
};
KbdHelper.OnKeyPress = function(e) { KbdHelper.ProcessKey(e, "HandleKeyPress"); };
KbdHelper.OnKeyUp = function(e) { KbdHelper.ProcessKey(e, "HandleKeyUp"); };
KbdHelper.RegisterAccessKey = function(obj) {
 var key;
 if(obj.accessKey)
  key = "CtrlShift" + obj.accessKey;
 else if(obj.keyTipModeShortcut)
  key = obj.keyTipModeShortcut;
 if(!key) return;
 KbdHelper.accessKeys[key.toLowerCase()] = obj.name;
};
KbdHelper.TryAccessKey = function(code) {
 var key = code.toLowerCase ? code.toLowerCase() : String.fromCharCode(code).toLowerCase();
 var name = KbdHelper.accessKeys[key];
 if(!name) return false;
 var obj = ASPx.GetControlCollection().Get(name);
 return KbdHelper.ClickAccessKey(obj);
};
KbdHelper.ClickAccessKey = function (control) {
 if (!control) return false;
 var el = control.GetMainElement();
 if (!el) return false;
 el.focus();
 setTimeout(function () {
  if (KbdHelper.active && KbdHelper.active.FocusByAccessKey)
   KbdHelper.active.FocusByAccessKey();
 }.aspxBind(this), ASPx.FOCUS_TIMEOUT);
 return true;
};
KbdHelper.getKeyName = function(e) {
 var name = "";
 if(e.altKey)
  name += "Alt";
 if(e.ctrlKey)
  name += "Ctrl";
 if(e.shiftKey)
  name += "Shift";
 var keyCode = e.key || e.code || String.fromCharCode(ASPx.Evt.GetKeyCode(e));
 if(keyCode.match(/key/i))
  name += keyCode.replace(/key/i, "");
 else if(keyCode.match(/digit/i))
  name += keyCode.replace(/digit/i, "");
 else if(keyCode.match(/arrow/i))
  name += keyCode.replace(/arrow/i, "");
 else if(keyCode.match(/ins/i))
  name += "Ins";
 else if(keyCode.match(/del/i))
  name += "Del";
 else if(keyCode.match(/back/i))
  name += "Back";
 else if(!keyCode.match(/alt/i) && !keyCode.match(/control/i) && !keyCode.match(/shift/i))
  name += keyCode;
 return name.replace(/^a-zA-Z0-9/, "");
};
AccessKeysHelper = ASPx.CreateClass(KbdHelper, {
 constructor: function (control) {
  this.constructor.prototype.constructor.call(this, control);
  this.accessKeysVisible = false;
  this.activeKey = null;
  this.accessKey = control.createAccessKey ? control.createAccessKey(control.accessKey) : new AccessKey(control.accessKey);
  this.accessKeys = this.accessKey.accessKeys;
  this.charIndex = 0;
  this.onFocusByAccessKey = null;
  this.onClose = null;
  this.manualStopProcessing = false;
  this.isActive = false;
  this.areAccessKeysShown = false;
 },
 Init: function (control) {
  KbdHelper.prototype.Init.call(this);
  KbdHelper.RegisterAccessKey(control);   
 },
 Add: function (accessKey) {
  this.accessKey.Add(accessKey);
 },
 HandleKeyDown: function (e) {
  var keyCode = ASPx.Evt.GetKeyCode(e);
  var stopProcessing = this.processKeyDown(keyCode);
  if (stopProcessing.value) {
   this.stopProcessing();
   if(this.onClosedOnEscape && (keyCode == ASPx.Key.Esc || stopProcessing.fireEvent))
    this.onClosedOnEscape();
  }
  return stopProcessing;
 },
 HandleNoFocusAction: function (e, actionName) {
  var keyCode = ASPx.Evt.GetKeyCode(e);
  if (this.onClosedOnEscape && keyCode == ASPx.Key.Esc && actionName == "HandleKeyDown")
   this.onClosedOnEscape();
 },
 Activate: function () {
  KbdHelper.ClickAccessKey(this.control);
  this.areAccessKeysShown = true;
 },
 Stop: function() {
  this.stopProcessing();
 },
 stopProcessing: function () {
  this.HideAccessKeys();
  if (KbdHelper.active && this.isActive) {
   this.isActive = false;
   KbdHelper.active.control.GetMainElement().blur();
   delete KbdHelper.active;
  }
 },
 onBlur: function() {
  if (this.manualStopProcessing) {
   this.manualStopProcessing = false;
   return;
  }
  this.HideAccessKeys();
  KbdHelper.prototype.onBlur.call(this);
 },
 processKeyDown: function (keyCode) {
  switch (keyCode) {
   case ASPx.Key.Left:
    this.TryMoveFocusLeft();
    return { value: false };
   case ASPx.Key.Right:
    this.TryMoveFocusRight();
    return { value: false };
   case ASPx.Key.Esc:
    if(this.control.hideAllPopups)
     this.control.hideAllPopups(true, true);
    if(this.activeKey)
     this.activeKey = this.activeKey.Return();
    this.charIndex = 0;
    if (!this.activeKey)
     return { value: true };
    break;
   case ASPx.Key.Enter:
    return { value: true };
   default:
    if (!ASPx.IsPrintableKey(keyCode))
     return { value: false };
    var char = String.fromCharCode(keyCode).toUpperCase();
    var needToContinue = { value: false };
    var keyResult;
    if(this.activeKey)
     keyResult = this.activeKey.TryAccessKey(char, this.charIndex, needToContinue);
    if (needToContinue.value) {
     this.charIndex++;
     return { value: false };
    }
    this.charIndex = 0;
    if(keyResult !== undefined)
     this.activeKey = keyResult;
    else
     return { value: true, fireEvent: true };
    if (!this.activeKey || !this.activeKey.accessKeys || this.activeKey.accessKeys.length == 0) {
     if (this.activeKey && this.activeKey.manualStopProcessing) {
      this.manualStopProcessing = true;
      break;
     }
     return { value: true, fireEvent: true };
    }
  }
  return { value: false };
 },
 TryMoveFocusLeft: function (modifier) {},
 TryMoveFocusRight: function (modifier) {},
 TryMoveFocusUp: function (modifier) {},
 TryMoveFocusDown: function (modifier) {},
 FocusByAccessKey: function() {
  if (this.onFocusByAccessKey)
   this.onFocusByAccessKey();
  this.HideAccessKeys();
  KbdHelper.prototype.FocusByAccessKey.call(this);
  this.activeKey = this.accessKey;
  this.activeKey.execute();
  this.isActive = true;
  this.areAccessKeysShown = true;
 },
 HideAccessKeys: function() {
  this.areAccessKeysShown = false;
  this.hideAccessKeys(this.accessKey);
 },
 Update: function() {
  this.throttleMethod(this.refresh, 100);
 },
 refresh: function() {
  if(this.activeKey && this.areAccessKeysShown) {
   this.activeKey.execute();
  }
 },
 throttleMethod: function(method, delay) {
  clearTimeout(method.timerId);
  method.timerId = setTimeout(function() {
   method.call(this);
  }.aspxBind(this), delay);
 },
 AreAccessKeysShown: function() {
  return this.areAccessKeysShown;
 },
 hideAccessKeys: function (accessKey) {
  for (var i = 0, ak; ak = accessKey.accessKeys[i]; i++) {
   this.hideAccessKeys(ak);
  }
  if (accessKey)
   accessKey.hide();
 },
 HandleClick: function(e) {
  KbdHelper.prototype.HandleClick.call(this, e);
  this.stopProcessing();
 }
});
AccessKey = ASPx.CreateClass(null, {
 constructor: function (popupItem, getPopupElement, keyTipElement, key, onlyClick, manualStopProcessing) {
  this.key = key ? key : keyTipElement ? ASPxClientUtils.Trim(ASPx.GetInnerText(keyTipElement)) : null;
  this.popupItem = popupItem;
  this.getPopupElement = getPopupElement;
  this.keyTipElement = keyTipElement;
  this.accessKeys = [];
  this.needShowChilds = true;
  this.parent = null;
  this.onlyClick = onlyClick;
  this.manualStopProcessing = manualStopProcessing;
 },
 Add: function (accessKey) {
  this.accessKeys.push(accessKey);
  accessKey.parent = this;
 },
 TryAccessKey: function (char, index, needToContinue) {
  if (!this.accessKeys || this.accessKeys.length == 0)
   return;
  for (var i = 0, accessKey; accessKey = this.accessKeys[i]; i++) {
   if (accessKey.key[index] == char && accessKey.isVisible()) {
    if (accessKey.key[index + 1]) {
     needToContinue.value = true;
    }
    else {
     accessKey.execute();
     return accessKey;
    }
   } else {
    accessKey.hide();
   }
  }
  for (var i = 0, accessKey; accessKey = this.accessKeys[i]; i++) {
   var key = accessKey.TryAccessKey(char, index, needToContinue);
   if (key)
    return key;
  }
  return;
 },
 isVisible: function(){
  return ASPx.GetElementVisibility(this.keyTipElement);
 },
 Return: function () {
  this.hideChildAccessKeys();
  if (this.parent) {
   this.parent.showAccessKeys(true);
  }  
  return this.parent;
 },
 execute: function () {
  this.hideAll();
  if (this.popupItem && this.popupItem.accessKeyClick && !this.onlyClick)
   this.popupItem.accessKeyClick();
  if (this.getPopupElement && this.onlyClick)
   ASPx.Evt.EmulateMouseClick(this.getPopupElement(this.popupItem));
  if (this.accessKeys)
   setTimeout(function () {
    this.showAccessKeys(true);
   }.aspxBind(this), 100);
 },
 showAccessKeys: function(directShow) {
  if (!directShow && !this.needShowChilds)
   return;
  for (var i = 0; i < this.accessKeys.length; i++) {
   var accessKey = this.accessKeys[i];
   if (accessKey) {
    var popupElement = accessKey.getPopupElement ? accessKey.getPopupElement(accessKey.popupItem) : null;
    if (popupElement && this.isElementVisible(popupElement)) {
     this.show(accessKey);
    }
    accessKey.showAccessKeys();
   }
  }
 },
 isElementVisible: function (el) { return ASPx.IsElementVisible(el, true); },
 show: function(accessKey) {
  var keyTipElement = accessKey.keyTipElement;
  var popupElement = accessKey.getPopupElement(accessKey.popupItem);
  this.showKeyTipElement(keyTipElement, this.calculateCoordinates(accessKey, keyTipElement, popupElement));
 },
 showKeyTipElement: function (keyTipElement, coordinates) {
  ASPx.SetAbsoluteY(keyTipElement, coordinates.top);
  ASPx.SetAbsoluteX(keyTipElement, coordinates.left);
  ASPx.SetElementVisibility(keyTipElement, true); 
 },
 calculateCoordinates: function (accessKey, keyTipElement, popupElement) {
  var top = ASPx.GetAbsolutePositionY(popupElement);
  var left = ASPx.GetAbsolutePositionX(popupElement);
  if (accessKey.popupItem.getAccessKeyPosition)
   switch (accessKey.popupItem.getAccessKeyPosition()) {
    case "AboveRight":
     left = left + popupElement.offsetWidth - keyTipElement.offsetWidth / 3;
     top = top - keyTipElement.offsetHeight / 2;
     break;
    case "Right":
     left = left + popupElement.offsetWidth - keyTipElement.offsetWidth / 3;
     top = top + popupElement.offsetHeight / 2 - keyTipElement.offsetHeight / 2;
     break;
    case "BelowRight":
     left = left + popupElement.offsetWidth - keyTipElement.offsetWidth / 3;
     top = top + keyTipElement.offsetHeight / 2;
     break;
    default:
     top = top + popupElement.offsetHeight;
     left = left + popupElement.offsetWidth / 2 - keyTipElement.offsetWidth / 2;
     break;
   }
  else {
   top = top + popupElement.offsetHeight;
   left = left + popupElement.offsetWidth / 2 - keyTipElement.offsetWidth / 2;
  }
  return { top: top, left: left };
 },
 hide: function() {
  if (this.keyTipElement)
   ASPx.SetElementVisibility(this.keyTipElement, false);
 },
 hideChildAccessKeys: function () {
  this.hideAccessKeys(this.accessKeys);
 },
 hideAccessKeys: function (accessKeys) {
  if (accessKeys) {
   for (var i = 0, accessKey; accessKey = accessKeys[i]; i++) {
    if (accessKey.keyTipElement)
     accessKey.hide();
    accessKey.hideChildAccessKeys();
   }
  }
 },
 hideAll: function () {
  this.getRoot(this).hideChildAccessKeys();
 },
 getRoot: function (accessKey) {
  if (!accessKey.parent)
   return accessKey;
  return this.getRoot(accessKey.parent);
 }
});
var focusedElement = null;
function aspxOnElementFocused(evt) {
 evt = ASPx.Evt.GetEvent(evt);
 if(evt && evt.target)
  focusedElement = evt.target;
}
function _aspxInitializeFocus() {
 if(!ASPx.GetActiveElement())
  ASPx.Evt.AttachEventToDocument("focus", aspxOnElementFocused);
}
function _aspxGetFocusedElement() {
 var activeElement = ASPx.GetActiveElement();
 return activeElement ? activeElement : focusedElement;
}
CheckBoxCheckState = {
 Checked : "Checked",
 Unchecked : "Unchecked",
 Indeterminate : "Indeterminate"
};
CheckBoxInputKey = { 
 Checked : "C",
 Unchecked : "U",
 Indeterminate : "I"
};
var CheckableElementStateController = ASPx.CreateClass(null, {
 constructor: function(imageProperties) {
  this.checkBoxStates = [];
  this.imageProperties = imageProperties;
  this.customImageMarkerClassName = "dxcbCI";
 },
 GetValueByInputKey: function(inputKey) {
  return this.GetFirstValueBySecondValue("Value", "StateInputKey", inputKey);
 },
 GetInputKeyByValue: function(value) {
  return this.GetFirstValueBySecondValue("StateInputKey", "Value", value);
 },
 GetImagePropertiesNumByInputKey: function(value) {
  return this.GetFirstValueBySecondValue("ImagePropertiesNumber", "StateInputKey", value);
 },
 GetNextCheckBoxValue: function(currentValue, allowGrayed) {
  var currentInputKey = this.GetInputKeyByValue(currentValue);
  var nextInputKey = '';
  switch(currentInputKey) {
   case CheckBoxInputKey.Checked:
    nextInputKey = CheckBoxInputKey.Unchecked; break;
   case CheckBoxInputKey.Unchecked:
    nextInputKey = allowGrayed ? CheckBoxInputKey.Indeterminate : CheckBoxInputKey.Checked; break;
   case CheckBoxInputKey.Indeterminate:
    nextInputKey = CheckBoxInputKey.Checked; break;
  }
  return this.GetValueByInputKey(nextInputKey);
 },
 GetCheckStateByInputKey: function(inputKey) {
  switch(inputKey) {
   case CheckBoxInputKey.Checked: 
    return CheckBoxCheckState.Checked;
   case CheckBoxInputKey.Unchecked: 
    return CheckBoxCheckState.Unchecked;
   case CheckBoxInputKey.Indeterminate: 
    return CheckBoxCheckState.Indeterminate;
  }
 },
 GetValueByCheckState: function(checkState) {
  switch(checkState) {
   case CheckBoxCheckState.Checked: 
    return this.GetValueByInputKey(CheckBoxInputKey.Checked);
   case CheckBoxCheckState.Unchecked: 
    return this.GetValueByInputKey(CheckBoxInputKey.Unchecked);
   case CheckBoxCheckState.Indeterminate: 
    return this.GetValueByInputKey(CheckBoxInputKey.Indeterminate);
  }
 },
 GetFirstValueBySecondValue: function(firstValueName, secondValueName, secondValue) {
  return this.GetValueByFunc(firstValueName, 
   function(checkBoxState) { return checkBoxState[secondValueName] === secondValue; });
 },
 GetValueByFunc: function(valueName, func) {
  for(var i = 0; i < this.checkBoxStates.length; i++) {
   if(func(this.checkBoxStates[i]))
    return this.checkBoxStates[i][valueName];
  }  
 },
 AssignElementClassName: function(element, cssClassPropertyKey, disabledCssClassPropertyKey, assignedClassName) {
  var classNames = [ ];
  for(var i = 0; i < this.imageProperties[cssClassPropertyKey].length; i++) {
   classNames.push(this.imageProperties[disabledCssClassPropertyKey][i]);
   classNames.push(this.imageProperties[cssClassPropertyKey][i]);
  }
  var elementClassName = element.className;
  for(var i = 0; i < classNames.length; i++) {
   var className = classNames[i];
   var index = elementClassName.indexOf(className);
   if(index > -1)
    elementClassName = elementClassName.replace((index == 0 ? '' : ' ') + className, "");
  }
  elementClassName += " " + assignedClassName;
  element.className = elementClassName;
 },
 UpdateInternalCheckBoxDecoration: function(mainElement, inputKey, enabled) {
  var imagePropertiesNumber = this.GetImagePropertiesNumByInputKey(inputKey);
  for(var imagePropertyKey in this.imageProperties) {
   if(this.imageProperties.hasOwnProperty(imagePropertyKey)) {
    var propertyValue = this.imageProperties[imagePropertyKey][imagePropertiesNumber];
    propertyValue = propertyValue || !isNaN(propertyValue) ? propertyValue : "";
    switch(imagePropertyKey) {
     case "0" : mainElement.title = propertyValue; break;
     case "1" : mainElement.style.width = propertyValue + (propertyValue != "" ? "px" : ""); break;
     case "2" : mainElement.style.height = propertyValue + (propertyValue != "" ? "px" : ""); break;
    }
    if(enabled) {
     switch(imagePropertyKey) {
      case "3" : this.SetImageSrc(mainElement, propertyValue); break;
      case "4" : 
       this.AssignElementClassName(mainElement, "4", "8", propertyValue);
       break;
      case "5" : this.SetBackgroundPosition(mainElement, propertyValue, true); break;
      case "6" : this.SetBackgroundPosition(mainElement, propertyValue, false); break;
     }
    } else {
     switch(imagePropertyKey) {
      case "7" : this.SetImageSrc(mainElement, propertyValue); break;
      case "8" : 
       this.AssignElementClassName(mainElement, "4", "8", propertyValue);
       break;
      case "9" : this.SetBackgroundPosition(mainElement, propertyValue, true); break;
      case "10" : this.SetBackgroundPosition(mainElement, propertyValue, false); break;
     }
    }
   }
  }
 },
 SetImageSrc: function(mainElement, src) {
  if(src === ""){
   mainElement.style.backgroundImage = "";
   mainElement.style.backgroundPosition = "";
   ASPx.RemoveClassNameFromElement(mainElement, this.customImageMarkerClassName);
  }
  else{
   mainElement.style.backgroundImage = "url('" + src + "')";
   this.SetBackgroundPosition(mainElement, 0, true);
   this.SetBackgroundPosition(mainElement, 0, false);
   ASPx.AddClassNameToElement(mainElement, this.customImageMarkerClassName);
  }
 },
 SetBackgroundPosition: function(element, value, isX) {
  if(value === "") {
   element.style.backgroundPosition = value;
   return;
  }
  if(element.style.backgroundPosition === "")
   element.style.backgroundPosition = isX ? "-" + value.toString() + "px 0px" : "0px -" + value.toString() + "px";
  else {
   var position = element.style.backgroundPosition.split(' ');
   element.style.backgroundPosition = isX ? '-' + value.toString() + "px " + position[1] :  position[0] + " -" + value.toString() + "px";
  }
 },
 AddState: function(value, stateInputKey, imagePropertiesNumber) {
  this.checkBoxStates.push({
   "Value" : value, 
   "StateInputKey" : stateInputKey, 
   "ImagePropertiesNumber" : imagePropertiesNumber
  });
 },
 GetAriaCheckedValue: function(state) {
  switch(state) {
   case ASPx.CheckBoxCheckState.Checked: return "true";
   case ASPx.CheckBoxCheckState.Unchecked: return "false";
   case ASPx.CheckBoxCheckState.Indeterminate: return "mixed";
   default: return "";
  }
 },
 GetAriaSelectedValue: function(state) {
  switch(state) {
   case ASPx.CheckBoxCheckState.Checked: return "true";
   case ASPx.CheckBoxCheckState.Unchecked: return "false";
   case ASPx.CheckBoxCheckState.Indeterminate: return "undefined";
   default: return "";
  }
 },
 SetAriaCheckedSelectedAttributes: function(mainElement, state) {
  if(mainElement.attributes["aria-checked"] !== undefined) {
   var ariaCheckedValue = this.GetAriaCheckedValue(state);
   mainElement.setAttribute("aria-checked", ariaCheckedValue);
  }
  if(mainElement.attributes["aria-selected"] !== undefined) {
   var ariaSelectedValue = this.GetAriaSelectedValue(state);
   mainElement.setAttribute("aria-selected", ariaSelectedValue);
  }
 }
});
CheckableElementStateController.Create = function(imageProperties, valueChecked, valueUnchecked, valueGrayed, allowGrayed) {
 var stateController = new CheckableElementStateController(imageProperties);
 stateController.AddState(valueChecked, CheckBoxInputKey.Checked, 0);
 stateController.AddState(valueUnchecked, CheckBoxInputKey.Unchecked, 1);
 if(typeof(valueGrayed) != "undefined")
  stateController.AddState(valueGrayed, CheckBoxInputKey.Indeterminate, allowGrayed ? 2 : 1);
 stateController.allowGrayed = allowGrayed;
 return stateController;
};
var CheckableElementHelper = ASPx.CreateClass(null, {
 InternalCheckBoxInitialize: function(internalCheckBox) {
  this.AttachToMainElement(internalCheckBox);
  this.AttachToInputElement(internalCheckBox);
 },
 AttachToMainElement: function(internalCheckBox) {
  var instance = this;
  if(internalCheckBox.mainElement) {
    var toggleEvent = internalCheckBox.displaySwitch ? ASPx.TouchUIHelper.touchMouseDownEventName : "click";
    ASPx.Evt.AttachEventToElement(internalCheckBox.mainElement, toggleEvent,
    function (evt) {
     if(ASPx.Evt.IsRightButtonPressed(evt))
      return;
     instance.InvokeClick(internalCheckBox, evt);
     if(!internalCheckBox.disableCancelBubble)
      return ASPx.Evt.PreventEventAndBubble(evt);
    }
   );
   ASPx.Evt.AttachEventToElement(internalCheckBox.mainElement, "mousedown",
    function (evt) {
     internalCheckBox.Refocus();
    }
   );
   ASPx.Evt.PreventElementDragAndSelect(internalCheckBox.mainElement, true);
  }
 },
 AttachToInputElement: function(internalCheckBox) {
  var instance = this;
  if(internalCheckBox.inputElement && internalCheckBox.mainElement) {
   var checkableElement = internalCheckBox.accessibilityCompliant ? internalCheckBox.mainElement : internalCheckBox.inputElement;
   ASPx.Evt.AttachEventToElement(checkableElement, "focus",
    function (evt) { 
     if(!internalCheckBox.enabled)
      checkableElement.blur();
     else
      internalCheckBox.OnFocus();
    }
   );
   ASPx.Evt.AttachEventToElement(checkableElement, "blur", 
    function (evt) { 
     internalCheckBox.OnLostFocus();
    }
   );
   ASPx.Evt.AttachEventToElement(checkableElement, "keyup",
    function (evt) { 
     if(ASPx.Evt.GetKeyCode(evt) == ASPx.Key.Space)
      instance.InvokeClick(internalCheckBox, evt);
    }
   );
   ASPx.Evt.AttachEventToElement(checkableElement, "keydown",
    function (evt) { 
     if(ASPx.Evt.GetKeyCode(evt) == ASPx.Key.Space)
      return ASPx.Evt.PreventEvent(evt);
    }
   );
  }
 },
 IsKBSInputWrapperExist: function() {
  return ASPx.Browser.Opera || ASPx.Browser.WebKitFamily;
 },
 GetICBMainElementByInput: function(icbInputElement) {
  return this.IsKBSInputWrapperExist() ? icbInputElement.parentNode.parentNode : icbInputElement.parentNode;
 },
 RequirePreventFocus: function() { return false; },
 InvokeClick: function(internalCheckBox, evt) {
  if(internalCheckBox.enabled && !internalCheckBox.GetReadOnly()) {
   var inputElementValue = internalCheckBox.inputElement.value;
   var focusableElement = internalCheckBox.accessibilityCompliant ? internalCheckBox.mainElement : internalCheckBox.inputElement; 
   if(!this.RequirePreventFocus())
    focusableElement.focus();
   if(!ASPx.Browser.IE) 
    internalCheckBox.inputElement.value = inputElementValue;
   this.InvokeClickCore(internalCheckBox, evt);
   }
 },
 InvokeClickCore: function(internalCheckBox, evt) {
  internalCheckBox.OnClick(evt);
 }
});
CheckableElementHelper.Instance = new CheckableElementHelper();
var CheckBoxInternal = ASPx.CreateClass(null, {
 constructor: function(inputElement, stateController, allowGrayed, allowGrayedByClick, helper, container, storeValueInInput, key, disableCancelBubble,
  accessibilityCompliant, displaySwitch) {
  this.inputElement = inputElement;
  this.mainElement = helper.GetICBMainElementByInput(this.inputElement);
  this.name = (key ? key : this.inputElement.id) + CheckBoxInternal.GetICBMainElementPostfix();
  this.mainElement.id = this.name;
  this.stateController = stateController;
  this.container = container;
  this.allowGrayed = allowGrayed;
  this.allowGrayedByClick = allowGrayedByClick;
  this.autoSwitchEnabled = true;
  this.displaySwitch = displaySwitch;
  this.storeValueInInput = !!storeValueInInput;
  this.storedInputKey = !this.storeValueInInput ? this.inputElement.value : null;
  this.disableCancelBubble = !!disableCancelBubble;
  this.accessibilityCompliant = accessibilityCompliant;
  this.focusDecoration = null;
  this.focused = false;
  this.focusLocked = false;
  this.enabled = !this.mainElement.className.match(/dxWeb_\w+Disabled(\b|_)/);
  this.readOnly = false;
  this.preventFocus = helper.RequirePreventFocus();
  this.CheckedChanged = new ASPxClientEvent();
  this.Focus = new ASPxClientEvent();
  this.LostFocus = new ASPxClientEvent();
  helper.InternalCheckBoxInitialize(this);
 },
 GetReadOnly: function() {
  return this.readOnly;
 },
 ChangeInputElementTabIndex: function() {  
  var changeMethod = this.enabled ? ASPx.Attr.RestoreTabIndexAttribute : ASPx.Attr.SaveTabIndexAttributeAndReset;
  changeMethod(this.inputElement);
 },
 CreateFocusDecoration: function(focusedStyle) {
   this.focusDecoration = new FocusedStyleDecoration(this);
   this.focusDecoration.AddStyle('F', focusedStyle[0], focusedStyle[1]);
   this.focusDecoration.AddPostfix("");
 },
 UpdateFocusDecoration: function() {
  this.focusDecoration.Update();
 },  
 StoreInputKey: function(inputKey) {
  if(this.storeValueInInput)
   this.inputElement.value = inputKey;
  else
   this.storedInputKey = inputKey;
 },
 GetStoredInputKey: function() {
  if(this.storeValueInInput)
   return this.inputElement.value;
  else
   return this.storedInputKey;
 },
 OnClick: function(e) {
  if(this.autoSwitchEnabled) {
   var currentValue = this.GetValue();
   var value = this.stateController.GetNextCheckBoxValue(currentValue, this.allowGrayedByClick && this.allowGrayed);
   this.SetValue(value);
  }
  this.CheckedChanged.FireEvent(this, e);
 },
 OnFocus: function() {
  if(!this.IsFocusLocked()) {
   this.focused = true;
   this.UpdateFocusDecoration();
   this.Focus.FireEvent(this, null);
  } else
   this.UnlockFocus();
 },
 OnLostFocus: function() {
  if(!this.IsFocusLocked()) {
   this.focused = false;
   this.UpdateFocusDecoration();
   this.LostFocus.FireEvent(this, null);
  }
 },
 Refocus: function() {
  if(this.preventFocus) return;
  if(this.focused) {
   this.LockFocus();
   this.inputElement.blur();
   if(ASPx.Browser.MacOSMobilePlatform) {
    window.setTimeout(function() {
     ASPx.SetFocus(this.inputElement);
    }, ASPx.FOCUS_TIMEOUT);
   } else {
    ASPx.SetFocus(this.inputElement);
   }
  }
 },
 LockFocus: function() {
  this.focusLocked = true;
 },
 UnlockFocus: function() {
  this.focusLocked = false;
 },
 IsFocusLocked: function() {
  if(!!ASPx.Attr.GetAttribute(this.mainElement, ASPx.Attr.GetTabIndexAttributeName()))
   return false;
  return this.focusLocked;
 },
 SetValue: function(value, force) {
  var currentValue = this.GetValue();
  if(currentValue !== value || force) {
   var newInputKey = this.stateController.GetInputKeyByValue(value);
   if(newInputKey) {
    this.StoreInputKey(newInputKey);   
    this.stateController.UpdateInternalCheckBoxDecoration(this.mainElement, newInputKey, this.enabled);
   }
  }
  if(this.accessibilityCompliant) {
   var state = this.GetCurrentCheckState();
   this.stateController.SetAriaCheckedSelectedAttributes(this.mainElement, state);
  }
 },
 GetValue: function() {
  return this.stateController.GetValueByInputKey(this.GetCurrentInputKey());
 },
 GetCurrentCheckState: function() {
  return this.stateController.GetCheckStateByInputKey(this.GetCurrentInputKey());
 },
 GetCurrentInputKey: function() {
  return this.GetStoredInputKey();
 },
 GetChecked: function() {
  return this.GetCurrentInputKey() === CheckBoxInputKey.Checked;
 },
 SetChecked: function(checked) {
  var newValue = this.stateController.GetValueByCheckState(checked ? CheckBoxCheckState.Checked : CheckBoxCheckState.Unchecked);
  this.SetValue(newValue);
 },
 SetEnabled: function(enabled) {
  if(this.enabled != enabled) {
   this.enabled = enabled;
   this.stateController.UpdateInternalCheckBoxDecoration(this.mainElement, this.GetCurrentInputKey(), this.enabled);
   this.ChangeInputElementTabIndex();
  }
 },
 GetEnabled: function() {
  return this.enabled;
 }
});
CheckBoxInternal.GetICBMainElementPostfix = function() {
 return "_D";
};
var CheckBoxInternalCollection = ASPx.CreateClass(CollectionBase, {
 constructor: function(imageProperties, allowGrayed, storeValueInInput, helper, disableCancelBubble, accessibilityCompliant) {
  this.constructor.prototype.constructor.call(this);
  this.stateController = allowGrayed 
   ? CheckableElementStateController.Create(imageProperties, CheckBoxInputKey.Checked, CheckBoxInputKey.Unchecked, CheckBoxInputKey.Indeterminate, true)
   : CheckableElementStateController.Create(imageProperties, CheckBoxInputKey.Checked, CheckBoxInputKey.Unchecked);
  this.helper = helper || CheckableElementHelper.Instance;
  this.storeValueInInput = !!storeValueInInput;
  this.disableCancelBubble = !!disableCancelBubble;
  this.accessibilityCompliant = accessibilityCompliant;
 },
 Add: function(key, inputElement, container) {
  this.Remove(key);
  var checkBox = this.CreateInternalCheckBox(key, inputElement, container);
  CollectionBase.prototype.Add.call(this, key, checkBox);
  return checkBox;
 },
 SetImageProperties: function(imageProperties) {
  this.stateController.imageProperties = imageProperties;
 },
 CreateInternalCheckBox: function(key, inputElement, container) {
  return new CheckBoxInternal(inputElement, this.stateController, this.stateController.allowGrayed, false, this.helper, container, 
   this.storeValueInInput, key, this.disableCancelBubble, this.accessibilityCompliant);
 }
});
var FocusedStyleDecoration = ASPx.CreateClass(null, {
 constructor: function(editor) {
  this.editor = editor;
  this.postfixList = [];
  this.styles = {};
  this.innerStyles = {};
 },
 AddPostfix: function(value) {
  this.postfixList.push(value);
 },
 AddStyle: function(key, className, cssText) {
  this.styles[key] = this.CreateRule(className, cssText);
  this.innerStyles[key] = this.CreateRule("", this.FilterInnerCss(cssText));
 },
 CreateRule: function(className, cssText) {
  return ASPx.Str.Trim(className + " " + ASPx.CreateImportantStyleRule(this.GetStyleSheet(), cssText));
 },
 GetStyleSheet: function() {
  return ASPx.GetCurrentStyleSheet();
 },
 FilterInnerCss: function(css) {
  return css.replace(/(border|background-image)[^:]*:[^;]+/gi, "");
 },
 Update: function() {
  for(var i = 0; i < this.postfixList.length; i++) {
   var postfix = this.postfixList[i];
   var inner = postfix.length > 0;
   var element = this.GetElementByPostfix(postfix);
   if(element)
    this.ApplyStyles(element, inner);
  }
 },
 GetElementByPostfix: function(postfix) {
  return ASPx.GetElementById(this.editor.name + postfix);
 },
 ApplyStyles: function(element, inner) {
  this.ApplyFocusedStyle(element, inner);
 },
 ApplyFocusedStyle: function(element, inner) {
  if(this.HasDecoration("F"))
   this.ApplyDecoration("F", element, inner, this.editor.focused);
 },
 HasDecoration: function(key) {
  return !!this.styles[key];
 },
 ApplyDecoration: function(key, element, inner, active) {
  var value = inner ? this.innerStyles[key] : this.styles[key];
  this.RemoveDecoration(element, value);
  if(active) {
   ASPx.AddClassNameToElement(element, value);
   if(ASPx.Browser.IE && ASPx.Browser.Version > 10 && element.border != null) 
    this.EnsureElementBorder(element);
  }
 },
 RemoveDecoration: function(element, value) {
  ASPx.RemoveClassNameFromElement(element, value);
  if(ASPx.Browser.IE && ASPx.Browser.MajorVersion >= 11)
   var dummy = element.offsetWidth; 
 },
 ApplyDecorationCore: function() {
 },
 EnsureElementBorder: function(element) {
  var border = parseInt(element.border) || 0;
  element.border = 1;
  element.border = border;
 }
});
var EditorStyleDecoration = ASPx.CreateClass(FocusedStyleDecoration, {
 constructor: function(editor) {
  this.constructor.prototype.constructor.call(this, editor);
  this.lockUpdate = false;
 },
 LockUpdate: function() {
  this.lockUpdate = true;
 },
 UnlockUpdate: function() {
  this.lockUpdate = false;
 },
 IsUpdateLocked: function() {
  return this.lockUpdate;
 },
 Update: function () {
  if(this.IsUpdateLocked())
   return;
  ASPx.FocusedStyleDecoration.prototype.Update.call(this);
 },
 ApplyStyles: function (element, inner) {
  this.ApplyInvalidStyle(element, inner);
  ASPx.FocusedStyleDecoration.prototype.ApplyStyles.call(this, element, inner);
 },
 ApplyInvalidStyle: function (element, inner) {
  if(this.HasDecoration("I")) {
   var isValid = this.editor.GetIsValid();
   this.ApplyDecoration("I", element, inner, !isValid);
  }
 }
});
var TextEditorStyleDecoration = ASPx.CreateClass(EditorStyleDecoration, {
 constructor: function(editor) {
  this.constructor.prototype.constructor.call(this, editor);
  this.nullTextClassName = "";
 },
 ApplyStyles: function(element, inner) {
  ASPx.EditorStyleDecoration.prototype.ApplyStyles.call(this, element, inner);
  this.ApplyNullTextStyle(element, inner);
 },
 ApplyNullTextStyle: function(element, inner) {
  if(!this.HasDecoration("N"))
   return;
  var apply = !this.editor.focused && this.editor.CanApplyNullTextDecoration();
  this.EnsureSpellcheckAttribute(element, apply);
  this.ApplyDecoration("N", element, inner, apply);
 },
 EnsureSpellcheckAttribute: function(element, apply) {
  if(apply)
   ASPx.Attr.ChangeAttribute(element, "spellcheck", "false");
  else
   ASPx.Attr.RestoreAttribute(element, "spellcheck");
 },
 ApplyNullTextClassName: function(active) {
  var nullTextClassName = this.GetNullTextClassName();
  var editorMainElement = this.editor.GetMainElement();
  if(active)
   ASPx.AddClassNameToElement(editorMainElement, nullTextClassName);
  else
   ASPx.RemoveClassNameFromElement(editorMainElement, nullTextClassName);
 },
 GetNullTextClassName: function() {
  if (!this.nullTextClassName)
   this.InitializeNullTextClassName();
  return this.nullTextClassName;
 },
 InitializeNullTextClassName: function() {
  var nullTextStyle = this.styles["N"];
  if (nullTextStyle) {
   var nullTextStyleClassNames = nullTextStyle.split(" ");
   for (var i = 0; i < nullTextStyleClassNames.length; i++)
    if (nullTextStyleClassNames[i].match("dxeNullText"))
     this.nullTextClassName = nullTextStyleClassNames[i];
  }
 }
});
var TouchUIHelper = {
 isGesture: false,
 isMouseEventFromScrolling: false,
 isNativeScrollingAllowed: true,
 clickSensetivity: 10,
 documentTouchHandlers: {},
 documentEventAttachingAllowed: true,
 msTouchDraggableClassName: "dxMSTouchDraggable",
 touchMouseDownEventName: ASPx.Browser.WebKitTouchUI ? "touchstart" : (ASPx.Browser.Edge && ASPx.Browser.MSTouchUI && window.PointerEvent ? "pointerdown" : "mousedown"),
 touchMouseUpEventName:   ASPx.Browser.WebKitTouchUI ? "touchend"   : (ASPx.Browser.Edge && ASPx.Browser.MSTouchUI && window.PointerEvent ? "pointerup" : "mouseup"),
 touchMouseMoveEventName: ASPx.Browser.WebKitTouchUI ? "touchmove"  : (ASPx.Browser.Edge && ASPx.Browser.MSTouchUI && window.PointerEvent ? "pointermove" : "mousemove"),
 isTouchEvent: function(evt) {
  if(!evt) return false;
  return ASPx.Browser.WebKitTouchUI && ASPx.IsExists(evt.changedTouches); 
 },
 isTouchEventName: function(eventName) {
  return ASPx.Browser.WebKitTouchUI && (eventName.indexOf("touch") > -1 || eventName.indexOf("gesture") > -1);
 },
 getEventX: function(evt) {
  if(ASPx.Browser.IE)
   return evt.pageX;
  var touchPoint = null;
  if(evt.changedTouches.length > 0)
   touchPoint = evt.changedTouches;
  else if(evt.targetTouches.length > 0)
   touchPoint = evt.targetTouches;
  return touchPoint ? touchPoint[0].pageX : 0;
 },
 getEventY: function(evt) { 
  if(ASPx.Browser.IE)
   return evt.pageY;
  var touchPoint = null;
  if(evt.changedTouches.length > 0)
   touchPoint = evt.changedTouches;
  else if(evt.targetTouches.length > 0)
   touchPoint = evt.targetTouches;
  return touchPoint ? touchPoint[0].pageY : 0;
 },
 getWebkitMajorVersion: function(){
  if(!this.webkitMajorVersion){
   var regExp = new RegExp("applewebkit/(\\d+)", "i");
   var matches = regExp.exec(ASPx.Browser.UserAgent);
   if(matches && matches.index >= 1)
    this.webkitMajorVersion = matches[1];
  }
  return this.webkitMajorVersion;
 },
 getIsLandscapeOrientation: function(){
  if(ASPx.Browser.MacOSMobilePlatform || ASPx.Browser.AndroidMobilePlatform)
   return Math.abs(window.orientation) == 90;
  return ASPx.GetDocumentClientWidth() > ASPx.GetDocumentClientHeight();
 },
 nativeScrollingSupported: function() {
  var allowedSafariVersion = ASPx.Browser.Version >= 5.1 && ASPx.Browser.Version < 8; 
  var webkitMajorVersion = this.getWebkitMajorVersion();
  var allowedWebKitVersion = webkitMajorVersion > 533 && webkitMajorVersion < 600;
  return (ASPx.Browser.MacOSMobilePlatform && (allowedSafariVersion || allowedWebKitVersion))
   || (ASPx.Browser.AndroidMobilePlatform && ASPx.Browser.PlaformMajorVersion >= 3) || (ASPx.Browser.MSTouchUI && (!ASPx.Browser.WindowsPhonePlatform || !ASPx.Browser.IE));
 },
 makeScrollableIfRequired: function(element, options) {
  if(ASPx.Browser.WebKitTouchUI && element) {
   var overflow = ASPx.GetCurrentStyle(element).overflow;
   if(element.tagName == "DIV" &&  overflow != "hidden" && overflow != "visible" ){
    return this.MakeScrollable(element);
   }
  }
 },
 preventScrollOnEvent: function(evt){
 },
 handleFastTapIfRequired: function(evt, action, preventCommonClickEvents) {
  if(ASPx.Browser.WebKitTouchUI && evt.type == 'touchstart' && action) {
   this.FastTapHelper.HandleFastTap(evt, action, preventCommonClickEvents);
   return true;
  }
  return false;
 },
 ensureDocumentSizesCorrect: function (){
  return (document.documentElement.clientWidth - document.documentElement.clientHeight) / (screen.width - screen.height) > 0;
 },
 ensureOrientationChanged: function(onOrientationChangedFunction){
  if(ASPxClientUtils.iOSPlatform || this.ensureDocumentSizesCorrect())
   onOrientationChangedFunction();
  else {
   window.setTimeout(function(){
    this.ensureOrientationChanged(onOrientationChangedFunction);
   }.aspxBind(this), 100);
  }
 },
 onEventAttachingToDocument: function(eventName, func){
  if(ASPx.Browser.MacOSMobilePlatform && this.isTouchEventName(eventName)) {
   if(!this.documentTouchHandlers[eventName])
    this.documentTouchHandlers[eventName] = [];
   this.documentTouchHandlers[eventName].push(func);
   return this.documentEventAttachingAllowed;
  }
  return true;
 },
 onEventDettachedFromDocument: function(eventName, func){
  if(ASPx.Browser.MacOSMobilePlatform && this.isTouchEventName(eventName)) {
   var handlers = this.documentTouchHandlers[eventName];
   if(handlers)
    ASPx.Data.ArrayRemove(handlers, func);
  }
 },
 processDocumentTouchEventHandlers: function(proc) {
  var touchEventNames = ["touchstart", "touchend", "touchmove", "gesturestart", "gestureend"];
  for(var i = 0; i < touchEventNames.length; i++) {
   var eventName = touchEventNames[i];
   var handlers = this.documentTouchHandlers[eventName];
   if(handlers) {
    for(var j = 0; j < handlers.length; j++) {
     proc(eventName,handlers[j]);
    }
   }
  }
 },
 removeDocumentTouchEventHandlers: function() {
  if(ASPx.Browser.MacOSMobilePlatform) {
   this.documentEventAttachingAllowed = false;
   this.processDocumentTouchEventHandlers(ASPx.Evt.DetachEventFromDocumentCore);
  }
 },
 restoreDocumentTouchEventHandlers: function () {
  if(ASPx.Browser.MacOSMobilePlatform) {
   this.documentEventAttachingAllowed = true;
   this.processDocumentTouchEventHandlers(ASPx.Evt.AttachEventToDocumentCore);
  }
 },
 IsNativeScrolling: function() {
  return TouchUIHelper.nativeScrollingSupported() && TouchUIHelper.isNativeScrollingAllowed;
 },
 pointerEnabled: !!(window.PointerEvent || window.MSPointerEvent),
 pointerDownEventName: window.PointerEvent ? "pointerdown" : "MSPointerDown",
 pointerUpEventName: window.PointerEvent ? "pointerup" : "MSPointerUp",
 pointerCancelEventName: window.PointerEvent ? "pointercancel" : "MSPointerCancel",
 pointerMoveEventName: window.PointerEvent ? "pointermove" : "MSPointerMove",
 pointerOverEventName: window.PointerEvent ? "pointerover" : "MSPointerOver",
 pointerOutEventName: window.PointerEvent ? "pointerout" : "MSPointerOut",
 pointerType: {
  Touch: (ASPx.Browser.IE && ASPx.Browser.Version == 10) ? 2 : "touch",
  Pen: (ASPx.Browser.IE && ASPx.Browser.Version == 10) ? 3 : "pen",
  Mouse: (ASPx.Browser.IE && ASPx.Browser.Version == 10) ? 4 : "mouse"
 },
 msGestureEnabled: !!(window.PointerEvent || window.MSPointerEvent) && typeof(MSGesture) != "undefined",
 msTouchCreateGesturesWrapper: function(element, onTap){
  if(!TouchUIHelper.msGestureEnabled) 
   return;
  var gesture = new MSGesture();
  gesture.target = element;
  ASPx.Evt.AttachEventToElement(element, TouchUIHelper.pointerDownEventName, function(evt){
   gesture.addPointer(evt.pointerId);
  });
  ASPx.Evt.AttachEventToElement(element, TouchUIHelper.pointerUpEventName, function(evt){
   gesture.stop();
  });
  if(onTap)
   ASPx.Evt.AttachEventToElement(element, "MSGestureTap", onTap);
  return gesture;
 },
 useLongTapHelper: function () {
  return ASPx.Browser.Safari && ASPx.Browser.TouchUI;
 },
 attachLongTapHandler: function(element, handler, onlyBubbling) {
  var timerID = -1;
  var timeout = 1000;
  var event = null;
  var preventClickEvent = false;
  var startX = -1;
  var startY = -1;
  var pixelLimit = 5;
  function onTouchMouseDown(evt) {
   abortWating();
   event = evt;
   startX = evt.pageX;
   startY = evt.pageY;
   preventClickEvent = false;
   timerID = window.setTimeout(onTimeout, timeout);
  }
  function onTouchMouseMove(evt) {
   if (!isUnderTouch())
    return;
   var shiftX = Math.abs(startX - evt.pageX),
    shiftY = Math.abs(startY - evt.pageY),
    maxShift = Math.max(shiftX, shiftY);
   if (maxShift > pixelLimit)
    abortWating();
  }
  function onTouchMouseUp(evt) {
   abortWating();
   if (preventClickEvent) {
    ASPx.Evt.PreventEventAndBubble(evt);
    preventClickEvent = false;
   }
  }
  function onTimeout() {
   handler(event);
   preventClickEvent = true;
   abortWatingInternal();
  }
  function isUnderTouch() {
   return timerID !== -1;
  }
  function abortWating() {
   if (isUnderTouch()) {
    window.clearTimeout(timerID);
    abortWatingInternal();
   }
  }
  function abortWatingInternal() {
   timerID = -1;
   event = null;
  }
  ASPx.Evt.AttachEventToElement(element, TouchUIHelper.touchMouseDownEventName, onTouchMouseDown, onlyBubbling);
  ASPx.Evt.AttachEventToElement(element, TouchUIHelper.touchMouseMoveEventName, onTouchMouseMove, onlyBubbling);
  ASPx.Evt.AttachEventToElement(element, TouchUIHelper.touchMouseUpEventName, onTouchMouseUp, onlyBubbling);
  element.style["-webkit-user-select"] = "none";
  return function () {
   ASPx.Evt.DetachEventFromElement(element, TouchUIHelper.touchMouseDownEventName, onTouchMouseDown);
   ASPx.Evt.DetachEventFromElement(element, TouchUIHelper.touchMouseMoveEventName, onTouchMouseMove);
   ASPx.Evt.DetachEventFromElement(element, TouchUIHelper.touchMouseUpEventName, onTouchMouseUp);
   element.style["-webkit-user-select"] = "";
  };
 }
};
var CacheHelper = {};
CacheHelper.GetCachedValueCore = function(obj, key, func, cacheObj, fillValueMethod) {
 if(!cacheObj)
  cacheObj = obj;
 if(!cacheObj.cache)
  cacheObj.cache = {};
 if(!key) 
  key = "default";
 fillValueMethod(obj, key, func, cacheObj);
 return cacheObj.cache[key];
};
CacheHelper.GetCachedValue = function(obj, key, func, cacheObj) {
 return CacheHelper.GetCachedValueCore(obj, key, func, cacheObj, 
  function(obj, key, func, cacheObj) {
   if(!ASPx.IsExists(cacheObj.cache[key]))
    cacheObj.cache[key] = func.apply(obj, []);
  });
};
CacheHelper.GetCachedElement = function(obj, key, func, cacheObj) {
 return CacheHelper.GetCachedValueCore(obj, key, func, cacheObj, 
  function(obj, key, func, cacheObj) {
   if(!ASPx.IsValidElement(cacheObj.cache[key]))
    cacheObj.cache[key] = func.apply(obj, []);
  });
};
CacheHelper.GetCachedElements = function(obj, key, func, cacheObj) {
 return CacheHelper.GetCachedValueCore(obj, key, func, cacheObj, 
  function(obj, key, func, cacheObj) {
   if(!ASPx.IsValidElements(cacheObj.cache[key])){
    var elements = func.apply(obj, []);
    if(!Ident.IsArray(elements))
     elements = [elements];
    cacheObj.cache[key] = elements;
   }
  });
};
CacheHelper.GetCachedElementById = function(obj, id, cacheObj) {
 return CacheHelper.GetCachedElement(obj, id, function() { return ASPx.GetElementById(id); }, cacheObj);
};
CacheHelper.GetCachedChildById = function(obj, parent, id, cacheObj) {
 return CacheHelper.GetCachedElement(obj, id, function() { return ASPx.GetChildById(parent, id); }, cacheObj);
};
CacheHelper.DropCachedValue = function(cacheObj, key) {
 cacheObj.cache[key] = null;
};  
CacheHelper.DropCache = function(cacheObj) {
 cacheObj.cache = null;
};  
var DomObserver = ASPx.CreateClass(null, {
 constructor: function() {
  this.items = { };
 },
 subscribe: function(elementID, callbackFunc) {
  var item = this.items[elementID];
  if(item)
   this.unsubscribe(elementID);
  item = {
   elementID: elementID,
   callbackFunc: callbackFunc,
   pauseCount: 0
  };
  this.prepareItem(item);
  this.items[elementID] = item;
 },
 prepareItem: function(item) {
 },
 unsubscribe: function(elementID) {
  this.items[elementID] = null;
 },
 getItemElement: function(item) {
  var element = this.getElementById(item.elementID);
  if(element)
   return element;
  this.unsubscribe(item.elementID);
  return null;
 },
 getElementById: function(elementID) {
  var element = document.getElementById(elementID);
  return element && ASPx.IsValidElement(element) ? element : null;
 },
 pause: function(element, includeSubtree) {
  this.changeItemsState(element, includeSubtree, true);
 },
 resume: function(element, includeSubtree) {
  this.changeItemsState(element, includeSubtree, false);
 },
 forEachItem: function(processFunc, context) {
  context = context || this;
  for(var itemName in this.items) {
   if(!this.items.hasOwnProperty(itemName))
    continue;
   var item = this.items[itemName];
   if(item) {
    var needBreak = processFunc.call(context, item);
    if(needBreak)
     return;
   }
  }
 },
 changeItemsState: function(element, includeSubtree, pause) {
  this.forEachItem(function(item) {
   if(!element)
    this.changeItemState(item, pause);
   else {
    var itemElement = this.getItemElement(item);
    if(itemElement && (element == itemElement || (includeSubtree && ASPx.GetIsParent(element, itemElement)))) {
     this.changeItemState(item, pause);
     if(!includeSubtree)
      return true;
    }
   }
  }.aspxBind(this));
 },
 changeItemState: function(item, pause) {
  if(pause)
   this.pauseItem(item);
  else
   this.resumeItem(item);
 },
 pauseItem: function(item) {
  item.paused = true;
  item.pauseCount++;
 },
 resumeItem: function(item) {
  if(item.pauseCount > 0) {
   if(item.pauseCount == 1)
    item.paused = false;
   item.pauseCount--;
  }
 }
});
DomObserver.IsMutationObserverAvailable = function() {
 return !!window.MutationObserver;
};
var TimerObserver = ASPx.CreateClass(DomObserver, {
 constructor: function() {
  this.constructor.prototype.constructor.call(this);
  this.timerID = -1;
  this.observationTimeout = 300;
 },
 subscribe: function(elementID, callbackFunc) {
  DomObserver.prototype.subscribe.call(this, elementID, callbackFunc);
  if(!this.isActivated())
   this.startObserving();
 },
 isActivated: function() {
  return this.timerID !== -1;
 },
 startObserving: function() {
  if(this.isActivated())
   window.clearTimeout(this.timerID);
  this.timerID = window.setTimeout(this.onTimeout, this.observationTimeout);
 },
 onTimeout: function() {
  var observer = _aspxGetDomObserver();
  observer.doObserve();
  observer.startObserving();
 },
 doObserve: function() {
  if(!ASPx.documentLoaded) return;
  this.forEachItem(function(item) {
   if(!item.paused)
    this.doObserveForItem(item);
  }.aspxBind(this));
 },
 doObserveForItem: function(item) {
  var element = this.getItemElement(item);
  if(element)
   item.callbackFunc.call(this, element);
 }
});
var MutationObserver = ASPx.CreateClass(DomObserver, {
 constructor: function() {
  this.constructor.prototype.constructor.call(this);
  this.callbackTimeout = 10;
 },
 prepareItem: function(item) {
  item.callbackTimerID = -1;
  var target = this.getElementById(item.elementID);
  if(!target)
   return;
  var observerCallbackFunc = function() {
   if(item.callbackTimerID === -1) {
    var timeoutHander = function() {
     item.callbackTimerID = -1;
     item.callbackFunc.call(this, target);
    }.aspxBind(this);
    item.callbackTimerID = window.setTimeout(timeoutHander, this.callbackTimeout);
   }
  }.aspxBind(this);
  var observer = new window.MutationObserver(observerCallbackFunc);
  var config = { attributes: true, childList: true, characterData: true, subtree: true };
  observer.observe(target, config);
  item.observer = observer;
  item.config = config;
 },
 unsubscribe: function(elementID) {
  var item = this.items[elementID];
  if(item) {
   item.observer.disconnect();
   item.observer = null;
  }
  DomObserver.prototype.unsubscribe.call(this, elementID);
 },
 pauseItem: function(item) {
  DomObserver.prototype.pauseItem.call(this, item);
  item.observer.disconnect();
 },
 resumeItem: function(item) {
  DomObserver.prototype.resumeItem.call(this, item);
  if(!item.paused) {
   var target = this.getItemElement(item);
   if(target)
    item.observer.observe(target, item.config);
  }
 }
});
var domObserver = null;
function _aspxGetDomObserver() {
 if(domObserver == null)
  domObserver = DomObserver.IsMutationObserverAvailable() ? new MutationObserver() : new TimerObserver();
 return domObserver;
}
var ControlUpdateWatcher = ASPx.CreateClass(null, {
 constructor: function() {
  this.helpers = { };
  this.clearLockerTimerID = -1;
  this.clearLockerTimerDelay = 15;
  this.postProcessing = false;
  this.init();
 },
 init: function() {
  var postHandler = aspxGetPostHandler();
  postHandler.Post.AddHandler(this.OnPost, this);
 },
 Add: function(helper) {
  this.helpers[helper.GetName()] = helper;
 },
 CanSendCallback: function(dxCallbackOwner, arg) {
  this.LockConfirmOnBeforeWindowUnload();
  var modifiedHelpers = this.FilterModifiedHelpersByDXCallbackOwner(this.GetModifiedHelpers(), dxCallbackOwner, arg);
  if(modifiedHelpers.length === 0) return true;
  var modifiedHelpersInfo = this.GetToConfirmAndToResetLists(modifiedHelpers, dxCallbackOwner.name);
  if(!modifiedHelpersInfo) return true;
  if(modifiedHelpersInfo.toConfirm.length === 0) {
   this.ResetClientChanges(modifiedHelpersInfo.toReset);
   return true;
  }
  var helper = modifiedHelpersInfo.toConfirm[0];
  if(!confirm(helper.GetConfirmUpdateText()))
   return false;
  this.ResetClientChanges(modifiedHelpersInfo.toReset);
  return true;
 },
 OnPost: function(s, e) {
  if(this.isDxCallback(e))
   return;
  this.postProcessing = true;
  this.LockConfirmOnBeforeWindowUnload();
  var modifiedHelpersInfo = this.GetModifedHelpersInfo(e);
  if(!modifiedHelpersInfo)
   return;
  if(modifiedHelpersInfo.toConfirm.length === 0) {
   this.ResetClientChanges(modifiedHelpersInfo.toReset);
   return;
  }
  var helper = modifiedHelpersInfo.toConfirm[0];
  if(!confirm(helper.GetConfirmUpdateText())) {
   e.cancel = true;
   this.finishPostProcessing();
  }
  if(!e.cancel)
   this.ResetClientChanges(modifiedHelpersInfo.toReset);
 },
 isDxCallback: function(e) {
  return e.isDXCallback || this.isInternalUploadControlCallback();
 },
 isInternalUploadControlCallback: function() {
  var isInCallback = false;
  for(var key in this.helpers) {
   if(this.helpers.hasOwnProperty(key)) {
    var helper = this.helpers[key];
    isInCallback = isInCallback || helper.isInUploadCallback();
   }
  }
  return isInCallback;
 },
 finishPostProcessing: function() {
  this.postProcessing = false;
 },
 GetModifedHelpersInfo: function(e) {
  var modifiedHelpers = this.FilterModifiedHelpers(this.GetModifiedHelpers(), e);
  if(modifiedHelpers.length === 0) return;
  return this.GetToConfirmAndToResetLists(modifiedHelpers, e && e.ownerID);
 },
 GetToConfirmAndToResetLists: function(modifiedHelpers, ownerID) {
  var resetList = [ ];
  var confirmList = [ ];
  for(var i = 0; i < modifiedHelpers.length; i++) {
   var helper = modifiedHelpers[i];
   if(!helper.GetConfirmUpdateText()) { 
    resetList.push(helper);
    continue;
   }
   if(helper.CanShowConfirm(ownerID)) { 
    resetList.push(helper);
    confirmList.push(helper);
   }
  }
  return { toConfirm: confirmList, toReset: resetList };
 },
 FilterModifiedHelpers: function(modifiedHelpers, e) {
  if(modifiedHelpers.length === 0)
   return [ ];
  if(this.RequireProcessUpdatePanelCallback(e))
   return this.FilterModifiedHelpersByUpdatePanels(modifiedHelpers);
  if(this.postProcessing)
   return this.FilterModifiedHelpersByPostback(modifiedHelpers);
  return modifiedHelpers;
 },
 FilterModifiedHelpersByDXCallbackOwner: function(modifiedHelpers, dxCallbackOwner, arg) {
  var result = [ ];
  for(var i = 0; i < modifiedHelpers.length; i++) {
   var helper = modifiedHelpers[i];
   if(helper.NeedConfirmOnCallback(dxCallbackOwner, arg))
    result.push(helper);
  }
  return result;
 },
 FilterModifiedHelpersByUpdatePanels: function(modifiedHelpers) {
  var result = [ ];
  var updatePanels = this.GetUpdatePanelsWaitedForUpdate();
  for(var i = 0; i < updatePanels.length; i++) {
   var panelID = updatePanels[i].replace(/\$/g, "_");
   var panel = ASPx.GetElementById(panelID);
   if(!panel) continue;
   for(var j = 0; j < modifiedHelpers.length; j++) {
    var helper = modifiedHelpers[j];
    if(ASPx.GetIsParent(panel, helper.GetControlMainElement()))
     result.push(helper);
   }
  }
  return result;
 },
 FilterModifiedHelpersByPostback: function(modifiedHelpers) {
  var result = [ ];
  for(var i = 0; i < modifiedHelpers.length; i++) {
   var helper = modifiedHelpers[i];
   if(helper.NeedConfirmOnPostback())
    result.push(helper);
  }
  return result;
 },
 RequireProcessUpdatePanelCallback: function(e) {
  var rManager = this.GetMSRequestManager();
  if(rManager && e && e.isMSAjaxCallback)
   return rManager._postBackSettings.async;
  return false;
 },
 GetUpdatePanelsWaitedForUpdate: function() {
  var rManager = this.GetMSRequestManager();
  if(!rManager) return [ ];
  var panelUniqueIDs = rManager._postBackSettings.panelsToUpdate || [ ];
  var panelClientIDs = [ ];
  for(var i = 0; i < panelUniqueIDs.length; i++) {
   var index = ASPx.Data.ArrayIndexOf(rManager._updatePanelIDs, panelUniqueIDs[i]);
   if(index >= 0)
    panelClientIDs.push(rManager._updatePanelClientIDs[index]);
  }
  return panelClientIDs;
 },
 GetMSRequestManager: function() {
  return ASPx.GetMSAjaxRequestManager();
 },
 GetModifiedHelpers: function() {
  var result = [ ];
  for(var key in this.helpers) { 
   if(this.helpers.hasOwnProperty(key)) {
    var helper = this.helpers[key];
    if(helper.HasChanges())
     result.push(helper);
   }
  }
  return result;
 },
 ResetClientChanges: function(modifiedHelpers) {
  for(var i = 0; i < modifiedHelpers.length; i++)
   modifiedHelpers[i].ResetClientChanges();
 },
 GetConfirmUpdateMessage: function() {
  if(this.confirmOnWindowUnloadLocked) return;
  var modifiedHelpersInfo = this.GetModifedHelpersInfo();
  if(!modifiedHelpersInfo || modifiedHelpersInfo.toConfirm.length === 0) 
   return;
  var helper = modifiedHelpersInfo.toConfirm[0];
  return helper.GetConfirmUpdateText();
 },
 LockConfirmOnBeforeWindowUnload: function() {
  this.confirmOnWindowUnloadLocked = true;
  this.clearLockerTimerID = ASPx.Timer.ClearTimer(this.clearLockerTimerID);
  this.clearLockerTimerID = window.setTimeout(function() {
   this.confirmOnWindowUnloadLocked = false;
  }.aspxBind(this), this.clearLockerTimerDelay);
 },
 OnWindowBeforeUnload: function(e) {
  var confirmMessage = this.GetConfirmUpdateMessage();
  if(confirmMessage)
   e.returnValue = confirmMessage;
  this.finishPostProcessing();
  return confirmMessage;
 },
 OnWindowUnload: function(e) {
  if(this.confirmOnWindowUnloadLocked) return;
  var modifiedHelpersInfo = this.GetModifedHelpersInfo();
  if(!modifiedHelpersInfo) return;
  this.ResetClientChanges(modifiedHelpersInfo.toReset);
 },
 OnMouseDown: function(e) {
  if(ASPx.Browser.IE)
   this.PreventBeforeUnloadOnLinkClick(e);
 },
 OnFocusIn: function(e) {
  if(ASPx.Browser.IE)
   this.PreventBeforeUnloadOnLinkClick(e);
 },
 PreventBeforeUnloadOnLinkClick: function(e) {
  if(ASPx.GetObjectKeys(this.helpers).length == 0)
   return;
  var link = ASPx.GetParentByTagName(ASPx.Evt.GetEventSource(e), "A");
  if(!link || link.dxgvLinkClickHanlderAssigned)
   return;
  var url = ASPx.Attr.GetAttribute(link, "href");
  if(!url || url.indexOf("javascript:") < 0)
   return;
  ASPx.Evt.AttachEventToElement(link, "click", function(ev) { return ASPx.Evt.PreventEvent(ev); });
  link.dxgvLinkClickHanlderAssigned = true;
 }
});
ControlUpdateWatcher.Instance = null;
ControlUpdateWatcher.getInstance = function () {
 if (!ControlUpdateWatcher.Instance) {
  ControlUpdateWatcher.Instance = new ControlUpdateWatcher();
  ASPx.Evt.AttachEventToElement(window, "beforeunload", function(e) {
   return ControlUpdateWatcher.Instance.OnWindowBeforeUnload(e);
  });
  ASPx.Evt.AttachEventToElement(window, "unload", function(e) {
   ControlUpdateWatcher.Instance.OnWindowUnload(e);
  });
  ASPx.Evt.AttachEventToDocument("mousedown", function(e) {
   ControlUpdateWatcher.Instance.OnMouseDown(e);
  });
  ASPx.Evt.AttachEventToDocument("focusin", function(e) {
   ControlUpdateWatcher.Instance.OnFocusIn(e);
  });
 }
 return ControlUpdateWatcher.Instance;
};
var UpdateWatcherHelper = ASPx.CreateClass(null, {
 constructor: function(owner) {
  this.owner = owner;
  this.ownerWatcher = ControlUpdateWatcher.getInstance();
  this.ownerWatcher.Add(this);
 },
 GetName: function() {
  return this.owner.name;
 },
 GetControlMainElement: function() {
  return this.owner.GetMainElement();
 },
 GetControlParentForm: function(){
  return ASPx.GetParentByTagName(this.GetControlMainElement(), "FORM");
 },
 CanShowConfirm: function(requestOwnerID) {
  return true;
 },
 HasChanges: function() {
  return false;
 },
 GetConfirmUpdateText: function() {
  return "";
 },
 NeedConfirmOnCallback: function(dxCallbackOwner) {
  return true;
 },
 NeedConfirmOnPostback: function() {
  if(ASPx.IsUploadSubmitRequest)
   return !ASPx.IsUploadSubmitRequest(this.GetControlParentForm());
  return true;
 },
 ResetClientChanges: function() {
 },
 ConfirmOnCustomControlEvent: function() {
  var confirmMessage = this.GetConfirmUpdateText();
  if(confirmMessage)
   return confirm(confirmMessage);
  return false;
 },
 isInUploadCallback: function() {
  return false;
 }
});
var ControlTabIndexManager = ASPx.CreateClass(null, {
 constructor: function() {
  this.elementsWithChangedTabIndex = {};
 },
 getChangedElementsForControlId: function(id) {
  if(!this.elementsWithChangedTabIndex[id])
   this.elementsWithChangedTabIndex[id] = [];
  return this.elementsWithChangedTabIndex[id];
 },
 isElementWithChangedIndex: function(element) {
  for(var key in this.elementsWithChangedTabIndex)
   if(this.elementsWithChangedTabIndex.hasOwnProperty(key))
    if(this.elementsWithChangedTabIndex[key].indexOf(element) !== -1)
     return true;
  return false;
 },
 changeTabIndexAttribute: function(element, id) {
  var elements = this.getChangedElementsForControlId(id);
  ASPx.Attr.ChangeTabIndexAttribute(element);
  if(elements.indexOf(element) === -1)
   elements.push(element);
 },
 restoreTabIndexAttribute: function(element, id) {
  var elements = this.getChangedElementsForControlId(id),
   index = elements.indexOf(element);
  if(index !== -1) {
   elements.splice(index, 1);
   if(!this.isElementWithChangedIndex(element))
    ASPx.Attr.RestoreTabIndexAttribute(element);
  }
 }
});
ControlTabIndexManager.Instance = null;
ControlTabIndexManager.getInstance = function() {
 if(!ControlTabIndexManager.Instance)
  ControlTabIndexManager.Instance = new ControlTabIndexManager();
 return ControlTabIndexManager.Instance;
};
var ControlCallbackHandlersQueue = ASPx.CreateClass(null, {
 constructor: function (owner) {
  this.owner = owner;
  this.handlerInfos = [];
 },
 addCallbackHandler: function(handlerInfo) {
  this.handlerInfos.push(handlerInfo);
 },
 executeCallbacksHandlers: function() {
  for(var i = 0, handlerInfo; handlerInfo = this.handlerInfos[i]; i++)
   handlerInfo.handler.call(this.owner, handlerInfo.result);
  this.handlerInfos = [];
 }
});
var ControlCallbackQueueHelper = ASPx.CreateClass(null, {
 constructor: function (owner) {
  this.owner = owner;
  this.pendingCallbacks = [];
  this.receivedCallbacks = [];
  this.attachEvents();
 },
 showLoadingElements: function () {
  this.owner.ShowLoadingDiv();
  if (this.owner.IsCallbackAnimationEnabled())
   this.owner.StartBeginCallbackAnimation();
  else
   this.owner.ShowLoadingElementsInternal();
 },
 attachEvents: function () {
  this.owner.EndCallback.AddHandler(this.onEndCallback.aspxBind(this));
  this.owner.CallbackError.AddHandler(this.onCallbackError.aspxBind(this));
 },
 detachEvents: function () {
  this.owner.EndCallback.RemoveHandler(this.onEndCallback);
  this.owner.CallbackError.RemoveHandler(this.onCallbackError);
 },
 onCallbackError: function (owner, result) {
  this.sendErrorToChildControl(result);
 },
 ignoreDuplicates: function () {
  return true;
 },
 hasDuplicate: function (arg) {
  for (var i in this.pendingCallbacks) {
   if (this.pendingCallbacks[i].arg == arg && this.pendingCallbacks[i].state != ASPx.callbackState.aborted)
    return true;
  }
  return false;
 },
 getToken: function (halperContext, callbackInfo) {
  return {
   cancel: function () {
    if (callbackInfo.state == ASPx.callbackState.sent) {
     callbackInfo.state = ASPx.callbackState.aborted;
     halperContext.sendNext();
    }
    if (callbackInfo.state == ASPx.callbackState.inTurn)
     ASPx.Data.ArrayRemove(halperContext.pendingCallbacks, callbackInfo);
   },
   callbackId: -1
  };
 },
 sendCallback: function (arg, handlerContext, handler, commandName, onBeforeSend) {
  if (this.ignoreDuplicates() && this.hasDuplicate(arg))
   return false;
  var handlerContext = handlerContext || this.owner;
  var callbackInfo = {
   arg: arg,
   handlerContext: handlerContext,
   handler: handler || handlerContext.OnCallback,
   state: ASPx.callbackState.inTurn,
   callbackId: -1,
   onBeforeSend: onBeforeSend
  };
  this.pendingCallbacks.push(callbackInfo);
  if (!this.hasActiveCallback()) {
   this.createCallbackByCallbackInfo(callbackInfo, commandName);
  }
  return this.getToken(this, callbackInfo);
 },
 hasActiveCallback: function () {
  return this.getCallbacksInfoByState(ASPx.callbackState.sent).length > 0;
 },
 sendNext: function () {
  var nextCallbackInfo = this.getCallbacksInfoByState(ASPx.callbackState.inTurn)[0];
  if (nextCallbackInfo) {
   this.createCallbackByCallbackInfo(nextCallbackInfo);
   return nextCallbackInfo.callbackId;
  }
 },
 createCallbackByCallbackInfo: function(callbackInfo, commandName) {
  if(callbackInfo.onBeforeSend)
   callbackInfo.onBeforeSend();
  callbackInfo.callbackId = this.owner.CreateCallback(callbackInfo.arg, commandName);
  callbackInfo.state = ASPx.callbackState.sent;
 },
 onEndCallback: function () {
  if (!this.owner.isErrorOnCallback && this.hasPendingCallbacks()) {
   var curCallbackId;
   var curCallbackInfo;
   var handlerContext;
   for (var i in this.receivedCallbacks) {
    if(this.receivedCallbacks.hasOwnProperty(i)) {
     curCallbackId = this.receivedCallbacks[i];
     curCallbackInfo = this.getCallbackInfoById(curCallbackId);
     if (curCallbackInfo.state != ASPx.callbackState.aborted) {
      handlerContext = curCallbackInfo.handlerContext;
      if (handlerContext.OnEndCallback)
       handlerContext.OnEndCallback();
      this.sendNext();
     }
     ASPx.Data.ArrayRemove(this.pendingCallbacks, curCallbackInfo);
    }
   }
   ASPx.Data.ArrayClear(this.receivedCallbacks);
  }
 },
 hasPendingCallbacks: function () {
  return this.pendingCallbacks && this.pendingCallbacks.length && this.pendingCallbacks.length > 0;
 },
 processCallback: function (result, callbackId) {
  this.receivedCallbacks.push(callbackId);
  if (this.hasPendingCallbacks()) {
   var callbackInfo = this.getCallbackInfoById(callbackId);
   if (callbackInfo.state != ASPx.callbackState.aborted)
    callbackInfo.handler.call(callbackInfo.handlerContext, result);
  }
 },
 getCallbackInfoById: function (id) {
  for (var i in this.pendingCallbacks) {
   if (this.pendingCallbacks[i].callbackId == id)
    return this.pendingCallbacks[i];
  }
 },
 getCallbacksInfoByState: function (state) {
  var result = [];
  for (var i in this.pendingCallbacks) {
   if (this.pendingCallbacks[i].state == state)
    result.push(this.pendingCallbacks[i]);
  }
  return result;
 },
 sendErrorToChildControl: function (callbackObj) {
  if (!this.hasPendingCallbacks())
   return;
  var callbackInfo = this.getCallbackInfoById(callbackObj.callbackId || 0);
  if (!callbackInfo)
   return;
  var hasChildControlHandler = (callbackInfo.handlerContext != this.owner) && callbackInfo.handlerContext.OnCallbackError;
  if (hasChildControlHandler)
   callbackInfo.handlerContext.OnCallbackError.call(callbackInfo.handlerContext, callbackObj.message, callbackObj.data);
 }
});
var AccessibilityHelperBase = ASPx.CreateClass(null, {
 constructor: function(control) {
  this.control = control;
  this.timerID = -1;
  this.pronounceMessageTimeout = 500;
  this.activeItem = this.getItems()[0];
  this.pronounceIsStarted = false;
 },
 PronounceMessage: function(text, activeItemArgs, inactiveItemArgs, mainElementArgs, ownerMainElement) {   
  this.timerID = ASPx.Timer.ClearTimer(this.timerID);
  this.pronounceIsStarted = true;
  this.timerID = window.setTimeout(function() {
   this.PronounceMessageCore(text, activeItemArgs, inactiveItemArgs, mainElementArgs, ownerMainElement);
  }.aspxBind(this), this.getPronounceTimeout());
 },
 PronounceMessageCore: function(text, activeItemArgs, inactiveItemArgs, mainElementArgs, ownerMainElement) {
  if(!this.getItems())
   return;
  this.toogleItem();
  var mainElement = this.getMainElement();
  var activeItem = this.getItem(true);
  var inactiveItem = this.getItem();
  if(ASPx.Attr.GetAttribute(mainElement, "role") != "application")
   mainElementArgs = this.addArguments(mainElementArgs, { "aria-activedescendant" : activeItem.id });
  var messageAttrObj = {};
  var activeItemRole = ASPx.Attr.GetAttribute(activeItem, "role");
  var attrName = activeItemRole == "combobox" ? "aria-label" : "innerHtml";
  messageAttrObj[attrName] = ASPx.Str.EncodeHtml(text);
  activeItemArgs = this.addArguments(activeItemArgs, messageAttrObj);
  messageAttrObj[attrName] = "";
  inactiveItemArgs = this.addArguments(inactiveItemArgs, messageAttrObj);
  var errorTextElement = null;
  if(this.control.GetErrorCell()) {
   errorTextElement = this.getAriaExplanatoryTextManager().GetErrorTextElement();
   activeItemArgs = this.addArguments(activeItemArgs,   {"aria-invalid"  : !this.control.isValid ? "true" : "" });
   mainElementArgs = this.addArguments(mainElementArgs, { "aria-invalid" : "" });
   inactiveItemArgs = this.addArguments(inactiveItemArgs,  { "aria-invalid" : "" });
  }
  this.changeActivityAttributes(activeItem, activeItemArgs);
  if(errorTextElement) {
   this.getAriaExplanatoryTextManager().SetOrRemoveText([activeItem], errorTextElement, !this.control.isValid, false, true);
   this.getAriaExplanatoryTextManager().SetOrRemoveText([mainElement, inactiveItem], errorTextElement, false, false, false);
  }
  this.changeActivityAttributes(mainElement, mainElementArgs);
  if(!!ownerMainElement && ASPx.Attr.GetAttribute(ownerMainElement, "role") != "application")
   this.changeActivityAttributes(ownerMainElement, { "aria-activedescendant": activeItem.id });
  this.changeActivityAttributes(inactiveItem, inactiveItemArgs);
  this.pronounceIsStarted = false;
 },
 GetActiveElement: function(inputIsMainElement) {
  if(this.pronounceIsStarted) return null;
  var mainElement = inputIsMainElement ? this.control.GetInputElement() : this.getMainElement();
  var activeElementId = ASPx.Attr.GetAttribute(mainElement, 'aria-activedescendant');
  return activeElementId ? ASPx.GetElementById(activeElementId) : mainElement;
 },
 getMainElement: function() {
  if(!ASPx.IsExistsElement(this.mainElement))
   this.mainElement = this.control.GetAccessibilityAssistantElement();
  return this.mainElement;
 },
 getItems: function() {
  if(!ASPx.IsExistsElement(this.items))
   this.items = ASPx.GetChildElementNodes(this.getMainElement());
  return this.items;
 },
 getItem: function(isActive) {
  if(isActive)
   return this.activeItem;
  var items = this.getItems();
  return items[0] === this.activeItem ? items[1] : items[0];
 },
 getAriaExplanatoryTextManager: function() { return this.control.ariaExplanatoryTextManager; },
 getPronounceTimeout: function() { return this.pronounceMessageTimeout; },
 toogleItem: function() {
  this.activeItem = this.getItem();
 },
 addArguments: function(targetArgs, newArgs) {
  if(!targetArgs) targetArgs = { };
  for(var key in newArgs) {
   if(newArgs.hasOwnProperty(key) && !targetArgs.hasOwnProperty(key))
    targetArgs[key] = newArgs[key];
  }
  return targetArgs;
 },
 changeActivityAttributes: function(element, args) {
  if(!element)
   return;
  for(var key in args) {
   if(args.hasOwnProperty(key)) {
    var value = args[key];
    if(key == "innerHtml")
     ASPx.SetInnerHtml(element, value);
    else {
     var action = value !== "" ? ASPx.Attr.SetAttribute : ASPx.Attr.RemoveAttribute;
     action(element, key, value);
    }
   }
  }
 }
});
var AccessibilityPronouncer = ASPx.CreateClass(null, {
 constructor: function() {
  this.pronouncerId = "dxPronouncer";
  this.initialized = false;
  this.focusableMessageElement = null;
  this.messageElement = null;
  this.pronouncers = {
   live: new AccessibilityLivePronouncer(this),
   descendant: new AccessibilityDescendantPronouncer(this)
  };
 },
 Pronounce: function(args, type) {
  this.pronouncers[type].Pronounce(args);
 },
 EnsureInitialize: function() {
  if(!this.initialized)
   this.initialize();
 },
 RemoveState: function() {
  for(var pronouncer in this.pronouncers)
   if(this.pronouncers.hasOwnProperty(pronouncer))
    pronouncer.RemoveState();
 },
 RestoreControlState: function(type, mainElement) {
  this.pronouncers[type].RestoreControlState(mainElement);
 },
 RestoreElementsState: function(type, elements) {
  this.pronouncers[type].RestoreElementsState(elements);
 },
 RestoreElementState: function(type, element) {
  this.pronouncers[type].RestoreElementState(element);
 },
 initialize: function() {
  this.createFocusableMessageElement();
  this.createMessageElement();
  this.prepareFocusableMessageElement();
  this.setAttributesForKeyboardNavigation();
  this.initialized = true;
 },
 createFocusableMessageElement: function() {
  var focusableMessageElement = document.createElement("DIV");
  document.body.appendChild(focusableMessageElement);
  this.focusableMessageElement = focusableMessageElement;   
 },
 prepareFocusableMessageElement: function() {
  this.focusableMessageElement.className = "dxAIFME";
 },
 setAttributesForKeyboardNavigation: function() {
  ASPx.Attr.Aria.SetApplicationRole(this.focusableMessageElement);
  ASPx.Attr.Aria.SetSilence(this.focusableMessageElement);
 },
 createMessageElement: function() {
  var messageElement = document.createElement("DIV");
  messageElement.id = this.pronouncerId;
  ASPx.Attr.SetAttribute(messageElement, "role", "note");
  this.focusableMessageElement.appendChild(messageElement);
  this.messageElement = messageElement;
 },
 getMessage: function(messagePartsArg) {
  var messageParts = messagePartsArg.filter(function(x) { return ASPx.IsExists(x); });
  return messageParts.join(", ");
 }
});
var AccessibilityPronouncerBase = ASPx.CreateClass(null, {
 constructor: function() {
  this.state = { };
 },
 Pronounce: function(args) {
  var messageElement = this.getMessageElement();
  ASPx.Attr.Aria.SetOrRemoveLabel(messageElement);
  ASPx.SetInnerHtml(messageElement, "");
  this.PronounceCore(args);
 },
 PronounceCore: function(args) { },
 SaveElementState: function(element) { 
  if(this.state[element.id])
   return;
  this.state[element.id] = {
   element: element,
   descendant: ASPx.Attr.GetAttribute(element, ASPx.Attr.Aria.descendant)
  };
 },
 RemoveState: function() {
  this.state = { };
 },
 RestoreControlState: function(mainElement) { 
  for(var elementInfo in this.state) {
   if(this.state.hasOwnProperty(elementInfo)) {
    var element = this.state[elementInfo].element;
    if(!mainElement || ASPx.GetIsParent(mainElement, element))
     this.RestoreElementState(element);
   }
  }
 },
 RestoreElementsState: function(elements) { 
  for(var i = 0; i < elements.length; i++)
   this.RestoreElementState(elements[i]);
 },
 RestoreElementState: function(element) {
  var elementState = this.state[element.id];
  if(!elementState)
   return;
  ASPx.Attr.Aria.SetOrRemoveDescendant(element, elementState.descendant);
  delete this.state[element.id];
 },
 getMessage: function(args) {
  return ASPx.AccessibilityPronouncer.getMessage(args.messageParts);
 },
 getMessageElement: function() {
  return ASPx.AccessibilityPronouncer.messageElement;
 },
 getFocusableMessageElement: function() {
   return ASPx.AccessibilityPronouncer.focusableMessageElement;
 }
});
var AccessibilityLivePronouncer = ASPx.CreateClass(AccessibilityPronouncerBase, {
 constructor: function() {
  this.constructor.prototype.constructor.call(this);
 },
 PronounceCore: function(args) {
  var message = this.getMessage(args);
  var messageElement = this.getMessageElement();
  ASPx.Attr.SetAttribute(this.getFocusableMessageElement(), "aria-live", "assertive");
  ASPx.Attr.Aria.SetAtomic(this.getFocusableMessageElement(), "true");
  ASPx.SetInnerHtml(messageElement, ASPx.Str.EncodeHtml(message));
 }
});
var AccessibilityDescendantPronouncer = ASPx.CreateClass(AccessibilityPronouncerBase, {
 constructor: function() {
  this.constructor.prototype.constructor.call(this);
 },
 PronounceCore: function(args) {
  var message = this.getMessage(args);
  var activeElement = ASPx.GetActiveElement();
  var messageElement = this.getMessageElement();
  this.SaveElementState(activeElement);
  ASPx.Attr.RemoveAttribute(this.getFocusableMessageElement(), "aria-live");
  ASPx.Attr.RemoveAttribute(this.getFocusableMessageElement(), "aria-atomic");
  ASPx.Attr.Aria.SetOrRemoveLabel(messageElement, message);
  ASPx.Attr.Aria.SetOrRemoveDescendant(activeElement, messageElement.id);
 }
});
ASPx.AccessibilityPronouncerType = {
 live: "live",
 descendant: "descendant"
};
ASPx.AccessibilityPronouncer = new AccessibilityPronouncer();
var RestoreFocusHelper = ASPx.CreateClass(null, {
 constructor: function() {
  this.excludedIDs = [ "DXCBtn" ]; 
  this.pronouncerType = ASPx.AccessibilityPronouncerType.live;
  this.callbackQueue = [];
  this.Initialize();
 },
 Initialize: function() {
  var that = this;
  ASPx.attachToLoad(function() {
   ASPxClientControl.GetControlCollection().BeginCallback.AddHandler(that.OnBeginCallback, that);
   ASPxClientControl.GetControlCollection().EndCallback.AddHandler(that.OnEndCallback, that);
  });
 },
 OnBeginCallback: function(s, e) {
  var control = e.control;
  if(!control.allowRestoreFocusOnCallbacks())
   return;
  control.accessibilityFocusTreeLine = this.getFocusTreeLine(control);
  var controlHasCallbackTreeLine = this.callbackQueueContainsTreeLine(control);
  this.pushTreeLineInfoIntoCallbackQueue(control);
  if(control.accessibilityFocusTreeLine && !controlHasCallbackTreeLine)
   control.SendMessageToAssistiveTechnology(this.getDefaultCallbackMessage());
 },
 OnEndCallback: function(s, e) {
  var control = e.control;
  if(!control.allowRestoreFocusOnCallbacks())
   return;
  var treeLineInfo = this.shiftTreeLineInfoFromCallbackQueue(control);
  if(treeLineInfo.queueLength == 0) {
   if(!control.accessibilityFocusTreeLine && treeLineInfo.treeLine)
    control.accessibilityFocusTreeLine = treeLineInfo.treeLine;
   var focusElement = this.findFocusElement(control);
   var focusIsManagerByPopupwindow = this.isFocusManagedByActivePopupWindow(focusElement);
   var focusIsManagedByControl = control.shouldPreventFocusRestoringOnCallback && control.shouldPreventFocusRestoringOnCallback();
   if(!focusIsManagerByPopupwindow && !focusIsManagedByControl)
    ASPx.AccessibilityUtils.SetFocusAccessible(focusElement);
   delete control.accessibilityFocusTreeLine;
  }
 },
 pushTreeLineInfoIntoCallbackQueue: function(control) {
  var controlTreeLine = control.accessibilityFocusTreeLine ? control.accessibilityFocusTreeLine.slice(0) : null;
  if(!this.callbackQueue[control.name])
   this.callbackQueue[control.name] = [];
  this.callbackQueue[control.name].push(controlTreeLine);
 },
 shiftTreeLineInfoFromCallbackQueue: function(control) {
  var treeLineInfo = { queueLength: 0, treeLine: null };
  var treeLines = this.callbackQueue[control.name];
  if(treeLines && treeLines.length > 0) {
   treeLineInfo.treeLine = treeLines.shift();
   var linesCount = treeLines.length;
   treeLineInfo.queueLength = linesCount;
   if(linesCount > 0 && !treeLines[0] && treeLineInfo.treeLine)
    treeLines[0] = treeLineInfo.treeLine.slice(0);
  }
  return treeLineInfo;
 },
 callbackQueueContainsTreeLine: function(control) {
  var treeLines = this.callbackQueue[control.name];
  if(!treeLines || treeLines.length == 0) 
   return false;
  if(treeLines[treeLines.length - 1])
   return true;
  return false;
 },
 getDefaultCallbackMessage: function() {
  return ASPx.AccessibilitySR.DefaultCallbackMessage;
 },
 isFocusManagedByActivePopupWindow: function(focusElement) {
  var popupControl = this.getActivePopupControl();
  if(!popupControl || popupControl.accessibleFocusElement)
   return false;
  this.initializePopupAccessibleFocusElement(popupControl, focusElement);
  return popupControl.setFocusOnCallback;
 },
 getActivePopupControl: function() {
  var activePopupWindow = ASPx.GetPopupControlCollection && ASPx.GetPopupControlCollection().GetCurrentActiveWindowElement();
  if(!activePopupWindow)
   return null;
  var popupInfo = ASPx.GetPopupControlCollection().GetPopupWindowFromID(activePopupWindow.id);
  return popupInfo.popupControl;
 },
 initializePopupAccessibleFocusElement: function(popupControl, focusElement) {
  if(popupControl.setFocusOnCallback)
   popupControl.accessibleFocusElement = focusElement;
  else {
   var parentControl = popupControl.GetParentControl();
   if(parentControl && parentControl.GetMainElement())
    popupControl.accessibleFocusElement = ASPx.FindFirstChildActionElement(parentControl.GetMainElement());
  }
 },
 getFocusTreeLine: function(control) {
  var element = ASPx.GetActiveElement();
  if(!ASPx.IsExistsElement(element))
   return null;
  var mainElement = control.GetMainElement();
  if(!ASPx.GetIsParent(mainElement, element)) {
   var treeInfo = this.findFocusedControlElement(mainElement, element);
   element = treeInfo.focusElement;
   mainElement = treeInfo.rootElement;
  }
  return this.getTreeLineCore(mainElement, element);
 },
 getTreeLineCore: function(mainElement, element) {
  if(!element) return null;
  treeLine = [ ];
  while(element) {
   treeLine.push({ 
    id: element.id,
    tagName: element.tagName,
    index: ASPx.Data.ArrayIndexOf(element.parentNode.childNodes, element)
   });
   if(element === mainElement || element === document.body)
    break;
   element = element.parentNode;
  }
  return treeLine;
 },
 findFocusedControlElement: function(mainElement, activeElement) {
  var element = null;
  var parentElement = mainElement;
  var focusedEditor = ASPx.IsExists(ASPx.GetFocusedEditor) ? ASPx.GetFocusedEditor() : null;
  if(focusedEditor && ASPx.GetIsParent(mainElement, focusedEditor.GetMainElement()))
   element = focusedEditor.GetFocusableInputElement();
  else {
   if(mainElement && activeElement) {
    var mainControl = ASPx.GetClientControlByElementID(mainElement.id);
    var parentControls = ASPx.GetParentClientControls(activeElement.id);
    for(var i = parentControls.length - 1; i > -1; i--) {   
     if(mainControl.name == parentControls[i].name) {
      element = activeElement;
      var rootIndex = i > 0 ? i - 1 : i;
      parentElement = parentControls[rootIndex].GetMainElement();
      if(!parentElement && parentControls[rootIndex].GetCurrentWindowElement)
       parentElement = parentControls[rootIndex].GetCurrentWindowElement();
      break;
     }
    }
   }
  }
  return { focusElement: element, rootElement: parentElement }; 
 },
 findFocusElement: function(control) {
  if(!control.accessibilityFocusTreeLine)
   return;
  var treeLine = control.accessibilityFocusTreeLine.slice(0);
  var focusElementParent = this.findFocusElementParentById(treeLine);
  if(!focusElementParent) 
   return;
  return this.findFocusElementFromDOMTree(treeLine, focusElementParent);
 },
 findFocusElementParentById: function(treeLine) {
  for(var i = 0; i < treeLine.length; i++) {
   var id = treeLine[i].id;
   if(!this.isValidId(id))
    continue;
   var element = document.getElementById(id);
   if(element) {
    treeLine.splice(i, treeLine.length - i);
    treeLine.reverse();
    return element;
   }
  }
  return null;
 },
 findFocusElementFromDOMTree: function(treeLine, focusElementParent) {
  var element = focusElementParent;
  for(var i = 0; i < treeLine.length; i++) {
   var info = treeLine[i];
   if(info.index >= element.childNodes.length) {
    element = element.childNodes.length > 0 ? element.childNodes[element.childNodes.length - 1] : null;
    return this.findNeighbourFocusElement(element, focusElementParent);
   }
   var child = element.childNodes[info.index];
   if(child.tagName !== info.tagName)
    return this.findNeighbourFocusElement(child, focusElementParent);
   element = child;
  }
  return element;
 },
 findNeighbourFocusElement: function(element, focusElementParent) {
  ASPx.ActionElementsCache.BeginUsage();
  var result = this.findNeighbourFocusElementCore(element, focusElementParent);
  ASPx.ActionElementsCache.EndUsage();
  return result;
 },
 findNeighbourFocusElementCore: function(element, focusElementParent) {
  if(!element || !element.parentNode) return null;
  var neighbours = element.parentNode.childNodes;
  var indices = this.calcLeftRightIndices(ASPx.Data.ArrayIndexOf(neighbours, element), neighbours.length);
  for(var i = 0; i < indices.length; i++) {
   var index = indices[i];
   var actionElement = ASPx.FindFirstChildActionElement(neighbours[index]);
   if(actionElement)
    return actionElement;
  }
  if(element === focusElementParent)
   return null;
  return this.findNeighbourFocusElement(element.parentNode, focusElementParent);
 },
 calcLeftRightIndices: function(startIndex, count) {
  var indices = [ ];
  var incSides = [ 0, 0 ];
  var index = startIndex;
  for(var i = 0; i < count; i++) {
   indices.push(index);
   var even = i % 2 === 0;
   var nextIndex = this.calcNextIndex(startIndex, count, incSides, even);
   if(nextIndex < 0)
    nextIndex = this.calcNextIndex(startIndex, count, incSides, !even);
   index = nextIndex;
  }
  return indices;
 },
 calcNextIndex: function(startIndex, count, incSides, even) {
  var sideIndex = even ? 0 : 1;
  var inc = incSides[sideIndex];
  inc += even ? -1 : 1;
  var nextIndex = startIndex + inc;
  if(nextIndex >= 0 && nextIndex < count) {
   incSides[sideIndex] = inc;
   return nextIndex;
  }
  return -1;
 },
 isValidId: function(id) {
  return id && !this.isExcludedId(id);
 },
 isExcludedId: function(id) {
  var result = false;
  for(var i = 0; i < this.excludedIDs.length; i++) {
   if(id.indexOf(this.excludedIDs[i]) > -1) {
    result = true;
    break;
   }
  }
  return result;
 }
});
var EventStorage = ASPx.CreateClass(null, {
 constructor: function() {
  this.bag = { };
 },
 Save: function(e, data, overwrite) {
  var key = this.getEventKey(e);
  if(this.bag.hasOwnProperty(key) && !overwrite)
   return;
  this.bag[key] = data;
  window.setTimeout(function() { delete this.bag[key]; }.aspxBind(this), 100);
 },
 Load: function(e) {
  var key = this.getEventKey(e);
  return this.bag[key];
 },
 getEventKey: function(e) {
  if(ASPx.IsExists(e.timeStamp))
   return e.timeStamp.toString();
  var eventSource = ASPx.Evt.GetEventSource(e);
  var type = e.type.toString();
  return eventSource ? type + "_" + eventSource.uniqueID.toString() : type;
 }
});
ASPx.RestoreFocusHelper = new RestoreFocusHelper();
EventStorage.Instance = null;
EventStorage.getInstance = function() {
 if(!EventStorage.Instance)
  EventStorage.Instance = new EventStorage();
 return EventStorage.Instance;
};
var GetGlobalObject = function(objectName) {
 var fields = objectName.split('.');
 var obj = window[fields[0]];
 for(var i = 1; obj && i < fields.length; i++) {
  obj = obj[fields[i]];
 }
 return obj;
};
var GetExternalScriptProcessor = function() {
 return ASPx.ExternalScriptProcessor ? ASPx.ExternalScriptProcessor.getInstance() : null;
};
var SAVED_WIDTH_ATTR = "data-dx-ripple-saved-width";
var RIPPLE_FIXED_ROW_ATTR = "data-dx-ripple-locked";
var READ_ONLY_COMBOBOX_MARKER_CSS_CLASS = "dxICBReadonlyMarker";
var ThemesWithRipple = ['Material'];
var RippleHelper = {
 rippleTargetClassName: "dxRippleTarget",
 rippleTargetExternalClassName: "dxRippleTargetExternal",
 rippleContainerClassName: "dxRippleContainer",
 rippleClassName: "dxRipple",
 touchRadius: -1,
 isMobileExternalRipple: null,
 zoom: 1,
 Init: function() {
  if(this.getIsRippleFunctionalityEnabled()) {
   setTimeout(function() {
    this.calcTouchRadius();
   }.aspxBind(this), 0);
  }
 },
 calcTouchRadius: function() {
  var testBlock = document.createElement("DIV");
  ASPx.SetStyles(testBlock, {
   height: "1in",
   width: "1in",
   left: "-100%",
   top: "-100%",
   position: "absolute"
  });
  document.body.appendChild(testBlock);
  this.touchRadius = (1.8 / 2.54) * Math.max(testBlock.offsetWidth, testBlock.offsetHeight);
  document.body.removeChild(testBlock);
 },
 isRippleFunctionalityEnabled: null,
 checkRippleFunctionality: function() {
  if(ASPx.Browser.Safari && ASPx.Browser.Version <= 5.1)
   return false;
  for(var i = 0; i < ThemesWithRipple.length; i++) {
   var firstRippleThemeElement = document.querySelector("[class*='_" + ThemesWithRipple[i] + "']");
   if(firstRippleThemeElement)
    return true;
  }  
  return false;
 },
 ReInit: function() {
  this.isRippleFunctionalityEnabled = null;
  this.Init();
 },
 onDocumentMouseDown: function(evt) {
  if(RippleHelper.getIsRippleFunctionalityEnabled())
   RippleHelper.processMouseDown(evt);
 },
 getIsRippleFunctionalityEnabled: function() {
  if(!ASPx.IsExists(this.isRippleFunctionalityEnabled))
   this.isRippleFunctionalityEnabled = this.checkRippleFunctionality();
  return this.isRippleFunctionalityEnabled;
 },
   createTargetInfo: function(target) {
  return { 
   x: ASPx.GetAbsoluteX(target),
   y: ASPx.GetAbsoluteY(target),
   width: target.offsetWidth,
   height: target.offsetHeight,
   classNames: ASPx.GetClassNameList(target),
   getTarget: function() { return target; },
   getRect: function() { return {x: this.x, y: this.y, width: this.width, height: this.height }; }
  };
 },
 createEventInfo: function(evt) {
  return { x: this.getEventX(evt), y: this.getEventY(evt) };
 },
 processMouseDown: function(evt) {
  var evtSource = ASPx.Evt.GetEventSource(evt);
  var rippleTarget = this.getRippleTargetElement(evtSource);
  if(this.needToProcessRipple(rippleTarget, evtSource))
   this.processRipple(this.createTargetInfo(rippleTarget), this.createEventInfo(evt));
 },
 getRippleTargetElement: function(evtSource) {
  if(this.hasRippleMarker(evtSource))
   return evtSource;
  if(evtSource.tagName && evtSource.tagName.toLowerCase() == "input" && ASPx.ElementContainsCssClass(evtSource, "dxTI")) {
   var elements = ASPx.GetChildElementNodesByPredicate(evtSource.parentNode.parentNode, function(element) {
    return this.hasRippleMarker(element);
   }.aspxBind(this));
   return elements && elements[0];
  }
  return ASPx.GetParent(evtSource, function(element) {
   return this.hasRippleMarker(element);
  }.aspxBind(this));
 },
 hasRippleMarker: function(element) {
  if(!ASPx.IsExistsElement(element))
   return false;
  var computedStyles = window.getComputedStyle(element, ":before");
  if(ASPx.IsExists(computedStyles)) {
   var content = computedStyles.getPropertyValue("content");
   if(content.indexOf(this.rippleTargetExternalClassName) > -1) {
    ASPx.AddClassNameToElement(element, this.rippleTargetExternalClassName);
    return true;
   }
   return content.indexOf(this.rippleTargetClassName) > -1;
  }
  return false;
 },
 needToProcessRipple: function(rippleTarget, evtSource) {
  if(!rippleTarget || !ASPx.AnimationUtils)
   return false;
  var isClearButton = ASPx.ElementContainsCssClass(rippleTarget, "dxeButton") && rippleTarget.id && rippleTarget.id.indexOf("B-100") !== -1;
  var isEmptyCalendarDay = ASPx.ElementContainsCssClass(rippleTarget, "dxeCalendarDay") && ASPx.Str.Trim(rippleTarget.textContent) == "";
  var isReadonly = ASPx.ElementContainsCssClass(rippleTarget, READ_ONLY_COMBOBOX_MARKER_CSS_CLASS);
  var tempFixDisable = ASPx.ElementContainsCssClass(rippleTarget, "dxSwitcher") && ASPx.Browser.MacOSMobilePlatform;
  var rippleIsForbidden = isReadonly || isClearButton || isEmptyCalendarDay || ASPx.GetParentByPartialClassName(rippleTarget, "Disabled") ||
   ASPx.ElementContainsCssClass(rippleTarget, "dxgvBatchEditCell") || ASPx.ElementContainsCssClass(rippleTarget, "dxcvEditForm") ||
   ASPx.GetParentByPartialClassName(evtSource, "dxcvFocusedCell") || tempFixDisable;
  return !rippleIsForbidden;
 },
 hasBothOverflow: function(style) {
  return style.overflow == "scroll" || style.overflow == "auto" || style.overflow == "hidden";
 },
 hasOverflowX: function(style) {
  return style.overflowX == "scroll" || style.overflowX == "auto" || style.overflowX == "hidden";
 },
 hasOverflowY: function(style) {
  return style.overflowY == "scroll" || style.overflowY == "auto" || style.overflowY == "hidden";
 },
 getExternalRippleContainerSize: function(targetRect) {
  if(ASPx.Browser.MobileUI) {
   var origTouchRadius = this.getOriginTouchRadius();
   if(origTouchRadius < targetRect.width || origTouchRadius < targetRect.height)
    origTouchRadius = Math.max(targetRect.width, targetRect.height);
   return {x: targetRect.x + (targetRect.width - origTouchRadius) / 2, y: targetRect.y + (targetRect.height - origTouchRadius) / 2, width: origTouchRadius, height: origTouchRadius };
  }
  var result = { x: 0, y: 0, width: 0, height: 0 };
  var diff = targetRect.width - targetRect.height;
  if(diff > 0) {
   result.x = targetRect.x;
   result.y = targetRect.y - diff / 2;
   result.width = targetRect.width;
   result.height = targetRect.width;
  } else {
   result.x = targetRect.x + diff / 2;
   result.y = targetRect.y;
   result.width = targetRect.height;
   result.height = targetRect.height;
  }
  return result;
 },
 getInternalContainerSize: function(targetInfo) {
  var parentWithOverflow = RippleHelper.getParentWithOverflow(targetInfo.getTarget());
  if(!ASPx.IsExists(parentWithOverflow))
   return targetInfo;
  var parentWithOverflowStyle = ASPx.GetCurrentStyle(parentWithOverflow);
  var bothOverflow = this.hasBothOverflow(parentWithOverflowStyle);
  var overflowX = this.hasOverflowX(parentWithOverflowStyle);
  var overflowY = this.hasOverflowY(parentWithOverflowStyle);
  var parentRect = {
   x: ASPx.GetAbsoluteX(parentWithOverflow),
   y: ASPx.GetAbsoluteY(parentWithOverflow),
   width: parentWithOverflow.offsetWidth,
   height: parentWithOverflow.offsetHeight
  };
  return this.getInternalContainerSizeCore(targetInfo, parentRect, bothOverflow, overflowX, overflowY);
 },
 getInternalContainerSizeCore: function(targetRect, parentRect, bothOverflow, overflowX, overflowY) {
  var result = {};
  ASPx.Data.MergeHashTables(result, targetRect);
  if(bothOverflow || overflowX) {
   result.x = targetRect.x < parentRect.x ? parentRect.x : targetRect.x;
   if(targetRect.x + targetRect.width > parentRect.x + parentRect.width)
    result.width = parentRect.x + parentRect.width - targetRect.x;
   if(parentRect.x > targetRect.x)
    result.width -= (parentRect.x - targetRect.x);
  }
  if(bothOverflow || overflowY) {
   result.y = targetRect.y < parentRect.y ? parentRect.y : targetRect.y;
   if(targetRect.y + targetRect.height > parentRect.y + parentRect.height)
    result.height = parentRect.y + parentRect.height - targetRect.y;
   if(parentRect.y > targetRect.y)
    result.height -= (parentRect.y - targetRect.y);
  }
  return result;
 },
 calculateRippleContainerSize: function(targetInfo, isExternalRipple) {
  return isExternalRipple ? this.getExternalRippleContainerSize(targetInfo) : this.getInternalContainerSize(targetInfo);
 },
 getParentWithOverflow: function(rippleTarget) {
  var result = ASPx.GetParent(rippleTarget, function(element) {
   var elementStyle = ASPx.GetCurrentStyle(element);
   return this.hasBothOverflow(elementStyle) || this.hasOverflowX(elementStyle) || this.hasOverflowY(elementStyle);
  }.aspxBind(this));
  return result;
 },
 getDuration: function(targetInfo) {
  return this.IsExternalRipple(targetInfo) || ASPx.Browser.MobileUI ? 650 : 450;
 },
 createRippleTransition: function(container, rippleElement, radius, targetInfo) {
  var rippleSize = 2 * radius;
  var transitionProperties = {
   width: { from: 0, to: rippleSize, transition: ASPx.AnimationConstants.Transitions.RIPPLE, propName: "width", unit: "px" },
   height: { from: 0, to: rippleSize, transition: ASPx.AnimationConstants.Transitions.RIPPLE, propName: "height", unit: "px" },
   marginLeft: { from: 0, to: -rippleSize / 2, transition: ASPx.AnimationConstants.Transitions.RIPPLE, propName: "marginLeft", unit: "px" },
   marginTop: { from: 0, to: -rippleSize / 2, transition: ASPx.AnimationConstants.Transitions.RIPPLE, propName: "marginTop", unit: "px" },
   opacity: { from: 1, to: 0.05, transition: ASPx.AnimationConstants.Transitions.RIPPLE, propName: "opacity", unit: "%" }
  };
  var rippleTransition = ASPx.AnimationUtils.createMultipleAnimationTransition(rippleElement, {
   transition: ASPx.AnimationConstants.Transitions.RIPPLE,
   duration: this.getDuration(targetInfo),
   onComplete: function() {
    this.RemoveRippleContainer(container.parentElement);
   }.bind(this)
  });
  rippleTransition.Start(transitionProperties);
 },
 needForceTransitionEndByTimer: function() { return true; }, 
 calculateRadius: function(isExternalRipple, posX, posY, containerRect) {
  var radius = -1;
  if(isExternalRipple) {
   if(ASPx.Browser.MobileUI)
    radius = this.getOriginTouchRadius() / 2;
   else
    radius = Math.max(containerRect.height, containerRect.width);
  } else {
   var width1 = posX - containerRect.x;
   var width2 = containerRect.width - width1;
   var height1 = posY - containerRect.y;
   var height2 = containerRect.height - height1;
   var rippleWidth = Math.max(width1, width2);
   var rippleHeight = Math.max(height1, height2);
   radius = Math.sqrt(Math.pow(rippleHeight, 2) + Math.pow(rippleWidth, 2));
  }
  return radius;
 },
 createRippleElement: function(container, rippleCenter) {
  var rippleElement = document.createElement("DIV");
  rippleElement.className = this.rippleClassName;
  container.appendChild(rippleElement);
  ASPxClientUtils.SetAbsoluteX(rippleElement, rippleCenter.x);
  ASPxClientUtils.SetAbsoluteY(rippleElement, rippleCenter.y);
  return rippleElement;
 },
 processRipple: function(targetInfo, eventInfo) {
  this.initRippleProcess();
  var isExternalRipple = this.IsExternalRipple(targetInfo);
  var rippleCenter = this.getRippleCenter(targetInfo.getRect(), eventInfo, isExternalRipple);
  var container = this.createRippleContainer(targetInfo, isExternalRipple);
  var rippleElement = this.createRippleElement(container, rippleCenter);
  var radius = this.calculateRadius(isExternalRipple, rippleCenter.x, rippleCenter.y, this.getElementRect(container));
  this.createRippleTransition(container, rippleElement, radius, targetInfo);
 },
 initRippleProcess: function() {
  this.isMobileExternalRipple = null;
  this.zoom = screen.width / window.innerWidth;
 },
 getRippleCenter: function(targetInfo, eventInfo, isExternalRipple) {
  var posX = 0;
  var posY = 0;
  if(isExternalRipple) {
   posX = targetInfo.x + targetInfo.width / 2;
   posY = targetInfo.y + targetInfo.height / 2;
  } else {
   posX = eventInfo.x;
   posY = eventInfo.y;
  }
  return {x: posX, y: posY};
 },
 createRippleContainer: function(targetInfo, isExternalRipple) {
  var containerParent = targetInfo.getTarget();
  if(!containerParent)
   return;
  var containerTagName = containerParent.tagName == "TR" ? "TD" : "DIV";
  var container = document.createElement(containerTagName);
  container.className = this.rippleContainerClassName;
  if(containerParent.parentNode && containerParent.tagName == "IMG")
   containerParent = containerParent.parentNode;
  if(this.isARowInFixedLayoutTable(containerParent))
   this.lockFixedLayoutTableSizes(containerParent);
  containerParent.appendChild(container);
  if(isExternalRipple)
   container.style.borderRadius = "50%";
  var containerRect = this.calculateRippleContainerSize(targetInfo, isExternalRipple);
  this.assignContainerSettings(container, containerRect);
  return container;
 },
 isARowInFixedLayoutTable: function(containerParent) {
  if(containerParent.tagName !== "TR")
   return false;
  var parentTable = this.getParentTable(containerParent);
  return parentTable && ASPx.GetCurrentStyle(parentTable)["table-layout"] === "fixed";
 },
 processFirstRowOfFixedTable: function(containerRow, rowAction, cellAction) {
  var firstRow = this.getFirstRow(containerRow);
  rowAction(firstRow);
  var cells = ASPx.Data.CollectionToArray(firstRow.cells);
  cells.forEach(cellAction);
 },
 getParentTable: function(element) {
  var parentTable = element;
  while(parentTable && parentTable.tagName !== "TABLE")
   parentTable = parentTable.parentElement;
  return parentTable;
 },
 lockFixedLayoutTableSizes: function(containerRow) {
  var firstRow = this.getFirstRow(containerRow);
  if(this.incLockCount(firstRow) === 1) {
   var cells = ASPx.Data.CollectionToArray(firstRow.cells);
   var widths = cells.map(function(cell) { return cell.style.width; });
   var computedWidths = cells.map(function(cell) {
    if(ASPx.Browser.IE && ASPx.ElementHasCssClass(cell, "dxeCM"))
     return cell.offsetWidth + "px";
    return window.getComputedStyle(cell).width;
   });
   var fixWidth = function(cell, i) {
    if(ASPx.Attr.IsExistsAttribute(cell, SAVED_WIDTH_ATTR))
     return;
    if(widths[i])
     ASPx.Attr.SetAttribute(cell, SAVED_WIDTH_ATTR, widths[i]);
    cell.style.width = computedWidths[i];
   };
   cells.forEach(fixWidth);
  }
 }, 
 unlockFixedLayoutTableSizes: function(containerRow) {
  var firstRow = this.getFirstRow(containerRow);   
  if(this.decLockCount(firstRow) === 0) {
   var cells = ASPx.Data.CollectionToArray(firstRow.cells);
   var restoreState = function(cell) {
    if(ASPx.Attr.IsExistsAttribute(cell, SAVED_WIDTH_ATTR)) {
     cell.style.width = ASPx.Attr.GetAttribute(cell, SAVED_WIDTH_ATTR);
     ASPx.Attr.RemoveAttribute(cell, SAVED_WIDTH_ATTR);
    } else {
     cell.style.width = null;
    }
   };
   cells.forEach(restoreState);
  }
 },
 getFirstRow: function(containerRow) { return ASPx.GetChildByTagName(containerRow.parentElement, "TR", 0); },
 incLockCount: function(elem) { return this.changeLockCount(elem, 1); },
 decLockCount: function(elem) { return this.changeLockCount(elem, -1); },
 changeLockCount: function(elem, diff) {
  var lockCounter = this.getLockCount(elem);
  lockCounter += diff;
  lockCounter = Math.max(0, lockCounter);
  if(lockCounter === 0)
   ASPx.Attr.RemoveAttribute(elem, RIPPLE_FIXED_ROW_ATTR);
  else
   ASPx.Attr.SetAttribute(elem, RIPPLE_FIXED_ROW_ATTR, lockCounter);
  return lockCounter;
 },
 getLockCount: function(lockElement) {
  var attrValue = ASPx.Attr.GetAttribute(lockElement, RIPPLE_FIXED_ROW_ATTR);
  return parseInt(attrValue) || 0;
 },
 assignContainerSettings: function(container, containerRect) {
  var properties = {
   height: containerRect.height,
   width: containerRect.width,
   left: ASPx.PrepareClientPosForElement(containerRect.x, container, true),
   top: ASPx.PrepareClientPosForElement(containerRect.y, container, false)
  };
  if(ASPx.Browser.MobileUI)
   ASPx.Data.MergeHashTables(properties, {marginTop: 0, marginLeft: 0 });
  ASPx.SetStyles(container, properties, ASPx.Browser.MobileUI);
 },
 IsExternalRipple: function(targetInfo) {
  var hasExternalRippleClassName = ASPx.ElementContainsCssClass(targetInfo.getTarget(), this.rippleTargetExternalClassName);
  if(!ASPx.Browser.MobileUI)
   return hasExternalRippleClassName;
  return hasExternalRippleClassName || this.IsMobileExternalRipple(targetInfo);
 },
 IsMobileExternalRipple: function(targetInfo) {
  if(this.isMobileExternalRipple == null) {
   var originTouchRadius = this.getOriginTouchRadius();
   this.isMobileExternalRipple = ASPx.Browser.MobileUI && targetInfo.width < originTouchRadius && targetInfo.height < originTouchRadius;
  }
  return this.isMobileExternalRipple;
 },
 RemoveRippleContainer: function(element) {
  if(!element)
   return;
  var childs = ASPx.GetChildNodesByClassName(element, this.rippleContainerClassName);
  var rippleContainer = childs.length > 0 ? childs[0] : null;
  if(rippleContainer != null) {
   var containerParent = rippleContainer.parentNode;
   containerParent.removeChild(rippleContainer);
   if(this.isARowInFixedLayoutTable(containerParent))
    this.unlockFixedLayoutTableSizes(containerParent);
  }
 },
 getEventX: function(evt) {
  return ASPxClientUtils.GetEventX(evt);
 },
 getEventY: function(evt) {
  return ASPxClientUtils.GetEventY(evt);
 },
 getOriginTouchRadius: function() {
  return this.touchRadius / this.zoom;
 },
 getElementRect: function(element) {
  return { x: ASPx.GetAbsoluteX(element), y: ASPx.GetAbsoluteY(element), width: element.offsetWidth, height: element.offsetHeight };
 }
};
var AccessibilitySR = {
 AddStringResources: function(stringResourcesObj) {
  if(stringResourcesObj) {
   for(var key in stringResourcesObj)
    if(stringResourcesObj.hasOwnProperty(key))
     this[key] = stringResourcesObj[key];
  }
 }
};
ASPx.CollectionBase = CollectionBase;
ASPx.FunctionIsInCallstack = _aspxFunctionIsInCallstack;
ASPx.RaisePostHandlerOnPost = aspxRaisePostHandlerOnPost;
ASPx.GetPostHandler = aspxGetPostHandler;
ASPx.ProcessScriptsAndLinks = _aspxProcessScriptsAndLinks;
ASPx.InitializeLinks = _aspxInitializeLinks;
ASPx.InitializeScripts = _aspxInitializeScripts;
ASPx.RunStartupScripts = _aspxRunStartupScripts;
ASPx.IsStartupScriptsRunning = _aspxIsStartupScriptsRunning;
ASPx.AddScriptsRestartHandler = _aspxAddScriptsRestartHandler;
ASPx.GetFocusedElement = _aspxGetFocusedElement;
ASPx.GetDomObserver = _aspxGetDomObserver;
ASPx.CacheHelper = CacheHelper;
ASPx.ControlTree = ControlTree;
ASPx.ControlAdjuster = ControlAdjuster;
ASPx.GetControlAdjuster = GetControlAdjuster;
ASPx.ControlCallbackHandlersQueue = ControlCallbackHandlersQueue;
ASPx.ResourceManager = ResourceManager;
ASPx.UpdateWatcherHelper = UpdateWatcherHelper;
ASPx.EventStorage = EventStorage;
ASPx.GetGlobalObject = GetGlobalObject;
ASPx.GetExternalScriptProcessor = GetExternalScriptProcessor;
ASPx.CheckBoxCheckState = CheckBoxCheckState;
ASPx.CheckBoxInputKey = CheckBoxInputKey;
ASPx.CheckableElementStateController = CheckableElementStateController;
ASPx.CheckableElementHelper = CheckableElementHelper;
ASPx.CheckBoxInternal = CheckBoxInternal;
ASPx.CheckBoxInternalCollection = CheckBoxInternalCollection;
ASPx.ControlCallbackQueueHelper = ControlCallbackQueueHelper;
ASPx.FocusedStyleDecoration = FocusedStyleDecoration;
ASPx.EditorStyleDecoration = EditorStyleDecoration;
ASPx.TextEditorStyleDecoration = TextEditorStyleDecoration;
ASPx.AccessibilitySR = AccessibilitySR;
ASPx.KbdHelper = KbdHelper;
ASPx.AccessKeysHelper = AccessKeysHelper;
ASPx.AccessKey = AccessKey;
ASPx.IFrameHelper = IFrameHelper;
ASPx.Ident = Ident;
ASPx.TouchUIHelper = TouchUIHelper;
ASPx.ControlUpdateWatcher = ControlUpdateWatcher;
ASPx.ControlTabIndexManager = ControlTabIndexManager;
ASPx.AccessibilityHelperBase = AccessibilityHelperBase;
ASPx.RippleHelper = RippleHelper;
ASPx.ThemesWithRipple = ThemesWithRipple;
window.ASPxClientEvent = ASPxClientEvent;
window.ASPxClientEventArgs = ASPxClientEventArgs;
window.ASPxClientCancelEventArgs = ASPxClientCancelEventArgs;
window.ASPxClientProcessingModeEventArgs = ASPxClientProcessingModeEventArgs;
window.ASPxClientProcessingModeCancelEventArgs = ASPxClientProcessingModeCancelEventArgs;
ASPx.Evt.AttachEventToDocument(TouchUIHelper.touchMouseDownEventName, RippleHelper.onDocumentMouseDown);
ASPx.classesScriptParsed = true;
})(ASPx, { GCCheckInterval: 5000 });

(function module(ASPx) {
ASPx.modules.Controls = module;
var ASPxClientBeginCallbackEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(command){
  this.constructor.prototype.constructor.call(this);
  this.command = command;
 }
});
var ASPxClientGlobalBeginCallbackEventArgs = ASPx.CreateClass(ASPxClientBeginCallbackEventArgs, {
 constructor: function(control, command){
  this.constructor.prototype.constructor.call(this, command);
  this.control = control;
 }
});
var ASPxClientEndCallbackEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(command){
  this.constructor.prototype.constructor.call(this);
  this.command = command;
 }
});
var ASPxClientGlobalEndCallbackEventArgs = ASPx.CreateClass(ASPxClientEndCallbackEventArgs, {
 constructor: function(control){
  this.constructor.prototype.constructor.call(this);
  this.control = control;
 }
});
var ASPxClientCustomDataCallbackEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(result) {
  this.constructor.prototype.constructor.call(this);
  this.result = result;
 }
});
var ASPxClientCallbackErrorEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function (message, callbackId) {
  this.constructor.prototype.constructor.call(this);
  this.message = message;
  this.handled = false;
  this.callbackId = callbackId;
 }
});
var ASPxClientGlobalCallbackErrorEventArgs = ASPx.CreateClass(ASPxClientCallbackErrorEventArgs, {
 constructor: function (control, message, callbackId) {
  this.constructor.prototype.constructor.call(this, message, callbackId);
  this.control = control;
 }
});
var ASPxClientValidationCompletedEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function (container, validationGroup, invisibleControlsValidated, isValid, firstInvalidControl, firstVisibleInvalidControl) {
  this.constructor.prototype.constructor.call(this);
  this.container = container;
  this.validationGroup = validationGroup;
  this.invisibleControlsValidated = invisibleControlsValidated;
  this.isValid = isValid;
  this.firstInvalidControl = firstInvalidControl;
  this.firstVisibleInvalidControl = firstVisibleInvalidControl;
 }
});
var ASPxClientControlsInitializedEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(isCallback) {
  this.isCallback = isCallback;
 }
});
var ASPxClientControlBeforePronounceEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(messageParts, control){
  this.constructor.prototype.constructor.call(this);
  this.messageParts = messageParts;
  this.control = control;
 }
});
var ASPxClientControlUnloadEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(control){
  this.constructor.prototype.constructor.call(this);
  this.control = control;
 }
});
var ASPxClientEndFocusEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(item) {
  this.constructor.prototype.constructor.call(this);
  this.item = item;
 }
});
var ASPxClientItemFocusedEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(item) {
  this.constructor.prototype.constructor.call(this);
  this.item = item;
 }
});
var BeforeInitCallbackEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(callbackOwnerID){
  this.constructor.prototype.constructor.call(this);
  this.callbackOwnerID = callbackOwnerID;
 }
});
var ASPxClientBrowserWindowResizedInternalEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(eventInfo) {
  this.constructor.prototype.constructor.call(this);
  this.htmlEvent = eventInfo.htmlEvent;
  this.windowClientWidth = eventInfo.wndWidth;
  this.windowClientHeigth = eventInfo.wndHeight;
  this.previousWindowClientWidth = eventInfo.prevWndWidth;
  this.previousWindowClientHeight = eventInfo.prevWndHeight;
  this.virtualKeyboardShownOnAndroid = eventInfo.virtualKeyboardShownOnAndroid;
 }
});
ASPx.createControl = function(type, name, windowName, properties, events, setupMethod, data){
 var globalName = windowName && windowName.length > 0 ? windowName : name;
 var dxo = new type(name);
 var haveWrapper = ASPx.Platform === "NETCORE" && dxo.createWrapper && !DevExpress.AspNetCore.Internal.BackwardCompatibility.useLegacyClientAPI;
 if(haveWrapper) {
  window[globalName] = dxo.createWrapper();
  dxo.aspNetCoreWrapperInstance = window[globalName];
 }
 else
  dxo.InitGlobalVariable(globalName);
 if(properties)
  dxo.SetProperties(properties);
 if(events)
  dxo.SetEvents(events);
 if(setupMethod)
  setupMethod.call(dxo);
 if(data)
  dxo.SetData(data);
 dxo.AfterCreate();
};
var ASPxClientControlBase = ASPx.CreateClass(null, {
 constructor: function(name){
  this.name = name;
  this.uniqueID = name;   
  this.globalName = name;
  this.stateObject = null;
  this.needEncodeState = true;
  this.encodeHtml = true;
  this.enabled = true;
  this.clientEnabled = true;
  this.savedClientEnabled = true;
  this.clientVisible = true;
  this.accessibilityCompliant = false;
  this.parseJSPropertiesOnCallbackError = false;
  this.autoPostBack = false;
  this.allowMultipleCallbacks = true;
  this.callBack = null;
  this.enableCallbackAnimation = false;
  this.enableSlideCallbackAnimation = false;
  this.slideAnimationDirection = null;
  this.beginCallbackAnimationProcessing = false;
  this.endCallbackAnimationProcessing = false;
  this.savedCallbackResult = null;
  this.savedCallbacks = null;
  this.isCallbackAnimationPrevented = false;
  this.lpDelay = 300;
  this.lpTimer = -1;
  this.requestCount = 0;
  this.enableSwipeGestures = false;
  this.disableSwipeGestures = false;
  this.supportGestures = false;
  this.repeatedGestureValue = 0;
  this.repeatedGestureCount = 0;
  this.isInitialized = false;
  this.initialFocused = false;
  this.leadingAfterInitCall = ASPxClientControl.LeadingAfterInitCallConsts.None; 
  this.serverEvents = [];
  this.loadingPanelElement = null;
  this.loadingDivElement = null;  
  this.hasPhantomLoadingElements = false;
  this.mainElement = null;
  this.touchUIMouseScroller = null;
  this.hiddenFields = {};
  this.scPrefix = "dx";
  this.callbackHandlersQueue = new ASPx.ControlCallbackHandlersQueue(this);
  this.callbackCommand = {};
  this.currentCallbackID = -1;
  this.InitializeIntersectionObserversManager();
  this.Init = new ASPxClientEvent();
  this.BeginCallback = new ASPxClientEvent();
  this.EndCallback = new ASPxClientEvent();
  this.EndCallbackAnimationStart = new ASPxClientEvent();
  this.CallbackError = new ASPxClientEvent();
  this.CustomDataCallback = new ASPxClientEvent();
  this.BeforePronounce = new ASPxClientEvent();
  this.Unload = new ASPxClientEvent();
  this.Disposed = new ASPxClientEvent(); 
  aspxGetControlCollection().Add(this);
 },
 Initialize: function() {
  if(this.callBack != null)
   this.InitializeCallBackData();
  if (this.useCallbackQueue())
   this.callbackQueueHelper = new ASPx.ControlCallbackQueueHelper(this);
  ASPx.AccessibilityUtils.createAccessibleBackgrounds(this);
  if(this.accessibilityCompliant)
   ASPx.AccessibilityPronouncer.EnsureInitialize();
 },
 FinalizeInitialization: function() { },
 InlineInitialize: function() {
  this.savedClientEnabled = this.clientEnabled;
 },
 InitializeGestures: function() {
  if(this.isSwipeGesturesEnabled() && this.supportGestures) {
   ASPx.GesturesHelper.AddSwipeGestureHandler(this.name, 
    function() { return this.GetCallbackAnimationElement(); }.aspxBind(this), 
    function(evt) { return this.CanHandleGestureCore(evt); }.aspxBind(this), 
    function(value) { return this.AllowStartGesture(value); }.aspxBind(this),
    function(value) { return this.StartGesture(); }.aspxBind(this),
    function(value) { return this.AllowExecuteGesture(value); }.aspxBind(this),
    function(value) { this.ExecuteGesture(value); }.aspxBind(this),
    function(value) { this.CancelGesture(value); }.aspxBind(this),
    this.GetDefaultanimationEngineType(),
    this.rtl
   );
   if(ASPx.Browser.MSTouchUI)
    this.touchUIMouseScroller = ASPx.MouseScroller.Create(
     function() { return this.GetCallbackAnimationElement(); }.aspxBind(this),
     function() { return null; },
     function() { return this.GetCallbackAnimationElement(); }.aspxBind(this),
     function(element) { return this.NeedPreventTouchUIMouseScrolling(element); }.aspxBind(this),
     true
    );
  }
 },
 isSwipeGesturesEnabled: function() {
  return !this.disableSwipeGestures && (this.enableSwipeGestures || ASPx.Browser.TouchUI);
 },
 isSlideCallbackAnimationEnabled: function() {
  return this.enableSlideCallbackAnimation || this.isSwipeGesturesEnabled(); 
 },
 InitGlobalVariable: function(varName){
  if(!window) return;
  this.globalName = varName;
  window[varName] = this;
 },
 SetElementDisplay: function(element, value, checkCurrentStyle, makeInline) {
  ASPx.SetElementDisplay(element, value, checkCurrentStyle, makeInline);
 },
 SetProperties: function(properties, obj){
  if(!obj) obj = this;
  var isAspNetCoreWrapperInstanceExist = !!obj.aspNetCoreWrapperInstance;
  for(var name in properties){
   if(!properties.hasOwnProperty(name)) continue;
   obj[name] = properties[name];
   if(isAspNetCoreWrapperInstanceExist && name.indexOf("cp") === 0)
    obj.aspNetCoreWrapperInstance[name] = properties[name]; 
  }
 },
 SetEvents: function(events, obj){
  if(!obj) obj = this;
  for(var name in events){
   if(events.hasOwnProperty(name) && obj[name] && obj[name].AddHandler)
    obj[name].AddHandler(events[name]);
  }
 },
 SetData: function(data){
 },
 useCallbackQueue: function(){
  return false;
 },
 NeedPreventTouchUIMouseScrolling: function(element) {
  return false;
 },
 InitailizeFocus: function() {
  if(this.initialFocused && this.IsVisible())
   this.Focus();
 },
 AfterCreate: function() {
  this.AddDefaultStateControllerItems();
  this.InlineInitialize();
  this.InitializeGestures();
 },
 AfterInitialize: function() {
  this.initializeAriaDescriptor();
  this.InitailizeFocus();
  this.isInitialized = true;
  this.RaiseInit();
  if(this.savedCallbacks) {
   for(var i = 0; i < this.savedCallbacks.length; i++) 
    this.CreateCallbackInternal(this.savedCallbacks[i].arg, this.savedCallbacks[i].command, 
     false, this.savedCallbacks[i].callbackInfo);
   this.savedCallbacks = null;
  }
 },
 InitializeCallBackData: function() {
 },
 AtlasPreInitialize: function() {
 },
 AtlasInitialize: function() {
 },
 IsDOMDisposed: function() { 
  return !ASPx.IsExistsElement(this.GetMainElement());
 },
 initializeAriaDescriptor: function() {
  if(this.ariaDescription) {
   var descriptionObject = ASPx.Json.Eval(this.ariaDescription);
   if(descriptionObject) {
    this.ariaDescriptor = new AriaDescriptor(this, descriptionObject);
    this.applyAccessibilityAttributes(this.ariaDescriptor); 
   }
  }
 },
 applyAccessibilityAttributes: function() { },
 setAriaDescription: function(selector, argsList) {
  if(this.ariaDescriptor)
   this.ariaDescriptor.setDescription(selector, argsList || [[]]);
 },
 allowRestoreFocusOnCallbacks: function(){
  return this.accessibilityCompliant;
 },
 HtmlEncode: function(text) {
  return this.encodeHtml ? ASPx.Str.EncodeHtml(text) : text;
 },
 IsServerEventAssigned: function(eventName){
  return ASPx.Data.ArrayIndexOf(this.serverEvents, eventName) >= 0;
 },
 OnPost: function(args){
  this.SerializeStateHiddenField();
 },
 SerializeStateHiddenField: function() {
  this.UpdateStateObject();
  if(this.stateObject != null)
   this.UpdateStateHiddenField();
 },
 OnPostFinalization: function(args){
 },
 UpdateStateObject: function(){
 },
 UpdateStateObjectWithObject: function(obj){
  if(!obj) return;
  if(!this.stateObject)
   this.stateObject = { };
  for(var key in obj)
   if(obj.hasOwnProperty(key))
    this.stateObject[key] = obj[key];
 },
 UpdateStateHiddenField: function() {
  var stateHiddenField = this.GetStateHiddenField();
  if(stateHiddenField) {
   var stateObjectStr = ASPx.Json.ToJson(this.stateObject, !this.needEncodeState);
   stateHiddenField.value = this.needEncodeState ? ASPx.Str.EncodeHtml(stateObjectStr) : stateObjectStr;
  }
 },
 GetStateHiddenField: function() {
  return this.GetHiddenField(this.GetStateHiddenFieldName(), this.GetStateHiddenFieldID(), 
   this.GetStateHiddenFieldParent(), this.GetStateHiddenFieldOrigin());
 },
 GetStateHiddenFieldName: function() {
  return this.uniqueID;
 },
 GetStateHiddenFieldID: function() {
  return this.name + "_State";
 },
 GetStateHiddenFieldOrigin: function() {
  return this.GetMainElement();
 },
 GetStateHiddenFieldParent: function() {
  var element = this.GetStateHiddenFieldOrigin();
  return element ? element.parentNode : null;
 },
 GetHiddenField: function(name, id, parent, beforeElement) {
  var hiddenField = this.hiddenFields[id];
  if(!hiddenField || !ASPx.IsValidElement(hiddenField)) {
   if(parent) {
    var existingHiddenField = ASPx.GetElementById(this.GetStateHiddenFieldID());
    this.hiddenFields[id] = hiddenField = existingHiddenField || ASPx.CreateHiddenField(name, id);
    if(existingHiddenField)
     return existingHiddenField;
    if(beforeElement)
     parent.insertBefore(hiddenField, beforeElement);
    else
     parent.appendChild(hiddenField);
   }
  }
  return hiddenField;
 },
 GetChildElement: function(idPostfix){
  var mainElement = this.GetMainElement();
  if(idPostfix.charAt && idPostfix.charAt(0) !== "_")
   idPostfix = "_" + idPostfix;
  return mainElement ? ASPx.CacheHelper.GetCachedChildById(this, mainElement, this.name + idPostfix) : null;
 },
 getChildControl: function(idPostfix) {
  var result = null;
  var childControlId = this.getChildControlUniqueID(idPostfix);
  ASPx.GetControlCollection().ProcessControlsInContainer(this.GetMainElement(), function(control) {
   if(control.uniqueID == childControlId)
    result = control;
  });
  return result;  
 },
 getChildControlUniqueID: function(idPostfix) {
  idPostfix = idPostfix.split("_").join("$");
  if(idPostfix.charAt && idPostfix.charAt(0) !== "$")
   idPostfix = "$" + idPostfix;
  return this.uniqueID + idPostfix;  
 },
 getInnerControl: function(idPostfix) {
  var name = this.name + idPostfix;
  var result = window[name];
  return result && Ident.IsASPxClientControl(result)
   ? result
   : null;
 },
 GetParentForm: function(){
  return ASPx.GetParentByTagName(this.GetMainElement(), "FORM");
 },
 GetMainElement: function(){
  if(!ASPx.IsExistsElement(this.mainElement))
   this.mainElement = ASPx.GetElementById(this.GetMainElementId());
  return this.mainElement;
 },
 GetMainElementId: function() {
  return this.name;
 },
 IsLoadingContainerVisible: function(){
  return this.IsVisible();
 },
 GetLoadingPanelElement: function(){
  return ASPx.GetElementById(this.name + "_LP");
 },
 GetClonedLoadingPanel: function(){
  return document.getElementById(this.GetLoadingPanelElement().id + "V"); 
 },
 CloneLoadingPanel: function(element, parent) {
  var clone = element.cloneNode(true);
  clone.id = element.id + "V";
  parent.appendChild(clone);
  return clone;
 },
 CreateLoadingPanelWithoutBordersInsideContainer: function(container) {
  var loadingPanel = this.CreateLoadingPanelInsideContainer(container, false, true, true);
  var contentStyle = ASPx.GetCurrentStyle(container);
  if(!loadingPanel || !contentStyle)
   return;
  var elements = [ ];
  var table = (loadingPanel.tagName == "TABLE") ? loadingPanel : ASPx.GetNodeByTagName(loadingPanel, "TABLE", 0);
  if(table != null)
   elements.push(table);
  else
   elements.push(loadingPanel);
  var cells = ASPx.GetNodesByTagName(loadingPanel, "TD");
  if(!cells) cells = [ ];
  for(var i = 0; i < cells.length; i++)
   elements.push(cells[i]);
  for(var i = 0; i < elements.length; i++) {
   var el = elements[i];
   el.style.backgroundColor = contentStyle.backgroundColor;
   ASPx.RemoveBordersAndShadows(el);
  }
 },
 CreateLoadingPanelInsideContainer: function(parentElement, hideContent, collapseHeight, collapseWidth) {
  if(this.ShouldHideExistingLoadingElements())
   this.HideLoadingPanel();
  if(parentElement == null)
   return null;
  if(!this.IsLoadingContainerVisible()) {
   this.hasPhantomLoadingElements = true;
   return null;
  }
  var element = this.GetLoadingPanelElement();
  if(element != null){
   var width = collapseWidth ? 0 : ASPx.GetClearClientWidth(parentElement);
   var height = collapseHeight ? 0 : ASPx.GetClearClientHeight(parentElement);
   if(hideContent){
    for(var i = parentElement.childNodes.length - 1; i > -1; i--){
     if(parentElement.childNodes[i].style)
      parentElement.childNodes[i].style.display = "none";
     else if(parentElement.childNodes[i].nodeType == 3) 
      parentElement.removeChild(parentElement.childNodes[i]);
    }
   }
   else
    parentElement.innerHTML = "";
   var table = document.createElement("TABLE");
   parentElement.appendChild(table);
   table.border = 0;
   table.cellPadding = 0;
   table.cellSpacing = 0;
   ASPx.SetStyles(table, {
    width: (width > 0) ? width : "100%",
    height: (height > 0) ? height : "100%"
   });
   var tbody = document.createElement("TBODY");
   table.appendChild(tbody);
   var tr = document.createElement("TR");
   tbody.appendChild(tr);
   var td = document.createElement("TD");
   tr.appendChild(td);
   td.align = "center";
   td.vAlign = "middle";
   element = this.CloneLoadingPanel(element, td);
   ASPx.SetElementDisplay(element, true);
   this.loadingPanelElement = element;
   return element;
  } else
   parentElement.innerHTML = "&nbsp;";
  return null;
 },
 CreateLoadingPanelWithAbsolutePosition: function(parentElement, offsetElement) {
  if(this.ShouldHideExistingLoadingElements())
   this.HideLoadingPanel();
  if(parentElement == null)
   return null;
  if(!this.IsLoadingContainerVisible()) {
   this.hasPhantomLoadingElements = true;
   return null;
  }
  if(!offsetElement)
   offsetElement = parentElement;
  var element = this.GetLoadingPanelElement();
  if(element != null) {
   element = this.CloneLoadingPanel(element, parentElement);
   ASPx.SetStyles(element, {
    position: "absolute"
   });
   ASPx.SetElementDisplay(element, true);
   ASPx.Evt.AttachEventToElement(element, ASPx.Evt.GetMouseWheelEventName(), ASPx.Evt.PreventEvent);
   this.SetLoadingPanelLocation(offsetElement, element);
   this.loadingPanelElement = element;
   return element;
  }
  return null;
 },
 CreateLoadingPanelInline: function(parentElement, centerInParent){
  if(this.ShouldHideExistingLoadingElements())
   this.HideLoadingPanel();
  if(parentElement == null)
   return null;
  if(!this.IsLoadingContainerVisible()) {
   this.hasPhantomLoadingElements = true;
   return null;
  }
  var element = this.GetLoadingPanelElement();
  if(element != null) {
   element = this.CloneLoadingPanel(element, parentElement);
   if(centerInParent){
    ASPx.SetElementDisplay(element, true);
    parentElement.style.textAlign = "center";
   }
   else
    ASPx.SetElementDisplay(element, true);
   this.loadingPanelElement = element;
   return element;
  }
  return null;
 },
 ShowLoadingPanel: function() {
 },
 ShowLoadingElements: function() {
  if(this.InCallback() || this.lpTimer > -1) return;
  this.ShowLoadingDiv();
  if(this.IsCallbackAnimationEnabled())
   this.StartBeginCallbackAnimation();
  else
   this.ShowLoadingElementsInternal();
 },
 ShowLoadingElementsInternal: function() {
  if(this.lpDelay > 0 && !this.IsCallbackAnimationEnabled()) 
   this.lpTimer = window.setTimeout(function() { 
    this.ShowLoadingPanelOnTimer(); 
   }.aspxBind(this), this.lpDelay);
  else {
   this.RestoreLoadingDivOpacity();
   this.ShowLoadingPanel();
  }
 },
 GetLoadingPanelOffsetElement: function (baseElement) {
  if(this.IsCallbackAnimationEnabled()) {
   var element = this.GetLoadingPanelCallbackAnimationOffsetElement();
   if(element) {
    var container = typeof(ASPx.AnimationHelper) != "undefined" ? ASPx.AnimationHelper.findSlideAnimationContainer(element) : null;
    if(container)
     return container.parentNode.parentNode;
    else
     return element;
   }
  }
  return baseElement;
 },
 GetLoadingPanelCallbackAnimationOffsetElement: function () {
  return this.GetCallbackAnimationElement();
 },
 IsCallbackAnimationEnabled: function () {
  return (this.enableCallbackAnimation || this.isSlideCallbackAnimationEnabled()) && !this.isCallbackAnimationPrevented;
 },
 GetDefaultanimationEngineType: function() {
  return ASPx.AnimationEngineType.DEFAULT;
 },
 StartBeginCallbackAnimation: function () {
  this.beginCallbackAnimationProcessing = true;
  this.isCallbackFinished = false;
  var element = this.GetCallbackAnimationElement();
  if (element && this.isSlideCallbackAnimationEnabled() && this.slideAnimationDirection)
   ASPx.AnimationHelper.slideOut(element, this.slideAnimationDirection, this.FinishBeginCallbackAnimation.aspxBind(this), this.GetDefaultanimationEngineType(), this.rtl);
  else if(element && this.enableCallbackAnimation) 
   ASPx.AnimationHelper.fadeOut(element, this.FinishBeginCallbackAnimation.aspxBind(this), null, ASPx.AnimationEngineType.JS);
  else
   this.FinishBeginCallbackAnimation();
 },
 CancelBeginCallbackAnimation: function() {
  if(this.beginCallbackAnimationProcessing) {
   this.beginCallbackAnimationProcessing = false;
   var element = this.GetCallbackAnimationElement();
   ASPx.AnimationHelper.cancelAnimation(element);
  }
 },
 FinishBeginCallbackAnimation: function () {
  this.beginCallbackAnimationProcessing = false;
  if(!this.isCallbackFinished)
   this.ShowLoadingElementsInternal();
  else {
   this.DoCallback(this.savedCallbackResult);
   this.savedCallbackResult = null;
  }
 },
 CheckBeginCallbackAnimationInProgress: function(callbackResult) {
  if(this.beginCallbackAnimationProcessing) {
   this.savedCallbackResult = callbackResult;
   this.isCallbackFinished = true;
   return true;
  }
  return false;
 },
 StartEndCallbackAnimation: function () {
  this.HideLoadingPanel();
  this.SetInitialLoadingDivOpacity();
  this.RaiseEndCallbackAnimationStart();
  this.endCallbackAnimationProcessing = true;
  var element = this.GetCallbackAnimationElement();
  if(element && this.isSlideCallbackAnimationEnabled() && this.slideAnimationDirection) 
   ASPx.AnimationHelper.slideIn(element, this.slideAnimationDirection, this.FinishEndCallbackAnimation.aspxBind(this), this.GetDefaultanimationEngineType(), this.rtl);
  else if(element && this.enableCallbackAnimation) 
   ASPx.AnimationHelper.fadeIn(element, this.FinishEndCallbackAnimation.aspxBind(this), null, ASPx.AnimationEngineType.JS);
  else
   this.FinishEndCallbackAnimation();
  this.slideAnimationDirection = null;
 },
 FinishEndCallbackAnimation: function () {
  this.DoEndCallback();
  this.endCallbackAnimationProcessing = false;
  this.CheckRepeatGesture();
 },
 CheckEndCallbackAnimationNeeded: function() {
  if(!this.endCallbackAnimationProcessing && this.requestCount == 1) {
   this.StartEndCallbackAnimation();
   return true;
  }
  return false;
 },
 PreventCallbackAnimation: function() {
  this.isCallbackAnimationPrevented = true;
 },
 GetCallbackAnimationElement: function() {
  return null;
 },
 AssignSlideAnimationDirectionByPagerArgument: function(arg, currentPageIndex) {
  this.slideAnimationDirection = null;
  if(this.isSlideCallbackAnimationEnabled() && typeof(ASPx.AnimationHelper) != "undefined") {
   if(arg == PagerCommands.Next || arg == PagerCommands.Last)
    this.slideAnimationDirection = ASPx.AnimationHelper.SLIDE_LEFT_DIRECTION;
   else if(arg == PagerCommands.First || arg == PagerCommands.Prev)
    this.slideAnimationDirection = ASPx.AnimationHelper.SLIDE_RIGHT_DIRECTION;
   else if(!isNaN(currentPageIndex) && arg.indexOf(PagerCommands.PageNumber) == 0) {
    var newPageIndex = parseInt(arg.substring(2));
    if (!isNaN(newPageIndex)) {
     var leftDir = this.rtl ? ASPx.AnimationHelper.SLIDE_LEFT_DIRECTION : ASPx.AnimationHelper.SLIDE_RIGHT_DIRECTION;
     var rightDir = this.rtl ? ASPx.AnimationHelper.SLIDE_RIGHT_DIRECTION : ASPx.AnimationHelper.SLIDE_LEFT_DIRECTION;
     this.slideAnimationDirection = newPageIndex < currentPageIndex ? leftDir : rightDir;
    }
   }
  }
 },
 TryShowPhantomLoadingElements: function () {
  if(this.hasPhantomLoadingElements && this.InCallback()) {
   this.hasPhantomLoadingElements = false;
   this.ShowLoadingDivAndPanel();
  }
 },
 ShowLoadingDivAndPanel: function () {
  this.ShowLoadingDiv();
  this.RestoreLoadingDivOpacity();
  this.ShowLoadingPanel();
 },
 HideLoadingElements: function() {
  this.CancelBeginCallbackAnimation();
  this.HideLoadingPanel();
  this.HideLoadingDiv();
 },
 ShowLoadingPanelOnTimer: function() {
  this.ClearLoadingPanelTimer();
  if(!this.IsDOMDisposed()) {
   this.RestoreLoadingDivOpacity();
   this.ShowLoadingPanel();
  }
 },
 ClearLoadingPanelTimer: function() {
  this.lpTimer = ASPx.Timer.ClearTimer(this.lpTimer);  
 },
 HideLoadingPanel: function() {
  this.ClearLoadingPanelTimer();
  this.hasPhantomLoadingElements = false;
  if(ASPx.IsExistsElement(this.loadingPanelElement)) {
   ASPx.RemoveElement(this.loadingPanelElement);
   this.loadingPanelElement = null;
  }
 },
 SetLoadingPanelLocation: function(offsetElement, loadingPanel, x, y, offsetX, offsetY) {
  if(!ASPx.IsExists(x) || !ASPx.IsExists(y)){
   var x1 = ASPx.GetAbsoluteX(offsetElement);
   var y1 = ASPx.GetAbsoluteY(offsetElement);
   var x2 = x1;
   var y2 = y1;
   if(offsetElement == document.body) {
    x1 = 0;
    y1 = 0;
    x2 = ASPx.GetDocumentMaxClientWidth();
    y2 = ASPx.GetDocumentMaxClientHeight();
   }
   else{
    x2 += offsetElement.offsetWidth;
    y2 += offsetElement.offsetHeight;
   }
   if(x1 < ASPx.GetDocumentScrollLeft())
    x1 = ASPx.GetDocumentScrollLeft();
   if(y1 < ASPx.GetDocumentScrollTop())
    y1 = ASPx.GetDocumentScrollTop();
   if(x2 > ASPx.GetDocumentScrollLeft() + ASPx.GetDocumentClientWidth())
    x2 = ASPx.GetDocumentScrollLeft() + ASPx.GetDocumentClientWidth();
   if(y2 > ASPx.GetDocumentScrollTop() + ASPx.GetDocumentClientHeight())
    y2 = ASPx.GetDocumentScrollTop() + ASPx.GetDocumentClientHeight();
   x = x1 + ((x2 - x1 - loadingPanel.offsetWidth) / 2);
   y = y1 + ((y2 - y1 - loadingPanel.offsetHeight) / 2);
  }
  if(ASPx.IsExists(offsetX) && ASPx.IsExists(offsetY)){
   x += offsetX;
   y += offsetY;
  }
  x = ASPx.PrepareClientPosForElement(x, loadingPanel, true);
  y = ASPx.PrepareClientPosForElement(y, loadingPanel, false);
  if(ASPx.Browser.IE && ASPx.Browser.Version > 8) {
   x = Math.round(x);
   y = Math.round(y);
  }
  ASPx.SetStyles(loadingPanel, { left: x, top: y });
 },
 GetLoadingDiv: function(){
  return ASPx.GetElementById(this.name + "_LD");
 },
 CreateLoadingDiv: function(parentElement, offsetElement){
  if(this.ShouldHideExistingLoadingElements())
   this.HideLoadingDiv();
  if(parentElement == null) 
   return null;
  if(!this.IsLoadingContainerVisible()) {
   this.hasPhantomLoadingElements = true;
   return null;
  }
  if(!offsetElement)
   offsetElement = parentElement;
  var div = this.GetLoadingDiv();
  if(div != null){
   div = div.cloneNode(true);
   parentElement.appendChild(div);
   ASPx.SetElementDisplay(div, true);
   ASPx.Evt.AttachEventToElement(div, ASPx.TouchUIHelper.touchMouseDownEventName, ASPx.Evt.PreventEvent);
   ASPx.Evt.AttachEventToElement(div, ASPx.TouchUIHelper.touchMouseMoveEventName, ASPx.Evt.PreventEvent);
   ASPx.Evt.AttachEventToElement(div, ASPx.TouchUIHelper.touchMouseUpEventName, ASPx.Evt.PreventEvent);
   ASPx.Evt.AttachEventToElement(div, ASPx.Evt.GetMouseWheelEventName(), ASPx.Evt.PreventEvent);
   this.SetLoadingDivBounds(offsetElement, div);
   this.loadingDivElement = div;
   this.SetInitialLoadingDivOpacity();
   return div;
  }
  return null;
 },
 SetInitialLoadingDivOpacity: function() {
  if(!this.loadingDivElement) return;
  ASPx.Attr.SaveStyleAttribute(this.loadingDivElement, "opacity");
  ASPx.Attr.SaveStyleAttribute(this.loadingDivElement, "filter");
  ASPx.SetElementOpacity(this.loadingDivElement, 0.01);
 },
 RestoreLoadingDivOpacity: function() {
  if(!this.loadingDivElement) return;
  ASPx.Attr.RestoreStyleAttribute(this.loadingDivElement, "opacity");
  ASPx.Attr.RestoreStyleAttribute(this.loadingDivElement, "filter");
 },
 SetLoadingDivBounds: function(offsetElement, loadingDiv) {
  var absX = (offsetElement == document.body) ? 0 : ASPx.GetAbsoluteX(offsetElement);
  var absY = (offsetElement == document.body) ? 0 : ASPx.GetAbsoluteY(offsetElement);
  ASPx.SetStyles(loadingDiv, {
   left: ASPx.PrepareClientPosForElement(absX, loadingDiv, true),
   top: ASPx.PrepareClientPosForElement(absY, loadingDiv, false)
  });
  var width = (offsetElement == document.body) ? ASPx.GetDocumentWidth() : offsetElement.offsetWidth;
  var height = (offsetElement == document.body) ? ASPx.GetDocumentHeight() : offsetElement.offsetHeight;
  if(height < 0) 
   height = 0;
  ASPx.SetStyles(loadingDiv, { width: width, height: height });
  var correctedWidth = 2 * width - loadingDiv.offsetWidth;
  if(correctedWidth <= 0) correctedWidth = width;
  var correctedHeight = 2 * height - loadingDiv.offsetHeight;
  if(correctedHeight <= 0) correctedHeight = height;
  ASPx.SetStyles(loadingDiv, { width: correctedWidth, height: correctedHeight });
 },
 ShowLoadingDiv: function() {
 },
 HideLoadingDiv: function() {
  this.hasPhantomLoadingElements = false;
  if(ASPx.IsExistsElement(this.loadingDivElement)){
   ASPx.RemoveElement(this.loadingDivElement);
   this.loadingDivElement = null;
  }
 },
 CanHandleGesture: function(evt) {
  return false;
 },
 CanHandleGestureCore: function(evt) {
  var source = ASPx.Evt.GetEventSource(evt);
  if(ASPx.GetIsParent(this.loadingPanelElement, source) || ASPx.GetIsParent(this.loadingDivElement, source))
   return true; 
  var callbackAnimationElement = this.GetCallbackAnimationElement();
  if(!callbackAnimationElement)
   return false;
  var animationContainer = ASPx.AnimationHelper.getSlideAnimationContainer(callbackAnimationElement, false, false);
  if(animationContainer && ASPx.GetIsParent(animationContainer, source) && !ASPx.GetIsParent(animationContainer.childNodes[0], source))
   return true; 
  return this.CanHandleGesture(evt); 
 },
 AllowStartGesture: function() {
  return !this.beginCallbackAnimationProcessing && !this.endCallbackAnimationProcessing;
 },
 StartGesture: function() {
 },
 AllowExecuteGesture: function(value) {
  return false;
 },
 ExecuteGesture: function(value) {
 },
 CancelGesture: function(value) {
  if(this.repeatedGestureCount === 0) {
   this.repeatedGestureValue = value;
   this.repeatedGestureCount = 1;
  }
  else {
   if(this.repeatedGestureValue * value > 0)
    this.repeatedGestureCount++;
   else
    this.repeatedGestureCount--;
   if(this.repeatedGestureCount === 0)
    this.repeatedGestureCount = 0;
  }
 },
 CheckRepeatGesture: function() {
  if(this.repeatedGestureCount !== 0) {
   if(this.AllowExecuteGesture(this.repeatedGestureValue))
    this.ExecuteGesture(this.repeatedGestureValue, this.repeatedGestureCount);
   this.repeatedGestureValue = 0;
   this.repeatedGestureCount = 0;
  }
 },
 AllowExecutePagerGesture: function (pageIndex, pageCount, value) {
  if(pageIndex < 0) return false;
  if(pageCount <= 1) return false;
  if(value > 0 && pageIndex === 0) return false;
  if(value < 0 && pageIndex === pageCount - 1) return false;
  return true;
 },
 ExecutePagerGesture: function(pageIndex, pageCount, value, count, method) {
  if(!count) count = 1;
  var pageIndex = pageIndex + (value < 0 ? count : -count);
  if(pageIndex < 0) pageIndex = 0;
  if(pageIndex > pageCount - 1) pageIndex = pageCount - 1;
  method(PagerCommands.PageNumber + pageIndex);
 },
 RaiseInit: function(){
  if(!this.Init.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.Init.FireEvent(this, args);
  }
 },
 RaiseBeginCallbackInternal: function(command){
  if(!this.BeginCallback.IsEmpty()){
   var args = new ASPxClientBeginCallbackEventArgs(command);
   this.BeginCallback.FireEvent(this, args);
  }
 },
 RaiseEndCallbackInternal: function(command) {
  if(!this.EndCallback.IsEmpty()){
   var args = new ASPxClientEndCallbackEventArgs(command);
   this.EndCallback.FireEvent(this, args);
  }
 },
 RaiseCallbackErrorInternal: function(message, callbackId) {
  if(!this.CallbackError.IsEmpty()) {
   var args = new ASPxClientCallbackErrorEventArgs(message, callbackId);
   this.CallbackError.FireEvent(this, args);
   if(args.handled)
    return { isHandled: true, errorMessage: args.message };
  }
 },
 RaiseBeginCallback: function(command){
  this.RaiseBeginCallbackInternal(command);    
  aspxGetControlCollection().RaiseBeginCallback(this, command);
 },
 RaiseEndCallback: function(command){
  this.RaiseEndCallbackInternal(command);
  aspxGetControlCollection().RaiseEndCallback(this, command);
 },
 RaiseCallbackError: function (message, callbackId) {
  var result = this.RaiseCallbackErrorInternal(message, callbackId);
  if(!result) 
   result = aspxGetControlCollection().RaiseCallbackError(this, message, callbackId);
  return result;
 },
 RaiseEndCallbackAnimationStart: function(){
  if(!this.EndCallbackAnimationStart.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.EndCallbackAnimationStart.FireEvent(this, args);
  }
 },
 RaiseBeforePronounce: function(message) {
  var args = new ASPxClientControlBeforePronounceEventArgs(message, this);
  if(!this.BeforePronounce.IsEmpty())
   this.BeforePronounce.FireEvent(this, args);
  return args;
 },
 RaiseUnload: function() {
  var args = new ASPxClientControlUnloadEventArgs(this);
  if(!this.Unload.IsEmpty())
   this.Unload.FireEvent(this, args);
 },
 RaiseDisposed: function() {
  this.Disposed.FireEvent(this, new ASPxClientEventArgs(this));
 },
 SendMessageToAssistiveTechnology: function(message) {
  if(!this.accessibilityCompliant)
   return;
  this.PronounceMessageInternal(message, ASPx.AccessibilityPronouncerType.live);
 },
 PronounceMessageInternal: function(messageArg, type) {
  var message = messageArg;
  if(!ASPx.Ident.IsArray(messageArg))
   message = [messageArg];
  var args = this.RaiseBeforePronounce(message);
  ASPx.AccessibilityPronouncer.Pronounce(args, type);
 },
 IsVisible: function() {
  var element = this.GetMainElement();
  return ASPx.IsElementVisible(element);
 },
 IsDisplayedElement: function(element) {
  while(element && element.tagName != "BODY") {
   if(!ASPx.GetElementDisplay(element)) 
    return false;
   element = element.parentNode;
  }
  return true;
 },
 IsDisplayed: function() {
  return this.IsDisplayedElement(this.GetMainElement());
 },
 IsHiddenElement: function(element) {
  return element && element.offsetWidth == 0 && element.offsetHeight == 0;
 },
 IsHidden: function() {
  return this.IsHiddenElement(this.GetMainElement());
 },
 IsDisposed: function() {
  return this.disposed;
 },
 GetParentControl: function() {
  var mainElement = this.getActualMainElement();
  var popupPostfix = ASPx.PCWIdSuffix + "-1";
  var result = null;
  ASPx.GetParent(mainElement, function(element) {
   if(element === mainElement || !element.id)
    return false;
   var controlName = element.id.replace(popupPostfix, "");
   result = ASPx.GetControlCollection().Get(controlName);
   return !!result;
  });
  return result;
 },
 getActualMainElement: function() { return this.GetMainElement(); },
 findParentByType: function (type) {
  var ctrl = this;
  while (ctrl) {
   var parent = ctrl.GetParentControl();
   if (parent && parent instanceof type)
    return parent;
   ctrl = parent;
  }
  return null;
 },
 Focus: function() {
 },
 GetClientVisible: function(){
  return this.GetVisible();
 },
 SetClientVisible: function(visible){
  this.SetVisible(visible);
 },
 GetVisible: function(){
  return this.clientVisible;
 },
 SetVisible: function(visible){
  if(this.clientVisible != visible){
   this.clientVisible = visible;
   ASPx.SetElementDisplay(this.GetMainElement(), visible);
   if(visible) {
    this.AdjustControl();
    var mainElement = this.GetMainElement();
    if(mainElement)
     aspxGetControlCollection().AdjustControls(mainElement);
   }
  }
 },
 GetEnabled: function() {
  return this.clientEnabled;
 },
 SetEnabled: function(enabled) {
  this.clientEnabled = enabled;
  if(ASPxClientControl.setEnabledLocked)
   return;
  else
   ASPxClientControl.setEnabledLocked = true;
  this.savedClientEnabled = enabled;
  aspxGetControlCollection().ProcessControlsInContainer(this.GetMainElement(), function(control) {
   if(ASPx.IsFunction(control.SetEnabled))
    control.SetEnabled(enabled && control.savedClientEnabled);
  });
  delete ASPxClientControl.setEnabledLocked;
 },
 InCallback: function() {
  return this.requestCount > 0;
 },
 DoBeginCallback: function(command) {
  this.RaiseBeginCallback(command || "");
  aspxGetControlCollection().Before_WebForm_InitCallback(this.name);
  if(typeof(WebForm_InitCallback) != "undefined" && WebForm_InitCallback) {
   __theFormPostData = "";
   __theFormPostCollection = [ ];
   this.ClearPostBackEventInput("__EVENTTARGET");
   this.ClearPostBackEventInput("__EVENTARGUMENT");
   WebForm_InitCallback();
   this.savedFormPostData = __theFormPostData;   
   this.savedFormPostCollection = __theFormPostCollection;
  }
 },
 ClearPostBackEventInput: function(id){
  var element = ASPx.GetElementById(id);
  if(element != null) element.value = "";
 },
 PerformDataCallback: function(arg, handler) {
  this.CreateCustomDataCallback(arg, "", handler);
 },
 sendCallbackViaQueue: function (prefix, arg, showLoadingPanel, context, handler, onBeforeSend) {
  if (!this.useCallbackQueue())
   return false;
  var context = context || this;
  var token = this.callbackQueueHelper.sendCallback(ASPx.FormatCallbackArg(prefix, arg), context, handler || context.OnCallback, prefix, onBeforeSend);
  if (showLoadingPanel)
   this.callbackQueueHelper.showLoadingElements();
  return token;
 },
 CreateCallback: function (arg, command, handler) {
  var callbackInfo = this.CreateCallbackInfo(ASPx.CallbackType.Common, handler || null);
  var callbackID = this.CreateCallbackByInfo(arg, command, callbackInfo);
  return callbackID;
 },
 CreateCustomDataCallback: function(arg, command, handler) {
  var callbackInfo = this.CreateCallbackInfo(ASPx.CallbackType.Data, handler);
  this.CreateCallbackByInfo(arg, command, callbackInfo);
 },
 CreateCallbackByInfo: function(arg, command, callbackInfo) {
  if(!this.CanCreateCallback()) return;
  var callbackID;
  if(typeof(WebForm_DoCallback) != "undefined" && WebForm_DoCallback && ASPx.documentLoaded || ASPx.Platform === "NETCORE")
   callbackID = this.CreateCallbackInternal(arg, command, true, callbackInfo);
  else {
   if(!this.savedCallbacks)
    this.savedCallbacks = [];
   var callbackInfo = { arg: arg, command: command, callbackInfo: callbackInfo };
   if(this.allowMultipleCallbacks)
    this.savedCallbacks.push(callbackInfo);
   else
    this.savedCallbacks[0] = callbackInfo;
  }
  return callbackID;
 },
 CreateCallbackInternal: function(arg, command, viaTimer, callbackInfo) {
  var watcher = ASPx.ControlUpdateWatcher.getInstance();
  if(watcher && !watcher.CanSendCallback(this, arg)) {
   this.CancelCallbackInternal();
   return;
  }
  this.requestCount++;
  this.DoBeginCallback(command);
  if(typeof(arg) == "undefined")
   arg = "";
  if(typeof(command) == "undefined")
   command = "";
  var callbackID = this.SaveCallbackInfo(callbackInfo, command),
   customArgs = this.GetCustomCallbackArgs();
  if(viaTimer)
   window.setTimeout(function() { this.CreateCallbackCoreWithCustomArgs(arg, command, callbackID, customArgs); }.aspxBind(this), 0);
  else
   this.CreateCallbackCoreWithCustomArgs(arg, command, callbackID, customArgs);
  return callbackID;
 },
 CreateCallbackCoreWithCustomArgs: function(arg, command, callbackID, customArgs) {
  this.CreateCallbackCore(arg, command, callbackID);
 },
 GetCustomCallbackArgs: function() {
  return {};
 },
 CancelCallbackInternal: function() {
  this.CancelCallbackCore();
  this.HideLoadingElements();
 },
 CancelCallbackCore: function() {
 },
 CreateCallbackCore: function(arg, command, callbackID) {
  var callBackMethod = this.GetCallbackMethod(command);
  __theFormPostData = this.savedFormPostData;
  __theFormPostCollection = this.savedFormPostCollection;
  callBackMethod.call(this, this.GetSerializedCallbackInfoByID(callbackID) + arg);
 },
 GetCallbackMethod: function(command){
  return this.callBack;
 },
 CanCreateCallback: function() {
  return !this.InCallback() || (this.allowMultipleCallbacks && !this.beginCallbackAnimationProcessing && !this.endCallbackAnimationProcessing);
 },
 DoLoadCallbackScripts: function() {
  ASPx.ProcessScriptsAndLinks(this.name, true);
 },
 DoEndCallback: function() {
  if(this.IsCallbackAnimationEnabled() && this.CheckEndCallbackAnimationNeeded()) 
   return;
  this.requestCount--;
  if (this.requestCount < 1) 
   this.callbackHandlersQueue.executeCallbacksHandlers();
  if(this.HideLoadingPanelOnCallback() && this.requestCount < 1) 
   this.HideLoadingElements();
  if(this.isSwipeGesturesEnabled() && this.supportGestures) {
   ASPx.GesturesHelper.UpdateSwipeAnimationContainer(this.name);
   if(this.touchUIMouseScroller)
    this.touchUIMouseScroller.update();
  }
  this.isCallbackAnimationPrevented = false;
  this.OnCallbackFinalized();
  this.AssignEllipsisTooltips();
  var command = this.GetCallbackCommand();
  this.RaiseEndCallback(command);
  this.InitializeIntersectionObserversManager();
  this.currentCallbackID = -1;
 },
 DoFinalizeCallback: function() {
 },
 OnCallbackFinalized: function() {
 },
 AssignEllipsisTooltips: function() { },
 GetCallbackCommand: function() {
  var result = "";
  if(this.currentCallbackID != -1) {
   var command = this.callbackCommand[this.currentCallbackID];
   if(command)
    result = command;
  }
  return result;
 },
 HideLoadingPanelOnCallback: function() {
  return true;
 },
 ShouldHideExistingLoadingElements: function() {
  return true;
 },
 EvalCallbackResult: function(resultString){
  return eval(resultString);
 },
 ParseJSProperties: function(resultObj) {
  if(resultObj.cp) {
   for(var name in resultObj.cp)
    if(resultObj.cp.hasOwnProperty(name)) {
     this[name] = resultObj.cp[name];
     if(this.aspNetCoreWrapperInstance)
      this.aspNetCoreWrapperInstance[name] = resultObj.cp[name]; 
    }
  }
 },
 DoCallback: function(result) {
  if(this.IsCallbackAnimationEnabled() && this.CheckBeginCallbackAnimationInProgress(result))
   return;
  result = ASPx.Str.Trim(result);
  if(result.indexOf(ASPx.CallbackResultPrefix) != 0) 
   this.ProcessCallbackGeneralError(result, false);
  else {
   var resultObj = null;
   try {
    resultObj = this.EvalCallbackResult(result);
   } 
   catch(e) {
   }
   if(resultObj) {
    this.currentCallbackID = resultObj.id;
    ASPx.CacheHelper.DropCache(this);
    if(resultObj.redirect) {
     this.ParseJSProperties(resultObj); 
     ASPx.Url.Redirect(resultObj.redirect);
    }
    else if(ASPx.IsExists(resultObj.generalError)) {
     this.ProcessCallbackGeneralError(resultObj.generalError, true);
    }
    else {
     var errorObj = resultObj.error;
     if(errorObj) { 
      if(this.parseJSPropertiesOnCallbackError)
       this.ParseJSProperties(resultObj);
      this.ProcessCallbackError(errorObj,resultObj.id);
     } else {
      this.ParseJSProperties(resultObj);
      var callbackInfo = this.DequeueCallbackInfo(resultObj.id);
      if(callbackInfo && callbackInfo.type == ASPx.CallbackType.Data)
       this.ProcessCustomDataCallback(resultObj.result, callbackInfo);
      else {
       if (this.useCallbackQueue() && this.callbackQueueHelper.getCallbackInfoById(resultObj.id))
        this.callbackQueueHelper.processCallback(resultObj.result, resultObj.id);
       else {
        this.ProcessCallback(resultObj.result, resultObj.id);
        if(callbackInfo && callbackInfo.handler) {
         var handlerInfo = { handler: callbackInfo.handler, result: resultObj.result.data };
         this.callbackHandlersQueue.addCallbackHandler(handlerInfo);
        }
       }
      }
     }
    }
   }
  }
  this.DoLoadCallbackScripts();
 },
 DoCallbackError: function(result) {
  this.HideLoadingElements();
  this.ProcessCallbackGeneralError(result, false); 
 },
 DoControlClick: function(evt) {
  this.OnControlClick(ASPx.Evt.GetEventSource(evt), evt);
 },
 ProcessCallback: function (result, callbackId) {
  this.OnCallback(result, callbackId);
 },
 ProcessCustomDataCallback: function(result, callbackInfo) {
  if(callbackInfo.handler != null)
   callbackInfo.handler(this, result);
  this.RaiseCustomDataCallback(result);
 },
 RaiseCustomDataCallback: function(result) {
  if(!this.CustomDataCallback.IsEmpty()) {
   var arg = new ASPxClientCustomDataCallbackEventArgs(result);
   this.CustomDataCallback.FireEvent(this, arg);
  }
 },
 OnCallback: function(result) {
 },
 CreateCallbackInfo: function(type, handler) {
  return { type: type, handler: handler };
 },
 GetSerializedCallbackInfoByID: function(callbackID) {
  return this.GetCallbackInfoByID(callbackID).type + callbackID + ASPx.CallbackSeparator;
 },
 SaveCallbackInfo: function(info, command) {
  var callbacks = this.GetActiveCallbacksInfo();
  var index = callbacks.indexOf(null);
  if(index === -1)
   index = callbacks.length;
  callbacks[index] = info;
  this.callbackCommand[index] = command;
  return index;
 },
 GetActiveCallbacksInfo: function() {
  var persistentProperties = this.GetPersistentProperties();
  if(!persistentProperties.activeCallbacks)
   persistentProperties.activeCallbacks = [ ];
  return persistentProperties.activeCallbacks;
 },
 GetPersistentProperties: function() {
  var storage = _aspxGetPersistentControlPropertiesStorage();
  var persistentProperties = storage[this.name];
  if(!persistentProperties) {
   persistentProperties = { };
   storage[this.name] = persistentProperties;
  }
  return persistentProperties;
 },
 GetCallbackInfoByID: function(callbackID) {
  return this.GetActiveCallbacksInfo()[callbackID];
 },
 DequeueCallbackInfo: function(index) {
  var activeCallbacksInfo = this.GetActiveCallbacksInfo();
  if(index < 0 || index >= activeCallbacksInfo.length)
   return null;
  var result = activeCallbacksInfo[index];
  activeCallbacksInfo[index] = null;
  return result;
 },
 ProcessCallbackError: function (errorObj, callbackId) {
  var data = ASPx.IsExists(errorObj.data) ? errorObj.data : null;
  var result = this.RaiseCallbackError(errorObj.message, callbackId);
  if(result.isHandled)
   this.OnCallbackErrorAfterUserHandle(result.errorMessage, data); 
  else
   this.OnCallbackError(result.errorMessage, data); 
 },
 OnCallbackError: function(errorMessage, data) {
  if(errorMessage)
   ASPx.ShowErrorAlert(errorMessage);
 },
 OnCallbackErrorAfterUserHandle: function(errorMessage, data) {
 },
 ProcessCallbackGeneralError: function(errorMessage, serverExceptionOnLastCallback) {
  this.serverExceptionOnLastCallback = serverExceptionOnLastCallback;
  var result = this.RaiseCallbackError(errorMessage);
  if(result.isHandled)
   this.OnCallbackGeneralErrorAfterUserHandle(result.errorMessage);
  else
   this.OnCallbackGeneralError(result.errorMessage);
 },
 OnCallbackGeneralError: function(errorMessage) {
  this.OnCallbackError(errorMessage, null);
 },
 OnCallbackGeneralErrorAfterUserHandle: function (errorMessage) {
 },
 SendPostBack: function(params, preventConvertToUpdatePanelCallback) {
  if(preventConvertToUpdatePanelCallback)
   this.sendMSAjaxCompatPostBack(params);
  else
   this.sendPostBackInternal(params);
 },
 sendPostBackInternal: function(params) {
  if(typeof(__doPostBack) != "undefined")
   __doPostBack(this.uniqueID, params);
  else{
   var form = this.GetParentForm();
   if(form) form.submit();
  }
 },
 sendMSAjaxCompatPostBack: function(params) {
  var rm = ASPx.GetMSAjaxRequestManager();
  var triggers = rm ? rm._postBackControlClientIDs : null;
  var needRegister = triggers && ASPx.Ident.IsArray(triggers) && ASPx.Data.ArrayIndexOf(triggers, this.name) == -1;
  if(needRegister)
   triggers.unshift(this.name);
  this.sendPostBackInternal(params);
  if(needRegister)
   triggers.shift();
 },
 IsValidInstance: function () {
  return aspxGetControlCollection().GetByName(this.name) === this;
 },
 OnDispose: function() { 
  this.RaiseDisposed();
  var varName = this.globalName;
  if(varName && varName !== "" && window && window[varName] && window[varName] == this){
   try{
    delete window[varName];
   }
   catch(e){  }
  }
  if(this.callbackQueueHelper)
   this.callbackQueueHelper.detachEvents();
  if (!this.IsDisposed())
   this.disposed = true;
 },
 OnGlobalControlsInitialized: function(args) { 
 },
 OnGlobalBrowserWindowResized: function(args) { 
 },
 OnGlobalBeginCallback: function(args) { 
 },
 OnGlobalEndCallback: function(args) { 
 },
 OnGlobalCallbackError: function(args) { 
 },
 OnGlobalValidationCompleted: function(args) { 
 },
 AddDefaultStateControllerItems: function() {
  var states = this.scStates;
  if(!states) return;
  var postfix = this.scPostfix ? ("_" + this.scPostfix) : "";
  var mainElementId = this.GetMainElementId();
  if(states & 2)
   this.AddDefaultReadOnlyStateControllerItem(this.scPrefix + "ReadOnly" + postfix, mainElementId);
  if(states & 4)
   this.AddDefaultDisabledStateControllerItem(this.scPrefix + "Disabled" + postfix, mainElementId);
 },
 AddDefaultReadOnlyStateControllerItem: function(cssClass, mainElementId) { throw "Not implemented"; },
 AddDefaultDisabledStateControllerItem: function(cssClass, mainElementId) { throw "Not implemented"; },
 DOMContentLoaded: function() { },
 IsStateControllerEnabled: function() { return false; },
 InitializeDOM: function() {
  var mainElement = this.GetMainElement();
  if(mainElement)
   ASPx.SetElementInitializedFlag(mainElement);
 },
 IsDOMInitialized: function() {
  var mainElement = this.GetMainElement();
  return mainElement && ASPx.GetElementInitializedFlag(mainElement);
 },
 AdjustControl: function(nestedCall) { },
 OnBrowserWindowResizeInternal: function(e) { },
 RegisterInControlTree: function(tree) { },
 InitializeIntersectionObserversManager: function () {
  var elementToObserve = this.getElementToObserveVisibilityChange();
  if(elementToObserve) {
   ASPx.IntersectionObserversManager.SubscribeElemensVisibilityChangeInBrowserWindow(elementToObserve, this.processVisibilityChanged.bind(this));
  }
 },
 getElementToObserveVisibilityChange: function () { },
 processVisibilityChanged: function (visible) { }
});
ASPxClientControlBase.Cast = function(obj) {
 if(typeof obj == "string")
  return window[obj];
 return obj;
};
var persistentControlPropertiesStorage = null;
function _aspxGetPersistentControlPropertiesStorage() {
 if(persistentControlPropertiesStorage == null)
  persistentControlPropertiesStorage = { };
 return persistentControlPropertiesStorage;
}
var ELLIPSIS_MARKER_CLASS = "dx-ellipsis";
var ELLIPSIS_TOOLTIP_MARKER_ATTR = "dxEllipsisTitle";
var ASPxClientControl = ASPx.CreateClass(ASPxClientControlBase, {
 constructor: function(name){
  this.constructor.prototype.constructor.call(this, name);
  this.rtl = false;
  this.enableEllipsis = false;
  this.isNative = false;
  this.isControlCollapsed = false;
  this.isInsideHierarchyAdjustment = false;
  this.controlOwner = null;
  this.adjustedSizes = { };
  this.dialogContentHashTable = { };
  this.renderIFrameForPopupElements = false;
  this.widthValueSetInPercentage = false;
  this.heightValueSetInPercentage = false;
  this.verticalAlignedElements = { };
  this.wrappedTextContainers = { };
  this.scrollPositionState = { };
  this.sizingConfig = {
   allowSetWidth: true,
   allowSetHeight: true,
   correction : false,
   adjustControl : false,
   supportPercentHeight: false,
   supportAutoHeight: false
  };
  this.percentSizeConfig = {
   width: -1,
   height: -1,
   markerWidth: -1,
   markerHeight: -1
  };  
 },
 querySelector: function(selector) { return this.querySelectorAll(selector)[0] || null; },
 querySelectorAll: function(selector) {
  return ASPx.CacheHelper.GetCachedElement(this, "querySelectorAll_" + selector,
   function() { return Array.prototype.slice.call(this.GetMainElement().querySelectorAll(selector)); });
 },
 createAccessKey: function (popupItem, getPopupElement, keyTipElement, key, onlyClick, manualStopProcessing) {
  return new ASPx.AccessKey(popupItem, getPopupElement, keyTipElement, key, onlyClick, manualStopProcessing);
 },
 InlineInitialize: function() {
  this.InitializeDOM();
  ASPxClientControlBase.prototype.InlineInitialize.call(this);
 },
 AfterCreate: function() { 
  ASPxClientControlBase.prototype.AfterCreate.call(this);
  if(!this.CanInitializeAdjustmentOnDOMContentLoaded() || ASPx.IsStartupScriptsRunning())
   this.InitializeAdjustment();
 },
 DOMContentLoaded: function() {
  if(this.CanInitializeAdjustmentOnDOMContentLoaded()) 
   this.InitializeAdjustment();
 },
 CanInitializeAdjustmentOnDOMContentLoaded: function() {
  return !ASPx.Browser.IE || ASPx.Browser.Version >= 10; 
 },
 InitializeAdjustment: function() {
  this.UpdateAdjustmentFlags();
  this.AdjustControl();
 },
 AfterInitialize: function() {
  this.AdjustControl();
  ASPxClientControlBase.prototype.AfterInitialize.call(this);
 },
 IsStateControllerEnabled: function(){
  return typeof(ASPx.GetStateController) != "undefined" && ASPx.GetStateController();
 },
 GetWidth: function() {
  return this.GetMainElement().offsetWidth;
 },
 GetHeight: function() {
  return this.GetMainElement().offsetHeight;
 },
 SetWidth: function(width) {
  if(this.sizingConfig.allowSetWidth)
   this.SetSizeCore("width", width, "GetWidth", false);
 },
 SetHeight: function(height) {
  if(this.sizingConfig.allowSetHeight)
   this.SetSizeCore("height", height, "GetHeight", false);
 },
 SetSizeCore: function(sizePropertyName, size, getFunctionName, corrected) {
  if(size < 0 || !this.GetMainElement())
   return;
  this.GetMainElement().style[sizePropertyName] = size + "px";
  this.UpdateAdjustmentFlags(sizePropertyName);
  if(this.sizingConfig.adjustControl)
   this.AdjustControl(true);
  if(this.sizingConfig.correction && !corrected) {
   var realSize = this[getFunctionName]();
   if(realSize != size) {
    var correctedSize = size - (realSize - size);
    this.SetSizeCore(sizePropertyName, correctedSize, getFunctionName, true);
   }
  }
 },
 AdjustControl: function(nestedCall) {
  if(this.IsAdjustmentRequired() && (!ASPxClientControl.adjustControlLocked || nestedCall)) {
   ASPxClientControl.adjustControlLocked = true;
   try {
    if(!this.IsAdjustmentAllowed())
     return;
    this.AdjustControlCore();
    this.UpdateAdjustedSizes();
   } 
   finally {
    delete ASPxClientControl.adjustControlLocked;
   }
  }
  this.AssignEllipsisTooltips();
  this.TryShowPhantomLoadingElements();
 },
 ResetControlAdjustment: function () {
  this.adjustedSizes = { };
 },
 UpdateAdjustmentFlags: function(sizeProperty) {
  var mainElement = this.GetMainElement();
  if(mainElement) {
   var mainElementStyle = ASPx.GetCurrentStyle(mainElement);
   this.UpdatePercentSizeConfig([mainElementStyle.width, mainElement.style.width], [mainElementStyle.height, mainElement.style.height], sizeProperty);
  }
 },
 UpdatePercentSizeConfig: function(widths, heights, modifyStyleProperty) {
  switch(modifyStyleProperty) {
   case "width":
    this.UpdatePercentWidthConfig(widths);
    break;
   case "height":
    this.UpdatePercentHeightConfig(heights);
    break;
   default:
    this.UpdatePercentWidthConfig(widths);
    this.UpdatePercentHeightConfig(heights);
    break;
  }
  this.ResetControlPercentMarkerSize();
 },
 UpdatePercentWidthConfig: function(widths) {
  this.widthValueSetInPercentage = false;
  for(var i = 0; i < widths.length; i++) {
   if(this.IsPercentageWidth(widths[i])) {
    this.percentSizeConfig.width = widths[i];
    this.widthValueSetInPercentage = true;
    break;
   }
  }
 },
 IsPercentageWidth: function(width) { return ASPx.IsPercentageSize(width); },
 UpdatePercentHeightConfig: function(heights) {
  this.heightValueSetInPercentage = false;
    for(var i = 0; i < heights.length; i++) {
   if(ASPx.IsPercentageSize(heights[i])) {
    this.percentSizeConfig.height = heights[i];
    this.heightValueSetInPercentage = true;
    break;
   }
  }
 },
 GetAdjustedSizes: function() {
  var mainElement = this.GetMainElement();
  if(mainElement) 
   return { width: mainElement.offsetWidth, height: mainElement.offsetHeight };
  return { width: 0, height: 0 };
 },
 IsAdjusted: function() {
  return (this.adjustedSizes.width && this.adjustedSizes.width > 0) && (this.adjustedSizes.height && this.adjustedSizes.height > 0);
 },
 IsAdjustmentRequired: function() {
  if(!this.IsAdjusted())
   return true;
  if(this.widthValueSetInPercentage)
   return true;
  if(this.heightValueSetInPercentage)
   return true;
  var sizes = this.GetAdjustedSizes();
  for(var name in sizes){
   if(this.adjustedSizes[name] !== sizes[name])
    return true;
  }
  return false;
 },
 IsAdjustmentAllowed: function() {
  var mainElement = this.GetMainElement();
  return mainElement && this.IsDisplayed() && !this.IsHidden() && this.IsDOMInitialized();
 },
 UpdateAdjustedSizes: function() {
  var sizes = this.GetAdjustedSizes();
  for(var name in sizes)
   if(sizes.hasOwnProperty(name))
    this.adjustedSizes[name] = sizes[name];
 },
 AdjustControlCore: function() {
 },
 AdjustAutoHeight: function() {
 },
 IsControlCollapsed: function() {
  return this.isControlCollapsed;
 },
 NeedCollapseControl: function() {
  return this.NeedCollapseControlCore() && this.IsAdjustmentRequired() && this.IsAdjustmentAllowed();
 },
 NeedCollapseControlCore: function() {
  return false;
 },
 CollapseEditor: function() {
 },
 CollapseControl: function() {
  this.SaveScrollPositions();
  var mainElement = this.GetMainElement(),
   marker = this.GetControlPercentSizeMarker();
  marker.style.height = this.heightValueSetInPercentage && this.sizingConfig.supportPercentHeight
   ? this.percentSizeConfig.height 
   : (mainElement.offsetHeight + "px");
  mainElement.style.display = "none";
  this.isControlCollapsed = true;
 },
 ExpandControl: function() {
  var mainElement = this.GetMainElement();
  mainElement.style.display = "";
  this.GetControlPercentSizeMarker().style.height = "0px";
  this.isControlCollapsed = false;
  this.RestoreScrollPositions();
 },
 CanCauseReadjustment: function() {
  return this.NeedCollapseControlCore();
 },
 IsExpandableByAdjustment: function() {
  return false;
 },
 HasFixedPosition: function() {
  return false;
 },
 SaveScrollPositions: function() {
  var mainElement = this.GetMainElement();
  this.scrollPositionState.outer = ASPx.GetOuterScrollPosition(mainElement.parentNode);
  this.scrollPositionState.inner = ASPx.GetInnerScrollPositions(mainElement);
 },
 RestoreScrollPositions: function() {
  ASPx.RestoreOuterScrollPosition(this.scrollPositionState.outer);
  ASPx.RestoreInnerScrollPositions(this.scrollPositionState.inner);
 },
 GetControlPercentSizeMarker: function() {
  if(this.percentSizeMarker === undefined) {
   this.percentSizeMarker = ASPx.CreateHtmlElementFromString("<div style='height:0px;font-size:0px;line-height:0;width:100%;'></div>");
   ASPx.InsertElementAfter(this.percentSizeMarker, this.GetMainElement());
  }
  return this.percentSizeMarker;
 },
 KeepControlPercentSizeMarker: function(needCollapse, needCalculateHeight) {
  var marker = this.GetControlPercentSizeMarker(),
   markerHeight;
  if(needCollapse)
   this.CollapseControl();
  if(this.widthValueSetInPercentage && marker.style.width !== this.percentSizeConfig.width)
   marker.style.width = this.percentSizeConfig.width;
  if(needCalculateHeight) {
   if(this.IsControlCollapsed())
    markerHeight = marker.style.height;
   marker.style.height = this.percentSizeConfig.height;
  }
  this.percentSizeConfig.markerWidth = marker.offsetWidth;
  if(needCalculateHeight) {
   this.percentSizeConfig.markerHeight = marker.offsetHeight;
   if(this.IsControlCollapsed())
    marker.style.height = markerHeight;
   else
    marker.style.height = "0px";
  }
  if(needCollapse)
   this.ExpandControl();
 },
 ResetControlPercentMarkerSize: function() {
  this.percentSizeConfig.markerWidth = -1;
  this.percentSizeConfig.markerHeight = -1;
 },
 GetControlPercentMarkerSize: function(hideControl, force) {
  var needCalculateHeight = this.heightValueSetInPercentage && this.sizingConfig.supportPercentHeight;
  if(force || this.percentSizeConfig.markerWidth < 1 || (needCalculateHeight && this.percentSizeConfig.markerHeight < 1))
   this.KeepControlPercentSizeMarker(hideControl && !this.IsControlCollapsed(), needCalculateHeight);
  return {
   width: this.percentSizeConfig.markerWidth,
   height: this.percentSizeConfig.markerHeight
  };
 },
 AssignEllipsisTooltips: function() {
  if(this.RequireAssignTooltips())
   this.AssignEllipsisTooltipsCore();
 },
 AssignEllipsisTooltipsCore: function(rootElement, reassingExistingTooltips) {
  var requirePaddingManipulation = ASPx.Browser.IE || ASPx.Browser.Edge || ASPx.Browser.Firefox;
  rootElement = rootElement || this.GetMainElement();
  var nodes = this.GetEllipsisNodes(rootElement);
  var nodeInfos = [];
  var nodesCount = nodes.length;
  for(var i = 0; i < nodesCount; i++) {
   var node = nodes[i];
   var info = { node: node };
   if(requirePaddingManipulation) {
    var style = ASPx.GetCurrentStyle(node);
    info.paddingLeft = node.style.paddingLeft;
    info.totalPadding = ASPx.GetLeftRightPaddings(node, style);
   }
   nodeInfos.push(info);
  }
  if(requirePaddingManipulation) {
   for(var i = 0; i < nodesCount; i++) {
    var info = nodeInfos[i];
    ASPx.SetStyles(info.node, { paddingLeft: info.totalPadding }, true);
   }
  }
  for(var i = 0; i < nodesCount; i++) {
   var info = nodeInfos[i];
   var node = info.node;
   info.isTextShortened = node.scrollWidth > node.clientWidth;
   info.hasTitle = ASPx.Attr.GetAttribute(node, "title") !== null;
   if(!info.hasTitle || reassingExistingTooltips)
    info.title = ASPx.GetEllipsisTooltipText(node);
  }
  for(var i = 0; i < nodesCount; i++) {
   var info = nodeInfos[i];
   var node = info.node;
   if(info.isTextShortened && info.title) {
    ASPx.Attr.SetAttribute(node, "title", info.title);
    ASPx.Attr.SetAttribute(node, ELLIPSIS_TOOLTIP_MARKER_ATTR, true);
   }
   if(!info.isTextShortened && info.hasTitle)
    ASPx.Attr.RemoveAttribute(node, "title");
  }
  if(requirePaddingManipulation) {
   for(var i = 0; i < nodesCount; i++) {
    var info = nodeInfos[i];
    var node = info.node;
    node.style.paddingLeft = info.paddingLeft;
   }
  }
 },
 GetEllipsisNodes: function(element) {
  var ellipsibleNodes = ASPx.Data.CollectionToArray(ASPx.GetNodesByClassName(element, ELLIPSIS_MARKER_CLASS));
  if(ASPx.ElementHasCssClass(element, ELLIPSIS_MARKER_CLASS))
   ellipsibleNodes.push(element);
  return ellipsibleNodes.filter(function(node) {
   return !ASPx.Attr.IsExistsAttribute(node, "title") || ASPx.Attr.IsExistsAttribute(node, ELLIPSIS_TOOLTIP_MARKER_ATTR);
  });
 },
 RequireAssignTooltips: function() {
  return this.enableEllipsis && !ASPx.Browser.MobileUI;
 },
 RemoveEllipsisFromNode: function(node) {
  ASPx.RemoveClassNameFromElement(node, ELLIPSIS_MARKER_CLASS);
  this.RemoveEllipsisTooltip(node);
 },
 RemoveEllipsisTooltip: function(node) {
  if(ASPx.Attr.IsExistsAttribute(node, ELLIPSIS_TOOLTIP_MARKER_ATTR)) {
   ASPx.Attr.RemoveAttribute(node, "title");
   ASPx.Attr.RemoveAttribute(node, ELLIPSIS_TOOLTIP_MARKER_ATTR);
  }
 },
 OnBrowserWindowResize: function(e) {
 },
 OnBrowserWindowResizeInternal: function(e){
  if(this.BrowserWindowResizeSubscriber()) 
   this.OnBrowserWindowResize(e);
 },
 BrowserWindowResizeSubscriber: function() {
  return this.widthValueSetInPercentage || !this.IsAdjusted();
 },
 ShrinkWrappedText: function(getElements, key, reCorrect) {
  if(!ASPx.Browser.Safari) return;
  var elements = ASPx.CacheHelper.GetCachedElements(this, key, getElements, this.wrappedTextContainers);
  for(var i = 0; i < elements.length; i++)
   this.ShrinkWrappedTextInContainer(elements[i], reCorrect);
 },
 ShrinkWrappedTextInContainer: function(container, reCorrect) {
  if(!ASPx.Browser.Safari || !container || (container.dxWrappedTextShrinked && !reCorrect) || container.offsetWidth === 0) return;
  ASPx.ShrinkWrappedTextInContainer(container);
  container.dxWrappedTextShrinked = true;
 },
 CorrectWrappedText: function(getElements, key, reCorrect) {
  var elements = ASPx.CacheHelper.GetCachedElements(this, key, getElements, this.wrappedTextContainers);
  for(var i = 0; i < elements.length; i++)
   this.CorrectWrappedTextInContainer(elements[i], reCorrect);
 },
 CorrectWrappedTextInContainer: function(container, reCorrect) {
  if(!container || (container.dxWrappedTextCorrected && !reCorrect) || container.offsetWidth === 0) return;
  ASPx.AdjustWrappedTextInContainer(container);
  container.dxWrappedTextCorrected = true;
 },
 CorrectVerticalAlignment: function(alignMethod, getElements, key, reAlign) {
  var elements = ASPx.CacheHelper.GetCachedElements(this, key, getElements, this.verticalAlignedElements);
  for(var i = 0; i < elements.length; i++)
   this.CorrectElementVerticalAlignment(alignMethod, elements[i], reAlign);
 },
 CorrectElementVerticalAlignment: function(alignMethod, element, reAlign) {
  if(!element || (element.dxVerticalAligned && !reAlign) || element.offsetHeight === 0) return;
  alignMethod(element);
  element.dxVerticalAligned = true;
 },
 ClearVerticalAlignedElementsCache: function() {
  ASPx.CacheHelper.DropCache(this.verticalAlignedElements);
 },
 ClearWrappedTextContainersCache: function() {
  ASPx.CacheHelper.DropCache(this.wrappedTextContainers);
 },
 AdjustPagerControls: function() {
  if(typeof(ASPx.GetPagersCollection) != "undefined")
   ASPx.GetPagersCollection().AdjustControls(this.GetMainElement());
 },
 RegisterInControlTree: function(tree) {
  var mainElement = this.GetMainElement();
  if(mainElement && mainElement.id)
   tree.createNode(mainElement.id, this);
 },
 GetItemElementName: function(element) {
  var name = "";
  if(element.id)
   name = element.id.substring(this.name.length + 1);
  return name;
 },
 GetLinkElement: function(element) {
  if(element == null) return null;
  return (element.tagName == "A") ? element : ASPx.GetNodeByTagName(element, "A", 0);
 },
 GetInternalHyperlinkElement: function(parentElement, index) {
  var element = ASPx.GetNodeByTagName(parentElement, "A", index);
  if(element == null) 
   element = ASPx.GetNodeByTagName(parentElement, "SPAN", index);
  return element;
 },
 OnControlClick: function(clickedElement, htmlEvent) {
 }
});
ASPxClientControl.Cast = function(obj) {
 if(typeof obj == "string")
  return window[obj];
 return obj;
};
ASPxClientControl.AdjustControls = function(container, collapseControls){
 aspxGetControlCollection().AdjustControls(container, collapseControls);
};
ASPxClientControl.GetControlCollection = function(){
 return aspxGetControlCollection();
};
ASPxClientControl.LeadingAfterInitCallConsts = {
 None: 0,
 Direct: 1,
 Reverse: 2
};
var ASPxClientComponent = ASPx.CreateClass(ASPxClientControl, {
 constructor: function (name) {
  this.constructor.prototype.constructor.call(this, name);
 },
 IsDOMDisposed: function() { 
  return false;
 }
});
var ASPxClientControlCollection = ASPx.CreateClass(ASPx.CollectionBase, {
 constructor: function(){
  this.constructor.prototype.constructor.call(this);
  this.prevWndWidth = "";
  this.prevWndHeight = "";
  this.requestCountInternal = 0; 
  this.BeforeInitCallback = new ASPxClientEvent();
  this.ControlsInitialized = new ASPxClientEvent();
  this.BrowserWindowResized = new ASPxClientEvent();
  this.BrowserWindowResizedInternal = new ASPxClientEvent();
  this.BeginCallback = new ASPxClientEvent();
  this.EndCallback = new ASPxClientEvent();
  this.CallbackError = new ASPxClientEvent();
  this.ValidationCompleted = new ASPxClientEvent();
  aspxGetControlCollectionCollection().Add(this);
 },
 Add: function(element) {
  var existsElement = this.Get(element.name);
  if(existsElement && existsElement !== element) 
   this.Remove(existsElement);
  ASPx.CollectionBase.prototype.Add.call(this, element.name, element);
 },
 Remove: function(element) {
  if(element && element instanceof ASPxClientControl && !element.IsDisposed())
   element.OnDispose();
  ASPx.CollectionBase.prototype.Remove.call(this, element.name);
 },
 GetGlobal: function(name) {
  var result = window[name];
  return result && Ident.IsASPxClientControl(result)
   ? result
   : null;
 },
 GetByName: function(name){
  return this.Get(name) || this.GetGlobal(name);
 },
 GetCollectionType: function(){
  return ASPxClientControlCollection.BaseCollectionType;
 },
 GetControlsByPredicate: function(predicate) {
  var result = [];
  this.ForEachControl(function(control) {
   if(!predicate || predicate(control))
    result.push(control);
  });
  return result;
 },
 GetControlsByType: function(type) {
  return this.GetControlsByPredicate(function(control) { 
   return type && (control instanceof type);
  });
 },
 ForEachControl: function(action, context) {
  context = context || this;
  this.elementsMap.forEachEntry(function(name, control) {
   if(Ident.IsASPxClientControl(control) && (!this.filterPredicate || this.filterPredicate(control)))
    return action.call(context, control);
  }, context);
 },
 ProcessActionByPredicate: function(action, predicate) {
  try {
   this.filterPredicate = predicate;
   action(this);
  }
  finally {
   this.filterPredicate = null;
  }
 },
 adjustControlsInternal: function(container, context, collapseControls, adjustFunc) {
  context = context || this;
  var func = function(control) {
   adjustFunc.call(context, control);
  };
  ASPx.GetControlAdjuster().adjustControlsInHierarchy(this, func, container, collapseControls);
 },
 AdjustControls: function(container, collapseControls) {
  container = container || null;
  window.setTimeout(function() {
   this.AdjustControlsCore(container, collapseControls);
  }.aspxBind(this), 0);
 },
 AdjustControlsCore: function(container, collapseControls) {
  var adjustFunction = function(control) { control.AdjustControl(); };
  this.adjustControlsInternal(container, this, collapseControls, adjustFunction);
 },
 CollapseControls: function(container) {
  this.ProcessControlsInContainer(container, function(control) {
   if(control.isASPxClientEdit)
    control.CollapseEditor();
   else if(!!window.ASPxClientRibbon && control instanceof ASPxClientRibbon)
    control.CollapseControl();
  });
 },
 AtlasInitialize: function(isCallback) {
  this.ForEachControl(function(control) {
   control.AtlasPreInitialize();
  });
  ASPx.ProcessScriptsAndLinks("", isCallback);
  this.ForEachControl(function(control) {
   control.AtlasInitialize();
  });
 },
 DOMContentLoaded: function() {
  this.ForEachControl(function(control){
    control.DOMContentLoaded();
  });
 },
 OnDocumentUnload: function() {
  this.ForEachControl(function(control) {
   control.RaiseUnload();
  });
 },
 Initialize: function() {
  ASPx.GetPostHandler().Post.AddHandler(
   function(s, e) { this.OnPost(e); }.aspxBind(this)
  );
  ASPx.GetPostHandler().PostFinalization.AddHandler(
   function(s, e) { this.OnPostFinalization(e); }.aspxBind(this)
  );
  this.InitializeElements(false );
  if(typeof(Sys) != "undefined" && typeof(Sys.Application) != "undefined") {
   var checkIsInitialized = function() {
    if(Sys.Application.get_isInitialized())
     Sys.Application.add_load(aspxCAInit);
    else
     setTimeout(checkIsInitialized, 0);
   };
   checkIsInitialized();
  }
  this.InitWindowSizeCache();
 },
 FinalizeInitialization: function() {
  this.ForEachControl(function(control) {
   control.FinalizeInitialization();
  });
 },
 InitializeElements: function(isCallback) {
  this.ForEachControl(function(control){
   if(!control.isInitialized)
    control.Initialize();
  });
  this.AfterInitializeElementsLeadingCall();
  this.AfterInitializeElements();
  this.RaiseControlsInitialized(isCallback);
 },
 AfterInitializeElementsLeadingCall: function() {
  var controls = {};
  controls[ASPxClientControl.LeadingAfterInitCallConsts.Direct] = [];
  controls[ASPxClientControl.LeadingAfterInitCallConsts.Reverse] = [];
  this.ForEachControl(function(control) {
   if(control.leadingAfterInitCall != ASPxClientControl.LeadingAfterInitCallConsts.None && !control.isInitialized)
    controls[control.leadingAfterInitCall].push(control);
  });
  var directInitControls = controls[ASPxClientControl.LeadingAfterInitCallConsts.Direct],
   reverseInitControls = controls[ASPxClientControl.LeadingAfterInitCallConsts.Reverse];
  for(var i = 0, control; control = directInitControls[i]; i++)
   control.AfterInitialize();
  for(var i = reverseInitControls.length - 1, control; control = reverseInitControls[i]; i--)
   control.AfterInitialize();
 },
 AfterInitializeElements: function() {
  this.ForEachControl(function(control) {
   if(control.leadingAfterInitCall == ASPxClientControl.LeadingAfterInitCallConsts.None && !control.isInitialized)
    control.AfterInitialize();
  });
  ASPx.RippleHelper.Init();
 },
 DoFinalizeCallback: function() {
  this.ForEachControl(function(control){
   control.DoFinalizeCallback();
  });
 },
 ProcessControlsInContainer: function(container, processFunc, filterFunc) {
  this.ForEachControl(function(control){
   if((!filterFunc || filterFunc(control)) && (!container || this.IsControlInContainer(container, control)))
    processFunc(control);
  });
 },
 IsControlInContainer: function(container, control) {
  if(control.GetMainElement) {
   var mainElement = control.GetMainElement();
   if(mainElement && (mainElement != container)) {
    if(ASPx.GetIsParent(container, mainElement))
     return true;
   }
  }
  return false;
 },
 RaiseControlsInitialized: function(isCallback) {
  if(typeof(isCallback) == "undefined")
   isCallback = true;
  var args = new ASPxClientControlsInitializedEventArgs(isCallback);
  if(!this.ControlsInitialized.IsEmpty())  
   this.ControlsInitialized.FireEvent(this, args);
  this.ForEachControl(function(control){
   control.OnGlobalControlsInitialized(args);
  });
 },
 RaiseBrowserWindowResized: function() {
  var args = new ASPxClientEventArgs();
  if(!this.BrowserWindowResized.IsEmpty())
   this.BrowserWindowResized.FireEvent(this, args);
  this.ForEachControl(function(control){
   control.OnGlobalBrowserWindowResized(args);
  });
 },
 RaiseBrowserWindowResizedInternal: function(eventInfo) {
  var args = new ASPxClientBrowserWindowResizedInternalEventArgs(eventInfo);
  if(!this.BrowserWindowResizedInternal.IsEmpty())
   this.BrowserWindowResizedInternal.FireEvent(this, args);
 },
 RaiseBeginCallback: function (control, command) {
  var args = new ASPxClientGlobalBeginCallbackEventArgs(control, command);
  if(!this.BeginCallback.IsEmpty())
   this.BeginCallback.FireEvent(this, args);
  this.ForEachControl(function(control){
   control.OnGlobalBeginCallback(args);
  });
  this.IncrementRequestCount();
 },
 RaiseEndCallback: function (control) {
  var args = new ASPxClientGlobalEndCallbackEventArgs(control);
  if (!this.EndCallback.IsEmpty()) 
   this.EndCallback.FireEvent(this, args);
  this.ForEachControl(function(control){
   control.OnGlobalEndCallback(args);
  });
  this.DecrementRequestCount();
 },
 InCallback: function() {
  return this.requestCountInternal > 0;
 },
 RaiseCallbackError: function (control, message, callbackId) {
  var args = new ASPxClientGlobalCallbackErrorEventArgs(control, message, callbackId);
  if (!this.CallbackError.IsEmpty()) 
   this.CallbackError.FireEvent(this, args);
  this.ForEachControl(function(control){
   control.OnGlobalCallbackError(args);
  });
  if(args.handled)
   return { isHandled: true, errorMessage: args.message };  
  return { isHandled: false, errorMessage: message };
 },
 RaiseValidationCompleted: function (container, validationGroup, invisibleControlsValidated, isValid, firstInvalidControl, firstVisibleInvalidControl) {
  var args = new ASPxClientValidationCompletedEventArgs(container, validationGroup, invisibleControlsValidated, isValid, firstInvalidControl, firstVisibleInvalidControl);
  if (!this.ValidationCompleted.IsEmpty()) 
   this.ValidationCompleted.FireEvent(this, args);
  this.ForEachControl(function(control){
   control.OnGlobalValidationCompleted(args);
  });
  return args.isValid;
 },
 Before_WebForm_InitCallback: function(callbackOwnerID){
  var args = new BeforeInitCallbackEventArgs(callbackOwnerID);
  this.BeforeInitCallback.FireEvent(this, args);
 },
 InitWindowSizeCache: function(){
  this.prevWndWidth = ASPx.GetDocumentClientWidth();
  this.prevWndHeight = ASPx.GetDocumentClientHeight();
 },
 OnBrowserWindowResize: function(evt){
  var shouldIgnoreNestedEvents = ASPx.Browser.IE && ASPx.Browser.MajorVersion == 8;
  if(shouldIgnoreNestedEvents) {
   if(this.prevWndWidth === "" || this.prevWndHeight === "" || this.browserWindowResizeLocked)
    return;
   this.browserWindowResizeLocked = true;
  }
  this.OnBrowserWindowResizeCore(evt);
  if(shouldIgnoreNestedEvents)
   this.browserWindowResizeLocked = false;
 },
 OnBrowserWindowResizeCore: function(htmlEvent){
  var args = this.CreateOnBrowserWindowResizeEventArgs(htmlEvent);
  if(this.CalculateIsBrowserWindowSizeChanged()) {
   this.RaiseBrowserWindowResizedInternal(args);
   this.adjustControlsInternal(null, this, true, function(control) {
    if(control.IsDOMInitialized())
     control.OnBrowserWindowResizeInternal(args);
   });
   this.RaiseBrowserWindowResized();
  }
 },
 CreateOnBrowserWindowResizeEventArgs: function(htmlEvent) {
  return {
   htmlEvent: htmlEvent,
   wndWidth: ASPx.GetDocumentClientWidth(),
   wndHeight: ASPx.GetDocumentClientHeight(),
   prevWndWidth: this.prevWndWidth,
   prevWndHeight: this.prevWndHeight,
   virtualKeyboardShownOnAndroid: this.IsVirtualKeyboardShownOnAndroid()
  };
 },
 IsVirtualKeyboardShownOnAndroid: function() {
  if(!ASPx.Browser.AndroidMobilePlatform)
   return false;
  var documentClientWidth = ASPx.GetDocumentClientWidth();
  var documentClientHeight = ASPx.GetDocumentClientHeight();
  var isDocumentClientHeightChangedOnly = documentClientWidth === this.prevWndWidth && documentClientHeight !== this.prevWndHeight;
  return isDocumentClientHeightChangedOnly && this.IsElementSupportKeyboardInput(document.activeElement);
 },
 IsElementSupportKeyboardInput: function(element) {
  if(!element || !element.tagName)
   return false;
  var supportedKeyboardInputTagNames = ["INPUT", "TEXTAREA"];
  return supportedKeyboardInputTagNames.indexOf(element.tagName) !== -1;
 },
 CalculateIsBrowserWindowSizeChanged: function(){
  var wndWidth = ASPx.GetDocumentClientWidth();
  var wndHeight = ASPx.GetDocumentClientHeight();
  var isBrowserWindowSizeChanged = (this.prevWndWidth != wndWidth) || (this.prevWndHeight != wndHeight);
  if(isBrowserWindowSizeChanged){
   this.prevWndWidth = wndWidth;
   this.prevWndHeight = wndHeight;
   return true;
  }
  return false;
 },
 OnPost: function(args){
  this.ForEachControl(function(control) {
   control.OnPost(args);
  }, null);
 },
 OnPostFinalization: function(args){
  this.ForEachControl(function(control) {
   control.OnPostFinalization(args);
  }, null);
 },
 IncrementRequestCount: function() {
  this.requestCountInternal++;
 },
 DecrementRequestCount: function() {
  this.requestCountInternal--;
 },
 ResetRequestCount: function() {
  this.requestCountInternal = 0;
 }
});
ASPxClientControlCollection.BaseCollectionType = "Control";
var controlCollection = null;
function aspxGetControlCollection(){
 if(controlCollection == null) {
  controlCollection = new ASPxClientControlCollection();
  if(ASPx.loadControlCollectionPreloadHandlers)
   ASPx.loadControlCollectionPreloadHandlers(controlCollection);
 }
 return controlCollection;
}
var ControlCollectionCollection = ASPx.CreateClass(ASPx.CollectionBase, {
 constructor: function(){
  this.constructor.prototype.constructor.call(this);
 },
 Add: function(element) {
  var key = element.GetCollectionType();
  if(!key) throw "The collection type isn't specified.";
  if(this.Get(key)) throw "The collection with type='" + key + "' already exists.";
  ASPx.CollectionBase.prototype.Add.call(this, key, element);
 },
 RemoveDisposedControls: function(){
  var baseCollection = this.Get(ASPxClientControlCollection.BaseCollectionType);
  var disposedControls = [];
  baseCollection.elementsMap.forEachEntry(function(name, control) {
   if(!ASPx.Ident.IsASPxClientControl(control)) return;
   if(control.IsDOMDisposed())
    disposedControls.push(control);
  });
  this.RemoveControls(disposedControls);
 },
 RemoveControls: function(controls){
  for(var i = 0; i < controls.length; i++) {
   this.elementsMap.forEachEntry(function(key, collection) {
    if(ASPx.Ident.IsASPxClientCollection(collection))
     collection.Remove(controls[i]);
   });
  }
 }
});
var controlCollectionCollection = null;
function aspxGetControlCollectionCollection(){
 if(controlCollectionCollection == null)
  controlCollectionCollection = new ControlCollectionCollection();
 return controlCollectionCollection;
}
var AriaDescriptionAttributes = {
 Role: "0",
 AriaLabel: "1",
 TabIndex: "2",
 AriaOwns: "3",
 AriaDescribedBy: "4",
 AriaDisabled: "5",
 AriaHasPopup: "6",
 AriaLevel: "7"
};
var AriaDescriptor = ASPx.CreateClass(null, {
 constructor: function(ownerControl, description) {
  this.ownerControl = ownerControl;
  this.rootElement = ownerControl.GetMainElement();
  this.description = description;
 },
 setDescription: function(name, argList) {
  var description = this.findChildDescription(name);
  if(description) {
   var elements = name ? this.rootElement.querySelectorAll(this.getDescriptionSelector(description)) : [this.rootElement];
   for(var i = 0; i < elements.length; i++)
    this.applyDescriptionToElement(elements[i], description, argList[i] || argList[0]);
  }
 },
 getDescriptionName: function(description) {
  return description.n;
 },
 getDescriptionSelector: function(description) {
  return description.s;
 },
 findChildDescription: function(name) {
  if(name === this.getDescriptionName(this.description))
   return this.description;
  var childCollection = this.description.c || [];
  for(var i = 0; i < childCollection.length; i++) {
   var childDescription = childCollection[i];
   if(this.getDescriptionName(childDescription) === name)
    return childDescription;
  }
  return null;
 },
 applyDescriptionToElement: function(element, description, args) {
  if(!description || !element)
   return;
  this.trySetAriaOwnsAttribute(element, description);
  this.trySetAriaDescribedByAttribute(element, description);
  this.trySetAttribute(element, description, AriaDescriptionAttributes.Role, "role");
  this.trySetAttribute(element, description, AriaDescriptionAttributes.TabIndex, "tabindex");
  this.trySetAttribute(element, description, AriaDescriptionAttributes.AriaLevel, "aria-level");
  this.executeOnDescription(description, AriaDescriptionAttributes.AriaLabel, function(value) {
   ASPx.Attr.SetAttribute(element, "aria-label", ASPx.Str.ApplyReplacement(value, args));
  });
  this.executeOnDescription(description, AriaDescriptionAttributes.AriaDisabled, function(value) {
   ASPx.Attr.SetAttribute(element, "aria-disabled", !!value); 
  });
  this.executeOnDescription(description, AriaDescriptionAttributes.AriaHasPopup, function(value) {
   ASPx.Attr.SetAttribute(element, "aria-haspopup", !!value);
  });
 },
 trySetAriaDescribedByAttribute: function(element, description) {
  this.executeOnDescription(description, AriaDescriptionAttributes.AriaDescribedBy, function(selectorInfo) {
   var descriptor = this.getNodesBySelector(element, selectorInfo.descriptorSelector)[0];
   var target = this.getNodesBySelector(element, selectorInfo.targetSelector)[0];
   if(!target || !descriptor)
    return;
   ASPx.Attr.SetAttribute(target, "aria-describedby", this.getNodeId(descriptor));
  });
 },
 trySetAriaOwnsAttribute: function(element, description) {
  this.executeOnDescription(description, AriaDescriptionAttributes.AriaOwns, function(selector) {
   var ownedNodes = this.getNodesBySelector(element, selector);
   var ariaOwnsAttributeValue = "";
   for(var i = 0; i < ownedNodes.length; i++)
    ariaOwnsAttributeValue += (this.getNodeId(ownedNodes[i]) + (i != ownedNodes.length - 1 ? " " : ""));
   ASPx.Attr.SetAttribute(element, "aria-owns", ariaOwnsAttributeValue);
  });
 },
 trySetAttribute: function(element, description, ariaAttribute, attributeName) {
  this.executeOnDescription(description, ariaAttribute, function(value) { 
   ASPx.Attr.SetAttribute(element, attributeName, description[ariaAttribute]); 
  });
 },
 executeOnDescription: function(description, ariaDescAttr, callback) {
  var descInfo = description[ariaDescAttr];
  if(ASPx.IsExists(descInfo))
   callback.aspxBind(this)(descInfo);
 },
 getNodesBySelector: function(element, selector) {
  var id = element.id || "";
  var childNodes = element.querySelectorAll("#" + this.getNodeId(element) + " > " + selector);
  ASPx.Attr.SetOrRemoveAttribute(element, "id", id);
  return childNodes;
 },
 getNodeId: function(node) {
  if(!node.id)
   node.id = this.createRandomId();
  return node.id; 
 },
 createRandomId: function() {
  return "r" + ASPx.CreateGuid();
 }
});
PagerCommands = {
 Next : "PBN",
 Prev : "PBP",
 Last : "PBL",
 First : "PBF",
 PageNumber : "PN",
 PageSize : "PSP"
};
ASPx.callbackProcessed = false;
ASPx.Callback = function(result, context){ 
 var collection = aspxGetControlCollection();
 collection.DoFinalizeCallback();
 var control = collection.Get(context);
 if(control != null)
  control.DoCallback(result);
 ASPx.RippleHelper.ReInit();
 ASPx.callbackProcessed = true;
};
ASPx.CallbackError = function(result, context){
 var control = aspxGetControlCollection().Get(context);
 if(control != null)
  control.DoCallbackError(result, false);
 ASPx.callbackProcessed = true;
};
ASPx.CClick = function(name, evt) {
 var control = aspxGetControlCollection().Get(name);
 if(control != null) control.DoControlClick(evt);
};
function aspxCAInit() {
 var isAppInit = typeof(Sys$_Application$initialize) != "undefined" &&
  ASPx.FunctionIsInCallstack(arguments.callee, Sys$_Application$initialize, 10 );
 aspxGetControlCollection().AtlasInitialize(!isAppInit);
}
ASPx.Evt.AttachEventToElement(window, "resize", aspxGlobalWindowResize);
function aspxGlobalWindowResize(evt){
 aspxGetControlCollection().OnBrowserWindowResize(evt); 
}
ASPx.Evt.AttachEventToElement(window, "unload", aspxClassesUnload);
function aspxClassesUnload(evt) {
 aspxGetControlCollection().OnDocumentUnload();
}
ASPx.attachToLoad(aspxClassesDOMContentLoaded);
function aspxClassesDOMContentLoaded(evt){
 aspxGetControlCollection().DOMContentLoaded();
}
ASPx.GetControlCollection = aspxGetControlCollection;
ASPx.GetControlCollectionCollection = aspxGetControlCollectionCollection;
ASPx.GetPersistentControlPropertiesStorage = _aspxGetPersistentControlPropertiesStorage;
ASPx.PagerCommands = PagerCommands;
ASPx.ELLIPSIS_MARKER_CLASS = ELLIPSIS_MARKER_CLASS;
window.ASPxClientBeginCallbackEventArgs = ASPxClientBeginCallbackEventArgs;
window.ASPxClientGlobalBeginCallbackEventArgs = ASPxClientGlobalBeginCallbackEventArgs;
window.ASPxClientEndCallbackEventArgs = ASPxClientEndCallbackEventArgs;
window.ASPxClientGlobalEndCallbackEventArgs = ASPxClientGlobalEndCallbackEventArgs;
window.ASPxClientCallbackErrorEventArgs = ASPxClientCallbackErrorEventArgs;
window.ASPxClientGlobalCallbackErrorEventArgs = ASPxClientGlobalCallbackErrorEventArgs;
window.ASPxClientCustomDataCallbackEventArgs = ASPxClientCustomDataCallbackEventArgs;
window.ASPxClientValidationCompletedEventArgs = ASPxClientValidationCompletedEventArgs;
window.ASPxClientControlsInitializedEventArgs = ASPxClientControlsInitializedEventArgs;
window.ASPxClientControlBeforePronounceEventArgs = ASPxClientControlBeforePronounceEventArgs;
window.ASPxClientControlUnloadEventArgs = ASPxClientControlUnloadEventArgs;
window.ASPxClientEndFocusEventArgs = ASPxClientEndFocusEventArgs;
window.ASPxClientItemFocusedEventArgs = ASPxClientItemFocusedEventArgs;
window.ASPxClientControlCollection = ASPxClientControlCollection;
window.ASPxClientControlBase = ASPxClientControlBase;
window.ASPxClientControl = ASPxClientControl;
window.ASPxClientComponent = ASPxClientComponent;
})(ASPx);

(function() {
var ASPxClientEditBase = ASPx.CreateClass(ASPxClientControl, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.EnabledChanged = new ASPxClientEvent();
  this.captionPosition = ASPx.Position.Left;
  this.showCaptionColon = true;
  this.scPrefix = "dxe";
 },
 InlineInitialize: function(){
  ASPxClientControl.prototype.InlineInitialize.call(this);
  this.InitializeEnabled(); 
  this.InitializeEvents();
 },
 InitializeEnabled: function() {
  this.SetEnabledInternal(this.clientEnabled, true);
 },
 InitializeEvents: function() { },
 AddDefaultReadOnlyStateControllerItem: function(cssClass, mainElementId) {
  ASPx.AddReadOnlyItems(mainElementId, [[[cssClass], [''], ['']]]);
 },
 AddDefaultDisabledStateControllerItem: function(cssClass, mainElementId) {
  ASPx.AddDisabledItems(mainElementId, [[[cssClass], [''], ['']]]);
 },
 GetValue: function() {
  var element = this.GetMainElement();
  if(ASPx.IsExistsElement(element))
   return element.innerHTML;
  return "";
 },
 GetValueString: function(){
  var value = this.GetValue();
  return (value == null) ? null : value.toString();
 },
 EnsureValueStringIsActual: function() {
  if(this.maskInfo != null)
   this.ParseValue();
 },
 SetValue: function(value) {
  if(value == null)
   value = "";
  var element = this.GetMainElement();
  if(ASPx.IsExistsElement(element))
   element.innerHTML = value;
 },
 GetEnabled: function(){
  return this.enabled && this.clientEnabled;
 },
 SetEnabled: function(enabled){
  if(this.clientEnabled != enabled) {
   var errorFrameRequiresUpdate = this.GetIsValid && !this.GetIsValid();
   if(errorFrameRequiresUpdate && !enabled)
    this.UpdateErrorFrameAndFocus(false , null , true );
   this.clientEnabled = enabled;
   this.SetEnabledInternal(enabled, false);
   if(errorFrameRequiresUpdate && enabled)
    this.UpdateErrorFrameAndFocus(false );
   this.RaiseEnabledChangedEvent();
  }
 },
 SetEnabledInternal: function(enabled, initialization){
  if(!this.enabled) return;
  if(!initialization || !enabled)
   this.ChangeEnabledStateItems(enabled);
  this.ChangeEnabledAttributes(enabled);
  if(ASPx.Browser.Chrome) {   
   var mainElement = this.GetMainElement();
   if(mainElement)
    mainElement.className = mainElement.className;
  } 
 },
 ChangeEnabledAttributes: function(enabled){
 },
 ChangeEnabledStateItems: function(enabled){
 },
 RaiseEnabledChangedEvent: function(){
  if(!this.EnabledChanged.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.EnabledChanged.FireEvent(this, args);
  }
 },
 GetDecodeValue: function (value) { 
  if(typeof (value) == "string" && value.length > 1)
   value = this.SimpleDecodeHtml(value);
  return value;
 },
 SimpleDecodeHtml: function (html) {
  return ASPx.Str.ApplyReplacement(html, [
   [/&lt;/g, '<'],
   [/&amp;/g, '&'],
   [/&quot;/g, '"'],
   [/&#39;/g, '\''],
   [/&#32;/g, ' ']
  ]);
 },
 GetCachedElementById: function(idSuffix) {
  return ASPx.CacheHelper.GetCachedElementById(this, this.name + idSuffix);
 },
 GetCaptionCell: function() {
  return this.GetCachedElementById(EditElementSuffix.CaptionCell);
 },
 GetExternalTable: function() {
  return this.GetCachedElementById(EditElementSuffix.ExternalTable);
 },
 getCaptionRelatedCellCount: function() {
  if(!this.captionRelatedCellCount)
   this.captionRelatedCellCount = ASPx.GetNodesByClassName(this.GetExternalTable(), CaptionRelatedCellClassName).length;
  return this.captionRelatedCellCount;
 },
 addCssClassToCaptionRelatedCells: function() {
  if(this.captionPosition == ASPx.Position.Left || this.captionPosition == ASPx.Position.Right) {
   var captionRelatedCellsIndex = this.captionPosition == ASPx.Position.Left ? 0 : this.GetCaptionCell().cellIndex;
   for(var i = 0; i < this.GetExternalTable().rows.length; i++)
    ASPx.AddClassNameToElement(this.GetExternalTable().rows[i].cells[captionRelatedCellsIndex], CaptionRelatedCellClassName);
  }
  if(this.captionPosition == ASPx.Position.Top || this.captionPosition == ASPx.Position.Bottom)
   for(var i = 0; i < this.GetCaptionCell().parentNode.cells.length; i++)
    ASPx.AddClassNameToElement(this.GetCaptionCell().parentNode.cells[i], CaptionRelatedCellClassName);
 },
 GetCaption: function() {
  if(ASPx.IsExists(this.GetCaptionCell()))
   return this.getCaptionInternal();
  return "";
 },
 SetCaption: function(caption) {
  if(!ASPx.IsExists(this.GetCaptionCell()))
   return;
  if(this.getCaptionRelatedCellCount() == 0)
   this.addCssClassToCaptionRelatedCells();
  if(caption !== "")
   ASPx.RemoveClassNameFromElement(this.GetExternalTable(), ASPxEditExternalTableClassNames.TableWithEmptyCaptionClassName);
  else
   ASPx.AddClassNameToElement(this.GetExternalTable(), ASPxEditExternalTableClassNames.TableWithEmptyCaptionClassName);
  this.setCaptionInternal(caption);
 },
 getCaptionTextNode: function() {
  var captionElement = ASPx.GetNodesByPartialClassName(this.GetCaptionCell(), CaptionElementPartialClassName)[0];
  return ASPx.GetNormalizedTextNode(captionElement);
 },
 getCaptionInternal: function() {
  var captionText = this.getCaptionTextNode().nodeValue;
  if(captionText !== "" && captionText[captionText.length - 1] == ":")
   captionText = captionText.substring(0, captionText.length - 1);
  return captionText;
 },
 setCaptionInternal: function(caption) {
  caption = ASPx.Str.Trim(caption);
  var captionTextNode = this.getCaptionTextNode();
  if(this.showCaptionColon && caption[caption.length - 1] != ":" && caption !== "")
   caption += ":";
  captionTextNode.nodeValue = caption;
 },
 onVirtualKeyboardUITouchStart: function(evt) { }
});
var ValidationPattern = ASPx.CreateClass(null, {
 constructor: function(errorText) {
  this.errorText = errorText;
 }
});
var RequiredFieldValidationPattern = ASPx.CreateClass(ValidationPattern, {
 constructor: function(errorText) {
  this.constructor.prototype.constructor.call(this, errorText);
 },
 EvaluateIsValid: function(value) {
  return value != null && (value.constructor == Array || ASPx.Str.Trim(value.toString()) != "");
 }
});
var RegularExpressionValidationPattern = ASPx.CreateClass(ValidationPattern, {
 constructor: function(errorText, pattern) {
  this.constructor.prototype.constructor.call(this, errorText);
  this.pattern = pattern;
 },
 EvaluateIsValid: function(value) {
  if(value == null) 
   return true;
  var strValue = value.toString();
  if(ASPx.Str.Trim(strValue).length == 0)
   return true;
  var regEx = new RegExp(this.pattern);
  var matches = regEx.exec(strValue);
  return matches != null && strValue == matches[0];
 }
});
function _aspxIsEditorFocusable(inputElement) {
 return ASPx.IsFocusableCore(inputElement, function(container) {
  return container.getAttribute("errorFrame") == "errorFrame";
 });
}
var invalidEditorToBeFocused = null;
var ValidationType = {
 PersonalOnValueChanged: "ValueChanged",
 PersonalViaScript: "CalledViaScript",
 MassValidation: "MassValidation"
};
var ErrorFrameDisplay = {
 None: "None",
 Static: "Static",
 Dynamic: "Dynamic"
};
var EditElementSuffix = {
 ExternalTable: "_ET",
 ControlCell: "_CC",
 ErrorCell: "_EC",
 ErrorTextCell: "_ETC",
 ErrorImage: "_EI",
 CaptionCell: "_CapC",
 AccessibilityAdditionalTextRow: "_AHTR"
};
var ASPxEditExternalTableClassNames = {
 ValidStaticTableClassName: "dxeValidStEditorTable",
 ValidDynamicTableClassName: "dxeValidDynEditorTable",
 TableWithEmptyCaptionClassName: "tableWithEmptyCaption"
};
var CaptionRelatedCellClassName = "dxeCaptionRelatedCell";
var CaptionElementPartialClassName = "dxeCaption";
var AccessibilityAssistantID = "AcAs";
var ASPxClientEdit = ASPx.CreateClass(ASPxClientEditBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.isASPxClientEdit = true;
  this.inputElement = null;
  this.convertEmptyStringToNull = true;
  this.readOnly = false;
  this.clientReadOnly = false;
  this.focused = false;
  this.focusEventsLocked = false;
  this.focusEventsLockCount = 0;
  this.receiveGlobalMouseWheel = true;
  this.styleDecoration = null;
  this.heightCorrectionRequired = false;
  this.customValidationEnabled = false;
  this.display = ErrorFrameDisplay.Static;
  this.initialErrorText = "";
  this.causesValidation = false;
  this.validateOnLeave = true;
  this.validationGroup = "";
  this.sendPostBackWithValidation = null;
  this.validationPatterns = [];
  this.setFocusOnError = false;
  this.errorDisplayMode = "it";
  this.errorText = "";
  this.isValid = true;
  this.errorImageIsAssigned = false;
  this.notifyValidationSummariesToAcceptNewError = false;
  this.isErrorFrameRequired = false;
  this.enterProcessed = false;
  this.keyDownHandlers = {};
  this.keyPressHandlers = {};
  this.keyUpHandlers = {};
  this.onKeyDownHandler = null;
  this.onKeyPressHandler = null;
  this.onKeyUpHandler = null;
  this.onGotFocusHandler = null;
  this.onLostFocusHandler = null;
  this.GotFocus = new ASPxClientEvent();
  this.LostFocus = new ASPxClientEvent();
  this.Validation = new ASPxClientEvent();
  this.ValueChanged = new ASPxClientEvent();
  this.KeyDown = new ASPxClientEvent();
  this.KeyPress = new ASPxClientEvent();
  this.KeyUp = new ASPxClientEvent();
  this.eventHandlersInitialized = false;
  this.errorCellVisibilityChanged = new ASPxClientEvent();
  this.ariaExplanatoryTextManager = null;
  this.InitializeEventHandlers();
 },
 SetData: function(data){
  if(data.decorationStyles){
   for(var i = 0; i < data.decorationStyles.length; i++)
    this.AddDecorationStyle(data.decorationStyles[i].key, 
     data.decorationStyles[i].className, 
     data.decorationStyles[i].cssText);
  }
 },
 Initialize: function() {
  this.initialErrorText = this.errorText;
  ASPxClientEditBase.prototype.Initialize.call(this);
  this.InitializeKeyHandlers();
  this.UpdateClientValidationState();
  this.UpdateValidationSummaries(null , true );
 },
 InlineInitialize: function() {
  if(this.UseDelayedSpecialFocus())
   this.InitializeDelayedSpecialFocus();
  ASPxClientEditBase.prototype.InlineInitialize.call(this);
  this.UpdateStyleDecorations();
  var externalTable = this.GetExternalTable();
  if(externalTable && ASPx.IsPercentageSize(externalTable.style.width)) {
   this.width = "100%";
   this.GetMainElement().style.width = "100%";
   if(this.isErrorFrameRequired)
    externalTable.setAttribute("errorFrame", "errorFrame");
  }
  this.ariaExplanatoryTextManager = this.CreateAriaExplanatoryTextManager();
  if(this.clientReadOnly)
   this.SetReadOnlyInternal(true);
  this.UpdateErrorCellParentRowVisibility();
 }, 
 AfterInitialize: function() {
  this.ariaExplanatoryTextManager.SetCaptionAssociating();
  this.ariaExplanatoryTextManager.UpdateText();
  this.ariaExplanatoryTextManager.UpdateValidationState();
  ASPxClientEditBase.prototype.AfterInitialize.call(this);
 },
 UpdateStyleDecorations: function() {
  if(this.styleDecoration)
   this.styleDecoration.Update();
 },
 UseSpecialKeyboardHandling: function() {
  return false;
 },
 InitializeKeyHandlers: function() {
 },
 AddKeyDownHandler: function(key, handler) {
  this.keyDownHandlers[key] = handler;
 },
 AddKeyPressHandler: function(key, handler) {
  this.keyPressHandlers[key] = handler;
 },
 InitializeEventHandlers: function() {
  this.onGotFocusHandler = function(evt) { ASPx.EGotFocus(this.name); }.bind(this);
  this.onLostFocusHandler = function(evt) { ASPx.ELostFocus(this.name); }.bind(this);
  if(this.UseSpecialKeyboardHandling()) {
   this.onKeyDownHandler = function(evt) { ASPx.KBSIKeyDown(this.name, evt); }.bind(this);
   this.onKeyPressHandler = function(evt) { ASPx.KBSIKeyPress(this.name, evt); }.bind(this);
   this.onKeyUpHandler = function(evt) { ASPx.KBSIKeyUp(this.name, evt); }.bind(this);
  }
 },
 ChangeSpecialInputEnabledAttributes: function(element, method, doNotChangeAutoComplete) {
  if(!doNotChangeAutoComplete) 
   element.autocomplete = "off";
  if(this.onKeyDownHandler != null)
   method(element, "keydown", this.onKeyDownHandler);
  if(this.onKeyPressHandler != null)
   method(element, "keypress", this.onKeyPressHandler);
  if(this.onKeyUpHandler != null)
   method(element, "keyup", this.onKeyUpHandler);
  if(this.onGotFocusHandler != null)
   method(element, "focus", this.onGotFocusHandler);
  if(this.onLostFocusHandler != null)
   method(element, "blur", this.onLostFocusHandler);
 },
 CreateAriaExplanatoryTextManager: function() {
  if(this.accessibilityCompliant)
   return new EditAccessibilityExplanatoryTextManager(this);
  else 
   return new DisableAccessibilityExplanatoryTextManager(this);
 },
 UpdateClientValidationState: function() {
  if(!this.customValidationEnabled)
   return;
  var mainElement = this.GetMainElement();
  if(mainElement) {
   var validationState = !this.GetIsValid() ? ("-" + this.GetErrorText()) : "";
   this.UpdateStateObjectWithObject({ validationState: validationState });
  }
 },
 UpdateValidationSummaries: function(validationType, initializing) {
  if(ASPx.Ident.scripts.ASPxClientValidationSummary) {
   var summaryCollection = ASPx.GetClientValidationSummaryCollection();
   summaryCollection.OnEditorIsValidStateChanged(this, validationType, initializing && this.notifyValidationSummariesToAcceptNewError);
  }
 },
 FindInputElement: function(){
  return null;
 },
 GetInputElement: function(){
  if(!ASPx.IsExistsElement(this.inputElement))
   this.inputElement = this.FindInputElement();
  return this.inputElement;
 },
 GetFocusableInputElement: function() {
  return this.GetInputElement();
 },
 GetAccessibilityActiveElements: function() {
  return [this.GetInputElement()];
 },
 GetAccessibilityFirstActiveElement: function() {
  return this.accessibilityHelper ? 
    this.accessibilityHelper.getMainElement() : 
    this.GetAccessibilityActiveElements()[0];
 },
 GetAccessibilityAssistantElement: function() {
  return this.GetChildElement(AccessibilityAssistantID);
 },
 GetErrorImage: function() {
  return this.GetCachedElementById(EditElementSuffix.ErrorImage);
 },
 GetControlCell: function() {
  return this.GetCachedElementById(EditElementSuffix.ControlCell);
 },
 GetErrorCell: function() {
  return this.GetCachedElementById(EditElementSuffix.ErrorCell);
 },
 GetErrorTextCell: function() {
  return this.GetCachedElementById(this.errorImageIsAssigned ? EditElementSuffix.ErrorTextCell : EditElementSuffix.ErrorCell);
 },
 GetReadOnly: function() {
  return this.readOnly || this.clientReadOnly;
 },
 SetReadOnly: function(readOnly) {
  readOnly = !!readOnly;
  if(this.clientReadOnly === readOnly || this.readOnly)
   return;
  this.SetReadOnlyInternal(readOnly);
 },
 SetReadOnlyInternal: function(readOnly) {
  this.clientReadOnly = readOnly;
  this.ChangeReadOnlyStateItems(readOnly);
 },
 ChangeReadOnlyStateItems: function(readOnly) {
  ASPx.GetStateController().SetElementReadOnly(this.GetMainElement(), readOnly);
 },
 SetVisible: function (isVisible) {
  if(this.clientVisible == isVisible)
   return;
  var externalTable = this.GetExternalTable();
  if(externalTable) {
   ASPx.SetElementDisplay(externalTable, isVisible);
   if(this.customValidationEnabled) {
    var isValid = !isVisible ? true : void (0);
    this.UpdateErrorFrameAndFocus(false , true , isValid );
   }
  }
  ASPxClientControl.prototype.SetVisible.call(this, isVisible);
 },
 GetStateHiddenFieldName: function() {
  return this.uniqueID + "$State";
 },
 GetValueInputToValidate: function() {
  return this.GetInputElement();
 },
 IsVisible: function() {
  if(!this.clientVisible)
   return false;
  var element = this.GetMainElement();
  if(!element) 
   return false;
  while(element && element.tagName != "BODY") {
   if(element.getAttribute("errorFrame") != "errorFrame" && (!ASPx.GetElementVisibility(element) || !ASPx.GetElementDisplay(element)))
    return false;
   element = element.parentNode;
  }
  return true;
 },
 AdjustControlCore: function() {
  this.CollapseEditor();
  this.UnstretchInputElement();
  if(this.heightCorrectionRequired)
   this.CorrectEditorHeight();
 },
 CorrectEditorHeight: function() {
 },
 UnstretchInputElement: function() {
 },
 UseDelayedSpecialFocus: function() {
  return false;
 },
 GetDelayedSpecialFocusTriggers: function() {
  return [ this.GetMainElement() ];
 },
 InitializeDelayedSpecialFocus: function() {
  this.specialFocusTimer = -1;    
  var handler = function(evt) { this.OnDelayedSpecialFocusMouseDown(evt); }.aspxBind(this);
  var triggers = this.GetDelayedSpecialFocusTriggers();
  for(var i = 0; i < triggers.length; i++)
   ASPx.Evt.AttachEventToElement(triggers[i], "mousedown", handler);
 },
 OnDelayedSpecialFocusMouseDown: function(evt) {
  window.setTimeout(function() { this.SetFocus(); }.aspxBind(this), 0);
 },
 IsFocusEventsLocked: function() {
  return this.focusEventsLocked || this.focusEventsLockCount !== 0;
 },
 BeginFocusUpdate: function() {
  this.focusEventsLockCount++;
 },
 EndFocusUpdate: function() {
  this.focusEventsLockCount--;
  if(this.focusEventsLockCount === 0)
   if(this.focused && !this.IsEditorElement(document.activeElement)) 
    this.OnLostFocus();
 },
 LockFocusEvents: function() {
  if(!this.focused) return;
  this.focusEventsLocked = true;
 },
 UnlockFocusEvents: function() {
  this.focusEventsLocked = false;
 },
 ForceRefocusEditor: function(evt, isNativeFocus) {
  if(ASPx.Browser.VirtualKeyboardSupported && !this.ownerListBox) {
   var focusedEditor = ASPx.VirtualKeyboardUI.getFocusedEditor();
   if(ASPx.VirtualKeyboardUI.getInputNativeFocusLocked() && (!focusedEditor || focusedEditor === this))
     return;
   ASPx.VirtualKeyboardUI.setInputNativeFocusLocked(!isNativeFocus);
  }
  this.LockFocusEvents();
  this.BlurInputElement();
  window.setTimeout(function() { 
   if(ASPx.Browser.VirtualKeyboardSupported && !this.ownerListBox) {
    ASPx.VirtualKeyboardUI.setFocusToEditor(this);
   } else {
    this.SetFocus();
   }
  }.aspxBind(this), 0);
 },
 BlurInputElement: function() {
  var inputElement = this.GetFocusableInputElement();
  if(inputElement && inputElement.blur)
   inputElement.blur();
 },
 IsEditorElement: function(element) {
  return this.GetMainElement() == element || ASPx.GetIsParent(this.GetMainElement(), element);
 },
 IsClearButtonElement: function(element) {
  return false;
 },
 IsElementBelongToInputElement: function(element) {
  return this.GetInputElement() == element;
 },
 OnFocusCore: function() {
  if(this.UseDelayedSpecialFocus())
   this.specialFocusTimer = ASPx.Timer.ClearTimer(this.specialFocusTimer);
  if(!this.IsFocusEventsLocked()){
   this.focused = true;
   ASPx.SetFocusedEditor(this);
   if(this.styleDecoration)
    this.styleDecoration.Update();
   if(this.isInitialized)
    this.RaiseFocus();
  }
  else
   this.UnlockFocusEvents();
 },
 OnLostFocusCore: function() {
  if(!this.IsFocusEventsLocked()){
   this.focused = false;
   if(ASPx.GetFocusedEditor() === this)
    ASPx.SetFocusedEditor(null);
   if(this.styleDecoration)
    this.styleDecoration.Update();
   this.RaiseLostFocus();
  }
 },
 OnFocus: function() {
  this.OnFocusCore();
 },
 OnLostFocus: function() {
  if(this.isInitialized)
   this.OnLostFocusCore();
 },
 OnMouseWheel: function(evt){
 },
 OnValidation: function(validationType) {
  if(this.customValidationEnabled && this.isInitialized && ASPx.IsExistsElement(this.GetMainElement()) &&
   (!this.IsErrorFrameDisplayed() || this.GetElementRequiredForErrorFrame())) {
   this.BeginErrorFrameUpdate();
   try {
    if(this.validateOnLeave || validationType != ValidationType.PersonalOnValueChanged) {
     this.SetIsValid(true, true );
     this.SetErrorText(this.initialErrorText, true );
     this.ValidateWithPatterns();
     this.RaiseValidation();
    }
    this.UpdateErrorFrameAndFocus(this.editorFocusingRequired(validationType));
   } finally {
    this.EndErrorFrameUpdate();
   }
   this.UpdateValidationSummaries(validationType);
   this.ariaExplanatoryTextManager.UpdateValidationState(validationType);
  }
 },
 GetElementRequiredForErrorFrame: function() {
  return this.GetExternalTable();
 },
 editorFocusingRequired: function(validationType) {
  return !this.GetIsValid() &&
   validationType == ValidationType.PersonalViaScript && this.setFocusOnError;
 },
 OnValueChanged: function() {
  if(this.getProcessOnServerOnValueChanged())
   this.SendPostBackInternal("");
 },
 getProcessOnServerOnValueChanged: function() {
  var processOnServer = this.RaiseValidationInternal();
  return this.RaiseValueChangedEvent() && processOnServer;
 },
 ParseValue: function() {
 },
 RaisePersonalStandardValidation: function() {
  if(ASPx.IsFunction(window.ValidatorOnChange)) {
   var inputElement = this.GetValueInputToValidate();
   if(inputElement && inputElement.Validators)
    window.ValidatorOnChange({ srcElement: inputElement });
  }
 },
 RaiseValidationInternal: function() {
  if(this.isPostBackAllowed() && this.causesValidation && this.validateOnLeave)
   return ASPxClientEdit.ValidateGroup(this.validationGroup);
  else {
   this.OnValidation(ValidationType.PersonalOnValueChanged);
   return this.GetIsValid();
  }
 },
 RaiseValueChangedEvent: function(){
  return this.RaiseValueChanged();
 },
 SendPostBackInternal: function(postBackArg) {
  if(ASPx.IsFunction(this.sendPostBackWithValidation))
   this.sendPostBackWithValidation(postBackArg);
  else
   this.SendPostBack(postBackArg);
 },
 SetElementToBeFocused: function() {
  if(this.IsVisible())
   invalidEditorToBeFocused = this;
 },
 GetFocusSelectAction: function() {
  return null;
 },
 SetFocus: function() {
  var inputElement = this.GetFocusableInputElement();
  if(!inputElement) return; 
  var isIE9 = ASPx.Browser.IE && ASPx.Browser.Version >= 9;
  if((ASPx.GetActiveElement() != inputElement || isIE9) && _aspxIsEditorFocusable(inputElement))
   ASPx.SetFocus(inputElement, this.GetFocusSelectAction());
 },
 SetFocusOnError: function() {
  if(invalidEditorToBeFocused == this) {
   this.SetFocus();
   invalidEditorToBeFocused = null;
  }
 },
 BeginErrorFrameUpdate: function() {
  if(!this.errorFrameUpdateLocked)
   this.errorFrameUpdateLocked = true;
 },
 EndErrorFrameUpdate: function() {
  this.errorFrameUpdateLocked = false;
  var args = this.updateErrorFrameAndFocusLastCallArgs;
  if(args) {
   this.UpdateErrorFrameAndFocus(args[0], args[1]);
   delete this.updateErrorFrameAndFocusLastCallArgs;
  }
 },
 UpdateErrorFrameAndFocus: function(setFocusOnError, ignoreVisibilityCheck, isValid) {
  if(!this.GetEnabled() || !ignoreVisibilityCheck && !this.GetVisible())
   return;
  if(this.errorFrameUpdateLocked) {
   this.updateErrorFrameAndFocusLastCallArgs = [ setFocusOnError, ignoreVisibilityCheck ];
   return;
  }
  if(this.styleDecoration)
   this.styleDecoration.Update();
  if(typeof(isValid) == "undefined")
   isValid = this.GetIsValid();
  if(isValid && this.IsErrorFrameDisplayed())
   this.ChangeErrorFrameVisibility(false);
  else {
   var editorLocatedWithinVisibleContainer = this.IsVisible();
   if(this.IsErrorFrameDisplayed()) {
    this.UpdateErrorCellContent();
    this.ChangeErrorFrameVisibility(true);
   }
   if(editorLocatedWithinVisibleContainer) {
    if(setFocusOnError && this.setFocusOnError && invalidEditorToBeFocused == null) {
     this.SetElementToBeFocused();
     this.SetFocusOnError();
    }
   }
  }
 },
 ChangeErrorFrameVisibility: function(visible) {
  var externalTable = this.GetExternalTable();
  var isStaticDisplay = this.display == ErrorFrameDisplay.Static;
  if(!isStaticDisplay && visible) {
   this.EnsureControlCellStylesLoaded();
   this.RestoreControlCellStyles();
  }
  this.ChangeErrorCellVisibility(visible, isStaticDisplay);
  if(!isStaticDisplay && !visible) {
   this.EnsureControlCellStylesLoaded();
   this.ClearControlCellStyles();
  }
  var validExternalTableClassName = isStaticDisplay ? ASPxEditExternalTableClassNames.ValidStaticTableClassName
   : ASPxEditExternalTableClassNames.ValidDynamicTableClassName;
  ASPx.ToggleClassNameToElement(externalTable, validExternalTableClassName, !visible);
  this.UpdateErrorCellParentRowVisibility();
 },
 ChangeErrorCellVisibility: function(visible, useVisibilityAttribute) {
  var errorCell = this.GetErrorCell();
  if(errorCell) {
   if(useVisibilityAttribute)
    ASPx.SetElementVisibility(errorCell, visible);
   else {
    ASPx.SetElementDisplay(errorCell, visible);
    this.raiseErrorCellVisibilityChanged();
   }
  }
 },
 raiseErrorCellVisibilityChanged: function() {
  if(!this.errorCellVisibilityChanged.IsEmpty())
   this.errorCellVisibilityChanged.FireEvent(this);
 },
 UpdateErrorCellParentRowVisibility: function() {
  var errorCell = this.GetErrorCell();
  if(!errorCell || this.display == ErrorFrameDisplay.Static)
   return;
  var displayedCellCount = 0;
  var errorCellParentRow = errorCell.parentNode;
  for(var i = 0; i < errorCellParentRow.cells.length; i++) {
   var cell = errorCellParentRow.cells[i];
   if(ASPx.GetElementDisplay(cell))
    displayedCellCount++;
  }
  ASPx.SetElementDisplay(errorCellParentRow, displayedCellCount > 0);
 },
 EnsureControlCellStylesLoaded: function() {
  if(typeof(this.controlCellStyles) == "undefined") {
   var controlCell = this.GetControlCell();
   this.controlCellStyles = {
    cssClass: controlCell.className,
    style: this.ExtractElementStyleStringIgnoringVisibilityProps(controlCell)
   };
  }
 },
 ClearControlCellStyles: function() {
  this.ClearElementStyle(this.GetControlCell());
 },
 RestoreControlCellStyles: function() {
  var controlCell = this.GetControlCell();
  controlCell.className = this.controlCellStyles.cssClass;
  controlCell.style.cssText = this.controlCellStyles.style;
 },
 ExtractElementStyleStringIgnoringVisibilityProps: function(element) {
  var savedVisibility = element.style.visibility;
  var savedDisplay = element.style.display;
  element.style.visibility = "";
  element.style.display = "";
  var styleStr = element.style.cssText;
  element.style.visibility = savedVisibility;
  element.style.display = savedDisplay;
  return styleStr;
 },
 ClearElementStyle: function(element) {
  if(!element)
   return;
  element.className = "";
  var excludedAttrNames = [
   "width", "display", "visibility",
   "position", "left", "top", "z-index",
   "margin", "margin-top", "margin-right", "margin-bottom", "margin-left",
   "float", "clear"
  ];
  var savedAttrValues = { };
  for(var i = 0; i < excludedAttrNames.length; i++) {
   var attrName = excludedAttrNames[i];
   var attrValue = element.style[attrName];
   if(attrValue)
    savedAttrValues[attrName] = attrValue;
  }
  element.style.cssText = "";
  for(var styleAttrName in savedAttrValues)
   if(savedAttrValues.hasOwnProperty(styleAttrName))
    element.style[styleAttrName] = savedAttrValues[styleAttrName];
 },
 Clear: function() {
  this.SetValue(null);
  this.SetIsValid(true);
  return true;
 },
 ResetEditorState: function() { },
 UpdateErrorCellContent: function() {
  if(this.errorDisplayMode.indexOf("t") > -1)
   this.UpdateErrorText();
  if(this.errorDisplayMode == "i")
   this.UpdateErrorImage();
 },
 UpdateErrorImage: function() {
  var image = this.GetErrorImage();
  if(ASPx.IsExistsElement(image)) {
   if(this.accessibilityCompliant) {
    ASPx.Attr.SetAttribute(image, "aria-label", this.errorText);
    var innerImg = ASPx.GetNodeByTagName(image, "IMG", 0);
    if(ASPx.IsExists(innerImg))
     innerImg.alt = this.errorText;
   }
   image.alt = this.errorText;
   image.title = this.errorText;
  } else {
   this.UpdateErrorText();
  }
 },
 UpdateErrorText: function() {
  var errorTextCell = this.GetErrorTextCell();
  if(ASPx.IsExistsElement(errorTextCell))
   errorTextCell.innerHTML = this.HtmlEncode(this.errorText);
 },
 ValidateWithPatterns: function() {
  if(this.validationPatterns.length > 0) {
   var value = this.GetValue();
   for(var i = 0; i < this.validationPatterns.length; i++) {
    var validator = this.validationPatterns[i];
    if(!validator.EvaluateIsValid(value)) {
     this.SetIsValid(false, true );
     this.SetErrorText(validator.errorText, true );
     return;
    }
   }
  }
 },
 OnSpecialKeyDown: function(evt){
  this.RaiseKeyDown(evt);
  var handler = this.keyDownHandlers[evt.keyCode];
  if(handler) 
   return this[handler](evt);
  return false;
 },
 OnSpecialKeyPress: function(evt){
  this.RaiseKeyPress(evt);
  var handler = this.keyPressHandlers[evt.keyCode];
  if(handler) 
   return this[handler](evt);
  if(ASPx.Browser.NetscapeFamily || ASPx.Browser.Opera){
   if(evt.keyCode == ASPx.Key.Enter)
    return this.enterProcessed;
  }
  return false;
 },
 OnSpecialKeyUp: function(evt){
  this.RaiseKeyUp(evt);
  var handler = this.keyUpHandlers[evt.keyCode];
  if(handler) 
   return this[handler](evt);
  return false;
 },
 OnKeyDown: function(evt) {
  if(!this.UseSpecialKeyboardHandling())
   this.RaiseKeyDown(evt);
 },
 OnKeyPress: function(evt) {
  if(!this.UseSpecialKeyboardHandling())
   this.RaiseKeyPress(evt);
 },
 OnKeyUp: function(evt) {
  if(!this.UseSpecialKeyboardHandling())
   this.RaiseKeyUp(evt);
 },
 RaiseKeyDown: function(evt){
  if(!this.KeyDown.IsEmpty()){
   var args = new ASPxClientEditKeyEventArgs(evt);
   this.KeyDown.FireEvent(this, args);
  }
 },
 RaiseKeyPress: function(evt){
  if(!this.KeyPress.IsEmpty()){
   var args = new ASPxClientEditKeyEventArgs(evt);
   this.KeyPress.FireEvent(this, args);
  }
 },
 RaiseKeyUp: function(evt){
  if(!this.KeyUp.IsEmpty()){
   var args = new ASPxClientEditKeyEventArgs(evt);
   this.KeyUp.FireEvent(this, args);
  }
 },
 RaiseFocus: function(){
  if(!this.GotFocus.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.GotFocus.FireEvent(this, args);
  }
 },
 RaiseLostFocus: function(){
  if(!this.LostFocus.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.LostFocus.FireEvent(this, args);
  }
 },
 RaiseValidation: function() {
  if(this.customValidationEnabled && !this.Validation.IsEmpty()) {
   var currentValue = this.GetValue();
   var args = new ASPxClientEditValidationEventArgs(currentValue, this.errorText, this.GetIsValid());
   this.Validation.FireEvent(this, args);
   this.SetErrorText(args.errorText, true );
   this.SetIsValid(args.isValid, true );
   if(args.value != currentValue)
    this.SetValue(args.value);
  }
 },
 RaiseValueChanged: function(){
  var processOnServer = this.isPostBackAllowed();
  if(!this.ValueChanged.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.ValueChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;  
 },
 isPostBackAllowed: function() {
  return this.autoPostBack;
 },
 AddDecorationStyle: function(key, className, cssText) {
  if(!this.styleDecoration) 
   this.RequireStyleDecoration();
  this.styleDecoration.AddStyle(key, className, cssText);
 }, 
 RequireStyleDecoration: function() {
  this.styleDecoration = this.CreateStyleDecoration();
  this.PopulateStyleDecorationPostfixes();
 },
 CreateStyleDecoration: function() {
  return new ASPx.EditorStyleDecoration(this);
 },
 PopulateStyleDecorationPostfixes: function() {
  this.styleDecoration.AddPostfix("");
 },
 LockStyleDecorationUpdate: function() {
  if(this.styleDecoration)
   this.styleDecoration.LockUpdate();
 },
 UnlockStyleDecorationUpdate: function() {
  if(this.styleDecoration)
   this.styleDecoration.UnlockUpdate();
 },
 Focus: function(){
  this.SetFocus();
 },
 GetIsValid: function() {
  var hasRequiredInputElement = !this.RequireInputElementToValidate() || ASPx.IsExistsElement(this.GetInputElement());
  if(!hasRequiredInputElement || this.IsErrorFrameDisplayed() && !ASPx.IsExistsElement(this.GetElementRequiredForErrorFrame()))
   return true;
  return this.isValid;
 },
 RequireInputElementToValidate: function() {
  return true;
 },
 IsErrorFrameDisplayed: function() {
  return this.display !== ErrorFrameDisplay.None;
 },
 GetErrorText: function(){
  return this.errorText;
 },
 SetIsValid: function(isValid, validating){
  if(this.customValidationEnabled && this.isValid != isValid) {
   this.isValid = isValid;
   this.UpdateErrorFrameAndFocus(false );
   this.UpdateClientValidationState();
   if(!validating)
    this.UpdateValidationSummaries(ValidationType.PersonalViaScript);
  }
 },
 SetErrorText: function(errorText, validating){
  if(this.customValidationEnabled && this.errorText != errorText) {
   this.errorText = errorText;
   this.UpdateErrorFrameAndFocus(false );
   this.UpdateClientValidationState();
   if(!validating)
    this.UpdateValidationSummaries(ValidationType.PersonalViaScript);
  }
 },
 Validate: function(){
  this.ParseValue();
  this.OnValidation(ValidationType.PersonalViaScript);
 },
 GetModifyEvent: function() {
  return this.ValueChanged;
 },
 EnsureRequiredNativeAttributesExists: function() { }
});
ASPx.Ident.scripts.ASPxClientEdit = true;
ASPx.focusedEditorName = "";
ASPx.GetFocusedEditor = function() {
 var focusedEditor = ASPx.GetControlCollection().Get(ASPx.focusedEditorName);
 if(focusedEditor && !focusedEditor.focused){
  ASPx.SetFocusedEditor(null);
  focusedEditor = null;
 }
 return focusedEditor;
};
ASPx.SetFocusedEditor = function(editor) {
 ASPx.focusedEditorName = editor ? editor.name : "";
};
ASPx.FindAssociatedLabelElements = function(editor) {
 var assocciatedLabels = [];
 var inputElement = editor.GetInputElement();
 if(!ASPx.IsExists(inputElement) || !inputElement.id) 
  return assocciatedLabels;
 var labels = ASPx.GetNodesByTagName(document, "LABEL");
 for(var i = 0; i < labels.length; i++) {
  if(!!labels[i].htmlFor && labels[i].htmlFor === inputElement.id)
   assocciatedLabels.push(labels[i]);
 }
 return assocciatedLabels;
};
var DisableAccessibilityExplanatoryTextManager = ASPx.CreateClass(null, {
 constructor: function(editor) {
  this.editor = editor;
 },
 GetAdditionalTextRowId: function() {
  return this.editor.name + EditElementSuffix.AccessibilityAdditionalTextRow;
 },
 GetErrorTextElement: function () {
  return !!this.editor.GetErrorTextCell() ? this.editor.GetErrorTextCell() : this.editor.GetErrorImage();
 },
 GetTextElement: function() { return null; },
 SetCaptionAssociating: function() { },
 UpdateText: function() { },
 UpdateValidationState: function(validationType) { },
 ToggleErrorAlert: function() { },
 SetOrRemoveText: function(accessibilityElements, textElement, setText, isLabel, isFirst) { }
});
var EditAccessibilityExplanatoryTextManager = ASPx.CreateClass(DisableAccessibilityExplanatoryTextManager, {
 constructor: function(editor) {
  this.constructor.prototype.constructor.call(this, editor);
  this.invisibleRowCssClassName = "dxAIR";
 },
 GetTextElement: function() {
  var mainElement = this.editor.GetMainElement();
  if(!mainElement) return null;
  var explanatoryText = "";
  var explanatoryTextElement = null;
  if(!!this.editor.nullText)
   explanatoryText = this.editor.nullText;
  else if(!!this.editor.helpTextObj)
   explanatoryTextElement = this.editor.helpTextObj.helpTextElement;
  else if(!!mainElement.title)
   explanatoryText = mainElement.title;
  if(explanatoryText && mainElement.tagName == "TABLE") {
   var assistantElement = this.editor.GetAccessibilityFirstActiveElement();
   if(assistantElement)
    ASPx.Attr.Aria.AppendLabel(assistantElement, explanatoryText, true);
  }
  return explanatoryTextElement;
 },
 SetCaptionAssociating: function() {
  var captionCell = this.editor.GetCaptionCell();
  if(!captionCell || captionCell.childNodes[0].tagName == "LABEL") return;
  var labelElement = captionCell.childNodes[0];
  ASPx.EditAccessibilityExplanatoryTextManager.SetLabelAssociating(this.editor, this.editor.GetAccessibilityFirstActiveElement(), labelElement);
 },
 UpdateText: function() {
  var additionalTextElement = this.GetTextElement();
  if(ASPx.IsExists(additionalTextElement)) {
   var pronounceElement = this.editor.GetAccessibilityFirstActiveElement();
   var hasAnyLabel = !!ASPx.Attr.GetAttribute(pronounceElement, "aria-label") || 
    !!ASPx.Attr.GetAttribute(pronounceElement, "aria-labelledby") ||
    ASPx.FindAssociatedLabelElements(this.editor).length > 0;
   this.SetOrRemoveText([pronounceElement], additionalTextElement, true, !hasAnyLabel, false);
  }
 },
 UpdateValidationState: function(validationType) {
  if(validationType == ValidationType.PersonalOnValueChanged && this.editor.accessibilityHelper) return;
  var accessibilityElements = this.editor.GetAccessibilityActiveElements();
  var errorTextElement = this.GetErrorTextElement();
  this.SetOrRemoveText(accessibilityElements, errorTextElement, !this.editor.isValid, false, true);
  if(accessibilityElements.length > 0 && !!errorTextElement) {
   for(var i = 0; i < accessibilityElements.length; i++) {
    if(!ASPx.IsExists(accessibilityElements[i])) continue;
    ASPx.Attr.SetOrRemoveAttribute(accessibilityElements[i], "aria-invalid", !this.editor.isValid);
   }
  }
 },
 ToggleErrorAlert: function() {
  var errorTextElement = this.GetErrorTextElement();
  ASPx.SetElementDisplay(errorTextElement, false);
  ASPx.Attr.SetAttribute(errorTextElement, 'role', 'alert');
  ASPx.SetElementDisplay(errorTextElement, true);
  setTimeout(function() { ASPx.Attr.RemoveAttribute(errorTextElement, 'role'); }, 500);
 },
 SetOrRemoveText: function(accessibilityElements, textElement, setText, isLabel, isFirst) {
  var idsRefAttribute = isLabel ? ASPx.Attr.Aria.labelled : ASPx.Attr.Aria.described;
  if(!textElement) return;
  var textId = !!textElement.id ? textElement.id : textElement.parentNode.id;
  for(var i = 0; i < accessibilityElements.length; i++) {
   if(!accessibilityElements[i]) continue;
   var descRefString = ASPx.Attr.GetAttribute(accessibilityElements[i], idsRefAttribute);
   var descRefIds = !!descRefString ? descRefString.split(" ") : [ ];
   var descIndex = descRefIds.indexOf(textId);
   if(setText && descIndex == -1) {
    if(isFirst)
     descRefIds.unshift(textId);
    else
     descRefIds.push(textId);
   }
   else if(!setText && descIndex > -1)
    descRefIds.splice(descIndex, 1);
   ASPx.Attr.SetOrRemoveAttribute(accessibilityElements[i], idsRefAttribute, descRefIds.join(" "));
  }
 }
});
ASPx.DisableAccessibilityExplanatoryTextManager = DisableAccessibilityExplanatoryTextManager;
ASPx.EditAccessibilityExplanatoryTextManager = EditAccessibilityExplanatoryTextManager;
ASPx.EditAccessibilityExplanatoryTextManager.SetLabelAssociating = function(editor, activeElement, labelElement) {
 var clickHandler = function(evt) {
  if(editor && editor.OnAssociatedLabelClick)
   editor.OnAssociatedLabelClick(evt);
  else
   activeElement.click();
 };
 ASPx.Evt.AttachEventToElement(labelElement, "click", clickHandler);
 if(!!editor) {
  var hasAriaLabel = !!ASPx.Attr.GetAttribute(activeElement, "aria-label");
  editor.ariaExplanatoryTextManager.SetOrRemoveText([activeElement], labelElement, true, !hasAriaLabel, true);
 }
};
ASPxClientEdit.ClearEditorsInContainer = function(container, validationGroup, clearInvisibleEditors) {
 invalidEditorToBeFocused = null;
 ASPx.ProcessEditorsInContainer(container, ASPx.ClearProcessingProc, ASPx.ClearChoiceCondition, validationGroup, clearInvisibleEditors, true );
 ASPxClientEdit.ClearExternalControlsInContainer(container, validationGroup, clearInvisibleEditors, true );
};
ASPxClientEdit.ClearEditorsInContainerById = function(containerId, validationGroup, clearInvisibleEditors) {
 var container = document.getElementById(containerId);
 this.ClearEditorsInContainer(container, validationGroup, clearInvisibleEditors);
};
ASPxClientEdit.ClearGroup = function(validationGroup, clearInvisibleEditors) {
 return this.ClearEditorsInContainer(null, validationGroup, clearInvisibleEditors);
};
ASPxClientEdit.ValidateEditorsInContainer = function(container, validationGroup, validateInvisibleEditors) {
 var summaryCollection;
 if(ASPx.Ident.scripts.ASPxClientValidationSummary) {
  summaryCollection = ASPx.GetClientValidationSummaryCollection();
  summaryCollection.AllowNewErrorsAccepting(validationGroup);
 }
 var validationResult = ASPx.ProcessEditorsInContainer(container, ASPx.ValidateProcessingProc, _aspxValidateChoiceCondition, validationGroup, validateInvisibleEditors,
  false );
 validationResult.isValid = ASPxClientEdit.ValidateExternalControlsInContainer(container, validationGroup, validateInvisibleEditors,
  false ) && validationResult.isValid;
 if(typeof(validateInvisibleEditors) == "undefined")
  validateInvisibleEditors = false;
 if(typeof(validationGroup) == "undefined")
  validationGroup = null;    
 validationResult.isValid = ASPx.GetControlCollection().RaiseValidationCompleted(container, validationGroup,
 validateInvisibleEditors, validationResult.isValid, validationResult.firstInvalid, validationResult.firstVisibleInvalid);
 if(summaryCollection)
  summaryCollection.ForbidNewErrorsAccepting(validationGroup);
 if(!validationResult.isValid && !!validationResult.firstVisibleInvalid && validationResult.firstVisibleInvalid.accessibilityCompliant && !validationResult.firstVisibleInvalid.setFocusOnError) {
  var accessInvalidControl = validationResult.firstVisibleInvalid;
  if(!summaryCollection && !accessInvalidControl.focused) {
   var beforeDelayActiveElement = ASPx.GetActiveElement();
   setTimeout(function() {
    var currentActiveElement = ASPx.GetActiveElement();
    if(accessInvalidControl.focused || (currentActiveElement != beforeDelayActiveElement && ASPx.Attr.IsExistsAttribute(currentActiveElement, 'role')))
     return;
    accessInvalidControl.ariaExplanatoryTextManager.ToggleErrorAlert();
   }, 500);    
  }
 }
 return validationResult.isValid;
};
ASPxClientEdit.ValidateEditorsInContainerById = function(containerId, validationGroup, validateInvisibleEditors) {
 var container = document.getElementById(containerId);
 return this.ValidateEditorsInContainer(container, validationGroup, validateInvisibleEditors);
};
ASPxClientEdit.ValidateGroup = function(validationGroup, validateInvisibleEditors) {
 return this.ValidateEditorsInContainer(null, validationGroup, validateInvisibleEditors);
};
ASPxClientEdit.AreEditorsValid = function(containerOrContainerId, validationGroup, checkInvisibleEditors) {
 var container = typeof(containerOrContainerId) == "string" ? document.getElementById(containerOrContainerId) : containerOrContainerId;
 var checkResult = ASPx.ProcessEditorsInContainer(container, ASPx.EditorsValidProcessingProc, _aspxEditorsValidChoiceCondition, validationGroup,
  checkInvisibleEditors, false );
 checkResult.isValid = ASPxClientEdit.AreExternalControlsValidInContainer(containerOrContainerId, validationGroup,
  checkInvisibleEditors, false ) && checkResult.isValid;
 return checkResult.isValid;
};
ASPxClientEdit.AreExternalControlsValidInContainer = function(containerId, validationGroup, validateInvisibleEditors, processDisabledEditors) {
 if(ASPx.Ident.scripts.ASPxClientHtmlEditor)
  return ASPxClientHtmlEditor.AreEditorsValidInContainer(containerId, validationGroup, validateInvisibleEditors, processDisabledEditors);
 return true;
};
ASPxClientEdit.ClearExternalControlsInContainer = function(containerId, validationGroup, validateInvisibleEditors, processDisabledEditors) {
 if(ASPx.Ident.scripts.ASPxClientHtmlEditor)
  return ASPxClientHtmlEditor.ClearEditorsInContainer(containerId, validationGroup, validateInvisibleEditors, processDisabledEditors);
 return true;
};
ASPxClientEdit.ValidateExternalControlsInContainer = function(containerId, validationGroup, validateInvisibleEditors, processDisabledEditors) {
 if(ASPx.Ident.scripts.ASPxClientHtmlEditor)
  return ASPxClientHtmlEditor.ValidateEditorsInContainer(containerId, validationGroup, validateInvisibleEditors, processDisabledEditors);
 return true;
};
ASPxClientEdit.AttachEditorModificationListener = function(handler, predicate) {
 var processAction = function(event) { event.AddHandler(handler); };
 ASPxClientEdit.ProcessEditorModificationListener(handler, processAction, predicate);
};
ASPxClientEdit.DetachEditorModificationListener = function(handler, predicate) {
 var processAction = function(event) { event.RemoveHandler(handler); };
 ASPxClientEdit.ProcessEditorModificationListener(handler, processAction, predicate);
};
ASPxClientEdit.ProcessEditorModificationListener = function(handler, action, predicate) {
 ASPx.GetControlCollection().ForEachControl(function(control) {
  if(control.GetModifyEvent && predicate(control)) {
   if(control.isNative)
    control.EnsureRequiredNativeAttributesExists();
   action(control.GetModifyEvent());
  }
 });
};
var ASPxClientEditKeyEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(htmlEvent) {
  this.constructor.prototype.constructor.call(this);
  this.htmlEvent = htmlEvent;
 }
});
var ASPxClientEditValidationEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(value, errorText, isValid) {
  this.constructor.prototype.constructor.call(this);
  this.errorText = errorText;
  this.isValid = isValid;
  this.value = value;
 }
});
ASPx.ProcessEditorsInContainer = function(container, processingProc, choiceCondition, validationGroup, processInvisibleEditors, processDisabledEditors) {
 var allProcessedSuccessfull = true;
 var firstInvalid = null;
 var firstVisibleInvalid = null;
 var invalidEditorToBeFocused = null;
 ASPx.GetControlCollection().ForEachControl(function(control) {
  var canValidate = ASPx.CanValidateControl(control, container, processingProc, choiceCondition, validationGroup, processInvisibleEditors, processDisabledEditors);
  if(!canValidate) return;
  var isSuccess = processingProc(control);
  if(!isSuccess) {
   allProcessedSuccessfull = false;
   if(firstInvalid == null)
    firstInvalid = control;
   var isVisible = control.IsVisible();
   if(isVisible && firstVisibleInvalid == null)
    firstVisibleInvalid = control;
   if(control.setFocusOnError && invalidEditorToBeFocused == null && isVisible)
    invalidEditorToBeFocused = control;
  }
 }, this);
 if(invalidEditorToBeFocused != null)
  invalidEditorToBeFocused.SetFocus();
 return new ASPxValidationResult(allProcessedSuccessfull, firstInvalid, firstVisibleInvalid);
};
ASPx.CanValidateControl = function(control, container, processingProc, choiceCondition, validationGroup, processInvisibleEditors, processDisabledEditors) {
 var needToProcessRatingControl = window.ASPxClientRatingControl && (control instanceof ASPxClientRatingControl) && processingProc === ASPx.ClearProcessingProc;
 var mainElement = control.GetMainElement(); 
 if(!ASPx.Ident.IsASPxClientEdit(control) && !needToProcessRatingControl)
  return false;
 if(ASPx.Ident.isDialogInvisibleControl(control) || ASPx.Ident.isBatchEditUnusedEditor(control))
  return false; 
 if(!processDisabledEditors && !control.GetEnabled())
  return false;
 if(!mainElement || (container && !ASPx.GetIsParent(container, mainElement)))
  return false;
 if(!processInvisibleEditors && !control.IsVisible())
  return false;
 if(choiceCondition && !choiceCondition(control, validationGroup))
  return false;
 return true;
};
var ASPxValidationResult = ASPx.CreateClass(null, {
 constructor: function(isValid, firstInvalid, firstVisibleInvalid) {
  this.isValid = isValid;
  this.firstInvalid = firstInvalid;
  this.firstVisibleInvalid = firstVisibleInvalid;
 }
});
ASPx.ClearChoiceCondition = function(edit, validationGroup) {
 return !ASPx.IsExists(validationGroup) || (edit.validationGroup == validationGroup);
};
function _aspxValidateChoiceCondition(edit, validationGroup) {
 return ASPx.ClearChoiceCondition(edit, validationGroup) && edit.customValidationEnabled;
}
function _aspxEditorsValidChoiceCondition(edit, validationGroup) {
 return _aspxValidateChoiceCondition(edit, validationGroup);
}
function wrapLostFocusHandler(handler) {
 if(ASPx.Browser.Edge) {
  return function(name) {
   var edit = ASPx.GetControlCollection().Get(name);
   if(edit && !ASPx.IsElementVisible(edit.GetMainElement()))
    setTimeout(handler, 0, name);
   else
    handler(name);
  };
 }
 return handler;
}
ASPx.EGotFocus = function(name) {
 var edit = ASPx.GetControlCollection().Get(name);
 if(edit) {
  if(edit.isInitialized) {
   if(ASPx.Browser.VirtualKeyboardSupported && !edit.ownerListBox)
    ASPx.VirtualKeyboardUI.processEditorGotFocus(edit);
   else
    edit.OnFocus();
  }
  else {
   var inputElement = edit.GetFocusableInputElement();
   if(inputElement && inputElement === document.activeElement) {
    if(ASPx.Browser.Firefox)
     window.setTimeout(function() { document.activeElement.blur(); }, 0);
    else
     document.activeElement.blur();
   }
  }
 }
};
ASPx.ELostFocusCore = function(name) {
 var edit = ASPx.GetControlCollection().Get(name);
 if(ASPx.Browser.VirtualKeyboardSupported && (!edit || !edit.ownerListBox)) {
  var supressLostFocus = ASPx.VirtualKeyboardUI.isInputNativeBluring();
  if(!supressLostFocus)
   ASPx.VirtualKeyboardUI.resetFocusedEditorCore();
  else 
   return;
 }
 if(edit && edit.focused) {
  if(edit.UseDelayedSpecialFocus()) {
   if(edit.specialFocusTimer === -1)
    edit.specialFocusTimer = ASPx.Timer.SetControlBoundTimeout(function() { edit.OnLostFocus(); }, edit, 30);
  }
  else {
   edit.OnLostFocus();
  }
 }
};
ASPx.ELostFocus = wrapLostFocusHandler(ASPx.ELostFocusCore);
ASPx.EValueChanged = function(name) {
 var edit = ASPx.GetControlCollection().Get(name);
 if(edit != null)
  edit.OnValueChanged();
};
ASPx.VirtualKeyboardUI = (function() {
 var result = {
  focusedEditor: null,
  inputNativeFocusLocked: false,
  elementBelongsToEditor: function(element) {
   if(!element) return false;
   var isBelongsToEditor = false;
   ASPx.GetControlCollection().ForEachControl(function(control) {
    if(ASPx.Ident.IsASPxClientEdit(control) && control.IsEditorElement(element)) {
     isBelongsToEditor = true;
     return true;
    }
   }, this);
   return isBelongsToEditor;
  },
  elementBelongsToFocusedEditor: function (element) {
   return this.focusedEditor && this.focusedEditor.IsEditorElement(element);
  },
  onTouchStart: function (evt) {
   if (!ASPx.Browser.VirtualKeyboardSupported || this.isGooglePlaceAutocompleteElementTap(evt)) return;
   this.setInputNativeFocusLocked(false);
   if(this.focusedEditor)
    this.focusedEditor.onVirtualKeyboardUITouchStart(evt);
  },
  onTouchEnd: function(evt) {
   if(ASPx.TouchUIHelper.pointerEnabled) {  
    if(!window.testingTouchMode) { 
     if(evt.pointerType !== ASPx.TouchUIHelper.pointerType.Touch)
      return;
    }
    this.processFocusEditorControl(evt);
   } else
    ASPx.TouchUIHelper.handleFastTapIfRequired(evt,
     function() {
      this.processFocusEditorControl(evt);
     }.aspxBind(this), false);
  },
  processFocusEditorControl: function(evt) {
   var evtSource = ASPx.Evt.GetEventSource(evt);
   var focusedEditorIsTimeEdit = this.focusedEditor && (ASPx.Ident.IsASPxClientTimeEdit && ASPx.Ident.IsASPxClientTimeEdit(this.focusedEditor));
   var focusedTimeEditBelongsToDateEdit = focusedEditorIsTimeEdit && this.focusedEditor.OwnerDateEdit && this.focusedEditor.OwnerDateEdit.GetShowTimeSection();
   if(focusedTimeEditBelongsToDateEdit) {
    this.focusedEditor.OwnerDateEdit.ForceRefocusTimeSectionTimeEdit(evtSource);
    return;
   }
   var elementWithNativeFocus = ASPx.GetActiveElement();
   var someEditorInputIsFocused = this.elementBelongsToEditor(elementWithNativeFocus);
   var touchKeyboardIsVisible = someEditorInputIsFocused;
   var tapOutsideEditorAndInputs = !this.elementBelongsToEditor(evtSource) && !ASPx.Ident.IsFocusableElementRegardlessTabIndex(evtSource);
   var blurToHideTouchKeyboard = touchKeyboardIsVisible && tapOutsideEditorAndInputs;
   if(blurToHideTouchKeyboard) {
    elementWithNativeFocus.blur();
    return;
   }
   var tapOutsideFocusedEditor = this.focusedEditor && !this.elementBelongsToFocusedEditor(evtSource);
   if(tapOutsideFocusedEditor) {
    if(!this.elementBelongsToFocusedEditor(elementWithNativeFocus))
     this.resetFocusedEditor();
   }
  },
  focusEditor: function(edit) {
   if(!edit.focused) {
    this.setInputNativeFocusLocked(true);
    this.setFocusToEditor(edit);
   } else {
    edit.ForceRefocusEditor();
   }
  },
  setFocusToEditor: function(edit) {
   if(ASPx.Browser.MacOSMobilePlatform) {
    var timeoutDuration = ASPx.Browser.Chrome ? 250 : 30;
    window.setTimeout(function() {
     edit.SetFocus();
    }, timeoutDuration);
   } else {
    edit.SetFocus();
   }
  },
  processEditorGotFocus: function(edit) {
   if(this.focusedEditor === edit) {
    this.focusedEditor.UnlockFocusEvents();
    if(this.focusedEditor.EnsureClearButtonVisibility)
     this.focusedEditor.EnsureClearButtonVisibility();
   }
   else {
    this.setFocusedEditor(edit);
    if(this.getInputNativeFocusLocked())
     edit.BlurInputElement();
   }
  },
  setFocusedEditor: function(edit) {
   this.resetFocusedEditor();
   this.focusedEditor = edit;
   this.focusedEditor.Disposed.AddHandler(this.onFocusedEditorDisposed);
   ASPx.SetFocusedEditor(this.focusedEditor);
   this.focusedEditor.OnFocus();
  },
  isInputNativeBluring: function() {
   return this.focusedEditor && this.getInputNativeFocusLocked();
  },
  setInputNativeFocusLocked: function(locked) {
   this.inputNativeFocusLocked = locked;
  },
  getInputNativeFocusLocked: function() {
   return this.inputNativeFocusLocked;
  },
  resetFocusedEditor: function() {
   if(this.focusedEditor) {
    var curEditorName = this.focusedEditor.name;
    var focusedEditorInputElementExists = this.focusedEditor.GetInputElement();
    this.resetFocusedEditorCore();
    if(focusedEditorInputElementExists)
     ASPx.ELostFocusCore(curEditorName);
   }
  },
  resetFocusedEditorCore: function() { 
   if(this.focusedEditor)
    this.focusedEditor.Disposed.RemoveHandler(this.onFocusedEditorDisposed);
   this.focusedEditor = null;
  },
  getFocusedEditor: function() {
   return this.focusedEditor;
  },
  focusableInputElementIsActive: function(edit) {
   var inputElement = edit.GetFocusableInputElement();
   return !!inputElement ? ASPx.GetActiveElement() === inputElement : false;
  },
  isGooglePlaceAutocompleteElementTap: function(evt) {
   var googlePlaceAutocompleteContainer = ASPx.GetNodeByClassName(document.body, "pac-container", 0);
   if(!googlePlaceAutocompleteContainer)
    return false;
   return ASPx.GetParentByClassName(ASPx.Evt.GetEventSource(evt), "pac-container") != null;
  }
 };
 result.onFocusedEditorDisposed = function() {
  this.resetFocusedEditor();
 }.bind(result);
 return result;
})();
if(ASPx.Browser.VirtualKeyboardSupported) {
 var touchStartEventName = ASPx.TouchUIHelper.pointerEnabled ? ASPx.TouchUIHelper.pointerDownEventName : 'touchstart';
 var touchEndEventName = ASPx.TouchUIHelper.pointerEnabled ? ASPx.TouchUIHelper.pointerUpEventName : 'touchend';
 ASPx.Evt.AttachEventToDocument(touchStartEventName, function(evt) { ASPx.VirtualKeyboardUI.onTouchStart(evt); });
 ASPx.Evt.AttachEventToDocument(touchEndEventName, function(evt) { ASPx.VirtualKeyboardUI.onTouchEnd(evt); });
}
ASPx.Evt.AttachEventToDocument("mousedown", function(evt) {
 var editor = ASPx.GetFocusedEditor();
 if(!editor) 
  return;
 var evtSource = ASPx.Evt.GetEventSource(evt);
 if(editor.IsClearButtonElement(evtSource))
  return;
 if(editor.OwnerDateEdit && editor.OwnerDateEdit.GetShowTimeSection()) {
  editor.OwnerDateEdit.ForceRefocusTimeSectionTimeEdit(evtSource);
  return;
 }
 if(editor.ownerListBox && editor.ownerListBox.IsEditorElement(evtSource) && !editor.IsEditorElement(evtSource)) {
  editor.ownerListBox.ForceRefocusEditor(evt);
  ASPx.SetFocusedEditor(editor.ownerListBox);
  return;
 }
 if(editor.IsEditorElement(evtSource) && !editor.IsElementBelongToInputElement(evtSource))
  editor.ForceRefocusEditor(evt);
});
ASPx.Evt.AttachEventToDocument(ASPx.Evt.GetMouseWheelEventName(), function(evt) {
 var editor = ASPx.GetFocusedEditor();
 if(editor != null && ASPx.IsExistsElement(editor.GetMainElement()) && editor.focused && editor.receiveGlobalMouseWheel)
  editor.OnMouseWheel(evt);
});
ASPx.KBSIKeyDown = function(name, evt){
 var control = ASPx.GetControlCollection().Get(name);
 if(control != null){
  var isProcessed = control.OnSpecialKeyDown(evt);
  if(isProcessed)
   return ASPx.Evt.PreventEventAndBubble(evt);
 }
};
ASPx.KBSIKeyPress = function(name, evt){
 var control = ASPx.GetControlCollection().Get(name);
 if(control != null){
  var isProcessed = control.OnSpecialKeyPress(evt);
  if(isProcessed)
   return ASPx.Evt.PreventEventAndBubble(evt);
 }
};
ASPx.KBSIKeyUp = function(name, evt){
 var control = ASPx.GetControlCollection().Get(name);
 if(control != null){
  var isProcessed = control.OnSpecialKeyUp(evt);
  if(isProcessed)
   return ASPx.Evt.PreventEventAndBubble(evt);
 }
};
ASPx.ClearProcessingProc = function(edit) {
 return edit.Clear();
};
ASPx.ValidateProcessingProc = function(edit) {
 edit.OnValidation(ValidationType.MassValidation);
 return edit.GetIsValid();
};
ASPx.EditorsValidProcessingProc = function(edit) {
 return edit.GetIsValid();
};
var CheckEditElementHelper = ASPx.CreateClass(ASPx.CheckableElementHelper, {
 AttachToMainElement: function(internalCheckBox) {
  ASPx.CheckableElementHelper.prototype.AttachToMainElement.call(this, internalCheckBox);
  this.AttachToLabelElement(this.GetLabelElement(internalCheckBox.container), internalCheckBox);
 },
 AttachToLabelElement: function(labelElement, internalCheckBox) {
  var _this = this;
  if(labelElement) {
   ASPx.Evt.AttachEventToElement(labelElement, "click", 
    function (evt) { 
     _this.InvokeClick(internalCheckBox, evt);
    }
   );
   ASPx.Evt.AttachEventToElement(labelElement, "mousedown",
    function (evt) {
     internalCheckBox.Refocus();
    }
   );
  }
 },
 GetLabelElement: function(container) {
  var labelElement = ASPx.GetNodeByTagName(container, "LABEL", 0);
  if(!labelElement) {
   var labelCell = ASPx.GetNodeByClassName(container, "dxichTextCellSys", 0);
   labelElement = ASPx.GetNodeByTagName(labelCell, "SPAN", 0);
  }
  return labelElement;
 }
});
CheckEditElementHelper.Instance = new CheckEditElementHelper();
var CalendarSharedParameters = ASPx.CreateClass(null, {
 updateCalendarCallbackCommand: "UPDATE",
 constructor: function() {
  this.minDate = null;
  this.maxDate = null;
  this.disabledDates = [];
  this.calendarCustomDraw = false;
  this.hasCustomDisabledDatesViaCallback = false;
  this.dateRangeMode = false;
  this.currentDateEdit = null;
  this.DaysSelectingOnMouseOver = new ASPxClientEvent();
  this.VisibleDaysMouseOut = new ASPxClientEvent();
  this.CalendarSelectionChangedInternal = new ASPxClientEvent();
 },
 Assign: function(source) {
  this.minDate = source.minDate ? source.minDate : null;
  this.maxDate = source.maxDate ? source.maxDate : null;
  this.calendarCustomDraw = source.calendarCustomDraw ? source.calendarCustomDraw : false;
  this.hasCustomDisabledDatesViaCallback = source.hasCustomDisabledDatesViaCallback ? source.hasCustomDisabledDatesViaCallback : false;
  this.disabledDates = source.disabledDates ? source.disabledDates : [];
  this.currentDateEdit = source.currentDateEdit ? source.currentDateEdit : null;
 },
 GetUpdateCallbackParameters: function() {
  var callbackArgs = this.GetCallbackArgs();
  callbackArgs = this.FormatCallbackArg(this.updateCalendarCallbackCommand, callbackArgs);
  return callbackArgs;
 },
 GetCallbackArgs: function() {
  var args = {};
  if(this.minDate)
   args.clientMinDate = ASPx.DateUtils.GetInvariantDateString(this.minDate);
  if(this.maxDate)
   args.clientMaxDate = ASPx.DateUtils.GetInvariantDateString(this.maxDate);
  if(args.clientMinDate || args.clientMaxDate) {
   var jsonArgs = JSON.stringify(args);
   return ASPx.Str.EncodeHtml(jsonArgs);
  }
  return null;
 },
 FormatCallbackArg: function(prefix, arg) {
  if(!arg) return prefix;
  return [prefix, '|', arg.length, ';', arg, ';'].join('');
 }
});
ASPx.CalendarSharedParameters = CalendarSharedParameters;
ASPx.ValidationType = ValidationType;
ASPx.ErrorFrameDisplay = ErrorFrameDisplay;
ASPx.EditElementSuffix = EditElementSuffix;
ASPx.ValidationPattern = ValidationPattern;
ASPx.RequiredFieldValidationPattern = RequiredFieldValidationPattern;
ASPx.RegularExpressionValidationPattern = RegularExpressionValidationPattern;
ASPx.CheckEditElementHelper = CheckEditElementHelper;
ASPx.IsEditorFocusable = _aspxIsEditorFocusable;
window.ASPxClientEditBase = ASPxClientEditBase;
window.ASPxClientEdit = ASPxClientEdit;
window.ASPxClientEditKeyEventArgs = ASPxClientEditKeyEventArgs;
window.ASPxClientEditValidationEventArgs = ASPxClientEditValidationEventArgs;
})();

(function() {
ASPx.TEInputSuffix = "_I";
ASPx.PasteCheckInterval = 50;
ASPx.CheckUserInputInterval = 10;
ASPx.TEHelpTextElementSuffix = "_HTE";
ASPx.TempHiddenInputSuffix = "_THI";
var passwordInputClonedSuffix = "_CLND";
var CHROME_AUTOFILL_SELECTOR = ":-webkit-autofill";
var BrowserHelper = {
 SAFARI_SYSTEM_CLASS_NAME: "dxeSafariSys",
 MOBILE_SAFARI_SYSTEM_CLASS_NAME: "dxeIPadSys",
 GetBrowserSpecificSystemClassName: function() {
  if(ASPx.Browser.Safari)
   return ASPx.Browser.MacOSMobilePlatform ? this.MOBILE_SAFARI_SYSTEM_CLASS_NAME : this.SAFARI_SYSTEM_CLASS_NAME;
  return "";
 }
};
var focusedNullTextClassName = "dxeFNTextSys";
var NullTextDisplayMode = {
 Unfocused: "Unfocused",
 UnfocusedAndFocused: "UnfocusedAndFocused"
};
ASPx.NullTextDisplayMode = NullTextDisplayMode;
var ASPxClientTextEdit = ASPx.CreateClass(ASPxClientEdit, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);      
  this.isASPxClientTextEdit = true;
  this.nullText = "";
  this.nullTextDisplayMode = NullTextDisplayMode.Unfocused;
  this.nullTextOnFocusCssText = "";
  this.focusedNullTextTimerID = -1;
  this.escCount = 0;
  this.raiseValueChangedOnEnter = true;
  this.autoResizeWithContainer = false;
  this.lastChangedValue = null;
  this.autoCompleteAttribute = null;
  this.isTextSelectionOnClickEnabled = false;
  this.trySelectInputTextOnClick = true;
  this.passwordNullTextIntervalID = -1;
  this.nullTextInputElement = null;
  this.helpText = "";
  this.helpTextObj = null;  
  this.helpTextStyle = [];
  this.externalTableStyle = [];
  this.helpTextPosition = ASPx.Position.Right;
  this.helpTextMargins = null;
  this.helpTextHAlign = ASPxClientTextEditHelpTextHAlign.Left;
  this.helpTextVAlign = ASPxClientTextEditHelpTextVAlign.Top;
  this.enableHelpTextPopupAnimation = true;
  this.helpTextDisplayMode = ASPxClientTextEditHelpTextDisplayMode.Inline;
  this.maskInfo = null;  
  this.maskValueBeforeUserInput = "";
  this.maskPasteTimerID = -1;
  this.maskPasteLock = false;    
  this.maskPasteCounter = 0;
  this.maskTextBeforePaste = "";    
  this.maskHintHtml = "";
  this.maskHintTimerID = -1;
  this.errorCellPosition = ASPx.Position.Right;
  this.inlineInitializeInputValue = null;
  this.initializeInputValue = null;
  this.displayFormat = null;
  this.TextChanged = new ASPxClientEvent();
  this.UserInput = new ASPxClientEvent();
  this.userInputEventTimerID = -1;
 },
 AddDefaultReadOnlyStateControllerItem: function(cssClass, mainElementId) {
  ASPx.AddReadOnlyItems(mainElementId, [[[cssClass], [''], ['', 'I']]]);
 },
 AddDefaultDisabledStateControllerItem: function(cssClass, mainElementId) {
  ASPx.AddDisabledItems(mainElementId, [[[cssClass], [''], ['', 'I']]]);
 },
 SetData: function(data){
  ASPxClientEdit.prototype.SetData.call(this, data);
  if(data.maskInfo) {
   var maskProperties = data.maskInfo.properties;
   var useInvariantCultureDecimalSymbol = maskProperties && maskProperties.useInvariantCultureDecimalSymbol || false;
   this.maskInfo = ASPx.MaskInfo.Create(data.maskInfo.maskText, data.maskInfo.dateTimeOnly, data.maskInfo.allowEscapingInEnums, useInvariantCultureDecimalSymbol);
   this.SetProperties(data.maskInfo.properties, this.maskInfo);
  }
 },
 InlineInitialize: function() {
  this.SaveInputValue(true);
  ASPxClientEdit.prototype.InlineInitialize.call(this);
  if(this.maskInfo != null)
   this.InitMask();
  this.ApplyBrowserSpecificClassName();
  this.helpTextInitialize();
  if(ASPx.Browser.IE && ASPx.Browser.Version >= 10 && this.nullText != "")
   this.addIEXButtonEventHandler();
 },
 Initialize: function(){
  this.SaveInputValue(false);
  this.SaveChangedValue();
  ASPxClientEdit.prototype.Initialize.call(this);
  this.CorrectInputMaxLength();
  this.SubscribeToIeDropEvent();
  if(ASPx.Browser.WebKitFamily)  
   this.CorrectMainElementWhiteSpaceStyle();
  this.InitializeTextDecoration();
  this.InitializeAutocompleteAttribute();
  if(this.IsValueRestoredByBrowser())
   this.SynchronizeRestoredValue();
 },
 InitializeEvents: function() {
  ASPxClientEdit.prototype.InitializeEvents.call(this);
  ASPx.Evt.AttachEventToElement(this.GetInputElement(), "keydown", this.OnKeyDown.aspxBind(this));
  ASPx.Evt.AttachEventToElement(this.GetInputElement(), "keyup", this.OnKeyUp.aspxBind(this));
  ASPx.Evt.AttachEventToElement(this.GetInputElement(), "keypress", this.OnKeyPress.aspxBind(this));
  if(this.isTextSelectionOnClickEnabled) {
   ASPx.Evt.AttachEventToElement(this.GetInputElement(), ASPx.TouchUIHelper.touchMouseDownEventName, this.OnMouseDown.aspxBind(this));
   ASPx.Evt.AttachEventToElement(this.GetInputElement(), "click", this.OnClick.aspxBind(this));
  }
  this.Unload.AddHandler(this.OnUnload.aspxBind(this));
 },
 InitializeTextDecoration: function() {
  var input = this.GetInputElement();
  if(input.type === "password" && !this.IsInputPasswordFilledAutomaticallyByChrome())
   this.ToggleTextDecoration();
 },
 IsInputPasswordFilledAutomaticallyByChrome: function() {
  if(!ASPx.Browser.Chrome)
   return false;
  var input = this.GetInputElement();
  return ASPx.ElementMatchesSelector(input, CHROME_AUTOFILL_SELECTOR);
 },
 OnMouseDown: function() {
  this.trySelectInputTextOnClick = ASPx.GetActiveElement() !== this.GetInputElement() && !this.IsFocusEventsLocked();
 },
 OnClick: function() {
  if(this.trySelectInputTextOnClick) {
   var input = this.GetInputElement();
   setTimeout(function() {
    var inputSelection = ASPx.Selection.GetInfo(input);
    if (inputSelection.startPos === inputSelection.endPos)
     ASPx.Selection.Set(input);
   }, 0);
  }
 },
 InitializeAutocompleteAttribute: function() {
  var input = this.GetInputElement();
  if(this.IsVCardAttributeRequired())
   ASPx.Attr.SetAttribute(input, this.autoCompleteAttribute.name, this.autoCompleteAttribute.value);
  else if(this.IsAutocompleteOffRequiredOnInitialize())
   ASPx.Attr.SetAttribute(input, "autocomplete", "off");
 },
 SaveInputValue: function(isInlineInitialize) {
  var input = this.GetInputElement();
  if(!input)
   return;
  var inputValue = input.value;
  if(inputValue === null)
   inputValue = "";
  if(isInlineInitialize)
   this.inlineInitializeInputValue = inputValue;
  else
   this.initializeInputValue = inputValue;
 },
 IsValueRestoredByBrowser: function() {
  if(this.displayFormat || this.isNative || this.inlineInitializeInputValue === null || this.initializeInputValue === null)
   return false;
  if(ASPx.Browser.Chrome)
   return this.IsValueRestoredByChrome();
  else if(ASPx.Browser.Firefox)
   return this.IsValueRestoredByFirefox();
  else if(ASPx.Browser.IE)
   return this.IsValueRestoredByIE();
  else
   return this.IsValueRestoredByBrowserCore();
 },
 IsValueRestoredByBrowserCore: function() {
  return this.IsValueChangedBeforeInitialize() || this.IsClientValueNotExists() || this.IsValueChangedOnMaskInitialize();
 },
 IsValueRestoredByChrome: function() {
  return this.IsValueRestoredByBrowserCore();
 },
 IsValueRestoredByFirefox: function() {
  return this.IsValueRestoredByBrowserCore();
 },
 IsValueRestoredByIE: function() {
  return this.IsValueRestoredByBrowserCore();
 },
 IsValueChangedBeforeInitialize: function() {
  return this.inlineInitializeInputValue !== this.initializeInputValue;
 },
 IsClientValueNotExists: function() {
  return this.inlineInitializeInputValue !== "" &&
      this.inlineInitializeInputValue !== this.nullText &&
      this.inlineInitializeInputValue !== this.GetValue() &&
      this.inlineInitializeInputValue !== this.GetText();
 },
 IsValueChangedOnMaskInitialize: function() {
  return this.maskInfo && this.inlineInitializeInputValue !== this.GetInputElement().value;
 },
 SynchronizeRestoredValue: function() {
  this.SetText(this.initializeInputValue);
 },
 AdjustControl: function() {
  ASPxClientEdit.prototype.AdjustControl.call(this);
  if(ASPx.Browser.IE && ASPx.Browser.Version > 8 && !this.isNative)
   this.correctInputElementHeight();
  this.ensureAdjustFocusedNullTextElement();
 },
 correctInputElementHeight: function() {
  var mainElement = this.GetMainElement();
  if(mainElement) {
   var mainElementHeight = mainElement.style.height;
   var mainElementHeightSpecified = mainElementHeight && mainElementHeight.indexOf('px') !== -1; 
   if(mainElementHeightSpecified) {
    var inputElement = this.GetInputElement();
    var inputElementHeight = this.getInputElementHeight();
    inputElement.style.height = inputElementHeight + "px";
    if(!ASPx.Ident.IsASPxClientMemo(this))
     inputElement.style.lineHeight = inputElementHeight + "px";
   }
  }
 },
 getInputElementHeight: function() {
  var mainElement = this.GetMainElement(),
   inputElement = this.GetInputElement();
  var inputElementHeight = ASPx.PxToInt(mainElement.style.height) - ASPx.GetTopBottomBordersAndPaddingsSummaryValue(mainElement);
  var inputElementContainer = inputElement.parentNode,
   inputContainerStyle = ASPx.GetCurrentStyle(inputElementContainer);
  inputElementHeight -= ASPx.GetTopBottomBordersAndPaddingsSummaryValue(inputElementContainer, inputContainerStyle) 
   + ASPx.GetTopBottomMargins(inputElementContainer, inputContainerStyle);
  var mainElementCellspacing = ASPx.GetCellSpacing(mainElement);
  if(mainElementCellspacing)
   inputElementHeight -= mainElementCellspacing * 2;
  var inputStyle = ASPx.GetCurrentStyle(inputElement);
  inputElementHeight -= ASPx.GetTopBottomBordersAndPaddingsSummaryValue(inputElement, inputStyle) 
   + ASPx.GetTopBottomMargins(inputElement, inputStyle);
  return inputElementHeight;
 },
 getInputCell: function() {
  var inputElement = this.GetInputElement();
  if(inputElement)
   return inputElement.parentNode;
 },
 addIEXButtonEventHandler: function() {
  var inputElement = this.GetInputElement();
  if(ASPx.IsExists(inputElement)) {
   this.isDeleteOrBackspaceKeyClick = false;
   ASPx.Evt.AttachEventToElement(inputElement, "input", function (evt) {
    if(this.isDeleteOrBackspaceKeyClick) {
     this.isDeleteOrBackspaceKeyClick = false;
     return;
    }
    if(inputElement.value === '') {
     this.SyncRawValue();
    }
   }.aspxBind(this));
   ASPx.Evt.AttachEventToElement(inputElement, "keydown", function (evt) {
    this.isDeleteOrBackspaceKeyClick = (evt.keyCode == ASPx.Key.Delete || evt.keyCode == ASPx.Key.Backspace);
   }.aspxBind(this));
  }   
 },
 ensureOutOfRangeWarningManager: function (minValue, maxValue, defaultMinValue, defaultMaxValue, valueFormatter) {
  if (!this.outOfRangeWarningManager)
   this.outOfRangeWarningManager = new ASPxOutOfRangeWarningManager(this, minValue, maxValue, defaultMinValue, defaultMaxValue,
    this.showOutOfRangeWarningElementAtBottom() ? ASPx.Position.Bottom : ASPx.Position.Right, valueFormatter);
 },
 showOutOfRangeWarningElementAtBottom: function() {
  return this.hasRightPopupHelpText();
 },
 GetOutOfRangeWarningElementPrevSibling: function() {
  return this.GetMainElement();
 },
 helpTextInitialize: function () {
  if(this.helpText) {
   this.helpTextObj = new ASPxClientTextEditHelpText(this, this.helpTextStyle, this.helpText, this.helpTextPosition,
    this.helpTextHAlign, this.helpTextVAlign, this.helpTextMargins, this.enableHelpTextPopupAnimation, this.helpTextDisplayMode);
  }
 },
 hasPopupHelpText: function() {
  return this.helpText && this.helpTextDisplayMode === ASPxClientTextEditHelpTextDisplayMode.Popup;
 },
 hasRightPopupHelpText: function() {
  return this.hasPopupHelpText() && this.helpTextPosition === ASPx.Position.Right;
 },
 showHelpText: function () {
  if(this.helpTextObj)
   this.helpTextObj.show();
 },
 hideHelpText: function () {
  if(this.helpTextObj)
   this.helpTextObj.hide();
 },
 ApplyBrowserSpecificClassName: function() {
  var mainElement = this.GetMainElement();
  if(ASPx.IsExistsElement(mainElement)) {
   var className = BrowserHelper.GetBrowserSpecificSystemClassName();
   if(className)
    mainElement.className += " " + className;
  }
 },
  CorrectMainElementWhiteSpaceStyle: function() {
  var inputElement = this.GetInputElement();
  if(inputElement && inputElement.parentNode) {
   if(this.IsElementHasWhiteSpaceStyle(inputElement.parentNode))
    inputElement.parentNode.style.whiteSpace = "normal";
  }
 },
 IsElementHasWhiteSpaceStyle: function(element) {
  var currentStyle = ASPx.GetCurrentStyle(element);
  return currentStyle.whiteSpace == "nowrap" || currentStyle.whiteSpace == "pre";  
 },
 FindInputElement: function(){
  return this.isNative ? this.GetMainElement() : ASPx.GetElementById(this.name + ASPx.TEInputSuffix);
 },
 DecodeRawInputValue: function(value) {
  return value;
 },
 GetRawValue: function(value){
  return ASPx.IsExists(this.stateObject) ? this.stateObject.rawValue : null;
 },
 SetRawValue: function(value){
  if(ASPx.IsExists(value))
   value = value.toString();
  this.UpdateStateObjectWithObject({ rawValue: value });
 },
 SyncRawValue: function() {
  if(this.maskInfo != null)
   this.SetRawValue(this.maskInfo.GetValue(true));
  else
   this.SetRawValue(this.GetInputElement().value);
 },
 HasTextDecorators: function() {
  return this.nullText != "" || this.displayFormat != null;
 },
 CanApplyTextDecorators: function(){
  return !this.focused;
 },
 CreateStyleDecoration: function () {
  return new ASPx.TextEditorStyleDecoration(this);
 },
 CanApplyNullTextDecoration: function() {
  var value = this.GetValue();
  return this.IsNull(value);
 },
 GetDecoratedText: function(value) {
  var result = value;
  if(this.IsNull(value) && this.nullText != "" && this.CanApplyNullTextDecoration())
   result = this.nullText;
  else if(this.displayFormat != null)
   result = this.GetDisplayFormatText(value);
  else if(this.maskInfo != null)
   result = this.maskInfo.GetText();
  else if(value == null)
   result = "";
  return result;
 },
 GetDisplayFormatText: function(value) {
  return ASPx.Formatter.Format(this.displayFormat, value);
 },
 ToggleTextDecoration: function() {
  if(this.HasTextDecorators()) {
   if(this.focused) {
    var input = this.GetInputElement();
    var oldValue = input.value;
    var sel = ASPx.Selection.GetExtInfo(input);
    this.ToggleTextDecorationCore();
    this.ensureActivateFocusedNullTextMechanism();
    if(oldValue != input.value || !ASPx.Selection.AreEqual(sel, ASPx.Selection.GetExtInfo(input))) {
     if(sel.startPos == 0 && sel.endPos == oldValue.length)
      sel.endPos = input.value.length;
     else
      sel.endPos = sel.startPos;
     if(!this.accessibilityCompliant || ASPx.GetActiveElement() == input)
      this.SetSelectionOnToggleTextDecoration(input, sel);
    }
   } else {
    this.ToggleTextDecorationCore();
    this.ensureDeactivateFocusedNullTextMechanism();
   }
  }
 },
 SetSelectionOnToggleTextDecoration: function(input, sel) {
  ASPx.Selection.Set(input, sel.startPos, sel.endPos);
 },
 ToggleTextDecorationCore: function() {
  if(this.maskInfo != null) {   
   this.ApplyMaskInfo(false);
  } else {
   var input = this.GetInputElement();
   var rawValue = this.GetRawValue();
   var value = this.CanApplyTextDecorators() ? this.GetDecoratedText(rawValue) : rawValue;
   if(input.value != value) {
    if(input.type == "password")
     this.TogglePasswordInputTextDecoration(value);
    else
     input.value = value;
   }
  }
 },
 GetPasswordNullTextInputElement: function() {
  if(!this.isPasswordNullTextInputElementExists())
   this.nullTextInputElement = this.createPasswordNullTextInputElement();
  return this.nullTextInputElement;
 },
 createPasswordNullTextInputElement: function() {
  var inputElement = this.GetInputElement(),
   nullTextInputElement = document.createElement("INPUT");
  nullTextInputElement.className = inputElement.className;
  nullTextInputElement.style.cssText = inputElement.style.cssText;
  nullTextInputElement.id = inputElement.id + passwordInputClonedSuffix;
  nullTextInputElement.type = "text";
  if(ASPx.IsExists(inputElement.tabIndex))
   nullTextInputElement.tabIndex = inputElement.tabIndex;
  nullTextInputElement.disabled = inputElement.disabled;
  var onFocusEventHandler = function() {
   var inputElement = this.GetInputElement(),
    nullTextInputElement = this.GetPasswordNullTextInputElement();
   if(inputElement) {
    this.LockFocusEvents();  
    ASPx.SetElementDisplay(inputElement, true);
    if((ASPx.Browser.MacOSMobilePlatform && ASPx.Browser.PlaformMajorVersion >= 14) || (ASPx.Browser.MacOSPlatform && ASPx.Browser.Safari && ASPx.Browser.Version >= 14)) { 
     ASPx.GetCurrentStyle(inputElement).display; 
    }
    inputElement.focus();
    ASPx.SetElementDisplay(nullTextInputElement, false);
    this.ensureAdjustFocusedNullTextElement();
    this.ReplaceAssociatedIdInLabels(nullTextInputElement.id, inputElement.id);
   }
  }.aspxBind(this);
  ASPx.Evt.AttachEventToElement(nullTextInputElement, "focus", onFocusEventHandler);
  return nullTextInputElement;
 },
 isPasswordNullTextInputElementExists: function() {
  return ASPx.IsExistsElement(this.nullTextInputElement);
 },
 TogglePasswordNullTextTimeoutChecker: function() {
  if(this.passwordNullTextIntervalID < 0) {
   var timeoutChecker = function() {
    var inputElement = this.GetInputElement();
    if(ASPx.GetControlCollection().GetByName(this.name) !== this || inputElement == null) {
     window.clearTimeout(this.passwordNullTextIntervalID);
     this.passwordNullTextIntervalID = -1;
     return;
    } else {
     if(!this.focused) {
      var passwordNullTextInputElement = this.GetPasswordNullTextInputElement();
      if(passwordNullTextInputElement.value != this.nullText && inputElement.value == "") { 
       passwordNullTextInputElement.value = this.nullText;
       this.SetValue(null);
      }
      if(inputElement.value != "") {
       if(inputElement.style.display == "none") {
        this.SetValue(inputElement.value);
        this.UnhidePasswordInput();
       }
      } else {
       if(inputElement.style.display != "none") {
        this.SetValue(null);
        this.HidePasswordInput();
       }
      }
     }
     else {
      var passwordNullTextInputElement = this.GetPasswordNullTextInputElement();
      if(passwordNullTextInputElement.value !== this.nullText && passwordNullTextInputElement.value !== "") { 
       if(inputElement.value === "")
        inputElement.value = passwordNullTextInputElement.value;
       passwordNullTextInputElement.value = this.nullText;
      }
     }
    }
   }.aspxBind(this);
   timeoutChecker(); 
   this.passwordNullTextIntervalID = window.setInterval(timeoutChecker, 100);
  }
 },
 TogglePasswordInputTextDecoration: function(value) {
  var inputElement = this.GetInputElement();
  var nullTextInputElement = this.GetPasswordNullTextInputElement();
  nullTextInputElement.value = value;
  var parentNode = inputElement.parentNode;
  if(ASPx.Data.ArrayIndexOf(parentNode.childNodes, nullTextInputElement) < 0) {
   ASPx.Attr.ChangeStyleAttribute(nullTextInputElement, "display", "none");
   ASPx.InsertElementAfter(nullTextInputElement, inputElement);
  }
  this.HidePasswordInput();
  this.TogglePasswordNullTextTimeoutChecker();
 },
 HidePasswordInput: function() {
  ASPx.Attr.ChangeStyleAttribute(this.GetInputElement(), "display", "none");
  ASPx.Attr.ChangeStyleAttribute(this.GetPasswordNullTextInputElement(), "display", "");
  this.ReplaceAssociatedIdInLabels(this.GetInputElement().id, this.GetPasswordNullTextInputElement().id);
 },
 UnhidePasswordInput: function() {
  ASPx.Attr.ChangeStyleAttribute(this.GetInputElement(), "display", "");
  ASPx.Attr.ChangeStyleAttribute(this.GetPasswordNullTextInputElement(), "display", "none");
  this.ReplaceAssociatedIdInLabels(this.GetPasswordNullTextInputElement().id, this.GetInputElement().id);
 },
 ReplaceAssociatedIdInLabels: function(oldId, newId) {
  var labels = document.getElementsByTagName("LABEL");
  for(var i = 0; i < labels.length; i++) {
   if(labels[i].attributes["for"] && labels[i].attributes["for"].value == oldId)
    labels[i].attributes["for"].value = newId;
  }
 },
 GetFormattedText: function() {
  var value = this.GetValue();
  if(this.IsNull(value) && this.nullText != "")
   return this.GetText();
  return this.GetDecoratedText(value);
 },
 IsNull: function(value) {
  return value == null || value === "";
 },
 PopulateStyleDecorationPostfixes: function() {
  ASPxClientEdit.prototype.PopulateStyleDecorationPostfixes.call(this);
  this.styleDecoration.AddPostfix(ASPx.TEInputSuffix);
 },
 GetValue: function() {
  var value = null;
  if(this.maskInfo != null)
   value = this.maskInfo.GetValue();
  else if(this.HasTextDecorators())
   value = this.GetRawValue();
  else {
   var input = this.GetInputElement();
   value = input ? input.value : null;
  }
  return (value == "" && this.convertEmptyStringToNull) ? null : value;
 },
 SetValue: function(value) {
  if(value == null || value === undefined) 
   value = "";
  if(this.maskInfo != null) {
   this.maskInfo.SetValue(value.toString());
   this.ApplyMaskInfo(false);
   this.SavePrevMaskValue();
  } 
  else if(this.HasTextDecorators()) {
   this.SetRawValue(value);
   this.GetInputElement().value = this.CanApplyTextDecorators() && this.GetInputElement().type != "password" ? this.GetDecoratedText(value) : value;
  }
  else
   this.GetInputElement().value = value;
  this.UpdateStyleDecorations(); 
  this.SaveChangedValue();   
 },
 SetVisible: function(visible) {
  ASPxClientEdit.prototype.SetVisible.call(this, visible);
  if(this.helpTextDisplayMode === ASPxClientTextEditHelpTextDisplayMode.Inline) {
   if(visible)
    this.showHelpText();
   else
    this.hideHelpText();
  }
 },
 UnstretchInputElement: function(){
  var inputElement = this.GetInputElement();
  var mainElement = this.GetMainElement();
  var mainElementCurStyle = ASPx.GetCurrentStyle(mainElement);
  if(ASPx.IsExistsElement(mainElement) && ASPx.IsExistsElement(inputElement) && ASPx.IsExists(mainElementCurStyle) && 
   inputElement.style.width == "100%" &&
   (mainElementCurStyle.width == "" || mainElementCurStyle.width == "auto"))
   inputElement.style.width = "";
 },
 RestoreActiveElement: function(activeElement) {
  if(activeElement && activeElement.setActive && activeElement.tagName != "IFRAME")
   activeElement.setActive();
 },
 RaiseValueChangedEvent: function() {
  var processOnServer = ASPxClientEdit.prototype.RaiseValueChangedEvent.call(this);
  processOnServer = this.RaiseTextChanged(processOnServer);
  return processOnServer;
 },
 InitMask: function() {
  var rawValue = this.GetRawValue();
  this.SetValue(rawValue.length ? this.DecodeRawInputValue(rawValue) : this.maskInfo.GetValue());
  this.validationPatterns.unshift(new MaskValidationPattern(this.maskInfo.errorText, this.maskInfo));
 },
 SetMaskPasteTimer: function() {
  this.ClearMaskPasteTimer();
  this.maskPasteTimerID = ASPx.Timer.SetControlBoundInterval(this.MaskPasteTimerProc, this, ASPx.PasteCheckInterval);
 },
 ClearMaskPasteTimer: function() {
  this.maskPasteTimerID = ASPx.Timer.ClearInterval(this.maskPasteTimerID);
 },
 SavePrevMaskValue: function() {
  this.maskValueBeforeUserInput = this.maskInfo.GetValue();
 },
 FillMaskInfo: function() {
  var input = this.GetInputElement();
  if(!input) return; 
  var sel = ASPx.Selection.GetInfo(input);
  this.maskInfo.SetCaret(sel.startPos, sel.endPos - sel.startPos);  
 },
 ApplyMaskInfo: function(applyCaret) {
  this.SyncRawValue();
  var input = this.GetInputElement();
  var text = this.GetMaskDisplayText();
  this.maskTextBeforePaste = text;
  if(input.value != text)
   input.value = text;
  if(applyCaret)
   ASPx.Selection.Set(input, this.maskInfo.caretPos, this.maskInfo.caretPos + this.maskInfo.selectionLength);
 },
 GetMaskDisplayText: function() {
  if(!this.focused && this.HasTextDecorators())
   return this.GetDecoratedText(this.maskInfo.GetValue());
  return this.maskInfo.GetText();
 },
 ShouldCancelMaskKeyProcessing: function(htmlEvent, keyDownInfo) {
  return ASPx.Evt.IsEventPrevented(htmlEvent);
 }, 
 HandleMaskKeyDown: function(evt) {
  var keyInfo = ASPx.MaskManager.CreateKeyInfoByEvent(evt);
  ASPx.MaskManager.keyCancelled = this.ShouldCancelMaskKeyProcessing(evt, keyInfo);
  if(ASPx.MaskManager.keyCancelled) {
   ASPx.Evt.PreventEvent(evt);
   return;
  }
  this.maskPasteLock = true;
  this.FillMaskInfo();  
  var canHandle = ASPx.MaskManager.CanHandleControlKey(keyInfo);   
  ASPx.MaskManager.savedKeyDownKeyInfo = keyInfo;
  if(canHandle) {   
   ASPx.MaskManager.OnKeyDown(this.maskInfo, keyInfo);
   this.ApplyMaskInfo(true);
   ASPx.Evt.PreventEvent(evt);
  }
  ASPx.MaskManager.keyDownHandled = canHandle;
  this.maskPasteLock = false;
  this.UpdateMaskHintHtml();
 },
 HandleMaskKeyPress: function(evt) {
  var keyInfo = ASPx.MaskManager.CreateKeyInfoByEvent(evt);
  ASPx.MaskManager.keyCancelled = ASPx.MaskManager.keyCancelled || this.ShouldCancelMaskKeyProcessing(evt, ASPx.MaskManager.savedKeyDownKeyInfo);
  if(ASPx.MaskManager.keyCancelled) {
   ASPx.Evt.PreventEvent(evt);
   return;
  }
  this.maskPasteLock = true;  
  var printable = ASPx.MaskManager.savedKeyDownKeyInfo != null && ASPx.MaskManager.IsPrintableKeyCode(ASPx.MaskManager.savedKeyDownKeyInfo);
  if(printable) {
   ASPx.MaskManager.OnKeyPress(this.maskInfo, keyInfo);
   this.ApplyMaskInfo(true);
  }
  if(printable || ASPx.MaskManager.keyDownHandled)   
   ASPx.Evt.PreventEvent(evt); 
  this.maskPasteLock = false;
  this.UpdateMaskHintHtml();
 },
 MaskPasteTimerProc: function() {
  if(this.maskPasteLock || !this.maskInfo) return;
  this.maskPasteCounter++;
  var inputElement = this.inputElement;
  if(!inputElement || this.maskPasteCounter > 40) {
   this.maskPasteCounter = 0;
   inputElement = this.GetInputElement();
   if(!ASPx.IsExistsElement(inputElement)) {
    this.ClearMaskPasteTimer();
    return;
   }
  }
  if(this.maskTextBeforePaste !== inputElement.value)
   this.ProcessInputValueChangedOnTimer();
  if(!this.focused)
   this.ClearMaskPasteTimer();
 },
 ProcessInputValueChangedOnTimer: function() {
  var inputElement = this.inputElement;
  var selectionInfo = ASPx.Selection.GetInfo(inputElement);
  var startCaretPosition = selectionInfo.startPos;
  var endCaretPosition = selectionInfo.endPos;
  var oldText = this.maskTextBeforePaste;
  var newText = inputElement.value;
  var isAndroidBackSpacePressed = this.isAndroidBackSpacePressed(oldText, newText, startCaretPosition, endCaretPosition);
  var isLastTypedCharacter = newText.indexOf(oldText) == 0 && newText.length > oldText.length;
  if(isAndroidBackSpacePressed || isLastTypedCharacter) {
   this.SetText(newText);
   this.SetCaretPosition(endCaretPosition);
  } else {
   this.maskInfo.ProcessPaste(newText, endCaretPosition);
   this.ApplyMaskInfo(true);
  }
 },
 isAndroidBackSpacePressed: function(oldText, newText, startCaretPosition, endCaretPosition) {
  if(!ASPx.Browser.AndroidMobilePlatform || startCaretPosition !== endCaretPosition || newText.length >= oldText.length)
   return false;
  var startSubstring = newText.substring(0, startCaretPosition);
  var endSubstring = newText.substring(startCaretPosition);
  var isStartSubstringMatches = oldText.indexOf(startSubstring) == 0;
  var isEndSubstringMatches = endSubstring == "" || oldText.lastIndexOf(endSubstring) == oldText.length - endSubstring.length;
  return isStartSubstringMatches && isEndSubstringMatches;
 },
 BeginShowMaskHint: function() {
  if(!this.GetReadOnly() && this.maskHintTimerID == -1)
   this.maskHintTimerID = window.setInterval(ASPx.MaskHintTimerProc, 500);
 },
 EndShowMaskHint: function() {
  window.clearInterval(this.maskHintTimerID);
  this.maskHintTimerID = -1;
 },
 MaskHintTimerProc: function() {  
  if(this.maskInfo) {
   this.FillMaskInfo();
   this.UpdateMaskHintHtml();
  } else {
   this.EndShowMaskHint();
  }
 },
 UpdateMaskHintHtml: function() {  
  var hint =  this.GetMaskHintElement();
  if(!ASPx.IsExistsElement(hint))
   return;
  var html = ASPx.MaskManager.GetHintHtml(this.maskInfo);
  if(html == this.maskHintHtml)
   return;
  if(html != "") {
   var mainElement = this.GetMainElement();
   if(ASPx.IsExistsElement(mainElement)) {
    hint.innerHTML = html;
    hint.style.position = "absolute";  
    hint.style.left = ASPx.PrepareClientPosForElement(ASPx.GetAbsoluteX(mainElement), mainElement, true) + "px";
    hint.style.top = (ASPx.PrepareClientPosForElement(ASPx.GetAbsoluteY(mainElement), mainElement, false) + mainElement.offsetHeight + 2) + "px";
    hint.style.display = "block";    
   }   
  } else {
   hint.style.display = "none";
  }
  this.maskHintHtml = html;
 },
 HideMaskHint: function() {
  var hint =  this.GetMaskHintElement();
  if(ASPx.IsExistsElement(hint))
   hint.style.display = "none";
  this.maskHintHtml = "";
 },
 GetMaskHintElement: function() {
  return ASPx.GetElementById(this.name + "_MaskHint");
 },
 OnFocus: function() {
  if (this.maskInfo != null && !ASPx.GetControlCollection().InCallback()) {
   this.TrySetCursorToStartPosition();
   this.SetMaskPasteTimer();
  }
  if(this.IsAutocompleteDropDownListRequiredOnFocus())
   ASPx.Attr.RemoveAttribute(this.GetInputElement(), "autocomplete");
  ASPxClientEdit.prototype.OnFocus.call(this);
 },
 OnLostFocus: function() {
  if(this.IsAutocompleteOffRequiredOnLostFocus())
   ASPx.Attr.SetAttribute(this.GetInputElement(), "autocomplete", "off");
  ASPxClientEdit.prototype.OnLostFocus.call(this);
 },
 OnMouseWheel: function(evt){
  if(this.GetReadOnly() || this.maskInfo == null || !this.maskInfo.allowMouseWheel)
   return;
  this.FillMaskInfo();
  ASPx.MaskManager.OnMouseWheel(this.maskInfo, ASPx.Evt.GetWheelDelta(evt) < 0 ? -1 : 1);
  this.ApplyMaskInfo(true);
  ASPx.Evt.PreventEvent(evt);
  this.UpdateMaskHintHtml();
 }, 
 OnBrowserWindowResize: function(e) {
  if(!this.autoResizeWithContainer)
   this.AdjustControl();
 },
 IsValueChanged: function() {
  return this.GetValue() != this.lastChangedValue; 
 },
 OnKeyDown: function(evt) {        
  if(this.NeedPreventBrowserUndoBehaviour(evt))
   return ASPx.Evt.PreventEvent(evt);
  if(this.RequireHandleMaxlenManually()) {
   this.onKeyDownInputValue = this.GetInputElement().value;
   var selectionInfo = ASPx.Selection.GetExtInfo(this.GetInputElement());
   this.onKeyDownCursorPos = selectionInfo.startPos;
  }
  if(ASPx.Browser.IE && ASPx.Evt.GetKeyCode(evt) == ASPx.Key.Esc) {   
   if(++this.escCount > 1) {
    ASPx.Evt.PreventEvent(evt);
    return;
   }
  } else 
   this.escCount = 0;
  ASPxClientEdit.prototype.OnKeyDown.call(this, evt);
  if(!this.IsRaiseStandardOnChange(evt)) {
   if(!this.GetReadOnly() && this.maskInfo != null)
    this.HandleMaskKeyDown(evt);
  }
 },
 IsCtrlZ: function(evt) {
  return evt.ctrlKey && !evt.altKey && !evt.shiftKey && (ASPx.Evt.GetKeyCode(evt) == 122 || ASPx.Evt.GetKeyCode(evt) == 90);
 },
 NeedPreventBrowserUndoBehaviour: function(evt) {
  var inputElement = this.GetInputElement();
  return this.IsCtrlZ(evt) && !!inputElement && !inputElement.value;
 },
 OnKeyPress: function(evt) {
  ASPxClientEdit.prototype.OnKeyPress.call(this, evt);
  if(!this.GetReadOnly() && this.maskInfo != null && !this.IsRaiseStandardOnChange(evt))
   this.HandleMaskKeyPress(evt);
  if(this.NeedOnKeyEventEnd(evt, true))
   this.OnKeyEventEnd(evt);
 },
 OnKeyUp: function(evt) {
  if(ASPx.Browser.Firefox && !this.focused && ASPx.Evt.GetKeyCode(evt) === ASPx.Key.Tab)
   return;
  if(this.NeedOnKeyEventEnd(evt, false)) {
   var proccessNextCommingPress = ASPx.Evt.GetKeyCode(evt) === ASPx.Key.Alt; 
   this.OnKeyEventEnd(evt, proccessNextCommingPress);
  }
  if(this.RequireHandleMaxlenManually()) {
   var inputValueLength = this.GetInputElement().value.length;
   var maxLength = this.GetInputMaxLength();
   if(inputValueLength > maxLength && inputValueLength > this.onKeyDownInputValue.length) {
    this.GetInputElement().value = this.onKeyDownInputValue;
    this.SetCaretPosition(this.onKeyDownCursorPos);
   }
  }
  ASPxClientEdit.prototype.OnKeyUp.call(this, evt);
 },
 RequireHandleMaxlenManually: function() { 
  return ASPx.Browser.AndroidMobilePlatform && ASPx.Browser.SamsungAndroidDevice && ASPx.Browser.PlaformMajorVersion < 6 && this.GetInputMaxLength() !== -1;
 },
 GetInputMaxLength: function() {
  var input = this.GetInputElement();
  if(ASPx.Attr.IsExistsAttribute(input, "maxlength"))
   return input.maxLength;
  return -1;
 },
 NeedOnKeyEventEnd: function(evt, isKeyPress) { 
  var handleKeyPress = this.maskInfo != null && evt.keyCode == ASPx.Key.Enter;
  return handleKeyPress == isKeyPress;
 },
 OnKeyEventEnd: function(evt, withDelay){
  if(!this.GetReadOnly()) {
   if(this.IsRaiseStandardOnChange(evt))
    this.RaiseStandardOnChange();
   this.SyncRawValueIfHasTextDecorators(withDelay);
  }
 },
 SyncRawValueIfHasTextDecorators: function(withDelay) {
  if(this.HasTextDecorators()) {
   if(withDelay) {
    window.setTimeout(function() {
     this.SyncRawValue();
    }.aspxBind(this), 0);
   } else 
    this.SyncRawValue();
  }
 },
 IsRaiseStandardOnChange: function(evt){
  return !this.UseSpecialKeyboardHandling() && this.raiseValueChangedOnEnter && evt.keyCode == ASPx.Key.Enter;
 },
 GetFocusSelectAction: function() {
  if (this.maskInfo)
   return this.maskInfo.IsEmpty() ? null : "start";
  return "all"; 
 },
 CorrectFocusWhenDisabled: function() {
  if(!this.GetEnabled()) {
   var inputElement = this.GetInputElement();
   if(inputElement)
    inputElement.blur();
   return true;
  }
  return false;
 },
 EnsureShowPopupHelpText: function() {
  if(this.helpTextDisplayMode === ASPxClientTextEditHelpTextDisplayMode.Popup)
   this.showHelpText();
 },
 EnsureHidePopupHelpText: function() {
  if(this.helpTextDisplayMode === ASPxClientTextEditHelpTextDisplayMode.Popup)
   this.hideHelpText();
 },
 OnFocusCore: function() {
  if(this.CorrectFocusWhenDisabled())
   return;
  var wasLocked = this.IsFocusEventsLocked();
  ASPxClientEdit.prototype.OnFocusCore.call(this);
  this.CorrectInputMaxLength(true);
  if(this.maskInfo != null) {
   this.SavePrevMaskValue();
   this.BeginShowMaskHint();
  }
  if(!wasLocked) {
   this.ToggleTextDecoration();
   this.startUserInputEventTimerIfRequired();
  }
  if(this.isPasswordNullTextInputElementExists())
   setTimeout(function() { this.EnsureShowPopupHelpText(); }.aspxBind(this), 0);
  else
   this.EnsureShowPopupHelpText();
 },
 startUserInputEventTimerIfRequired: function () {
  if(this.shouldStartUserInputTimer() && this.userInputEventTimerID === -1) {
   this.prevInputValue = this.GetInputElement().value;
   this.userInputEventTimerID = ASPx.Timer.SetControlBoundInterval(this.processUserInputEventTimer, this, ASPx.CheckUserInputInterval);
  }
 },
 shouldStartUserInputTimer: function() {
  return !this.UserInput.IsEmpty();
 },
 restartCurrentUserInputTimer: function() {
  if(this.userInputEventTimerID !== -1) {
   this.processUserInputEventTimer(true);
   this.clearUserInputEventTimerIfRequired();
   this.startUserInputEventTimerIfRequired();
  }
 },
 clearUserInputEventTimerIfRequired: function () {
  if (this.userInputEventTimerID !== -1)
   this.userInputEventTimerID = ASPx.Timer.ClearInterval(this.userInputEventTimerID);
 },
 processUserInputEventTimer: function(onRestart) {
  var currentInputValue = this.GetInputElement().value;
  if(currentInputValue !== this.prevInputValue) {
   this.onInputChangedOnUserInputTimer(onRestart);
   this.prevInputValue = currentInputValue;
  }
 },
 onInputChangedOnUserInputTimer: function(onRestart) {
  if(this.raiseUserInputTimeout > -1)
   clearTimeout(this.raiseUserInputTimeout);
  this.raiseUserInputTimeout = setTimeout(function() {
   this.RaiseUserInput();
   this.raiseUserInputTimeout = -1;
  }.bind(this), 0);
 },
 ensureFocusedNullTextElement: function () {
  if(!this.focusedNullTextElement)
   this.createFocusedNullTextElement();
 },
 getFocusedNullTextElementClassName: function() {
  return focusedNullTextClassName;
 },
 getFocusedNullTextElementTagName: function() {
  return "INPUT";
 },
 getCopyFromInputElementStyles: function() {
  return [ "paddingLeft", "paddingTop", "paddingRight", "paddingBottom", "borderCollapse", "borderLeftWidth", "borderTopWidth", "borderRightWidth", "borderBottomWidth" ];
 },
 copyStylesFromInputElementToFocusedNullTextElement: function() {
  var input = this.GetInputElement();
  var inputStyle = ASPx.GetCurrentStyle(input);
  var stylesToCopy = this.getCopyFromInputElementStyles();
  for(var i = 0; i < stylesToCopy.length; i++)
   this.focusedNullTextElement.style[stylesToCopy[i]] = inputStyle[stylesToCopy[i]];
 },
 createFocusedNullTextElement: function() {
  this.focusedNullTextElement = document.createElement(this.getFocusedNullTextElementTagName());
  this.focusedNullTextElement.value = this.nullText;
  this.focusedNullTextElement.className = this.getFocusedNullTextElementClassName();
  this.focusedNullTextElement.tabIndex = -1;
  ASPx.SetElementDisplay(this.focusedNullTextElement, false);
  if(this.accessibilityCompliant) {
   ASPx.Attr.SetAttribute(this.focusedNullTextElement, "aria-label", this.nullText);
   ASPx.Attr.SetAttribute(this.focusedNullTextElement, "aria-hidden", true);
  }
  this.copyStylesFromInputElementToFocusedNullTextElement();
  if (this.nullTextOnFocusCssText) {
   var styleSheet = ASPx.GetCurrentStyleSheet();
   this.focusedNullTextElement.className += " " + ASPx.CreateImportantStyleRule(styleSheet, this.nullTextOnFocusCssText);
  }
  var inputElement = this.GetInputElement();
  inputElement.parentNode.insertBefore(this.focusedNullTextElement, inputElement.nextSibling);
 },
 ensureActivateFocusedNullTextMechanism: function() {
  if (this.nullTextDisplayMode === NullTextDisplayMode.UnfocusedAndFocused) {
   if(this.IsNull(this.GetValue()))
    this.changeFocusedNullTextElementVisibility(true);
   this.setFocusedNullTextTimer();
  }
 },
 ensureDeactivateFocusedNullTextMechanism: function () {
  if (this.nullTextDisplayMode === NullTextDisplayMode.UnfocusedAndFocused) {
   this.clearFocusedNullTextTimer();
   this.changeFocusedNullTextElementVisibility(false);
  }
 },
 setFocusedNullTextTimer: function () {
  if(this.focusedNullTextTimerID === -1)
   this.focusedNullTextTimerID = ASPx.Timer.SetControlBoundInterval(this.onFocusedNullTextVisibilityCheck, this, ASPx.PasteCheckInterval);
 },
 clearFocusedNullTextTimer: function () {
  this.focusedNullTextTimerID = ASPx.Timer.ClearInterval(this.focusedNullTextTimerID);
 },
 onFocusedNullTextVisibilityCheck: function (evt) {
  if(!this.needShowFocusedNullText() && this.isFocusedNullTextElementDisplayed())
   this.changeFocusedNullTextElementVisibility(false);
  else if(this.needShowFocusedNullText() && !this.isFocusedNullTextElementDisplayed())
   this.changeFocusedNullTextElementVisibility(true);
 },
 isFocusedNullTextElementDisplayed: function() {
  return this.focusedNullTextElement && ASPx.GetElementDisplay(this.focusedNullTextElement);
 },
 needShowFocusedNullText: function() {
  if(this.focusedNullTextTimerID === -1)
   return this.IsNull(this.GetValue());
  var result = this.GetInputElement().value === "";
  if(this.CanApplyNullTextDecoration)
   result = result && this.CanApplyNullTextDecoration();
  return result;
 }, 
 changeFocusedNullTextElementVisibility: function (visible) {
  this.ensureFocusedNullTextElement();
  ASPx.SetElementDisplay(this.focusedNullTextElement, visible);
  if(visible)
   this.adjustFocusedNullTextElement();  
 },
 getInputElementAbsoluteX: function(input) {
  var result = ASPx.GetAbsoluteX(input);
  if(ASPx.Browser.Opera || ASPx.Browser.AndroidMobilePlatform) 
   result++;
  return result;
 },
 getInputElementAbsoluteY: function (input) {
  var result = ASPx.GetAbsoluteY(input);
  if(ASPx.Browser.Opera || ASPx.Browser.AndroidMobilePlatform) 
   result++;
  return result;
 },
 adjustFocusedNullTextElement: function() {
  var input = this.GetInputElement();
  this.focusedNullTextElement.style.width = input.offsetWidth + "px";
  this.focusedNullTextElement.style.height = input.offsetHeight + "px";
  var inputXPos = this.getInputElementAbsoluteX(input);
  var inputYPos = this.getInputElementAbsoluteY(input);
  ASPx.SetAbsoluteX(this.focusedNullTextElement, inputXPos);
  ASPx.SetAbsoluteY(this.focusedNullTextElement, inputYPos);
  var shiftByX = inputXPos - ASPx.GetAbsoluteX(this.focusedNullTextElement);
  var shiftByY = inputYPos - ASPx.GetAbsoluteY(this.focusedNullTextElement);
  if (shiftByX !== 0)
   this.focusedNullTextElement.style.left = ASPx.PxToFloat(this.focusedNullTextElement.style.left) + shiftByX + "px";
  if (shiftByY !== 0)
   this.focusedNullTextElement.style.top = ASPx.PxToFloat(this.focusedNullTextElement.style.top) + shiftByY + "px";
 },
 ensureAdjustFocusedNullTextElement: function () {
  if(this.isFocusedNullTextElementDisplayed())
   this.adjustFocusedNullTextElement(this.focusedNullTextElement);
 },
 TrySetCursorToStartPosition: function() {
  var input = this.GetInputElement();
  var sel = ASPx.Selection.GetInfo(input);
  if (sel.startPos === sel.endPos && this.IsMaskInfoEmpty()) {
   var pos = this.maskInfo.GetFirstNonLiteralPosition();
   var setCaret = ASPx.Selection.SetCaretPosition.bind(this, input, pos);
   setTimeout(function() {
    if (document.activeElement === input) {
     setCaret();
     setTimeout(setCaret, 50);
    }
   }, 0);
  }
 },
 IsMaskInfoEmpty: function() {
  return this.maskInfo.IsEmpty();
 },
 OnLostFocusCore: function() {
  var wasLocked = this.IsFocusEventsLocked();
  ASPxClientEdit.prototype.OnLostFocusCore.call(this);
  this.CorrectInputMaxLength();
  if(this.maskInfo != null) {
   this.EndShowMaskHint();
   this.HideMaskHint();   
   if(this.maskInfo.ApplyFixes(null))
    this.ApplyMaskInfo(false);
   this.RaiseStandardOnChange();
  }
  if(!wasLocked) {
   this.clearUserInputEventTimerIfRequired();
   this.ToggleTextDecoration();
  }
  this.escCount = 0;
  this.EnsureHidePopupHelpText();
 },
 InputMaxLengthCorrectionRequired: function () {
  return ASPx.Browser.IE && ASPx.Browser.Version >= 10 && (!this.isNative || this.nullText != "");
 },
 CorrectInputMaxLength: function (onFocus) {
  if(this.InputMaxLengthCorrectionRequired()) {
   var input = this.GetInputElement();
   if(!ASPx.IsExists(this.inputMaxLength))
    this.inputMaxLength = input.maxLength;
   input.maxLength = onFocus ? this.inputMaxLength : -1;
  }
 },
 SubscribeToIeDropEvent: function() {
  if(this.InputMaxLengthCorrectionRequired()) {
   var input = this.GetInputElement();
   ASPx.Evt.AttachEventToElement(input, "drop", function(e) { this.CorrectInputMaxLength(true); }.aspxBind(this));
  }
 },
 SetFocus: function() {
  if(this.isPasswordNullTextInputElementExists()) {
   this.GetPasswordNullTextInputElement().focus();
  } else {
     ASPxClientEdit.prototype.SetFocus.call(this);
  }
 },
 OnValueChanged: function() {
  if(this.maskInfo != null) {
   if(this.maskInfo.GetValue() == this.maskValueBeforeUserInput && !this.IsValueChangeForced())
    return;
   this.SavePrevMaskValue();
  }
  if(this.HasTextDecorators())
   this.SyncRawValue();
  if(!this.IsValueChanged() && !this.IsValueChangeForced())
   return;
  this.SaveChangedValue(); 
  ASPxClientEdit.prototype.OnValueChanged.call(this);
 },
 IsValueChangeForced: function() {
  return false;
 },
 OnTextChanged: function() {
 },
 ForceTextChanged: function() {
  this.OnTextChanged();
 },
 SaveChangedValue: function() {
  this.lastChangedValue = this.GetValue();
 },
 RaiseStandardOnChange: function(){
  var element = this.GetInputElement();
  if(element && element.onchange) {
   element.onchange({ target: this.GetInputElement() });
  }
  else if(this.ValueChanged) {
   this.ValueChanged.FireEvent(this);
  }
 },
 RaiseTextChanged: function(processOnServer){
  if(!this.TextChanged.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.TextChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;  
 },
 RaiseUserInput: function () {
  if(!this.UserInput.IsEmpty()) {
   var args = new ASPxClientEventArgs();
   this.UserInput.FireEvent(this, args);
  }
 },
 GetText: function(){
  if(this.maskInfo != null) {
   return this.maskInfo.GetText();
  } else {
   var value = this.GetValue();
   return value != null ? value : "";
  }
 },
 SetText: function (value){
  if(this.maskInfo != null) {
   this.maskInfo.SetText(value);
   this.ApplyMaskInfo(false);
   this.SavePrevMaskValue();
  } else {
   this.SetValue(value);
  }
 },
 SelectAll: function() {
  this.SetSelection(0, -1, false);
 },
 SetCaretPosition: function(pos) {
  var inputElement = this.GetInputElement();
  ASPx.Selection.SetCaretPosition(inputElement, pos);
 },
 GetCaretPosition: function() {
  var inputElement = this.GetInputElement();
  return ASPx.Selection.GetCaretPosition(inputElement);
 },
 SetSelection: function(startPos, endPos, scrollToSelection) { 
  var inputElement = this.GetInputElement();
  ASPx.Selection.Set(inputElement, startPos, endPos, scrollToSelection, true);
 },
 ChangeEnabledAttributes: function(enabled){
  var inputElement = this.GetInputElement();
  if(inputElement){
   this.ChangeInputEnabledAttributes(inputElement, ASPx.Attr.ChangeAttributesMethod(enabled), enabled);
   this.ChangeSpecialInputEnabledAttributes(inputElement, ASPx.Attr.ChangeEventsMethod(enabled), true);
   this.ChangeInputEnabled(inputElement, enabled, this.GetReadOnly());
   if(this.isPasswordNullTextInputElementExists())
    this.GetPasswordNullTextInputElement().disabled = inputElement.disabled;
  }
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientEdit.prototype.SetReadOnlyInternal.call(this, readOnly);
  this.ChangeInputReadOnly(readOnly);
 },
 ChangeReadOnlyStateItems: function(readOnly) {
  ASPxClientEdit.prototype.ChangeReadOnlyStateItems.call(this, readOnly);
  ASPx.GetStateController().SetElementReadOnly(this.GetInputElement(), readOnly);
 },
 ChangeInputReadOnly: function(readOnly) {
  var inputElement = this.GetInputElement();
  if(inputElement)
   inputElement.readOnly = readOnly || !this.GetEnabled() && this.UseReadOnlyForDisabled();
 },
 ChangeEnabledStateItems: function(enabled){
  if(!this.isNative) {
   var sc = ASPx.GetStateController();
   sc.SetElementEnabled(this.GetMainElement(), enabled);
   sc.SetElementEnabled(this.GetInputElement(), enabled);
  }
 },
 ChangeInputEnabled: function(element, enabled, readOnly) {
  if(this.UseReadOnlyForDisabled())
   element.readOnly = !enabled || readOnly;
  else
   element.disabled = !enabled;
 },
 ChangeInputEnabledAttributes: function(element, method, enabled) {
  var ieTabIndexFix = enabled && ASPx.Browser.IE && element.setAttribute && ASPx.Attr.IsExistsAttribute(element, "savedtabIndex");
  method(element, "tabIndex");
  if(!enabled) element.tabIndex = -1;
  if(ieTabIndexFix) { 
   window.setTimeout(function() {
    if(element && element.parentNode)
     element.parentNode.replaceChild(element, element); 
   }, 0);
  }
  method(element, "onclick");
  method(element, "onkeydown");
  method(element, "onkeypress");
  method(element, "onkeyup");
 },
 UseReadOnlyForDisabled: function() {
  return (ASPx.Browser.IE && ASPx.Browser.Version < 10) && !this.isNative;
 },
 NeedFocusCorrectionWhenDisabled: function(){
  return (ASPx.Browser.IE && ASPx.Browser.Version < 10) && !this.isNative;
 },
 OnPostFinalization: function(args) {
  this.TryRestoreDisabledOnPost(args);
  this.TryClearInputTextDecorationOnPost(args);
 },
 TryRestoreDisabledOnPost: function(args) { 
  if(this.GetEnabled() || !this.UseReadOnlyForDisabled() || args.isDXCallback)
   return;
  var inputElement = this.GetInputElement();
  if(inputElement) {
   var inputDisabled = inputElement.disabled;
   inputElement.disabled = true;
   window.setTimeout(function() {
    inputElement.disabled = inputDisabled;
   }, 0);
  }
 },
 GetTempHiddenInputID: function() {
  return this.name + ASPx.TempHiddenInputSuffix;
 },
 TryClearInputTextDecorationOnPost: function(args) {
  if(ASPx.Platform === "NETCORE")
   return;
  if(this.HasTextDecorators() && !ASPx.IsExists(this.GetValue())) {
   var inputElement = this.GetInputElement();
   if(inputElement) {
    var name = ASPx.Attr.GetAttribute(inputElement, "name");
    if(name)
     this.TryClearInputTextDecorationOnPostCore(inputElement, name);
   }
  }
 },
 TryClearInputTextDecorationOnPostCore: function(inputElement, name) {
  var hiddenInput = ASPx.CreateHiddenField(name, this.GetTempHiddenInputID(), inputElement.parentNode);
  ASPx.Attr.SetAttribute(inputElement, "data-name", name);
  ASPx.Attr.RemoveAttribute(inputElement, "name");
  setTimeout(function() {
   ASPx.Attr.SetAttribute(inputElement, "name", name);
   ASPx.Attr.RemoveAttribute(inputElement, "data-name");
   ASPx.RemoveElement(hiddenInput);
  }, 0);
 },
 OnUnload: function() {
  var input = this.GetInputElement();
  if(!input)
   return;
  if(this.IsAutocompleteOffNotRequiredOnUnload())
   ASPx.Attr.RemoveAttribute(input, "autocomplete");
  if(this.focusedNullTextElement)
   ASPx.RemoveElement(this.focusedNullTextElement);
 },
 IsVCardAttributeRequired: function() {
  return this.autoCompleteAttribute && this.autoCompleteAttribute.name !== "autocomplete";
 },
 IsAutocompleteDropDownListRequiredOnFocus: function() {
  return !this.autoCompleteAttribute || this.IsVCardAttributeRequired();
 },
 IsAutocompleteOffRequiredOnInitialize: function() {
  return !this.isNative && (this.autoCompleteAttribute && this.autoCompleteAttribute.name === "autocomplete" || ASPx.Browser.WebKitFamily);
 },
 IsAutocompleteOffRequiredOnLostFocus: function() {
  return !this.autoCompleteAttribute && this.IsNullTextVisible() && !this.IsVCardAttributeRequired();
 },
 IsAutocompleteOffNotRequiredOnUnload: function() {
  return !this.IsNullTextVisible() || this.IsVCardAttributeRequired() || (this.maskInfo != null && this.GetValue() == null);
 },
 IsNullTextVisible: function() {
  return this.nullText && !this.GetValue() && !this.GetText();
 },
 GetModifyEvent: function() {
  return this.UserInput;
 }
});
MaskValidationPattern = ASPx.CreateClass(ASPx.ValidationPattern, {
 constructor: function(errorText, maskInfo) {
  this.constructor.prototype.constructor.call(this, errorText);
  this.maskInfo = maskInfo;
 },
 EvaluateIsValid: function(value) {
  return this.maskInfo.IsValid();
 }
});
ASPx.Ident.IsASPxClientTextEdit = function(obj) {
 return !!obj.isASPxClientTextEdit;
};
var ASPxClientTextBoxBase = ASPx.CreateClass(ASPxClientTextEdit, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.sizingConfig.allowSetHeight = false;
  this.sizingConfig.adjustControl = true;
 }
});
var ASPxClientTextBox = ASPx.CreateClass(ASPxClientTextBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.isASPxClientTextBox = true;
  this.isCaptchaTextBox = false;
 },
 NeedProcessUnload: function() {
  return ASPxClientTextBoxBase.prototype.NeedProcessUnload.call(this) && !this.isCaptchaTextBox;
 },
 IsValueRestoredByBrowser: function() {
  if(this.isCaptchaTextBox)
   return this.initializeInputValue !== "" && this.initializeInputValue !== this.nullText;
  return  ASPxClientTextBoxBase.prototype.IsValueRestoredByBrowser.call(this);
 },
 SynchronizeRestoredValue: function() {
  if(this.isCaptchaTextBox)
   this.SetText(null);
  else
   ASPxClientTextBoxBase.prototype.SynchronizeRestoredValue.call(this);
 },
});
ASPxClientTextBox.Cast = ASPxClientControl.Cast;
ASPx.Ident.IsASPxClientTextBox = function(obj) {
 return !!obj.isASPxClientTextBox;
};
var ASPxClientMemo = ASPx.CreateClass(ASPxClientTextEdit, { 
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);        
  this.isASPxClientMemo = true;
  this.raiseValueChangedOnEnter = false;
  this.maxLength = 0;
  this.pasteTimerID = -1;
  this.pasteTimerActivatorCount = 0;
 },
 Initialize: function() {
  ASPxClientTextEdit.prototype.Initialize.call(this);
  this.SaveChangedValue();
  this.maxLengthRestricted = this.maxLength > 0;
 },
 CutString: function() {
  var text = this.GetText();
  if(text.length > this.maxLength) {
   text = text.substring(0, this.maxLength);
   this.SetText(text);
  }
 },
 EventKeyCodeChangesTheInput: function(evt) {
  if(ASPx.IsPasteShortcut(evt))
   return true;
  else if(evt.ctrlKey)
   return false;
  var keyCode = ASPx.Evt.GetKeyCode(evt);
  var isSystemKey = ASPx.Key.Windows <= keyCode && keyCode <= ASPx.Key.ContextMenu;
  var isFKey = ASPx.Key.F1 <= keyCode && keyCode <= 127; 
  return ASPx.Key.Delete < keyCode && !isSystemKey && !isFKey || keyCode == ASPx.Key.Enter || keyCode == ASPx.Key.Space;
 },
 OnTextChangingCheck: function() {
  if(this.maxLengthRestricted)  
   this.CutString(); 
 },
 StartTextChangingTimer: function() {
  if(this.maxLengthRestricted) {
   if(this.pasteTimerActivatorCount == 0) 
    this.SetTextChangingTimer();
   this.pasteTimerActivatorCount ++;
  }
 },
 EndTextChangingTimer: function() {
  if(this.maxLengthRestricted) {
   this.pasteTimerActivatorCount --;
   if(this.pasteTimerActivatorCount == 0) 
    this.ClearTextChangingTimer();
  }
 },
 CollapseEditor: function() {
  if(!this.IsAdjustmentRequired()) return;
  var mainElement = this.GetMainElement();
  var inputElement = this.GetInputElement();
  if(!ASPx.IsExistsElement(mainElement) || !ASPx.IsExistsElement(inputElement))
   return;
  ASPxClientTextEdit.prototype.CollapseEditor.call(this);
  var mainElementCurStyle = ASPx.GetCurrentStyle(mainElement);
  if(this.heightCorrectionRequired && mainElement && inputElement) {
   if(mainElement.style.height == "100%" || mainElementCurStyle.height == "100%") {
    mainElement.style.height = "0";
    mainElement.wasCollapsed = true;
   }
   inputElement.style.height = "0";
  }
 },
 SetWidth: function(width) {
  ASPxClientTextEdit.prototype.SetWidth.call(this, width);
  if(ASPx.Browser.IE)
   this.AdjustControl();
 },
 SetHeight: function(height) {
  var textarea = this.GetInputElement();
  textarea.style.height = "1px";
  ASPxClientTextEdit.prototype.SetHeight.call(this, height);
  textarea.style.height = ASPx.GetClearClientHeight(this.GetMainElement()) - ASPx.GetTopBottomBordersAndPaddingsSummaryValue(textarea) + "px";
 },
 ClearErrorFrameElementsStyles: function() {
  var textarea = this.GetInputElement();
  if(!textarea)
   return;
  var scrollBarPosition = textarea.scrollTop;
  ASPxClientTextEdit.prototype.ClearErrorFrameElementsStyles.call(this);
  if(ASPx.Browser.Firefox)
   textarea.scrollTop = scrollBarPosition;
 },
 OnMouseOver: function() {
  this.StartTextChangingTimer();
 },  
 OnMouseOut: function() {
  this.EndTextChangingTimer();
 },   
 OnFocus: function() {  
  this.StartTextChangingTimer();
  ASPxClientTextEdit.prototype.OnFocus.call(this);
 },
 OnLostFocus: function() {
  this.EndTextChangingTimer();
  ASPxClientTextEdit.prototype.OnLostFocus.call(this);
 },
 OnKeyDown: function(evt) { 
  if(this.NeedPreventBrowserUndoBehaviour(evt))
   return ASPx.Evt.PreventEvent(evt);
  if(this.maxLengthRestricted){
   var selection = ASPx.Selection.GetInfo(this.GetInputElement()); 
   var noCharToReplace = selection.startPos == selection.endPos;
   if(this.GetText().length >= this.maxLength && noCharToReplace && this.EventKeyCodeChangesTheInput(evt)) {
    return ASPx.Evt.PreventEvent(evt);
   }
  }
  ASPxClientEdit.prototype.OnKeyDown.call(this, evt);
 },
 SetTextChangingTimer: function() {
  this.pasteTimerID = ASPx.Timer.SetControlBoundInterval(this.OnTextChangingCheck, this, ASPx.PasteCheckInterval);
 },
 ClearTextChangingTimer: function() {
  this.pasteTimerID = ASPx.Timer.ClearInterval(this.pasteTimerID);
 },
 getFocusedNullTextElementTagName: function() {
  return "TEXTAREA";
 },
 getCopyFromInputElementStyles: function() {
  var result = ASPxClientTextEdit.prototype.getCopyFromInputElementStyles.call(this);
  result.push("resize");
  return result;
 }
});
ASPxClientMemo.Cast = ASPxClientControl.Cast;
ASPx.Ident.IsASPxClientMemo = function(obj) { return obj && !!obj.isASPxClientMemo; };
var CLEAR_BUTTON_INDEX = -100;
var HIDE_CONTENT_CSS_CLASS_NAME = "dxHideContent";
var setContentVisibility = function(clearButtonElement, value) {
 var action = value ? ASPx.RemoveClassNameFromElement : ASPx.AddClassNameToElement;
 action(clearButtonElement, HIDE_CONTENT_CSS_CLASS_NAME);
};
var CLEAR_BUTTON_DISPLAY_MODE = {
 AUTO: 'Auto',
 ALWAYS: 'Always',
 NEVER: 'Never',
 ON_HOVER: 'OnHover'
};
var AccessibilityFocusedButtonClassName = "dxAFB";
var ButtonEditButtonLeftSystemClassName = "dxeButtonLeft";
var ASPxClientButtonEditBase = ASPx.CreateClass(ASPxClientTextBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);        
  this.allowUserInput = true;
  this.isValueChanging = false;
  this.allowMouseWheel = true;
  this.isMouseOver = false;
  this.buttonCount = 0;
  this.emptyValueMaskDisplayText = "";
  this.clearButtonDisplayMode = CLEAR_BUTTON_DISPLAY_MODE.AUTO;
  this.forceShowClearButtonAlways = false;
  this.recoverClearButtonVisibility = false;
  this.ButtonClick = new ASPxClientEvent();
 },
 Initialize: function() {
  ASPxClientTextBoxBase.prototype.Initialize.call(this);
  this.EnsureEmptyValueMaskDisplayText();
  if(this.HasClearButton())
   this.InitializeClearButton();
  this.InitAccessibilityCompliant();
 },
 InlineInitialize: function() {
  ASPxClientTextBoxBase.prototype.InlineInitialize.call(this);
  if(this.clearButtonDisplayMode === CLEAR_BUTTON_DISPLAY_MODE.AUTO) {
   this.clearButtonDisplayMode = this.IsClearButtonVisibleAuto() || this.forceShowClearButtonAlways ?
    CLEAR_BUTTON_DISPLAY_MODE.ALWAYS : CLEAR_BUTTON_DISPLAY_MODE.NEVER;
  }
  this.EnsureClearButtonVisibility();
 },
 InitializeClearButton: function() {
  if(this.clearButtonDisplayMode === CLEAR_BUTTON_DISPLAY_MODE.ON_HOVER) {
   ASPx.Evt.AttachMouseEnterToElement(this.GetHoverElementToShowClearButton(), this.OnMouseOver.aspxBind(this), this.OnMouseOut.aspxBind(this));
  }
 },
 GetHoverElementToShowClearButton: function() {
  return this.GetMainElement();
 },
 IsClearButtonVisibleAuto: function() {
  return ASPx.Browser.MobileUI;
 },
 SetEnabled: function(enabled) {
  ASPxClientTextBoxBase.prototype.SetEnabled.call(this, enabled);
  this.EnsureClearButtonVisibility();
 },
 EnsureEmptyValueMaskDisplayText: function() {
  if(this.maskInfo && this.HasClearButton()) {
   var savedText = this.maskInfo.GetText();
   this.maskInfo.SetText("");
   this.emptyValueMaskDisplayText = this.maskInfo.GetText();
   this.maskInfo.SetText(savedText);
  }
 },
 GetButton: function(number) {
  return this.GetChildElement("B" + number);
 },
 GetCustomButtonCollection: function() {
  var buttonElements = [];
  for(var i = 0; i < this.buttonCount; i++) {
   var button =  this.GetButton(i);
   if(!!button)
    buttonElements.push(button);
  }
  return buttonElements;
 },
 GetButtonCollection: function() {
  var buttonElements = [];
  var clearButton = this.GetClearButton();
  if(!!clearButton)
   buttonElements.push(clearButton);
  return buttonElements.concat(this.GetCustomButtonCollection());
 },
 GetAccessibilityAnchor: function(buttonElement) {
  var firstChild = buttonElement.firstElementChild;
  var isExistsAnchorElement = ASPx.Attr.GetAttribute(firstChild, "role") === "button";
  return isExistsAnchorElement ? firstChild : null;
 },
 GetButtonByAccessibilityAnchor: function(anchorElement) {
  return anchorElement.parentNode;
 },
 SetAccessibilityAnchorEnabled: function(buttonElement, enabled) {
  var anchorElement = this.GetAccessibilityAnchor(buttonElement);
  if(ASPx.IsExists(anchorElement))
   ASPx.Attr.SetOrRemoveAttribute(anchorElement, "tabindex", enabled ? "0" : "");
 },
 InitAccessibilityCompliant: function() {
  if(!this.accessibilityCompliant) return;
  var buttonElements = this.GetButtonCollection();
  var labelElements = ASPx.FindAssociatedLabelElements(this);
  for(var i = 0; i < buttonElements.length; i++) {
   this.InitAccessibilityAnchor(this.GetAccessibilityAnchor(buttonElements[i]), labelElements);
   ASPx.Evt.AttachEventToElement(buttonElements[i], "mousedown", this.Button_MouseDown.bind(this));
  }
 },
 InitAccessibilityAnchor: function(anchorElement, labelElements) {
  if(!ASPx.IsExists(anchorElement))
   return;
  for(var i = 0; i < labelElements.length; i++)
   this.ariaExplanatoryTextManager.SetOrRemoveText([anchorElement], labelElements[i], true, false, false);
  this.InitAccessibilityAnchorEvents(anchorElement);
 },
 InitAccessibilityAnchorEvents: function(anchorElement) {
  ASPx.Evt.AttachEventToElement(anchorElement, "keydown", function(evt) { this.OnButtonKeysHandling(evt); }.aspxBind(this));
  ASPx.Evt.AttachEventToElement(anchorElement, "keyup", function(evt) { this.OnButtonKeysHandling(evt); }.aspxBind(this));
  ASPx.Evt.AttachEventToElement(anchorElement, "focus", function(evt) { this.OnButtonGotFocus(evt); }.aspxBind(this));
  ASPx.Evt.AttachEventToElement(anchorElement, "blur", function(evt) { this.OnButtonLostFocus(evt); }.aspxBind(this));
 },
 EmulateButtonMouseEvent: function(sourceElement) {
  var buttonElement = this.GetButtonByAccessibilityAnchor(sourceElement);
  var mouseEvent = buttonElement.onclick || buttonElement.onmousedown || buttonElement.ontouchstart || buttonElement.onpointerdown;
  var emulateMouseEvtArgs = { button: 0, which: 1, srcElement: buttonElement, target: buttonElement };
  if(!!mouseEvent) {
   ASPx.Attr.SetAttribute(sourceElement, "aria-pressed", true);
   setTimeout(function() {
    mouseEvent(emulateMouseEvtArgs);
    ASPx.Attr.RemoveAttribute(sourceElement, "aria-pressed");
   }, 300);
  }
 },
 OnButtonKeysHandling: function(evt) {
  var isKeyUp = evt.type == "keyup";
  var keyCode = ASPx.Evt.GetKeyCode(evt);
  var sourceElement = ASPx.Evt.GetEventSource(evt);
  if((keyCode == ASPx.Key.Space && isKeyUp) || (keyCode == ASPx.Key.Enter && !isKeyUp))
   this.EmulateButtonMouseEvent(sourceElement);
  if(keyCode != ASPx.Key.Tab)
   ASPx.Evt.PreventEventAndBubble(evt);
  return false;
 },
 OnButtonGotFocus: function(evt) {
  this.UnlockFocusEvents();
  var editor = ASPx.GetControlCollection().Get(this.name);
  var sourceElement = ASPx.Evt.GetEventSource(evt);
  if(!!editor && !editor.CorrectAccessibilityButtonFocus(sourceElement)) {
   var buttonElement = editor.GetButtonByAccessibilityAnchor(sourceElement);
   ASPx.AddClassNameToElement(buttonElement, this.GetAccessibilityFocusedButtonClassName());
   ASPx.EGotFocus(editor.name);
  }
 },
 OnButtonLostFocus: function(evt) {
  var editor = ASPx.GetControlCollection().Get(this.name);
  var sourceElement = ASPx.Evt.GetEventSource(evt);
  if(!!editor) {
   var buttonElement = editor.GetButtonByAccessibilityAnchor(sourceElement);
   ASPx.RemoveClassNameFromElement(buttonElement, this.GetAccessibilityFocusedButtonClassName());
  }
  setTimeout(function() {
   if(!!editor && !editor.IsEditorElement(ASPx.GetActiveElement())) {
    ASPx.ELostFocus(editor.name);
   }
  }.aspxBind(this), 0);
 },
 Button_MouseDown: function(evt) {
  var editor = ASPx.GetControlCollection().Get(this.name);
  if(!!editor) {
   var sourceElement = ASPx.Evt.GetEventSource(evt);
   if(document.activeElement !== sourceElement)
    this.LockFocusEvents();
  }
 },
 ForceRefocusEditor: function(evt, isNativeFocus) {
  if(this.accessibilityCompliant) {
   var srcElement = ASPx.Evt.GetEventSource(evt);
   var customButtons = this.GetCustomButtonCollection();
   for(var i = 0; i < customButtons.length; i++)
    if(customButtons[i] == srcElement || ASPx.GetIsParent(customButtons[i], srcElement))
     return;
  }
  ASPxClientEdit.prototype.ForceRefocusEditor.call(this, evt, isNativeFocus);
  if(this.GetInputElement().type == "password") {
   window.setTimeout(function() { this.GetInputElement().focus(); }.bind(this), 0);
  }
 },
 CorrectAccessibilityButtonFocus: function(sourceElement) {
  if(ASPx.Attr.IsExistsAttribute(sourceElement, "tabindex"))
   return false;
  setTimeout(function() {
   var buttonElements = this.GetButtonCollection();
   for(var i = 0; i < buttonElements.length; i++)
    if(ASPx.GetIsParent(buttonElements[i], sourceElement))
     this.GetAccessibilityAnchor(buttonElements[i]).focus();
  }.aspxBind(this), 0);
  return true;
 },
 OnKeyDown: function(evt) { 
  if(this.NeedEnsureClearButtonVisibilityOnKeyDown()) {
   var hasClearButtonOnHover = this.HasClearButton() && this.clearButtonDisplayMode === CLEAR_BUTTON_DISPLAY_MODE.ON_HOVER;
   this.recoverClearButtonVisibility = hasClearButtonOnHover && ASPx.Evt.GetKeyCode(evt) == ASPx.Key.Tab && !evt.shiftKey;
  }
  if(this.accessibilityCompliant) {
   var hasVisibleFocusableButtonToTheRIGHT = this.GetButtonCollection().some(function(buttonElement) {
    return this.IsButtonVisible(buttonElement)
     && !ASPx.ElementHasCssClass(buttonElement, ButtonEditButtonLeftSystemClassName)
     && this.GetAccessibilityAnchor(buttonElement) !== null;
   }, this);
   var hasVisibleFocusableButtonToTheLEFT = this.GetButtonCollection().some(function(buttonElement) {
    return this.IsButtonVisible(buttonElement)
     && ASPx.ElementHasCssClass(buttonElement, ButtonEditButtonLeftSystemClassName)
     && this.GetAccessibilityAnchor(buttonElement) !== null;
   }, this);
   if((ASPx.Evt.GetKeyCode(evt) === ASPx.Key.Tab && !evt.shiftKey && hasVisibleFocusableButtonToTheRIGHT) ||
    (ASPx.Evt.GetKeyCode(evt) === ASPx.Key.Tab && evt.shiftKey && hasVisibleFocusableButtonToTheLEFT ))
    this.LockFocusEvents();
  }
  ASPxClientTextBoxBase.prototype.OnKeyDown.call(this, evt);
 },
 NeedEnsureClearButtonVisibilityOnKeyDown: function() {
  return this.accessibilityCompliant;
 },
 GetAccessibilityFocusedButtonClassName: function() {
  return AccessibilityFocusedButtonClassName;
 },
 SetButtonVisible: function(number, value) {
  var button = this.GetButton(number);
  if(!button)
   return;
  var isClearButton = number === CLEAR_BUTTON_INDEX;
  var visibilityModifier = isClearButton ? setContentVisibility : ASPx.SetElementDisplay;
  if(isClearButton && this.clearButtonDisplayMode === CLEAR_BUTTON_DISPLAY_MODE.ALWAYS && this.accessibilityCompliant && this.enabled)
   this.SetAccessibilityAnchorEnabled(button, value);
  visibilityModifier(button, value);
 },
 GetButtonVisible: function(number) {
  var button = this.GetButton(number);
  return this.IsButtonVisible(button);
 },
 IsButtonVisible: function(button) {
  var result = false;
  if(button) {
   if(this.IsClearButtonElement(button) && this.clearButtonDisplayMode === CLEAR_BUTTON_DISPLAY_MODE.ALWAYS)
    result = !ASPx.ElementHasCssClass(button, this.GetHideContentCssClassName());
   else
    result = ASPx.IsElementVisible(button);
  }
  return result;
 },
 GetHideContentCssClassName: function() {
  return HIDE_CONTENT_CSS_CLASS_NAME;
 },
 ProcessInternalButtonClick: function(buttonIndex) {
  return false;
 },
 OnButtonClick: function(number) {
  var processOnServer = this.RaiseButtonClick(number);
  if(!this.ProcessInternalButtonClick(number) && processOnServer)
   this.SendPostBack('BC:' + number);
 },
 GetLastSuccesfullValue: function() {
  return this.lastChangedValue;
 },
 OnClear: function() {
  this.startUserInputEventTimerIfRequired();
  this.ClearEditorValueAndForceOnChange();
  this.ForceRefocusEditor(null, true);
  window.setTimeout(this.EnsureClearButtonVisibility.aspxBind(this), 0);
 },
 ClearEditorValueAndForceOnChange: function() {
  if(this.GetReadOnly() || !this.GetButtonVisible(CLEAR_BUTTON_INDEX))
   return;
  var raiseOnChange = this.ClearEditorValueByClearButton();
  if(raiseOnChange)
   this.ForceStandardOnChange();
 },
 ClearEditorValueByClearButton: function() {
  var prevValue = this.GetLastSuccesfullValue();
  this.ClearEditorValueByClearButtonCore();
  return prevValue !== this.GetValue();
 },
 ClearEditorValueByClearButtonCore: function() {
  this.Clear();
  this.GetInputElement().value = '';
 },
 ForceStandardOnChange: function() {
  this.forceValueChanged = true;
  this.RaiseStandardOnChange();
  this.forceValueChanged = false;
 },
 IsValueChangeForced: function() {
  return this.forceValueChanged || ASPxClientTextBoxBase.prototype.IsValueChangeForced.call(this);
 },
 IsValueChanging: function() { return this.isValueChanging; },
 StartValueChanging: function() { this.isValueChanging = true; },
 EndValueChanging: function() { this.isValueChanging = false; },
 IsClearButtonElement: function(element) {
  return ASPx.GetIsParent(this.GetClearButton(), element);
 },
 OnFocusCore: function() {
  if(this.accessibilityCompliant) {
   if(this.focused) 
    this.UnlockFocusEvents();   
   else 
    ASPxClientTextBoxBase.prototype.OnFocusCore.call(this);
  }
  else
   ASPxClientTextBoxBase.prototype.OnFocusCore.call(this);
  this.EnsureClearButtonVisibility();
 },
 OnLostFocusCore: function() {
  ASPxClientTextBoxBase.prototype.OnLostFocusCore.call(this);
  this.EnsureClearButtonVisibility();
  this.recoverClearButtonVisibility = false;
 },
 GetClearButton: function() {
  return this.GetButton(CLEAR_BUTTON_INDEX);
 },
 HasClearButton: function() {
  return !!this.GetClearButton();
 },
 RequireShowClearButton: function() {
  return !this.IsClearButtonDisabled() && !this.IsClearButtonNotRequired() && this.RequireShowClearButtonInternal();
 },
 IsClearButtonDisabled: function() {
  return !this.clientEnabled || !this.HasClearButton() || this.clearButtonDisplayMode === CLEAR_BUTTON_DISPLAY_MODE.NEVER;
 },
 IsClearButtonNotRequired: function() {
  return !this.IsFocused() && !this.isMouseOver && this.clearButtonDisplayMode !== CLEAR_BUTTON_DISPLAY_MODE.ALWAYS && !this.recoverClearButtonVisibility;
 },
 RequireShowClearButtonInternal: function () {
  return this.IsFocused() && this.RequireShowClearButtonCore() || !this.IsNullState();
 },
 RequireShowClearButtonCore: function() {
  var inputText = this.GetInputElement().value;
  return inputText !== this.GetEmptyValueDisplayText();
 },
 IsFocused: function() {
  return this === ASPx.GetFocusedEditor();
 },
 IsNullState: function() {
  var value = this.GetValue();
  return this.IsNull(value) || value === this.GetEmptyValueDisplayText();
 },
 GetEmptyValueDisplayText: function() { 
  return this.maskInfo ? this.emptyValueMaskDisplayText : "";
 },
 EnsureClearButtonVisibility: function() {
  this.SetButtonVisible(CLEAR_BUTTON_INDEX, this.RequireShowClearButton());
 },
 OnMouseOver: function() {
  this.isMouseOver = true;
  this.EnsureClearButtonVisibility();
 },
 OnMouseOut: function() {
  this.isMouseOver = false;
  this.EnsureClearButtonVisibility();
 },
 OnKeyPress: function(evt) {
  if(this.allowUserInput)
   ASPxClientTextBoxBase.prototype.OnKeyPress.call(this, evt);
 },
 OnKeyEventEnd: function(evt, withDelay) {
  ASPxClientTextBoxBase.prototype.OnKeyEventEnd.call(this, evt, withDelay);
  this.EnsureClearButtonVisibility();
 },
 RaiseButtonClick: function(number){
  var processOnServer = this.autoPostBack || this.IsServerEventAssigned("ButtonClick");
  if(!this.ButtonClick.IsEmpty()){
   var args = new ASPxClientButtonEditClickEventArgs(processOnServer, number);
   this.ButtonClick.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 ChangeEnabledAttributes: function(enabled){
  ASPxClientTextEdit.prototype.ChangeEnabledAttributes.call(this, enabled);
  for(var i = 0; i < this.buttonCount; i++){
   var element = this.GetButton(i);
   if(element)
    this.ChangeButtonEnabledAttributes(element, this.GetChangeButtonEnabledAttributesMethod(enabled));
  }
  if(this.accessibilityCompliant)
   this.ChangeAccessibilityButtonEnabledAttributes(enabled);
 },
 ChangeEnabledStateItems: function(enabled){
  ASPxClientTextEdit.prototype.ChangeEnabledStateItems.call(this, enabled);
  for(var i = 0; i < this.buttonCount; i++){
   var element = this.GetButton(i);
   if(element) 
    ASPx.GetStateController().SetElementEnabled(element, enabled);
  }
 },
 GetChangeButtonEnabledAttributesMethod: function(enabled) {
  return ASPx.Attr.ChangeAttributesMethod(enabled);
 },
 ChangeButtonEnabledAttributes: function(element, method){
  method(element, "onclick");
  method(element, "ondblclick");
  if(ASPx.Browser.Edge)
   method(element, "onmousedown");
  method(element, "on" + ASPx.TouchUIHelper.touchMouseDownEventName);
  method(element, "on" + ASPx.TouchUIHelper.touchMouseUpEventName);
 },
 ChangeInputEnabled: function(element, enabled, readOnly) {
  ASPxClientTextEdit.prototype.ChangeInputEnabled.call(this, element, enabled, readOnly || !this.allowUserInput);
 },
 ChangeAccessibilityButtonEnabledAttributes: function(enabled) {
  var buttonElements = this.GetButtonCollection();
  for(var i = 0; i < buttonElements.length; i++)
   this.SetAccessibilityAnchorEnabled(buttonElements[i], enabled);
 },
 SetValue: function(value) {
  ASPxClientTextEdit.prototype.SetValue.call(this, value);
  if(!this.IsFocused())
   this.EnsureClearButtonVisibility();
 },
 OnAssociatedLabelClick: function(focusableElement) {
  var isValidElement = focusableElement && ASPx.IsActionElement(focusableElement) && ASPx.GetIsParent(this.GetMainElement(), focusableElement) && ASPx.IsElementVisible(focusableElement);
  if(isValidElement)
   focusableElement.focus();
  else
   this.SetFocus();
 },
 onClearButtonClick: function() {
  var requireFocus = !ASPx.Browser.VirtualKeyboardSupported || ASPx.Browser.MSTouchUI;
  if(this.ownerListBox)
   this.ownerListBox.ForceLockFocusEvents();
  if((requireFocus && !this.IsFocused()) || this.accessibilityCompliant)
   this.GetInputElement().focus();
  if(this.IsFocused() || !requireFocus) {
   if(this.ownerListBox)
    this.ownerListBox.UnlockFocusEvents();
   this.OnClear();
  }
  else
   window.setTimeout(this.onClearButtonClick.bind(this), 100);
 }
});
var ASPxClientButtonEdit = ASPx.CreateClass(ASPxClientButtonEditBase, {
});
ASPxClientButtonEdit.Cast = ASPxClientControl.Cast;
var ASPxClientButtonEditClickEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(processOnServer, buttonIndex){
  this.constructor.prototype.constructor.call(this, processOnServer);
  this.buttonIndex = buttonIndex;
 }
});
var ASPxClientTextEditHelpTextHAlign = {
 Left: "Left",
 Right: "Right",
 Center: "Center"
};
var ASPxClientTextEditHelpTextVAlign = {
 Top: "Top",
 Bottom: "Bottom",
 Middle: "Middle"
};
var ASPxClientTextEditHelpTextDisplayMode = {
 Inline: "Inline",
 Popup: "Popup"
};
var ASPxClientTextEditHelpTextConsts = {
 VERTICAL_ORIENTATION_CLASS_NAME: "dxeVHelpTextSys",
 HORIZONTAL_ORIENTATION_CLASS_NAME: "dxeHHelpTextSys"
};
var ASPxClientTextEditHelpText = ASPx.CreateClass(null, {
 constructor: function (editor, helpTextStyle, helpText, position, hAlign, vAlign, margins, animationEnabled, helpTextDisplayMode) {
  this.hAlign = hAlign;
  this.vAlign = vAlign;
  this.animationEnabled = animationEnabled;
  this.displayMode = helpTextDisplayMode;
  this.editor = editor;
  this.editorMainElement = editor.GetMainElement();
  this.margins = margins ? { Top: margins[0], Right: margins[1], Bottom: margins[2], Left: margins[3] } : null;
  this.defaultMargins = { Top: 10, Right: 10, Bottom: 10, Left: 10 };
  this.position = position;
  this.helpTextElement = this.createHelpTextElement();
  this.setHelpTextZIndex(true);
  this.prepareHelpTextElement(helpTextStyle, helpText);
 },
 getRows: function (table) {
  return ASPx.GetChildNodesByTagName(table, "TR");
 },
 getCells: function (row) {
  return ASPx.GetChildNodesByTagName(row, "TD");
 },
 getCellByIndex: function(row, cellIndex) {
  return this.getCells(row)[cellIndex];
 },
 getCellIndex: function(row, cell) {
  var cells = this.getCells(row);
  for(var i = 0; i < cells.length; i++) {
   if(cells[i] === cell)
    return i;
  }
 },
 isHorizontal: function(position) {
  return position === ASPx.Position.Left || position === ASPx.Position.Right;
 },
 isVertical: function (position) {
  return position === ASPx.Position.Top || position === ASPx.Position.Bottom;
 },
 createEmptyCell: function(assignClassName) {
  var cell = document.createElement("TD");
  if(assignClassName)
   cell.className = "dxeFakeEmptyCell";
  return cell;
 },
 addHelpTextCellToExternalTableWithTwoCells: function (captionCell, errorCell, helpTextCell, errorTableBody, tableRows) {
  var captionPosition = this.editor.captionPosition;
  var errorCellPosition = this.editor.errorCellPosition;
  var helpTextRow = this.isVertical(this.position) ? document.createElement("TR") : null;
  if(captionPosition === ASPx.Position.Left && this.position === ASPx.Position.Left && this.isHorizontal(errorCellPosition))
   captionCell.parentNode.insertBefore(helpTextCell, captionCell.nextSibling);
  if(captionPosition === ASPx.Position.Right && this.position === ASPx.Position.Right && this.isHorizontal(errorCellPosition))
   captionCell.parentNode.insertBefore(helpTextCell, captionCell);
  if(captionPosition === ASPx.Position.Left && this.position === ASPx.Position.Right && this.isHorizontal(errorCellPosition))
   tableRows[0].appendChild(helpTextCell);
  if(captionPosition === ASPx.Position.Right && this.position === ASPx.Position.Left && this.isHorizontal(errorCellPosition))
   tableRows[0].insertBefore(helpTextCell, tableRows[0].childNodes[0]);
  if(captionPosition === ASPx.Position.Top && this.position === ASPx.Position.Bottom && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.appendChild(helpTextRow);
  }
  if(captionPosition === ASPx.Position.Bottom && this.position === ASPx.Position.Top && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
  }
  if(captionPosition === ASPx.Position.Top && this.position === ASPx.Position.Top && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.insertBefore(helpTextRow, captionCell.parentNode.nextSibling);
  }
  if(captionPosition === ASPx.Position.Bottom && this.position === ASPx.Position.Bottom && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.insertBefore(helpTextRow, captionCell.parentNode);
  }
  if(captionPosition === ASPx.Position.Right && this.position === ASPx.Position.Top && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(helpTextCell);
   helpTextRow.appendChild(this.createEmptyCell());
   errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
  }
  if(this.position === ASPx.Position.Bottom) {
   if(captionPosition === ASPx.Position.Right && errorCellPosition === ASPx.Position.Top || captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Right) {
    helpTextRow.appendChild(helpTextCell);
    helpTextRow.appendChild(this.createEmptyCell());
    errorTableBody.appendChild(helpTextRow);
   }
  }
  if(captionPosition === ASPx.Position.Left && this.position === ASPx.Position.Top && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(this.createEmptyCell());
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
  }
  if(captionPosition === ASPx.Position.Left && this.position === ASPx.Position.Bottom && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(this.createEmptyCell());
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.appendChild(helpTextRow);
  }
  if(this.position === ASPx.Position.Right) {
   if(captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Left || captionPosition === ASPx.Position.Left && errorCellPosition === ASPx.Position.Top
    || captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Right) {
    tableRows[1].appendChild(helpTextCell);
    tableRows[0].appendChild(this.createEmptyCell());
   }
   if(captionPosition === ASPx.Position.Left && errorCellPosition === ASPx.Position.Bottom || captionPosition === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Left) {
    tableRows[0].appendChild(helpTextCell);
    tableRows[1].appendChild(this.createEmptyCell());
   }
  }
  if(this.position === ASPx.Position.Left) {
   if(captionPosition === ASPx.Position.Right && errorCellPosition === ASPx.Position.Top || captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Right
    || captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Left) {
    tableRows[1].insertBefore(helpTextCell, tableRows[1].childNodes[0]);
    tableRows[0].insertBefore(this.createEmptyCell(), tableRows[0].childNodes[0]);
   }
   if(captionPosition === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Top || captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Bottom) {
    tableRows[1].insertBefore(helpTextCell, tableRows[1].childNodes[0]);
    tableRows[0].insertBefore(this.createEmptyCell(errorCellPosition === ASPx.Position.Top), tableRows[0].childNodes[0]);
    tableRows[2].insertBefore(this.createEmptyCell(errorCellPosition !== ASPx.Position.Top), tableRows[2].childNodes[0]);
   }
   if(captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Top) {
    tableRows[2].insertBefore(helpTextCell, tableRows[2].childNodes[0]);
    tableRows[0].insertBefore(this.createEmptyCell(false), tableRows[0].childNodes[0]);
    tableRows[1].insertBefore(this.createEmptyCell(true), tableRows[1].childNodes[0]);
   }
   if(captionPosition === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Bottom) {
    tableRows[0].insertBefore(helpTextCell, tableRows[0].childNodes[0]);
    tableRows[1].insertBefore(this.createEmptyCell(true), tableRows[1].childNodes[0]);
    tableRows[2].insertBefore(this.createEmptyCell(false), tableRows[2].childNodes[0]);
   }
   if(captionPosition === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Left || captionPosition === ASPx.Position.Right && errorCellPosition === ASPx.Position.Bottom
    || captionPosition === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Right) {
    tableRows[0].insertBefore(helpTextCell, tableRows[0].childNodes[0]);
    tableRows[1].insertBefore(this.createEmptyCell(), tableRows[1].childNodes[0]);
   }
   if(captionPosition === ASPx.Position.Left && this.isVertical(errorCellPosition)) {
    captionCell.parentNode.insertBefore(helpTextCell, captionCell.nextSibling);
    var emptyCellParentRow = errorCellPosition === ASPx.Position.Top ? tableRows[0] : tableRows[1];
    var helpTextCellIndex = this.getCellIndex(helpTextCell.parentNode, helpTextCell);
    emptyCellParentRow.insertBefore(this.createEmptyCell(), this.getCellByIndex(emptyCellParentRow, helpTextCellIndex));
   }
  }
  if(this.position === ASPx.Position.Right) {
   if(captionPosition === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Top || captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Bottom) {
    tableRows[1].appendChild(helpTextCell);
    tableRows[0].appendChild(this.createEmptyCell(errorCellPosition === ASPx.Position.Top));
    tableRows[2].appendChild(this.createEmptyCell(errorCellPosition !== ASPx.Position.Top));
   }
   if(captionPosition === ASPx.Position.Top && errorCellPosition === ASPx.Position.Top) {
    tableRows[2].appendChild(helpTextCell);
    tableRows[0].appendChild(this.createEmptyCell(false));
    tableRows[1].appendChild(this.createEmptyCell(true));
   }
   if(captionPosition === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Bottom) {
    tableRows[0].appendChild(helpTextCell);
    tableRows[1].appendChild(this.createEmptyCell(true));
    tableRows[2].appendChild(this.createEmptyCell(false));
   }
   if(captionPosition === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Right) {
    tableRows[0].appendChild(helpTextCell);
    tableRows[1].appendChild(this.createEmptyCell());
   }
   if(captionPosition === ASPx.Position.Right && this.isVertical(errorCellPosition)) {
    captionCell.parentNode.insertBefore(helpTextCell, captionCell);
    var emptyCellParentRow = errorCellPosition === ASPx.Position.Top ? tableRows[0] : tableRows[1];
    var helpTextCellIndex = this.getCellIndex(helpTextCell.parentNode, helpTextCell);
    emptyCellParentRow.insertBefore(this.createEmptyCell(), this.getCellByIndex(emptyCellParentRow, helpTextCellIndex));
   }
  }
  if(captionPosition === ASPx.Position.Top && this.position === ASPx.Position.Top && this.isHorizontal(errorCellPosition)) {
   if(errorCellPosition === ASPx.Position.Left) {
    helpTextRow.appendChild(this.createEmptyCell(true));
    helpTextRow.appendChild(helpTextCell);
   }
   else {
    helpTextRow.appendChild(helpTextCell);
    helpTextRow.appendChild(this.createEmptyCell());
   }
   errorTableBody.insertBefore(helpTextRow, captionCell.parentNode.nextSibling);
  }
  if(captionPosition === ASPx.Position.Bottom && this.position === ASPx.Position.Top && this.isHorizontal(errorCellPosition)) {
   if(errorCellPosition === ASPx.Position.Left) {
    helpTextRow.appendChild(this.createEmptyCell(true));
    helpTextRow.appendChild(helpTextCell);
   }
   else {
    helpTextRow.appendChild(helpTextCell);
    helpTextRow.appendChild(this.createEmptyCell());
   }
   errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
  }
  if(captionPosition === ASPx.Position.Bottom && this.position === ASPx.Position.Bottom && this.isHorizontal(errorCellPosition)) {
   if(errorCellPosition === ASPx.Position.Left) {
    helpTextRow.appendChild(this.createEmptyCell(true));
    helpTextRow.appendChild(helpTextCell);
   }
   else {
    helpTextRow.appendChild(helpTextCell);
    helpTextRow.appendChild(this.createEmptyCell());
   }
   errorTableBody.insertBefore(helpTextRow, captionCell.parentNode);
  }
  if(captionPosition === ASPx.Position.Top && this.position === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Left) {
   helpTextRow.appendChild(this.createEmptyCell(true));
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.appendChild(helpTextRow);
  }
  if(captionPosition === ASPx.Position.Right && this.position === ASPx.Position.Bottom && errorCellPosition === ASPx.Position.Bottom) {
   helpTextRow.appendChild(helpTextCell);
   helpTextRow.appendChild(this.createEmptyCell());
   errorTableBody.appendChild(helpTextRow);
  }
  if(this.position === ASPx.Position.Bottom) {
   if(captionPosition === ASPx.Position.Left && errorCellPosition === ASPx.Position.Right || captionPosition === ASPx.Position.Right && errorCellPosition === ASPx.Position.Left) {
    helpTextRow.appendChild(this.createEmptyCell(errorCellPosition !== ASPx.Position.Right));
    helpTextRow.appendChild(helpTextCell);
    helpTextRow.appendChild(this.createEmptyCell(errorCellPosition === ASPx.Position.Right));
    errorTableBody.appendChild(helpTextRow);
   }
   if(captionPosition === ASPx.Position.Left && errorCellPosition === ASPx.Position.Left) {
    helpTextRow.appendChild(this.createEmptyCell(false));
    helpTextRow.appendChild(this.createEmptyCell(true));
    helpTextRow.appendChild(helpTextCell);
    errorTableBody.appendChild(helpTextRow);
   }
   if(captionPosition === ASPx.Position.Right && errorCellPosition === ASPx.Position.Right) {
    helpTextRow.appendChild(helpTextCell);
    helpTextRow.appendChild(this.createEmptyCell(true));
    helpTextRow.appendChild(this.createEmptyCell(false));
    errorTableBody.appendChild(helpTextRow);
   }   
  }
  if(this.position === ASPx.Position.Top) {
   if(captionPosition === ASPx.Position.Left && errorCellPosition === ASPx.Position.Right || captionPosition === ASPx.Position.Right && errorCellPosition === ASPx.Position.Left) {
    helpTextRow.appendChild(this.createEmptyCell(errorCellPosition !== ASPx.Position.Right));
    helpTextRow.appendChild(helpTextCell);
    helpTextRow.appendChild(this.createEmptyCell(errorCellPosition === ASPx.Position.Right));
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   }
   if(captionPosition === ASPx.Position.Left && errorCellPosition === ASPx.Position.Left) {
    helpTextRow.appendChild(this.createEmptyCell(false));
    helpTextRow.appendChild(this.createEmptyCell(true));
    helpTextRow.appendChild(helpTextCell);
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   }
   if(captionPosition === ASPx.Position.Right && errorCellPosition === ASPx.Position.Right) {
    helpTextRow.appendChild(helpTextCell);
    helpTextRow.appendChild(this.createEmptyCell(true));
    helpTextRow.appendChild(this.createEmptyCell(false));
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   }
  }
 },
 addHelpTextCellToExternalTableWithErrorCell: function (errorCell, helpTextCell, errorTableBody, tableRows) {
  var errorCellPosition = this.editor.errorCellPosition;
  var helpTextRow = document.createElement("TR");
  if(this.position === ASPx.Position.Left && this.isHorizontal(errorCellPosition))
   tableRows[0].insertBefore(helpTextCell, tableRows[0].childNodes[0]);
  if(this.position === ASPx.Position.Right && this.isHorizontal(errorCellPosition))
   tableRows[0].appendChild(helpTextCell);
  if(this.position === ASPx.Position.Top && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
  }
  if(this.position === ASPx.Position.Bottom && this.isVertical(errorCellPosition)) {
   helpTextRow.appendChild(helpTextCell);
   errorTableBody.appendChild(helpTextRow);
  }
  if(errorCellPosition === ASPx.Position.Left && this.isVertical(this.position)) {
   helpTextRow.appendChild(this.createEmptyCell(true));
   helpTextRow.appendChild(helpTextCell);
   if(this.position === ASPx.Position.Top)
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   else
    errorTableBody.appendChild(helpTextRow);
  }
  if(errorCellPosition === ASPx.Position.Right && this.isVertical(this.position)) {
   helpTextRow.appendChild(helpTextCell);
   helpTextRow.appendChild(this.createEmptyCell(true));
   if(this.position === ASPx.Position.Top)
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   else
    errorTableBody.appendChild(helpTextRow);
  }
  if(this.position === ASPx.Position.Left && this.isVertical(errorCellPosition)) {
   var helpTextParentRowIndex = errorCellPosition === ASPx.Position.Top ? 1 : 0;
   var emptyCellRowIndex = helpTextParentRowIndex === 0 ? 1 : 0;
   tableRows[helpTextParentRowIndex].insertBefore(helpTextCell, tableRows[helpTextParentRowIndex].childNodes[0]);
   tableRows[emptyCellRowIndex].insertBefore(this.createEmptyCell(true), tableRows[emptyCellRowIndex].childNodes[0]);
  }
  if(this.position === ASPx.Position.Right && this.isVertical(errorCellPosition)) {
   var helpTextParentRowIndex = errorCellPosition === ASPx.Position.Top ? 1 : 0;
   var emptyCellRowIndex = helpTextParentRowIndex === 0 ? 1 : 0;
   tableRows[helpTextParentRowIndex].appendChild(helpTextCell);
   tableRows[emptyCellRowIndex].appendChild(this.createEmptyCell(true));
  }
 },
 addHelpTextCellToExternalTableWithCaption: function (captionCell, helpTextCell, errorTableBody, tableRows) {
  var captionPosition = this.editor.captionPosition;
  var helpTextRow = document.createElement("TR");
  if(captionPosition === ASPx.Position.Left && this.isVertical(this.position)) {
   helpTextRow.appendChild(this.createEmptyCell());
   helpTextRow.appendChild(helpTextCell);
   if(this.position === ASPx.Position.Top)
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   else
    errorTableBody.appendChild(helpTextRow);
  }
  if(this.position === ASPx.Position.Left && this.isVertical(captionPosition)) {
   var helpTextParentRowIndex = captionPosition === ASPx.Position.Top ? 1 : 0;
   var emptyCellParentRowIndex = helpTextParentRowIndex === 0 ? 1 : 0;
   tableRows[helpTextParentRowIndex].insertBefore(helpTextCell, tableRows[helpTextParentRowIndex].childNodes[0]);
   tableRows[emptyCellParentRowIndex].insertBefore(this.createEmptyCell(), tableRows[emptyCellParentRowIndex].childNodes[0]);
  }
  if(this.position === ASPx.Position.Right && this.isVertical(captionPosition)) {
   var helpTextParentRowIndex = captionPosition === ASPx.Position.Top ? 1 : 0;
   var emptyCellParentRowIndex = helpTextParentRowIndex === 0 ? 1 : 0;
   tableRows[helpTextParentRowIndex].appendChild(helpTextCell);
   tableRows[emptyCellParentRowIndex].appendChild(this.createEmptyCell());
  }
  if(captionPosition === ASPx.Position.Right && this.isVertical(this.position)) {
   helpTextRow.appendChild(helpTextCell);
   helpTextRow.appendChild(this.createEmptyCell());
   if(this.position === ASPx.Position.Top)
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   else
    errorTableBody.appendChild(helpTextRow);
  }
  if(this.isVertical(captionPosition) && this.isVertical(this.position)) {
   helpTextRow.appendChild(helpTextCell);
   if(captionPosition === ASPx.Position.Top && this.position === ASPx.Position.Top)
    errorTableBody.insertBefore(helpTextRow, captionCell.parentNode.nextSibling);
   if(captionPosition === ASPx.Position.Top && this.position === ASPx.Position.Bottom)
    errorTableBody.appendChild(helpTextRow);
   if(captionPosition === ASPx.Position.Bottom && this.position === ASPx.Position.Top)
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   if(captionPosition === ASPx.Position.Bottom && this.position === ASPx.Position.Bottom)
    errorTableBody.insertBefore(helpTextRow, captionCell.parentNode);
  }
  if(captionPosition === ASPx.Position.Left && this.position === ASPx.Position.Left)
   captionCell.parentNode.insertBefore(helpTextCell, captionCell.nextSibling);
  if(captionPosition === ASPx.Position.Right && this.position === ASPx.Position.Right)
   captionCell.parentNode.insertBefore(helpTextCell, captionCell);
  if(captionPosition === ASPx.Position.Left && this.position === ASPx.Position.Right)
   tableRows[0].appendChild(helpTextCell);
  if(captionPosition === ASPx.Position.Right && this.position === ASPx.Position.Left)
   tableRows[0].insertBefore(helpTextCell, tableRows[0].childNodes[0]);
 },
 addHelpTextCellToExternalTableWithEditorOnly: function (helpTextCell, errorTableBody, tableRows) {
  if(this.isHorizontal(this.position)) {
   if(this.position === ASPx.Position.Left)
    tableRows[0].insertBefore(helpTextCell, tableRows[0].childNodes[0]);
   else
    tableRows[0].appendChild(helpTextCell);
  }
  else {
   var helpTextRow = document.createElement("TR");
   helpTextRow.appendChild(helpTextCell);
   if(this.position === ASPx.Position.Top)
    errorTableBody.insertBefore(helpTextRow, errorTableBody.childNodes[0]);
   else
    errorTableBody.appendChild(helpTextRow);
  }
 },
 addHelpTextCellToExternalTable: function (errorTable, helpTextCell) {
  var errorTableBody = ASPx.GetNodeByTagName(errorTable, "TBODY", 0);
  var tableRows = this.getRows(errorTableBody);
  var captionCell = this.editor.GetCaptionCell();
  var errorCell = this.editor.GetErrorCell();
  if(captionCell) {
   if(errorCell)
    this.addHelpTextCellToExternalTableWithTwoCells(captionCell, errorCell, helpTextCell, errorTableBody, tableRows);
   else
    this.addHelpTextCellToExternalTableWithCaption(captionCell, helpTextCell, errorTableBody, tableRows);
  }
  else if(errorCell)
   this.addHelpTextCellToExternalTableWithErrorCell(errorCell, helpTextCell, errorTableBody, tableRows);
  else
   this.addHelpTextCellToExternalTableWithEditorOnly(helpTextCell, errorTableBody, tableRows);
 },
 createExternalTable: function () {
  var externalTable = document.createElement("TABLE");
  externalTable.id = this.editor.name + ASPx.EditElementSuffix.ExternalTable;
  externalTable.cellPadding = 0;
  externalTable.cellSpacing = 0;
  this.applyExternalTableStyle(externalTable);
  var editorWidth = this.editorMainElement.style.width;
  if(ASPx.IsPercentageSize(editorWidth)) {
   externalTable.style.width = editorWidth;
   this.editorMainElement.style.width = "100%";
   this.editor.width = "100%";
  }
  var externalTableBody = document.createElement("TBODY");
  var externalTableRow = document.createElement("TR");
  var externalTableCell = document.createElement("TD");
  externalTable.appendChild(externalTableBody);
  externalTableBody.appendChild(externalTableRow);
  externalTableRow.appendChild(externalTableCell);
  this.editorMainElement.parentNode.appendChild(externalTable);
  ASPx.ChangeElementContainer(this.editorMainElement, externalTableCell, true);
  if(this.editor.accessibilityCompliant)
   ASPx.Attr.SetAttribute(externalTable, "role", "presentation");
  return externalTable;
 },
 applyExternalTableStyle: function (externalTable) {
  var externalTableStyle = this.editor.externalTableStyle;
  if(externalTableStyle.length > 0) {
   this.applyStyleToElement(externalTable, externalTableStyle);
  }
 },
 applyStyleToElement: function(element, style) {
  element.className = style[0];
  if(style[1]) {
   var styleSheet = ASPx.GetCurrentStyleSheet();
   element.className += " " + ASPx.CreateImportantStyleRule(styleSheet, style[1]);
  }
 },
 createInlineHelpTextElement: function () {
  var helpTextElement = document.createElement("TD");
  var externalTable = this.editor.GetExternalTable();
  if(!externalTable)
   externalTable = this.createExternalTable();
  this.addHelpTextCellToExternalTable(externalTable, helpTextElement);
  return helpTextElement;
 },
 createPopupHelpTextElement: function () {
  var helpTextElement = document.createElement("DIV");
  ASPx.InsertElementAfter(helpTextElement, this.editor.GetMainElement());
  ASPx.AnimationHelper.setOpacity(helpTextElement, 0);
  ASPx.SetElementDisplay(helpTextElement, false);
  return helpTextElement;
 },
 createHelpTextElement: function () {
  return this.displayMode === ASPxClientTextEditHelpTextDisplayMode.Popup ?
   this.createPopupHelpTextElement() : this.createInlineHelpTextElement();
 },
 prepareHelpTextElement: function (helpTextStyle, helpText) {
  this.helpTextElement.id = this.getHelpTextElementId();
  this.applyStyleToElement(this.helpTextElement, helpTextStyle);
  ASPx.SetInnerHtml(this.helpTextElement, "<SPAN>" + helpText + "</SPAN>");
  if(this.displayMode === ASPxClientTextEditHelpTextDisplayMode.Popup)
   this.updatePopupHelpTextPosition();
  else {
   var isVerticalOrientation = this.position === ASPx.Position.Top || this.position === ASPx.Position.Bottom;
   var orientationClassName = isVerticalOrientation ? ASPxClientTextEditHelpTextConsts.VERTICAL_ORIENTATION_CLASS_NAME :
    ASPxClientTextEditHelpTextConsts.HORIZONTAL_ORIENTATION_CLASS_NAME;
   this.helpTextElement.className += " " + orientationClassName;
   this.setInlineHelpTextElementAlign();
   ASPx.SetElementDisplay(this.helpTextElement, this.editor.clientVisible);
  }
 },
 getHelpTextElementId: function() {
  return this.editor.name + ASPx.TEHelpTextElementSuffix;
 },
 setInlineHelpTextElementAlign: function() {
  var hAlignValue = "", vAlignValue = "";
  switch(this.hAlign) {
   case ASPxClientTextEditHelpTextHAlign.Left: hAlignValue = "left"; break;
   case ASPxClientTextEditHelpTextHAlign.Right: hAlignValue = "right"; break;
   case ASPxClientTextEditHelpTextHAlign.Center: hAlignValue = "center"; break;
  }
  switch(this.vAlign) {
   case ASPxClientTextEditHelpTextVAlign.Top: vAlignValue = "top"; break;
   case ASPxClientTextEditHelpTextVAlign.Bottom: vAlignValue = "bottom"; break;
   case ASPxClientTextEditHelpTextVAlign.Middle: vAlignValue = "middle"; break;
  }
  this.helpTextElement.style.textAlign = hAlignValue;
  this.helpTextElement.style.verticalAlign = vAlignValue;
 },
 getHelpTextMargins: function() {
  if(this.margins)
   return this.margins;
  var result = this.defaultMargins;
  if(this.position === ASPx.Position.Top || this.position === ASPx.Position.Bottom)
   result.Left = result.Right = 0;
  else
   result.Top = result.Bottom = 0;
  return result;
 },
 updatePopupHelpTextPosition: function (editorMainElement) {
  var editorWidth = this.editorMainElement.offsetWidth;
  var editorHeight = this.editorMainElement.offsetHeight;
  var helpTextWidth = this.helpTextElement.offsetWidth;
  var helpTextHeight = this.helpTextElement.offsetHeight;
  var editorX = ASPx.GetAbsoluteX(this.editorMainElement);
  var editorY = ASPx.GetAbsoluteY(this.editorMainElement);
  var helpTextX = 0, helpTextY = 0;
  var margins = this.getHelpTextMargins();
  if(this.position === ASPx.Position.Top || this.position === ASPx.Position.Bottom) {
   if(this.position === ASPx.Position.Top)
    helpTextY = editorY - margins.Bottom - helpTextHeight;
   else if(this.position === ASPx.Position.Bottom)
    helpTextY = editorY + editorHeight + margins.Top;
   if(this.hAlign === ASPxClientTextEditHelpTextHAlign.Left)
    helpTextX = editorX + margins.Left;
   else if(this.hAlign === ASPxClientTextEditHelpTextHAlign.Right)
    helpTextX = editorX + editorWidth - helpTextWidth - margins.Right;
   else if(this.hAlign === ASPxClientTextEditHelpTextHAlign.Center) {
    var editorCenterX = editorX + editorWidth / 2;
    var helpTextWidthWithMargins = helpTextWidth + margins.Left + margins.Right;
    helpTextX = editorCenterX - helpTextWidthWithMargins / 2 + margins.Left;
   }
  } else {
   if(this.position === ASPx.Position.Left)
    helpTextX = editorX - margins.Right - helpTextWidth;
   else if(this.position === ASPx.Position.Right)
    helpTextX = editorX + editorWidth + margins.Left;
   if(this.vAlign === ASPxClientTextEditHelpTextVAlign.Top)
    helpTextY = editorY + margins.Top;
   else if(this.vAlign === ASPxClientTextEditHelpTextVAlign.Bottom)
    helpTextY = editorY + editorHeight - helpTextHeight - margins.Bottom;
   else if(this.vAlign === ASPxClientTextEditHelpTextVAlign.Middle) {
    var editorCenterY = editorY + editorHeight / 2;
    var helpTextHeightWithMargins = helpTextHeight + margins.Top + margins.Bottom;
    helpTextY = editorCenterY - helpTextHeightWithMargins / 2 + margins.Top;
   }
  }
  helpTextX = helpTextX < 0 ? 0 : helpTextX;
  helpTextY = helpTextY < 0 ? 0 : helpTextY;
  ASPx.SetAbsoluteX(this.helpTextElement, helpTextX);
  ASPx.SetAbsoluteY(this.helpTextElement, helpTextY);
 },
 setHelpTextZIndex: function (hide) { 
  var newZIndex = 41998 * (hide ? -1 : 1);
  if(this.helpTextElement.style.zIndex != newZIndex)
   this.helpTextElement.style.zIndex = newZIndex;
 },
 hide: function () {
  if(this.displayMode === ASPxClientTextEditHelpTextDisplayMode.Inline) {
   ASPx.SetElementDisplay(this.helpTextElement, false);
  }
  else
   this.hidePopupHelpText();
 },
 hidePopupHelpText: function() {
  var onHidePopupHelpTextComplete = function () {
   this.setHelpTextZIndex(true);
   ASPx.SetElementDisplay(this.helpTextElement, false);
  }.aspxBind(this);
  if(this.animationEnabled)
   ASPx.AnimationHelper.fadeOut(this.helpTextElement, onHidePopupHelpTextComplete);
  else {
   ASPx.AnimationHelper.setOpacity(this.helpTextElement, 0);
   onHidePopupHelpTextComplete();
  }    
 },
 show: function () {
  if(this.displayMode === ASPxClientTextEditHelpTextDisplayMode.Inline) {
   ASPx.SetElementDisplay(this.helpTextElement, true);
  }
  else
   this.showPopupHelpText();
 },
 showPopupHelpText: function () {
  ASPx.SetElementDisplay(this.helpTextElement, true);
  this.updatePopupHelpTextPosition();
  if(this.animationEnabled)
   ASPx.AnimationHelper.fadeIn(this.helpTextElement);
  else
   ASPx.AnimationHelper.setOpacity(this.helpTextElement, 1);
  this.setHelpTextZIndex(false);
 }
});
var ASPxOutOfRangeWarningManager = ASPx.CreateClass(null, {
 constructor: function (editor, minValue, maxValue, defaultMinValue, defaultMaxValue, outOfRangeWarningElementPosition, valueFormatter) {
  this.editor = editor;
  this.outOfRangeWarningElementPosition = outOfRangeWarningElementPosition;
  this.minValue = minValue;
  this.maxValue = maxValue;
  this.defaultMinValue = defaultMinValue;
  this.defaultMaxValue = defaultMaxValue;
  this.minMaxValueFormatter = valueFormatter;
  this.animationDuration = 150;
  this.CreateOutOfRangeWarningElement();
 },
 SetMinValue: function (minValue) {
  this.minValue = minValue;
  this.UpdateOutOfRangeWarningElementText();
 },
 SetMaxValue: function (maxValue) {
  this.maxValue = maxValue;
  this.UpdateOutOfRangeWarningElementText();
 },
 CreateOutOfRangeWarningElement: function () {
  this.outOfRangeWarningElement = document.createElement("DIV");
  this.outOfRangeWarningElement.id = this.editor.name + "OutOfRWarn";
  ASPx.InsertElementAfter(this.outOfRangeWarningElement, this.editor.GetOutOfRangeWarningElementPrevSibling());
  ASPx.AnimationHelper.setOpacity(this.outOfRangeWarningElement, 0);
  this.outOfRangeWarningElement.className = this.editor.outOfRangeWarningClassName;
  this.UpdateOutOfRangeWarningElementText();
 },
 IsValueInRange: function (value) {
  return (!this.IsMinValueExists() || value >= this.minValue)
   && (!this.IsMaxValueExists() || value <= this.maxValue);
 },
 IsMinValueExists: function() {
  return ASPx.IsExists(this.minValue) && !isNaN(this.minValue) && this.minValue !== this.defaultMinValue;
 },
 IsMaxValueExists: function () {
  return ASPx.IsExists(this.maxValue) && !isNaN(this.maxValue) && this.maxValue !== this.defaultMaxValue;
 },
 GetFormattedTextByValue: function(value) {
  if (this.minMaxValueFormatter)
   return this.minMaxValueFormatter.Format(value);
  return value;
 },
 GetWarningText: function() {
  var textTemplate = arguments[0];
  var valueTexts = [];
  for (var i = 1; i < arguments.length; i++) {
   var valueText = this.GetFormattedTextByValue(arguments[i]);
   valueTexts.push(valueText);
  }
  return ASPx.Formatter.Format(textTemplate, valueTexts);
 },
 UpdateOutOfRangeWarningElementText: function () {
  var text = "";
  if (this.IsMinValueExists() && this.IsMaxValueExists())
   text = this.GetWarningText(this.editor.outOfRangeWarningMessages[0], this.minValue, this.maxValue);
  if (this.IsMinValueExists() && !this.IsMaxValueExists())
   text = this.GetWarningText(this.editor.outOfRangeWarningMessages[1], this.minValue);
  if (!this.IsMinValueExists() && this.IsMaxValueExists())
   text = this.GetWarningText(this.editor.outOfRangeWarningMessages[2], this.maxValue);
  ASPx.SetInnerHtml(this.outOfRangeWarningElement, "<LABEL>" + text + "</LABEL>");
 },
 UpdateOutOfRangeWarningElementVisibility: function (currentValue) {
  var isValidValue = currentValue == null || this.IsValueInRange(currentValue);
  if (!isValidValue && !this.outOfRangeWarningElementShown)
   this.ShowOutOfRangeWarningElement();
  if (isValidValue && this.outOfRangeWarningElementShown)
   this.HideOutOfRangeWarningElement();
 },
 GetOutOfRangeWarningElementCoordinates: function() {
  var editorMainElement = this.editor.GetMainElement();
  var editorWidth = editorMainElement.offsetWidth;
  var editorHeight = editorMainElement.offsetHeight;
  var editorX = ASPx.GetAbsoluteX(editorMainElement);
  var editorY = ASPx.GetAbsoluteY(editorMainElement);
  var outOfRangeWarningElementX = this.outOfRangeWarningElementPosition === ASPx.Position.Right ? editorX + editorWidth : editorX;
  var outOfRangeWarningElementY = this.outOfRangeWarningElementPosition === ASPx.Position.Right ? editorY : editorY + editorHeight;
  outOfRangeWarningElementX = outOfRangeWarningElementX < 0 ? 0 : outOfRangeWarningElementX;
  outOfRangeWarningElementY = outOfRangeWarningElementY < 0 ? 0 : outOfRangeWarningElementY;
  return {
   x: outOfRangeWarningElementX,
   y: outOfRangeWarningElementY
  };
 },
 ShowOutOfRangeWarningElement: function () {
  this.outOfRangeWarningElement.style.display = "inline";
  var outOfRangeWarningElementCoordinates = this.GetOutOfRangeWarningElementCoordinates();
  ASPx.SetAbsoluteX(this.outOfRangeWarningElement, outOfRangeWarningElementCoordinates.x);
  ASPx.SetAbsoluteY(this.outOfRangeWarningElement, outOfRangeWarningElementCoordinates.y);
  ASPx.AnimationHelper.fadeIn(this.outOfRangeWarningElement, null, this.animationDuration);
  this.ScrollToWarningElementIfRequired(outOfRangeWarningElementCoordinates);
  this.outOfRangeWarningElementShown = true;
 },
 HideOutOfRangeWarningElement: function () {
  ASPx.AnimationHelper.fadeOut(this.outOfRangeWarningElement, function () {
   ASPx.SetElementDisplay(this.outOfRangeWarningElement, false);
  }.aspxBind(this), this.animationDuration);
  this.outOfRangeWarningElementShown = false;
 },
 ScrollToWarningElementIfRequired: function (outOfRangeWarningElementCoordinates) {
  if(this.outOfRangeWarningElementPosition === ASPx.Position.Right) {
   var warnElementRightPos = outOfRangeWarningElementCoordinates.x
    + ASPx.PxToInt(ASPx.GetCurrentStyle(this.outOfRangeWarningElement).marginLeft)
    + this.outOfRangeWarningElement.offsetWidth;
   if(warnElementRightPos > ASPx.GetDocumentClientWidth() + ASPx.GetDocumentScrollLeft())
    ASPx.SetDocumentScrollLeft(warnElementRightPos - ASPx.GetDocumentClientWidth());
  }
  if(this.outOfRangeWarningElementPosition === ASPx.Position.Bottom) {
   var warnElementBottomPos = outOfRangeWarningElementCoordinates.y
    + ASPx.PxToInt(ASPx.GetCurrentStyle(this.outOfRangeWarningElement).marginTop)
    + this.outOfRangeWarningElement.offsetHeight;
   if(warnElementBottomPos > ASPx.GetDocumentClientHeight() + ASPx.GetDocumentScrollTop())
    ASPx.SetDocumentScrollTop(warnElementBottomPos - ASPx.GetDocumentClientHeight());
  }
 }
});
ASPx.MMMouseOut = function(name, evt) {
 var edit = ASPx.GetControlCollection().Get(name);
 if(edit != null) edit.OnMouseOut(evt);
};
ASPx.MMMouseOver = function(name, evt) {
 var edit = ASPx.GetControlCollection().Get(name);
 if(edit != null) edit.OnMouseOver(evt);
};
ASPx.MaskHintTimerProc = function() {
 var focusedEditor = ASPx.GetFocusedEditor();
 if(focusedEditor != null && ASPx.IsFunction(focusedEditor.MaskHintTimerProc))
  focusedEditor.MaskHintTimerProc();
};
ASPx.ETextChanged = function(name) {
 var edit = ASPx.GetControlCollection().Get(name);
 if(edit != null) edit.OnTextChanged(); 
};
ASPx.BEClick = function(name,number){
 var edit = ASPx.GetControlCollection().Get(name);
 if(edit != null) edit.OnButtonClick(number);
};
ASPx.BEClear = function(name, evt) {
 var edit = ASPx.GetControlCollection().Get(name);
 if(edit && (evt.button === 0 || ASPx.Browser.TouchUI))
  edit.onClearButtonClick();
};
ASPx.SetFocusToTextEditWithDelay = function(name) {
 window.setTimeout(function() {
  var edit = ASPx.GetControlCollection().Get(name);
  if(!edit)
   return;
  if(ASPx.Browser.IE)
   edit.SetCaretPosition(0);
  else
   edit.SetFocus();
 }, 500);
};
window.ASPxClientTextEdit = ASPxClientTextEdit;
window.ASPxClientTextBoxBase = ASPxClientTextBoxBase;
window.ASPxClientTextBox = ASPxClientTextBox;
window.ASPxClientMemo = ASPxClientMemo;
window.ASPxClientButtonEditBase = ASPxClientButtonEditBase;
window.ASPxClientButtonEdit = ASPxClientButtonEdit;
window.ASPxClientButtonEditClickEventArgs = ASPxClientButtonEditClickEventArgs;
})();

(function() {
var DateFormatter = ASPx.CreateClass(null, {
 constructor: function() {
  this.date = new Date(2000, 0, 1);
  this.mask = "";
  this.specifiers = {};     
  this.spPositions = [];    
  this.parserKeys = [];
  this.knownSpecifiers = ["d", "M", "y", "H", "h", "m", "s", "f", "F", "g", "t"];
  this.savedYear = -1;
  this.isYearParsed = false;
  this.parsedMonth = -1;
  this.replacers = {
   "d": this.ReplaceDay,
   "M": this.ReplaceMonth,
   "y": this.ReplaceYear,
   "H": this.ReplaceHours23,
   "h": this.ReplaceHours12,
   "m": this.ReplaceMinutes,
   "s": this.ReplaceSeconds,
   "F": this.ReplaceMsTrimmed,
   "f": this.ReplaceMs,
   "g": this.ReplaceEra,
   "t": this.ReplaceAmPm
  };
  this.parsers = {
   "d": this.ParseDay,
   "M": this.ParseMonth,
   "y": this.ParseYear,
   "H": this.ParseHours,
   "h": this.ParseHours,
   "m": this.ParseMinutes,
   "s": this.ParseSeconds,
   "F": this.ParseMs,
   "f": this.ParseMs,
   "g": this.ParseEra,
   "t": this.ParseAmPm
  };
 },
 Format: function(date) {
  this.date = date;
  var sp;
  var pos;
  var replacerKey;
  var result = this.mask;
  for(var i = 0; i < this.spPositions.length; i++) {
   pos = this.spPositions[i];
   sp = this.specifiers[pos];
   replacerKey = sp.substr(0, 1);
   if(this.replacers[replacerKey]) {
    result = result.substr(0, pos) + this.replacers[replacerKey].call(this, sp.length) + result.substr(pos + sp.length);
   }
  }
  return result;
 }, 
 Parse: function(str, rememberParserKeys) {
  var now = new Date();  
  this.savedYear = now.getFullYear();
  this.isYearParsed = false;
  this.parsedMonth = -1;
  this.date = new Date(2000, 0, now.getDate());    
  this.strToParse = str;
  this.catchNumbers(str);  
  var parserKey;
  var sp;
  var pos;
  var parseResult;
  var error = false;
  this.hasAmPm = false;
  for(var i = 0; i < this.spPositions.length; i++) {
   pos = this.spPositions[i];
   sp = this.specifiers[pos];
   parserKey = sp.substr(0, 1);
   if(this.parsers[parserKey]) {
    if(rememberParserKeys)
     this.parserKeys.push(parserKey);
    parseResult = this.parsers[parserKey].call(this, sp.length);
    if(!parseResult) {
     error = true;
     break;
    }
   }
  }
  if(error)
   return false;
  if(this.hasAmPm) {
   if(!this.fixHours())
    return false;
  }
  if(!this.isYearParsed)
   this.date.setYear(this.savedYear);
  if(this.parsedMonth < 0)
   this.parsedMonth = now.getMonth();   
  this.ApplyMonth();
  return this.date;  
 },
 ParseAndMergeWithDate: function(str, sourceDate) {
  this.parserKeys = [];
  var date = this.Parse(str, true);
  if(date && sourceDate)
   date = new Date(
        this.HasYear() ? date.getFullYear() : sourceDate.getFullYear(),
        this.HasMonth() ? date.getMonth() : sourceDate.getMonth(),
        this.HasDay() ? date.getDate() : sourceDate.getDate(),
        this.HasHours() ? date.getHours() : sourceDate.getHours(),
        this.HasMinutes() ? date.getMinutes() : sourceDate.getMinutes(),
        this.HasSeconds() ? date.getSeconds() : sourceDate.getSeconds(),
        this.HasMilliseconds() ? date.getMilliseconds() : sourceDate.getMilliseconds()
        );
  this.parserKeys = [];
  return date;
 },
 HasYear: function() { return this.HasParserKey("y"); },
 HasMonth: function() { return this.HasParserKey("M"); },
 HasDay: function() { return this.HasParserKey("d"); },
 HasHours: function() { return this.HasParserKey("h") || this.HasParserKey("H"); },
 HasMinutes: function() { return this.HasParserKey("m"); },
 HasSeconds: function() { return this.HasParserKey("s"); },
 HasMilliseconds: function() { return this.HasParserKey("f") || this.HasParserKey("F"); },
 HasParserKey: function(key) { return ASPx.Data.ArrayIndexOf(this.parserKeys, key) !== -1; },
 ApplyMonth: function() {
  var trial;
  var day = this.date.getDate();
  while(true) {
   trial = new Date();
   trial.setTime(this.date.getTime());   
   trial.setMonth(this.parsedMonth);
   if(trial.getMonth() == this.parsedMonth)
    break;
   --day;
   this.date.setDate(day);
  }
  ASPx.DateUtils.FixTimezoneGap(this.date, trial);
  this.date = trial;
 },
 SetFormatString: function(mask) {
  if(mask.length == 2 && mask.charAt(0) == "%")
   mask = mask.charAt(1);
  var stringContainsDateSeparator = mask && mask.indexOf(ASPx.CultureInfo.ds) !== -1;
  this.specifiers = {}; 
  this.spPositions = [];
  this.mask = "";
  var subt = 0;
  var pos = 0;
  var startPos = 0;
  var ch;
  var prevCh = "";
  var skip = false;
  var backslash = false;
  var sp = "";
  while(true) {
   ch = mask.charAt(pos);
   if(ch == "") {
    if(sp.length > 0)
     this.RegisterSpecifier(startPos, sp, stringContainsDateSeparator);
    break;
   }
   if(ch == "\\" && !backslash) {
    backslash = true;
    subt++;
   } else {
    if(!backslash && (ch == "'" || ch == '"')) {
     skip = !skip;
     subt++;
    } else {     
     if(!skip) {
      if(ch == "/")
       ch = ASPx.CultureInfo.ds;
      else if(ch == ":")
       ch = ASPx.CultureInfo.ts;
      else if(this.IsKnownSpecifier(ch)) {
       if(prevCh.length == 0)
        prevCh = ch;
       if(ch == prevCh)
        sp += ch;
       else {
        if(sp.length > 0)
         this.RegisterSpecifier(startPos, sp, stringContainsDateSeparator);
        sp = ch;
        startPos = pos - subt;
       }
      }
     }     
     this.mask += ch;
    }      
    backslash = false;
   }            
   prevCh = ch;
   pos++;
  }
  this.spPositions.reverse();
 },
 RegisterSpecifier: function (pos, sp, stringContainsDateSeparator) {
  if(ASPx.CultureInfo.ds.length > 1 && this.mask && !stringContainsDateSeparator) {
   var dateParts = this.mask.split(ASPx.CultureInfo.ds);
   if(dateParts) {
    if(dateParts.length > 0 && dateParts[dateParts.length - 1] == "")
     dateParts.pop();
    pos += (dateParts.length - 1) * (ASPx.CultureInfo.ds.length - 1);
   }
  }
  this.spPositions.push(pos);
  this.specifiers[pos] = sp; 
 },
 ReplaceDay: function(length) {
  if(length < 3) {
   var value = this.date.getDate().toString();
   return length == 2 ? this.padLeft(value, 2) : value;  
  } else if(length == 3) {
   return ASPx.CultureInfo.abbrDayNames[this.date.getDay()];
  } else {
   return ASPx.CultureInfo.dayNames[this.date.getDay()];
  }
 }, 
 ReplaceMonth: function(length) {
  var value = 1 + this.date.getMonth();
  switch(length) {
   case 1:
    return value.toString();
   case 2:
    return this.padLeft(value.toString(), 2);
   case 3:
    return ASPx.CultureInfo.abbrMonthNames[value - 1];
   default:
    for(var i in this.specifiers) {
     if(this.specifiers.hasOwnProperty(i)) {
      var spec = this.specifiers[i];
      if(spec == "d" || spec == "dd")
       return ASPx.CultureInfo.genMonthNames[value - 1];
     }
    }
    return ASPx.CultureInfo.monthNames[value - 1];
  }
 },
 ReplaceYear: function(length) {
  var value = this.date.getFullYear();
  if(length <= 2)
   value = value % 100;
  return this.padLeft(value.toString(), length);
 },
 ReplaceHours23: function(length) {
  var value = this.date.getHours().toString();
  return length > 1 ? this.padLeft(value, 2) : value;
 },
 ReplaceHours12: function(length) {
  var value = this.date.getHours() % 12;
  if(value == 0)
   value = 12;
  value = value.toString();
  return length > 1 ? this.padLeft(value, 2) : value;
 },
 ReplaceMinutes: function(length) {
  var value = this.date.getMinutes().toString();
  return length > 1 ? this.padLeft(value, 2) : value;
 },
 ReplaceSeconds: function(length) {
  var value = this.date.getSeconds().toString();
  return length > 1 ? this.padLeft(value, 2) : value;
 },
 ReplaceMsTrimmed: function(length) {   
  return this.formatMs(length, true);
 },
 ReplaceMs: function(length) { 
  return this.formatMs(length, false);
 },
 ReplaceEra: function(length) {
  return "A.D.";
 },
 ReplaceAmPm: function(length) {
  var value = this.date.getHours() < 12 ? ASPx.CultureInfo.am : ASPx.CultureInfo.pm;
  return length < 2 ? value.charAt(0) : value;
 },
 catchNumbers: function(str) {
  this.parseNumbers = [];  
  var regex = /\d+/g;  
  var match;
  for(;;) {
   match = regex.exec(str);
   if(!match)
    break;
   this.parseNumbers.push(this.parseDecInt(match[0]));
  }  
  var spCount = 0;
  var now = new Date();
  for(var i in this.specifiers) {
   if(this.specifiers.hasOwnProperty(i)) {
    var sp = this.specifiers[i];
    if (sp.constructor != String || !this.IsNumericSpecifier(sp)) continue;
    spCount++;
    if(this.parseNumbers.length < spCount) {
     var defaultValue = 0;
     if (sp.charAt(0) == "y") defaultValue = now.getFullYear();
     this.parseNumbers.push(defaultValue);
    }
   }
  }
  var excess = this.parseNumbers.length - spCount;
  if(excess > 0)
   this.parseNumbers.splice(spCount, excess);  
  this.currentParseNumber = this.parseNumbers.length - 1;
 },
 popParseNumber: function() {
  return this.parseNumbers[this.currentParseNumber--];
 },
 findAbbrMonth: function() {
  return this.findMonthCore(ASPx.CultureInfo.abbrMonthNames);
 },
 findFullMonth: function() {
  return this.findMonthCore(ASPx.CultureInfo.genMonthNames);
 },
 findMonthCore: function(monthNames) {
  var inputLower = this.strToParse.toLowerCase();
  var matchMonthNames = monthNames.filter(function(n) { return inputLower.indexOf(n.toLowerCase()) > -1; });
  if(matchMonthNames.length == 0)
   return false;
  var sortedMatchNames = matchMonthNames.sort(function(a, b) { return b.length - a.length; });
  var name = sortedMatchNames[0];
  var emptyMonth = new Array(name.length + 1).join(" ");
  this.strToParse = this.strToParse.replace(new RegExp(name, "gi"), emptyMonth);
  return monthNames.indexOf(name) + 1;
 },
 ParseDay: function(length) {
  if(length < 3) {
   var value = this.popParseNumber();
   if(value < 1 || value > 31)
    return false;
   this.date.setDate(value);
  }
  return true;
 },
 ParseMonth: function(length) {
  var value;
  var actualMonthTextContainsDigitOnly = this.actualDayMonthTextContainsDigitOnly("M", length);
  if(length < 3 || actualMonthTextContainsDigitOnly)
   value = this.popParseNumber();
  else
   value = length === 3 ? this.findAbbrMonth() : this.findFullMonth();
  if(value < 1 || value > 12)
   return false;
  this.parsedMonth = value - 1;
  if(this.actualDayMonthTextContainsAnyDigit("M", length) && !actualMonthTextContainsDigitOnly && length > 2)
   this.currentParseNumber--;
  return true;
 }, 
 ParseYear: function(length) {  
  var value = this.popParseNumber();
  if(value > 9999)
   return false;
  if(value < 100)
   value = ASPx.DateUtils.ExpandTwoDigitYear(value);
  this.date.setFullYear(value);
  this.isYearParsed = true;
  return true;
 },
 ParseHours: function(length) {
  var value = this.popParseNumber();
  if(value > 23)
   return false;
  this.date.setHours(value);
  return true;
 },
 ParseMinutes: function(length) {
  var value = this.parseMinSecCore();
  if(value == -1)
   return false;
  this.date.setMinutes(value);
  return true;
 },
 ParseSeconds: function(length) {
  var value = this.parseMinSecCore();
  if(value == -1)
   return false;
  this.date.setSeconds(value);
  return true;
 },
 ParseMs: function(length) {
  if(length > 3)
   length = 3;
  var thr = 1;
  for(var i = 0; i < length; i++)
   thr *= 10;
  thr -= 1;
  var value = this.popParseNumber();
  while(value > thr)
   value /= 10;
  this.date.setMilliseconds(Math.round(value));
  return true;
 },
 ParseEra: function(length) {
  return true;
 },
 ParseAmPm: function(length) {
  this.hasAmPm = ASPx.CultureInfo.is12HoursCulture;
  return true;
 },
 parseDecInt: function(str) {
  return parseInt(str, 10);
 },
 padLeft: function(str, length) {
  while(str.length < length)
   str = "0" + str;
  return str;
 },
 formatMs: function(length, trim) {
  var value = Math.floor(this.date.getMilliseconds() * Math.pow(10, length - 3));
  value = this.padLeft(value.toString(), length);    
  if(trim) {
   var pos = value.length - 1;
   var req = false;
   while(value.charAt(pos) == "0") {
    req = true;
    pos--;
   }
   if(req)
    value = value.substring(0, pos + 1);   
  }
  return value;
 },
 parseMinSecCore: function() {
  var value = this.popParseNumber();
  return value > 59 ? -1 : value;
 },
 fixHours: function() {
  var state = this.getAmPmState(this.strToParse);
  if(!state) return true;
  var h = this.date.getHours();
  switch(state) {
   case "P":
    if(h > 12) return false;
    if(h < 12)
     this.date.setHours(12 + h);
    break;
   case "A":
    if(h == 12)
     this.date.setHours(0);
  }
  return true;
 },
 getAmPmState: function(str, skipCorrection) {
  var am = ASPx.CultureInfo.am.charAt(0).toLowerCase();
  var pm = ASPx.CultureInfo.pm.charAt(0).toLowerCase();
  var amMatches = new RegExp(am, "gi").exec(str);
  var pmMatches = new RegExp(pm, "gi").exec(str);
  var amCount = amMatches ? amMatches.length : 0;
  var pmCount = pmMatches ? pmMatches.length : 0;
  var hasAm = amCount > 0;
  var hasPm = pmCount > 0;
  if(hasAm ^ hasPm && amCount < 2 && pmCount < 2)
   return hasAm ? "A" : "P";
  if(!skipCorrection) {
   str = str.replace(new RegExp(this.getDayMonthNameReplacePattern(), "gi"), "");
   return this.getAmPmState(str, true);
  }
  return null;
 },
 getDayMonthNameReplacePattern: function() {
  if(!this.dayMonthNameReplacePattern)
   return this.createDayMonthNameReplacePattern();
  return this.dayMonthNameReplacePattern;
 },
 createDayMonthNameReplacePattern: function() {
  var parts = [ ] ;
  parts.push("(?:");
  parts.push(this.createReplacePattern(ASPx.CultureInfo.monthNames));
  parts.push(this.createReplacePattern(ASPx.CultureInfo.genMonthNames));
  parts.push(this.createReplacePattern(ASPx.CultureInfo.abbrMonthNames));
  parts.push(this.createReplacePattern(ASPx.CultureInfo.abbrDayNames));
  parts.push(this.createReplacePattern(ASPx.CultureInfo.dayNames));
  parts.push(")");
  return parts.join("");
 },
 createReplacePattern: function(names) {
  return names && names.length > 0 ? "\\b" + names.join("\\b|\\b") + "\\b" : "";
 },
 IsNumericSpecifier: function(sp) {
  var ch = sp.charAt(0);
  if(ch == "g" || ch == "t" || ((ch == "M" || ch == "d") && !this.actualDayMonthTextContainsAnyDigit(ch, sp.length)))
   return false;
  return true;
 },
 actualDayMonthTextContainsAnyDigit: function(datePart, datePartLength) {
  return this.actualDayMonthTextContainsDigitCore(datePart, datePartLength, function(name) { return /\d+/g.test(name); });
 },
 actualDayMonthTextContainsDigitOnly: function(datePart, datePartLength) {
  return this.actualDayMonthTextContainsDigitCore(datePart, datePartLength, function(name) { return !isNaN(parseInt(name)); });
 },
 actualDayMonthTextContainsDigitCore: function(datePart, datePartLength, matchDigitFunc) {
  if(datePartLength < 3)
   return true;
  var targetNames = this.getDayMonthNames(datePart, datePartLength);
  return targetNames.length > 0 ? matchDigitFunc(targetNames[0]) : false;
 },
 getDayMonthNames: function(datePart, datePartLength) {
  var result = [];
  var useAbbrNames = datePartLength == 3;
  if(datePart == "d")
   result = useAbbrNames ? ASPx.CultureInfo.abbrDayNames : ASPx.CultureInfo.dayNames;
  else
   result = useAbbrNames ? ASPx.CultureInfo.abbrMonthNames : ASPx.CultureInfo.monthNames;
  return result;
 },
 IsKnownSpecifier: function(sp) {
  if(sp.length > 1)
   sp = sp.charAt(0);
  for(var i = 0; i < this.knownSpecifiers.length; i++) {
   if(this.knownSpecifiers[i] == sp)
    return true;
  }
  return false;
 }
});
DateFormatter.Create = function(format) {
 var instance = new DateFormatter();
 instance.SetFormatString(format);
 return instance;
};
DateFormatter.ExpandPredefinedFormat = function(format) {
 switch(format) {
  case "d":
   return ASPx.CultureInfo.shortDate;
  case "D":
   return ASPx.CultureInfo.longDate;
  case "t":
   return ASPx.CultureInfo.shortTime;
  case "T":
   return ASPx.CultureInfo.longTime;
  case "g":
   return ASPx.CultureInfo.shortDate + " " + ASPx.CultureInfo.shortTime;   
  case "f":
   return ASPx.CultureInfo.longDate + " " + ASPx.CultureInfo.shortTime;
  case "G":
   return ASPx.CultureInfo.shortDate + " " + ASPx.CultureInfo.longTime;
  case "F":
  case "U":
   return ASPx.CultureInfo.longDate + " " + ASPx.CultureInfo.longTime;   
  case "M":
  case "m":
   return ASPx.CultureInfo.monthDay;
  case "Y":
  case "y":
   return ASPx.CultureInfo.yearMonth;   
  case "O":
  case "o":
   return "yyyy'-'MM'-'dd'T'HH':'mm':'ss.fffffff";
  case "R":
  case "r":
   return "ddd, dd MMM yyyy HH':'mm':'ss 'GMT'";
  case "s":
   return "yyyy'-'MM'-'dd'T'HH':'mm':'ss";
  case "u":
    return "yyyy'-'MM'-'dd HH':'mm':'ss'Z'";
 }
 return format;
};
ASPx.DateFormatter = DateFormatter;
})();
(function() {
ASPx.Formatter = {
 Format: function() {
  if(arguments.length < 1) 
   return "";
  var format = arguments[0];
  if(format == null)
   return "";
  var args;
  if(arguments.length > 1 && arguments[1] != null && arguments[1].constructor == Array) {
   args = arguments[1];
  } else {
   args = [ ];
   for(var i = 1; i < arguments.length; i++)
    args.push(arguments[i]);
  }
  var bag = [ ];
  var pos = 0;
  var savedPos = 0;  
  while(pos < format.length) {
   var ch = format.charAt(pos);
   pos++;
   if(ch == '{') {
    bag.push(format.substr(savedPos, pos - savedPos - 1));    
    if(format.charAt(pos) == "{") {
     savedPos = pos;
     pos++;
     continue;
    }
    var spec = this.ParseSpec(format, pos);
    var pos = spec.pos;
    var arg = args[spec.index];
    var argString;
    if(arg == null) {
     argString = "";
    } else if(typeof arg == "number") {
     argString = ASPx.NumberFormatter.Format(spec.format, arg);
    } else if(arg.constructor == Date) {     
     if(spec.format != this.activeDateFormat) {
      this.activeDateFormat = spec.format;
      if(spec.format == "")
       spec.format = "G";      
      if(spec.format.length == 1)
       spec.format = ASPx.DateFormatter.ExpandPredefinedFormat(spec.format);
      this.GetDateFormatter().SetFormatString(spec.format);
     }
     if(this.activeDateFormat == "U")
      arg = ASPx.DateUtils.ToUtcTime(arg);
     argString = this.GetDateFormatter().Format(arg);
    } else {
     argString = String(arg);     
     if(spec.format != "" && argString.length > 0) {
      var num = Number(argString.replace(",", "."));
      if(!isNaN(num))
       argString = ASPx.NumberFormatter.Format(spec.format, num);
     }
    }
    var padLen = spec.width - argString.length;
    if(padLen > 0) {
     if(spec.left)
      bag.push(argString);
     for(var i = 0; i < padLen; i++)
      bag.push(" ");
     if(!spec.left)
      bag.push(argString);
    } else {
     bag.push(argString);
    }
    savedPos = pos;
   }
   else if(ch == "}" && pos < format.length && format.charAt(pos) == "}") {
    bag.push(format.substr(savedPos, pos - savedPos - 1));
    savedPos = pos;
    pos++;
   }
   else if (ch == "}") {
    return "";
   }
  }
  if(savedPos < format.length)
   bag.push(format.substr(savedPos));   
  return bag.join("");
 },
 ParseSpec: function(format, pos) {
  var result = {
   index: -1,   
   left: false,
   width: 0,
   format: "",
   pos: 0
  };
  var savedPos, ch;
  savedPos = pos;
  while(true) {   
   ch = format.charAt(pos);
   if(ch < "0" || ch > "9")
    break;
   pos++;
  }  
  if(pos > savedPos)
   result.index = Number(format.substr(savedPos, pos - savedPos));  
  if(format.charAt(pos) == ",") {
   pos++;
   while(true) {
    ch = format.charAt(pos);
    if(ch != " " && ch != "\t")
     break;
    pos++;
   }
   result.left = format.charAt(pos) == "-";
   if(result.left)
    pos++;   
   savedPos = pos;
   while(true) {
    ch = format.charAt(pos);
    if(ch < "0" || ch > "9")
     break;
    pos++;
   }
   if(pos > savedPos)
    result.width = Number(format.substr(savedPos, pos - savedPos));
  }
  if(format.charAt(pos) == ":") {
   pos++;
   savedPos = pos;
   while(format.charAt(pos) != "}")
    pos++;
   result.format = format.substr(savedPos, pos - savedPos);
  }
  pos++;
  result.pos = pos;
  return result;
 },
 activeDateFormat: null,
 GetDateFormatter: function() {
  if(!this.__dateFormatter)
   this.__dateFormatter = new ASPx.DateFormatter();
  return this.__dateFormatter;
 }
};
ASPx.NumberFormatter = {
 Format: function(format, value) {
  if(isNaN(value))
   return ASPx.CultureInfo.numNan;
  if(!isFinite(value)) {
   return value > 0 
    ? ASPx.CultureInfo.numPosInf 
    : ASPx.CultureInfo.numNegInf;
  }
  this.FillFormatInfo(format);
  if(this.spec == "X")
   return this.FormatHex(value);
  this.FillDigitInfo(value);  
  switch(this.spec) {
   case "C":
    return this.FormatCurrency();
   case "D":
    return this.FormatDecimal();
   case "E":
    return this.FormatExp();
   case "F":
    return this.FormatFixed();
   case "G":   
    return this.FormatGeneral();
   case "N":
    return this.FormatNumber();
   case "P":
    return this.FormatPercent();
   default:
    if(this.custom)
     return this.FormatCustom(format);
    return "?";
  }
 },
 positive: true,
 digits: null,
 pointPos: 0, 
 spec: "",
 prec: -1,  
 upper: true,
 custom: false,
 FormatCurrency: function() {  
  if(this.prec < 0)
   this.prec = ASPx.CultureInfo.currPrec;
  this.Round(this.prec);
  var bag = [ ];
  if(this.positive) {
   switch(ASPx.CultureInfo.currPosPattern) {
    case 0:
     bag.push(ASPx.CultureInfo.currency);
     break;
    case 2:
     bag.push(ASPx.CultureInfo.currency, " ");     
     break;     
   }
  } else {
   switch(ASPx.CultureInfo.currNegPattern) {
    case 0:
     bag.push("(", ASPx.CultureInfo.currency);
     break;
    case 1:
     bag.push("-", ASPx.CultureInfo.currency);
     break;
    case 2:
     bag.push(ASPx.CultureInfo.currency, "-");
     break;
    case 3:
     bag.push(ASPx.CultureInfo.currency);
     break;
    case 4:
     bag.push("(");
     break;
    case 5:
    case 8:
     bag.push("-");
     break;
    case 9:
     bag.push("-", ASPx.CultureInfo.currency, " ");
     break;
    case 11:
     bag.push(ASPx.CultureInfo.currency, " ");
     break;
    case 12:
     bag.push(ASPx.CultureInfo.currency, " -");
     break;
    case 14:
     bag.push("(", ASPx.CultureInfo.currency, " ");
     break;
    case 15:
     bag.push("(");
     break;
   }
  }
  this.AppendGroupedInteger(bag, ASPx.CultureInfo.currGroups, ASPx.CultureInfo.currGroupSeparator);
  if(this.prec > 0) {
   bag.push(ASPx.CultureInfo.currDecimalPoint);
   this.AppendDigits(bag, this.pointPos, this.pointPos + this.prec);
  }
  if(this.positive) {
   switch(ASPx.CultureInfo.currPosPattern) {
    case 1:
     bag.push(ASPx.CultureInfo.currency);
     break;
    case 3:
     bag.push(" ", ASPx.CultureInfo.currency);
     break;     
   }   
  } else {
   switch(ASPx.CultureInfo.currNegPattern) {
    case 0:
    case 14:
     bag.push(")");
     break;
    case 3:
     bag.push("-");
     break;
    case 4:
     bag.push(ASPx.CultureInfo.currency, ")");
     break;
    case 5:
     bag.push(ASPx.CultureInfo.currency);
     break;
    case 6:
     bag.push("-", ASPx.CultureInfo.currency);
     break;
    case 7:
     bag.push(ASPx.CultureInfo.currency, "-");
     break;
    case 8:
     bag.push(" ", ASPx.CultureInfo.currency);
     break;
    case 10:
     bag.push(" ", ASPx.CultureInfo.currency, "-");
     break;
    case 11:
     bag.push("-");
     break;
    case 13:
     bag.push("- ", ASPx.CultureInfo.currency);
     break;
    case 15:
     bag.push(" ", ASPx.CultureInfo.currency, ")");
     break;
   }
  }
  return bag.join("");
 }, 
 FormatDecimal: function() {
  if(this.prec < this.pointPos)
   this.prec = this.pointPos;
  if(this.prec < 1)
   return "0";
  var bag = [ ];
  if(!this.positive)
   bag.push("-");
  this.AppendDigits(bag, this.pointPos - this.prec, this.pointPos);
  return bag.join("");
 },
 FormatExp: function() {  
  if(this.prec < 0)
   this.prec = 6;
  this.Round(1 - this.pointPos + this.prec);
  return this.FormatExpCore(3);
 },
 FormatExpCore: function(minExpDigits) {
  var bag = [ ];
  if(!this.positive)
   bag.push("-");
  this.AppendDigits(bag, 0, 1);
  if(this.prec > 0) {
   bag.push(ASPx.CultureInfo.numDecimalPoint);
   this.AppendDigits(bag, 1, 1 + this.prec);
  }
  bag.push(this.upper ? "E" : "e");
  var order = this.pointPos - 1;  
  if(order >= 0) {
   bag.push("+");
  } else {
   bag.push("-");
   order = -order;
  }
  var orderStr = String(order);
  for(var i = orderStr.length; i < minExpDigits; i++)
   bag.push(0);
  bag.push(orderStr);
  return bag.join("");
 },
 FormatFixed: function() {
  if(this.prec < 0)
   this.prec = ASPx.CultureInfo.numPrec;
  this.Round(this.prec);
  var bag = [ ];
  if(!this.positive)
   bag.push("-");
  if(this.pointPos < 1)
   bag.push(0);
  else
   this.AppendDigits(bag, 0, this.pointPos);
  if(this.prec > 0) {
   bag.push(ASPx.CultureInfo.numDecimalPoint);
   this.AppendDigits(bag, this.pointPos, this.pointPos + this.prec);
  }
  return bag.join(""); 
 },
 FormatGeneral: function() {
  var hasFrac = this.pointPos < this.digits.length;
  var allowExp;
  if(this.prec < 0) {
   allowExp = hasFrac;
   this.prec = hasFrac ? 15 : 10;
  } else {   
   allowExp = true;
   if(this.prec < 1)
    this.prec = hasFrac ? 15 : 10;
   this.Round(this.prec - this.pointPos);
  }
  if(allowExp) {
   if(this.pointPos > this.prec || this.pointPos <= -4) {
    this.prec = this.digits.length - 1;
    return this.FormatExpCore(2);
   }
  }
  this.prec = Math.min(this.prec, Math.max(1, this.digits.length)) - this.pointPos;
  return this.FormatFixed();
 },
 FormatNumber: function() {
  if(this.prec < 0)
   this.prec = ASPx.CultureInfo.numPrec;
  this.Round(this.prec);
  var bag = [ ];
  if(!this.positive) {
   switch(ASPx.CultureInfo.numNegPattern) {
    case 0:
     bag.push("(");
     break;
    case 1:
     bag.push("-");
     break;
    case 2:
     bag.push("- ");
     break;
   }
  }
  this.AppendGroupedInteger(bag, ASPx.CultureInfo.numGroups, ASPx.CultureInfo.numGroupSeparator);
  if(this.prec > 0) {
   bag.push(ASPx.CultureInfo.numDecimalPoint);
   this.AppendDigits(bag, this.pointPos, this.pointPos + this.prec);
  }
  if(!this.positive) {
   switch(ASPx.CultureInfo.numNegPattern) {
    case 0:
     bag.push(")");
     break;
    case 3:
     bag.push("-");
     break;
    case 4:
     bag.push(" -");
     break;
   }
  }
  return bag.join("");
 },
 FormatPercent: function() {
  if(this.prec < 0)
   this.prec = ASPx.CultureInfo.numPrec;
  if(this.digits.length > 0)
   this.pointPos += 2;
  this.Round(this.prec);
  var bag = [ ];
  if(!this.positive)
   bag.push("-");
  if(ASPx.CultureInfo.percentPattern == 2)
   bag.push("%");    
  this.AppendGroupedInteger(bag, ASPx.CultureInfo.numGroups, ASPx.CultureInfo.numGroupSeparator);
  if(this.prec > 0) {
   bag.push(ASPx.CultureInfo.numDecimalPoint);
   this.AppendDigits(bag, this.pointPos, this.pointPos + this.prec);
  }  
  switch(ASPx.CultureInfo.percentPattern) {
   case 0:
    bag.push(" %");
    break;
   case 1:
    bag.push("%");
    break;
  }  
  return bag.join("");
 },
 FormatHex: function(value) {
  var result = value.toString(16);
  if(result.indexOf("(") > -1)
   return result;
  result = this.upper ? result.toUpperCase() : result.toLowerCase();
  if(this.prec <= result.length)
   return result;
  var bag = [ ];
  for(var i = result.length; i < this.prec; i++)
   bag.push(0);
  bag.push(result);
  return bag.join("");
 },
 FormatCustom: function(format) {
  var sectionList = this.GetCustomFormatSections(format);
  var section = this.SelectCustomFormatSection(sectionList);
  if(section == "")
   return this.positive ? "" : "-";
  var info = this.ParseCustomFormatSection(section);
  var lists = this.CreateCustomFormatLists(info);
  if(sectionList.length > 2 && section != sectionList[2]) {
   var zero = lists.i.concat(lists.f).join("").split(0).join("") == "";
   if(zero) {
    section = sectionList[2];
    info = this.ParseCustomFormatSection(section);
    lists = this.CreateCustomFormatLists(info);   
   }   
  }
  return this.FormatCustomCore(section, info, lists);
 },
 GetCustomFormatSections: function(format) {
  var sections = [ ];
  var escaping = false;
  var quote = "";
  var length = 0;
  var prevPos = 0;
  for(var i = 0; i < format.length; i++) {
   var ch = format.charAt(i);
   if(!escaping && quote == "" && ch == ";") {
    sections.push(format.substr(prevPos, length));
    length = 0;
    prevPos = i + 1;
    if(sections.length > 2)
     break;
   } else {
    if(escaping)
     escaping = false;
    else if(ch == quote)
     quote = quote == "" ? ch : "";
    else if(ch == "\\")
     escaping = true;
    else if(ch == "'" || ch == '"')
     quote = ch;
    ++length;
   }
  }
  if(length > 0)
   sections.push(format.substr(prevPos, length));
  if(sections.length < 1)
   sections.push(format);
  return sections;
 },
 SelectCustomFormatSection: function(sections) {
  if(!this.positive && sections.length > 1 && sections[1] != "") {
   this.positive = true;
   return sections[1];
  }
  if(this.digits.length < 1 && sections.length > 2 && sections[2] != "")
   return sections[2];
  return sections[0];
 },
 CreateCustomFormatInfo: function() {
  return {
   pointPos: -1,
   grouping: false,
   exp: false,
   expShowPlus: false,
   percent: false,
   scaling: 0,
   intDigits: 0,
   fracDigits: 0,
   expDigits: 0,
   intSharps: 0,
   fracSharps: 0, 
   expSharps: 0
  };
 },
 ParseCustomFormatSection: function(section) {  
  var quote = "";
  var area = "i"; 
  var canParseIntSharps = true;
  var result = this.CreateCustomFormatInfo();
  var groupSeparators = 0;  
  for(var i = 0; i < section.length; i++) {
   var ch = section.charAt(i);   
   if(ch == quote) {
    quote = "";    
    continue;
   }
   if(quote != "")
    continue;
   if(area == "e" && ch != "0" && ch != "#") {
    area = result.pointPos < 0 ? "i" : "f";
    i--;
    continue;
   }
   switch(ch) {
    case "\\":
     i++;
     continue;
    case "'":
    case '"':
     quote = ch;
     continue;
    case "#":
    case "0":
     if(ch == "#") {
      switch(area) {
       case "i":
        if(canParseIntSharps)
         result.intSharps++;
        break;
       case "f":
        result.fracSharps++;
        break;
       case "e":
        result.expSharps++;
        break;
      }
     } else {
      canParseIntSharps = false;
      switch(area) {
       case "f":
        result.fracSharps = 0;        
        break;
       case "e":
        result.expSharps = 0;
        break;
      }
     }
     switch(area) {
      case "i":
       result.intDigits++;
       if(groupSeparators > 0)
        result.grouping = true;
       groupSeparators = 0;
       break;
      case "f":
       result.fracDigits++;  
       break;
      case "e":
       result.expDigits++;
       break;
     }
     break;
    case "e":
    case "E":
     if(result.exp)
      break;
     result.exp = true;     
     area = "e"; 
     if(i < section.length - 1) {
      var next = section.charAt(1 + i);
      if(next == "+" || next == "-") {
       if(next == "+")
        result.expShowPlus = true;
       i++;
      }
      else if(next != "0" && next != "#") {
       result.exp = false;
       if(result.pointPos < 0)
        area = "i";       
      }
     }
     break;
    case ".":
     area = "f";
     if(result.pointPos < 0)
      result.pointPos = i;
     break;
    case "%":
     result.percent = true;     
     break;
    case ",":
     if(area == "i" && result.intDigits > 0)
      groupSeparators++;
     break;
    default:
     break;
   }
  }
  if(result.expDigits < 1)
   result.exp = false;
  else
   result.intSharps = 0;
  if(result.fracDigits < 1)
   result.pointPos = -1;
  result.scaling = 3 * groupSeparators;  
  return result;
 },
 CreateCustomFormatLists: function(info) {
  var intList = [ ];
  var fracList = [ ];
  var expList = [ ];
  if(this.digits.length > 0) {
   if(info.percent)
    this.pointPos += 2;
   this.pointPos -= info.scaling;
  }
  var expPositive = true;
  if(info.exp && (info.intDigits > 0 || info.fracDigits > 0)) {
   var diff = 0;
   if(this.digits.length > 0) {
    this.Round(info.intDigits + info.fracDigits - this.pointPos);
    diff -= this.pointPos - info.intDigits;
    this.pointPos = info.intDigits;
   }
   expPositive = diff <= 0;   
   expList = String(diff < 0 ? -diff : diff).split("");
  } else {
   this.Round(info.fracDigits);
  }
  if(this.digits.length < 1 || this.pointPos < 1)
   intList = [ 0 ];
  else
   this.AppendDigits(intList, 0, this.pointPos);
  this.AppendDigits(fracList, this.pointPos, this.digits.length);
  if(info.exp) {
   while(intList.length < info.intDigits)
    intList.unshift(0);
   while(expList.length < info.expDigits - info.expSharps)
    expList.unshift(0);
   if(expPositive && info.expShowPlus)
    expList.unshift("+");
   else if(!expPositive)
    expList.unshift("-");
  } else {
   while(intList.length < info.intDigits - info.intSharps)
    intList.unshift(0);    
   if(info.intSharps >= info.intDigits) {
    var zero = true;
    for(var i = 0; i < intList.length; i++) {
     if(intList[i] != 0) {
      zero = false;
      break;
     }
    }
    if(zero)
     intList = [ ];
   }
  }
  while(fracList.length < info.fracDigits - info.fracSharps)
   fracList.push(0);
  return {
   i: intList,
   f: fracList,
   e: expList
  };
 },
 FormatCustomCore: function(section, info, lists) {
  var intLen = 0; 
  var total = 0;
  var groupIndex = 0; 
  var counter = 0;
  var groupSize = 0;
  if(info.grouping && ASPx.CultureInfo.numGroups.length > 0) {
   intLen = lists.i.length;
   for(var i = 0; i < ASPx.CultureInfo.numGroups.length; i++) {
    if(total + ASPx.CultureInfo.numGroups[i] <= intLen) {
     total += ASPx.CultureInfo.numGroups[i];
     groupIndex = i;
    }
   }
   groupSize = ASPx.CultureInfo.numGroups[groupIndex];
   var fraction = intLen > total ? intLen - total : 0;
   if(groupSize == 0) {
    while(groupIndex >= 0 && ASPx.CultureInfo.numGroups[groupIndex] == 0)
     groupIndex--;
    groupSize = fraction > 0 ? fraction : ASPx.CultureInfo.numGroups[groupIndex];
   }
   if(fraction == 0) {
    counter = groupSize;
   } else {
    groupIndex += Math.floor(fraction / groupSize);
    counter = fraction % groupSize;
    if(counter == 0)
     counter = groupSize;
    else
     groupIndex++;
   }
  } else {
   info.grouping = false;
  }
  var bag = [ ];
  var area = "i";
  var intSharps = 0;
  var intListIndex = 0;
  var fracListIndex = 0;
  var savedCh = "";
  for(var i = 0; i < section.length; i++) {
   var ch = section.charAt(i);
   if(ch == savedCh) {
    savedCh = "";
    continue;
   }
   if(savedCh != "") {
    bag.push(ch);
    continue;
   }
   switch(ch) {
    case "\\":
     ++i;
     if(i < section.length)
      bag.push(section.charAt(i));
     continue;
    case "'":
    case '"':     
     savedCh = ch;
     continue;
    case "#":     
    case "0":
     if(area == "i") {
      intSharps++;
      if(ch == "0" || info.intDigits - intSharps < lists.i.length + intListIndex) {
       while(info.intDigits - intSharps + intListIndex < lists.i.length) {
        bag.push(lists.i[intListIndex]);
        intListIndex++;
        if(info.grouping && --intLen > 0 && --counter == 0) {
         bag.push(ASPx.CultureInfo.numGroupSeparator);
         if(--groupIndex < ASPx.CultureInfo.numGroups.length && groupIndex >= 0)
          groupSize = ASPx.CultureInfo.numGroups[groupIndex];
         counter = groupSize;
        }
       }
      }
     } else if(area == "f") {
      if(fracListIndex < lists.f.length) {
       bag.push(lists.f[fracListIndex]);
       fracListIndex++;
      }
     }
     break;
    case "e":
    case "E":
     if(lists.e == null || !info.exp) {
      bag.push(ch);
      break;
     }
     for(var q = i + 1; q < section.length; q++) {
      if(q == i + 1 && (section.charAt(q) == "+" || section.charAt(q) == "-"))
       continue;                   
      if(section.charAt(q) == "0" || section.charAt(q) == "#")
       continue;
      break;
     }
     i = q - 1;
     area = info.pointPos < 0 ? "i" : "f";
     bag.push(ch);
     bag = bag.concat(lists.e);
     lists.e = null;      
     break;
    case ".":
     if(info.pointPos == i && lists.f.length > 0)
      bag.push(ASPx.CultureInfo.numDecimalPoint);
     area = "f";
     break;
    case ",":
     break;
    default:
     bag.push(ch);
     break;
   }
  }
  if(!this.positive)
   bag.unshift("-");
  return bag.join("");
 },
 FillDigitInfo: function(value) {
  this.positive = true;
  if(value < 0) {
   value = -value;
   this.positive = false;   
  }
  this.digits = [ ];
  this.pointPos = 0;    
  if(value == 0 || !isFinite(value) || isNaN(value)) {
   this.pointPos = 1;
   return;
  }
  var list = String(value).split("e");
  var str = list[0];
  if(list.length > 1) {   
   this.pointPos = Number(list[1]);
  }
  var frac = false;
  var decimalCount = 0;
  for(var i = 0; i < str.length; i++) {
   var ch = str.charAt(i);
   if(ch == ".") {
    frac = true;
   } else {
    if(frac)
     decimalCount++;     
    if(ch != "0" || this.digits.length > 0)
     this.digits.push(Number(ch));
   }
  }
  this.pointPos += this.digits.length - decimalCount;
 },
 FillFormatInfo: function(format) {
  this.upper = true;
  this.custom = false;
  this.prec = -1;
  var spec;
  if(format == null || format.length < 1)
   spec = "G";
  else
   spec = format.charAt(0);
  if(spec >= "a" && spec <= "z") {
   spec = spec.toUpperCase();
   this.upper = false;
  }
  if(spec >= "A" && spec <= "Z") {   
   if(format != null && format.length > 1) {
    var prec = Number(format.substr(1));
    if(!isNaN(prec))
     this.prec = prec;
    else
     this.custom = true;
   }
  } else {
   this.custom = true;   
  }  
  this.spec = this.custom ? "0" : spec;
 },
 Round: function(shift) {
  var amount = this.digits.length - this.pointPos - shift;
  if(amount <= 0) 
   return;
  var cutPos = this.pointPos + shift;
  if(cutPos < 0) {
   this.digits = [ ];
   this.pointPos = 0;
   return;
  }
  var digit = this.digits[cutPos];
  if(digit > 4) { 
   for(var i = 0; i < amount; i++) {
    var index = cutPos - 1 - i;
    if(index < 0) {
     this.digits.unshift(0);
     this.pointPos++;
     cutPos++;
     index++;
    }
    digit = this.digits[index];    
    if(digit < 9) {
     this.digits[index] = 1 + digit;
     break;
    } else {
     this.digits[index] = 0;
     amount++;
    }
   }
  }
  for(var i = cutPos - 1; i >= 0; i--) {
   if(this.digits[i] > 0) break;
   cutPos--;
  }
  this.digits.splice(cutPos, this.digits.length - cutPos);
 },
 AppendGroupedInteger: function(list, groups, separator) { 
  if(this.pointPos < 1) {
   list.push(0);
   return;
  }
  var total = 0;
  var groupIndex = 0;
  for(var i = 0; i < groups.length; i++) {
   if(total + groups[i] <= this.pointPos) {
    total += groups[i];
    groupIndex = i;
   }
   else
    break;
  }
  if(groups.length > 0 && total > 0) {
   var counter;
   var groupSize = groups[groupIndex];
   var fraction = this.pointPos > total ? this.pointPos - total : 0;
   if(groupSize == 0) {
    while(groupIndex >= 0 && groups[groupIndex] == 0)
     groupIndex--;
    groupSize = fraction > 0 ? fraction : groups[groupIndex];
   }
   if(fraction == 0) {
    counter = groupSize;
   } else {
    groupIndex += Math.floor(fraction / groupSize);
    counter = fraction % groupSize;
    if(counter == 0)
     counter = groupSize;
    else
     groupIndex++;
   }
   var i = 0;
   while(true) {
    if(this.pointPos - i <= counter || counter == 0) {
     this.AppendDigits(list, i, this.pointPos);
     break;
    }
    this.AppendDigits(list, i, i + counter);
    list.push(separator);
    i += counter;    
    groupIndex--;     
    if(groupIndex < groups.length && groupIndex >= 0)
     groupSize = groups[groupIndex];
    counter = groupSize;
   }
  } else {
   this.AppendDigits(list, 0, this.pointPos);   
  }  
 },
 AppendDigits: function(list, start, end) {
  for(var i = start; i < end; i++) {
   if(i < 0 || i >= this.digits.length)
    list.push(0);
   else
    list.push(this.digits[i]);
  }
 }
};
})();
(function() {
var dropDownNameSuffix = "_DDD";
var itemImageCellClassName = "dxeIIC";
var CONSTANTS = {
 DROPDOWN_COMMAND_APPLY: "Apply",
 DROPDOWN_COMMAND_CLOSE: "Close",
 DROPDOWN_HELPTEXT_CLASS: "dxdd-help",
 DROPDOWN_CAPTION_CLASS: "dxdd-caption",
 DROPDOWN_HEADER_CLASS: "dxdd-header",
 DROPDOWN_MODALVISIBLE_CLASS: "dxdd-vmdd"
};
var DROPDOWN_ELEMENT_VISIBILITY = {
 Never: 0,
 DropDown: 1,
 ModalDropDown: 2,
 Always: 3
};
ASPx.DROPDOWN_ELEMENT_VISIBILITY = DROPDOWN_ELEMENT_VISIBILITY;
var ASPxClientDropDownEditBase = ASPx.CreateClass(ASPxClientButtonEditBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.DropDown = new ASPxClientEvent();
  this.CloseUp = new ASPxClientEvent();
  this.QueryCloseUp = new ASPxClientEvent();
  this.ddHeightCache = ASPx.InvalidDimension;
  this.ddWidthCache = ASPx.InvalidDimension;
  this.mainElementWidthCache = ASPx.InvalidDimension;
  this.dropDownButtonIndex = -1;
  this.droppedDown = false;
  this.ddButtonPushed = false;
  this.lastSuccessText = "";
  this.isToolbarItem = false;
  this.allowFocusDropDownWindow = false;
  this.pcIsShowingNow = false;
  this.needTimeoutForInputElementFocusEvent = false;
  this.ddButtonsVis = 0;
  this.ddmInput = false;
  this.ddDefCap = true;
  this.ddScrPicker = ASPx.DROPDOWN_ELEMENT_VISIBILITY.Never;
  this.accessibilityHelper = null;
  aspxGetDropDownCollection().Add(this);
 },
 InitializeEvents: function() {
  ASPxClientButtonEditBase.prototype.InitializeEvents.call(this);
  var ddTargets = this.getDropDownEventTargets();
  ddTargets
   .filter(function(trg, index, arr) { return trg && arr.indexOf(trg) === index; })
   .forEach(function(trg) {
    ASPx.Evt.AttachEventToElement(trg, "click", this.onDropDownEvent.bind(this));
    ASPx.Evt.AttachEventToElement(trg, ASPx.TouchUIHelper.touchMouseDownEventName, this.onDropDownEvent.bind(this));
  }.bind(this));
 },
 getDropDownEventTargets: function() {
  return [
   this.GetDropDownItemImageCell(),
   this.GetDropDownButton()
  ];
 },
 onDropDownEvent: function(evt) {
  if(evt.type === this.getDropDownEvent() && ASPx.Evt.IsLeftButtonPressed(evt) && this.GetEnabled())
   return this.OnDropDown(evt);
 },
 getDropDownEvent: function() {
  return this.isDropDownModal() || ASPx.Browser.MobileUI && !ASPx.Browser.MacOSMobilePlatform ? "click" : ASPx.TouchUIHelper.touchMouseDownEventName;
 },
 Initialize: function(){
  this.initializePopupControl();
  this.AssignClientAttributes();
  this.InitLastSuccessText();
  if(this.RefocusOnClickRequired()){ 
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "click", function(evt) {
    if(this.GetInputElement() && ASPx.Evt.GetEventSource(evt).id != this.GetInputElement().id) 
     this.ForceRefocusEditor(evt);
   }.aspxBind(this));
  }
  if(this.accessibilityCompliant && ASPx.IsExists(this.GetAccessibilityAssistantElement())) {
   this.GotFocus.AddHandler(function() { 
    this.ariaExplanatoryTextManager.SetHelperLabel(); 
   }.aspxBind(this));
  }
  ASPxClientButtonEditBase.prototype.Initialize.call(this);
 },
 initializePopupControl: function() {
  var pc = this.GetPopupControl();
  if(!pc) return;
  pc.usedInDropDown = true;
  pc.dropDownEditName = this.name;
  pc.setFocusOnCallback = false;
  this.initializeDropDown(pc);
 },
 initializeDropDown: function(pc) {
  pc = pc || this.GetPopupControl();
  if(!pc)
   return;
  if(this.ddmBP !== undefined) {
   pc.AdaptiveModeChanged.AddHandler(function() {
    this.onDropDownModalChanged(pc.GetAdaptiveModalMode());
   }.bind(this));
   pc.PopUp.AddHandler(function() {
    if(pc.GetAdaptiveModalMode())
     this.onDropDownModalChanged(true);
   }.bind(this));
   pc.Closing.AddHandler(function() {
    if(pc.GetAdaptiveModalMode())
     this.onDropDownModalChanged(false);
   }.bind(this));
  }
  this.initializeDropDownCommandButtons(pc);
  if(this.flSettings) {
   this.initializeDropDownContent(pc, this.flSettings.caption, this.flSettings.helpText);
   delete this.flSettings;
  }
 },
 initializeDropDownCommandButtons: function(pc) {
  this.dropDownCommandButtons = {};
  [CONSTANTS.DROPDOWN_COMMAND_APPLY, CONSTANTS.DROPDOWN_COMMAND_CLOSE].forEach(function(cmd) {
   var button = this.createDropDownCommandButtonClientInstance(pc, cmd);
   if(button) {
    button.allowFocus = false;
    button.useSubmitBehavior = false;
    button.causesValidation = false;
    button.accessibilityCompliant = this.accessibilityCompliant;
    button.Click.AddHandler(this.onDropDownCommandButtonClick.bind(this, cmd));
    button.InlineInitialize();
    this.dropDownCommandButtons[cmd] = button;
   }
  }.bind(this));
  this.ensureDropDownApplyCommandState();
 },
 createDropDownCommandButtonClientInstance: function(pc, cmd) {
  var buttonElementSelector = "." + CONSTANTS.DROPDOWN_HEADER_CLASS + " .dxbButtonSys[id*=" + cmd + "]";
  var popupContentContainer = pc.GetContentContainer(-1);
  var buttonElement = popupContentContainer ? popupContentContainer.querySelector(buttonElementSelector) : null;
  return buttonElement ? new ASPxClientButton(buttonElement.id) : null;  
 },
 initializeDropDownContent: function(pc, caption, helpText) {
  if(this.ddmBP === undefined)
   return;
  var container = pc.GetContentContainer(-1);
  if(helpText) {
   var helpTextContainer = container.querySelector(CONSTANTS.DROPDOWN_HELPTEXT_CLASS);
   if(!helpTextContainer) {
    helpTextContainer = document.createElement("div");
    helpTextContainer.innerHTML = this.HtmlEncode(helpText);
    helpTextContainer.className = CONSTANTS.DROPDOWN_HELPTEXT_CLASS + " " + CONSTANTS.DROPDOWN_MODALVISIBLE_CLASS;
    container.appendChild(helpTextContainer);
   }
  }
  if(caption && this.ddDefCap) {
   var captionContainer = container.querySelector("." + CONSTANTS.DROPDOWN_CAPTION_CLASS);
   if(!captionContainer) {
    captionContainer = document.createElement("div");
    captionContainer.className = CONSTANTS.DROPDOWN_CAPTION_CLASS + " " + CONSTANTS.DROPDOWN_MODALVISIBLE_CLASS;
    var headerContainer = container.querySelector("." + CONSTANTS.DROPDOWN_HEADER_CLASS);
    if(!headerContainer) {
     headerContainer = document.createElement("div");
     headerContainer.className = CONSTANTS.DROPDOWN_HEADER_CLASS + " " + CONSTANTS.DROPDOWN_MODALVISIBLE_CLASS;
     container.insertBefore(headerContainer, container.firstChild);
    }
    headerContainer.insertBefore(captionContainer, headerContainer.firstChild);
   }
   captionContainer.innerHTML = this.HtmlEncode(caption);
  }
 },
 InitLastSuccessText: function(){
  var rawText = this.GetTextInternal();
  this.SetLastSuccessText(rawText);
 },
 AssignClientAttributes: function(){
  var element = this.GetDropDownButton();
  if(ASPx.IsExistsElement(element))
   ASPx.Evt.PreventElementDragAndSelect(element, true);
 },
 RefocusOnClickRequired: function(){
  return false;
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientButtonEditBase.prototype.SetReadOnlyInternal.call(this, readOnly);
  if(this.isDropDownModal())
   this.ensureDropDownModalInputVisibility();
  this.ensureDropDownApplyCommandState();
 },
 SetEnabled: function(enabled) {
  ASPxClientButtonEditBase.prototype.SetEnabled.call(this, enabled);
  this.ensureDropDownApplyCommandState();
 },
 GetDropDownButton: function(){
  return this.GetButton(this.dropDownButtonIndex);
 },
 GetButtonCollection: function(){
  var buttonElements = ASPxClientButtonEditBase.prototype.GetButtonCollection.call(this);
  var dropDownButtonElement = this.GetDropDownButton();
  if(ASPx.IsExists(dropDownButtonElement))
   buttonElements.push(dropDownButtonElement);
  return buttonElements;
 },
 GetPopupControl: function(){
  var pc = ASPx.GetControlCollection().Get(this.name + dropDownNameSuffix);
  if(pc && pc.GetWindowElement(-1))
   return pc;
  else
   return null;
 },
 GetDropDownWindow: function() {
  var pc = this.GetPopupControl();
  if(pc)
   return pc.GetWindowElement(-1);
  return null;
 },
 GetDropDownInnerControlName: function(suffix){
  var pc = this.GetPopupControl();
  if(pc)
   return this.GetPopupControl().name + suffix;
  return "";
 },
 GetDropDownItemImageCell: function() {
  return ASPx.GetNodesByPartialClassName(this.GetMainElement(), itemImageCellClassName)[0];
 },
 GetIsControlWidthWasChanged: function(){
  return this.mainElementWidthCache == ASPx.InvalidDimension || this.mainElementWidthCache != this.GetMainElement().clientWidth;
 },
 GetDropDownHeight: function(){
  return null;
 },
 GetDropDownWidth: function(){
  return null;
 },
 GetDropDownIsWindowElement: function(id, pcPostfix) {
  var pos = id.lastIndexOf(pcPostfix);
  if(pos != -1) {
   var name = id.substring(0, pos);
   var pc = ASPx.GetPopupControlCollection().Get(name);
   if(pc && pc.dropDownEditName)
    return aspxGetDropDownCollection().Get(pc.dropDownEditName);
  }
  return null;
 },
 GetDropDownParents: function() {
  var parents = [ ];
  var mainElement = this.GetMainElement();
  var element = mainElement.parentNode;
  while(element != null){
   if(element.tagName == "BODY")
    break;
   var dropDown = this.GetElementIsDropDownParent(element);
   if(dropDown != null)
    parents.push(dropDown);
   element = element.parentNode;
  }
  return parents.reverse();
 },
 GetElementIsDropDownParent: function(element) {
  return ASPx.Attr.IsExistsAttribute(element, "id") 
   ? this.GetDropDownIsWindowElement(ASPx.Attr.GetAttribute(element, "id"), ASPx.PCWIdSuffix + "-1") : null;
 },
 BeforePopupControlResizing: function() {
 },
 AfterPopupControlResizing: function() {
 },
 AfterPopupControlShown: function() {
 },
 ShowDropDownArea: function(isRaiseEvent, forceSize) {
  this.SetPCIsShowingNow(true);
  aspxGetDropDownCollection().RegisterDroppedDownControl(this, this.GetDropDownParents());
  if(!this.droppedDown) 
   this.SetLockListBoxClick();
  this.lockClosing = true; 
  var pc = this.GetPopupControl();
  var element = this.GetMainElement();
  var pcwElement = pc.GetCurrentWindowElement();
  pc.OnBeforeDropdownShow();
  if(ASPx.Browser.Chrome && pcwElement.clientHeight <= 0) 
   this.RestorePopupInsideNonStaticPositionedContainer();
  var height = forceSize ? forceSize.height : this.GetDropDownHeight();
  var width = forceSize ? forceSize.width : this.GetDropDownWidth();
  this.BeforePopupControlResizing();
  if(this.ddHeightCache != height || this.ddWidthCache != width || forceSize) {
   pc.SetSize(width, height);
   if(!forceSize) {
    this.ddHeightCache = height;
    this.ddWidthCache = width;
   }
  }
  this.AfterPopupControlResizing();
  if(ASPx.Browser.Chrome && pcwElement.clientHeight <= 0) 
   this.RestorePopupInsideNonStaticPositionedContainer();
  this.RaiseDropDownEventRequired = isRaiseEvent;
  pc.ShowAtElement(element, true);
  this.AfterPopupControlShown();
  this.droppedDown = true;
  this.lockClosing = false;
 },
 HideDropDownArea: function(isRaiseEvent){
  if(this.lockClosing || !this.droppedDown) return;
  if(!this.RaiseQueryCloseUp()) {
   return;
  }
  this.RemoveLockListBoxClick();
  this.DropDownButtonPop();
  var pc = this.GetPopupControl();
  if(pc){
   aspxGetDropDownCollection().UnregisterDroppedDownControl(this);
   pc.Hide();
   if(isRaiseEvent)
    this.RaiseCloseUp();
   this.droppedDown = false;
  }
 },
 RaiseLostFocus: function() {
  this.ensureDropDownClosedOnLostFocus();
  ASPxClientButtonEditBase.prototype.RaiseLostFocus.call(this);
 },
 ensureDropDownClosedOnLostFocus: function() {
  if(!this.isDropDownModal() && this.droppedDown)
   this.HideDropDownArea(true);
 },
 RestorePopupInsideNonStaticPositionedContainer: function() {
  var pc = this.GetPopupControl();
  var pcwElement = pc.GetCurrentWindowElement();
  var pcwParentElement = pcwElement.parentNode;
  var offsetParentElement = pcwElement.offsetParent;
  if(!offsetParentElement || offsetParentElement.tagName == "BODY") return;
  pcwParentElement.style.position = "relative";
  setTimeout(
   function() { 
    pcwParentElement.style.position = "";
    if(this.focused)
     pc.ShowAtElement(this.GetMainElement());
   }.aspxBind(this), 0);
 },
 SetLockListBoxClick: function() {
  this.lockListBoxClick = true;
 },
 RemoveLockListBoxClick: function() {
  delete this.lockListBoxClick;
 },
 ProcessInternalButtonClick: function(buttonIndex) {
  return this.dropDownButtonIndex == buttonIndex;
 },
 ToggleDropDown: function(){
  this.OnApplyChanges();
  if(this.droppedDown)
   this.HideDropDownArea(true);
  else
   this.ShowDropDownArea(true);  
 },
 GetTextInternal: function(){
  var text = ASPxClientButtonEditBase.prototype.GetValue.call(this);
  return text != null ? text : "";
 },
 SetTextInternal: function(text){
  if(!this.GetReadOnly())
   this.SetTextBase(text);
 },
 SetTextBase: function(text) {
  ASPxClientButtonEditBase.prototype.SetValue.call(this, text);
 },
 SetValue: function(value) {
  ASPxClientButtonEditBase.prototype.SetValue.call(this, value);
  this.SetLastSuccessText(this.GetTextInternal());
 },
 SetLastSuccessText: function(text){
  var tmpText = text;
  if(text == null) tmpText = "";
  else if(typeof(text) != "string")
     tmpText = text.toString();
  this.lastSuccessText = tmpText;
 },
 SetVisible: function(visible) {
  ASPxClientButtonEditBase.prototype.SetVisible.call(this, visible);
  if(!visible)
   this.HideDropDown();
 },
 RollbackTextInputValue: function () {
  this.SetTextBase(this.lastSuccessText);
 },
 SetPCIsShowingNow: function(value){
  this.pcIsShowingNow = value;
 },
 GetLastSuccesfullValue: function() {
  return this.lastSuccessText !== '' ? this.lastSuccessText : null;
 },
 GetAccessibilityHelper: function() {
  if(!this.accessibilityCompliant)
   return null;
  if(!this.accessibilityHelper)
   this.accessibilityHelper = this.CreateAccessibilityHelper();
  return this.accessibilityHelper;
 },
 CreateAccessibilityHelper: function() {
  return new ASPx.AccessibilityHelperBase(this);
 },
 CreateAriaExplanatoryTextManager: function() {
  if(this.accessibilityCompliant)
   return new DropDownAccessibilityExplanatoryTextManager(this);
  else 
   return new ASPx.DisableAccessibilityExplanatoryTextManager(this);
 },
 GetAccessibilityText: function() {
  var labelText = "";
  var helperContainer = this.GetAccessibilityAssistantElement();
  if(ASPx.IsExists(helperContainer))
   labelText = ASPx.Attr.GetAttribute(helperContainer, "aria-label");
  return !!labelText ? labelText : this.GetTextInternal();
 },
 GetAccessibilityActiveElements: function() {
  var helperContainer = this.GetAccessibilityAssistantElement();
  if(!this.accessibilityCompliant || !ASPx.IsExists(helperContainer))
   return [this.GetInputElement()];
  return [this.GetAccessibilityHelper().GetActiveElement(true)];
 },
 OnValueChanged: function() {
  this.SetLastSuccessText(this.GetTextInternal());
  ASPxClientEdit.prototype.OnValueChanged.call(this);
 },
 OnApplyChanges: function(){
 },
 OnCancelChanges: function(){
  var isCancelProcessed = (this.GetTextInternal() != this.lastSuccessText);
  this.SetTextInternal(this.lastSuccessText);
  return isCancelProcessed;
 },
 OnFocus: function () {
  if(this.CorrectFocusWhenDisabled())
   return;
  if(ASPx.Browser.IE && this.needTimeoutForInputElementFocusEvent) {
   setTimeout(function () {
    this.OnFocusInternal();
    this.needTimeoutForInputElementFocusEvent = false;
   }.aspxBind(this), 0);
  } else
   this.OnFocusInternal();
 },
 OnFocusInternal: function() {
  this.OnSetFocus(true);
  ASPxClientButtonEditBase.prototype.OnFocus.call(this);
 },
 OnLostFocus: function(){
  this.OnSetFocus(false);
  ASPxClientButtonEditBase.prototype.OnLostFocus.call(this);
 },
 OnSetFocus: function(isFocused){
  aspxGetDropDownCollection().SetFocusedDropDownName(isFocused ? this.name : "");
 },
 IsEditorElement: function(element) {
  if(ASPxClientButtonEditBase.prototype.IsEditorElement.call(this, element))
   return true;
  if(this.allowFocusDropDownWindow)
   return false;
  var pc = this.GetPopupControl();
  if(pc != null) {
   var windowElement = pc.GetCurrentWindowElement();
   return windowElement == element || ASPx.GetIsParent(windowElement, element);
  }
  return false;
 },
 OnPopupControlShown: function(){
  this.SetPCIsShowingNow(false);
  if(this.RaiseDropDownEventRequired){
   this.RaiseDropDownEventRequired = false;
   window.setTimeout(function() { this.RaiseDropDown(); }.aspxBind(this), 0);
  }
 },
 IsCanToDropDown: function(){
  return true;
 },
 OnDropDown: function(evt) { 
  if(!this.isInitialized) 
   return true;
  if(evt.type === ASPx.TouchUIHelper.touchMouseDownEventName && ASPx.Evt.GetEventSource(evt) === this.GetInputElement())
   this.OnMouseDown();
  if(!this.IsCanToDropDown()) {
   this.ForceRefocusEditor(evt);
   return true;
  }
  if(ASPx.Browser.IE && ASPx.Browser.Version < 9 || ASPx.Browser.Opera){
   if(!this.droppedDown) {
    ASPx.Evt.EmulateOnMouseDown(this.GetMainElement(), evt);
    ASPx.GetStateController().ClearSavedCurrentPressedElement();
   }
  }
  this.OnDropDownCore(evt);
  if(this.needCancelBubbleDropDownEvent())
   return ASPx.Evt.CancelBubble(evt); 
  return true;
 },
 OnDropDownCore: function(evt) {
  if(!this.droppedDown)
   this.DropDownButtonPush();
  this.ToggleDropDown();
  var isNativeFocus = this.isNativeFocus(evt);
  if(!isNativeFocus || !ASPx.Browser.MacOSMobilePlatform)
   this.ForceRefocusEditor(evt, isNativeFocus);
 },
 isNativeFocus: function(evt) {
  var inputElement = this.GetInputElement();
  return !!inputElement ? this.IsElementBelongToInputElement(ASPx.Evt.GetEventSource(evt)) : false;
 },
 needCancelBubbleDropDownEvent: function() {
  return true;
 },
 DropDownButtonPush: function(){
  if(this.droppedDown || this.ddButtonPushed) return;
  this.ddButtonPushed = true;
  if(ASPx.Browser.IE && ASPx.Browser.Version < 9 || ASPx.Browser.Opera)
   this.DropDownButtonPushPop(true);
  else
   this.DropDownButtonPushMozilla();
 }, 
 DropDownButtonPop: function(force){
  if((!this.droppedDown || !this.ddButtonPushed) && !force) return;
  this.ddButtonPushed = false;
  if(ASPx.Browser.IE && ASPx.Browser.Version < 9 || ASPx.Browser.Opera)
   this.DropDownButtonPushPop(false);
  else
   this.DropDownButtonPopMozilla();
 },
 DropDownButtonPushPop: function(isPush){
  var buttonElement = this.GetDropDownButton();
  if(buttonElement){
   var controller = ASPx.GetStateController();
   var element = controller.GetPressedElement(buttonElement);
   if(element){
    if(isPush){
     controller.SetCurrentHoverElement(null);
     controller.DoSetPressedState(element);
    } else {
     controller.DoClearPressedState(element);
     controller.SetCurrentPressedElement(null);
     controller.SetCurrentHoverElement(element);
    }
   }
  }
 },
 DropDownButtonPushMozilla: function(){
  this.DisableStyleControllerForDDButton();
  var controller = ASPx.GetStateController();
  controller.savedCurrentPressedElement = null;
 },
 DropDownButtonPopMozilla: function(){
  this.EnableStyleControllerForDDButton();
  var controller = ASPx.GetStateController();
  var buttonElement = this.GetDropDownButton();
  if(buttonElement){
   var element = controller.GetPressedElement(buttonElement);
   if(element)
    controller.DoClearPressedState(element);
   controller.currentPressedElement = null;
   element = controller.GetHoverElement(buttonElement);
   if(element)
    controller.SetCurrentHoverElement(element);
  }
 },
 EnableStyleControllerForDDButton: function(){
  var element = this.GetDropDownButton();
  if(element){
   var controller = ASPx.GetStateController();
   this.ReplaceElementControlStyleItem(controller.hoverItems, ASPx.HoverItemKind, element, this.ddButtonHoverStyle);
   this.ReplaceElementControlStyleItem(controller.pressedItems, ASPx.PressedItemKind, element, this.ddButtonPressedStyle);
   this.ReplaceElementControlStyleItem(controller.selectedItems, ASPx.SelectedItemKind, element, this.ddButtonSelectedStyle);
  }
 },
 DisableStyleControllerForDDButton: function(){
  var element = this.GetDropDownButton();
  if(element){
   var controller = ASPx.GetStateController();
   this.ddButtonHoverStyle = this.ReplaceElementControlStyleItem(controller.hoverItems, ASPx.HoverItemKind, element, null);
   this.ddButtonPressedStyle = this.ReplaceElementControlStyleItem(controller.pressedItems, ASPx.PressedItemKind, element, null);
   this.ddButtonSelectedStyle = this.ReplaceElementControlStyleItem(controller.selectedItems, ASPx.SelectedItemKind, element, null);
  }
 },
 ReplaceElementControlStyleItem: function(items, kind, element, newStyleItem){
  var styleItem = items[element.id];
  items[element.id] = newStyleItem;
  element[kind] = newStyleItem;
  return styleItem;
 },
 CloseDropDownByDocumentOrWindowEvent: function(causedByWindowResizing){
  if(!causedByWindowResizing || !this.pcIsShowingNow)
   this.HideDropDownArea(true);
 },
 OnDocumentMouseUp: function() {
  this.DropDownButtonPop();
 },
 OnDDButtonMouseMove: function(evt){
 },
 ShouldCloseOnMCMouseDown: function () {
  return true;
 },
 OnMainCellMouseDown: function (evt) {
  if(this.ShouldCloseOnMCMouseDown())
   this.OnCloseUp(evt);
 },
 OnCloseUp: function (evt) {
  if(ASPx.Browser.IE) {
   this.needTimeoutForInputElementFocusEvent = true;
   setTimeout(function () { this.HideDropDownArea(true); }.aspxBind(this), 0);
  } else {
   this.HideDropDownArea(true);
  }
 },
 OnOpenAnotherDropDown: function(){
  this.HideDropDownArea(true);
 },
 OnTextChanged: function() {
  if(!this.ChangedByEnterKeyPress())
   this.OnTextChangedInternal();
 },
 OnTextChangedInternal: function() {
  this.ParseValue();
 },
 ChangedByEnterKeyPress: function() {
  if(ASPx.Browser.Firefox || ASPx.Browser.WebKitFamily) 
   if(this.enterKeyPressed) {
    this.enterKeyPressed = false;
    return true;
   } 
  return false;
 },
 ChangeEnabledAttributes: function(enabled){
  ASPxClientButtonEditBase.prototype.ChangeEnabledAttributes.call(this, enabled);
  var btnElement = this.GetDropDownButton();
  if(btnElement)
   this.ChangeButtonEnabledAttributes(btnElement, this.GetChangeButtonEnabledAttributesMethod(enabled));
  var inputElement = this.GetInputElement();
  if(inputElement)
   this.ChangeInputCellEnabledAttributes(inputElement.parentNode, ASPx.Attr.ChangeAttributesMethod(enabled));
  var imageCell = this.GetDropDownItemImageCell();
  if(ASPx.IsExists(imageCell))
   this.ChangeImageCellEnabledAttributes(imageCell, ASPx.Attr.ChangeAttributesMethod(enabled));
 },
 ChangeEnabledStateItems: function(enabled){
  ASPxClientButtonEditBase.prototype.ChangeEnabledStateItems.call(this, enabled);
  var btnElement = this.GetDropDownButton();
  if(btnElement)
   ASPx.GetStateController().SetElementEnabled(btnElement, enabled);
 },
 ChangeInputCellEnabledAttributes: function(element, method){
  method(element, "onclick");
  method(element, "onkeyup");
  if(ASPx.Browser.Edge)
   method(element, "onmousedown");
  method(element, "on" + ASPx.TouchUIHelper.touchMouseDownEventName);
  method(element, "on" + ASPx.TouchUIHelper.touchMouseUpEventName);
 },
 ChangeImageCellEnabledAttributes: function(imageCell, method){
  method(imageCell, "onmousedown");
 },
 InitializeKeyHandlers: function() {
  this.AddKeyDownHandler(ASPx.Key.Enter, "OnEnter");
  this.AddKeyDownHandler(ASPx.Key.Esc, "OnEscape");
  this.AddKeyDownHandler(ASPx.Key.PageUp, "OnPageUp");
  this.AddKeyDownHandler(ASPx.Key.PageDown, "OnPageDown");
  this.AddKeyDownHandler(ASPx.Key.End, "OnEndKeyDown");
  this.AddKeyDownHandler(ASPx.Key.Home, "OnHomeKeyDown");
  this.AddKeyDownHandler(ASPx.Key.Left, "OnArrowLeft");
  this.AddKeyDownHandler(ASPx.Key.Right, "OnArrowRight");
  this.AddKeyDownHandler(ASPx.Key.Up, "OnArrowUp");
  this.AddKeyDownHandler(ASPx.Key.Down, "OnArrowDown");
  this.AddKeyDownHandler(ASPx.Key.Tab, "OnTab");
 },
 OnArrowUp: function(evt){
  if(evt.altKey) {
   this.ToggleDropDown();
   return true;
  }
  return false;
 },
 OnArrowDown: function(evt){
  if(evt.altKey) {
   this.ToggleDropDown();
   return true;
  }
  return false;
 },
 OnPageUp: function(evt){
  return false;
 }, 
 OnPageDown: function(evt){
  return false;
 },
 OnEndKeyDown: function(evt){
  return false;
 },
 OnHomeKeyDown: function(evt){
  return false;
 },
 OnArrowLeft: function(evt){
  return false;
 },
 OnArrowRight: function(evt){
  return false;
 },
 OnEscape: function(evt){
  return this.OnEscapeInternal();
 },
 OnEscapeInternal: function() {
  var isCancelProcessed = this.OnCancelChanges() || this.droppedDown;
  this.HideDropDownArea(true);
  return isCancelProcessed;
 },
 OnEnter: function(evt){
  return false;
 },
 OnTab: function(evt){
  return false;
 },
 isDropDownModalRequired: function() {
  return this.ddmBP && window.innerWidth < this.ddmBP;
 },
 isDropDownModal: function(undefinedIfPopupIsDifferent) {
  var result = this.isDropDownModalRequired();
  if(undefinedIfPopupIsDifferent) {
   var pc = this.GetPopupControl();
   if(pc && pc.GetAdaptiveModalMode(-1) != result)
    return undefined;
  }
  return !!result;
 },
 onDropDownModalChanged: function(enabled) {
  if(!this.ddmInput)
   return;
  if(enabled)
   this.enableDropDownModal();
  else
   this.disableDropDownModal();
  if(this.focusedNullTextElement)
   this.ensureAdjustFocusedNullTextElement();
 },
 enableDropDownModal: function() {
  this.loadMainElementHeight();
  var pc = this.GetPopupControl();
  var contentContainer = pc.GetContentContainer(-1);
  var inputContainer = contentContainer.querySelector(".dxdd-input");
  var inputElement = this.GetInputElement();
  inputContainer.appendChild(inputElement);
  if(this.focusedNullTextElement)
   inputContainer.appendChild(this.focusedNullTextElement);
  this.initializeDropDownModalClearButton(inputContainer);
  if(this.dropDownModalClearButton)
   this.EnsureClearButtonVisibility();
  this.ensureDropDownModalInputVisibility(inputContainer);
 },
 disableDropDownModal: function() {
  this.resetMainElementHeight();
  var inputElement = this.GetInputElement();
  this.getInputCell().appendChild(inputElement);
  if(this.focusedNullTextElement)
   this.getInputCell().appendChild(this.focusedNullTextElement);
 },
 loadMainElementHeight: function() {
  var mainElement = this.GetMainElement();
  var mainElementHeight = mainElement.style.height;
  if(!mainElementHeight) {
   var currentHeight = mainElement.getBoundingClientRect().height;
   mainElement.style.height = currentHeight + "px";
   ASPx.Attr.SetAttribute(mainElement, "data-hasAssignedHeight", true);
  }
 },
 resetMainElementHeight: function() {
  var mainElement = this.GetMainElement();
  var hasAssignedHeight = ASPx.Attr.GetAttribute(mainElement, "data-hasAssignedHeight");
  if(hasAssignedHeight) {
   mainElement.style.height = "";
   ASPx.Attr.RemoveAttribute(mainElement, "data-hasAssignedHeight");
  }
 },
 ensureDropDownModalInputVisibility: function(inputContainer) {
  if(!inputContainer && this.ddmInput) {
   var pc = this.GetPopupControl();
   inputContainer = pc && pc.GetContentContainer(-1).querySelector(".dxdd-input");
  }
  if(!inputContainer)
   return;
  ASPx.ToggleClassNameToElement(inputContainer, "dxdd-readonly", this.GetReadOnly() || !this.GetEnabled());
 },
 onDropDownCommandButtonClick: function(command) {
  if(command === CONSTANTS.DROPDOWN_COMMAND_APPLY)
   this.onDropDownApplyCommandClick();
  this.onDropDownCloseCommandClick();
 },
 onDropDownApplyCommandClick: function() {
  throw "Not Implemented";
 },
 onDropDownCloseCommandClick: function() {
  throw "Not Implemented";
 },
 ensureDropDownApplyCommandState: function() {
  if(!this.dropDownCommandButtons)
   return;
  var button = this.dropDownCommandButtons[CONSTANTS.DROPDOWN_COMMAND_APPLY];
  if(button)
   button.SetEnabled(this.isDropDownApplyCommandEnabled());
 },
 isDropDownApplyCommandEnabled: function() {
  return this.GetEnabled() && !this.GetReadOnly();
 },
 initializeDropDownModalClearButton: function(inputContainer) {
  if(this.dropDownModalClearButton === undefined) {
   this.dropDownModalClearButton = inputContainer.querySelector(this.getDropDownModalClearButtonSelector()) || null;
   if(this.dropDownModalClearButton)
    ASPx.Evt.AttachEventToElement(this.dropDownModalClearButton, "click", this.onClearButtonClick.bind(this));
  }
 },
 getDropDownModalClearButtonSelector: function() {
  return ".dxdd-clearbutton";
 },
 EnsureClearButtonVisibility: function() {
  ASPxClientButtonEditBase.prototype.EnsureClearButtonVisibility.call(this);
  if(this.dropDownModalClearButton && this.isDropDownModal())
   ASPx.SetElementDisplay(this.dropDownModalClearButton, this.RequireShowClearButton());
 },
 applyFormLayoutItemSettings: function(settings) {
  var pc = this.GetPopupControl();
  if(pc)
   this.initializeDropDownContent(pc, settings.caption, settings.helpText);
  else
   this.flSettings = settings;
 },
 getInputCell: function() {
  var cell = ASPxClientButtonEditBase.prototype.getInputCell.call(this);
  return ASPx.ElementHasCssClass(cell, "dxic") ? cell : this.GetMainElement().querySelector(".dxic");
 },
 RaiseCloseUp: function(){
  if(!this.CloseUp.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.CloseUp.FireEvent(this, args);
  }
 },
 RaiseDropDown: function(){
  if(!this.DropDown.IsEmpty() && this.isInitialized){
   var args = new ASPxClientEventArgs();
   this.DropDown.FireEvent(this, args);
  }
 },
 RaiseQueryCloseUp: function(){
  if(!this.QueryCloseUp.IsEmpty() && this.isInitialized) {
   var args = new ASPxClientCancelEventArgs();
   this.QueryCloseUp.FireEvent(this, args);
   return !args.cancel;
  }
  return true;
 },
 AdjustDropDownWindow: function(){
  var pc = this.GetPopupControl();
  if(pc) {
   if(ASPx.Browser.IE)
    ASPx.GetPopupControlCollection().LockWindowResizeByBodyScrollVisibilityChanging();
   pc.AdjustSize();
   pc.UpdatePositionAtElement(this.GetMainElement());
   if(ASPx.Browser.IE)
    ASPx.GetPopupControlCollection().UnlockWindowResizeByBodyScrollVisibilityChanging();
  }
 },
 ResetDropDownSizeCache: function(){
  this.ddHeightCache = ASPx.InvalidDimension;
  this.ddWidthCache = ASPx.InvalidDimension;
 },
 ShowDropDown: function(){
  if(!this.droppedDown)
   this.ShowDropDownArea(false);
 },
 HideDropDown: function(){
  if(this.droppedDown)
   this.HideDropDownArea(false);
 }
});
var ASPxClientDropDownEdit = ASPx.CreateClass(ASPxClientDropDownEditBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.LostFocusInternal = new ASPxClientEvent();
  this.dropDownWindowHeight = "";
  this.dropDownWindowWidth = "";
  this.allowFocusDropDownWindow = true;
  this.needAdjustControlsInDropDownWindow = true;
  this.DropDownCommandButtonClick = new ASPxClientEvent();
 },
 UseSpecialKeyboardHandling: function() {
  return true;
 },
 getDropDownEventTargets: function() {
  return ASPxClientDropDownEditBase.prototype.getDropDownEventTargets.call(this).concat([
   this.shouldDropDownOnMCMouseDown() ? this.getInputCell() : null,
  ]);
 },
 shouldDropDownOnMCMouseDown: function() {
  return this.readOnly || !this.allowUserInput;
 },
 ShouldCloseOnMCMouseDown: function() {
  return !this.shouldDropDownOnMCMouseDown();
 },
 InitializeEvents: function() {
  this.LostFocus.AddHandler(this.ProcessLostFocus.aspxBind(this));
  this.QueryCloseUp.AddHandler(this.ProcessQueryCloseUp.aspxBind(this));
  ASPxClientDropDownEditBase.prototype.InitializeEvents.call(this);
 },
 RefocusOnClickRequired: function(){
  return ASPx.Browser.IE;
 },
 BeforePopupControlResizing: function() {
  var divContainer = this.GetDropDownDivContainer();
  if(divContainer && this.needAdjustControlsInDropDownWindow) {
   this.AdjustControlsInDropDownWindow();
   ASPx.SetElementDisplay(divContainer, false);
  }
 },
 AfterPopupControlResizing: function() {
  var divContainer = this.GetDropDownDivContainer();
  if(divContainer && this.needAdjustControlsInDropDownWindow) {
   ASPx.SetElementDisplay(divContainer, true);
   this.AdjustControlsInDropDownWindow();
   this.needAdjustControlsInDropDownWindow = false;
  }
 },
 AdjustControlsInDropDownWindow: function() {
  var pc = this.GetPopupControl();
  var pcwElement = pc.GetCurrentWindowElement();
  ASPx.GetControlCollection().ProcessControlsInContainer(pcwElement, function(control) {
   control.AdjustControl(false);
  });
 },
 GetDropDownDivContainer: function() {
  return ASPx.GetElementById(this.name + dropDownNameSuffix + "_DDDC");
 },
 GetDropDownHeight: function(){
  if(this.dropDownWindowHeight != "")
   return this.dropDownWindowHeight;
  return ASPxClientDropDownEditBase.prototype.GetDropDownHeight.call(this);
 },
 GetDropDownWidth: function(){
  if(this.dropDownWindowWidth != "")
   return this.dropDownWindowWidth;
  return this.GetMainElement().offsetWidth;
 },
 CloseDropDownByDocumentOrWindowEvent: function(causedByWindowResizing){
  if(!ASPx.GetPopupControlCollection().WindowResizeByBodyScrollVisibilityChangingLocked())
   ASPxClientDropDownEditBase.prototype.CloseDropDownByDocumentOrWindowEvent.call(this, causedByWindowResizing);
 },
 OnBrowserWindowResize: function(e){
  this.needAdjustControlsInDropDownWindow = true;
 },
 OnEnter: function(evt){
  return this.droppedDown;
 },
 OnEscape: function(evt){
  var isCancelProcessed = this.droppedDown;
  this.HideDropDownArea(true);
  return isCancelProcessed;
 },
 OnTextChanged: function() {
  this.OnValueChanged();
 },
 ProcessLostFocus: function() {
  if(!this.droppedDown)
   this.RaiseLostFocusInternal();
 },
 ProcessQueryCloseUp: function() {
  if(this.focused)
   return;
  var forceRefocusTimeout = 150;
  setTimeout(function() {
   if(!this.IsDropDownContainsFocus())
    this.RaiseLostFocusInternal();
  }.aspxBind(this), forceRefocusTimeout);
 },
 IsDropDownContainsFocus: function() {
  return ASPx.GetIsParent(this.GetDropDownWindow(), ASPx.GetActiveElement());
 },
 GetKeyValueInternal: function(){
  if(ASPx.IsExists(this.stateObject))
   return this.stateObject.keyValue;
  return null;
 },
 SetKeyValueInternal: function(keyValue){
  this.UpdateStateObjectWithObject({ keyValue: keyValue });
 },
 GetValueString: function() {
  var value = this.GetKeyValue();
  return (value === null || value === "") ? ASPxClientDropDownEditBase.prototype.GetValueString.call(this) : value.toString();
 },
 onDropDownCommandButtonClick: function(action) {
  this.raiseDropDownCommandButtonClick(action);
 },
 raiseDropDownCommandButtonClick: function(command) {
  var args = new ASPxClientDropDownCommandEventArgs(command);
  if(!this.DropDownCommandButtonClick.IsEmpty())
   this.DropDownCommandButtonClick.FireEvent(this, args);
  return !args.cancel;
 },
 GetKeyValue: function(){
  return this.GetKeyValueInternal();
 },
 SetKeyValue: function(keyValue){
  this.SetKeyValueInternal(keyValue);
 },
 RaiseLostFocusInternal: function() {
  if(!this.isInitialized)
   return;
  this.ensureDropDownClosedOnLostFocus();
  if(this.LostFocusInternal.IsEmpty())
   return;
  var args = new ASPxClientEventArgs();
  this.LostFocusInternal.FireEvent(this, args);
 },
 ensureDropDownClosedOnLostFocus: function() { }
});
ASPxClientDropDownEdit.Cast = ASPxClientControl.Cast;
var ASPxClientDropDownCollection = ASPx.CreateClass(ASPxClientControlCollection, {
 constructor: function() {
  this.constructor.prototype.constructor.call(this);
  this.droppedControlName = "";
  this.droppedParentNames = [ ];
  this.focusedControlName = "";
 },
 GetCollectionType: function(){
  return "DropDown";
 },
 SetFocusedDropDownName: function(name){
  this.focusedControlName = name;
 },
 ResetDroppedDownControl: function(){
  this.droppedControlName = "";
 },
 ResetDroppedDownParentCollection: function(startDroppedDownControlName) {
  var regArray = [ ];
  for(var i = 0; i < this.droppedParentNames.length; i++) {
   if(this.droppedParentNames[i] == startDroppedDownControlName)
    break;
   regArray.push(this.droppedParentNames[i]);
  }
  this.droppedParentNames = regArray;
  if(this.droppedParentNames.length > 0) {
   this.droppedControlName = this.droppedParentNames[this.droppedParentNames.length - 1];
   ASPx.Data.ArrayRemoveAt(this.droppedParentNames, this.droppedParentNames.length - 1);
  }
 },
 ResetFocusedControl: function(){
  this.focusedControlName = "";
 },
 GetFocusedDropDown: function(){
  var control = this.GetDropDownControlInternal(this.focusedControlName);
  if(control == null) this.ResetFocusedControl();
  return control;
 },
 GetDroppedDropDown: function(){
  var control = this.GetDropDownControlInternal(this.droppedControlName);
  if(control == null) this.ResetDroppedDownControl();
  return control;
 },
 GetDroppedDropDownParents: function(startDroppedDownControlName) {
  var dropDownArray = [ ];
  var isNeedGetControl = false;
  for(var i = 0; i < this.droppedParentNames.length; i++) {
   if(this.droppedParentNames[i] == startDroppedDownControlName) isNeedGetControl = true;
   if(isNeedGetControl) {
    var control = this.GetDropDownControlInternal(this.droppedParentNames[i]);
    if(control != null)
     dropDownArray.push(control);
   }
  }
  return dropDownArray;
 },
 FindFirstNameForClose: function(newDroppedDownParentArray) {
  var firstNameToClose = newDroppedDownParentArray.length > 0 ? "" : this.droppedParentNames[i];
  for(var i = 0; i < this.droppedParentNames.length; i++) {
   if(ASPx.Data.ArrayIndexOf(newDroppedDownParentArray, this.Get(this.droppedParentNames[i])) == -1) {
    firstNameToClose = this.droppedParentNames[i];
    break;
   }
  }
  return firstNameToClose;
 },
 GetDropDownControlInternal: function(name){
  var control = this.Get(name);
  var isControlExists = control && !control.IsDOMDisposed();
  if(!isControlExists)
   control = null;
  return control;
 },
 IsDroppedDropDownParentExist: function(name) {
  for(var i = 0; i < this.droppedParentNames.length; i++) {
   if(this.droppedParentNames[i] == name)
    return true;
  }
  return false;
 },
 OnDDButtonMouseMove: function(evt){
  var dropDownControl = this.GetDroppedDropDown();
  if(dropDownControl != null)
   dropDownControl.OnDDButtonMouseMove(evt);
 },
 OnDocumentMouseDown: function(evt){
  if(ASPxClientControl.documentDropDownMouseDownLocked) return; 
  if(!ASPx.TouchUIHelper.handleFastTapIfRequired(evt, function(){ this.CloseDropDownByDocumentOrWindowEvent(evt, false); }.aspxBind(this), false))
   this.CloseDropDownByDocumentOrWindowEvent(evt, false);
 },
 OnDocumentMouseUp: function(evt){
  var dropDownControl = this.GetDroppedDropDown();
  if(dropDownControl != null)
   dropDownControl.OnDocumentMouseUp();
 },
 OnBrowserWindowResize: function(e){
  if(typeof(ASPx.GetPopupControlCollection) != "undefined" && !ASPx.GetPopupControlCollection().WindowResizeByBodyScrollVisibilityChangingLocked()){
   this.CloseDropDownByDocumentOrWindowEvent(e.htmlEvent, true);
   this.AdjustControls();
  }
 },
 CloseDropDownByDocumentOrWindowEvent: function(evt, causedByWindowResizing){
  var dropDownControl = this.GetDroppedDropDown();
  if(dropDownControl != null && (this.IsEventNotFromControlSelf(evt, dropDownControl) || causedByWindowResizing))
   dropDownControl.CloseDropDownByDocumentOrWindowEvent(causedByWindowResizing);
  var childrenDropDownsToClose = this.GetDroppedDropDownParents(this.droppedParentNames[0]);
  if(childrenDropDownsToClose.length != 0) {
   childrenDropDownsToClose = childrenDropDownsToClose.reverse();
   this.ResetDroppedDownParentCollection(this.droppedParentNames[0]);
   var rollbackDroppedDownNames = [ ];
   for(var c = 0; c < childrenDropDownsToClose.length; c++) {
    if(this.IsEventNotFromControlSelf(evt, childrenDropDownsToClose[c]))
     childrenDropDownsToClose[c].CloseDropDownByDocumentOrWindowEvent(causedByWindowResizing);
    else
     rollbackDroppedDownNames.push(childrenDropDownsToClose[c].name);
   }
   if(rollbackDroppedDownNames != 0) {
    rollbackDroppedDownNames = rollbackDroppedDownNames.reverse();
    this.droppedParentNames = rollbackDroppedDownNames;
   }
  }
 },
 AdjustControls: function(){
  this.ForEachControl(function(control) {
   control.AdjustControl(false);
  });
 },
 IsEventNotFromControlSelf: function(evt, control){
  var srcElement = ASPx.Evt.GetEventSource(evt);
  var mainElement = control.GetMainElement();
  var dropDownWindow = control.GetDropDownWindow();
  if(!srcElement || !mainElement || !dropDownWindow) return true;
  return (!ASPx.GetIsParent(mainElement, srcElement) &&
   !ASPx.GetIsParent(dropDownWindow, srcElement) &&
   !this.IsEventFromSharedPopupOfInnerEditor(dropDownWindow, srcElement));
 },
 IsEventFromSharedPopupOfInnerEditor: function(dropDownWindow, srcElement) {
  var eventFromPopupOfInnerEditor = false;
  ASPx.GetControlCollection().ProcessControlsInContainer(dropDownWindow,
   function(control){
    if(control.calendarOwnerName) {
     var sharedCalendarPopup = control.GetCalendarOwner().GetDropDownWindow();
     if(ASPx.GetIsParent(sharedCalendarPopup, srcElement))
      eventFromPopupOfInnerEditor = true;
    }
  });
  return eventFromPopupOfInnerEditor;
 },
 RegisterDroppedDownControl: function(dropDownControl, droppedDownParentArray){
  var prevDropDownControl = this.GetDroppedDropDown();
  var areDroppedDownsCollectionParents = ASPx.Data.ArrayIndexOf(droppedDownParentArray, prevDropDownControl) != -1;
  if(prevDropDownControl != null && prevDropDownControl != dropDownControl && !areDroppedDownsCollectionParents)
   prevDropDownControl.OnOpenAnotherDropDown();
  if(this.droppedParentNames.length > 0) {
   var firstDropDownsNameToClose = this.FindFirstNameForClose(droppedDownParentArray);
   if(firstDropDownsNameToClose != "") {
    var childrenDropDownsToClose = this.GetDroppedDropDownParents(firstDropDownsNameToClose);
    this.ResetDroppedDownParentCollection(firstDropDownsNameToClose);
    this.CloseDroppedDownCollection(childrenDropDownsToClose.reverse());
   }
  }
  this.droppedControlName = dropDownControl.name;
  this.droppedParentNames = [ ];
  for(var i = 0; i < droppedDownParentArray.length; i++)
   this.droppedParentNames.push(droppedDownParentArray[i].name);
 },
 UnregisterDroppedDownControl: function(dropDownControl){
  if(this.droppedControlName == dropDownControl.name)
   this.ResetDroppedDownControl();
  if(this.IsDroppedDropDownParentExist(dropDownControl.name)) {
   var prevDropDownControl = this.GetDroppedDropDown();
   if(prevDropDownControl != null)
    prevDropDownControl.OnOpenAnotherDropDown();
   var childrenDropDownsToClose = this.GetDroppedDropDownParents(dropDownControl.name);
   this.ResetDroppedDownParentCollection(dropDownControl.name);
   ASPx.Data.ArrayRemoveAt(childrenDropDownsToClose, 0);
   this.CloseDroppedDownCollection(childrenDropDownsToClose.reverse());
  }
 },
 CloseDroppedDownCollection: function(dropDownParentArray) {
  for(var c = 0; c < dropDownParentArray.length; c++)
   dropDownParentArray[c].OnOpenAnotherDropDown();
 }
});
var DropDownAccessibilityExplanatoryTextManager = ASPx.CreateClass(ASPx.EditAccessibilityExplanatoryTextManager , {
 constructor: function(editor) {
  this.constructor.prototype.constructor.call(this, editor);
 },
 SetHelperLabel: function() {
  var pronounceText = this.editor.GetAccessibilityText();
  var labelElements = ASPx.FindAssociatedLabelElements(this.editor);
  if(labelElements.length > 0) {
   var labelText = labelElements.map(function(label) { return ASPx.GetInnerText(label); }).join(" ");
   if(pronounceText.indexOf(labelText) < 0)
    pronounceText = labelText + " " + pronounceText;
  }
  var pronounceElement = !!this.editor.accessibilityHelper ? 
   this.editor.accessibilityHelper.getItem(true) : 
   this.editor.GetAccessibilityAssistantElement();
  ASPx.Attr.SetAttribute(pronounceElement, "aria-label", pronounceText);
  var textElement = this.GetTextElement();
  if(ASPx.IsExists(textElement)) {
   if(!ASPx.IsExists(ASPx.Attr.GetAttribute(this.editor.GetInputElement(), 'aria-activedescendant')))
    pronounceElement = this.editor.GetInputElement();
   this.SetOrRemoveText([pronounceElement], textElement, true, false, false);
   setTimeout(function() {
    this.SetOrRemoveText([pronounceElement], textElement, false, false, false);
   }.aspxBind(this), 500);
  }
 }
});
var ASPxClientDropDownCommandEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function (command) {
  this.constructor.prototype.constructor.call(this);
  this.commandName = command;
 }
});
var dropDownCollection = null;
function aspxGetDropDownCollection() {
 if(dropDownCollection == null)
  dropDownCollection  = new ASPxClientDropDownCollection();
 return dropDownCollection;
}
ASPx.Ident.IsASPxClientDateEdit = function(obj) {
 return !!obj.isASPxClientDateEdit;
};
ASPx.DDMC_MD = function(name, evt) {
 var dd = ASPx.GetControlCollection().Get(name);
 if(dd)
  dd.OnMainCellMouseDown(evt);
};
ASPx.DDBPCShown = function(name){
 var cb = ASPx.GetControlCollection().Get(name);
 if(cb != null) cb.OnPopupControlShown();
};
ASPx.CBLBSelectedIndexChanged = function(name, evt){
 var cb = ASPx.GetControlCollection().Get(name);
 if(cb != null) cb.OnLBSelectedIndexChanged();
};
ASPx.CBLBItemMouseUp = function(name, evt){
 var cb = ASPx.GetControlCollection().Get(name);
 if(cb != null) cb.OnListBoxItemMouseUp(evt);
};
ASPx.Evt.AttachEventToDocument(ASPx.TouchUIHelper.touchMouseDownEventName, function(evt) {
 return aspxGetDropDownCollection().OnDocumentMouseDown(evt);
});
ASPx.Evt.AttachEventToDocument(ASPx.TouchUIHelper.touchMouseUpEventName, function(evt) {
 return aspxGetDropDownCollection().OnDocumentMouseUp(evt);
});
window.ASPxClientDropDownEditBase = ASPxClientDropDownEditBase;
window.ASPxClientDropDownEdit = ASPxClientDropDownEdit;
ASPx.GetDropDownCollection = aspxGetDropDownCollection;
})();

(function () {
 var PositionAnimationTransition = ASPx.CreateClass(ASPx.AnimationTransitionBase, {
  constructor: function (element, options) {
   this.constructor.prototype.constructor.call(this, element, options);
   this.direction = options.direction;
   this.animationTransition = this.createAnimationTransition();
   AnimationHelper.appendWKAnimationClassNameIfRequired(this.element);
  },
  Start: function (to) {
   var from = this.GetValue();
   if(ASPx.AnimationUtils.CanUseCssTransform()) {
    from = this.convertPosToCssTransformPos(from);
    to = this.convertPosToCssTransformPos(to);
   }
   this.animationTransition.Start(from, to);
  },
  SetValue: function (value) {
   ASPx.AnimationUtils.SetTransformValue(this.element, value, this.direction == AnimationHelper.SLIDE_VERTICAL_DIRECTION);
  },
  GetValue: function () {
   return ASPx.AnimationUtils.GetTransformValue(this.element, this.direction == AnimationHelper.SLIDE_VERTICAL_DIRECTION);
  },
  createAnimationTransition: function () {
   var transition = ASPx.AnimationUtils.CanUseCssTransform() ? this.createTransformAnimationTransition() : this.createPositionAnimationTransition();
   transition.transition = ASPx.AnimationConstants.Transitions.POW_EASE_OUT;
   return transition;
  },
  createTransformAnimationTransition: function () {
   return ASPx.AnimationUtils.createCssAnimationTransition(this.element, {
    property: ASPx.AnimationUtils.CanUseCssTransform(),
    duration: this.duration,
    onComplete: this.onComplete
   });
  },
  createPositionAnimationTransition: function () {
   return AnimationHelper.createAnimationTransition(this.element, {
    property: this.direction == AnimationHelper.SLIDE_VERTICAL_DIRECTION ? "top" : "left",
    unit: "px",
    duration: this.duration,
    onComplete: this.onComplete
   });
  },
  convertPosToCssTransformPos: function (position) {
   return ASPx.AnimationUtils.GetTransformCssText(position, this.direction == AnimationHelper.SLIDE_VERTICAL_DIRECTION);
  }
 });
 var AnimationHelper = {
  SLIDE_HORIZONTAL_DIRECTION: 0,
  SLIDE_VERTICAL_DIRECTION: 1,
  SLIDE_TOP_DIRECTION: 0,
  SLIDE_RIGHT_DIRECTION: 1,
  SLIDE_BOTTOM_DIRECTION: 2,
  SLIDE_LEFT_DIRECTION: 3,
  SLIDE_CONTAINER_CLASS: "dxAC",
  MAXIMUM_DEPTH: 3,
  createAnimationTransition: function (element, options) {
   if(options.onStep)
    options.animationEngineType = AnimationEngineType.JS;
   switch(options.animationEngineType) {
    case AnimationEngineType.JS:
     return ASPx.AnimationUtils.createJsAnimationTransition(element, options);
    case AnimationEngineType.CSS:
     return ASPx.AnimationUtils.createCssAnimationTransition(element, options);
    default:
     return ASPx.AnimationUtils.CanUseCssTransition() ? ASPx.AnimationUtils.createCssAnimationTransition(element, options) :
      ASPx.AnimationUtils.createJsAnimationTransition(element, options);
   }
  },
  createMultipleAnimationTransition: function (element, options) {
   return ASPx.AnimationUtils.createMultipleAnimationTransition(element, options);
  },
  createSimpleAnimationTransition: function (options) {
   return ASPx.AnimationUtils.createSimpleAnimationTransition(options);
  },
  cancelAnimation: function (element) {
   ASPx.AnimationTransitionBase.Cancel(element);
  },
  fadeIn: function(element, onComplete, duration, animationEngineType) {
   AnimationHelper.fadeTo(element, {
    from: 0, to: 1,
    onComplete: onComplete,
    animationEngineType: animationEngineType || AnimationEngineType.DEFAULT,
    duration: duration || ASPx.AnimationConstants.Durations.DEFAULT
   });
  },
  fadeOut: function(element, onComplete, duration, animationEngineType) {
   AnimationHelper.fadeTo(element, {
    from: ASPx.GetElementOpacity(element), to: 0,
    onComplete: onComplete,
    animationEngineType: animationEngineType || AnimationEngineType.DEFAULT,
    duration: duration || ASPx.AnimationConstants.Durations.DEFAULT
   });
  },
  fadeTo: function (element, options) {
   options.property = "opacity";
   if(!options.duration)
    options.duration = ASPx.AnimationConstants.Durations.SHORT;
   var transition = AnimationHelper.createAnimationTransition(element, options);
   if(!ASPx.IsExists(options.from))
    options.from = transition.GetValue();
   transition.Start(options.from, options.to);
  },
  slideIn: function (element, direction, onComplete, animationEngineType, rtl) {
   AnimationHelper.setOpacity(element, 1);
   var animationContainer = AnimationHelper.getSlideAnimationContainer(element, true, true);
   var pos = AnimationHelper.getSlideInStartPos(animationContainer, direction, rtl);
   var transition = AnimationHelper.createSlideTransition(animationContainer, direction,
    function (el) {
     AnimationHelper.resetSlideAnimationContainerSize(animationContainer);
     if(onComplete)
      onComplete(el);
    }, animationEngineType, rtl);
   transition.Start(pos, 0);
  },
  slideOut: function (element, direction, onComplete, animationEngineType, rtl) {
   var animationContainer = AnimationHelper.getSlideAnimationContainer(element, true, true);
   var pos = AnimationHelper.getSlideOutFinishPos(animationContainer, direction, rtl);
   var transition = AnimationHelper.createSlideTransition(animationContainer, direction,
    function (el) {
     AnimationHelper.setOpacity(el.firstChild, 0);
     if(onComplete)
      onComplete(el);
    }, animationEngineType, rtl);
   transition.Start(pos);
  },
  slideTo: function (element, options) {
   if(!ASPx.IsExists(options.direction))
    options.direction = AnimationHelper.SLIDE_HORIZONTAL_DIRECTION;
   var transition = new PositionAnimationTransition(element, options);
   transition.Start(options.to);
  },
  setOpacity: function (element, value) {
   ASPx.AnimationUtils.setOpacity(element, value);
  },
  appendWKAnimationClassNameIfRequired: function (element) {
   if(ASPx.AnimationUtils.CanUseCssTransform() && ASPx.Browser.WebKitFamily && !ASPx.ElementHasCssClass(element, "dx-wbv"))
    element.className += " dx-wbv";
  },
  findSlideAnimationContainer: function (element) {
   var container = element;
   for(var i = 0; i < AnimationHelper.MAXIMUM_DEPTH; i++) {
    if(container.tagName == "BODY")
     return null;
    if(ASPx.ElementHasCssClass(container, AnimationHelper.SLIDE_CONTAINER_CLASS))
     return container;
    container = container.parentNode;
   }
   return null;
  },
  createSlideAnimationContainer: function (element) {
   var rootContainer = document.createElement("DIV");
   ASPx.SetStyles(rootContainer, {
    className: AnimationHelper.SLIDE_CONTAINER_CLASS,
    overflow: "hidden"
   });
   var elementContainer = document.createElement("DIV");
   rootContainer.appendChild(elementContainer);
   var parentNode = element.parentNode;
   parentNode.insertBefore(rootContainer, element);
   elementContainer.appendChild(element);
   return rootContainer;
  },
  getSlideAnimationContainer: function (element, create, fixSize) {
   if(!element) return;
   var width = element.offsetWidth;
   var height = element.offsetHeight;
   var container;
   if(element.className == AnimationHelper.SLIDE_CONTAINER_CLASS)
    container = element;
   if(!container)
    container = AnimationHelper.findSlideAnimationContainer(element);
   if(!container && create)
    container = AnimationHelper.createSlideAnimationContainer(element);
   if(container && fixSize) {
    ASPx.SetStyles(container, {
     width: width, height: height
    });
    ASPx.SetStyles(container.firstChild, {
     width: width, height: height
    });
   }
   return container;
  },
  resetSlideAnimationContainerSize: function (container) {
   ASPx.SetStyles(container, {
    width: "", height: ""
   });
   ASPx.SetStyles(container.firstChild, {
    width: "", height: ""
   });
  },
  getModifyProperty: function (direction, rtl) {
   if(direction == AnimationHelper.SLIDE_TOP_DIRECTION || direction == AnimationHelper.SLIDE_BOTTOM_DIRECTION)
    return "marginTop";
   return rtl ? "margin-right" : "margin-left";
  },
  createSlideTransition: function (animationContainer, direction, complete, animationEngineType, rtl) {
   if(rtl == undefined)
    rtl = false;
   return AnimationHelper.createAnimationTransition(animationContainer.firstChild, {
    unit: "px",
    property: AnimationHelper.getModifyProperty(direction, rtl),
    onComplete: complete,
    animationEngineType: animationEngineType
   });
  },
  getSlideInStartPos: function (animationContainer, direction, rtl) {
   var dir = rtl ? -1 : 1;
   switch (direction) {
    case AnimationHelper.SLIDE_TOP_DIRECTION:
     return animationContainer.offsetHeight;
    case AnimationHelper.SLIDE_LEFT_DIRECTION:
     return animationContainer.offsetWidth * dir;
    case AnimationHelper.SLIDE_RIGHT_DIRECTION:
     return -animationContainer.offsetWidth * dir;
    case AnimationHelper.SLIDE_BOTTOM_DIRECTION:
     return -animationContainer.offsetHeight;
   }
  },
  getSlideOutFinishPos: function (animationContainer, direction, rtl) {
   var dir = rtl ? -1 : 1;
   switch (direction) {
    case AnimationHelper.SLIDE_TOP_DIRECTION:
     return -animationContainer.offsetHeight;
    case AnimationHelper.SLIDE_LEFT_DIRECTION:
     return -animationContainer.offsetWidth * dir;
    case AnimationHelper.SLIDE_RIGHT_DIRECTION:
     return animationContainer.offsetWidth * dir;
    case AnimationHelper.SLIDE_BOTTOM_DIRECTION:
     return animationContainer.offsetHeight;
   }
  }
 };
 var GestureHandler = ASPx.CreateClass(null, {
  constructor: function (getAnimationElement, canHandle, allowStart) {
   this.getAnimationElement = getAnimationElement;
   this.canHandle = canHandle;
   this.allowStart = allowStart;
   this.startMousePosX = 0;
   this.startMousePosY = 0;
   this.startTime = null;
   this.isEventsPrevented = false;
   this.savedElements = [];
  },
  OnSelectStart: function(evt) {
   ASPx.Evt.PreventEvent(evt); 
  },
  OnDragStart: function(evt) {
   ASPx.Evt.PreventEvent(evt);  
  },
  OnMouseDown: function (evt) {
   this.startMousePosX = ASPx.Evt.GetEventX(evt);
   this.startMousePosY = ASPx.Evt.GetEventY(evt);
   this.startTime = new Date();
  },
  OnMouseMove: function(evt) {
   if(!ASPx.Browser.MobileUI)
    ASPx.Selection.Clear();
   if(Math.abs(this.GetCurrentDistanceX(evt)) < GestureHandler.SLIDER_MIN_START_DISTANCE && Math.abs(this.GetCurrentDistanceY(evt)) < GestureHandler.SLIDER_MIN_START_DISTANCE)
    GesturesHelper.isExecutedGesture = false;
  },
  OnMouseUp: function (evt) {
  },
  CanHandleEvent: function (evt) {
   return !this.canHandle || this.canHandle(evt);
  },
  IsStartAllowed: function(value) {
   return !this.allowStart || this.allowStart(value);
  },
  RollbackGesture: function () {
  },
  GetRubberPosition: function (position) {
   return position / GestureHandler.FACTOR_RUBBER;
  },
  GetCurrentDistanceX: function (evt) {
   return ASPx.Evt.GetEventX(evt) - this.startMousePosX;
  },
  GetCurrentDistanceY: function (evt) {
   return ASPx.Evt.GetEventY(evt) - this.startMousePosY;
  },
  GetDistanceLimit: function () {
   return (new Date() - this.startTime) < GestureHandler.MAX_TIME_SPAN ? GestureHandler.MIN_DISTANCE_LIMIT : GestureHandler.MAX_DISTANCE_LIMIT;
  },
  GetContainerElement: function () {
  },
  AttachPreventEvents: function (evt) {
   if(!this.isEventsPrevented) {
    var element = ASPx.Evt.GetEventSource(evt);
    var container = this.GetContainerElement();
    while(element && element != container) {
     ASPx.Evt.AttachEventToElement(element, "mouseup", ASPx.Evt.PreventEvent);
     ASPx.Evt.AttachEventToElement(element, "click", ASPx.Evt.PreventEvent);
     this.savedElements.push(element);
     element = element.parentNode;
    }
    this.isEventsPrevented = true;
   }
  },
  DetachPreventEvents: function () {
   if(this.isEventsPrevented) {
    window.setTimeout(function () {
     while(this.savedElements.length > 0) {
      var element = this.savedElements.pop();
      ASPx.Evt.DetachEventFromElement(element, "mouseup", ASPx.Evt.PreventEvent);
      ASPx.Evt.DetachEventFromElement(element, "click", ASPx.Evt.PreventEvent);
     }
    }.aspxBind(this), 0);
    this.isEventsPrevented = false;
   }
  }
 });
 GestureHandler.MAX_DISTANCE_LIMIT = 70;
 GestureHandler.MIN_DISTANCE_LIMIT = 10;
 GestureHandler.MIN_START_DISTANCE = 0;
 GestureHandler.SLIDER_MIN_START_DISTANCE = 5;
 GestureHandler.MAX_TIME_SPAN = 300;
 GestureHandler.FACTOR_RUBBER = 4;
 GestureHandler.RETURN_ANIMATION_DURATION = 150;
 var SwipeSlideGestureHandler = ASPx.CreateClass(GestureHandler, {
  constructor: function (getAnimationElement, direction, canHandle, backward, forward, rollback, move) {
   this.constructor.prototype.constructor.call(this, getAnimationElement, canHandle);
   this.slideElement = this.getAnimationElement();
   this.container = this.slideElement.parentNode;
   this.direction = direction;
   this.backward = backward;
   this.forward = forward;
   this.rollback = rollback;
   this.slideElementSize = 0;
   this.containerElementSize = 0;
   this.startSliderElementPosition = 0;
   this.centeredSlideElementPosition = 0;
  },
  OnMouseDown: function (evt) {
   GestureHandler.prototype.OnMouseDown.call(this, evt);
   this.slideElementSize = this.GetElementSize();
   this.startSliderElementPosition = this.GetElementPosition();
   this.containerElementSize = this.GetContainerElementSize();
   if(this.slideElementSize <= this.containerElementSize)
    this.centeredSlideElementPosition = (this.containerElementSize - this.slideElementSize) / 2;
  },
  OnMouseMove: function (evt) {
   GestureHandler.prototype.OnMouseMove.call(this, evt);
   if(!ASPx.Browser.TouchUI && !ASPx.GetIsParent(this.container, ASPx.Evt.GetEventSource(evt))) {
    GesturesHelper.OnDocumentMouseUp(evt);
    return;
   }
   var distance = this.GetCurrentDistance(evt);
   if(Math.abs(distance) < GestureHandler.SLIDER_MIN_START_DISTANCE || ASPx.TouchUIHelper.isGesture)
    return;
   this.SetElementPosition(this.GetCalculatedPosition(distance));
   this.AttachPreventEvents(evt);
   ASPx.Evt.PreventEvent(evt);
  },
  GetCalculatedPosition: function (distance) {
   ASPx.AnimationTransitionBase.Cancel(this.slideElement);
   var position = this.startSliderElementPosition + distance,
    maxPosition = -(this.slideElementSize - this.containerElementSize),
    minPosition = 0;
   if(this.centeredSlideElementPosition > 0)
    position = this.GetRubberPosition(distance) + this.centeredSlideElementPosition;
   else if(position > minPosition)
    position = this.GetRubberPosition(distance);
   else if(position < maxPosition)
    position = this.GetRubberPosition(distance) + maxPosition;
   return position;
  },
  OnMouseUp: function (evt) {
   this.DetachPreventEvents();
   if(this.GetCurrentDistance(evt) != 0)
    this.OnMouseUpCore(evt);
  },
  OnMouseUpCore: function (evt) {
   var distance = this.GetCurrentDistance(evt);
   if(this.centeredSlideElementPosition > 0 || this.CheckSlidePanelIsOutOfBounds())
    this.PerformRollback();
   else
    this.PerformAction(distance);
  },
  PerformAction: function (distance) {
   if(Math.abs(distance) < this.GetDistanceLimit())
    this.PerformRollback();
   else if(distance < 0)
    this.PerformForward();
   else
    this.PerformBackward();
  },
  PerformBackward: function () {
   this.backward();
  },
  PerformForward: function () {
   this.forward();
  },
  PerformRollback: function () {
   this.rollback();
  },
  CheckSlidePanelIsOutOfBounds: function () {
   var minOffset = -(this.slideElementSize - this.containerElementSize), maxOffset = 0;
   var slideElementPos = this.GetElementPosition();
   if(slideElementPos > maxOffset || slideElementPos < minOffset)
    return true;
   return false;
  },
  GetContainerElement: function () {
   return this.container;
  },
  GetElementSize: function () {
   return this.IsHorizontalDirection() ? this.slideElement.offsetWidth : this.slideElement.offsetHeight;
  },
  GetContainerElementSize: function () {
   return this.IsHorizontalDirection() ? ASPx.GetClearClientWidth(this.container) : ASPx.GetClearClientHeight(this.container);
  },
  GetCurrentDistance: function (evt) {
   return this.IsHorizontalDirection() ? this.GetCurrentDistanceX(evt) : this.GetCurrentDistanceY(evt);
  },
  GetElementPosition: function () {
   return ASPx.AnimationUtils.GetTransformValue(this.slideElement, !this.IsHorizontalDirection());
  },
  SetElementPosition: function (position) {
   ASPx.AnimationUtils.SetTransformValue(this.slideElement, position, !this.IsHorizontalDirection());
  },
  IsHorizontalDirection: function () {
   return this.direction == AnimationHelper.SLIDE_HORIZONTAL_DIRECTION;
  }
 });
 var SwipeSimpleSlideGestureHandler = ASPx.CreateClass(SwipeSlideGestureHandler, {
  constructor: function (getAnimationElement, direction, canHandle, backward, forward, rollback, updatePosition) {
   this.constructor.prototype.constructor.call(this, getAnimationElement, direction, canHandle, backward, forward, rollback);
   this.container = this.slideElement;
   this.updatePosition = updatePosition;
   this.prevDistance = 0;
  },
  OnMouseDown: function (evt) {
   GestureHandler.prototype.OnMouseDown.call(this, evt);
   this.prevDistance = 0;
  },
  OnMouseUpCore: function (evt) {
   this.PerformAction(this.GetCurrentDistance(evt));
  },
  PerformAction: function (distance) {
   if(Math.abs(distance) < this.GetDistanceLimit())
    this.PerformRollback();
   else if(distance < 0)
    this.PerformForward();
   else
    this.PerformBackward();
  },
  GetCalculatedPosition: function (distance) {
   var position = distance - this.prevDistance;
   this.prevDistance = distance;
   return position;
  },
  SetElementPosition: function (position) {
   this.updatePosition(position);
  }
 });
 var SwipeGestureHandler = ASPx.CreateClass(GestureHandler, {
  constructor: function (getAnimationElement, canHandle, allowStart, start, allowComplete, complete, cancel, animationEngineType, rtl) {
   this.constructor.prototype.constructor.call(this, getAnimationElement, canHandle, allowStart);
   this.start = start;
   this.allowComplete = allowComplete;
   this.complete = complete;
   this.cancel = cancel;
   this.animationTween = null;
   this.currentDistanceX = 0;
   this.currentDistanceY = 0;
   this.tryStartGesture = false;
   this.tryStartScrolling = false;
   this.animationEngineType = animationEngineType;
   this.rtl = rtl;
   this.UpdateAnimationContainer();
  },
  UpdateAnimationContainer: function () {
   this.animationContainer = AnimationHelper.getSlideAnimationContainer(this.getAnimationElement(), true, false);
  },
  CanHandleEvent: function (evt) {
   if(GestureHandler.prototype.CanHandleEvent.call(this, evt))
    return true;
   return this.animationTween && this.animationContainer && ASPx.GetIsParent(this.animationContainer, ASPx.Evt.GetEventSource(evt));
  },
  OnMouseDown: function (evt) {
   GestureHandler.prototype.OnMouseDown.call(this, evt);
   if(this.animationTween)
    this.animationTween.Cancel();
   this.currentDistanceX = 0;
   this.currentDistanceY = 0;
   this.tryStartGesture = false;
   this.tryStartScrolling = false;
  },
  OnMouseMove: function (evt) {
   GestureHandler.prototype.OnMouseMove.call(this, evt);
   var isZoomGestureConflict = evt.touches && evt.touches.length > 1;
   if (isZoomGestureConflict)
    return false;
   this.currentDistanceX = this.GetCurrentDistanceX(evt);
   this.currentDistanceY = this.GetCurrentDistanceY(evt);
   if(this.rtl)
    this.currentDistanceX = -this.currentDistanceX;
   if(!this.animationTween && !this.tryStartScrolling && (Math.abs(this.currentDistanceX) >
    GestureHandler.MIN_START_DISTANCE || Math.abs(this.currentDistanceY) > GestureHandler.MIN_START_DISTANCE)) {
    if(Math.abs(this.currentDistanceY) < Math.abs(this.currentDistanceX)) {
     this.tryStartGesture = true;
     if(this.IsStartAllowed(this.currentDistanceX)) {
      this.animationContainer = AnimationHelper.getSlideAnimationContainer(this.getAnimationElement(), true, true);
      this.animationTween = AnimationHelper.createSlideTransition(this.animationContainer, AnimationHelper.SLIDE_LEFT_DIRECTION,
       function () {
        AnimationHelper.resetSlideAnimationContainerSize(this.animationContainer);
        this.animationContainer = null;
        this.animationTween = null;
       }.aspxBind(this), this.animationEngineType, this.rtl);
      this.PerformStart(this.currentDistanceX);
      this.AttachPreventEvents(evt);
     }
    }
    else
     this.tryStartScrolling = true;
   }
   if(this.animationTween) {
    if(this.allowComplete && !this.allowComplete(this.currentDistanceX))
     this.currentDistanceX = this.GetRubberPosition(this.currentDistanceX);
    this.animationTween.SetValue(this.currentDistanceX);
   }
   if(!this.tryStartScrolling && !ASPx.TouchUIHelper.isGesture && evt.touches && evt.touches.length < 2)
    ASPx.Evt.PreventEvent(evt);
  },
  OnMouseUp: function (evt) {
   if(!this.animationTween) {
    if(this.tryStartGesture)
     this.PerformCancel(this.currentDistanceX);
   }
   else {
    if(Math.abs(this.currentDistanceX) < this.GetDistanceLimit())
     this.RollbackGesture();
    else {
     if(this.IsCompleteAllowed(this.currentDistanceX)) {
      this.PerformComplete(this.currentDistanceX);
      this.animationContainer = null;
      this.animationTween = null;
     }
     else
      this.RollbackGesture();
    }
   }
   this.DetachPreventEvents();
   this.tryStartGesture = false;
   this.tryStartScrolling = false;
  },
  PerformStart: function (value) {
   if(this.start)
    this.start(value);
  },
  IsCompleteAllowed: function (value) {
   return !this.allowComplete || this.allowComplete(value);
  },
  PerformComplete: function (value) {
   if(this.complete)
    this.complete(value);
  },
  PerformCancel: function (value) {
   if(this.cancel)
    this.cancel(value);
  },
  RollbackGesture: function () {
   this.animationTween.Start(this.currentDistanceX, 0);
  },
  ResetGestureElementPosition: function () {
   if (this.currentDistanceX === 0) return;
   var container = AnimationHelper.getSlideAnimationContainer(this.getAnimationElement());
   var onComplete = function () { AnimationHelper.resetSlideAnimationContainerSize(container); };
   var animation = AnimationHelper.createSlideTransition(container, AnimationHelper.SLIDE_LEFT_DIRECTION, onComplete, this.animationEngineType, this.rtl);
   animation.Start(this.currentDistanceX, 0);
  },
  GetContainerElement: function () {
   return this.animationContainer;
  }
 });
 var GesturesHelper = {
  handlers: {},
  activeHandler: null,
  isAttachedEvents: false,
  isExecutedGesture: false,
  AddSwipeGestureHandler: function (id, getAnimationElement, canHandle, allowStart, start, allowComplete, complete, cancel, animationEngineType, rtl) {
   this.handlers[id] = new SwipeGestureHandler(getAnimationElement, canHandle, allowStart, start, allowComplete, complete, cancel, animationEngineType, rtl);
  },
  UpdateSwipeAnimationContainer: function (id) {
   if(this.handlers[id])
    this.handlers[id].UpdateAnimationContainer();
  },
  AddSwipeSlideGestureHandler: function (id, getAnimationElement, direction, canHandle, backward, forward, rollback, updatePosition) {
   if(updatePosition)
    this.handlers[id] = new SwipeSimpleSlideGestureHandler(getAnimationElement, direction, canHandle, backward, forward, rollback, updatePosition);
   else
    this.handlers[id] = new SwipeSlideGestureHandler(getAnimationElement, direction, canHandle, backward, forward, rollback);
  },
  getParentDXEditorWithSwipeGestures: function(element) {
     return ASPx.GetParent(element, function(parent) {
      var parentObj = ASPx.GetControlCollection().Get(parent.id);
      return parentObj && parentObj.supportGestures && parentObj.isSwipeGesturesEnabled();
   });
  },
  canHandleMouseDown: function(evt) {
   if(!ASPx.Evt.IsLeftButtonPressed(evt))
    return false;
   var element = ASPx.Evt.GetEventSource(evt);
   var dxFocusedEditor = ASPx.Ident.scripts.ASPxClientEdit && ASPx.GetFocusedEditor();
   if(dxFocusedEditor && dxFocusedEditor.IsEditorElement(element)) {
    var elementParentDXEditorWithSwipeGestures = GesturesHelper.getParentDXEditorWithSwipeGestures(element);
    if(!elementParentDXEditorWithSwipeGestures || !dxFocusedEditor.IsEditorElement(elementParentDXEditorWithSwipeGestures))
     return false;
   }
   var isTextEditor = element.tagName == "TEXTAREA" || element.tagName == "INPUT" && ASPx.Attr.GetAttribute(element, "type") == "text";
   if(isTextEditor && document.activeElement == element)
    return false;
   return true;  
  },
  OnDocumentDragStart: function(evt) {
   if(GesturesHelper.activeHandler)
    GesturesHelper.activeHandler.OnDragStart(evt);
  },
  OnDocumentSelectStart: function(evt) {
   if(GesturesHelper.activeHandler)
    GesturesHelper.activeHandler.OnSelectStart(evt);
  },
  OnDocumentMouseDown: function (evt) {
   if(!GesturesHelper.canHandleMouseDown(evt))
    return;
   GesturesHelper.activeHandler = GesturesHelper.FindHandler(evt);
   if(GesturesHelper.activeHandler)
    GesturesHelper.activeHandler.OnMouseDown(evt);
  },
  OnDocumentMouseMove: function (evt) {
   if(GesturesHelper.activeHandler) {
    GesturesHelper.isExecutedGesture = true;
    GesturesHelper.activeHandler.OnMouseMove(evt);
   }
  },
  OnDocumentMouseUp: function (evt) {
   if(GesturesHelper.activeHandler) {
    GesturesHelper.activeHandler.OnMouseUp(evt);
    GesturesHelper.activeHandler = null;
    window.setTimeout(function () { GesturesHelper.isExecutedGesture = false; }, 0);
   }
  },
  AttachEvents: function () {
   if(!GesturesHelper.isAttachedEvents) {
    GesturesHelper.Attach(ASPx.Evt.AttachEventToElement);
    GesturesHelper.isAttachedEvents = true;
   }
  },
  DetachEvents: function () {
   if(GesturesHelper.isAttachedEvents) {
    GesturesHelper.Attach(ASPx.Evt.DetachEventFromElement);
    GesturesHelper.isAttachedEvents = false;
   }
  },
  Attach: function (changeEventsMethod) {
   var doc = window.document;
   changeEventsMethod(doc, ASPx.TouchUIHelper.touchMouseDownEventName, GesturesHelper.OnDocumentMouseDown);
   changeEventsMethod(doc, ASPx.TouchUIHelper.touchMouseMoveEventName, GesturesHelper.OnDocumentMouseMove);
   changeEventsMethod(doc, ASPx.TouchUIHelper.touchMouseUpEventName, GesturesHelper.OnDocumentMouseUp);
   if(!ASPx.Browser.MobileUI) {
    changeEventsMethod(doc, "selectstart", GesturesHelper.OnDocumentSelectStart);
    changeEventsMethod(doc, "dragstart", GesturesHelper.OnDocumentDragStart);
   }
  },
  FindHandler: function (evt) {
   var handlers = [];
   for(var id in GesturesHelper.handlers) {
    if(GesturesHelper.handlers.hasOwnProperty(id)) {
     var handler = GesturesHelper.handlers[id];
     if(handler.CanHandleEvent && handler.CanHandleEvent(evt))
      handlers.push(handler);
    }
   }
   if(!handlers.length)
    return null;
   handlers.sort(function (a, b) {
    return ASPx.GetIsParent(a.getAnimationElement(), b.getAnimationElement()) ? 1 : -1;
   });
   return handlers[0];
  },
  IsExecutedGesture: function () {
   return GesturesHelper.isExecutedGesture;
  }
 };
 GesturesHelper.AttachEvents();
 var AnimationEngineType = {
  "DEFAULT": 0,
  "CSS": 1,
  "JS": 2
 };
 ASPx.AnimationEngineType = AnimationEngineType;
 ASPx.AnimationHelper = AnimationHelper;
 ASPx.GesturesHelper = GesturesHelper;
})();

(function () {
var PopupUtils = {
 NotSetAlignIndicator: "NotSet",
 InnerAlignIndicator: "Sides",
 OutsideLeftAlignIndicator: "OutsideLeft",
 LeftSidesAlignIndicator: "LeftSides",
 RightSidesAlignIndicator: "RightSides",
 OutsideRightAlignIndicator: "OutsideRight",
 CenterAlignIndicator: "Center",
 AboveAlignIndicator: "Above",
 TopSidesAlignIndicator: "TopSides",
 MiddleAlignIndicator: "Middle",
 BottomSidesAlignIndicator: "BottomSides",
 BelowAlignIndicator: "Below",
 WindowCenterAlignIndicator: "WindowCenter",
 LeftAlignIndicator: "Left",
 RightAlignIndicator: "Right",
 TopAlignIndicator: "Top",
 BottomAlignIndicator: "Bottom",
 WindowLeftAlignIndicator: "WindowLeft",
 WindowRightAlignIndicator: "WindowRight",
 WindowTopAlignIndicator: "WindowTop",
 WindowBottomAlignIndicator: "WindowBottom",
 IsAlignNotSet: function (align) {
  return align == PopupUtils.NotSetAlignIndicator;
 },
 IsInnerAlign: function (align) {
  return align.indexOf(PopupUtils.InnerAlignIndicator) != -1;
 },
 IsRightSidesAlign: function(align) {
  return align == PopupUtils.RightSidesAlignIndicator;
 },
 IsOutsideRightAlign: function(align) {
  return align == PopupUtils.OutsideRightAlignIndicator;
 },
 IsCenterAlign: function(align) {
  return align == PopupUtils.CenterAlignIndicator;
 },
 FindPopupElementById: function (id) {
  if(id == "")
   return null; 
  var popupElement = ASPx.GetElementById(id);
  if(!ASPx.IsExistsElement(popupElement)) {
   var idParts = id.split("_");
   var uniqueId = idParts.join("$");
   popupElement = ASPx.GetElementById(uniqueId);
  }
  return popupElement;
 },
 FindEventSourceParentByTestFunc: function (evt, testFunc) {
  return ASPx.GetParent(ASPx.Evt.GetEventSource(evt), testFunc);
 },
 PreventContextMenu: function (evt) {
  ASPx.Evt.PreventEventAndBubble(evt);
  if(ASPx.Browser.WebKitFamily)
   evt.returnValue = false;
 },
 GetDocumentClientWidthForPopup: function() {
  return ASPx.Browser.WebKitTouchUI ? document.body.offsetWidth : ASPx.GetDocumentClientWidth();
 },
 GetDocumentClientHeightForPopup: function() {
  return ASPx.Browser.WebKitTouchUI ? document.body.offsetHeight : ASPx.GetDocumentClientHeight();
 },
 AdjustPositionToClientScreen: function (element, pos, rtl, isX) {
  var min = isX ? ASPx.GetDocumentScrollLeft() : ASPx.GetDocumentScrollTop(),
   max = min + (isX ? ASPx.GetDocumentClientWidth() : ASPx.GetDocumentClientHeight());
  max -= (isX ? element.offsetWidth : element.offsetHeight);
  if(rtl && isX) {
   if(pos < min) pos = min;
   if(pos > max) pos = max;
  } else {
   if(pos > max) pos = max;
   if(pos < min) pos = min;
  }
  return pos;
 },
 GetPopupAbsoluteX: function(element, popupElement, hAlign, hOffset, x, left, rtl, isPopupFullCorrectionOn, showPopupInsideScreenBounds) {
  return PopupUtils.getPopupAbsolutePos(element, popupElement, hAlign, hOffset, x, left, rtl, isPopupFullCorrectionOn, false, false, true, showPopupInsideScreenBounds);
 },
 GetPopupAbsoluteY: function(element, popupElement, vAlign, vOffset, y, top, isPopupFullCorrectionOn, ignoreAlignWithoutScrollReserve, ignorePopupElementBorders, showPopupInsideScreenBounds) {
  return PopupUtils.getPopupAbsolutePos(element, popupElement, vAlign, vOffset, y, top, false, isPopupFullCorrectionOn, ignoreAlignWithoutScrollReserve, ignorePopupElementBorders, false, showPopupInsideScreenBounds);
 },
 getPopupAbsolutePos: function(element, popupElement, align, offset, startPos, startPosInit, rtl, isPopupFullCorrectionOn, ignoreAlignWithoutScrollReserve, ignorePopupElementBorders, isHorizontal, showPopupInsideScreenBounds) {
  var calculator = getPositionCalculator();
  calculator.applyParams(element, popupElement, align, offset, startPos, startPosInit, rtl, isPopupFullCorrectionOn, ignoreAlignWithoutScrollReserve, ignorePopupElementBorders, isHorizontal, showPopupInsideScreenBounds);
  var position = calculator.getPopupAbsolutePos();
  calculator.disposeState();
  return position;
 },
 InitAnimationProperties: function(element, onAnimStopCallString) {
  element.popuping = true;
  element.onAnimStopCallString = onAnimStopCallString;
 },
 InitAnimationDiv: function (element, x, y, onAnimStopCallString, skipSizeInit) {
  PopupUtils.InitAnimationProperties(element, onAnimStopCallString);
  PopupUtils.InitAnimationDivCore(element);
  if(!skipSizeInit) {
   ASPx.SetStyles(element, { width: "", height: "" });
   ASPx.SetStyles(element, { width: element.offsetWidth, height: element.offsetHeight });
  }
  ASPx.SetStyles(element, { left: x, top: y });
 },
 InitAnimationDivCore: function (element) {
  ASPx.SetStyles(element, {
   overflow: "hidden",
   position: "absolute"
  });
 },
 StartSlideAnimation: function (animationDivElement, element, iframeElement, duration, preventChangingWidth, preventChangingHeight) {
  if(iframeElement) {
   var endLeft = ASPx.PxToInt(iframeElement.style.left);
   var endTop = ASPx.PxToInt(iframeElement.style.top);
   var startLeft = ASPx.PxToInt(element.style.left) < 0 ? endLeft : animationDivElement.offsetLeft + animationDivElement.offsetWidth;
   var startTop = ASPx.PxToInt(element.style.top) < 0 ? endTop : animationDivElement.offsetTop + animationDivElement.offsetHeight;
   var properties = {
    left: { from: startLeft, to: endLeft, unit: "px" },
    top: { from: startTop, to: endTop, unit: "px" }
   };
   if(!preventChangingWidth)
    properties.width = { to: element.offsetWidth, unit: "px" };
   if(!preventChangingHeight)
    properties.height = { to: element.offsetHeight, unit: "px" };
   ASPx.AnimationHelper.createMultipleAnimationTransition(iframeElement, {
    duration: duration
   }).Start(properties);
  }
  ASPx.AnimationHelper.createMultipleAnimationTransition(element, {
   duration: duration,
   onComplete: function () { PopupUtils.AnimationFinished(animationDivElement, element); }
  }).Start({
   left: { to: 0, unit: "px" },
   top: { to: 0, unit: "px" }
  });
 },
 AnimationFinished: function (animationDivElement, element) {
  if(PopupUtils.StopAnimation(animationDivElement, element) && ASPx.IsExists(animationDivElement.onAnimStopCallString) &&
   animationDivElement.onAnimStopCallString !== "") {
   window.setTimeout(animationDivElement.onAnimStopCallString, 0);
  }
 },
 StopAnimation: function (animationDivElement, element) {
  if(animationDivElement.popuping) {
   ASPx.AnimationHelper.cancelAnimation(element);
   animationDivElement.popuping = false;
   animationDivElement.style.overflow = "visible";
   return true;
  }
  return false;
 },
 GetAnimationHorizontalDirection: function (popupPosition, horizontalAlign, verticalAlign, rtl) {
  if(PopupUtils.IsInnerAlign(horizontalAlign)
   && !PopupUtils.IsInnerAlign(verticalAlign)
   && !PopupUtils.IsAlignNotSet(verticalAlign))
   return 0;
  var toTheLeft = (horizontalAlign == PopupUtils.OutsideLeftAlignIndicator || horizontalAlign == PopupUtils.RightSidesAlignIndicator || (horizontalAlign == PopupUtils.NotSetAlignIndicator && rtl)) ^ popupPosition.isInverted;
  return toTheLeft ? 1 : -1;
 },
 GetAnimationVerticalDirection: function (popupPosition, horizontalAlign, verticalAlign) {
  if(PopupUtils.IsInnerAlign(verticalAlign)
   && !PopupUtils.IsInnerAlign(horizontalAlign)
   && !PopupUtils.IsAlignNotSet(horizontalAlign))
   return 0;
  var toTheTop = (verticalAlign == PopupUtils.AboveAlignIndicator || verticalAlign == PopupUtils.BottomSidesAlignIndicator) ^ popupPosition.isInverted;
  return toTheTop ? 1 : -1;
 },
 IsVerticalScrollExists: function () {
  var scrollIsNotHidden = ASPx.GetCurrentStyle(document.body).overflowY !== "hidden" && ASPx.GetCurrentStyle(document.documentElement).overflowY !== "hidden";
  return (scrollIsNotHidden && ASPx.GetDocumentHeight() > ASPx.GetDocumentClientHeight());
 },
 CoordinatesInDocumentRect: function (x, y) {
  var docScrollLeft = ASPx.GetDocumentScrollLeft();
  var docScrollTop = ASPx.GetDocumentScrollTop();
  return (x > docScrollLeft && y > docScrollTop &&
   x < ASPx.GetDocumentClientWidth() + docScrollLeft &&
   y < ASPx.GetDocumentClientHeight() + docScrollTop);
 },
 GetElementZIndexArray: function (element) {
  var currentElement = element;
  var zIndexesArray = [0];
  while(currentElement && currentElement.tagName != "BODY") {
   if(currentElement.style) {
    if(typeof (currentElement.style.zIndex) != "undefined" && currentElement.style.zIndex != "")
     zIndexesArray.unshift(currentElement.style.zIndex);
   }
   currentElement = currentElement.parentNode;
  }
  return zIndexesArray;
 },
 IsHigher: function (higherZIndexArrat, zIndexArray) {
  if(zIndexArray == null) return true;
  var count = (higherZIndexArrat.length >= zIndexArray.length) ? higherZIndexArrat.length : zIndexArray.length;
  for(var i = 0; i < count; i++)
   if(typeof (higherZIndexArrat[i]) != "undefined" && typeof (zIndexArray[i]) != "undefined") {
    var higherZIndexArrayCurrentElement = parseInt(higherZIndexArrat[i].toString());
    var zIndexArrayCurrentElement = parseInt(zIndexArray[i].toString());
    if(higherZIndexArrayCurrentElement != zIndexArrayCurrentElement)
     return higherZIndexArrayCurrentElement > zIndexArrayCurrentElement;
   } else return typeof (zIndexArray[i]) == "undefined";
  return true;
 },
 TestIsPopupElement: function (element) {
  return !!element.DXPopupElementControl;
 },
 adjustViewportScrollWrapper: function(wrapper, wrapperScroll, windowElement) {
  var document = wrapper.ownerDocument;
  var window = document.defaultView || document.parentWindow;
  var isWindowElementDisplayed = ASPx.IsElementDisplayed(windowElement);
  if(!isWindowElementDisplayed) {
   wrapper.style.cssText = "";
   wrapperScroll.style.cssText = "";
   return; 
  }
  var windowRect = windowElement.getBoundingClientRect();
  var yAxis = this.calculateViewPortScrollDataByAxis(wrapper.style.top, windowRect.top, windowElement.offsetHeight, window.innerHeight, wrapper.scrollTop);
  var xAxis = this.calculateViewPortScrollDataByAxis(wrapper.style.left, windowRect.left, windowElement.offsetWidth, window.innerWidth, wrapper.scrollLeft);
  this.prepareViewPortScrollData(xAxis, yAxis);
  ASPx.SetStyles(windowElement, {
   top: yAxis.windowOffset,
   left: xAxis.windowOffset
  });
  ASPx.SetStyles(wrapper, {
   width: xAxis.wrapperSize,
   height: yAxis.wrapperSize,
   position: "absolute",
   overflow: ASPx.Browser.MobileUI ? "scroll" : "auto",
   zIndex: windowElement.style.zIndex
  });
  ASPx.SetAbsoluteX(wrapper, ASPx.GetDocumentScrollLeft());
  ASPx.SetAbsoluteY(wrapper, ASPx.GetDocumentScrollTop());
  ASPx.SetStyles(wrapperScroll, {
   width: xAxis.wrapperScrollSize,
   height: yAxis.wrapperScrollSize,
   position: "absolute",
   overflow: "hidden"
  });
  wrapper.scrollLeft = xAxis.scrollSize;
  wrapper.scrollTop = yAxis.scrollSize;
 },
 calculateViewPortScrollDataByAxis: function(wrapperOffsetStyle, windowOffset, windowSize, viewPortSize, scrollSize) {
  var isWindowOffsetNegative = windowOffset < 0;
  windowOffset = isWindowOffsetNegative ? 0 : windowOffset;
  var wrapperScrollSize = Math.max(viewPortSize + Math.abs(Math.min(0, windowOffset)), windowSize + Math.abs(windowOffset));
  return { 
   windowOffset: isWindowOffsetNegative ? 0 : windowOffset,
   wrapperSize: viewPortSize,
   wrapperScrollSize: wrapperScrollSize,
   scrollSize: isWindowOffsetNegative ? scrollSize + Math.abs(windowOffset) : 0,
   hasScroll: wrapperScrollSize > viewPortSize
  };
 },
 prepareViewPortScrollData: function(xAxis, yAxis) {
  var scrollBarSize = ASPx.GetVerticalScrollBarWidth();
  if(yAxis.hasScroll && !xAxis.hasScroll) {
   xAxis.wrapperScrollSize = Math.min(xAxis.wrapperSize - scrollBarSize, xAxis.wrapperScrollSize);
  } else if(xAxis.hasScroll && !yAxis.hasScroll) {
   yAxis.wrapperScrollSize = Math.min(yAxis.wrapperSize - scrollBarSize, yAxis.wrapperScrollSize);
  } else if(yAxis.hasScroll && xAxis.hasScroll) {
   yAxis.wrapperScrollSize -= scrollBarSize;
   xAxis.wrapperScrollSize -= scrollBarSize;
  }
 }
};
PopupUtils.OverControl = {
 GetPopupElementByEvt: function (evt) {
  return PopupUtils.FindEventSourceParentByTestFunc(evt, PopupUtils.TestIsPopupElement);
 },
 OnMouseEvent: function (evt, mouseOver) {
  var popupElement = PopupUtils.OverControl.GetPopupElementByEvt(evt);
  if(mouseOver)
   popupElement.DXPopupElementControl.OnPopupElementMouseOver(evt, popupElement);
  else
   popupElement.DXPopupElementControl.OnPopupElementMouseOut(evt, popupElement);
 },
 OnMouseOut: function (evt) {
  PopupUtils.OverControl.OnMouseEvent(evt, false);
 },
 OnMouseOver: function (evt) {
  PopupUtils.OverControl.OnMouseEvent(evt, true);
 }
};
PopupUtils.BodyScrollHelper = (function () {
 var windowScrollLock = {},
  windowScroll = {},
  hideScrollbarsClassName = "dxpc-hideScrollbars",
  savedHtmlOverflow = "";
 function lockWindowScroll(windowId) {
  windowScrollLock[windowId] = true;
 }
 function unlockWindowScroll(windowId) {
  delete windowScrollLock[windowId];
 }
 function isLocked(windowId) {
  return !!windowScrollLock[windowId];
 }
 function isAnyWindowScrollLocked() {
  for(var key in windowScrollLock) 
   if (windowScrollLock.hasOwnProperty(key) && windowScrollLock[key] === true)
    return true;
  return false;
 }
 function replaceVerticalScrollByPadding() {
  var currentBodyStyle = ASPx.GetCurrentStyle(document.body),
   paddingWidth = ASPx.GetVerticalScrollBarWidth() + ASPx.PxToInt(currentBodyStyle.paddingRight);
  ASPx.Attr.ChangeStyleAttribute(document.body, "padding-right", paddingWidth + "px");
 }
 function needToChangeOverflowUsingStyle() {
  return ASPx.Browser.IE && ASPx.Browser.Version >= 11;
 }
 function changeOverflow() {
  if(needToChangeOverflowUsingStyle()) { 
   savedHtmlOverflow = document.documentElement.style.overflow;
   document.documentElement.style.overflow = "hidden";
  }
  else
   ASPx.Attr.ChangeStyleAttribute(document.documentElement, "overflow", "hidden");
  if(ASPx.GetCurrentStyle(document.body).overflowY === "scroll")
   ASPx.Attr.ChangeStyleAttribute(document.body, "overflow", "hidden");
  resetOverflowCache();
 }
 function restoreOverflow() {
  if(needToChangeOverflowUsingStyle()) { 
   document.documentElement.style.overflow = savedHtmlOverflow;
   savedHtmlOverflow = "";
  }
  else
   ASPx.Attr.RestoreStyleAttribute(document.documentElement, "overflow");
  ASPx.Attr.RestoreStyleAttribute(document.body, "overflow");
  resetOverflowCache();
 }
 function resetOverflowCache() {
  ASPx.verticalScrollIsNotHidden = null;
  ASPx.horizontalScrollIsNotHidden = null;
 }
 function saveScrollPosition(windowId) {
  windowScroll[windowId] = {
   x: window.pageXOffset,
   y: window.pageYOffset
  };
 }
 function restoreScrollPosition(windowId) {
  var currentWindowScroll = windowScroll[windowId];
  if(!!currentWindowScroll)
   window.scrollTo(currentWindowScroll.x, currentWindowScroll.y);
 }
 function restoreBodyScroll(windowId) {
  unlockWindowScroll(windowId);
  if(isAnyWindowScrollLocked())
   return;
  if(ASPx.Browser.IE) {
   ASPx.Attr.RestoreAttribute(document.body, "scroll");
   restoreOverflow();
   restoreScrollPosition(windowId);
  } else if(ASPx.Browser.WebKitTouchUI) {
   ASPx.Attr.RestoreStyleAttribute(document.body, "position");
   ASPx.Attr.RestoreStyleAttribute(document.body, "height");
   ASPx.Attr.RestoreStyleAttribute(document.body, "margin");
   ASPx.RemoveClassNameFromElement(document.documentElement, hideScrollbarsClassName);
   ASPx.Attr.RestoreStyleAttribute(document.body, "overflow");
   restoreScrollPosition(windowId);
  } else {
   restoreOverflow();
   restoreScrollPosition(windowId);
  }
  if(ASPx.Browser.Chrome)
   var dummy = document.documentElement.scrollTop; 
  ASPx.Attr.RestoreStyleAttribute(document.body, "padding-right");
  ASPx.Attr.RestoreStyleAttribute(document.body, "height");
  ASPx.Attr.RestoreStyleAttribute(document.body, "width");
 }
 return {
  RestoreIfLocked: function(windowId) {
   if(isLocked(windowId))
    restoreBodyScroll(windowId);
  },
  HideBodyScroll: function(windowId) {
   if(isAnyWindowScrollLocked()) { 
    lockWindowScroll(windowId);
    return;
   }
   lockWindowScroll(windowId);
   if(PopupUtils.IsVerticalScrollExists())
    replaceVerticalScrollByPadding();
   if(ASPx.Browser.IE) {
    saveScrollPosition(windowId);
    ASPx.Attr.ChangeAttribute(document.body, "scroll", "no");
    changeOverflow();
   } else if(ASPx.Browser.WebKitTouchUI) {
    saveScrollPosition(windowId);
    ASPx.Attr.ChangeStyleAttribute(document.body, "overflow", "hidden");
    ASPx.Attr.ChangeStyleAttribute(document.body, "position", "relative");
    ASPx.Attr.ChangeStyleAttribute(document.body, "height", "100%");
    ASPx.Attr.ChangeStyleAttribute(document.body, "margin", "0");
    ASPx.AddClassNameToElement(document.documentElement, hideScrollbarsClassName);
   } else {
    saveScrollPosition(windowId);
    changeOverflow();
    var documentHeight = ASPx.GetDocumentHeight();
    var documentWidth = ASPx.GetDocumentWidth();
    if(window.pageYOffset > 0 && ASPx.PxToInt(window.getComputedStyle(document.body, null)) != documentHeight)
     ASPx.Attr.ChangeStyleAttribute(document.body, "height", documentHeight + "px");
    if(window.pageXOffset > 0 && ASPx.PxToInt(window.getComputedStyle(document.body, null)) != documentWidth)
     ASPx.Attr.ChangeStyleAttribute(document.body, "width", documentWidth + "px");
   }
  },
  RestoreBodyScroll: restoreBodyScroll
 };
})();
var PositionAlignConsts = {
 NOT_SET: 0,
 OUTSIDE_START: 1,
 NEAR_BOUND_START: 2,
 INNER_START: 3,
 CENTER: 4,
 INNER_END: 5,
 NEAR_BOUND_END: 6,
 OUTSIDE_END: 7,
 WINDOW_CENTER: 8,
 WINDOW_START: 9,
 WINDOW_END: 10
};
var AlignIndicatorTable = {};
var PositionCalculator = ASPx.CreateClass(null, {
 constructor: function() {
  this.element = null;
  this.popupElement = null;
  this.align = 0;
  this.offset = 0;
  this.startPos = 0;
  this.startPosInit = 0;
  this.rtl = false;
  this.isPopupFullCorrectionOn = false;
  this.isHorizontal = true;
  this.size = 0;
  this.bodySize = 0;
  this.actualBodySize = 0;
  this.elementStartPos = 0;
  this.scrollStartPos = 0;
  this.isInverted = false;
  this.popupElementSize = 0;
  this.boundStartPos = 0;
  this.boundEndPos = 0;
  this.innerBoundStartPos = 0;
  this.innerBoundEndPos = 0;
  this.isMoreFreeSpaceLeft = false;
  this.nearBoundOverlapRate = 0.25;
  this.functionsTable = {};
  this.initializeFunctionsTable();
 },
 applyParams: function(element, popupElement, align, offset, startPos, startPosInit, rtl, isPopupFullCorrectionOn, ignoreAlignWithoutScrollReserve, ignorePopupElementBorders, isHorizontal, showPopupInsideScreenBounds) {
  this.isHorizontal = isHorizontal;
  this.element = element;
  this.popupElement = popupElement;
  this.align = this.getAlignValueFromIndicator(align);
  this.offset = offset;
  this.startPos = startPos;
  this.startPosInit = startPosInit;
  this.rtl = rtl;
  this.isPopupFullCorrectionOn = isPopupFullCorrectionOn;
  this.ignoreAlignWithoutScrollReserve = ignoreAlignWithoutScrollReserve;
  this.ignorePopupElementBorders = ignorePopupElementBorders;
  this.showPopupInsideScreenBounds = showPopupInsideScreenBounds;
  this.calculateParams();
 },
 disposeState: function() {
  this.element = null;
  this.popupElement = null;
 },
 getPopupAbsolutePos: function() {
  if(this.isWindowAlign()) {
   var showAtPos = this.startPos != ASPx.InvalidPosition && !this.popupElement;
   if(showAtPos)
    this.align = PositionAlignConsts.NOT_SET;
   else
    return this.getWindowAlignPos();
  }
  if(this.popupElement)
   this.calculatePopupElement();
  else
   this.align = PositionAlignConsts.NOT_SET;
  return this.getPopupAbsolutePosCore();
 },
 initializeFunctionsTable: function() {
  var table = this.functionsTable;
  table[PositionAlignConsts.NOT_SET] = this.calculateNotSet;
  table[PositionAlignConsts.OUTSIDE_START] = this.calculateOutsideStart;
  table[PositionAlignConsts.INNER_START] = this.calculateInnerStart;
  table[PositionAlignConsts.CENTER] = this.calculateCenter;
  table[PositionAlignConsts.INNER_END] = this.calculateInnerEnd;
  table[PositionAlignConsts.OUTSIDE_END] = this.calculateOutsideEnd;
  table[PositionAlignConsts.NEAR_BOUND_START] = this.calculateNearBoundStart;
  table[PositionAlignConsts.NEAR_BOUND_END] = this.calculateNearBoundEnd;
  table[PositionAlignConsts.WINDOW_CENTER] = this.calculateWindowCenter;
  table[PositionAlignConsts.WINDOW_START] = this.calculateWindowStart;
  table[PositionAlignConsts.WINDOW_END] = this.calculateWindowEnd;
 },
 calculateParams: function() {
  this.size = this.getElementSize();
  if(this.isHorizontal) {
   this.bodySize = ASPx.GetDocumentClientWidth();
   this.elementStartPos = ASPx.GetAbsoluteX(this.popupElement) + this.getBorderCorrection();
   this.scrollStartPos = ASPx.GetDocumentScrollLeft();
  }
  else {
   this.bodySize = ASPx.GetDocumentClientHeight();
   this.elementStartPos = ASPx.GetAbsoluteY(this.popupElement) + this.getBorderCorrection();
   this.scrollStartPos = ASPx.GetDocumentScrollTop();
  }
 },
 getBorderCorrection: function() {
  if(!this.ignorePopupElementBorders)
   return 0;
  var style = getComputedStyle(this.popupElement);
  return ASPx.PxToInt(this.isHorizontal ? style.borderLeftWidth : style.borderTopWidth);
 },
 isWindowAlign: function() {
  return this.align == PositionAlignConsts.WINDOW_CENTER || this.align == PositionAlignConsts.WINDOW_START ||
   this.align == PositionAlignConsts.WINDOW_END;
 },
 getWindowAlignPos: function() {
  this.actualBodySize = ASPx.Browser.WebKitTouchUI ? this.getWindowInnerSize() : this.bodySize;
  return this.getPopupAbsolutePosCore();
 },
 getPopupAbsolutePosCore: function() {
  var calculationFunc = this.functionsTable[this.align];
  calculationFunc.call(this);
  return new ASPx.PopupPosition(this.startPos, this.isInverted);
 },
 calculateWindowCenter: function() {
  this.startPos = Math.max(Math.ceil(this.actualBodySize / 2 - this.size / 2), 0) + this.scrollStartPos + this.offset;
 },
 calculateWindowStart: function() {
  this.startPos = this.scrollStartPos + this.offset;
 },
 calculateWindowEnd: function() {
  this.startPos = this.scrollStartPos + this.actualBodySize - this.size + this.offset;
 },
 calculatePopupElement: function() {
  this.popupElementSize = this.getPopupElementSize();
  this.boundStartPos = this.elementStartPos - this.size;
  this.boundEndPos = this.elementStartPos + this.popupElementSize;
  this.innerBoundStartPos = this.elementStartPos;
  this.innerBoundEndPos = this.elementStartPos + this.popupElementSize - this.size;
  var hasLeftScrollReserve = this.boundStartPos >= 0;
  this.isMoreFreeSpaceLeft = (this.bodySize - (this.boundEndPos + this.size) < this.boundStartPos - 2 * this.scrollStartPos) && (!this.ignoreAlignWithoutScrollReserve || hasLeftScrollReserve);
 },
 calculateOutsideStart: function() {
  this.isInverted = this.isPopupFullCorrectionOn && (!(this.boundStartPos - this.scrollStartPos > 0 || this.isMoreFreeSpaceLeft));
  if(this.isInverted)
   this.startPos = this.boundEndPos - this.offset;
  else
   this.startPos = this.boundStartPos + this.offset;
 },
 calculateInnerStart: function() {
  this.startPos = this.innerBoundStartPos + this.offset;
  if(this.isPopupFullCorrectionOn)
   this.startPos = PopupUtils.AdjustPositionToClientScreen(this.element, this.startPos, this.rtl, this.isHorizontal);
 },
 calculateCenter: function() {
  this.startPos = this.elementStartPos + Math.round((this.popupElementSize - this.size) / 2) + this.offset;
  if(this.showPopupInsideScreenBounds) {
   if(this.startPos < 0)
    this.startPos = 0;
   if(this.startPos + this.size > this.bodySize)
    this.startPos = this.bodySize - this.size;
  }
 },
 calculateInnerEnd: function() {
  this.startPos = this.innerBoundEndPos + this.offset;
  if(this.isPopupFullCorrectionOn)
   this.startPos = PopupUtils.AdjustPositionToClientScreen(this.element, this.startPos, this.rtl, this.isHorizontal);
 },
 calculateOutsideEnd: function() {
  this.isInverted = this.isPopupFullCorrectionOn && (!(this.boundEndPos + this.size < this.bodySize + this.scrollStartPos || !this.isMoreFreeSpaceLeft));
  if(this.isInverted)
   this.startPos = this.boundStartPos - this.offset;
  else
   this.startPos = this.boundEndPos + this.offset;
 },
 calculateNotSet: function() {
  if(this.rtl)
   this.calculateNotSetRightToLeft();
  else
   this.calculateNotSetLeftToRight();
 },
 calculateNotSetLeftToRight: function() {
  if(!ASPx.IsValidPosition(this.startPos)) {
   if(this.popupElement)
    this.startPos = this.elementStartPos;
   else if(this.offset)
    this.startPos = 0;
   else
    this.startPos = this.startPosInit;
  }
  this.isInverted = this.isPopupFullCorrectionOn && (this.startPos - this.scrollStartPos + this.size > this.bodySize && this.startPos - this.scrollStartPos > this.bodySize / 2);
  if(this.isInverted)
   this.startPos = this.startPos - this.size - this.offset;
  else
   this.startPos = this.startPos + this.offset;
 },
 calculateNotSetRightToLeft: function() {
  if(!ASPx.IsValidPosition(this.startPos)) {
   if(this.popupElement)
    this.startPos = this.innerBoundEndPos;
   else if(this.offset)
    this.startPos = 0;
   else
    this.startPos = this.startPosInit;
  }
  else
   this.startPos -= this.size;
  this.isInverted = this.isPopupFullCorrectionOn && (this.startPos < this.scrollStartPos && this.startPos - this.scrollStartPos < this.bodySize / 2);
  if(this.isInverted)
   this.startPos = this.startPos + this.size + this.offset;
  else
   this.startPos = this.startPos - this.offset;
 },
 calculateNearBoundStart: function() {
  this.startPos = this.boundStartPos + this.offset + this.size * this.nearBoundOverlapRate;
  if(this.isPopupFullCorrectionOn)
   this.startPos = PopupUtils.AdjustPositionToClientScreen(this.element, this.startPos, this.rtl, this.isHorizontal);
 },
 calculateNearBoundEnd: function() {
  this.startPos = this.boundEndPos + this.offset - this.size * this.nearBoundOverlapRate;
  if(this.isPopupFullCorrectionOn)
   this.startPos = PopupUtils.AdjustPositionToClientScreen(this.element, this.startPos, this.rtl, this.isHorizontal);
 },
 getAlignValueFromIndicator: function(alignIndicator) {
  var alignValue = AlignIndicatorTable[alignIndicator];
  if(alignValue === undefined)
   throw "Incorrect align indicator.";
  return alignValue;
 },
 getElementSize: function() {
  return this.getCustomElementSize(this.element, false);
 },
 getPopupElementSize: function() {
  return this.getCustomElementSize(this.popupElement, this.ignorePopupElementBorders);
 },
 getCustomElementSize: function(customElement, ignoreBorders) {
  if(ignoreBorders) {
   return this.isHorizontal ? ASPx.GetClearClientWidth(customElement) : ASPx.GetClearClientHeight(customElement);
  }
  return this.isHorizontal ? ASPx.GetElementOffsetWidth(customElement) : ASPx.GetElementOffsetHeight(customElement);
 },
 getWindowInnerSize: function() {
  return this.isHorizontal ? window.innerWidth : window.innerHeight;
 }
});
var positionCalculator = null;
function getPositionCalculator() {
 if(positionCalculator == null)
  positionCalculator = new PositionCalculator();
 return positionCalculator;
}
function initializeAlignIndicatorTable() {
 AlignIndicatorTable[PopupUtils.NotSetAlignIndicator] = PositionAlignConsts.NOT_SET;
 AlignIndicatorTable[PopupUtils.OutsideLeftAlignIndicator] = PositionAlignConsts.OUTSIDE_START;
 AlignIndicatorTable[PopupUtils.AboveAlignIndicator] = PositionAlignConsts.OUTSIDE_START;
 AlignIndicatorTable[PopupUtils.LeftAlignIndicator] = PositionAlignConsts.NEAR_BOUND_START;
 AlignIndicatorTable[PopupUtils.TopAlignIndicator] = PositionAlignConsts.NEAR_BOUND_START;
 AlignIndicatorTable[PopupUtils.LeftSidesAlignIndicator] = PositionAlignConsts.INNER_START;
 AlignIndicatorTable[PopupUtils.TopSidesAlignIndicator] = PositionAlignConsts.INNER_START;
 AlignIndicatorTable[PopupUtils.CenterAlignIndicator] = PositionAlignConsts.CENTER;
 AlignIndicatorTable[PopupUtils.MiddleAlignIndicator] = PositionAlignConsts.CENTER;
 AlignIndicatorTable[PopupUtils.RightSidesAlignIndicator] = PositionAlignConsts.INNER_END;
 AlignIndicatorTable[PopupUtils.BottomSidesAlignIndicator] = PositionAlignConsts.INNER_END;
 AlignIndicatorTable[PopupUtils.RightAlignIndicator] = PositionAlignConsts.NEAR_BOUND_END;
 AlignIndicatorTable[PopupUtils.BottomAlignIndicator] = PositionAlignConsts.NEAR_BOUND_END;
 AlignIndicatorTable[PopupUtils.OutsideRightAlignIndicator] = PositionAlignConsts.OUTSIDE_END;
 AlignIndicatorTable[PopupUtils.BelowAlignIndicator] = PositionAlignConsts.OUTSIDE_END;
 AlignIndicatorTable[PopupUtils.WindowCenterAlignIndicator] = PositionAlignConsts.WINDOW_CENTER;
 AlignIndicatorTable[PopupUtils.WindowLeftAlignIndicator] = PositionAlignConsts.WINDOW_START;
 AlignIndicatorTable[PopupUtils.WindowTopAlignIndicator] = PositionAlignConsts.WINDOW_START;
 AlignIndicatorTable[PopupUtils.WindowRightAlignIndicator] = PositionAlignConsts.WINDOW_END;
 AlignIndicatorTable[PopupUtils.WindowBottomAlignIndicator] = PositionAlignConsts.WINDOW_END;
}
initializeAlignIndicatorTable();
ASPx.PopupPosition = function(position, isInverted) {
 this.position = position;
 this.isInverted = isInverted;
};
ASPx.PopupSize = function(width, height) {
 this.width = width;
 this.height = height;
};
ASPx.PopupUtils = PopupUtils;
ASPx.PositionCalculator = PositionCalculator;
})();
(function() {
var serializingSeparator = "|";
var serializingSeparatorLength = serializingSeparator.length;
var lbIPostfixes = ['C', 'I', 'T'];
var lbIIdSuffix = "LBI";
var lbSIIdSuffix = lbIIdSuffix + "-1";
var lbAIRIdSuffix = "AIR";
var lbAIRTIdSuffix = lbAIRIdSuffix + "-1";
var lbTSIdSuffix = "_TS";
var lbBSIdSuffix = "_BS";
var lbHeaderDivIdSuffix = "_H";
var lTableIdSuffix = "_LBT";
var leVISuffix = "_VI";
var lbDSuffix = "_D";
var emptyItemsRange = "0:-1";
var nbsp = "&nbsp;";
var nameSeparator = "_";
var nbspChar = String.fromCharCode(160);
var NullSizeCellClassName = "dxlbNullSizeCell";
var itemCellTextAttributeName = "data-item-cell-text";
var itemSerializedTextsAttributeName = "data-item-serialized-texts";
var FIRST_CELL_MARKER_CSS_CLASS_NAME = "dxeFTM";
var LAST_CELL_MARKER_CSS_CLASS_NAME = "dxeLTM";
var selectAllMainElementID = "LBSAME";
var selectAllCheckBoxID = "LBSACB";
var filterMainElementID = "LBF";
var filteringTextBoxID = "LBFE";
var showFilterButtonID = "LBSFEB";
var inactiveFilterElementClassName = "dxeLBInactiveFilterPanelSys";
var listTableCollapsedClassName = "dxeLBTCollapsed";
var ListBoxSelectionMode = { Single : 0, Multiple : 1, CheckColumn : 2 };
var ListBoxVirtualScrollTableContainerIDPostfix = "LBVSTC";
var CONSTANTS = {
 CALLBACK_PREFIXES: {
  CUSTOM: "LECC",
  CUSTOMPERFORM: "LECCP",
  LOAD_RANGE_ITEMS: "LBCRI",
  FILTERING: "CBLF",
  FILTERING_CORRECT: "CBCF"
 },
 CALLBACK_RESULTS: {
  ITEMS: "i",
  FILTER_CUSTOMHIGHLIGHTING: "fCH",
  FILTER_LENGTH: "fL"
 }
};
var ListBoxItemsManagerBase = ASPx.CreateClass(null, {
 constructor: function(listBox) {
  this.listBox = listBox;
  this.listTable = listBox.GetListTable();
 },
 Initialize: function() {
  this.AddStateItems(false, false);  
 },
 HasSampleItemStateItems: function() {
  return this.listBox.hasSampleItem;
 },
 AddStateItems: function(clearCache, hoverItemOnly) {
  if (typeof (ASPx.GetStateController) !== "undefined") {
   var itemCellsIdSuffixes = this.listBox.GetItemCellsIdPostfixes();
   this.AddStateItemsCore(ASPx.GetStateController(), clearCache, itemCellsIdSuffixes, hoverItemOnly);
  }
 },
 AddStateItemsCore: function (controller, clearCache, itemCellsIdSuffixes, hoverItemOnly) {
  if(this.HasSampleItemStateItems())
   this.AddItemStateItems(controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, -1);
 },
 AddItemStateItems: function (controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, index) {
  var name = this.listBox.name + "_" + lbIIdSuffix + index;
  if (clearCache)
   this.listBox.ClearStateItemCache(controller, name, itemCellsIdSuffixes);
  if (!ASPx.Browser.WebKitTouchUI)
   controller.AddHoverItem(name, this.listBox.hoverClasses, this.listBox.hoverCssArray, itemCellsIdSuffixes, null, null, true);
  if (!hoverItemOnly) {
   controller.AddSelectedItem(name, this.listBox.selectedClasses, this.listBox.selectedCssArray, itemCellsIdSuffixes, null, null, true);
   controller.AddDisabledItem(name, this.listBox.disabledClasses, this.listBox.disabledCssArray, itemCellsIdSuffixes, null, null, true);
  }
 },
 RemoveHoverStateItem: function() {
  if (typeof (ASPx.GetStateController) !== "undefined") {
   var itemCellsIdSuffixes = this.listBox.GetItemCellsIdPostfixes();
   this.RemoveHoverStateItemCore(ASPx.GetStateController(), itemCellsIdSuffixes);
  }
 },
 RemoveHoverStateItemCore: function(controller, itemCellsIdSuffixes) {
  if(this.HasSampleItemStateItems())
   this.RemoveItemStateHoverItem(controller, itemCellsIdSuffixes, -1);
 },
 RemoveItemStateHoverItem: function(controller, itemCellsIdSuffixes, index) {
  var name = this.listBox.name + "_" + lbIIdSuffix + index;
  this.listBox.ClearStateItemCache(controller, name, itemCellsIdSuffixes);
  if (!ASPx.Browser.WebKitTouchUI)
   controller.RemoveHoverItem(name, itemCellsIdSuffixes);
 },
 GetListTableRows: function() {
  return this.listTable ? this.listTable.rows : [];
 },
 GetItemHtmlContent: function(index) { return null; },
 GetItem: function () { return null; },
 GetItemIndexByRow: function (itemRow) { return null; },
 GetItemCount: function () { return 0; },
 GetItemRow: function (index) {
  if (this.listTable && index >= 0) {
   var rowIndex = this.ConvertItemIndexToRowIndex(index);
   var itemRow = this.listTable.rows[rowIndex];
   if (itemRow && ASPx.ElementContainsCssClass(itemRow, "dxeListBoxItemRow"))
    return itemRow;
  }
  return null;
 },
 GetItemElement: function (index) {
  var result = null;
  var itemRow = this.GetItemRow(index);
  if (itemRow)
   result = this.GetFirstVisibleCell(itemRow) || itemRow.cells[0];
  return result;
 },
 GetFirstVisibleCell: function (itemRow) {
  for (var i = 0; i < itemRow.cells.length; i++)
   if (ASPx.GetElementDisplay(itemRow.cells[i]))
    return itemRow.cells[i];
  return null;
 },
 GetItemHeight: function (index) {
  var itemElement = this.GetItemElement(index);
  return itemElement != null ? itemElement.getBoundingClientRect().height : this.GetDefaultItemHeight();
 },
 GetDefaultItemHeight: function () { return 0; },
 ResetItemHeightIfRequired: function () { return false; },
 GetItemsHeight: function() { return 0; },
 GetItemsWidth: function() { return 0; },
 GetVisibleItemCount: function () { return 0; },
 GetTopSpacersHeight: function() {
  return this.listBox.GetTopScrollSpacerHeight();
 },
 GetItemTopOffset: function(index) {
  return this.GetItemTopOffsetCore(index);
 },
 GetItemTopOffsetCore: function(index) {
  var itemElement = this.GetItemElement(index);
  return itemElement ? itemElement.offsetTop + this.GetTopSpacersHeight() : 0;
 },
 IsItemVisible: function(index) {
  return this.IsItemEdgeVisible(index, true, true);
 },
 IsItemEdgeVisible: function(index, checkTop, checkBottom) {
  var result = false;
  var itemElement = this.GetItemElement(index);
  if(itemElement != null) {
   var scrollDiv = this.listBox.GetScrollDivElement();
   var topScrollDivEdge = scrollDiv.scrollTop;
   var bottomScrollDivEdge = scrollDiv.scrollTop + scrollDiv.clientHeight;
   var topItemElementEdge = this.GetItemTopOffset(index);
   var bottomItemElementEdge = topItemElementEdge + itemElement.getBoundingClientRect().height;
   var checkTopVisibleResult = !checkTop || this.IsVisibleOffset(topItemElementEdge, topScrollDivEdge, bottomScrollDivEdge);
   var checkBottomVisibleResult = !checkBottom || this.IsVisibleOffset(bottomItemElementEdge, topScrollDivEdge, bottomScrollDivEdge);
   result = checkTopVisibleResult && checkBottomVisibleResult;
  }
  return result;
 },
 IsVisibleOffset: function(offset, topScrollDivEdge, bottomScrollDivEdge) {
  return offset >= topScrollDivEdge && offset <= bottomScrollDivEdge;
 },
 GetFirstVisibleItem: function () { return null; },
 GetFirstVisibleItemRow: function() {
  var firstVisibleItemIndex = this.GetFirstVisibleItem();
  return this.listTable.rows[this.ConvertItemIndexToRowIndex(firstVisibleItemIndex)];
 },
 GetFirstRenderedItem: function () { },
 GetLastRenderedItem: function () { },
 InitializeInternalCheckBoxCollection: function () { },
 GetScrollDivChildElementHeight: function () { return null; },
 RemoveItem: function(index) { this.RemoveItemCore(index); },
 RemoveItemCore: function(index) {
  this.listBox.RemoveItemRow(index);
 },
 InsertItem: function () { },
 CreateNewItemRow: function (index) {
  var newItemRow = this.listBox.GetSampleItemRow();
  if (ASPx.IsExistsElement(newItemRow))
   newItemRow = newItemRow.cloneNode(true);
  return newItemRow;
 },
 ClearItems: function () {
  this.ClearItemsCore();
 },
 ClearItemsCore: function() {
  var tBody = this.listBox.GetListTableRowParent();
  if(ASPx.Browser.IE)
   tBody.innerText = "";
  else
   tBody.innerHTML = "";
 },
 IsItemFiltered: function (index) { return false; },
 ConvertItemIndexToRowIndex: function () { return null; },
 Adjust: function () { },
 BeforeClientFiltering: function () { },
 ApplyFilterToItem: function (index, isSatisfy, savePrevState, isFilterReset) { },
 RestorePrevFilteredState: function (index) { },
 OnEndItemsFiltering: function () { },
 ChangeItemsFilteredState: function(action) {
  var count = this.GetItemCount();
  for (var i = 0; i < count; i++) {
   action(i);
   this.AfterChangeItemFilteredStateAction(i);
  }
 },
 AfterChangeItemFilteredStateAction: function() { },
 MakeAllItemsVisible: function () {
  this.ChangeItemsFilteredState(function (index) {
   this.ApplyFilterToItem(index, true, false, true);
  }.aspxBind(this));
 },
 RewriteFilteredItemIndices: function(newFilteredItemIndices) { },
 OnScrollSpacerVisibilityChanged: function () { },
 SetItemHtml: function (index, html) { },
 SetItemTooltip: function(index, tooltip) { },
 SetItemAttribute: function(index, attrName, attrValue) { },
 AddItemCssClass: function (index, className) { },
 RemoveItemCssClass: function (index, className) { },
 SetItemTextCellHtml: function (itemIndex, textCellIndex, html) { },
 SetItemTextCellTooltip: function(itemIndex, textCellIndex, tooltip) { },
 SetItemTextCellAttribute: function(itemIndex, textCellIndex, attrName, attrValue) { },
 AddItemTextCellCssClass: function (itemIndex, textCellIndex, className) { },
 RemoveItemTextCellCssClass: function (itemIndex, textCellIndex, className) { },
 OnDecoratedItemsRendering: function () { },
 DeactivateScrollHandler: function() { },
 ActivateScrollHandler: function() { },
 IsScrollActivated: function() { return true; },
 FixItemTruncatingIfRequired: function() { },
 BeginUpdate: function() { },
 EndUpdate: function() { }
});
var ListBoxItemsDefaultManager = ASPx.CreateClass(ListBoxItemsManagerBase, {
 constructor: function (listBox) {
  this.constructor.prototype.constructor.call(this, listBox);
 },
 AddStateItemsCore: function (controller, clearCache, itemCellsIdSuffixes, hoverItemOnly) {
  ListBoxItemsManagerBase.prototype.AddStateItemsCore.call(this, controller, clearCache, itemCellsIdSuffixes, hoverItemOnly);
  var count = this.GetItemCount();
  for (var i = 0; i < count; i++)
   this.AddItemStateItems(controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, i);
 },
 RemoveHoverStateItemCore: function(controller, itemCellsIdSuffixes) {
  ListBoxItemsManagerBase.prototype.RemoveHoverStateItemCore.call(this, controller, itemCellsIdSuffixes);
  var count = this.GetItemCount();
  for (var i = 0; i < count; i++)
   this.RemoveItemStateHoverItem(controller, itemCellsIdSuffixes, i);
 },
 GetItemIndexByRow: function (itemRow) {
  var result = itemRow.rowIndex;
  if (this.listBox.ContainsFixWidthRow())
   result--;
  return result;
 },
 GetItemCount: function () {
  if (this.listTable) {
   var rowLength = this.listTable.rows.length;
   if (!!this.listBox.GetAccessibilityHeaderRow())
    rowLength--;
   if (this.listBox.ContainsFixWidthRow())
    rowLength--;
   return rowLength;
  }
  return 0;
 },
 GetItem: function (index) {
  var rowLength = this.GetItemCount();
  if (!this.listTable || index < 0 || index >= rowLength)
   return null;
  var row = this.listBox.GetItemRow(index);
  var image = this.listBox.imageCellExists ? ASPx.GetNodeByTagName(row.cells[this.listBox.GetImageCellIndex()], "IMG", 0) : null;
  var src = image == null ? "" : ASPx.ImageUtils.GetImageSrc(image);
  var itemValue = this.listBox.itemsValue[index] !== undefined ? this.listBox.itemsValue[index] : null;
  return new ASPxClientListBoxItem(this.listBox, index, this.listBox.GetItemRowTexts(row), itemValue, src, this.listBox.GetIsItemSelected(index));
 },
 GetVisibleItemCount: function () {
  var count = this.GetItemCount();
  var visibleItemCount = 0;
  for (var i = 0; i < count; i++) {
   if (ASPx.GetElementDisplay(this.GetItemRow(i)))
    visibleItemCount++;
  }
  return visibleItemCount;
 },
 GetFirstVisibleItem: function () {
  var itemCount = this.GetItemCount();
  for (var i = 0; i < itemCount; i++)
   if (this.GetItemRow(i) && ASPx.GetElementDisplay(this.GetItemRow(i)))
    return i;
  return -1;
 },
 GetFirstFilteredItemIndex: function () {
  return this.GetFirstVisibleItem();
 },
 GetFirstRenderedItem: function () {
  return this.GetItemCount() > 0 ? this.GetItem(0) : null;
 },
 GetLastRenderedItem: function () {
  return this.GetItemCount() > 0 ? this.GetItem(this.GetItemCount() - 1) : null;
 },
 ConvertItemIndexToRowIndex: function (itemIndex) {
  return this.listBox.ContainsFixWidthRow() ? itemIndex + 1 : itemIndex;
 },
 GetScrollDivChildElementHeight: function () {
  return this.listBox.GetListTableHeight() + this.listBox.GetTopScrollSpacerHeight() + this.listBox.GetBottomScrollSpacerHeight();
 },
 IsItemFiltered: function (index) {
  return ASPx.GetElementDisplay(this.GetItemRow(index));
 },
 InsertItem: function (index, itemProperties) {
  this.listBox.InsertItemRow(index, itemProperties);
 },
 InitializeInternalCheckBoxCollection: function () {
  var count = this.GetItemCount();
  var enabled = this.listBox.GetEnabled();
  var changeEventMethod = ASPx.Attr.ChangeEventsMethod(enabled);
  for (var i = 0; i < count; i++)
   this.listBox.AddInternalCheckBoxToCollectionCore(i, enabled, changeEventMethod);
 },
 ApplyFilterToItem: function (index, isSatisfy, savePrevState, isFilterReset) {
  var itemRow = this.GetItemRow(index);
  if (savePrevState) {
   var newDisplayValue = isSatisfy ? "" : "none";
   ASPx.Attr.ChangeStyleAttribute(itemRow, "display", newDisplayValue);
  }
  else
   ASPx.SetElementDisplay(itemRow, isSatisfy);
 },
 RestorePrevFilteredState: function (index) {
  ASPx.Attr.RestoreStyleAttribute(this.GetItemRow(index), "display");
 },
 GetItemsHeight: function () {
  return this.listBox.GetListTableHeight();
 },
 GetItemsWidth: function() {
  return this.listTable.offsetWidth;
 },
 GetNewItemIndexInFilteredRange: function(selectedIndex, step) {
  var rows = Array.prototype.slice.call(this.listTable.rows);
  var filteredRows = rows.filter(function(row) { 
   return ASPx.GetElementDisplay(row);
  });
  var selectedRow = this.GetItemRow(selectedIndex);
  var itemIndexInFilteredRange = ASPx.Data.ArrayIndexOf(filteredRows, selectedRow);
  var newItemIndexInFilteredRange = itemIndexInFilteredRange + step;
  if(newItemIndexInFilteredRange >= filteredRows.length)
   newItemIndexInFilteredRange = filteredRows.length - 1;
  else if(newItemIndexInFilteredRange < 0)
   newItemIndexInFilteredRange = 0;
  var newSelectedRow = filteredRows[newItemIndexInFilteredRange];
  return this.GetItemIndexByRow(newSelectedRow);
 }
});
var ListBoxItemsVirtualManager = ASPx.CreateClass(ListBoxItemsManagerBase, {
 Initialize: function () {
  ListBoxItemsManagerBase.prototype.Initialize.call(this);
  this.virtualScrollTopInvisibleItemsCount = 1;
  this.virtualScrollBottomInvisibleItemsCount = 1;
  this.virtualScrollItemHeight = 0;
  this.virtualEmptyItemWidth = 0;
  this.showFilterButtonWidthCounted = false;
  this.isScrollProcessingActivated = true;
  this.InitializeItemRows();
  this.virtualScrollVisibleItemIndices = [];
 },
 GetItemIndexByRow: function (itemRow) {
  return itemRow.itemIndex;
 },
 GetItemCount: function () {
  return this.deserializedItems.length;
 },
 GetItem: function(index, preventEncodeText) {
  if (index < 0 || index >= this.GetItemCount())
   return null;
  var deserializedItem = this.deserializedItems[index];
  var itemTexts = this.AdjustItemTexts(deserializedItem, preventEncodeText);
  var result = new ASPxClientListBoxItem(this.listBox, index, itemTexts, deserializedItem.value,
   deserializedItem.imageUrl, this.listBox.GetIsItemSelected(index));
  result.insertOrderIndex = deserializedItem.insertOrderIndex;
  return result;
 },
 GetItemHtmlContent: function(index) {
  return this.deserializedItems[index] && this.deserializedItems[index].htmlContent;
 },
 AdjustItemTexts: function (item, preventEncodeText) {
  var itemInnerTexts = this.GetItemInnerTexts(item, preventEncodeText);
  if (this.listBox.IsMultiColumn()) {
   for (var i = itemInnerTexts.length; i < this.listBox.columnFieldNames.length; i++)
    itemInnerTexts.push("");
  }
  return itemInnerTexts;
 },
 GetItemInnerTexts: function(item, preventEncodeText) {
  if(!item.texts)
   return item.texts;
  var adjustedItemTexts = [];
  for(var i = 0; i < item.texts.length; i++) {
   var itemText = item.texts[i] || "";
   if(!this.listBox.encodeHtml && !preventEncodeText)
    itemText = this.GetEncodedItemInnerText(itemText);
   adjustedItemTexts[i] = itemText;
  }
  return adjustedItemTexts;
 },
 GetEncodedItemInnerText: function(itemText) {
  var result = itemText;
  var encodedItemText = ASPx.Str.EncodeHtml(itemText);
  if(itemText !== encodedItemText) {
   var div = document.createElement("DIV");
   ASPx.SetInnerHtml(div, itemText);
   result = ASPx.GetInnerText(div);
  }
  return result;
 },
 GetVisibleItemCount: function () {
  return this.filteredItemIndices.length;
 },
 GetItemsHeight: function () {
  this.EnsureVirtualScrollItemHeight();
  return this.filteredItemIndices.length * this.virtualScrollItemHeight;
 },
 GetItemsWidth: function() {
  var listTableOffsetWidth = this.listTable.offsetWidth;
  var showFilterButton = this.listBox.GetShowFilterButton();
  if(showFilterButton && !this.showFilterButtonWidthCounted) {
   listTableOffsetWidth += showFilterButton.GetMainElement().offsetWidth;
   this.showFilterButtonWidthCounted = true;
  } 
  var itemsWidth = this.UseVirtualItemWidth() ?
   Math.max(this.visibleItemTextMaxWidth + this.virtualEmptyItemWidth, listTableOffsetWidth)
   : listTableOffsetWidth;
  return itemsWidth;
 },
 UseVirtualItemWidth: function() {
  return !this.IsFixedWidth() && !this.listBox.hasDecoratedItems && !this.IsItemTextWrapEnabled();
 },
 IsFixedWidth: function() {
  return this.listBox.IsMultiColumn() || this.IsStandaloneListBoxWithFixedWidth();
 },
 IsStandaloneListBoxWithFixedWidth: function() {
  return !this.listBox.isComboBoxList && this.listBox.width !== "";
 },
 GetFirstRenderedItem: function () {
  for (var i = 0; i < this.listTable.rows.length; i++)
   if (this.listTable.rows[i].itemIndex !== undefined)
    return this.GetItem(this.listTable.rows[i].itemIndex);
  return null;
 },
 GetLastRenderedItem: function () {
  for (var i = this.listTable.rows.length - 1; i >= 0; i--)
   if (this.listTable.rows[i].itemIndex !== undefined)
    return this.GetItem(this.listTable.rows[i].itemIndex);
  return null;
 },
 GetDefaultItemHeight: function (index) {
  return this.virtualScrollItemHeight;
 },
 ResetItemHeightIfRequired: function () {
  var firstItemRow = this.GetFirstVisibleItemRow();
  var isResetRequired = firstItemRow && this.GetVirtualScrollItemHeight(firstItemRow) !== this.virtualScrollItemHeight;
  if(isResetRequired)
   this.virtualScrollItemHeight = 0;
  return isResetRequired;
 },
 GetTopSpacersHeight: function () {
  return ListBoxItemsManagerBase.prototype.GetTopSpacersHeight.call(this) + this.GetVirtualScrollTopSpacer().clientHeight;
 },
 GetItemTopOffset: function (index) {
  var baseItemTopOffset = this.GetItemTopOffsetCore(index);
  if(baseItemTopOffset == 0) {
   var renderedItemRange = this.GetRenderedItemRange();
   if (index < renderedItemRange.startIndex || index > renderedItemRange.endIndex) {
    itemIndexInFilteredRange = ASPx.Data.ArrayIndexOf(this.filteredItemIndices, index);
    var nearestRenderedItemIndex = index < renderedItemRange.startIndex ?
     renderedItemRange.startIndex : renderedItemRange.endIndex;
    var nearestRenderedItemIndexInFilteredRange = ASPx.Data.ArrayIndexOf(this.filteredItemIndices, nearestRenderedItemIndex);
    return this.GetItemTopOffset(nearestRenderedItemIndex)
      + this.virtualScrollItemHeight * (itemIndexInFilteredRange - nearestRenderedItemIndexInFilteredRange);
   }
   return 0;
  }
  return baseItemTopOffset;
 },
 IsItemVisible: function (index) {
  return this.IsItemRendered(index) ? ListBoxItemsManagerBase.prototype.IsItemVisible.call(this, index) : false;
 },
 AreAllItemsVisible: function() {
  return this.filteredItemIndices.length === this.GetItemCount();
 },
 IsLastItemBottomEdgeVisible: function() {
  return this.IsItemEdgeVisible(this.GetLastFilteredItemIndex(), false, true);
 },
 ConvertItemIndexToRowIndex: function (itemIndex) {
  if(this.listTable.rows.length < 1)
   return -1;
  if(this.AreAllItemsVisible() && this.listBox.syncLockCount < 1 && !this.listBox.hasItemTemplate){ 
   var rawIndex = itemIndex - this.listTable.rows[0].itemIndex;
   return rawIndex >= 0 && rawIndex < this.listTable.rows.length ? rawIndex : -1;
  }
  return ASPx.Data.ArrayIndexOf(this.listTable.rows, itemIndex, function (element) { return element.itemIndex === itemIndex; });
 },
 GetScrollDivChildElementHeight: function () {
  return this.GetVirtualScrollTableContainer().getBoundingClientRect().height;
 },
 IsItemFiltered: function (index) {
  return this.deserializedItems[index] && this.deserializedItems[index].filtered;
 },
 GetFirstVisibleItem: function () { 
  for(var i = 0; i < this.listTable.rows.length; i++)
   if (this.listTable.rows[i] && ASPx.ElementContainsCssClass(this.listTable.rows[i], "dxeListBoxItemRow"))
    return this.listTable.rows[i].itemIndex;
  return -1;
 },
 GetFirstFilteredItemIndex: function() {
  return this.filteredItemIndices.length > 0 ? this.filteredItemIndices[0] : -1;
 },
 GetLastFilteredItemIndex: function() {
  return this.filteredItemIndices.length > 0 ? this.filteredItemIndices[this.filteredItemIndices.length - 1] : -1;
 },
 GetNewItemIndexInFilteredRange: function(selectedIndex, step) {
  var itemIndexInFilteredRange = ASPx.Data.ArrayIndexOf(this.filteredItemIndices, selectedIndex);
  var newItemIndexInFilteredRange = itemIndexInFilteredRange + step;
  if(newItemIndexInFilteredRange >= this.filteredItemIndices.length)
   newItemIndexInFilteredRange = this.filteredItemIndices.length - 1;
  else if(newItemIndexInFilteredRange < 0)
   newItemIndexInFilteredRange = 0;
  return this.filteredItemIndices[newItemIndexInFilteredRange];
 },
 ShouldRenderItemOnInsert: function(index) {
  if (!this.listBox.IsDisplayed())
   return false;
  if (this.GetFirstVisibleItemRow() == null)
   return true;
  if (this.IsIndexInRenderedItemRange(index))
   return true;
  if (this.filteredItemIndices.length > 0) {
   var startFilteredItemIndex = this.filteredItemIndices[0];
   var endFilteredItemIndex = this.filteredItemIndices[this.filteredItemIndices.length - 1];
   return index < startFilteredItemIndex && this.IsItemVisible(startFilteredItemIndex)
    || index > endFilteredItemIndex && this.IsItemVisible(endFilteredItemIndex);
  }
  return false;
 },
 InsertItem: function(index, itemProperties) {
  var isInsertToEnd = index === this.GetItemCount();
  var isInsertToEndWithLock = isInsertToEnd && this.updateLock;
  var shouldRenderItemOnInsert = !isInsertToEndWithLock && this.ShouldRenderItemOnInsert(index);
  var isItemInsertedToTop = this.virtualScrollVisibleItemIndices.length > 0 && index < this.virtualScrollVisibleItemIndices[0];
  ASPx.Data.ArrayInsert(this.deserializedItems, this.listBox.CreateItem(index, itemProperties), index);
  this.deserializedItems[index].filtered = true;
  this.deserializedItems[index].insertOrderIndex = this.listBox.FindFreeIndex();
  if(!isInsertToEnd) {
   for(var i = 0; i < this.deserializedItems.length; i++)
    this.deserializedItems[i].index = i;
   var requiredItemIndexInFilteredRange = -1;
   for(var i = 0; i < this.filteredItemIndices.length; i++)
    if(this.filteredItemIndices[i] >= index) {
     this.filteredItemIndices[i]++;
     if(requiredItemIndexInFilteredRange == -1)
      requiredItemIndexInFilteredRange = i;
    }
   ASPx.Data.ArrayInsert(this.filteredItemIndices, index, requiredItemIndexInFilteredRange);
  }
  else
   this.filteredItemIndices.push(index);
  if (shouldRenderItemOnInsert) {
   this.EnsureVirtualScrollItemHeight();
   if (this.GetFirstVisibleItemRow() == null)
    this.EnsureVirtualEmptyItemWidth();
  }
  if(!isInsertToEndWithLock) {
   this.virtualScrollVisibleItemIndices = [];
   var rows = this.GetListTableRows();
   for(var i = 0; i < rows.length; i++) {
    var row = rows[i];
    if(row.itemIndex !== undefined && row.itemIndex >= index)
     row.itemIndex++;
    this.virtualScrollVisibleItemIndices.push(row.itemIndex);
   }
   if(shouldRenderItemOnInsert) {
    ASPx.Data.ArrayInsert(this.virtualScrollVisibleItemIndices, index,
     ASPx.Data.ArrayIndexOf(this.virtualScrollVisibleItemIndices, index,
     function(element) { return element > index; }));
    this.listBox.InsertItemRow(index, itemProperties);
    this.RecreateItemRows();
   }
   this.UpdateScrollTableContainerHeight();
   if(isItemInsertedToTop)
    this.UpdateVirtualScrollSpacerHeight(this.virtualScrollVisibleItemIndices);
   if(!this.listBox.IsDisplayed())
    this.listBox.ResetControlAdjustment();
  }
  this.UpdateItemTextMaxWidth(this.GetItem(index).text);
 },
 BeginUpdate: function() {
  this.updateLock = true;
 },
 EndUpdate: function() {
  this.updateLock = false;
  this.EnsureVirtualScrollItemHeight();
  this.EnsureVirtualEmptyItemWidth();
  this.RecreateItemRows();
  this.UpdateScrollTableContainerHeight();
  if(!this.listBox.IsDisplayed())
   this.listBox.ResetControlAdjustment();
 },
 RemoveItem: function(index) {
  var shouldRecreateItemRows = this.listBox.IsDisplayed() && this.IsIndexInRenderedItemRange(index);
  var shouldRemoveFromRender = this.GetItemRow(index);
  var isItemRemovedFromTop = this.virtualScrollVisibleItemIndices.length > 0 && index < this.virtualScrollVisibleItemIndices[0];
  var needUpdateItemTextMaxWidth = this.NeedUpdateItemTextMaxWidthOnRemoveItem(index);
  ASPx.Data.ArrayRemoveAt(this.deserializedItems, index);
  ASPx.Data.ArrayRemove(this.filteredItemIndices, index);
  for (var i = 0; i < this.deserializedItems.length; i++)
   this.deserializedItems[i].index = i;
  for (var i = 0; i < this.filteredItemIndices.length; i++)
   if (this.filteredItemIndices[i] > index)
    this.filteredItemIndices[i]--;
  this.virtualScrollVisibleItemIndices = [];
  if (shouldRemoveFromRender)
   this.RemoveItemCore(index);
  var rows = this.GetListTableRows();
  for (var i = 0; i < rows.length; i++) {
   var row = rows[i];
   if (row.itemIndex !== undefined && row.itemIndex > index)
    row.itemIndex--;
   this.virtualScrollVisibleItemIndices.push(row.itemIndex);
  }
  if (shouldRecreateItemRows)
   this.RecreateItemRows();
  this.UpdateScrollTableContainerHeight();
  if (isItemRemovedFromTop)
   this.UpdateVirtualScrollSpacerHeight(this.virtualScrollVisibleItemIndices);
  if (needUpdateItemTextMaxWidth) {
   this.itemTextMaxWidth = 0;
   this.visibleItemTextMaxWidth = 0;
   for (var i = 0; i < this.GetItemCount() ; i++)
    this.UpdateItemTextMaxWidth(this.GetItem(i).text);
  }
  if (!this.listBox.IsDisplayed())
   this.listBox.ResetControlAdjustment();
 },
 ClearItems: function () {
  this.ClearItemsCore();
  this.deserializedItems = [];
  this.filteredItemIndices = [];
  this.virtualScrollVisibleItemIndices = [];
  if (this.listBox.isComboBoxList) {
   this.itemTextMaxWidth = 0;
   this.visibleItemTextMaxWidth = 0;
  }
  this.UpdateScrollTableContainerHeight();
  if (!this.listBox.IsDisplayed())
   this.listBox.ResetControlAdjustment();
 },
 CreateNewItemRow: function (index) {
  var newItemRow = ListBoxItemsManagerBase.prototype.CreateNewItemRow.call(this, index);
  newItemRow.itemIndex = index;
  return newItemRow;
 },
 Adjust: function () {
  if (this.GetItemCount() == 0 || !this.listBox.IsDisplayed())
   return;
  this.EnsureVirtualScrollItemHeight();
  this.EnsureVirtualEmptyItemWidth();
  this.RecreateItemRows();
  this.FixItemTruncatingIfRequired();
  this.listBox.InitializePageSize();
  if(!this.listBox.isComboBoxList)
   this.listBox.CorrectWidth();
 },
 UpdateItemTextMaxWidth: function (itemText, isFiltering) {
  if (!this.UseVirtualItemWidth())
   return;
  if (!ASPx.IsExists(this.visibleItemTextMaxWidth))
   this.visibleItemTextMaxWidth = 0;
  this.visibleItemTextMaxWidth = Math.max(this.GetItemTextWidth(itemText), this.visibleItemTextMaxWidth);
  if (!isFiltering)
   this.itemTextMaxWidth = this.visibleItemTextMaxWidth;
 },
 GetItemTextWidth: function (itemText) {
  return Math.round(this.GetItemTextMeasureContext().measureText(itemText).width);
 },
 GetItemTextMeasureContext: function() {
  if (!this.itemTextMeasureContext) {
   var itemTextMeasureCanvas = document.createElement("canvas");
   this.itemTextMeasureContext = itemTextMeasureCanvas.getContext("2d");
   var mainElementStyle = ASPx.GetCurrentStyle(this.listBox.GetMainElement());
   var mainElementFont = mainElementStyle.font ? mainElementStyle.font :
    mainElementStyle.fontStyle + " " + mainElementStyle.fontVariant + " " + mainElementStyle.fontWeight + " "
     + mainElementStyle.fontSize + " / " + mainElementStyle.lineHeight + " " + mainElementStyle.fontFamily;
   this.itemTextMeasureContext.font = mainElementFont;
  }
  return this.itemTextMeasureContext;
 },
 NeedUpdateItemTextMaxWidthOnRemoveItem: function(index) {
  return this.UseVirtualItemWidth() && this.listBox.isComboBoxList && this.IsItemWithMaxText(this.GetItem(index).text);
 },
 BeforeClientFiltering: function () {
  if (this.listBox.isComboBoxList)
   this.visibleItemTextMaxWidth = 0;
 },
 IsItemWithMaxText: function(itemText) {
  return this.GetItemTextWidth(itemText) === this.itemTextMaxWidth;
 },
 ApplyFilterToItem: function (index, isSatisfy, savePrevState, isFilterReset) {
  if (savePrevState && !ASPx.IsExists(this.deserializedItems[index].savedFiltered))
   this.deserializedItems[index].savedFiltered = this.deserializedItems[index].filtered;
  this.ChangeItemFilteredFlag(index, isSatisfy, isFilterReset);
 },
 RestorePrevFilteredState: function (index) {
  var savedFilteredState = this.deserializedItems[index].savedFiltered;
  if (ASPx.IsExists(savedFilteredState)) {
   this.ChangeItemFilteredFlag(index, savedFilteredState);
   delete this.deserializedItems[index].savedFiltered;
  }
 },
 ChangeItemFilteredFlag: function (index, newValue, isFilterReset) {
  var item = this.deserializedItems[index];
  item.filtered = newValue;
  if (!isFilterReset && this.listBox.isComboBoxList && newValue)
   this.UpdateItemTextMaxWidth(item.text);
 },
 OnEndItemsFiltering: function () {
  if (this.virtualScrollItemHeight && this.listBox.IsDisplayed()) {
   this.RecreateItemRows();
   this.UpdateScrollTableContainerHeight();
   if(!this.listBox.isComboBoxList)
    this.FixItemTruncatingIfRequired();
  }
 },
 ChangeItemsFilteredState: function (action) {
  this.filteredItemIndices = [];
  ListBoxItemsManagerBase.prototype.ChangeItemsFilteredState.call(this, action);
 },
 AfterChangeItemFilteredStateAction: function (index) {
  if (this.IsItemFiltered(index))
   this.filteredItemIndices.push(index);
 },
 RewriteFilteredItemIndices: function (newFilteredItemIndices) {
  this.filteredItemIndices = newFilteredItemIndices;
 },
 MakeAllItemsVisible: function () {
  ListBoxItemsManagerBase.prototype.MakeAllItemsVisible.call(this);
  this.visibleItemTextMaxWidth = this.itemTextMaxWidth;
 },
 InsertTempFirstItemRow: function() {
  try {
   this.listBox.LockRunStartupSciptsInItemRow();
   this.RecreateItemRowsByVisibleIndices([0]);
  }
  finally {
   this.listBox.UnlockRunStartupSciptsInItemRow();
  }
 },
 EnsureVirtualScrollItemHeight: function () {
  if (this.virtualScrollItemHeight == 0) {
   var firstItemRow = this.GetFirstVisibleItemRow();
   if (firstItemRow)
    this.virtualScrollItemHeight = this.GetVirtualScrollItemHeight(firstItemRow);
   else if(this.GetItemCount() > 0) {
    this.virtualScrollVisibleItemIndices = [];
    this.InsertTempFirstItemRow();
    firstItemRow = this.GetFirstVisibleItemRow();
    if(firstItemRow)
     this.virtualScrollItemHeight = this.GetVirtualScrollItemHeight(firstItemRow);
    this.RecreateItemRowsByVisibleIndices([]);
   }
   this.UpdateScrollTableContainerHeight();
  }
 },
 GetVirtualScrollItemHeight: function(virtualScrollItemRow) {
  return virtualScrollItemRow.getBoundingClientRect().height;
 },
 EnsureVirtualEmptyItemWidth: function () {
  if (this.virtualEmptyItemWidth == 0 && this.UseVirtualItemWidth() && this.GetItemCount() > 0) {
   this.InsertTempFirstItemRow();
   var firstItemRow = this.GetFirstVisibleItemRow();
   var itemTextCell = this.listBox.GetItemFirstTextCell(0);
   ASPx.SetInnerHtml(itemTextCell, "");
   ASPx.AddClassNameToElement(this.listTable, listTableCollapsedClassName);
   this.virtualEmptyItemWidth = firstItemRow.offsetWidth;
   ASPx.RemoveClassNameFromElement(this.listTable, listTableCollapsedClassName);
   this.RecreateItemRowsByVisibleIndices([]);
  }
 },
 UpdateScrollTableContainerHeight: function () {
  var virtualScrollTableContainer = this.GetVirtualScrollTableContainer();
  if (virtualScrollTableContainer)
   ASPx.SetStyles(virtualScrollTableContainer, {
    height: this.filteredItemIndices.length * this.virtualScrollItemHeight
     + this.listBox.GetTopScrollSpacerHeight()
     + this.listBox.GetBottomScrollSpacerHeight()
   });
 },
 UpdateVirtualScrollSpacerHeight: function(visibleIndices) {
  var firstVisibleIndex = visibleIndices.length > 0 && this.filteredItemIndices.length > 0 ? ASPx.Data.ArrayIndexOf(this.filteredItemIndices, visibleIndices[0]) : 0;
  var topSpacerHeight = this.virtualScrollItemHeight !== undefined ? firstVisibleIndex * this.virtualScrollItemHeight : 0;
  ASPx.SetStyles(this.GetVirtualScrollTopSpacer(), { height: topSpacerHeight });
 },
 OnScrollSpacerVisibilityChanged: function() {
  this.UpdateScrollTableContainerHeight();
 },
 SetItemHtml: function(index, html) {
  this.deserializedItems[index].htmlContent = html;
 },
 SetItemTooltip: function (index, tooltip) {
  this.deserializedItems[index].tooltip = tooltip;
 },
 SetItemAttribute: function(index, attrName, attrValue) {
  if(!this.deserializedItems[index].attributes)
   this.deserializedItems[index].attributes = {};
  this.deserializedItems[index].attributes[attrName] = attrValue;
 },
 AddClassNameToCssClass: function(cssClass, className) {
  return (cssClass == "" || cssClass == undefined) ? className : cssClass + " " + className;
 },
 RemoveClassNameFromCssClass: function (cssClass, className) {
  var updClassName = " " + cssClass + " ";
  var newClassName = updClassName.replace(" " + className + " ", " ");
  return updClassName.length != newClassName.length ? ASPx.Str.Trim(newClassName) : cssClass;
 },
 AddItemCssClass: function (index, className) {
  this.deserializedItems[index].cssClass = this.AddClassNameToCssClass(this.deserializedItems[index].cssClass, className);
 },
 RemoveItemCssClass: function (index, className) {
  this.deserializedItems[index].cssClass = this.RemoveClassNameFromCssClass(this.deserializedItems[index].cssClass, className);
 },
 SetItemTextCellHtml: function (itemIndex, textCellIndex, html) {
  if (!this.deserializedItems[itemIndex].htmlContents)
   this.deserializedItems[itemIndex].htmlContents = [];
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].htmlContents, textCellIndex, html);
 },
 SetItemTextCellTooltip: function (itemIndex, textCellIndex, tooltip) {
  if (!this.deserializedItems[itemIndex].cellTooltips)
   this.deserializedItems[itemIndex].cellTooltips = [];
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].cellTooltips, textCellIndex, tooltip);
 },
 SetItemTextCellAttribute: function(itemIndex, textCellIndex, attrName, attrValue) {
  if(!this.deserializedItems[itemIndex].cellAttributes)
   this.deserializedItems[itemIndex].cellAttributes = [];
  var setValueAction = function(itemInfo, value) {
   if(!itemInfo.value)
    itemInfo.value = {};
   itemInfo.value[value.attrName] = value.attrValue;
  };
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].cellAttributes, textCellIndex,
   { attrName: attrName, attrValue: attrValue }, setValueAction);
 },
 AddItemTextCellCssClass: function (itemIndex, textCellIndex, className) {
  if (!this.deserializedItems[itemIndex].cellCssClasses)
   this.deserializedItems[itemIndex].cellCssClasses = [];
  var newCssClass = this.AddClassNameToCssClass(this.deserializedItems[itemIndex].cellCssClasses[textCellIndex], className);
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].cellCssClasses, textCellIndex, newCssClass);
 },
 RemoveItemTextCellCssClass: function (itemIndex, textCellIndex, className) {
  if (!this.deserializedItems[itemIndex].cellCssClasses)
   this.deserializedItems[itemIndex].cellCssClasses = [];
  var newCssClass = this.RemoveClassNameFromCssClass(this.deserializedItems[itemIndex].cellCssClasses[textCellIndex], className);
  this.SetItemTextCellInfoValue(this.deserializedItems[itemIndex].cellCssClasses, textCellIndex, newCssClass);
 },
 SetItemTextCellInfoValue: function (infoArray, textCellIndex, value, setValueAction) {
  var itemInfo = null;
  var filteredArray = infoArray.filter(function (info) { return info.index === textCellIndex; });
  if (filteredArray.length == 0) {
   itemInfo = { index: textCellIndex };
   infoArray.push(itemInfo);
  }
  else
   itemInfo = filteredArray[0];
  if(setValueAction)
   setValueAction(itemInfo, value);
  else
   itemInfo.value = value;
 },
 InitializeItems: function(items, itemsValue) {
  this.deserializedItems = this.listBox.DeserializeItems(items);
  this.filteredItemIndices = [];
  this.visibleItemTextMaxWidth = 0;
  this.itemTextMaxWidth = 0;
  for (var i = 0; i < this.deserializedItems.length; i++) {
   this.listBox.AdjustItemProperties(this.deserializedItems[i]);
   itemsValue[i] = this.deserializedItems[i].value;
   this.filteredItemIndices[i] = this.deserializedItems[i].index;
   this.deserializedItems[i].filtered = true;
   this.deserializedItems[i].insertOrderIndex = this.listBox.FindFreeIndex();
   this.UpdateItemTextMaxWidth(this.deserializedItems[i].text);
  }
 },
 InitializeItemRows: function () {
  var topSpacer = ASPx.CreateHtmlElement("DIV");
  topSpacer.id = this.listBox.name + "VirtualScrollTopSpacer";
  var tableContainer = ASPx.CreateHtmlElement("DIV");
  tableContainer.id = this.listBox.name + ListBoxVirtualScrollTableContainerIDPostfix;
  tableContainer.appendChild(topSpacer);
  var scrollDiv = this.listBox.GetScrollDivElement();
  ASPx.MoveChildrenToElement(scrollDiv, tableContainer);
  scrollDiv.appendChild(tableContainer);
  ASPx.SetStyles(tableContainer, { overflow: "hidden", width: "100%" });
  ASPx.Evt.AttachEventToElement(scrollDiv, "scroll", function () {
   if(this.IsScrollActivated()) {
    this.RecreateItemRows();
    this.CorrectScrollTableContainerHeightByContent();
   } else
    this.ActivateScrollHandler();
  }.bind(this));
 },
 RecreateItemRows: function() {
  if(!this.listBox.IsDisplayed()) return;
  var scrollDiv = this.listBox.GetScrollDivElement();
  if(!scrollDiv) return;
  var scrollDivHeight = scrollDiv.clientHeight;
  var scrollTop = scrollDiv.scrollTop - this.listBox.GetTopScrollSpacerHeight();
  if(scrollTop < 0)
   scrollTop = 0;
  var firstVisibleItemIndex = Math.floor(scrollTop / this.virtualScrollItemHeight);
  var lastVisibleItemIndex = Math.floor((scrollTop + scrollDivHeight) / this.virtualScrollItemHeight);
  var topRenderedItemIndex = Math.max(firstVisibleItemIndex - this.virtualScrollTopInvisibleItemsCount, 0);
  var bottomRenderedItemIndex = Math.min(lastVisibleItemIndex + this.virtualScrollBottomInvisibleItemsCount, this.filteredItemIndices.length - 1);
  this.RecreateItemRowsCore(topRenderedItemIndex, bottomRenderedItemIndex);
  if(typeof(ASPxClientHint) != "undefined")
   this.UpdateHintControl();
  this.listBox.AssignEllipsisTooltips();
 },
 RecreateItemRowsCore: function(topRenderedItemIndex, bottomRenderedItemIndex) {
  if(topRenderedItemIndex > bottomRenderedItemIndex && this.filteredItemIndices.length > 0)
   return;
  var newVisibleIndices = this.filteredItemIndices.slice(topRenderedItemIndex, bottomRenderedItemIndex + 1);
  this.RecreateItemRowsByVisibleIndices(newVisibleIndices);
  this.OnDecoratedItemsRendering();
  this.CreateItemRowsInFreeSpace(false);
  if(this.listBox.NeedToHandleCellWidth())
   this.listBox.CorrectCellNullWidthStyle(this.GetFirstVisibleItemRow());
 },
 UpdateHintControl: function() {
  ASPxClientHint.hideByTargetsContainerElement(this.listTable, true);
  ASPxClientHint.Update();
 },
 CorrectScrollTableContainerHeightByContent: function() {
  if(this.virtualScrollVisibleItemIndices.length == 0) return;
  var scrollTableContainer = this.GetVirtualScrollTableContainer();
  if(!scrollTableContainer) return;
  var scrollDiv = this.listBox.GetScrollDivElement();
  var containerHeight = scrollTableContainer.getBoundingClientRect().height;
  var scrollDivHeight = scrollDiv.clientHeight;
  var containerOffsetTop = scrollTableContainer.offsetTop - scrollDiv.offsetTop;
  var isScrolledToBottomEdge = scrollDiv.scrollTop + scrollDivHeight >= containerOffsetTop + containerHeight;
  if(isScrolledToBottomEdge || this.IsLastItemBottomEdgeVisible()) {
   var contentHeight = this.GetScrollContentHeight();
   var heightError = 0.01;
   if(Math.abs(contentHeight - containerHeight) > heightError) {
    this.DeactivateScrollHandler();
    scrollTableContainer.style.height = contentHeight + "px";
    setTimeout(function() {
     scrollDiv.scrollTop = containerOffsetTop + scrollTableContainer.getBoundingClientRect().height - scrollDivHeight + 1;
     var isListBoxDisplayed = this.listBox.IsDisplayed();
     if(!isListBoxDisplayed)
      this.ActivateScrollHandler();
     if(isListBoxDisplayed && this.GetVisibleItemCount() > 0 && !this.IsLastItemBottomEdgeVisible()) {
      this.RecreateItemRowsByVisibleIndices([this.GetLastFilteredItemIndex()], true);
      scrollTableContainer.style.height = this.GetScrollContentHeight() + "px";
      this.CreateItemRowsInFreeSpace(true);
     }
    }.aspxBind(this), 0);
   }
  }
 },
 CreateItemRowsInFreeSpace: function(toTop, edgeRenderedItemIndexInFilteredRange) {
  if(this.virtualScrollVisibleItemIndices.length == 0)
   return;
  var edgeRenderedItemIndex = this.virtualScrollVisibleItemIndices[toTop ? 0 : this.virtualScrollVisibleItemIndices.length - 1];
  var edgeFilteredItemIndex = this.filteredItemIndices[toTop ? 0 : this.filteredItemIndices.length - 1];
  if(edgeRenderedItemIndex !== edgeFilteredItemIndex && this.IsItemVisible(edgeRenderedItemIndex)) {
   edgeRenderedItemIndexInFilteredRange = edgeRenderedItemIndexInFilteredRange || ASPx.Data.ArrayIndexOf(this.filteredItemIndices, edgeRenderedItemIndex);
   var newRenderedItemIndexInFilteredRange = toTop ? --edgeRenderedItemIndexInFilteredRange : ++edgeRenderedItemIndexInFilteredRange;
   var newRenderedItemIndex = this.filteredItemIndices[newRenderedItemIndexInFilteredRange];
   var newRenderedIndices = this.virtualScrollVisibleItemIndices.slice();
   if(toTop)
    newRenderedIndices.unshift(newRenderedItemIndex);
   else
    newRenderedIndices.push(newRenderedItemIndex);
   this.RecreateItemRowsByVisibleIndices(newRenderedIndices, toTop);
   if(toTop) {
    this.GetVirtualScrollTableContainer().style.height = this.GetScrollContentHeight() + "px";
    this.listBox.MakeItemVisible(this.filteredItemIndices[this.filteredItemIndices.length - 1]);
   }
   this.CreateItemRowsInFreeSpace(toTop, newRenderedItemIndexInFilteredRange);
  }
 },
 GetScrollContentHeight: function() {
  return this.GetVirtualScrollTopSpacer().getBoundingClientRect().height
   + this.listBox.GetTopScrollSpacerHeight() + this.listBox.GetBottomScrollSpacerHeight()
   + this.listTable.getBoundingClientRect().height;
 },
 FixItemTruncatingIfRequired: function() {
  var scrollDiv = this.listBox.GetScrollDivElement();
  var scrollTableContainer = this.GetVirtualScrollTableContainer();
  if(scrollTableContainer && scrollDiv.offsetHeight >= scrollTableContainer.offsetHeight) {
   this.CorrectScrollTableContainerHeightByContent();
   if(scrollDiv.offsetHeight < scrollTableContainer.offsetHeight)
    scrollDiv.style.height = scrollTableContainer.style.height;
  }
 },
 RecreateItemRowsByVisibleIndices: function (newVisibleIndices, keepTopSpacerHeight) {
  newVisibleIndices = newVisibleIndices || [];
  var indicesToRemove = this.virtualScrollVisibleItemIndices.filter(function (index) { return newVisibleIndices.indexOf(index) === -1; });
  var indicesToInsert = newVisibleIndices.filter(function (index) { return this.virtualScrollVisibleItemIndices.indexOf(index) === -1; }.bind(this));
  this.listBox.LockSynchronization();
  for (var i = 0; i < indicesToRemove.length; i++) {
   var itemIndex = indicesToRemove[i];
   this.listBox.RemoveItemRow(itemIndex);
  }
  for (var i = 0; i < indicesToInsert.length; i++) {
   var itemIndex = indicesToInsert[i];
   this.listBox.InsertItemRow(itemIndex, this.deserializedItems[itemIndex]);
   var isItemSelected = this.listBox.GetIsItemSelected(itemIndex);
   var stateController = typeof (ASPx.GetStateController) != "undefined" ? ASPx.GetStateController() : null;
   this.listBox.SetItemSelectionAppearance(itemIndex, isItemSelected, stateController, false);
   if (this.listBox.GetIsCheckColumnExists())
    this.listBox.SetCheckBoxChecked(itemIndex, isItemSelected);
   this.listBox.ChangeEnabledStateItem(itemIndex, this.listBox.clientEnabled, ASPx.GetStateController());
  }
  this.listBox.TryApplyHighlighting();
  this.listBox.UnlockSynchronization();
  if(!keepTopSpacerHeight)
   this.UpdateVirtualScrollSpacerHeight(newVisibleIndices);
  this.listBox.InitDXTextAttributes();
  this.virtualScrollVisibleItemIndices = newVisibleIndices;
 },
 RemoveHoverStateItemCore: function (controller, itemCellsIdSuffixes) {
  ListBoxItemsManagerBase.prototype.RemoveHoverStateItemCore.call(this, controller, itemCellsIdSuffixes);
  var range = this.GetRenderedItemRange();
  for (var i = range.startIndex; i <= range.endIndex; i++) {
   if(i >= 0)
    this.RemoveItemStateHoverItem(controller, itemCellsIdSuffixes, i);
  }
 },
 AddStateItemsCore: function (controller, clearCache, itemCellsIdSuffixes, hoverItemOnly) {
  ListBoxItemsManagerBase.prototype.AddStateItemsCore.call(this, controller, clearCache, itemCellsIdSuffixes, hoverItemOnly);
  var range = this.GetRenderedItemRange();
  for (var i = range.startIndex; i <= range.endIndex; i++) {
   if (i >= 0)
    this.AddItemStateItems(controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, i);
  }
 },
 GetVirtualScrollTableContainer: function () {
  return this.listBox.tempCache.Get("virtualScrollTableContainer", this.GetVirtualScrollTableContainerCore.aspxBind(this), this.listBox);
 },
 GetVirtualScrollTableContainerCore: function () {
  if (!ASPx.IsExistsElement(this.listBox.virtualScrollTableContainer))
   this.listBox.virtualScrollTableContainer = ASPx.GetElementById(this.listBox.name + ListBoxVirtualScrollTableContainerIDPostfix);
  return this.listBox.virtualScrollTableContainer;
 },
 GetVirtualScrollTopSpacer: function () {
  return this.listBox.tempCache.Get("virtualScrollTopSpacer", this.GetVirtualScrollTopSpacerCore.aspxBind(this), this.listBox);
 },
 GetVirtualScrollTopSpacerCore: function () {
  if (!ASPx.IsExistsElement(this.listBox.virtualScrollTopSpacer))
   this.listBox.virtualScrollTopSpacer = ASPx.GetElementById(this.listBox.name + "VirtualScrollTopSpacer");
  return this.listBox.virtualScrollTopSpacer;
 },
 GetRenderedItemRange: function () {
  var firstRenderedItem = this.GetFirstRenderedItem();
  var lastRenderedItem = this.GetLastRenderedItem();
  return {
   startIndex: firstRenderedItem ? firstRenderedItem.index : -1,
   endIndex: lastRenderedItem ? lastRenderedItem.index : -1
  };
 },
 IsIndexInRenderedItemRange: function(index) {
  var renderedItemRange = this.GetRenderedItemRange();
  return index >= renderedItemRange.startIndex && index <= renderedItemRange.endIndex;
 },
 IsItemRendered: function (itemIndex) {
  return this.GetItemRow(itemIndex) !== null;
 },
 IsItemTextWrapEnabled: function() {
  if(!ASPx.IsExists(this.enableItemTextWrap)) {
   var sampleItemFirstTextCell = this.listBox.GetSampleItemFirstTextCell();
   this.enableItemTextWrap = sampleItemFirstTextCell && ASPx.GetCurrentStyle(sampleItemFirstTextCell).whiteSpace !== "nowrap";
  }
  return this.enableItemTextWrap;
 },
 OnDecoratedItemsRendering: function () {
  if(this.listBox.hasDecoratedItems && !this.IsFixedWidth() && this.listBox.IsDisplayed() && !this.IsItemTextWrapEnabled())
   this.listBox.CorrectWidth();
 },
 DeactivateScrollHandler: function() { 
  this.isScrollProcessingActivated = false;
 },
 ActivateScrollHandler: function() { 
  this.isScrollProcessingActivated = true;
 },
 IsScrollActivated: function() {
  return this.isScrollProcessingActivated;
 }
});
var ASPxClientListEdit = ASPx.CreateClass(ASPxClientEdit, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.SelectedIndexChanged = new ASPxClientEvent();
  this.savedSelectedIndex = -1;
 },
 FindInputElement: function() {
  return this.FindStateInputElement();
 },
 FindStateInputElement: function(){
  return document.getElementById(this.name + leVISuffix);
 },
 GetItem: function(index) {
  throw "Not implemented";
 },
 GetItemValue: function(index) {
  throw "Not implemented";
 },
 GetValue: function(){
  return this.GetItemValue(this.GetSelectedIndex());
 }, 
 GetSelectedIndexInternal: function(){
  return this.savedSelectedIndex;
 },
 SetSelectedIndexInternal: function(index){
  this.savedSelectedIndex = index;
 },
 FindItemIndexByValue: function(value){
  for(var i = 0; i < this.GetItemCount(); i++){
   if(this.GetItemValue(i) == value)
    return i;
  }
  return -1;
 },
 RaiseItemClick: function() {
  var processOnServer = this.autoPostBack;
  if(!this.ItemClick.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.ItemClick.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 RaiseItemDoubleClick: function() {
  var processOnServer = this.autoPostBack;
  if(!this.ItemDoubleClick.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.ItemDoubleClick.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 RaiseValueChangedEvent: function() {
  if(!this.isInitialized) return false;
  var processOnServer = ASPxClientEdit.prototype.RaiseValueChangedEvent.call(this);
  processOnServer = this.RaiseValueChangedAdditionalEvents(processOnServer);
  return processOnServer;
 },
 RaiseValueChangedAdditionalEvents: function(processOnServer){
  return this.RaiseSelectedIndexChanged(processOnServer);
 },
 RaiseSelectedIndexChanged: function (processOnServer) {
  this.RaiseValidationInternal();
  if(!this.SelectedIndexChanged.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.SelectedIndexChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 UpdateHiddenInputs: function(){
  var element = this.FindStateInputElement();
  if(ASPx.IsExistsElement(element)) {
   var value = this.GetValue();
   if(value == null)
    value = "";
   element.value = value;
  }
 },
 GetModifyEvent: function () {
  return this.SelectedIndexChanged;
 },
 GetSelectedItem: function(){
  var index = this.GetSelectedIndexInternal();
  return this.GetItem(index);
 },
 GetSelectedIndex: function(){
  return this.GetSelectedIndexInternal();
 },
 SetSelectedItem: function(item){
  var index = (item != null) ? item.index : -1;
  this.SetSelectedIndex(index);
 },
 SetSelectedIndex: function(index){
  this.SelectIndexSilent(index);
 },
 SelectIndexSilent: function(index){
  throw "Not implemented";
 },
 OnValueChanged: function () {
  var processOnServer = this.RaiseValueChangedEvent() && this.GetIsValid();
  if(processOnServer)
   this.SendPostBackInternal("");
 },
 getElementToObserveVisibilityChange: function () {
  return this.GetMainElement();
 },
 processVisibilityChanged: function (visible) {
  var focusHandlingInputForKeyboardSupport = this.GetMainElement().querySelector(".dxKBSI");
  ASPx.ToggleClassNameToElement(focusHandlingInputForKeyboardSupport, "dx-position-fixed", visible);
 }
});
var ASPxClientListEditItem = ASPx.CreateClass(null, {
 constructor: function(listEditBase, index, text, value, imageUrl){
  this.listEditBase = listEditBase;
  this.index = index;
  this.imageUrl = imageUrl;
  this.text = text;
  this.value = value;
 }
});
var ASPxClientListBoxItem = ASPx.CreateClass(ASPxClientListEditItem, {
 constructor: function(listEditBase, index, texts, value, imageUrl, selected, cellStyles, cellCssClasses, cellTooltips, cellAttributes, htmlContents, style, cssClass, tooltip, attributes, htmlContent) {
  this.constructor.prototype.constructor.call(this, listEditBase, index, null, value, imageUrl);
  this.selected = !!selected;
  this.texts = texts;
  this.text = listEditBase.FormatText(texts, value);
  this.cellStyles = cellStyles;
  this.cellCssClasses = cellCssClasses;
  this.cellTooltips = cellTooltips;
  this.cellAttributes = cellAttributes;
  this.htmlContents = htmlContents;
  this.style = style;
  this.cssClass = cssClass;
  this.tooltip = tooltip;
  this.attributes = attributes;
  this.htmlContent = htmlContent;
 },
 GetColumnText: function(columnIndexOrFieldName){
  var columnIndex = -1;
  if(typeof(columnIndexOrFieldName) == "string")
   columnIndex = ASPx.Data.ArrayIndexOf(this.listEditBase.columnFieldNames, columnIndexOrFieldName);
  else if(typeof(columnIndexOrFieldName) == "number")
   columnIndex = columnIndexOrFieldName;
  return this.GetColumnTextByIndex(columnIndex);
 },
 GetColumnTextByIndex: function(columnIndex){
  if(0 <= columnIndex && columnIndex < this.texts.length)
   return this.texts[columnIndex];
  else
   return null;
 }
});
var ListBoxScrollCallbackHelperBase = ASPx.CreateClass(null, {
 constructor: function(listBoxControl) {
  this.listBoxControl = listBoxControl;
  this.itemsRange = "";
  this.defaultItemsRange = "0:" + (this.listBoxControl.callbackPageSize - 1);
 },
 OnScroll: function(){ },
 Reset: function(){ },
 IsScrolledToTopSpacer: function(){ return false; },
 IsScrolledToBottomSpacer: function(){ return false; },
 GetIsNeedToHideTopSpacer: function(){ return false; },
 GetIsNeedCallback: function(){ return false; },
 GetIsAnySpacerVisible: function() { return false; },
 GetItemsRangeForLoad: function(){ return this.defaultItemsRange; },
 SetItemsRangeForLoad: function(){}
});
var ListBoxScrollCallbackHelper = ASPx.CreateClass(ListBoxScrollCallbackHelperBase, {
 constructor: function(listBoxControl) {
  this.constructor.prototype.constructor.call(this, listBoxControl);
  this.isScrolledToTopSpacer = false;
  this.isScrolledToBottomSpacer = false;
 },
 OnScroll: function(){
  this.DetectScrollDirection();
  this.ResetItemsRange();
  if(this.GetIsAnySpacerVisible())
   this.RecalcItemsRangeForLoad();
 },
 DetectScrollDirection: function(){
  var listBoxControl = this.listBoxControl;
  var divElement = listBoxControl.GetScrollDivElement();
  var scrollTop = divElement.scrollTop;
  var scrollBottom = divElement.scrollTop + divElement.clientHeight;
  var isTopSpacerVisible = listBoxControl.GetScrollSpacerVisibility(true);
  var isBottomSpacerVisible = listBoxControl.GetScrollSpacerVisibility(false);
  this.isScrolledToTopSpacer = (scrollTop < parseInt(listBoxControl.GetTopSpacersHeight())) && isTopSpacerVisible;
  var listHeight = this.GetListHeight();
  this.isScrolledToBottomSpacer = (scrollBottom >= listBoxControl.GetTopSpacersHeight() + listHeight) && isBottomSpacerVisible;
 },
 GetListHeight: function () {
  var listTable = this.listBoxControl.GetListTable();
  return listTable.clientHeight;
 },
 Reset: function(){
  this.ResetItemsRange();
  this.isScrolledToTopSpacer = false;
  this.isScrolledToBottomSpacer = false;
 },
 ResetItemsRange: function(){
  this.itemsRange = "";
 },
 RecalcItemsRangeForLoad: function(){
  if(this.listBoxControl.isCallbackMode) {
   if(this.isScrolledToTopSpacer || this.isScrolledToBottomSpacer)
    this.SetItemsRangeForLoad(this.isScrolledToTopSpacer);
  }
 },
 IsScrolledToTopSpacer: function(){
  return this.isScrolledToTopSpacer;
 },
 IsScrolledToBottomSpacer: function(){
  return this.isScrolledToBottomSpacer;
 },
 GetIsAnySpacerVisible: function(){
  return this.isScrolledToTopSpacer || this.isScrolledToBottomSpacer;
 },
 GetIsNeedCallback: function(){
  return !this.GetIsItemsRangeEmpty();
 },
 GetIsNeedToHideTopSpacer: function(){
  return this.isScrolledToTopSpacer && this.GetIsItemsRangeEmpty();
 },
 GetItemsRangeForLoad: function(){
  return (!this.GetIsItemsRangeEmpty() ? this.itemsRange : this.defaultItemsRange);
 },
 SetItemsRangeForLoad: function(isForTop){
  var listbox = this.listBoxControl;
  var beginIndex = isForTop ? 
   listbox.serverIndexOfFirstItem - listbox.callbackPageSize : 
   listbox.serverIndexOfFirstItem + listbox.GetItemCount();
  beginIndex = beginIndex < 0 ? 0 : beginIndex;
  var endIndex = isForTop ? 
   listbox.serverIndexOfFirstItem - 1 : 
   beginIndex + listbox.callbackPageSize - 1;
  this.itemsRange = beginIndex + ":" + endIndex;
  this.isScrolledToTopSpacer = isForTop;
  this.isScrolledToBottomSpacer = !isForTop;
 },
 GetIsItemsRangeEmpty: function(){
  return (this.itemsRange == "" || this.itemsRange == emptyItemsRange);
 }
});
var ASPxClientListBoxBase = ASPx.CreateClass(ASPxClientListEdit, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.APILockCount = 0;
  this.updateSelectAllElementsLockCount = 0;
  this.enableSyncOnPerfCallback = false;
  this.scrollOnKBNavigationLockCount = 0;
  this.isComboBoxList = false;
  this.isSyncEnabled = true;
  this.ownerName = "";
  this.selectionEventsLockCount = 0;
  this.syncLockCount = 0;
  this.encodeHtml = true;
  this.useCaseInsensitiveSearch = true;
  this.serializingHelper = null;
  this.deletedItems = [];
  this.insertedItems = [];
  this.itemsValue = [];
  this.ItemDoubleClick = new ASPxClientEvent();
  this.ItemClick = new ASPxClientEvent();
 },
 InlineInitialize: function () {
  ASPxClientListEdit.prototype.InlineInitialize.call(this);
  for(var i = 0; i < this.itemsValue.length; i++)
   this.itemsValue[i] = this.GetDecodeValue(this.itemsValue[i]);
 },
 LockScrollOnKBNavigation: function(){
  this.scrollOnKBNavigationLockCount++;
 },
 UnlockScrollOnKBNavigation: function(){
  this.scrollOnKBNavigationLockCount--;
 },
 IsScrollOnKBNavigationLocked: function() {
  return this.scrollOnKBNavigationLockCount > 0;
 },
 LockSelectionEvents: function(){
  this.selectionEventsLockCount++;
 },
 UnlockSelectionEvents: function(){
  this.selectionEventsLockCount--;
 },
 IsSelectionEventsLocked: function(){
  return this.selectionEventsLockCount > 0;
 },
 LockSynchronizationOnInternalCallback: function(){
  if(!this.enableSyncOnPerfCallback)
   this.LockSynchronization();
 },
 UnlockSynchronizationOnInternalCallback: function (){
  if(!this.enableSyncOnPerfCallback)
   this.UnlockSynchronization();
 },
 GetItemCount: function(){
  return 0;
 },
 GetItemValue: function(index){
  if(0 <= index && index < this.GetItemCount())
   return this.PrepareItemValue(this.itemsValue[index]);
  return null;
 },
 GetItemTexts: function(item) {
  return item.text;
 },
 PrepareItemValue: function(value) {
  return (typeof(value) == "string" && value == "" && this.convertEmptyStringToNull) ? null : value;
 },
 LoadItemsFromCallback: function(isToTop, itemStrings){
 },
 SetValue: function(value){
  var index = this.FindItemIndexByValue(value);
  this.SelectIndexSilentAndMakeVisible(index);
 },
 FindItemIndexByText: function(text){
  var transformText = function(text) { return text; };
  var textIsString = typeof(text) === "string";
  if(this.useCaseInsensitiveSearch && textIsString)
   transformText = function(text) { return text.toUpperCase(); };
  text = transformText(text);
  for(var i = 0; i < this.GetItemCount(); i ++){
   if(transformText(this.GetItem(i).text) == text)
    return i;
  }
  return -1;
 },
 SelectIndex: function (index){ 
  if(this.SelectIndexSilentAndMakeVisible(index, false)){
   this.RaisePersonalStandardValidation();
   this.OnValueChanged();
  }
 },
 SelectIndexSilentAndMakeVisible: function(index, lockScrollingToItem){
  var selectionChanged = this.SelectIndexSilent(index);
  if(!this.IsScrollOnKBNavigationLocked() && !lockScrollingToItem)
   this.MakeItemVisible(index);
  return selectionChanged;
 },
 FormatText: function (texts) {
  return texts;
 },
 MakeItemVisible: function(index){
 },
 InitOnContainerMadeVisible: function(){
 },
 AddItem: function(texts, value, imageUrl) {
  return this.AddItemInternal(this.CreateItemProperties(texts, value, imageUrl));
 },
 AddItemInternal: function(itemProperties) {
  var index = this.GetItemCount();
  this.InsertItemInternal(index, itemProperties);
  if(!ASPx.IsExists(this.GetItem(index)))
   index = -1;
  return index;
 },
 InsertItem: function(index, texts, value, imageUrl) {
  this.InsertItemInternal(index, this.CreateItemProperties(texts, value, imageUrl));
 },
 CreateItemProperties: function(texts, value, imageUrl, htmlContent, cssClass, tooltip) {
  return {
   texts: texts,
   value: value,
   imageUrl: imageUrl,
   htmlContent: htmlContent,
   cssClass: cssClass,
   tooltip: tooltip
  };
 },
 InsertItemInternal: function(index, itemProperties) {
 },
 BeginUpdate: function(){
  this.APILockCount ++;
 },
 EndUpdate: function(){
  this.APILockCount --;
  this.Synchronize();
 },
 LockUpdateSelectAllElements: function() {
  this.updateSelectAllElementsLockCount++;
 },
 UnlockUpdateSelectAllElements: function () {
  this.updateSelectAllElementsLockCount--;
 },
 IsUpdateSelectAllElementsLocked: function() {
  return this.updateSelectAllElementsLockCount > 0;
 },
 ClearItems: function(){
  this.BeginUpdate();
  this.UpdateArraysItemsCleared();
  this.ClearItemsCore();
  this.EndUpdate();
 },
 ClearItemsCore: function(){
 },
 ClearItemsForPerformCallback: function(){
  this.itemsValue = [];
  this.ClearItemsCore();
 },
 RemoveItem: function(index){
 },
 FindItemByText: function(text){
  var index = this.FindItemIndexByText(text);
  return this.GetItem(index);
 },
 FindItemByValue: function(value){
  var index = this.FindItemIndexByValue(value);
  return this.GetItem(index);
 },
 PerformCallback: function(arg) {
 },
 GetCallbackArguments: function(){
  var args = this.GetCustomCallbackArg();
  args += this.GetLoadItemsRangeCallbackArg();
  if(this.filterStrategy)
   args += this.filterStrategy.GetCallbackArguments();
  return args;
 },
 GetLoadItemsRangeCallbackArg: function(){
  return this.GetLoadItemsRangeCallbackArgCore(this.GetItemsRangeForLoad());
 },
 GetLoadCustomItemsRangeCallbackArguments: function(beginIndex, endIndex, value) {
  var itemsRange = beginIndex + ":" + endIndex;
  if(ASPx.IsExists(value))
   itemsRange = itemsRange + ":" + ASPx.Json.ToJson(value);
  var args = this.GetCustomCallbackArg();
  args += this.GetLoadItemsRangeCallbackArgCore(itemsRange);
  return args;
 },
 GetLoadItemsRangeCallbackArgCore: function(itemsRange) {
  return this.FormatCallbackArg(CONSTANTS.CALLBACK_PREFIXES.LOAD_RANGE_ITEMS, itemsRange);
 },
 FormatCallbackArg: function(prefix, arg) { 
  arg = arg.toString();
  return (ASPx.IsExists(arg) ? prefix + "|" + arg.length + ';' + arg + ';' : "");
 },
 GetItemsRangeForLoad: function(){
  return emptyItemsRange;
 },
 GetCallbackOwnerControl: function(){
  if(this.ownerName && !this.ownerControl)
   this.ownerControl = ASPx.GetControlCollection().Get(this.ownerName);
  return this.ownerControl;
 },
 GetCustomCallbackArg: function(){
  return this.stateObject["CustomCallback"];
 },
 SetCustomCallbackArg: function(arg){
  this.UpdateStateObjectWithObject({ CustomCallback: arg });
 },
 FormatAndSetCustomCallbackArg: function(arg, onPerformCallback){
  arg = ASPx.IsExists(arg) ? arg.toString() : "";
  var formatArg = this.FormatCallbackArg(onPerformCallback ? CONSTANTS.CALLBACK_PREFIXES.CUSTOMPERFORM : CONSTANTS.CALLBACK_PREFIXES.CUSTOM, arg);
  this.SetCustomCallbackArg(formatArg);
 },
 SendCallback: function(){
 },
 LockSynchronization: function(){
  this.syncLockCount++;
 },
 UnlockSynchronization: function(){
  this.syncLockCount--;
 },
 IsSyncLocked: function(){
  return this.syncLockCount > 0;
 },
 IsSyncEnabled: function(){
  return this.isSyncEnabled && !this.IsSyncLocked();
 },
 RegisterInsertedItem: function(index, itemProperties){
  if(this.IsSyncEnabled()){
   this.RefreshSynchroArraysIndex(index, true);
   var item = this.CreateItem(index, itemProperties);
   this.insertedItems.push(item);
   this.Synchronize();
  }
 },
 CreateItem: function(index, itemProperties) {
  return new ASPxClientListBoxItem(this, index, itemProperties.texts || [itemProperties.text], itemProperties.value, itemProperties.imageUrl,
   itemProperties.selected, itemProperties.cellStyles, itemProperties.cellCssClasses, itemProperties.cellTooltips, itemProperties.cellAttributes, itemProperties.htmlContents,
   itemProperties.style, itemProperties.cssClass, itemProperties.tooltip, itemProperties.attributes, itemProperties.htmlContent);
 },
 UpdateSyncArraysItemDeleted: function(item, isValueRemovingRequired){
  if(isValueRemovingRequired)
   ASPx.Data.ArrayRemoveAt(this.itemsValue, item.index);
  if(this.IsSyncEnabled()){
   var index = this.FindItemInArray(this.insertedItems, item);
   if(index == -1){
    this.RefreshSynchroArraysIndex(item.index, false);
    this.deletedItems.push(item);
   } else {
    this.RefreshSynchroArraysIndex(item.index, false);
    ASPx.Data.ArrayRemoveAt(this.insertedItems, index);
   }
   this.Synchronize();
  }
 },
 UpdateArraysItemsCleared: function(){
  if(this.IsSyncEnabled()){
   for(var i = this.GetItemCount() - 1; i >= 0; i --)
    this.UpdateSyncArraysItemDeleted(this.GetItem(i), false);
  } 
  this.itemsValue = [];
 },
 RefreshSynchroArraysIndex: function(startIndex, isIncrease){
  this.RefreshSynchroArrayIndexIndex(this.deletedItems, startIndex, isIncrease);
  this.RefreshSynchroArrayIndexIndex(this.insertedItems, startIndex, isIncrease);
 },
 RefreshSynchroArrayIndexIndex: function(array, startIndex, isIncrease){
  var delta = isIncrease ? 1 : -1;
  for(var i = 0; i < array.length; i ++){
   if(array[i].index >= startIndex)
    array[i].index += delta;
  }   
 },
 FindItemInArray: function(array, item){
  for(var i = array.length - 1; i >= 0; i--){
   var currentItem = array[i];
   if((!this.encodeHtml || currentItem.text == item.text) && currentItem.value == item.value &&
    currentItem.imageUrl == item.imageUrl)
    break;
  }
  return i;
 },
 Synchronize: function(){
  if(this.APILockCount == 0){
   if(this.IsSyncEnabled()){
    this.SynchronizeItems(this.deletedItems, "DeletedItems");
    this.SynchronizeItems(this.insertedItems, "InsertedItems");
   }
   this.CorrectSizeByTimer();
  }
 },
 CorrectSizeByTimer: function(){
 },
 SynchronizeItems: function(items, syncType){
  var itemsObj = { };
  itemsObj[syncType] = this.SerializeItems(items);
  this.UpdateStateObjectWithObject(itemsObj);
 },
 GetSerializingHelper: function(){ 
  if(this.serializingHelper == null)
   this.serializingHelper = this.CreateSerializingHelper();
  return this.serializingHelper;
 },
 CreateSerializingHelper: function(){
  return new ListBoxBaseItemsSerializingHelper(this);
 },
 SerializeItems: function(items){
  var serialiser = this.GetSerializingHelper();
  return serialiser.SerializeItems(items);
 },
 DeserializeItems: function(items) {
  return items.map(function(itemProperties, index) {
   return this.CreateItem(index, itemProperties);
  }.bind(this));
 }
});
var ListBoxBaseItemsSerializingHelper = ASPx.CreateClass(null, {
 constructor: function(listBoxControl) {
  this.listBoxControl = listBoxControl;
  this.startPos = 0;
 },
 SerializeItems: function(items){
  var sb = [ ];
  for(var i = 0; i < items.length; i++)
   this.SerializeItem(sb, items[i]);
  return sb.join("");
 },
 SerializeItem: function(sb, item) {
  if(!item)
   return;
  this.SerializeAtomValue(sb, item.index);
  this.SerializeAtomValue(sb, item.value);
  this.SerializeAtomValue(sb, item.imageUrl);
  var texts = this.listBoxControl.GetItemTexts(item);
  if(typeof(texts) == "string")
   this.SerializeAtomValue(sb, texts);
  else {
   for(var i = 0; i < texts.length; i++)
    this.SerializeAtomValue(sb, texts[i]);
  }
 },
 SerializeAtomValue: function(sb, value) {
  var valueStr = ASPx.IsExists(value) ? value.toString() : "";
  sb.push(valueStr.length);
  sb.push('|');
  sb.push(valueStr);
 },
 ParseItemIndex: function(serializedItem){
  return parseInt(this.ParseString(serializedItem));
 },
 ParseItemValue: function(serializedItem){
  return this.ParseString(serializedItem);
 },
 ParseString: function(str){
  var indexOfSeparator = str.indexOf(serializingSeparator, this.startPos);
  var strLength = parseInt(str.substring(this.startPos, indexOfSeparator));
  var strStartPos = indexOfSeparator + serializingSeparatorLength;
  this.startPos = strStartPos + strLength;
  return str.substring(strStartPos, strStartPos + strLength);
 },
 ParseTexts: function(serializedItems){
  return this.ParseString(serializedItems);
 },
 DeserializeValues: function(serializedValues){
  var deserializedValues = [];
  this.startPos = 0;
  while(this.startPos < serializedValues.length){
   deserializedValues.push(this.ParseItemValue(serializedValues));
  }
  return deserializedValues;
 }
});
var ListBoxItemsSerializingHelper = ASPx.CreateClass(ListBoxBaseItemsSerializingHelper, {
 constructor: function(listBoxControl) {
  this.constructor.prototype.constructor.call(this, listBoxControl);
 },
 ParseTexts: function(serializedItems){
  var textColumnCount = this.listBoxControl.GetItemTextCellCount();
  return (textColumnCount > 1) ? this.DeserializeItemTexts(serializedItems, textColumnCount) 
   : ListBoxBaseItemsSerializingHelper.prototype.ParseTexts.call(this, serializedItems);
 },
 DeserializeItemTexts: function(serializedItem, textColumnCount){
  var texts = [];
  for(var i = 0; i < textColumnCount; i++)
   texts.push(this.ParseString(serializedItem));
  return texts;
 }
});
var ListBoxSingleSelectionHelper = ASPx.CreateClass(null, {
 constructor: function(listBoxControl) {
  this.listBoxControl = listBoxControl;
  this.savedSelectedIndex = listBoxControl.savedSelectedIndex;
  this.updateHiddenInputsLockCount = 0;
  this.cachedSelectionChangedArgs = [];
 },
 ClearSelection: function(){
  this.SetSelectedIndexCore(-1);
  this.OnSelectionCleared();
 },
 OnSelectionCleared: function(){
  this.cachedSelectionChangedArgs = [];
 },
 GetSelectedIndexInternal: function(){
  return this.savedSelectedIndex;
 }, 
 SetSelectedIndexInternal: function(index){
  this.savedSelectedIndex = index;
 }, 
 SetSelectedIndexCore: function(index){
  if(index != this.savedSelectedIndex && -1 <= index && index < this.GetItemCount()){
   this.BeginSelectionUpdate();
   this.SetSelectedIndexInternal(index);
   this.EndSelectionUpdate();
   return true;
  }
  return false;
 },
 GetSelectedIndex: function(){
  return this.GetSelectedIndexInternal();
 },
 SetSelectedIndex: function(index){
  this.ChangeSelectedItem(index);
  this.SetSelectedIndexCore(index);
  this.OnItemSelectionChanged(index, true);
 },
 GetSelectedIndices: function(){ 
  var selectedIndex = this.GetSelectedIndexInternal();
  return selectedIndex != -1 ? [selectedIndex] : [];
 },
 GetSelectedValues: function(){ 
  var selectedValue =  this.listBoxControl.GetValue();
  return selectedValue != null ? [selectedValue] : [];
 },
 GetSelectedItems: function(){ 
  var selectedItem = this.listBoxControl.GetSelectedItem();
  return selectedItem != null? [selectedItem] : [];
 },
 SelectIndices: function(indices){},
 SelectItems: function(items){},
 SelectValues: function(values){},
 UnselectIndices: function (selected) { this.SetSelectedIndex(-1); },
 UnselectItems: function(items){},
 UnselectValues: function(values){},
 GetIsItemSelected: function(index){ return index == this.GetSelectedIndexInternal(); },
 ResetSelectionCollectionsCache: function(){ },
 OnItemClick: function(index, evt){
  var selected = true;
  this.BeginSelectionUpdate();
  this.ChangeSelectedItem(index);
  var selectedIndexChanged = this.SetSelectedIndexCore(index);
  this.EndSelectionUpdate();
  if(selectedIndexChanged)
   this.OnItemSelectionChanged(index, selected);
 },
 ChangeSelectedItem: function(newSelectedIndex){
  var selected = true;
  var oldSelectedIndex = this.GetSelectedIndexInternal();
  this.BeginSelectionUpdate();
  this.SetItemSelectionState(oldSelectedIndex, !selected);
  this.SetItemSelectionState(newSelectedIndex, selected);
  this.EndSelectionUpdate();
 },
 SetItemSelectionState: function (itemIndex, selected, controller) {
  this.BeginSelectionUpdate();
  this.listBoxControl.SetItemSelectionAppearance(itemIndex, selected, controller, true);
  this.EndSelectionUpdate();
 },
 GetFocusedIndex: function(){
  return this.GetSelectedIndexInternal();
 },
 BeginSelectionUpdate: function(){
  this.updateHiddenInputsLockCount++;
 },
 EndSelectionUpdate: function(){
  this.updateHiddenInputsLockCount--;
  if(!this.IsUpdateInternalSelectionStateLocked()){
   this.listBoxControl.UpdateInternalState();
   this.FlushSelectionChanged();
  }
 },
 IsUpdateInternalSelectionStateLocked: function(){
  return this.updateHiddenInputsLockCount > 0;
 },
 GetItemCount: function(){
  return this.listBoxControl.GetItemCount();
 },
 OnItemSelectionChanged: function(index, selected){
  if(this.IsUpdateInternalSelectionStateLocked()){
   var a = {Index: index, Selected: selected};
   this.cachedSelectionChangedArgs.push(a);
  }
  else 
   this.listBoxControl.OnItemSelectionChanged(index, selected);
 },
 FlushSelectionChanged: function(){
  if(this.IsUpdateInternalSelectionStateLocked()) 
   return;
  for(var i = 0; i < this.cachedSelectionChangedArgs.length; i++)
   this.listBoxControl.OnItemSelectionChanged(this.cachedSelectionChangedArgs[i].Index, this.cachedSelectionChangedArgs[i].Selected);
  this.cachedSelectionChangedArgs = [];
 },
 OnItemInserted: function(index){
  if(index <= this.savedSelectedIndex && this.savedSelectedIndex != -1)
   this.SetSelectedIndexInternal(this.savedSelectedIndex + 1);
 },
 OnItemRemoved: function(index){
  if(index < this.savedSelectedIndex)
   this.SetSelectedIndexInternal( this.savedSelectedIndex - 1);
  else if(index == this.savedSelectedIndex)
   this.SetSelectedIndexInternal(-1);
 },
 OnItemsCleared: function(){
  this.ClearSelection();
 }
});
var ListBoxMultiSelectionHelper = ASPx.CreateClass(ListBoxSingleSelectionHelper, {
 constructor: function(listBoxControl) {
  this.constructor.prototype.constructor.call(this, listBoxControl);
  this.selectedValuesCache = [];
  this.selectedItemsCache = [];
  this.savedSelectedIndices = [];
  this.selectedIndicesSortingRequired = false;
  this.focusedIndex = -1;
  this.lastIndexFocusedWithoutShift = -1;
 },
 SetSelectedIndex: function(index){
  this.SingleIndexSelection(index);
 },
 SetSelectedIndexCore: function(index){
  ListBoxSingleSelectionHelper.prototype.SetSelectedIndexCore.call(this, index);
  this.updateSelectAllElementsState();
 },
 updateSelectAllElementsState: function() {
  this.listBoxControl.updateSelectAllElementsState();
 },
 ResetSelectionCollectionsCache: function(){
  this.selectedIndicesSortingRequired = true;
  this.selectedItemsCache = [];
  this.selectedValuesCache = [];
 },
 GetSelectedIndices: function(){
  return this.GetSortedSelectedIndices().slice();
 },
 GetSortedSelectedIndices: function() {
  if(this.savedSelectedIndices.length > 1 && this.selectedIndicesSortingRequired)
   this.SortSelectedIndices();
  return this.savedSelectedIndices;
 },
 GetSelectedValues: function(){ 
  if(this.savedSelectedIndices.length == 0)
   return [];
  if(this.selectedValuesCache.length == 0)
   this.selectedValuesCache = this.GetSelectedValuesCore();
  return this.selectedValuesCache;
 },
 GetSelectedValuesCore: function(){
  var selectedValues = [];
  var selectedIndices = this.GetSortedSelectedIndices();
  if(selectedIndices.length == 0)
   return selectedValues;
  for(var i = 0; i < selectedIndices.length; i++)
   selectedValues.push(this.listBoxControl.GetItemValue([selectedIndices[i]]));
  return selectedValues;
 },
 GetSelectedItems: function(){
  if(this.savedSelectedIndices.length == 0)
   return [];
  if(this.selectedItemsCache.length == 0)
   this.selectedItemsCache = this.GetSelectedItemsCore();
  return this.selectedItemsCache;
 },
 GetSelectedItemsCore: function(){
  var selectedItems = [];
  for(var i = 0; i < this.savedSelectedIndices.length; i++)
   selectedItems.push(this.listBoxControl.GetItem(this.savedSelectedIndices[i]));
  return selectedItems;
 },
 SetIndicesSelectionState: function(indices, selected){
  this.BeginSelectionUpdate();
  var controller = typeof(ASPx.GetStateController) != "undefined" ? ASPx.GetStateController() : null;
  this.LockForceRedrawAppearance(controller);
  if(indices){
   var itemCount = this.listBoxControl.GetItemCount();
   for(var i = 0; i < indices.length; i++) {
    var index = indices[i];
    if(index >= 0 && index < itemCount)
     this.SetItemSelectionState(indices[i], selected, controller);
   }
  } else if(this.IsClientFilterApplied())
   this.SetAllFilteredItemsSelectionState(selected, controller);
  else
   this.SetAllItemsSelectionState(selected, controller);
  this.UnlockForceRedrawAppearance(controller);
  this.SetSelectedIndexCore(this.GetFirstSelectedIndex());
  this.EndSelectionUpdate();
 },
 IsClientFilterApplied: function() {
  return this.listBoxControl.IsClientFilterApplied();
 },
 SetAllFilteredItemsSelectionState: function (selected, controller) {
  for (var i = 0; i < this.listBoxControl.GetItemCount() ; i++) {
   if (this.listBoxControl.IsItemFiltered && !this.listBoxControl.IsItemFiltered(i))
    continue;
   this.SetItemSelectionState(i, selected, controller);
  }
 },
 SetItemsSelectionState: function(items, selected){
  var indices = items ? this.ConvertItemsToIndices(items) : null;
  this.SetIndicesSelectionState(indices, selected);
 },
 SetValuesSelectionState: function(values, selected){
  var indices = values ? this.ConvertValuesToIndices(values)  : null;
  this.SetIndicesSelectionState(indices, selected);
 },
 ConvertValuesToIndices: function(values){
  var indices = [];
  for(var i = 0; i < values.length; i++)
   indices.push(this.listBoxControl.FindItemIndexByValue(values[i]));
  return indices;
 },
 ConvertItemsToIndices: function(items){
  var indices = [];
  for(var i = 0; i < items.length; i++)
   indices.push(items[i].index);
  return indices;
 },
 SelectIndices: function(indices){
  this.SetIndicesSelectionState(indices, true);
 },
 SelectItems: function(items){
  this.SetItemsSelectionState(items, true);
 },
 SelectValues: function(values){
  this.SetValuesSelectionState(values, true);
 },
 UnselectIndices: function(indices){
  this.SetIndicesSelectionState(indices, false);
 },
 UnselectItems: function(items){
  this.SetItemsSelectionState(items, false);
 },
 UnselectValues: function(values){
  this.SetValuesSelectionState(values, false);  
 },
 GetIsItemSelected: function(index){ 
  return ASPx.Data.ArrayBinarySearch(this.GetSortedSelectedIndices(), index) > -1;
 },
 OnItemClick: function(index, evt){
  this.BeginSelectionUpdate();
  var ctrlKey = evt.ctrlKey || evt.metaKey;
  var shift = evt.shiftKey;
  if(ctrlKey)
   this.AddSelectedIndex(index);
  else if(shift){
   var startIndex = index > this.lastIndexFocusedWithoutShift ? this.lastIndexFocusedWithoutShift + 1 : index;
   var endIndex = index > this.lastIndexFocusedWithoutShift ? index : this.lastIndexFocusedWithoutShift - 1;
   this.SelectRangeIndicesOnly(startIndex, endIndex);
   this.SetFocusedIndexInternal(index, true);
  }else 
   this.SingleIndexSelection(index);
  this.EndSelectionUpdate();
 },
 OnItemCheckBoxClick: function(index, evt){
  this.BeginSelectionUpdate();
  this.AddSelectedIndex(index);
  this.EndSelectionUpdate();
 },
 AddSelectedIndex: function(index){
  this.SetFocusedIndexInternal(index, false);
  var indexInSelectedIndices = ASPx.Data.ArrayIndexOf(this.savedSelectedIndices, index);
  var selectionOperation = indexInSelectedIndices == -1;
  this.SetItemSelectionState(index, selectionOperation);
  this.SetSelectedIndexCore(this.GetFirstSelectedIndex());
 },
 SelectRangeIndicesOnly: function(startIndex, endIndex){
  this.BeginSelectionUpdate();
  var controller = typeof(ASPx.GetStateController) != "undefined" ? ASPx.GetStateController() : null;
  if(startIndex < endIndex)
   this.LockForceRedrawAppearance(controller);
  var itemCount = this.GetItemCount();
  for(var i = 0; i < itemCount; i ++) {
   if(i == this.lastIndexFocusedWithoutShift) 
    continue;
   if(startIndex !== endIndex && this.listBoxControl.IsItemFiltered && !this.listBoxControl.IsItemFiltered(i))
    continue;
   this.SetItemSelectionState(i, i >= startIndex && i <= endIndex, controller);
  }
  this.SetSelectedIndexCore(this.GetFirstSelectedIndex());
  if(startIndex < endIndex)
   this.UnlockForceRedrawAppearance(controller);
  this.EndSelectionUpdate();
 },
 SingleIndexSelection: function(index){
  this.SetFocusedIndexInternal(-1, false);
  this.SelectRangeIndicesOnly(index, index);
  this.SetFocusedIndexInternal(index, false);
 },
 LockForceRedrawAppearance: function(controller) {
   if(controller && ASPx.Browser.IE && ASPx.Browser.MajorVersion >= 11)
   controller.LockForceRedrawAppearance();
 },
 UnlockForceRedrawAppearance: function(controller) {
  if(controller && ASPx.Browser.IE && ASPx.Browser.MajorVersion >= 11)
   controller.UnlockForceRedrawAppearance();
 },
 SetAllItemsSelectionState: function(selected, controller){
  this.BeginSelectionUpdate();
  this.savedSelectedIndices = [ ];
  var itemCount = this.GetItemCount();
  for (var i = 0; i < itemCount; i++) {
   this.SetItemSelectionStateCore(i, selected, controller);
   if(selected)
    this.PushSelectedIndex(i);
   this.OnItemSelectionChanged(i, selected);
  }
  this.ResetSelectionCollectionsCache();
  this.EndSelectionUpdate();
 },
 SetItemSelectionState: function(itemIndex, selected, controller){
  this.SetItemSelectionStateCore(itemIndex, selected, controller);
  this.ResetSelectionCollectionsCache();
  var indexInSelectionArray = this.savedSelectedIndices.indexOf(itemIndex);
  if(selected && indexInSelectionArray == -1){
   this.PushSelectedIndex(itemIndex);
   this.OnItemSelectionChanged(itemIndex, true);
  }
  if(!selected && indexInSelectionArray != -1){
   this.RemoveSelectedIndexAt(indexInSelectionArray);
   this.OnItemSelectionChanged(itemIndex, false);
  }
 },
 GetFirstSelectedIndex: function(){
  var selectedIndices = this.GetSelectedIndices();
  var selectedIndicesCount = selectedIndices.length;
  var firstSelectedIndex = -1;
  if(selectedIndicesCount > 0){
   firstSelectedIndex = selectedIndices[0];
   for(var i = 1; i < selectedIndices.length; i++){
    if(firstSelectedIndex > selectedIndices[i])
     firstSelectedIndex = selectedIndices[i];
   }
  }
  return firstSelectedIndex;
 },
 PushSelectedIndex: function(index){
  this.savedSelectedIndices.push(index);
 },
 RemoveSelectedIndex: function(index){
  ASPx.Data.ArrayRemove(this.savedSelectedIndices, index);
 },
 RemoveSelectedIndexAt: function(indexInArray){
  ASPx.Data.ArrayRemoveAt(this.savedSelectedIndices, indexInArray);
 },
 SortSelectedIndices: function(){
  ASPx.Data.ArrayIntegerAscendingSort(this.savedSelectedIndices);
  this.selectedIndicesSortingRequired = false;
 },
 SetItemSelectionStateCore: function(itemIndex, selected, controller){
  ListBoxSingleSelectionHelper.prototype.SetItemSelectionState.call(this, itemIndex, selected, controller);
 },
 GetFocusedIndex: function(){
  return this.focusedIndex;
 },
 SetFocusedIndexInternal: function(index, isShiftPressed){
  if(!isShiftPressed)
   this.lastIndexFocusedWithoutShift = index;
  this.focusedIndex = index;
 },
 OnItemInserted: function(index){
  this.ResetSelectionCollectionsCache();
  ListBoxSingleSelectionHelper.prototype.OnItemInserted.call(this, index);
  if(this.focusedIndex >= index)
   this.focusedIndex ++;
  for(var i = 0; i < this.savedSelectedIndices.length; i++){
   if(this.savedSelectedIndices[i] >= index)
    this.savedSelectedIndices[i]++;
  }
  this.updateSelectAllElementsState();
 },
 OnItemRemoved: function(index){
  this.ResetSelectionCollectionsCache();
  ListBoxSingleSelectionHelper.prototype.OnItemRemoved.call(this, index);
  if(this.focusedIndex == index)
   this.focusedIndex = -1;
  else if(this.focusedIndex > index)
   this.focusedIndex --;
  if(this.GetIsItemSelected(index))
   this.RemoveSelectedIndex(index);
  for(var i = 0; i < this.savedSelectedIndices.length; i++){
   if(this.savedSelectedIndices[i] > index)
    this.savedSelectedIndices[i]--;
  }
  if(this.GetSelectedIndex() == -1)
   this.SetSelectedIndexCore(this.GetFirstSelectedIndex());
  this.updateSelectAllElementsState();
 },
 ClearSelection: function(){
  this.ResetSelectionCollectionsCache();
  ASPx.Data.ArrayClear(this.savedSelectedIndices);
  this.OnSelectionCleared();
  this.SetSelectedIndexCore(-1);
 }
});
var CheckBoxListMultiSelectionHelper = ASPx.CreateClass(ListBoxMultiSelectionHelper, {
 OnItemClick: function(index){
  this.BeginSelectionUpdate();
  this.AddSelectedIndex(index);
  this.EndSelectionUpdate();
 },
 GetFocusedItemIndex: function(){
  return this.lastIndexFocusedWithoutShift;
 },
 updateSelectAllElementsState: function () { },
 IsClientFilterApplied: function() { return false; }
});
var ListBoxCheckSelectionHelper = ASPx.CreateClass(ListBoxMultiSelectionHelper, {
 OnItemClick: function(index, evt){
  this.BeginSelectionUpdate();
  if(evt.shiftKey)
   ListBoxMultiSelectionHelper.prototype.OnItemClick.call(this, index, evt);
  else
   this.AddSelectedIndex(index);
  this.EndSelectionUpdate();
 }
});
var ASPxClientListBox = ASPx.CreateClass(ASPxClientListBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.freeUniqIndex = -1;
  this.isHasFakeRow = false;
  this.headerDiv = null;
  this.headerTable = null;
  this.listTable = null;
  this.sampleItemFirstTextCell = null;
  this.width = "";
  this.defaultHeight = "";
  this.hasSampleItem = false;
  this.hoverClasses = [""];
  this.hoverCssArray = [""];
  this.selectAllHoverClasses = [""];
  this.selectAllHoverCssArray = [""];
  this.selectAllDisabledClasses = [""];
  this.selectAllDisabledCssArray = [""];
  this.selectedClasses = [""];
  this.selectedCssArray = [""];
  this.disabledClasses = [""];
  this.disabledCssArray = [""];
  this.imageCellExists = false;
  this.scrollHandlerLockCount = 0;
  this.columnFieldNames = [];
  this.textFormatString = "";
  this.nullValueItemDisplayText = null;
  this.defaultImageUrl = "";
  this.selectionMode = 0;
  this.initSelectedIndices = [];
  this.itemHorizontalAlign = "";
  this.emptyTextRowCellIndices = null;
  this.accessibilityHelper = null;
  this.accessibilityHelperID = "";
  this.allowMultipleCallbacks = false;
  this.isCallbackMode = false;
  this.callbackPageSize = -1;
  this.isTopSpacerVisible = false;
  this.isBottomSpacerVisible = false;
  this.serverIndexOfFirstItem = 0;
  this.scrollHelper = null;
  this.changeSelectAfterCallback = 0;
  this.ownerControl = null;
  this.SampleItem = null;
  this.sampleHeaderRow = null;
  this.scrollDivElement = null;
  this.scrollPageSize = 4;
  this.itemsValue = [];
  this.cachedValue = null;
  this.tempCache = new ListBoxTemporaryCache();
  this.sizingConfig.adjustControl = true;
  this.disableScrolling = false;
  this.icbFocusedStyle = null;
  this.icbImageProperties = null;
  this.internalCheckBoxCollection = null;
  this.focusableCheckInput = null;
  this.nativeCheckOnFocusHandler = null;
  this.enableSelectAll = false;
  this.enableFiltering = false;
  this.filteringDelay = 100;
  this.filterMinLength = 1;
  this.filterTimerID = -1;
  this.customFilteringEditorID = "";
  this.filteringTextBox = null;
  this.filteringTextBoxInput = null;
  this.showFilterButtonInput = null;
  this.highlighting = this.CreateHighlightingHelper();
  this.hasDecoratedItems = false;
  this.scrollDivMinWidth = 0;
  this.ItemFiltering = new ASPxClientEvent();
  this.CustomHighlighting = new ASPxClientEvent();
 },
 Initialize: function() {   
  this.LockScrollHandler();
  this.InitScrollPos();
  if((ASPx.Browser.WebKitTouchUI || (ASPx.Browser.WindowsPhonePlatform && ASPx.Browser.IE)) && !this.disableScrolling)
   ASPx.TouchUIHelper.MakeScrollable(this.GetScrollDivElement(), {showHorizontalScrollbar: false});
  this.CreateInternalCheckBoxCollection();
  this.InitSelection();
  if(!this.isComboBoxList && this.ResetItemHeightIfRequired())
   this.AdjustControlCore();
  this.InitializeLoadOnDemand();
  this.UnlockScrollHandler();
  if(!this.HasVirtualScrolling())
   this.freeUniqIndex = this.GetItemCount();
  ASPxClientEdit.prototype.Initialize.call(this);
  if(this.NeedUnfocusableScrollDivElement())
   ASPx.Attr.SetAttribute(this.GetScrollDivElement(), "tabIndex", "-1");
  this.EnsureFilteringElements();
 },
 InitDXTextAttributes: function(){
  if(this.emptyTextRowCellIndices != null){
   var itemWithDXTextCount = this.emptyTextRowCellIndices.length;
   for(var i = 0; i < itemWithDXTextCount; i++){
    var itemIndex = this.emptyTextRowCellIndices[i][0];
    var cellIndices = this.emptyTextRowCellIndices[i][1];
    var itemRow = this.GetItemRow(itemIndex);
    if(!itemRow) continue;
    for(var j = 0; j < cellIndices.length; j++){
     ASPx.Attr.SetAttribute(itemRow.cells[cellIndices[j]], "DXText", "");
    }
   }
  }
 },
 InitSelection: function(){
  var valueFromLastTime = this.GetValueFromValueInput();
  if(this.MultiSelectionMode()){
   if(valueFromLastTime != ""){
    var serialiser = this.GetSerializingHelper();
    var selectedValuesFromLastTime = serialiser.DeserializeValues(valueFromLastTime);
    var selectedIdicesFromLastTime = [];
    for(var i = 0; i < selectedValuesFromLastTime.length; i++)
     selectedIdicesFromLastTime.push(this.FindItemIndexByValue(selectedValuesFromLastTime[i]));
    this.SelectIndices(selectedIdicesFromLastTime);
   } else
    this.SelectIndices(this.initSelectedIndices);
  } else {
   var selectedIndex = (valueFromLastTime != "") ? 
    this.FindItemIndexByValue(valueFromLastTime) : this.GetSelectedIndexInternal();
   this.SetSelectedIndexInternal(selectedIndex);
   this.SelectIndexSilent(selectedIndex);
   this.GetItemSelectionHelper().SetSelectedIndexInternal(selectedIndex);
  }
  this.CacheValue();
 },
 BeginUpdate: function() {
  ASPxClientListBoxBase.prototype.BeginUpdate.call(this);
  if(this.isInitialized)
   this.itemsManager.BeginUpdate();
 },
 EndUpdate: function() {
  ASPxClientListBoxBase.prototype.EndUpdate.call(this);
  if(this.isInitialized)
   this.itemsManager.EndUpdate();
 },
 GetShowFilterButton: function() {
  return ASPx.GetControlCollection().Get(this.name + "_" + showFilterButtonID);
 },
 GetAccessibilityHelper: function() {
  var result = null;
  if(this.accessibilityCompliant) {
   if(!this.accessibilityHelper) {
    this.accessibilityHelper = new AccessibilityHelperListBox(this);
   }
   result = this.accessibilityHelper;
  }
  return result;
 },
 CreateHighlightingHelper: function() {
  return new ASPx.ListBoxHighlightingHelper(this, "em");
 },
 CreateInternalCheckBoxCollection: function() {
  if(this.IsNativeCheckBoxes() || this.internalCheckBoxCollection)
   return;
  this.internalCheckBoxCollection = new ASPx.CheckBoxInternalCollection(this.icbImageProperties, false, false, null, true, this.accessibilityCompliant);
  this.itemsManager.InitializeInternalCheckBoxCollection();
 },
 AddInternalCheckBoxToCollection: function(index) {
  if(!this.internalCheckBoxCollection)
   return;
  var enabled = this.GetEnabled();
  var changeEventMethod = ASPx.Attr.ChangeEventsMethod(enabled);
  this.AddInternalCheckBoxToCollectionCore(index, enabled, changeEventMethod);
 },
 AddInternalCheckBoxToCollectionCore: function(index, enabled, changeEventMethod) {
  var inputElement = this.GetItemCheckBoxInput(index);
  if(inputElement) {
   var internalCheckBox = this.internalCheckBoxCollection.Add(this.GetInternalCheckBoxKey(index), inputElement);
   internalCheckBox.CreateFocusDecoration(this.icbFocusedStyle);
   internalCheckBox.SetEnabled(enabled);
   internalCheckBox.autoSwitchEnabled = false;
   var checkBoxFocusableElement = this.GetCheckBoxFocusableElement(index);
   this.ChangeSpecialInputEnabledAttributes(checkBoxFocusableElement, changeEventMethod, true);
   if(this.accessibilityCompliant) {
    this.SetupCheckBoxAccessibilityAttributes(checkBoxFocusableElement, index);
   }
   internalCheckBox.CheckedChanged.AddHandler(
    function(s, e) {
     if(ASPx.Evt.GetKeyCode(e) == ASPx.Key.Space) {
      var element = ASPx.Evt.GetEventSource(e);
      this.GetItemSelectionHelper().OnItemCheckBoxClick(this.FindInternalCheckBoxIndex(element), e);
     }
    }.aspxBind(this)
   );
   internalCheckBox.Focus.AddHandler(
    function(s, e) {
     var index = this.FindInternalCheckBoxIndex(s.mainElement);
     window.setTimeout(function() { this.ScrollToItemVisible(index); }.aspxBind(this), 50);
    }.aspxBind(this)
   );
  }
 },
 SetupCheckBoxAccessibilityAttributes: function(checkBox, index) {
  if(index !== -1) { 
   ASPx.Attr.SetAttribute(checkBox, "aria-label", this.GetAccessibilityHelper().getTextForScreenReader(this.GetItem(index)));
  }
 },
 ClearInternalCheckBoxCollection: function() {
  if(this.internalCheckBoxCollection)
   this.internalCheckBoxCollection.Clear();
 },
 RemoveInternalCheckBoxFromCollecntion: function(index) {
  if(this.internalCheckBoxCollection)
   this.internalCheckBoxCollection.Remove(this.GetItemValue(index));
 },
 GetInternalCheckBoxKey: function(index) {
  return this.name + nameSeparator + this.GetItemValue(index);
 },
 GetInternalCheckBox: function (index) {
  if(this.internalCheckBoxCollection == null)
   this.CreateInternalCheckBoxCollection();
  if(this.internalCheckBoxCollection)
   return this.internalCheckBoxCollection.Get(this.GetInternalCheckBoxKey(index));
  return null;
 },
 IsNativeCheckBoxes: function() {
  return !this.icbImageProperties;
 },
 SetCheckBoxChecked: function(index, checked) {
  var checkBox = this.IsNativeCheckBoxes() ? this.GetItemCheckBoxInput(index) : this.GetInternalCheckBox(index);
  if(checkBox)
   this.SetCheckBoxCheckedCore(checkBox, checked);
  if(this.accessibilityCompliant) {
   setTimeout(function() { this.GetAccessibilityHelper().SetCheckBoxesValidationAttributes(); }.bind(this), 0);
  }
 },
 SetCheckBoxCheckedCore: function (checkBox, checked) {
  if(this.IsNativeCheckBoxes())
   checkBox.checked = checked;
  else
   checkBox.SetValue(checked ? ASPx.CheckBoxInputKey.Checked : ASPx.CheckBoxInputKey.Unchecked);
 },
 SetCheckBoxEnabled: function (index, enabled) {
  var checkBox = this.IsNativeCheckBoxes() ? this.GetItemCheckBoxInput(index) : this.GetInternalCheckBox(index);
  if (checkBox)
   this.SetCheckBoxEnabledCore(checkBox, enabled);
 },
 SetCheckBoxEnabledCore: function (checkbox, enabled) {
  if (this.IsNativeCheckBoxes()) {
   checkbox.disabled = !enabled;
   this.ChangeNativeCheckEnabledAttributes(checkbox, ASPx.Attr.ChangeEventsMethod(this.GetEnabled()));
  }
  else
   checkbox.SetEnabled(enabled);
  this.ChangeSpecialInputEnabledAttributes(this.IsNativeCheckBoxes() ?
   checkbox : checkbox.inputElement, ASPx.Attr.ChangeEventsMethod(enabled));
 },
 ClearItems: function() {
  ASPxClientListBoxBase.prototype.ClearItems.call(this);
  this.ClearInternalCheckBoxCollection();
  this.freeUniqIndex = this.GetItemCount();
 },
 OnDelayedSpecialFocusMouseDown: function (evt) {
  if(this.filteringTextBox) {
   var isEventFromFilteringTextBox = ASPx.Evt.GetEventSource(evt) == this.filteringTextBox.GetInputElement();
   this.filteringTextBoxInput = isEventFromFilteringTextBox ? this.filteringTextBox.GetInputElement() : null;
  }
  if(this.showFilterButton) {
   var isEventFromShowFilterButton = ASPx.GetIsParent(this.showFilterButton.GetMainElement(), ASPx.Evt.GetEventSource(evt));
   this.showFilterButtonInput = isEventFromShowFilterButton ? this.showFilterButton.GetInternalButton() : null;
   this.isFilterEditorShowing = isEventFromShowFilterButton;
  }
  if(this.GetIsCheckColumnExists())
   this.SetFocusableCheckInput(this.GetCheckBoxInputFromEvent(evt));
  ASPxClientListBoxBase.prototype.OnDelayedSpecialFocusMouseDown.call(this, evt);
  var shiftPressed = evt.shiftKey;
  var ctrlKey = evt.ctrlKey || evt.metaKey;
  if(shiftPressed || ctrlKey){
   ASPx.Selection.Clear();
   if(ASPx.Browser.IE)
    ASPx.Evt.PreventEventAndBubble(evt);
  }
 },
 GetCheckBoxInputFromEvent: function(evt) {
  var element = ASPx.Evt.GetEventSource(evt);
  if(this.IsNativeCheckBoxes())
   return element.type == "checkbox" ? element : null;
  var index = this.FindInternalCheckBoxIndex(element);
  if(index > -1)
   return this.GetCheckBoxFocusableElement(index);
  else if(this.IsSelectAllCheckBoxClicked(element))
   return this.GetSelectAllCheckBoxFocusableElement();
  return null;
 },
 IsSelectAllCheckBoxClicked: function(eventSource) {
  return this.selectAllCheckBox && ASPx.GetIsParent(this.selectAllCheckBox.container, eventSource)
   && (eventSource == this.selectAllCheckBox.mainElement || eventSource.tagName == "LABEL");
 },
 IsNativeSelectAllCheckBoxClicked: function (eventSource) {
  return this.nativeSelectAllCheckBox && ASPx.GetIsParent(this.nativeSelectAllCheckBox, eventSource);
 },
 GetSelectAllClickableElement: function() {
  return this.IsMultiColumn() ? this.selectAllMainElement.parentNode : this.selectAllMainElement;
 },
 GetSelectAllCheckBoxFocusableElement: function() {
  return this.accessibilityCompliant ? this.selectAllCheckBox.mainElement : this.selectAllCheckBox.inputElement;
 },
 GetCheckBoxFocusableElement: function(index) {
  var internalCheckBox = this.GetInternalCheckBox(index);
  if(!internalCheckBox)
   return null;
  return this.accessibilityCompliant ? internalCheckBox.mainElement : internalCheckBox.inputElement;
 },
 FindInternalCheckBoxIndex: function(element) {
  var level = 5;
  while(level > 0) {
   var id = element.id;
   if(id && element.tagName == "TD" && id.slice(-1) == lbIPostfixes[0])
    return this.GetItemIndexByRow(element.parentNode);
   element = element.parentNode;
   level--;
  }
  return -1;
 },
 IsCheckBoxClicked: function(evt) {
  return !!this.GetCheckBoxInputFromEvent(evt);
 },
 GetFocusableInputElement: function() {
  return this.showFilterButtonInput || this.filteringTextBoxInput || this.focusableCheckInput || this.GetInputElement();
 },
 IsElementBelongToInputElement: function (element) {
  return ASPxClientEdit.prototype.IsElementBelongToInputElement.call(this, element)
  || this.filteringTextBox && this.filteringTextBox.ownerListBox == this && this.filteringTextBox.IsElementBelongToInputElement(element);
 },
 SetFocusableCheckInput: function(element) {
  this.focusableCheckInput = element;
 },
 OnFocusCore: function() {
  if(this.UseDelayedSpecialFocus())
   this.specialFocusTimer = ASPx.Timer.ClearTimer(this.specialFocusTimer);
  if(this.focused)
   this.UnlockFocusEvents();
  else
   ASPxClientListBoxBase.prototype.OnFocusCore.call(this);
 },
 OnLostFocusCore: function() {
  if(!this.IsFocusEventsLocked()) { 
   this.SetFocusableCheckInput(null);
   this.filteringTextBoxInput = null;
   this.showFilterButtonInput = null;
  }
  ASPxClientListBoxBase.prototype.OnLostFocusCore.call(this);
 },
 IsFocusEventsLocked: function() {
  var result = ASPxClientEdit.prototype.IsFocusEventsLocked.call(this) ||
      this.IsInternalFilteringTextBoxFocusEventsLocked() ||
      this.isFilterEditorShowing;
  if(this.accessibilityCompliant)
   result = this.focused && (result || this.HasInternalFilteringTextBoxFocus());
  return result;
 },
 HasInternalFilteringTextBoxFocus: function() {
  return !this.customFilteringEditorID && this.filteringTextBox && ASPx.GetIsParent(this.filteringTextBox.GetMainElement(), ASPx.GetActiveElement());
 },
 IsInternalFilteringTextBoxFocusEventsLocked: function() {
  return !this.customFilteringEditorID && this.filteringTextBox && this.filteringTextBox.IsFocusEventsLocked();
 },
 ForceLockFocusEvents: function() {
  this.focusEventsLocked = true;
 },
 GetValueFromValueInput: function(){
  var valueInput = this.FindStateInputElement();
  if(ASPx.IsExistsElement(valueInput))
   return valueInput.value;
  return "";
 },
 NeedUnfocusableScrollDivElement: function() {
  return ASPx.Browser.Firefox;
 },
 GetInitSelectedIndex: function(){
  return this.savedSelectedIndex;
 },
 CacheValue: function(){
  this.cachedValue = this.GetValue();
 },
 InitScrollPos: function(){ 
  if(!this.isComboBoxList && this.isCallbackMode && this.GetInitSelectedIndex() == -1)
   this.GetScrollDivElement().scrollTop = 0;
 },
 InitializeLoadOnDemand: function(){
  var loadOnDemandRequired = this.isCallbackMode && this.GetEnabledByServer();
  this.scrollHelper = this.CreateScrollHelper(loadOnDemandRequired);
 },
 CreateScrollHelper: function (loadOnDemandRequired) {
  if (loadOnDemandRequired)
   return new ListBoxScrollCallbackHelper(this);
  return new ListBoxScrollCallbackHelperBase(this);
 },
 HasVirtualScrolling: function() { return !!this.itemsInfo || this.itemsManager instanceof ListBoxItemsVirtualManager; },
 CreateItemsManager: function() {
  if (this.HasVirtualScrolling()) {
   var manager = new ListBoxItemsVirtualManager(this);
   manager.InitializeItems(this.itemsInfo, this.itemsValue);
   delete this.itemsInfo;
   return manager;
  }
  return new ListBoxItemsDefaultManager(this);
 },
 InlineInitialize: function(){
  if(this.HasVirtualScrolling())
   this.freeUniqIndex = 0;
  this.itemsManager = this.CreateItemsManager();
  this.filterStrategy = this.isComboBoxList ? null : this.CreateFilterStrategy();
  this.EnsureFixWidthRow();
  this.InitializeNativeCheckHandlers();
  this.LockScrollHandler();
  this.InitializeItemsAttributes();
  this.InitDXTextAttributes();
  this.itemsManager.Initialize();
  this.AddSelectAllStateItems(true);
  this.UnlockScrollHandler();
  if(this.NeedToHandleCellWidth()) {
   var headerTable = this.GetHeaderTableElement();
   var firstHeaderRow = !!headerTable && headerTable.rows[0];
   this.CorrectCellNullWidthStyle(firstHeaderRow);
   this.CorrectCellNullWidthStyle(this.itemsManager.GetFirstVisibleItemRow());
  }
  ASPxClientListBoxBase.prototype.InlineInitialize.call(this);
  this.EnsureSelectAllElements();
 },
 UseSpecialKeyboardHandling: function() {
  return true;
 },
 GetItemIndexByInsertionOrder: function (itemIndex) { 
  return this.HasVirtualScrolling() ? this.GetItem(itemIndex).insertOrderIndex : this.FindFreeIndex();
 },
 InsertItemRow: function (index, itemProperties) {
  var newItemRow = this.itemsManager.CreateNewItemRow(index);
  ASPx.Attr.RemoveAttribute(newItemRow, "id");
  var listTable = this.GetListTable();
  var tbody = this.GetTableRowParent(listTable);
  var rowBeforeNewItemRow = this.GetListTableRowBeforeNewItemRow(index, listTable);
  if(rowBeforeNewItemRow)
   tbody.insertBefore(newItemRow, rowBeforeNewItemRow);
  else
   tbody.appendChild(newItemRow);  
  var newIndex = this.GetItemIndexByInsertionOrder(index);
  var newId = this.CreateItemId(newIndex);
  var newClientId = this.CreateItemClientId(newIndex);
  this.InitializeItemAttributes(newItemRow, newClientId, true);
  this.AddStateControllerClasses(newId);
  this.PrepareItem(newItemRow, itemProperties);
  if (this.needUnselectableItemRows)
   this.SetItemRowUnselectable(newItemRow);
  if (this.GetIsCheckColumnExists() && !this.IsNativeCheckBoxes()) {
   if (!this.internalCheckBoxCollection)
    this.CreateInternalCheckBoxCollection();
   this.AddInternalCheckBoxToCollection(index);
  }
 },
 RemoveItemRow: function (index) {
  if (this.GetIsCheckColumnExists() && !this.IsNativeCheckBoxes())
   this.RemoveInternalCheckBoxFromCollecntion(index);
  var row = this.GetItemRow(index);
  if (ASPx.IsExistsElement(row)) {
   var firstCellId = this.GetItemElement(index).id;
   var itemId = firstCellId.match(/LBI\d+/)[0];
   this.RemoveStateControllerClasses(itemId);
   row.parentNode.removeChild(row);
  }
 },
 SetItemRowsUnselectable: function() {
  var count = this.GetItemCount();
  for (var i = 0; i < count; i++) {
   var itemRow = this.GetItemRow(i);
   if (itemRow)
    this.SetItemRowUnselectable(itemRow);
  }
  this.needUnselectableItemRows = true;
 },
 SetItemRowUnselectable: function (itemRow) {
  for (var j = 0; j < itemRow.cells.length; j++)
   ASPx.Selection.SetElementAsUnselectable(itemRow.cells[j], true);
 },
 GetInactiveFilterElementClassName: function() {
  return inactiveFilterElementClassName;
 },
 GetAnimatedFilterElementClassName: function() {
  return "dxeLBAnimatedFilterPanelSys";
 },
 GetCompactViewFilterAdjacentScrollDivSelector: function() {
  return "*[class*=\"dxeListBoxFilter\"]:not(.dxeLBInactiveFilterPanelSys) + *[class*=\"dxeListBoxSelectAll\"] + .dxlbd";
 },
 GetCompactViewInactiveFilterAdjacentScrollDivSelector: function() {
  return ".dxeLBInactiveFilterPanelSys + *[class*=\"dxeListBoxSelectAll\"] + .dxlbd";
 },
 EnsureFilteringElements: function () {
  if(this.enableFiltering) {
   this.EnsureFilteringTextBox();
   if(!this.customFilteringEditorID) {
    this.filterMainElement = this.GetChildElement(filterMainElementID);
    this.showFilterButton = this.GetShowFilterButton();
    if(this.showFilterButton) {
     this.showFilterButton.ownerListBox = this;
     var changeEventMethod = ASPx.Attr.ChangeEventsMethod(this.GetEnabled());
     this.ChangeSpecialInputEnabledAttributes(this.showFilterButton.GetInternalButton(), changeEventMethod, true);
     this.showFilterButton.SetEnabled(this.GetEnabled());
     this.UpdateFilterButtonHeight();
     this.UpdateShowHideFilterElementCssRules();
    }
   }
  }
 },
 CreateFilterStrategy: function() {
  if(this.enableFiltering)
   return new ListBoxFilterStrategy(this);
  return new ListEditFilterStrategyBase();
 },
 UpdateShowHideFilterElementCssRules: function() {
  var scrollDiv = this.GetScrollDivElement();
  var scrollDivClientHeight = scrollDiv.offsetHeight - ASPx.GetTopBottomBordersAndPaddingsSummaryValue(scrollDiv);
  var filterMainElementOffsetHeight = this.GetFilterMainElementHeight();
  if (ASPx.GetElementVisibility(this.filteringTextBox.GetMainElement(), true))
   scrollDivClientHeight += filterMainElementOffsetHeight;
  var showHideFilterStyle = this.EnsureShowHideFilterStyle();
  var mainElementSelector = "#" + this.name;
  var styleContent = [
   mainElementSelector + " " + this.GetCompactViewFilterAdjacentScrollDivSelector()
    + " { max-height: " + (scrollDivClientHeight - filterMainElementOffsetHeight) + "px; }",
   mainElementSelector + " " + this.GetCompactViewInactiveFilterAdjacentScrollDivSelector()
    + " { max-height: " + scrollDivClientHeight + "px; }"
  ];
  showHideFilterStyle.innerHTML = styleContent.join('\n');
 },
 EnsureShowHideFilterStyle: function() {
  if(!this.showHideFilterStyle) {
   this.showHideFilterStyle = this.FindShowHideFilterStyle();
   if(!this.showHideFilterStyle) {
    this.showHideFilterStyle = document.createElement('style');
    this.showHideFilterStyle.id = this.GetShowHideFilterStyleID();
    ASPx.Attr.AppendStyleType(this.showHideFilterStyle);
    document.getElementsByTagName('head')[0].appendChild(this.showHideFilterStyle);
   }
  }
  return this.showHideFilterStyle;
 },
 FindShowHideFilterStyle: function() {
  return ASPx.GetChildById(document.getElementsByTagName('head')[0], this.GetShowHideFilterStyleID());
 },
 GetShowHideFilterStyleID: function() {
  return this.name + "ShowHideFilterStyle";
 },
 GetFilterMainElementHeight: function() {
  if(!this.filterMainElementHeight) {
   var filteringTextBoxClone = this.filteringTextBox.GetMainElement().cloneNode(true);
   filteringTextBoxClone.style.position = "absolute";
   filteringTextBoxClone.style.visibility = "hidden";
   document.body.appendChild(filteringTextBoxClone);
   this.filterMainElementHeight = filteringTextBoxClone.offsetHeight;
   document.body.removeChild(filteringTextBoxClone);
   var filterMainElementClone = this.filterMainElement.cloneNode(false);
   filterMainElementClone.style.position = "absolute";
   filterMainElementClone.style.visibility = "hidden";
   ASPx.RemoveClassNameFromElement(filterMainElementClone, this.GetInactiveFilterElementClassName());
   ASPx.RemoveClassNameFromElement(filterMainElementClone, this.GetAnimatedFilterElementClassName());
   document.body.appendChild(filterMainElementClone);
   this.filterMainElementHeight += ASPx.GetTopBottomBordersAndPaddingsSummaryValue(filterMainElementClone);
   document.body.removeChild(filterMainElementClone);
  }
  return this.filterMainElementHeight;
 },
 RemoveShowHideFilterCssRules: function () {
  var showHideFilterStyle = this.FindShowHideFilterStyle();
  if(showHideFilterStyle)
   showHideFilterStyle.innerHTML = "";
 },
 UpdateFilterButtonHeight: function() {
  setTimeout(function () {
   this.showFilterButton.SetHeight(this.selectAllMainElement.offsetHeight - ASPx.GetVerticalBordersWidth(this.selectAllMainElement));
  }.aspxBind(this), 0);
 },
 EnsureFilteringTextBox: function() {
  this.filteringTextBox = this.FindFilteringTextBox();
  if(this.filteringTextBox) {
   this.filteringTextBox.UserInput.AddHandler(this.filterStrategy.OnInput.bind(this.filterStrategy));
   if(!this.customFilteringEditorID) {
    this.filteringTextBox.ownerListBox = this;
    var changeEventMethod = ASPx.Attr.ChangeEventsMethod(this.GetEnabled());
    this.ChangeSpecialInputEnabledAttributes(this.filteringTextBox.GetInputElement(), changeEventMethod, true);
    this.filteringTextBox.SetEnabled(this.GetEnabled());
    this.filteringTextBox.KeyDown.AddHandler(function(sender, args) {
     if(ASPx.Evt.GetKeyCode(args.htmlEvent) === ASPx.Key.Esc)
      sender.GetInputElement().value = "";
    });
   }
  }
 },
 FindFilteringTextBox: function() {
  var actualFilteringTextBoxID = this.customFilteringEditorID ? this.customFilteringEditorID : this.name + "_" + filteringTextBoxID;
  return ASPx.GetControlCollection().Get(actualFilteringTextBoxID);
 },
 CollectionChanged: function(isFiltering) {
  if(this.APILockCount == 0) {
   if(ASPx.Browser.IE) { 
    var selectedIndex = this.GetSelectedIndex();
    if (selectedIndex > -1) {
     var selectedItemTextCell = this.GetItemFirstTextCell(selectedIndex);
     var controller = ASPx.GetStateController();
     controller.DeselectElementBySrcElement(selectedItemTextCell);
     controller.SelectElementBySrcElement(selectedItemTextCell);
    }
   }
  }
  if(isFiltering)
   this.itemsManager.OnEndItemsFiltering();
 },
 ChangeItemsFilteredState: function(action) {
  this.itemsManager.ChangeItemsFilteredState(action);
 },
 RewriteFilteredItemIndices: function (newFilteredItemIndices) {
  this.itemsManager.RewriteFilteredItemIndices(newFilteredItemIndices);
 },
 BeforeClientFiltering: function () {
  this.itemsManager.BeforeClientFiltering();
 },
 ApplyFilterToItem: function (index, isSatisfy, savePrevState, isFilterReset) {
  this.itemsManager.ApplyFilterToItem(index, isSatisfy, savePrevState, isFilterReset);
 },
 RestorePrevFilteredState: function (index) {
  this.itemsManager.RestorePrevFilteredState(index);
 },
 IsItemFiltered: function (index) {
  return this.itemsManager.IsItemFiltered(index);
 },
 IsClientFilterApplied: function() {
  return !this.isComboBoxList && this.filterStrategy.filter != "" && !this.isCallbackMode;
 },
 MakeAllItemsVisible: function () {
  this.itemsManager.MakeAllItemsVisible();
 },
 ShowFilterElement: function() {
  ASPx.RemoveClassNameFromElement(this.filterMainElement, this.GetInactiveFilterElementClassName());
  this.showFilterButton.SetVisible(false);
  if(ASPx.Browser.VirtualKeyboardSupported) {
   this.ReplaceFilteringTextBoxShowNullTextOnFocusFunction();
   this.isFilterEditorShowing = false;
   this.filteringTextBox.GetInputElement().focus();
  }
  else
   setTimeout(function () {
    this.isFilterEditorShowing = false;
    this.filteringTextBox.GetInputElement().focus();
   }.aspxBind(this), 200);
 },
 HideFilterElement: function () {
  ASPx.AddClassNameToElement(this.filterMainElement, this.GetInactiveFilterElementClassName());
  this.showFilterButton.SetVisible(true);
  this.UpdateFilterButtonHeight();
  this.CorrectHeight(true);
  setTimeout(function () {
   this.filteringTextBox.UnlockFocusEvents();
   this.showFilterButton.GetInternalButton().focus();
  }.aspxBind(this), 0);
 },
 ReplaceFilteringTextBoxShowNullTextOnFocusFunction: function () {
  if(this.filteringTextBox.nullTextDisplayMode === ASPx.NullTextDisplayMode.UnfocusedAndFocused) {
   var origin = this.filteringTextBox.ensureActivateFocusedNullTextMechanism;
   var filteringTextBox = this.filteringTextBox;
   this.filteringTextBox.ensureActivateFocusedNullTextMechanism = function() {
    setTimeout(function() {
     origin.call(filteringTextBox);
     filteringTextBox.ensureActivateFocusedNullTextMechanism = origin;
     setTimeout(function () {
      if(filteringTextBox.isFocusedNullTextElementDisplayed())
       filteringTextBox.adjustFocusedNullTextElement();
     }, 300);
    }, 400);
   };
  }
 },
 EnsureSelectAllElements: function () {
  if(this.enableSelectAll && !this.selectAllMainElement) {
   this.EnsureSelectAllCheckElement();
   this.selectAllMainElement = this.GetChildElement(selectAllMainElementID);
   var selectAllClickableElement = this.GetSelectAllClickableElement();
   ASPx.Evt.AttachEventToElement(selectAllClickableElement, "click", this.onSelectAllClickableElementClick.bind(this));
  }
 },
 EnsureSelectAllCheckElement: function () {
  var selectAllCheckBoxInput = null;
  if(!this.IsNativeCheckBoxes()) {
   this.CreateSelectAllCheckBox();
   selectAllCheckBoxInput = this.GetSelectAllCheckBoxFocusableElement();
  }
  else {
   this.nativeSelectAllCheckBox = this.GetChildElement(selectAllCheckBoxID + "_I");
   this.nativeSelectAllCheckBox.disabled = !this.GetEnabled();
   selectAllCheckBoxInput = this.nativeSelectAllCheckBox;
  }
  var changeEventMethod = ASPx.Attr.ChangeEventsMethod(this.GetEnabled());
  this.ChangeSpecialInputEnabledAttributes(selectAllCheckBoxInput, changeEventMethod, true);
 },
 CreateSelectAllCheckBox: function () {
  var selectAllCheckBoxElement = this.GetChildElement(selectAllCheckBoxID);
  var selectAllCheckBoxInputElement = this.GetChildElement(selectAllCheckBoxID + "_S");
  var selectAllStateController = ASPx.CheckableElementStateController.Create(this.icbImageProperties, CheckBoxInputKey.Checked, CheckBoxInputKey.Unchecked, CheckBoxInputKey.Indeterminate, true);  
  this.selectAllCheckBox = new ASPx.CheckBoxInternal(selectAllCheckBoxInputElement, selectAllStateController, true, false,
   ASPx.CheckEditElementHelper.Instance, selectAllCheckBoxElement, true, undefined, undefined, this.accessibilityCompliant);
  this.selectAllCheckBox.CreateFocusDecoration(this.icbFocusedStyle);
  this.selectAllCheckBox.SetEnabled(this.GetEnabled());
  this.selectAllCheckBox.GetReadOnly = this.GetReadOnly.bind(this);
  this.selectAllCheckBox.CheckedChanged.AddHandler(this.onSelectAll.aspxBind(this));
  if(ASPx.Browser.WebKitFamily)
   ASPx.Evt.AttachEventToElement(this.selectAllCheckBox.mainElement.parentNode, "selectstart", ASPx.Evt.PreventEventAndBubble);
 },
 onSelectAllClickableElementClick: function (evt) {
  if (!this.GetEnabled() || this.GetReadOnly()) {
   if (this.IsNativeCheckBoxes() || this.isNative)
    ASPx.Evt.PreventEvent(evt);
   return false;
  }
  if(this.IsSelectAllCheckBoxClicked(ASPx.Evt.GetEventSource(evt)))
   return;
  if(!this.IsNativeSelectAllCheckBoxClicked(ASPx.Evt.GetEventSource(evt))) {
   var currentCheckState = this.getSelectAllCheckElementState();
   var newCheckState = currentCheckState != ASPx.CheckBoxCheckState.Checked ?
    ASPx.CheckBoxCheckState.Checked : ASPx.CheckBoxCheckState.Unchecked;
   this.updateSelectAllCheckElementState(newCheckState);
  }
  this.onSelectAll();
 },
 onSelectAll: function () {
  this.LockUpdateSelectAllElements();
  var selectAllCheckState = this.getSelectAllCheckElementState();
  this.onSelectAllCore(selectAllCheckState);
  this.UnlockUpdateSelectAllElements();
 },
 onSelectAllCore: function (currentCheckState) {
  var toSelect = currentCheckState == ASPx.CheckBoxCheckState.Checked;
  var valueBeforeSelectAll = this.GetValue();
  var selectionBeforeSelectAll = this.GetValueFromValueInput();
  if (toSelect)
   this.SelectAll();
  else
   this.UnselectAll();
  if(selectionBeforeSelectAll !== this.GetValueFromValueInput())
   this.OnItemSelectionChanged(-1, toSelect, true, valueBeforeSelectAll !== this.GetValue());
 },
 getSelectAllCheckElementState: function () {
  if(this.selectAllCheckBox)
   return this.selectAllCheckBox.GetCurrentCheckState();
  if(this.nativeSelectAllCheckBox)
   return this.nativeSelectAllCheckBox.checked ? ASPx.CheckBoxCheckState.Checked : ASPx.CheckBoxCheckState.Unchecked;
  return null;
 },
 updateSelectAllCheckElementState: function (checkState) {
  if(this.selectAllCheckBox) {
   var checkValue = this.selectAllCheckBox.stateController.GetValueByCheckState(checkState);
   this.selectAllCheckBox.SetValue(checkValue, !this.isInitialized);
  } else if(this.nativeSelectAllCheckBox)
   this.nativeSelectAllCheckBox.checked = checkState === ASPx.CheckBoxCheckState.Checked;
 },
 updateSelectAllElementsState: function() {
  if(!this.IsUpdateSelectAllElementsLocked() && this.enableSelectAll) {
   this.EnsureSelectAllElements();
   this.updateSelectAllElementsStateCore();
  }
 },
 updateSelectAllElementsStateCore: function() {
  var selectAllCheckState = ASPx.CheckBoxCheckState.Unchecked;
  var isFilteredSelectedItemFound = false;
  var isFilteredUnselectedItemFound = false;
  var itemCount = this.GetItemCount();
  for(var i = 0; i < itemCount; i++) {
   if(this.IsItemFiltered(i)) {
    if(this.GetIsItemSelected(i))
     isFilteredSelectedItemFound = true;
    else
     isFilteredUnselectedItemFound = true;
   }
   if (isFilteredSelectedItemFound && isFilteredUnselectedItemFound) {
    selectAllCheckState = ASPx.CheckBoxCheckState.Indeterminate;
    break;
   }
   if(i == itemCount - 1 && isFilteredSelectedItemFound && !isFilteredUnselectedItemFound)
    selectAllCheckState = ASPx.CheckBoxCheckState.Checked;
  }
  this.updateSelectAllCheckElementState(selectAllCheckState);
 },
 changeSelectAllElementsEnabledState: function(enabled) {
  var selectAllCheckBoxInput = null;
  if(this.selectAllCheckBox) {
   this.selectAllCheckBox.SetEnabled(enabled);
   selectAllCheckBoxInput = this.GetSelectAllCheckBoxFocusableElement();
  }
  else if(this.nativeSelectAllCheckBox) {
   this.nativeSelectAllCheckBox.disabled = !enabled;
   selectAllCheckBoxInput = this.nativeSelectAllCheckBox;
  }
  if(selectAllCheckBoxInput) {
   var changeEventMethod = ASPx.Attr.ChangeEventsMethod(enabled);
   this.ChangeSpecialInputEnabledAttributes(selectAllCheckBoxInput, changeEventMethod, true);
  }
  ASPx.GetStateController().SetElementEnabled(this.selectAllMainElement, enabled);
 },
 NeedToHandleCellWidth: function() {
  return this.IsMultiColumn() && (ASPx.Browser.Firefox || ASPx.Browser.IE || ASPx.Browser.Edge);
 },
 CorrectCellNullWidthStyle: function(row) {
  if(!row) return;
  var cellCount = row.cells.length;
  for(var i = 0; i < cellCount; i++) {
   var cellStyle = !!window.getComputedStyle ? window.getComputedStyle(row.cells[i]) : ASPx.GetCurrentStyle(row.cells[i]);
   var originalWidth = parseInt(cellStyle.width);
   var needToApply = originalWidth === 0 || originalWidth <= ASPx.PxToInt(cellStyle.paddingLeft) || originalWidth <= ASPx.PxToInt(cellStyle.paddingRight);
   var action = needToApply ? ASPx.AddClassNameToElement : ASPx.RemoveClassNameFromElement;
   action(row.cells[i], NullSizeCellClassName);
  }
 },
 InitializeNativeCheckHandlers: function() {
  this.nativeCheckOnFocusHandler = function(evt) {
   this.SetFocusableCheckInput(ASPx.Evt.GetEventSource(evt));
  }.aspxBind(this);
 },
 ChangeNativeCheckEnabledAttributes: function(element, method) {
  if(this.nativeCheckOnFocusHandler)
   method(element, "focus", this.nativeCheckOnFocusHandler);
 },
 InitializeItemsAttributes: function() { 
  var listTable = this.GetListTable();
  if(this.isHasFakeRow){
   this.LockSynchronization();
   this.ClearItems();
   this.UnlockSynchronization();
  }
  listTable.ListBoxId = this.name;
  var rowIdConst = this.name + "_";
  if(this.hasSampleItem)
   this.InitializeItemAttributes(this.GetSampleItemRow(), rowIdConst + lbSIIdSuffix);
  if(!this.HasVirtualScrolling()) {
   rowIdConst += lbIIdSuffix;
   var count = this.GetItemCount();
   if (this.accessibilityCompliant && this.IsMultiColumn())
    count--;
   for (var i = 0; i < count; i++)
    this.InitializeItemAttributes(this.GetItemRow(i), rowIdConst + i);
  }
  var rows = listTable.rows;
  if(this.accessibilityCompliant && rows[rows.length - 1])
   rows[rows.length - 1].id = this.GetAccessibilityHeaderRowID();
 },
 InitializeItemAttributes: function(row, rowId) {
  var cells = row.cells;
  var itemCellsIdSuffixes = this.GetItemCellsIdPostfixes();
  for(var i = 0; i < row.cells.length; i++) {
   cells[i].style.textAlign = this.itemHorizontalAlign;
   cells[i].id = rowId + itemCellsIdSuffixes[i];
  }
  if(this.GetIsCheckColumnExists() && this.IsNativeCheckBoxes() && rowId != this.GetSampleItemRowID()) {
   var input = this.GetItemCheckBoxInput(this.GetItemIndexByRow(row));
   this.ChangeNativeCheckEnabledAttributes(input, ASPx.Attr.ChangeEventsMethod(this.GetEnabled()));
   this.ChangeSpecialInputEnabledAttributes(input, ASPx.Attr.ChangeEventsMethod(this.GetEnabled()));
  }
 },
 InitializePageSize: function(){
  var divElement = this.GetScrollDivElement();
  var count = this.GetItemCount();
  if (divElement && count > 0) {
   var firstVisibleRow = this.itemsManager.GetFirstVisibleItemRow();
   if(firstVisibleRow)
    this.scrollPageSize = Math.round(divElement.clientHeight / firstVisibleRow.offsetHeight) - 1;
  }
 },
 AddSelectAllStateItems: function(isInitialization) {
  if (this.enableSelectAll && typeof (ASPx.GetStateController) !== "undefined") {
   var stateController = ASPx.GetStateController();
   var name = this.name + "_" + selectAllMainElementID;
   if (!isInitialization)
    this.ClearStateItemCache(stateController, name, [""]);
   stateController.AddHoverItem(name, this.selectAllHoverClasses, this.selectAllHoverCssArray, "", null, null, true);
   stateController.AddDisabledItem(name, this.selectAllDisabledClasses, this.selectAllDisabledCssArray, "", null, null, true);
  }
 },
 RemoveSelectAllStateItems: function() {
  if (this.enableSelectAll && typeof (ASPx.GetStateController) !== "undefined") {
   var stateController = ASPx.GetStateController();
   var name = this.name + "_" + selectAllMainElementID;
   this.ClearStateItemCache(stateController, name, [""]);
   stateController.RemoveHoverItem(name, "");
   stateController.RemoveDisabledItem(name, "");
  }
 },
 ClearStateItemCache: function(stateController, name, suffixes) {
  for (var i = 0; i < suffixes.length; i++) {
   var element = document.getElementById(name + suffixes[i]);
   var elements = ASPx.GetNodes(element);
   elements.push(element);
   ASPx.Data.ForEach(elements, stateController.ClearElementCache.bind(stateController));
  }
 },
 AfterInitialize: function() {
  if(this.disableScrolling) {
   var scrollDiv = this.GetScrollDivElement();
   var mainElement = this.GetMainElement();
   var listTable = this.GetListTable();
   scrollDiv.style.height = mainElement.style.height = (listTable 
    ? ASPx.GetClearClientHeight(listTable)
    : this.GetListTableHeight() - ASPx.GetTopBottomBordersAndPaddingsSummaryValue(mainElement)) + "px";
  }
  this.CallbackSpaceInit(true);
  ASPxClientListBoxBase.prototype.AfterInitialize.call(this);
 },
 GetEnabledByServer: function(){
  return this.enabled;
 },
 SetEnabled: function(enabled){  
  ASPxClientListBoxBase.prototype.SetEnabled.call(this, enabled);
  this.CallbackSpaceInit(false);
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientListBoxBase.prototype.SetReadOnlyInternal.call(this, readOnly);
  if (readOnly) {
   this.RemoveSelectAllStateItems();
   this.itemsManager.RemoveHoverStateItem();
  }
  else {
   this.AddSelectAllStateItems(false);
   this.itemsManager.AddStateItems(true, true);
  }
 }, 
 CallbackSpaceInit: function(isInitialization){
  if(this.isCallbackMode){
   this.SetBottomScrollSpacerVisibility(this.GetScrollSpacerVisibility(false));
   this.SetTopScrollSpacerVisibility(this.GetScrollSpacerVisibility(true));
   if(isInitialization || this.isComboBoxList){
    this.EnsureSelectedItemVisible();
    ASPx.Evt.AttachEventToElement(this.GetScrollDivElement(), "scroll", aspxLBScroll);
   }
   this.itemsManager.FixItemTruncatingIfRequired();
  }
 },
 GetListTable: function() {
  return this.tempCache.Get("ListTable", this.GetListTableCore, this);
 },
 GetListTableCore: function(){
  if(!ASPx.IsExistsElement(this.listTable))
   this.listTable = ASPx.GetElementById(this.name + lTableIdSuffix);
  return this.listTable;
 },
 GetItemElements: function() {
  return this.GetListTable().rows;
 },
 GetListTableHeight: function(){
  return this.GetListTable().offsetHeight;
 },
 GetHeaderDivElement: function(){
  if(!ASPx.IsExistsElement(this.headerDiv))
   this.headerDiv = ASPx.GetElementById(this.name + lbHeaderDivIdSuffix);
  return this.headerDiv;
 },
 GetHeaderTableElement: function(){
  if(!ASPx.IsExistsElement(this.headerTable)){
   var headerDiv = this.GetHeaderDivElement();
   this.headerTable = ASPx.GetNodeByTagName(headerDiv, "table", 0);
  }
  return this.headerTable;
 },
 GetScrollDivElement: function(){
  if(!ASPx.IsExistsElement(this.scrollDivElement))
   this.scrollDivElement = document.getElementById(this.name + lbDSuffix);
  return this.scrollDivElement;
 },
 GetItemElement: function(index) {
  return this.itemsManager.GetItemElement(index);
 },
 GetItemRow: function(index){
  return this.itemsManager.GetItemRow(index);
 },
 GetItemIndexByRow: function (itemRow) {
  return this.itemsManager.GetItemIndexByRow(itemRow);
 },
 GetItemSelectableElementsByRow: function(row) {
  return row.cells;
 },
 GetItemTexts: function(item) {
  return item.texts ? item.texts : [ item.text ];
 },
 GetItemHtmlContent: function(index) {
  return this.itemsManager.GetItemHtmlContent(index);
 },
 GetItemCount: function(){
  return this.itemsManager.GetItemCount();
 },
 GetListTableRowParent: function() {
  var listTable = this.GetListTable();
  return this.GetTableRowParent(listTable);
 },
 EnsureFixWidthRow: function (isSetItemHtmlProcessing) {
  var needfixWidthRow = !this.ContainsFixWidthRow() && this.IsMultiColumn() && (isSetItemHtmlProcessing || this.hasItemTemplate);
  if (needfixWidthRow)
   this.CreateFixWidthRow();
 },
 CreateFixWidthRow: function() {
  this.fixWidthRow = document.createElement("TR");
  var etalonRow = this.GetSampleItemRow();
  for(var i = 0; i < etalonRow.cells.length; i++) {
   var fixWidthCell = document.createElement("TD");
   var etalonCell = etalonRow.cells[i];
   var etalonCellStyle = ASPx.GetCurrentStyle(etalonCell);
   fixWidthCell.style.width = etalonCell.style.width || etalonCellStyle.width;
   fixWidthCell.style.borderLeftWidth = etalonCellStyle.borderLeftWidth;
   fixWidthCell.style.borderRightWidth = etalonCellStyle.borderRightWidth;
   fixWidthCell.style.borderLeftStyle = etalonCellStyle.borderLeftStyle;
   fixWidthCell.style.borderRightStyle = etalonCellStyle.borderRightStyle;
   fixWidthCell.style.paddingLeft = etalonCellStyle.paddingLeft;
   fixWidthCell.style.paddingRight = etalonCellStyle.paddingRight;
   fixWidthCell.style.boxSizing = etalonCellStyle.boxSizing;
   fixWidthCell.style.display = etalonCellStyle.display;
   this.fixWidthRow.appendChild(fixWidthCell);
  }
  ASPx.SetElementVisibility(this.fixWidthRow, "hidden");
  this.fixWidthRow.style.height = "0px";
  var listTableBody = this.GetListTableRowParent();
  listTableBody.insertBefore(this.fixWidthRow, listTableBody.childNodes[0]);
 },
 ContainsFixWidthRow: function() {
  return this.fixWidthRow && this.fixWidthRow.parentNode === this.GetListTableRowParent();
 },
 GetVisibleItemCount: function () {
  return this.itemsManager.GetVisibleItemCount();
 },
 GetIndexVisibleItem: function(item) {
  var count = this.GetItemCount();
  var visibleItemCount = 0;
  for(var i = 0; i < count; i ++){
   if(this.IsItemFiltered(i))
    visibleItemCount++;
   var curItem = this.GetItem(i);
   if(item.value === curItem.value && item.text === curItem.text)
    break;
  }
  return visibleItemCount;
 },
 GetItemCellCount: function(){
  if(this.hasSampleItem)
   return this.GetSampleItemRow().cells.length;
  if(this.GetItemCount() > 0)
   return this.itemsManager.GetFirstVisibleItemRow().cells.length;
  return 0;
 },
 GetItemTextCellCount: function(){
  return this.GetItemCellCount() - this.GetItemFirstTextCellIndex();
 },
 GetItemFirstTextCellIndex: function(){
  var itemFirstTextCellIndex  = 0;
  if(this.GetIsCheckColumnExists())
   itemFirstTextCellIndex++;
  if(this.imageCellExists)
   itemFirstTextCellIndex++;
  return itemFirstTextCellIndex;
 },
 GetItemFirstTextCell: function(index){
  return this.GetItemTextCell(index, 0);
 },
 GetItemTextCell: function(itemIndex, textCellIndex) {
  var rowElement = this.GetItemRow(itemIndex);
  if(rowElement == null) 
   return null;
  return rowElement.cells[this.GetItemFirstTextCellIndex() + textCellIndex];
 },
 GetItemTextCells: function(item) {
  var firstTextCellIndex = this.GetItemFirstTextCellIndex();
  return Array.prototype.slice.call(this.GetItemSelectableElementsByRow(item), firstTextCellIndex);
 },
 GetItemTopOffset: function(index){
  return this.itemsManager.GetItemTopOffset(index);
 },
 GetItemHeight: function(index){
  return this.itemsManager.GetItemHeight(index);
 },
 ResetItemHeightIfRequired: function (index) {
  return this.itemsManager.ResetItemHeightIfRequired(index);
 },
 GetItemsHeight: function(){
  return this.itemsManager.GetItemsHeight();
 },
 GetItemsWidth: function () {
  return this.itemsManager.GetItemsWidth();
 },
 GetItemCheckBoxInput: function(index){
  var itemRow = this.GetItemRow(index);
  var checkBoxCell = itemRow ? itemRow.cells[this.GetCheckBoxCellIndex()] : null;
  return checkBoxCell ? ASPx.GetNodesByTagName(checkBoxCell, "input")[0] : null;
 },
 GetIsCheckColumnExists: function(){
  if(!this.checkCellExists)
   this.checkCellExists = this.CheckColumnSelectionMode();
  return this.checkCellExists;
 },
 GetCheckBoxCellIndex: function(){
  return 0;
 },
 GetImageCellIndex: function(){
  return this.GetIsCheckColumnExists() ? 1 : 0;
 },
 GetItemCellsIdPostfixes: function(){
  if(this.itemCellsIdPostfixes == null){
   this.itemCellsIdPostfixes = [];
   var i = 0;
   if(this.GetIsCheckColumnExists()) {
    this.itemCellsIdPostfixes.push(lbIPostfixes[0]);
    i++;
   }
   if(this.imageCellExists){
    this.itemCellsIdPostfixes.push(lbIPostfixes[1]);
    i++;
   }
   var cellCount = this.GetItemCellCount();
   for(; i < cellCount; i++) 
    this.itemCellsIdPostfixes.push(lbIPostfixes[2] + i);
  }
  return this.itemCellsIdPostfixes;
 },
 AdjustControl: function (nestedCall) {
  if(this.IsAdjustmentRequired()) 
   this.heightCorrected = false;
  ASPxClientEdit.prototype.AdjustControl.call(this, nestedCall);
 },
 AdjustControlCore: function(){
  this.RemoveShowHideFilterCssRules();
  if(this.disableScrolling)
   return;
  ASPxClientEdit.prototype.AdjustControlCore.call(this);
  this.CorrectSize();
  this.itemsManager.Adjust();
  this.EnsureSelectedItemVisible();
  if(!this.isComboBoxList && ASPx.Browser.IE) 
   this.CorrectWidth();
  if(this.showFilterButton) {
   this.UpdateFilterButtonHeight();
   this.UpdateShowHideFilterElementCssRules();
  }
 },
 CorrectSize: function() {
  if(this.isComboBoxList || this.disableScrolling || this.filterStrategy.currentCallbackIsFiltration)
   return;
  this.LockScrollHandler();
  this.CorrectHeight();
  this.CorrectWidth();
  this.InitializePageSize();
  this.UnlockScrollHandler();
 },
 OnCorrectSizeByTimer: function() {
  if(this.IsVisible())
   this.CorrectSize();
 }, 
 SetProtectionFromFlick_inFF: function(changeVisibility, changeDisplay){
  if(!ASPx.Browser.Firefox) return;
  var listTable = this.GetListTable();
  if(changeVisibility)
   listTable.style.visibility = "hidden";
  if(changeDisplay)
   listTable.style.display = "none";
 },
 ResetProtectionFromFlick_inFF: function(){
  if(!ASPx.Browser.Firefox) return;
  var listTable = this.GetListTable();
  listTable.style.visibility = "";
  listTable.style.display = "";
 },
 CorrectHeight: function(force){
  if(ASPx.Browser.Firefox && this.heightCorrected && !force) return; 
  this.heightCorrected = true;
  var mainElement = this.GetMainElement();
  var divElement = this.GetScrollDivElement();
  divElement.style.height = "0px";
  var height = mainElement.offsetHeight;
  divElement.style.height = height + "px";
  var extrudedHeight = mainElement.offsetHeight;
  var heightCorrection = extrudedHeight - height;
  if(heightCorrection > 0){
   var divHeight = divElement.offsetHeight;
   this.SetProtectionFromFlick_inFF(true, false);
   divElement.style.height = (divHeight - heightCorrection) + "px";
   this.ResetProtectionFromFlick_inFF(); 
   extrudedHeight = mainElement.offsetHeight;
   var paddingsHeightCorrection = extrudedHeight - height;
   if(paddingsHeightCorrection > 0)
    divElement.style.height = (divHeight - heightCorrection - paddingsHeightCorrection) + "px";
  } 
 },
 IsMultiColumn: function(){
  return this.columnFieldNames.length > 0;
 },
 IsCorrectWidthRequired: function(){
  return true;
 },
 GetVisibleColumnCount: function() {
  if (!this.visibleColumnCount) {
   this.visibleColumnCount = this.IsMultiColumn() ?
    ASPx.Data.CollectionToArray(this.GetSampleItemRow().cells)
     .slice(this.GetItemFirstTextCellIndex())
     .filter(function (cell) { return ASPx.GetElementDisplay(cell); }).length
    : -1;
  }
  return this.visibleColumnCount;
 },
 CorrectWidth: function () {
  if(!this.IsCorrectWidthRequired()) return;
  if(this.IsMultiColumn())
   this.CorrectMultiColumnWidth();
  else
   this.CorrectNonMultiColumnWidth();
 },
 CorrectMultiColumnWidth: function(){
  var scrollBarWidth = this.GetVerticalScrollBarWidth(); 
  this.CorrectMultiColumnHeaderWidth(scrollBarWidth);
 },
 CollapseMultiColumnHeaderWidth:function(){
  var headerDivElement = this.GetHeaderDivElement();
  headerDivElement.style.width = "0px";
 },
 CorrectMultiColumnHeaderWidth: function(scrollBarWidth){
  var headerDivElement = this.GetHeaderDivElement();
  if(ASPx.IsExistsElement(headerDivElement)){
   var headerTable;
   if(ASPx.Browser.WebKitFamily){
    headerTable = this.GetHeaderTableElement();
    if(!ASPx.IsExistsElement(headerTable))
     headerTable = null;
   }
   if(this.rtl)
    headerDivElement.style.paddingLeft = scrollBarWidth + "px";
   else
    headerDivElement.style.paddingRight = scrollBarWidth + "px";
   if(headerTable)
    window.setTimeout(function() { headerTable.style.width = "100%"; }, 0);
  }
 },
 CorrectNonMultiColumnWidth: function(){
  var mainElement = this.GetMainElement(),
   divElement = this.GetScrollDivElement();
  if(this.width == ""){
   var itemsWidth = this.GetItemsWidth();
   if (itemsWidth != 0 || !ASPx.Browser.NetscapeFamily) { 
    divElement.style.width = Math.max((itemsWidth + this.GetVerticalScrollBarWidth()), this.scrollDivMinWidth) + "px";
    if(ASPx.Browser.Firefox) 
     mainElement.style.width = divElement.offsetWidth + "px";
   }
  } else {  
   mainElement.style.width = this.width;
   if(this.width !== "100%") {
    var scrollDivWidth = ASPx.Browser.WebKitFamily ? 1 : 0,
     isMicrosoftBrowser = ASPx.Browser.Edge || ASPx.Browser.IE;
    var oldScrollTop = divElement.scrollTop;
    divElement.style.width = scrollDivWidth + "px";
    scrollDivWidth = isMicrosoftBrowser ? mainElement.clientWidth - ASPx.GetHorizontalBordersWidth(mainElement) : mainElement.clientWidth;
    divElement.style.width = scrollDivWidth + "px";
    var isScrollEventWillRaised = divElement.scrollTop != oldScrollTop;
    if(isScrollEventWillRaised)
     this.itemsManager.DeactivateScrollHandler();
    divElement.scrollTop = oldScrollTop;
   }
  }
 },
 UpdateAdjustmentFlags: function() {
  var mainElement = this.GetMainElement();
  if(mainElement) {
   var mainElementStyle = ASPx.GetCurrentStyle(mainElement);
   this.UpdatePercentSizeConfig([this.width], [mainElementStyle.height, mainElement.style.height]);
  }
 },
 EnsureSelectedItemVisible: function(){
  var index = this.GetSelectedIndex();
  if(index != -1)
   this.MakeItemVisible(index);
 },
 MakeItemVisible: function(index){
  if(!this.IsItemVisible(index))
   this.ScrollItemToTop(index);
 },
 IsItemVisible: function(index){
  return this.itemsManager.IsItemVisible(index);
 },
 ScrollItemToTop: function(index){
  this.LockScrollHandler();
  this.SetScrollTop(this.GetItemTopOffset(index));
  this.UnlockScrollHandler();
 },
 ScrollToItemVisible: function(index){
  if(!this.IsItemVisible(index)){
   var scrollDiv = this.GetScrollDivElement();
   var scrollTop = scrollDiv.scrollTop;
   var scrollDivHeight = scrollDiv.clientHeight;
   var itemOffsetTop = this.GetItemTopOffset(index);
   var itemHeight = this.GetItemHeight(index);
   var itemAbove = scrollTop > itemOffsetTop;
   var itemBelow = scrollTop  + scrollDivHeight < itemOffsetTop + itemHeight;
   if(itemAbove)
    scrollDiv.scrollTop = itemOffsetTop;
   else if(itemBelow){
    var scrollDivChildElementHeight = this.GetScrollDivChildElementHeight();
    var scrollPaddings = scrollDiv.scrollHeight - scrollDivChildElementHeight;
    scrollDiv.scrollTop = itemOffsetTop + itemHeight - scrollDivHeight + scrollPaddings;
   }
  }
 },
 GetScrollDivChildElementHeight: function() {
  return this.itemsManager.GetScrollDivChildElementHeight();
 },
 SetScrollTop: function(scrollTop){
  var scrollDiv = this.GetScrollDivElement();
  if(scrollDiv){ 
   scrollDiv.scrollTop = scrollTop;
   if(ASPx.Browser.Opera) 
    this.CachedScrollTop();
  }   
 },
 CachedScrollTop: function(){
  var scrollDiv = this.GetScrollDivElement();
  scrollDiv.cachedScrollTop = scrollDiv.scrollTop;
 },
 RestoreScrollTopFromCache: function(){
  var scrollDiv = this.GetScrollDivElement();
  if(scrollDiv && ASPx.IsExists(scrollDiv.cachedScrollTop))
   scrollDiv.scrollTop = scrollDiv.cachedScrollTop;
 },
 IsListBoxWidthLessThenList: function(){
  var divElement = this.GetScrollDivElement();
  var listTable = this.GetListTable();
  var listTabelWidth = listTable.style.width;
  var isLess = false;
  listTable.style.width = "";
  isLess = listTable.offsetWidth < divElement.offsetWidth;
  listTable.style.width = listTabelWidth;
  return isLess;
 },
 GetVerticalScrollBarWidth: function(){
  var divElement = this.GetScrollDivElement(); 
  if(!this.verticalScrollBarWidth || this.verticalScrollBarWidth <= 0){
   this.verticalScrollBarWidth = this.GetVerticalScrollBarWidthCore(divElement);
   return this.verticalScrollBarWidth;
  } else
   return this.GetIsVerticalScrollBarVisible(divElement) ? this.verticalScrollBarWidth : 0;
 },
 GetIsVerticalScrollBarVisible: function(divElement){
  var verticalOverflow = this.GetVerticalOverflow(divElement);
  if(verticalOverflow != "auto"){
   return divElement.clientHeight < this.GetListTableHeight();
  } else {
   var borderWidthWithScroll = divElement.offsetWidth - divElement.clientWidth;
   return borderWidthWithScroll == this.scrollDivBordersWidthWithScroll;
  }
 },
 GetVerticalScrollBarWidthCore: function(divElement){
  var overflowYReserv = this.GetVerticalOverflow(divElement);
  this.SetVerticalOverflow(divElement, "auto");
  this.scrollDivBordersWidthWithScroll = divElement.offsetWidth - divElement.clientWidth;
  if(ASPx.Browser.IE)
   return this.scrollDivBordersWidthWithScroll; 
  this.SetProtectionFromFlick_inFF(false, true);
  this.SetVerticalOverflow(divElement, "hidden");
  var bordersWidthWithoutScroll = divElement.offsetWidth - divElement.clientWidth;
  this.SetVerticalOverflow(divElement, overflowYReserv);
  this.ResetProtectionFromFlick_inFF();
  return this.scrollDivBordersWidthWithScroll - bordersWidthWithoutScroll;
 },
 GetVerticalOverflow: function(element){
  if(ASPx.Browser.IE || ASPx.Browser.Safari && ASPx.Browser.Version >= 3 || ASPx.Browser.Chrome || ASPx.Browser.Firefox && ASPx.Browser.Version >= 3)
   return element.style.overflowY;
  return element.style.overflow;
 },
 SetVerticalOverflow: function(element, value) {
  if(ASPx.Browser.IE || ASPx.Browser.Safari && ASPx.Browser.Version >= 3 || ASPx.Browser.Chrome || ASPx.Browser.AndroidDefaultBrowser || ASPx.Browser.Firefox && ASPx.Browser.Version >= 3) {
   element.style.overflowY = value;
  } else {
   element.style.overflow = value;
  }
 },
 MultiSelectionMode: function(){
  return this.selectionMode != ListBoxSelectionMode.Single;
 },
 CheckColumnSelectionMode: function(){
  return this.selectionMode == ListBoxSelectionMode.CheckColumn;
 },
 OnItemClick: function(index, evt){
  if(!this.isInitialized) 
   return;
  if (this.GetReadOnly()) {
   ASPx.Evt.PreventEvent(evt);
   return this.OnItemClickOrDblClickReadOnly();
  }
  if(this.CheckColumnSelectionMode() && this.IsCheckBoxClicked(evt))
   this.GetItemSelectionHelper().OnItemCheckBoxClick(index, evt);
  else
   this.GetItemSelectionHelper().OnItemClick(index, evt);
  this.SetFocus();
  this.RaiseItemClick();
 },
 OnItemClickOrDblClickReadOnly: function(){
  return false;
 },
 OnItemDblClick: function(){
  if (this.GetReadOnly())
   return this.OnItemClickOrDblClickReadOnly();
  return this.RaiseItemDoubleClick();
 },
 CanChangeSelection: function(){
  return !this.GetReadOnly() || !this.isInitialized;
 },
 SelectIndexSilent: function(index){ 
  return this.SetItemSelectionStateSilent(index);
 },
 SetItemSelectionStateSilent: function(index){
  if(!this.CanChangeSelection())
   return;
  var oldSelectionIndex = this.GetSelectedIndex();
  this.LockSelectionEvents();
  this.SetSelectedIndexCore(index);
  this.UnlockSelectionEvents();
  return index != oldSelectionIndex;
 },
 SetItemSelectionAppearance: function (index, selected, controller, checkCanChangeSelection) {
  if (checkCanChangeSelection && !this.CanChangeSelection())
   return;
  if(!controller)
   controller = ASPx.GetStateController();
  var itemFirstTextCell = this.GetItemFirstTextCell(index);
  if(selected)
   controller.SelectElementBySrcElement(itemFirstTextCell);
  else
   controller.DeselectElementBySrcElement(itemFirstTextCell);
 },
 GetItemSelectionHelper: function(){
  if(!this.itemSelectionHelper)
   this.itemSelectionHelper = this.CreateItemSelectionHelper();
  return this.itemSelectionHelper;
 },
 CreateItemSelectionHelper: function(){
  if(this.selectionMode == ListBoxSelectionMode.Single)
   return new ListBoxSingleSelectionHelper(this);
  else if(this.selectionMode == ListBoxSelectionMode.Multiple)
   return new ListBoxMultiSelectionHelper(this);
  else if(this.selectionMode == ListBoxSelectionMode.CheckColumn)
   return new ListBoxCheckSelectionHelper(this);
 },
 GetValue: function(){
  var index = this.GetSelectedIndex();
  if(0 <= index && index < this.itemsValue.length)
   return this.itemsValue[index];
  return null;
 },
 SetValue: function(value){
  var index = this.FindItemIndexByValue(value);
  this.SetSelectedIndex(index);
 },
 GetSelectedItem: function(){
  var index = this.GetSelectedIndex();
  return this.GetItem(index);
 },
 GetSelectedIndex: function(){
  if(!this.itemSelectionHelper)
   return this.GetSelectedIndexInternal();
  return this.GetItemSelectionHelper().GetSelectedIndex();
 },
 SetSelectedIndex: function(index){
  this.LockSelectionEvents();
  this.SetSelectedIndexCore(index);
  this.EnsureSelectedItemVisible(index);
  this.UnlockSelectionEvents();
 },
 SetSelectedIndexCore: function(index){
  this.GetItemSelectionHelper().SetSelectedIndex(index);
 },
 GetSelectedIndices: function(){
  return this.GetItemSelectionHelper().GetSelectedIndices();
 },
 GetSelectedValues: function(){ 
  return this.GetItemSelectionHelper().GetSelectedValues();
 },
 GetSelectedItems: function(){
  return this.GetItemSelectionHelper().GetSelectedItems();
 },
 SelectAll: function(){
  this.SelectIndices();
 },
 UnselectAll: function(){
  this.UnselectIndices();
 },
 SelectIndices: function(indices){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectIndices(indices);
  this.UnlockSelectionEvents();
 },
 SelectItems: function(items){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectItems(items);
  this.UnlockSelectionEvents();
 },
 SelectValues: function(values){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectValues(values);
  this.UnlockSelectionEvents();
 },
 UnselectIndices: function(indices){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectIndices(indices);
  this.UnlockSelectionEvents();
 },
 UnselectItems: function(items){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectItems(items);
  this.UnlockSelectionEvents();
 },
 UnselectValues: function(values){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectValues(values);
  this.UnlockSelectionEvents();
 },
 GetIsItemSelected: function(index){
  return this.GetItemSelectionHelper().GetIsItemSelected(index);
 },
 GetFocusedIndex: function(){
  return this.GetItemSelectionHelper().GetFocusedIndex();
 },
 UpdateInternalState: function(){
  this.UpdateHiddenInputs();
 },
 IsUpdateHiddenInputsLocked: function(){
  return this.GetItemSelectionHelper().IsUpdateInternalSelectionStateLocked();
 },
 UpdateHiddenInputs: function(){
  if(this.IsUpdateHiddenInputsLocked())
   return;
  if(this.MultiSelectionMode()){ 
   var element = this.FindStateInputElement();
   if(ASPx.IsExistsElement(element)) {
    var sb = [ ];
    var serialiser = this.GetSerializingHelper();
    var selectedIndices = this.GetSelectedIndices();
    for(var i = 0; i < selectedIndices.length; i++)
     serialiser.SerializeAtomValue(sb, this.GetItemValue(selectedIndices[i]));
    element.value = sb.join("");
   }
  } else 
   ASPxClientListBoxBase.prototype.UpdateHiddenInputs.call(this);
 },
 UseDelayedSpecialFocus: function() { 
  return true;
 },
 AdjustWidthInDropDown: function(parentComboBoxMainElement, isCallbackMode, customWidth) {
  var lbScrollDiv = this.GetScrollDivElement();
  var lbMainElement = this.GetMainElement();
  var scrollWidth = 0;
  if (this.IsMultiColumn() && isCallbackMode && this.GetScrollSpacerVisibility(false) && this.GetBottomScrollSpacerHeight() == 0)
   this.SetBottomScrollSpacerVisibility(true);
  var keepCurrentWidth = this.HasVirtualScrolling() && this.hasDecoratedItems && this.isComboBoxScrollingCallbackProcessing;
  if(!keepCurrentWidth) {
   lbMainElement.style.width = "";
   lbScrollDiv.style.paddingRight = "0px";
   lbScrollDiv.style.width = "100%";
  }
  else
   this.isComboBoxScrollingCallbackProcessing = false;
  if (customWidth != "") {
   lbMainElement.style.width = customWidth;
   var width = lbMainElement.clientWidth;
   var scrollInfo = this.SetScrollDivAndCorrectionForScroll(width, false);
   width = scrollInfo.scrollDivWidth;
   scrollWidth = scrollInfo.scrollWidth;
   if((!ASPx.Browser.IE || this.HasVirtualScrolling()) && !this.enableEllipsis) {
    var difference = this.GetItemsWidth() - lbScrollDiv.clientWidth;
    if (difference > 0) {
     lbMainElement.style.width = (lbMainElement.offsetWidth + difference) + "px";
     lbScrollDiv.style.width = (lbMainElement.clientWidth) + "px";
    }
   }
  } else {
   var width = this.GetItemsWidth();
   var scrollInfo = this.SetScrollDivAndCorrectionForScroll(width, true);
   width = scrollInfo.scrollDivWidth;
   scrollWidth = scrollInfo.scrollWidth;
   if (ASPx.Browser.Firefox && lbMainElement.offsetWidth < lbScrollDiv.offsetWidth)
    lbMainElement.style.width = "0%"; 
   if (parentComboBoxMainElement) {
    var widthDifference = parentComboBoxMainElement.offsetWidth - lbMainElement.offsetWidth;
    if (widthDifference > 0) {
     this.scrollDivMinWidth = width + widthDifference;
     lbScrollDiv.style.width = this.scrollDivMinWidth + "px";
     var twoBorderSize = (lbMainElement.offsetWidth - lbMainElement.clientWidth);
     lbMainElement.style.width = (width + widthDifference + twoBorderSize) + "px"; 
    }
   }
  }
  if (this.IsMultiColumn())
   this.CorrectMultiColumnHeaderWidth(scrollWidth);
  if (this.NeedToHandleCellWidth())
   this.CorrectCellNullWidthStyle(this.itemsManager.GetFirstVisibleItemRow());
  if (this.ContainsFixWidthRow()) {
   var lbHeaderDiv = this.GetHeaderDivElement();
   if (lbHeaderDiv)
    lbScrollDiv.style.width = lbHeaderDiv.offsetWidth - ASPx.GetLeftRightBordersAndPaddingsSummaryValue(lbScrollDiv) + "px";
  }
  return lbScrollDiv.offsetWidth;
 },
 SetScrollDivAndCorrectionForScroll: function(width, widthByContent) {
  var lbScrollDiv = this.GetScrollDivElement();
  var scrollWidth = this.GetVerticalScrollBarWidth();
  var browserCanHaveScroll = this.GetVerticalOverflow(lbScrollDiv) == "auto";
  if (widthByContent && browserCanHaveScroll)
   width += scrollWidth;
  lbScrollDiv.style.width = width + "px";
  return { scrollDivWidth: width, scrollWidth: scrollWidth };
 },
 BeforeAdjustHeightInDropDown: function() {
  this.GetMainElement().style.height = "0px";
 },
 AdjustHeightInDropDown: function(customHeight, visibleRowCount, getDefaultHeight) {
  this.BeforeAdjustHeightInDropDown();
  var lbHeight = 0;
  if (customHeight == "")
   lbHeight = this.GetHeightByContent(visibleRowCount, getDefaultHeight);
  else
   lbHeight = this.GetHeightByServerValue(customHeight);
  this.itemsManager.Adjust();
  this.InitializePageSize();
  return lbHeight;
 },
 GetHeightByContent: function(visibleRowCount, getDefaultHeight) {
  var lbScrollDiv = this.GetScrollDivElement(),
   itemCount = this.GetVisibleItemCount(),
   hasVerticalScrollbar = itemCount > visibleRowCount;
  lbScrollDiv.style.height = "";
  if (!hasVerticalScrollbar)
   lbScrollDiv.style.height = this.GetListTableHeight() + "px";
  var height = hasVerticalScrollbar ? this.GetItemsHeight() : Math.max(this.GetItemsHeight(), this.GetListTableHeight());
  if (hasVerticalScrollbar)
   height = getDefaultHeight(height, itemCount);
  else
   height = itemCount == 0 ? "0px" : height + "px";
  lbScrollDiv.style.height = height;
  height = lbScrollDiv.offsetHeight;
  height += ASPx.GetTopBottomBordersAndPaddingsSummaryValue(this.GetMainElement());
  var lbHeaderDiv = this.GetHeaderDivElement();
  if (ASPx.IsExists(lbHeaderDiv))
   height += lbHeaderDiv.offsetHeight;
  return height;
 },
 GetHeightByServerValue: function(customHeight) {
  var lbMainElement = this.GetMainElement();
  var lbScrollDiv = this.GetScrollDivElement();
  var height = customHeight;
  lbMainElement.style.height = "0px";
  lbScrollDiv.style.height = "0px";
  lbMainElement.style.height = height;
  var trueLbOffsetHeight = lbMainElement.offsetHeight;
  var trueLbClientHeight = lbMainElement.clientHeight;
  lbScrollDiv.style.height = lbMainElement.clientHeight + "px";
  var lbHeightCorrection = lbMainElement.offsetHeight - trueLbOffsetHeight;
  lbScrollDiv.style.height = (trueLbClientHeight - lbHeightCorrection) + "px";
  height = lbMainElement.offsetHeight;
  return height;
 },
 GetLoadingParentElement: function() {
  return this.GetScrollDivElement().parentNode;
 },
 ShowLoadingPanel: function() { 
  if(!this.isComboBoxList){
   var loadingParentElement = this.GetLoadingParentElement();
   var lp = this.CreateLoadingPanelWithAbsolutePosition(loadingParentElement);
   this.PreventMouseWheelOnElement(lp);
  }
 },
 ShowLoadingDiv: function () {
  if(!this.isComboBoxList){
   var loadingParentElement = this.GetLoadingParentElement();
   var ld = this.CreateLoadingDiv(loadingParentElement);
   this.PreventMouseWheelOnElement(ld);
  }
 },
 PreventMouseWheelOnElement: function(element) {
  if(!element) return;
  var wheelEventName = ASPx.Evt.GetMouseWheelEventName();
  ASPx.Evt.AttachEventToElement(element, wheelEventName, function(evt) {
   if(this.scrollHelper.GetIsAnySpacerVisible())
    ASPx.Evt.PreventEvent(evt);
  }.aspxBind(this));
 },
 ParseCallbackResult: function(result, shouldSelectSilentDelegate){
  var gottenEgdeOfCollection = false;
  var isLoadindToTopByScroll = this.scrollHelper.IsScrolledToTopSpacer();
  if(result[CONSTANTS.CALLBACK_RESULTS.ITEMS].length) {
   var deserializedItems = this.DeserializeItems(result[CONSTANTS.CALLBACK_RESULTS.ITEMS]);
   this.LoadItemsFromCallback(isLoadindToTopByScroll, deserializedItems, shouldSelectSilentDelegate);
   gottenEgdeOfCollection = deserializedItems.length < this.callbackPageSize;
  }
  var noMoreItemsForLoadThisDirection = !result[CONSTANTS.CALLBACK_RESULTS.ITEMS].length || gottenEgdeOfCollection;
  this.SetScrollSpacerVisibility(isLoadindToTopByScroll, !noMoreItemsForLoadThisDirection);
  this.scrollHelper.Reset();
 },
 LoadItemsFromCallback: function(isToTop, deserializedItems, shouldSelectSilentDelegate){
  this.LockSynchronizationOnInternalCallback();
  this.BeginUpdate();
  var isMultiSelect = this.MultiSelectionMode();
  this.RemoveAccessibilityHeaderRow();
  if(isToTop){
   var scrollHeightCorrection = 0;
   for(var i = deserializedItems.length - 1; i >= 0; i--) {
    this.InsertItemInternal(0, deserializedItems[i]);
    scrollHeightCorrection += this.GetItemHeight(0);
   } 
   this.GetScrollDivElement().scrollTop += scrollHeightCorrection;
   this.serverIndexOfFirstItem -= deserializedItems.length;
   if(this.serverIndexOfFirstItem < 0) this.serverIndexOfFirstItem = 0;
  } else {
   for(var i = 0; i < deserializedItems.length; i++) {
    var itemIndex = this.AddItemInternal(deserializedItems[i]);
    var shouldSelectSilent = shouldSelectSilentDelegate && shouldSelectSilentDelegate(deserializedItems[i].value, deserializedItems[i].text);
    this.SelectValueOnLoad(itemIndex, deserializedItems[i].selected, shouldSelectSilent, isMultiSelect);
   } 
  }
  if(this.changeSelectAfterCallback != 0) {
   var newIndex = this.GetSelectedIndex() + this.changeSelectAfterCallback;
   newIndex = this.GetAdjustedIndex(newIndex);
   this.SelectIndexSilent(newIndex);
   if(this.scrollHelper.isScrolledToTopSpacer)
    this.ScrollItemToTop(newIndex);
   else
    this.ScrollToItemVisible(newIndex);
  }
  this.AddAccessibilityHeaderRow();
  this.EndUpdate();
  this.UnlockSynchronizationOnInternalCallback();
 },
 SelectValueOnLoad: function (index, selected, shouldSelectSilent, isMultiSelect) {
  if(selected && this.changeSelectAfterCallback == 0) {
   if(isMultiSelect) {
    this.SelectIndices([index]);
   } else {
    if(shouldSelectSilent)
     this.SelectIndexSilent(index);
    else
     this.SelectIndex(index);
   }
  }
 },
 CreateSerializingHelper: function(){
  return new ListBoxItemsSerializingHelper(this);
 },
 InCallback: function(){
  var callbackOwner = this.GetCallbackOwnerControl();
  if(callbackOwner != null)
   return callbackOwner.InCallback();
  return ASPxClientListEdit.prototype.InCallback.call(this);
 },
 GetItemsRangeForLoad: function(){
  return this.scrollHelper.GetItemsRangeForLoad();
 },
 GetScrollSpacerElement: function(isTop){
  return document.getElementById(this.name + (isTop ? lbTSIdSuffix : lbBSIdSuffix));
 },
 GetScrollSpacerVisibility: function(isTop){
  if(!this.clientEnabled)
   return false;
  return isTop ? this.isTopSpacerVisible : this.isBottomSpacerVisible;
 },
 SetScrollSpacerVisibility: function(isTop, visibility){
  this.LockScrollHandler();
  var spacer = this.GetScrollSpacerElement(isTop);
  if(spacer){
   if(visibility)
    spacer.style.height = this.GetRequiredScrollSpacerHeight() + "px";
   if(this.clientEnabled){
    if(isTop)
     this.isTopSpacerVisible = visibility;
    else
     this.isBottomSpacerVisible = visibility;
   }
   if(ASPx.GetElementDisplay(spacer) != visibility){
    ASPx.SetElementDisplay(spacer, visibility);
    ASPx.GetElementVisibility(spacer, visibility);
   }
  }
  this.itemsManager.OnScrollSpacerVisibilityChanged();
  this.UnlockScrollHandler();
 },
 GetRequiredScrollSpacerHeight: function() {
  return this.GetScrollDivElement().clientHeight;
 },
 SetTopScrollSpacerVisibility: function(visibility){
  this.SetScrollSpacerVisibility(true, visibility);
 },
 SetBottomScrollSpacerVisibility: function(visibility){
  this.SetScrollSpacerVisibility(false, visibility);
 },
 GetTopScrollSpacerHeight: function(){
  return this.GetScrollSpacerVisibility(true) ? this.GetScrollSpacerElement(true).clientHeight : 0;
 },
 GetBottomScrollSpacerHeight: function(){
  return this.GetScrollSpacerVisibility(false) ? this.GetScrollSpacerElement(false).clientHeight : 0;
 },
 GetTopSpacersHeight: function() {
  return this.itemsManager.GetTopSpacersHeight();
 },
 SendCallback: function(onSuccess) {
  if(!this.InCallback()){
   this.ShowLoadingElements();
   var callbackOwner = this.GetCallbackOwnerControl();
   if(callbackOwner != null)
    callbackOwner.SendCallback(onSuccess);
   else {
    var argument = this.GetCallbackArguments();
    this.CreateCallback(argument, null, onSuccess);
   }
  }
 },
 OnCallback: function(result, shouldSelectSilentDelegate) {
  if(result.serverMode)
   this.UpdateStateObjectWithObject({serverMode: true});
  if(!this.filterStrategy || !this.filterStrategy.ShouldDiscardCallbackResult()) {
   this.ParseCallbackResult(result, shouldSelectSilentDelegate);
   if(!this.isComboBoxList)
    this.filterStrategy.OnCallback(result);
   this.OnCallbackFinally();
  }
 },
 OnCallbackError: function(result){
  ASPxClientListBoxBase.prototype.OnCallbackError.call(this, result);
  this.OnCallbackFinally();
 },
 OnCallbackFinally: function () {
  this.itemsManager.Adjust();
  this.HideLoadingPanel();
  this.changeSelectAfterCallback = 0;
 },
 DoEndCallback: function() {
  this.filterStrategy.OnBeforeDoEndCallback();
  ASPxClientListBoxBase.prototype.DoEndCallback.call(this);
  this.filterStrategy.OnAfterDoEndCallback();
 },
 RaiseEndCallback: function() {
  if(this.preventEndCallbackRising)
   this.preventEndCallbackRising = false;
  else
   ASPxClientListBoxBase.prototype.RaiseEndCallback.call(this);
 },
 LockScrollHandler: function(){
  this.scrollHandlerLockCount ++;
 },
 UnlockScrollHandler: function(){
  this.scrollHandlerLockCount --;
 },
 IsScrollHandlerLocked: function(){
  return this.scrollHandlerLockCount > 0;
 },
 OnScroll: function(){
  if(this.IsScrollHandlerLocked()) return;
  if(this.IsVisible() && !this.InCallback() && ( this.GetScrollSpacerVisibility(true) || this.GetScrollSpacerVisibility(false))) {
   this.scrollHelper.OnScroll();
   if(this.scrollHelper.GetIsNeedToHideTopSpacer())
    this.SetTopScrollSpacerVisibility(false);
   if(this.scrollHelper.GetIsNeedCallback()) {
    this.isComboBoxScrollingCallbackProcessing = this.isComboBoxList;
    this.SendCallback();
   }
  }
 },
 OnBrowserWindowResize: function(e) {
  if(this.IsVisible())
   this.CorrectSize();
 },
 KeyboardSupportAllowed: function(){
  return !this.CheckColumnSelectionMode();
 },
 InitializeKeyHandlers: function() {
  if(this.KeyboardSupportAllowed()){
   this.AddKeyDownHandler(ASPx.Key.PageUp, "OnPageUp");
   this.AddKeyDownHandler(ASPx.Key.PageDown, "OnPageDown");
   this.AddKeyDownHandler(ASPx.Key.End, "OnEndKeyDown");
   this.AddKeyDownHandler(ASPx.Key.Home, "OnHomeKeyDown");
   this.AddKeyDownHandler(ASPx.Key.Up, "OnArrowUp");
   this.AddKeyDownHandler(ASPx.Key.Down, "OnArrowDown");
  } else if(this.accessibilityCompliant && !this.IsNativeCheckBoxes()) {
   this.AddKeyDownHandler(ASPx.Key.Up, "OnAccessArrowUp");
   this.AddKeyDownHandler(ASPx.Key.Down, "OnAccessArrowDown");
  }
 },
 OnArrowUp: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(-1);
  return true;
 },
 OnArrowDown: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(1);
  return true;
 },
 OnAccessArrowUp: function(evt){
  if(!this.isInitialized) return true;
  var index = this.GetFocusedIndex();
  var isItemCheckBoxFocused = this.GetInternalCheckBox(index) && this.GetInternalCheckBox(index).focused;
  var isSelectAllCheckBoxFocused = this.selectAllCheckBox && this.selectAllCheckBox.focused;
  if(index > 0 && isItemCheckBoxFocused)
   this.SetFocusedIndex(index - 1);
  else if(index == 0 && this.selectAllCheckBox && !isSelectAllCheckBoxFocused) {
   this.selectAllCheckBox.mainElement.focus();
   this.GetItemSelectionHelper().SetFocusedIndexInternal(index, false);
  }
  else
   this.SetFocusedIndex(this.GetItemCount() - 1);
  return true;
 },
 OnAccessArrowDown: function(evt){
  if(!this.isInitialized) return true;
  var index = this.GetFocusedIndex();
  var isItemCheckBoxFocused = this.GetInternalCheckBox(index) && this.GetInternalCheckBox(index).focused;
  var isSelectAllCheckBoxFocused = this.selectAllCheckBox && this.selectAllCheckBox.focused;
  if(index < this.GetItemCount() - 1 && isItemCheckBoxFocused)
   this.SetFocusedIndex(index + 1);
  else if(index == this.GetItemCount() - 1 && this.selectAllCheckBox && !isSelectAllCheckBoxFocused) {
   this.selectAllCheckBox.mainElement.focus();
   this.GetItemSelectionHelper().SetFocusedIndexInternal(index, false);
  }
  else
   this.SetFocusedIndex(0);
  return true;
 },
 SetFocusedIndex: function(index) {
  if(this.GetIsCheckColumnExists()) {
   this.MakeItemVisible(index);
   setTimeout(function () { this.GetInternalCheckBox(index).mainElement.focus(); }.aspxBind(this), 0);
  }
  this.GetItemSelectionHelper().SetFocusedIndexInternal(index, false);
 },
 OnPageUp: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(-this.scrollPageSize);
  return true;
 },
 OnPageDown: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(this.scrollPageSize);
  return true;
 },
 OnHomeKeyDown: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(-this.GetItemCount());
  return true;
 },
 OnEndKeyDown: function(evt){
  if(this.isInitialized)
   this.SelectNeighbour(this.GetItemCount());
  return true;
 },
 GetAdjustedIndex: function(index){
  if(index < 0) index = 0;
  else{
   var itemCount = this.GetItemCount();
   if(index >= itemCount) index = itemCount - 1;
  }
  return index;
 },
 SelectNeighbour: function (step) {
  var itemCount = this.GetItemCount();
  if(itemCount > 0) {
   this.changeSelectAfterCallback = 0;
   var selectedIndex = this.GetFocusedIndex();
   var newSelectedIndex = this.GetNewSelectedIndex(selectedIndex, step);
   newSelectedIndex = this.GetAdjustedIndex(newSelectedIndex);
   if(selectedIndex != newSelectedIndex && this.IsItemFiltered(newSelectedIndex)) {
    this.LockScrollOnKBNavigation();
    this.SetSelectedIndexCore(newSelectedIndex);
    this.UnlockScrollOnKBNavigation();
   }
   if(this.GetIsNeedToCallbackLoadItemsToTop(newSelectedIndex, step, itemCount)) {
    this.LoadItemsOnCallback(true, newSelectedIndex);
   } else if(this.GetIsNeedToCallbackLoadItemsToBottom(newSelectedIndex, step, itemCount)) {
    this.LoadItemsOnCallback(false, newSelectedIndex);
   }
   this.ScrollToItemVisible(newSelectedIndex);
  }
 },
 GetNewSelectedIndex: function(selectedIndex, step) {
  var pageDownSize = step == 1 ? this.scrollPageSize + 1 : this.scrollPageSize; 
  var isFirstPageDown = selectedIndex == -1 && step == pageDownSize && step > 1;
  if(isFirstPageDown)
   step++;
  var newSelectedIndex = 0;
  var areThereUnfilteredItems = this.GetVisibleItemCount() < this.GetItemCount();
  if(areThereUnfilteredItems)
   newSelectedIndex = this.itemsManager.GetNewItemIndexInFilteredRange(selectedIndex, step);
  else
   newSelectedIndex = selectedIndex + step;
  return newSelectedIndex;
 },
 GetIsNeedToCallbackLoadItemsToTop: function(selectedIndex, step, itemCount){
  return this.isCallbackMode && this.GetScrollSpacerVisibility(true) && 
   this.serverIndexOfFirstItem > 0 && ((step < 0 && selectedIndex <= 0) || step <= -itemCount);
 },
 GetIsNeedToCallbackLoadItemsToBottom: function(selectedIndex, step, itemCount){
  return this.isCallbackMode && this.GetScrollSpacerVisibility(false) && 
   ((step > 0 && selectedIndex >= itemCount - 1) || step >= itemCount);
 },
 LoadItemsOnCallback: function(isToTop, index){
  this.changeSelectAfterCallback = index - this.GetSelectedIndex();
  this.scrollHelper.SetItemsRangeForLoad(isToTop);
  this.isComboBoxScrollingCallbackProcessing = this.isComboBoxList;
  this.SendCallback();
 },
 FindInputElement: function(){
  if(this.accessibilityCompliant)
   return this.isComboBoxList ? null : this.GetAccessibilityAssistantElement();
  return this.GetKBSInput();
 },
 GetKBSInput: function() {
  return this.GetChildElement("KBS");
 },
 GetAccessibilityActiveElements: function() {
  var accessibilityElements = [];
  if(this.CheckColumnSelectionMode()) {
   for(var i = 0; i < this.GetItemCount() ; i++) {
    var checkBoxFocusableElement = this.GetCheckBoxFocusableElement(i);
    if(checkBoxFocusableElement)
     accessibilityElements.push(checkBoxFocusableElement);
   }
  }
  accessibilityElements.push(this.accessibilityCompliant ? this.GetAccessibilityHelper().GetActiveElement() : this.GetInputElement());
  return accessibilityElements;
 },
 SetHoverElement: function(element){
  ASPx.GetStateController().SetCurrentHoverElementBySrcElement(element);
 },
 InitOnContainerMadeVisible: function(){
  this.AdjustControl();
 },
 ClearItemsCore: function(){
  this.itemsManager.ClearItems();
  this.EnsureFixWidthRow();
  this.AddAccessibilityHeaderRow();
  this.OnItemsCleared();
  this.SetValue(null);
 },
 OnItemsCleared: function(){
  this.GetItemSelectionHelper().OnItemsCleared();
 },
 CorrectCellWidthsOnFirstRowItemReplacement: function(oldFirstRowItemIndex, newFirstRowItemIndex) {
  if (!this.ContainsFixWidthRow() && !this.HasVirtualScrolling()) {
   var oldFirstRowItemHasTemplate = this.ItemRowHasTemplate(oldFirstRowItemIndex);
   var newFirstRowItemHasTemplate = this.ItemRowHasTemplate(newFirstRowItemIndex);
   if(!oldFirstRowItemHasTemplate && !newFirstRowItemHasTemplate)
    this.CopyCellWidths(oldFirstRowItemIndex, newFirstRowItemIndex);
  }
 },
 CopyCellWidths: function(sourceRowIndex, destinationRowIndex){
  var cellCount = this.GetItemCellCount();
  var sourceRow = this.GetItemRow(sourceRowIndex);
  var destRow = this.GetItemRow(destinationRowIndex);
  if (!sourceRow || !destRow) return; 
  var lastDestCellIndex = destRow.cells.length - 1;
  for(var i = 0; i < lastDestCellIndex; i++) {
   destRow.cells[i].style.width = sourceRow.cells[i].style.width;
  }
  if(destRow.cells.length === cellCount) {
   destRow.cells[lastDestCellIndex].style.width = sourceRow.cells[lastDestCellIndex].style.width;
  } else {
   var cellWidths = ASPx.Data.CollectionToArray(sourceRow.cells)
    .slice(lastDestCellIndex)
    .map(function(cell) { return ASPx.PxToInt(cell.style.width); })
    .reduce(function(accumulator, current) { return accumulator + current; }, 0);
   destRow.cells[lastDestCellIndex].style.width = cellWidths + "px";
  }
  if(this.NeedToHandleCellWidth())
   this.CorrectCellNullWidthStyle(destRow);
 },
 RemoveItem: function (index) {
  var firstRenderedItem = this.itemsManager.GetFirstRenderedItem();
  if (firstRenderedItem && index == firstRenderedItem.index && this.GetItemRow(firstRenderedItem.index + 1) !== null)
   this.CorrectCellWidthsOnFirstRowItemReplacement(firstRenderedItem.index, firstRenderedItem.index + 1);
  if (0 <= index && index < this.GetItemCount()) {
   this.UpdateSyncArraysItemDeleted(this.GetItem(index), true);
   this.itemsManager.RemoveItem(index);
   this.OnItemRemoved(index);
  }
 },
 GetItem: function(index, preventEncodeText) {
  return this.itemsManager.GetItem(index, preventEncodeText);
 },
 GetItemRowTexts: function(row) {
  var serializedTexts = this.GetTextsDataAttribute(row);
  if(ASPx.IsExists(serializedTexts))
   return JSON.parse(serializedTexts);
  var texts = [];
  var i = this.GetItemFirstTextCellIndex();
  var cellsLength = this.IsMultiColumn() ? row.cells.length : i + 1;
  for(; i < cellsLength; i++) {
   var textCell = row.cells[i];
   texts.push(ASPxClientListBox.GetItemCellInnerText(textCell));
  }
  return texts;
 },
 ItemRowHasTemplate: function(itemIndex) {
  var itemRow = this.GetItemRow(itemIndex);
  return itemRow ? this.ItemRowHasTemplateCore(itemRow) : false;
 },
 ItemRowHasTemplateCore: function(itemRow) {
  return this.ItemRowHasSerializedTextsAttr(itemRow);
 },
 ItemRowHasSerializedTextsAttr: function(itemRow) {
  return ASPx.Attr.IsExistsAttribute(itemRow, itemSerializedTextsAttributeName);
 },
 ItemCellHasTextAttr: function(itemTextCell) {
  return ASPx.Attr.IsExistsAttribute(itemTextCell, itemCellTextAttributeName);
 },
 GetFirstVisibleItem: function() {
  return this.itemsManager.GetFirstVisibleItem();
 },
 GetFirstFilteredItemIndex: function () {
  return this.itemsManager.GetFirstFilteredItemIndex();
 },
 PerformCallback: function(arg, onSuccess) {
  this.SetScrollSpacerVisibility(true, false);
  this.SetScrollSpacerVisibility(false, false);
  this.ClearItemsForPerformCallback();
  this.serverIndexOfFirstItem = 0;
  this.SetScrollSpacerVisibility(true, false);
  this.SetScrollSpacerVisibility(false, false);
  this.FormatAndSetCustomCallbackArg(arg, true);
  this.SendCallback(onSuccess);
  this.FormatAndSetCustomCallbackArg(arg, false);
 },
 GetTableRowParent: function(table){
  if(table.tBodies.length > 0)
   return table.tBodies[0];
  return table;
 },
 ProtectWhitespaceSerieses: function(text){
  if(text == "") 
   text = nbsp;
  else {
   if(text.charAt(0) == ' ')
    text = nbsp + text.slice(1);
   if(text.charAt(text.length - 1) == ' ')
    text = text.slice(0, -1) + nbsp;
   text = text.replace(new RegExp("  ", "g"), " &nbsp;");
  }
  return text;
 }, 
 InsertItemInternal: function(index, itemProperties) {
  if(!this.hasSampleItem) 
   return;
  this.AdjustItemProperties(itemProperties);
  ASPx.Data.ArrayInsert(this.itemsValue, itemProperties.value, index);
  this.itemsManager.InsertItem(index, itemProperties);
  this.RegisterInsertedItem(index, itemProperties);
  this.OnItemInserted(index);
 },
 GetListTableRowBeforeNewItemRow: function (newItemIndex, listTable) {
  var lastRenderedItem = this.itemsManager.GetLastRenderedItem();
  if (!lastRenderedItem || lastRenderedItem.index < newItemIndex) {
   var lastItemRow = lastRenderedItem ? this.GetItemRow(lastRenderedItem.index) : null;
   var lastListTableRow = listTable.rows[listTable.rows.length - 1];
   if (lastItemRow)
    return lastItemRow === lastListTableRow ? null : lastItemRow.nextSibling;
   if (!!this.GetAccessibilityHeaderRow())
    return this.ContainsFixWidthRow() ? listTable.rows[1] : listTable.rows[0];
   return null;
  }
  for (var i = 0; i < listTable.rows.length; i++)
   if (this.GetItemIndexByRow(listTable.rows[i]) >= newItemIndex)
    return listTable.rows[i];
  return null;
 },
 AdjustItemProperties: function(itemProperties) {
  if(!itemProperties.texts || itemProperties.texts.length == 0)
   itemProperties.texts = [""];
  else if(typeof (itemProperties.texts) === "string")
   itemProperties.texts = [itemProperties.texts];
  if(typeof (itemProperties.value) === "undefined")
   itemProperties.value = itemProperties.texts[0];
  if(!ASPx.IsExists(itemProperties.imageUrl) || itemProperties.imageUrl === "")
   itemProperties.imageUrl = this.defaultImageUrl;
 },
 AddStateControllerClasses: function(itemId){
  var itemCellsIdPostfixes = this.GetItemCellsIdPostfixes();
  var sampleItemFirstTextCell = this.GetSampleItemFirstTextCell();
  var styleController = ASPx.GetStateController();
  var hoverStyleClasses = this.CreateStyleClasses(itemId, itemCellsIdPostfixes, 
      styleController.GetHoverElement(sampleItemFirstTextCell), ASPx.HoverItemKind);
  var selectedStyleClasses = this.CreateStyleClasses(itemId, itemCellsIdPostfixes, 
      styleController.GetSelectedElement(sampleItemFirstTextCell), ASPx.SelectedItemKind);
  var disabledStyleClasses = this.CreateStyleClasses(itemId, itemCellsIdPostfixes, 
      styleController.GetDisabledElement(sampleItemFirstTextCell), ASPx.DisabledItemKind);
    ASPx.AddHoverItems(this.name, hoverStyleClasses, true);
    ASPx.AddSelectedItems(this.name, selectedStyleClasses, true);
    ASPx.AddDisabledItems(this.name, disabledStyleClasses, true);
  ASPx.Attr.RemoveAttribute(sampleItemFirstTextCell, ASPx.CachedStatePrefix + ASPx.HoverItemKind);
  ASPx.Attr.RemoveAttribute(sampleItemFirstTextCell, ASPx.CachedStatePrefix + ASPx.SelectedItemKind);
  ASPx.Attr.RemoveAttribute(sampleItemFirstTextCell, ASPx.CachedStatePrefix + ASPx.DisabledItemKind);
 },
 RemoveStateControllerClasses: function(itemId){
  var itemCellsIdPostfixes = this.GetItemCellsIdPostfixes();
  var classes = [];
  classes[0] = [];
  classes[0][0] = [itemId];
  classes[0][1] = itemCellsIdPostfixes;
    ASPx.RemoveHoverItems(this.name, classes);
    ASPx.RemoveSelectedItems(this.name, classes);
    ASPx.RemoveDisabledItems(this.name, classes);
 },
 GetCellInfo: function(index, infoArray) {
  if(!infoArray) return null;
  var filteredArray = infoArray.filter(function(info) { return info.index === index; });
  return filteredArray.length ? filteredArray[0].value : null;
 },
 PrepareItem: function(newItemRow, itemProperties) {
  var i = 0;
  if(this.GetIsCheckColumnExists())
   i++;
  if(this.imageCellExists) {
   this.PrepareItemImage(newItemRow, i, itemProperties.imageUrl);
   i++;
  }
  if(itemProperties.htmlContent) {
   this.SetItemHtmlContent(newItemRow, itemProperties.htmlContent);
   this.SetTextsDataAttribute(newItemRow, itemProperties.texts);
  } else {
   this.SetItemTextContent(i, newItemRow, itemProperties);
  }
  this.AssignDecorationSettingsToElement(newItemRow, itemProperties.style, itemProperties.cssClass, itemProperties.tooltip, itemProperties.attributes);
 },
 LockRunStartupSciptsInItemRow: function() {
  this.lockRunStartupScipts = true;
 },
 UnlockRunStartupSciptsInItemRow: function() {
  this.lockRunStartupScipts = false;
 },
 IsRunStartupSciptsInItemRowLocked: function() {
  return this.lockRunStartupScipts;
 },
 EnsureStartupScriptsInContainer: function(container) {
  if(!this.InCallback() && !this.IsRunStartupSciptsInItemRowLocked())
   ASPx.RunStartupScripts(false, container);
 },
 SetItemHtml: function(index, html) {
  this.hasDecoratedItems = true;
  this.hasItemTemplate = true;
  this.EnsureFixWidthRow(true);
  this.itemsManager.SetItemHtml(index, html);
  this.ProcessItemRow(index, function(itemRow) {
   if(!this.ItemRowHasSerializedTextsAttr(itemRow))
    this.SetTextsDataAttribute(itemRow, this.GetItem(index).texts);
   this.SetItemHtmlContent(itemRow, html);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 SetTextsDataAttribute: function(itemRow, texts) { ASPx.Attr.SetAttribute(itemRow, itemSerializedTextsAttributeName, JSON.stringify(texts)); },
 GetTextsDataAttribute: function(itemRow) { return ASPx.Attr.GetAttribute(itemRow, itemSerializedTextsAttributeName); },
 SetItemTooltip: function(index, tooltip) {
  this.itemsManager.SetItemTooltip(index, tooltip);
  this.ProcessItemRow(index, function(itemRow) { this.SetElementTooltip(itemRow, tooltip); }.aspxBind(this));
 },
 SetItemAttribute: function(index, attributeName, attributeValue) {
  this.itemsManager.SetItemAttribute(index, attributeName, attributeValue);
  this.ProcessItemRow(index, function(itemRow) { ASPx.Attr.SetAttribute(itemRow, attributeName, attributeValue); }.aspxBind(this));
 },
 AddItemCssClass: function(index, className) {
  this.hasDecoratedItems = true;
  this.itemsManager.AddItemCssClass(index, className);
  this.ProcessItemRow(index, function(itemRow) {
   ASPx.AddClassNameToElement(itemRow, className);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 RemoveItemCssClass: function(index, className) {
  this.hasDecoratedItems = true;
  this.itemsManager.RemoveItemCssClass(index, className);
  this.ProcessItemRow(index, function(itemRow) {
   ASPx.RemoveClassNameFromElement(itemRow, className);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 SetItemTextCellHtml: function(itemIndex, textCellIndex, html) {
  this.hasDecoratedItems = true;
  this.itemsManager.SetItemTextCellHtml(itemIndex, textCellIndex, html);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) {
   if(!this.ItemCellHasTextAttr(textCell))
    this.SetItemCellTextDataAttribute(textCell, this.GetItem(itemIndex).texts[textCellIndex]);
   this.SetItemTextCellHtmlContent(textCell, html);
   this.itemsManager.OnDecoratedItemsRendering();
  }.aspxBind(this));
 },
 SetItemCellTextDataAttribute: function(textCell, text) {
  ASPx.Attr.SetAttribute(textCell, itemCellTextAttributeName, text);
 },
 SetItemTextCellTooltip: function(itemIndex, textCellIndex, tooltip) {
  this.itemsManager.SetItemTextCellTooltip(itemIndex, textCellIndex, tooltip);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) { this.SetElementTooltip(textCell, tooltip); }.aspxBind(this));
 },
 SetItemTextCellAttribute: function(itemIndex, textCellIndex, attributeName, attributeValue) {
  this.itemsManager.SetItemTextCellAttribute(itemIndex, textCellIndex, attributeName, attributeValue);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) { ASPx.Attr.SetAttribute(textCell, attributeName, attributeValue); }.aspxBind(this));
 },
 AddItemTextCellCssClass: function(itemIndex, textCellIndex, className) {
  this.hasDecoratedItems = true;
  this.itemsManager.AddItemTextCellCssClass(itemIndex, textCellIndex, className);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) {
   ASPx.AddClassNameToElement(textCell, className);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 RemoveItemTextCellCssClass: function(itemIndex, textCellIndex, className) {
  this.hasDecoratedItems = true;
  this.itemsManager.RemoveItemTextCellCssClass(itemIndex, textCellIndex, className);
  this.ProcessItemTextCell(itemIndex, textCellIndex, function(textCell) {
   ASPx.RemoveClassNameFromElement(textCell, className);
   this.itemsManager.OnDecoratedItemsRendering();
  }.bind(this));
 },
 ProcessItemRow: function(index, action) {
  var itemRow = this.GetItemRow(index);
  if(itemRow)
   action(itemRow);
 },
 ProcessItemTextCell: function(itemIndex, textCellIndex, action) {
  var itemTextCell = this.GetItemTextCell(itemIndex, textCellIndex);
  if(itemTextCell && !this.ItemRowHasTemplateCore(itemTextCell.parentNode))
   action(itemTextCell);
 },
 SetItemHtmlContent: function(itemRow, html) {
  var redundantCells = ASPx.Data.CollectionToArray(itemRow.cells)
   .slice(this.GetItemFirstTextCellIndex(), itemRow.cells.length - 1);
  redundantCells.forEach(function(cell) { itemRow.removeChild(cell); });
  var itemHtmlContainerCell = itemRow.cells[itemRow.cells.length - 1];
  ASPx.SetElementDisplay(itemHtmlContainerCell, this.GetVisibleColumnCount() !== 0);
  itemHtmlContainerCell.colSpan = Math.max(itemHtmlContainerCell.colSpan, this.GetVisibleColumnCount());
  if(this.IsMultiColumn()) {
   if(this.GetItemFirstTextCellIndex() === 0)
    ASPx.AddClassNameToElement(itemHtmlContainerCell, FIRST_CELL_MARKER_CSS_CLASS_NAME);
   ASPx.AddClassNameToElement(itemHtmlContainerCell, LAST_CELL_MARKER_CSS_CLASS_NAME);
  }
  itemHtmlContainerCell.style.width = "";
  itemHtmlContainerCell.innerHTML = html;
  this.RemoveEllipsisFromNode(itemHtmlContainerCell);
  this.EnsureStartupScriptsInContainer(itemHtmlContainerCell);
 },
 SetItemTextContent: function(textCellIndex, newItemRow, itemProperties) {
  var cellCount = this.GetItemCellCount();
  for(var j = 0; textCellIndex < cellCount; textCellIndex++, j++) {
   var cellStyle = this.GetCellInfo(j, itemProperties.cellStyles);
   var cellCssClass = this.GetCellInfo(j, itemProperties.cellCssClasses);
   var cellTooltip = this.GetCellInfo(j, itemProperties.cellTooltips);
   var cellAttributes = this.GetCellInfo(j, itemProperties.cellAttributes);
   var htmlContent = this.GetCellInfo(j, itemProperties.htmlContents);
   this.PrepareItemTextCell(newItemRow.cells[textCellIndex], itemProperties.texts[j], cellStyle, cellCssClass, cellTooltip, cellAttributes, htmlContent);
  }
 },
 SetItemTextCellHtmlContent: function(cell, html) {
  cell.innerHTML = html;
  this.RemoveEllipsisFromNode(cell);
  this.EnsureStartupScriptsInContainer(cell);
 },
 PrepareItemImage: function(newItemRow, imageCellIndex, imageUrl){
  var imageCell = newItemRow.cells[imageCellIndex];
  var image = ASPx.GetNodeByTagName(imageCell, "IMG", 0);
  if(!imageUrl) {
   if(image)
    ASPx.RemoveElement(image);
   imageCell.innerHTML = "&nbsp;";
  } else {
   if(!image) {
    image = document.createElement("IMG");
    imageCell.innerHTML = "";
    imageCell.appendChild(image);
   }
   ASPx.ImageUtils.SetImageSrc(image, imageUrl);
  }
 }, 
 PrepareItemTextCell: function(cell, text, style, cssClass, tooltip, attributes, htmlContent) {
  if(!ASPx.IsExists(text)) 
   text = "";
  if(this.encodeHtml)
   text = ASPx.Str.EncodeHtml(text);
  if(htmlContent) {
   this.SetItemTextCellHtmlContent(cell, htmlContent);
   this.SetItemCellTextDataAttribute(cell, this.ProtectWhitespaceSerieses(text));
  }
  else {
   cell.innerHTML = this.ProtectWhitespaceSerieses(text);
   if(this.enableEllipsis)
    ASPx.AddClassNameToElement(cell, ASPx.ELLIPSIS_MARKER_CLASS);
  }
  this.AssignDecorationSettingsToElement(cell, style, cssClass, tooltip, attributes);
  if(text == "")
   ASPx.Attr.SetAttribute(cell, "DXText", text);
 },
 AssignDecorationSettingsToElement: function(element, style, cssClass, tooltip, attributes) {
  if(cssClass)
   ASPx.AddClassNameToElement(element, cssClass);
  if(style) {
   var styleSheet = ASPx.GetCurrentStyleSheet();
   ASPx.AddClassNameToElement(element, ASPx.CreateImportantStyleRule(styleSheet, style));
  }
  if(tooltip)
   this.SetElementTooltip(element, tooltip);
  if(attributes)
   for(var key in attributes)
    if(attributes.hasOwnProperty(key))
     ASPx.Attr.SetAttribute(element, key, attributes[key]);
 },
 SetElementTooltip: function(element, tooltip) {
  this.RemoveEllipsisTooltip(element);
  ASPx.Attr.SetAttribute(element, "title", tooltip);
 },
 FormatText: function(texts, value) {
  if(typeof(texts) === "string")
   return texts;
  else if(!this.IsMultiColumn())
   return texts[0];
  else
   return this.FormatTextCore(texts, value);
 },
 FormatTextCore: function(texts, value) {
  var result = "";
  if(this.isComboBoxList) {
   if(this.nullValueItemDisplayText !== null && value === null)
    result = this.nullValueItemDisplayText;
   else
    result = ASPx.Formatter.Format(this.textFormatString, texts);
  } else
   result = texts.join("; ");
  return result;
 },
 OnItemInserted: function(index){
  this.GetItemSelectionHelper().OnItemInserted(index);
 },
 OnItemRemoved: function(index){
  this.GetItemSelectionHelper().OnItemRemoved(index);
 },
 CreateItemId: function(index){
  return lbIIdSuffix + index;
 },
 CreateItemClientId: function(index){
  return this.name + "_" + lbIIdSuffix + index;
 },
 CreateStyleClasses: function(id, postfixes, item, kind){
  var classes = [];
  if(item && item[kind]){
   classes[0] = [];
   classes[0][0] = item[kind].classNames;
   classes[0][1] = item[kind].cssTexts;
   classes[0][2] = [];
   classes[0][2][0] = id;
   classes[0][3] = postfixes;
  }
  return classes;
 },
 CorrectSizeByTimer: function(){
  if(this.APILockCount == 0 && this.IsDisplayed())
   window.setTimeout(function() { this.OnCorrectSizeByTimer(); }.aspxBind(this), 0);
 },
 FindFreeIndex: function(){
  return this.freeUniqIndex ++;
 },
 GetSampleItemRowID: function(){
  return this.name + "_" + lbSIIdSuffix;
 },
 GetAccessibilitySampleHeaderRowID: function() {
  return this.name + "_" + lbAIRTIdSuffix;
 },
 GetSampleItemRow: function(){
  if(this.SampleItem == null)
   this.SampleItem = ASPx.GetElementById(this.GetSampleItemRowID());
  return this.SampleItem;
 },
 GetAccessibilitySampleHeaderRow: function() {
  if(this.sampleHeaderRow == null)
   this.sampleHeaderRow = ASPx.GetElementById(this.GetAccessibilitySampleHeaderRowID());
  return this.sampleHeaderRow;
 },
 AddAccessibilityHeaderRow: function() {
  if(!this.accessibilityCompliant || !this.IsMultiColumn()) return;
  var listTableBody = ASPx.GetChildByTagName(this.GetListTable(), "TBODY", 0);
  var headerRow = this.GetAccessibilitySampleHeaderRow().cloneNode(true);
  headerRow.id = this.GetAccessibilityHeaderRowID();
  listTableBody.appendChild(headerRow);
 },
 GetAccessibilityHeaderRow: function() {
  return this.GetChildElement(lbAIRIdSuffix);
 },
 RemoveAccessibilityHeaderRow: function() {
  var headerRow = this.GetAccessibilityHeaderRow();
  if(headerRow)
   ASPx.RemoveElement(headerRow);
 },
 GetAccessibilityHeaderRowID: function() {
  return this.name + "_" + lbAIRIdSuffix;
 },
 GetSampleItemFirstTextCell: function(){
  if(!ASPx.IsExistsElement(this.sampleItemFirstTextCell)){
   var sampleItemRow = this.GetSampleItemRow();
   if(ASPx.IsExistsElement(sampleItemRow))
    this.sampleItemFirstTextCell = sampleItemRow.cells[this.imageCellExists ? 1 : 0];
  }
  return this.sampleItemFirstTextCell;
 },
 ChangeEnabledAttributes: function(enabled){
  this.ChangeListTableEvents(this.GetListTable(), ASPx.Attr.ChangeEventsMethod(enabled));
  var focusableElement = this.GetInputElement();
  if(focusableElement) {
   this.ChangeSpecialInputEnabledAttributes(focusableElement, ASPx.Attr.ChangeEventsMethod(enabled));
   if(this.accessibilityCompliant)
    this.ChangeFocusableElementTabIndex(focusableElement, enabled);
   else if(!this.isComboBoxList) {
    var changeMethod = enabled ? ASPx.Attr.RestoreTabIndexAttribute : ASPx.Attr.SaveTabIndexAttributeAndReset;
    changeMethod(focusableElement);
   }
  }
 },
 ChangeFocusableElementTabIndex: function(focusableElement, enabled) {
  if(!this.isComboBoxList) {
   if(enabled)
    ASPx.Attr.SetAttribute(focusableElement, "tabindex", "0");
   else
    focusableElement.removeAttribute("tabindex");
  }
 },
 ChangeEnabledStateItems: function(enabled){
  var controller = ASPx.GetStateController();
  controller.SetElementEnabled(this.GetMainElement(), enabled);
  var count = this.GetItemCount();
  var i = this.hasSampleItem ? -1 : 0 ;
  for(; i < count; i ++){
   this.ChangeEnabledStateItem(i, enabled, controller);
  }
  this.changeSelectAllElementsEnabledState(enabled);
  var changeEventMethod = ASPx.Attr.ChangeEventsMethod(enabled);
  if(this.filteringTextBox && !this.customFilteringEditorID) {
   this.filteringTextBox.SetEnabled(enabled);
   this.ChangeSpecialInputEnabledAttributes(this.filteringTextBox.GetInputElement(), changeEventMethod, true);
  }
  if(this.showFilterButton) {
   this.showFilterButton.SetEnabled(enabled);
   this.ChangeSpecialInputEnabledAttributes(this.showFilterButton.GetInternalButton(), changeEventMethod, true);
  }
 },
 ChangeEnabledStateItem: function (index, enabled, controller) {
  var element = this.GetItemFirstTextCell(index);
  if (element)
   controller.SetElementEnabled(element, enabled);
  if (this.GetIsCheckColumnExists() && index >= 0)
   this.SetCheckBoxEnabled(index, enabled);
 },
 ChangeListTableEvents: function(listTable, method){
  if(this.isComboBoxList){
   method(listTable, "mouseup", aspxLBIClick);
   if(ASPx.Browser.Firefox)
    method(listTable, "mousedown", ASPx.Evt.PreventEvent); 
  }
  else{
   method(listTable, "click", aspxLBIClick);   
   method(listTable, "dblclick", aspxLBIClick); 
   if(this.MultiSelectionMode())
    this.AttachSelectStartHandlerToElement(listTable);
  }
 },
 AttachSelectStartHandlerToElement: function(element) {
  ASPx.Evt.AttachEventToElement(element, "selectstart", aspxLBTSelectStart);
 },
 IsValueChanged: function(){
  return this.cachedValue != this.GetValue();
 },
 OnItemSelectionChanged: function(index, selected, fromSelectAllClick, forceValueChanged){
  if(this.CheckColumnSelectionMode() && !fromSelectAllClick)
   this.SetCheckBoxChecked(index, selected);
  if(!this.IsSelectionEventsLocked()) {
   this.SetRaiseSelectedIndexChangedArguments(this.autoPostBack, index, selected);
   var valueChanged = this.IsValueChanged() || forceValueChanged;
   if(valueChanged) {
    this.RaisePersonalStandardValidation();
    this.OnValueChanged();
   } else {
    if(this.RaiseSelectedIndexChanged())
     this.SendPostBackInternal("");
   }
  }
  this.CacheValue();
  if(this.accessibilityCompliant && !fromSelectAllClick)
   this.GetAccessibilityHelper().OnSelectedIndexChanged(index);
 },
 SetRaiseSelectedIndexChangedArguments: function(processOnServer, index, selected){
  this.selectedIndexChangedArguments = {
   processOnServer: processOnServer,
   index: index,
   selected: selected
  };
 },
 GetRaiseSelectedIndexChangedArguments: function(){
  if(!this.selectedIndexChangedArguments)
   this.SetRaiseSelectedIndexChangedArguments(false, this.GetSelectedIndex(), true);
  return this.selectedIndexChangedArguments;
 },
 RaiseSelectedIndexChanged: function (processOnServer) {
  this.RaiseValidationInternal();
  var savedArgs = this.GetRaiseSelectedIndexChangedArguments();
  processOnServer = savedArgs.processOnServer || processOnServer;
  if(!this.SelectedIndexChanged.IsEmpty()){
   var args = new ASPxClientListEditItemSelectedChangedEventArgs(savedArgs.index, savedArgs.selected, processOnServer);
   this.SelectedIndexChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 RaiseItemFiltering: function(item, filter, isFit) {
  if(!this.ItemFiltering.IsEmpty()) {
   var args = new ASPxClientListEditItemFilteringEventArgs(item, filter, isFit);
   this.ItemFiltering.FireEvent(this, args);
   isFit = args.isFit;
  }
  return isFit;
 },
 RaiseCustomHighlighting: function(filter, callbackHighlighting) {
  if(!this.CustomHighlighting.IsEmpty()) {
   var args = new ASPxClientListEditCustomHighlightingEventArgs(filter);
   args.highlighting = callbackHighlighting;
   this.CustomHighlighting.FireEvent(this, args);
   return args.highlighting;
  }
  return callbackHighlighting;
 },
 SetWidth: function(width) {
  this.width = width + "px";
  this.GetScrollDivElement().style.width = "100%";
  ASPxClientListBoxBase.prototype.SetWidth.call(this, width);
 },
 SetHeight: function(height) {
  this.heightCorrected = false;
  ASPxClientListBoxBase.prototype.SetHeight.call(this, height);
  this.CorrectHeight();
 },
 OnAssociatedLabelClick: function(focusableElement) {
  var isValidElement = focusableElement && ASPx.IsActionElement(focusableElement) && ASPx.GetIsParent(this.GetMainElement(), focusableElement);
  if(isValidElement)
   focusableElement.focus();
  else
   ASPxClientListBoxBase.prototype.OnDelayedSpecialFocusMouseDown.call(this, null);
 },
 TryApplyHighlighting: function() {
  var ownerControl = this.GetCallbackOwnerControl();
  var filterStrategy = ownerControl && ownerControl.filterStrategy ? ownerControl.filterStrategy : this.filterStrategy;
  if(filterStrategy.ApplyHighlighting)
   filterStrategy.ApplyHighlighting();
 },
 onDropDownModalChanged: function(enabled) {
  if(!this.IsMultiColumn())
   return;
  if(enabled && !this.itemsManager.GetFirstVisibleItemRow())
   return;
  this.updateCellWidthsOnDropDownChanged(enabled);
 },
 updateCellWidthsOnDropDownChanged: function(enabled) {
  var applyFunction = this.getUpdateCellWidthsFunctionOnDropDownChanged(enabled);
  var sampleRow = this.GetSampleItemRow();
  var headerRow = this.GetHeaderTableElement().rows[0];
  var dataRows = this.itemsManager.GetListTableRows();
  for(var i = this.columnFieldNames.length - 1; i >= 0; i--) {
   applyFunction(sampleRow, i);
   applyFunction(headerRow, i);
   for(var row, j = 0; row = dataRows[j]; j++)
    applyFunction(row, i);
  }
 },
 getUpdateCellWidthsFunctionOnDropDownChanged: function(enabled) {
  if(enabled) {
   var row = this.itemsManager.GetFirstVisibleItemRow();
   var widths = Array.prototype.slice.call(row.cells, 0).map(function(cell) { return cell.offsetWidth; });
   var commonWidth = widths.reduce(function(a, b) { return a + b; }, 0);
   widths = widths.map(function(w) { return (w * 100) / commonWidth; });
   return function(row, cellIndex) {
    ASPx.Attr.ChangeStyleAttribute(row.cells[cellIndex], "width", widths[cellIndex] + "%");
   };
  }
  return function(row, cellIndex) {
   ASPx.Attr.RestoreStyleAttribute(row.cells[cellIndex], "width");
  };
 }
});
ASPxClientListBox.GetItemCellInnerText = function(itemTextCell) {
 var text;
 if(typeof(itemTextCell.attributes["DXText"]) != "undefined")
  text = ASPx.Attr.GetAttribute(itemTextCell, "DXText");
 else {
  var itemCellTextAttribute = ASPx.Attr.GetAttribute(itemTextCell, itemCellTextAttributeName);    
  text = ASPx.IsExists(itemCellTextAttribute) ? itemCellTextAttribute : ASPx.GetInnerText(itemTextCell);
 }
 text = text.replace(new RegExp(nbspChar, "g"), " ");
 return text;
};
var ASPxClientNativeListBox = ASPx.CreateClass(ASPxClientListBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
 },
 InitializeEvents: function() {
  ASPxClientListBoxBase.prototype.InitializeEvents.call(this);
  if(!!this.GetMainElement()) {
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "keydown", this.OnKeyDown.aspxBind(this));
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "keyup", this.OnKeyUp.aspxBind(this));
   ASPx.Evt.AttachEventToElement(this.GetMainElement(), "keypress", this.OnKeyPress.aspxBind(this));
  }
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientListBoxBase.prototype.SetReadOnlyInternal.call(this, readOnly);
  var options = this.GetMainElement().querySelectorAll("option");
  for (var i = 0, option; option = options[i]; i++) {
   if (readOnly)
    ASPx.Attr.SetAttribute(option, "disabled", "disabled");
   else
    ASPx.Attr.RemoveAttribute(option, "disabled");
  }
 }, 
 SetMainElement: function(mainElement){
  this.mainElement = mainElement;
 },
 FindInputElement: function(){
  return this.GetMainElement();
 }, 
 GetOptionCount: function(){
  return this.GetMainElement().options.length;
 },
 GetOption: function(index){
  return this.GetMainElement().options[index];
 },
 GetItemCount: function(){
  return this.GetOptionCount();
 },
 SelectIndexSilent: function(index){
  var selectedIndex = this.GetSelectedIndexInternal();
  var isValidIndex = (-1 <= index && index < this.GetItemCount());
  if((selectedIndex != index && isValidIndex) || !this.isInitialized){
   this.SetSelectedIndexInternal(index);
   return true;
  }
  return false;
 },
 GetSelectedIndexInternal: function(){
  return this.GetMainElement().selectedIndex; 
 },
 SetSelectedIndexInternal: function(index){
  this.GetMainElement().selectedIndex = index; 
 },
 ClearItemsCore: function(){
  this.GetMainElement().innerHTML = "";
 },
 RemoveItem: function(index){
  if(0 <= index && index < this.GetItemCount()){
   var oldSelectedIndex = this.GetSelectedIndexInternal();
   this.UpdateSyncArraysItemDeleted(this.GetItem(index), true);
   var option = this.GetOption(index);
   this.GetMainElement().removeChild(option);
   this.UpdateOptionValues();
   this.OnItemRemoved(oldSelectedIndex, index);
  }
 },
 OnItemRemoved: function(oldSelectedIndex, newSelectedIndex){
  if(newSelectedIndex == oldSelectedIndex && !this.MultiSelectionMode())
   this.SetSelectedIndexInternal(-1);
 },
 MultiSelectionMode: function(){
  return this.GetMainElement().multiple;
 },
 GetItem: function(index){
  if(0 <= index && index < this.GetOptionCount()) {
   var text = this.GetOption(index).text;
   var selected = this.GetMainElement().options[index].selected;
   var itemValue = this.itemsValue[index] !== undefined ? this.itemsValue[index] : null;
   if(ASPx.IsExists(text))
    return new ASPxClientListBoxItem(this, index, text, itemValue, "", selected);
  }
  return null;
 },
 PerformCallback: function(arg) {
  this.ClearItemsForPerformCallback();
  this.FormatAndSetCustomCallbackArg(arg, true);
  this.SendCallback();
  this.FormatAndSetCustomCallbackArg(arg, false);
 },
 SendCallback: function(){
  if(!this.InCallback()){
   var callbackOwner = this.GetCallbackOwnerControl();
   if(callbackOwner != null)
    callbackOwner.SendCallback();
    else {
    var argument = this.GetCallbackArguments();
    this.CreateCallback(argument);
   }
  }
 },
 ParseCallbackResult: function(result){
  var deserializedItems = this.DeserializeItems(result[CONSTANTS.CALLBACK_RESULTS.ITEMS]);
  this.LoadItemsFromCallback(true, deserializedItems);
 },
 InsertItemInternal: function(index, itemProperties) {
  if(typeof (itemProperties.value) == "undefined")
   itemProperties.value = itemProperties.texts;
  var oldSelectedIndex = this.GetSelectedIndexInternal();
  var isAdd = this.GetOptionCount() <= index;
  var newOption = document.createElement("OPTION");
  if(isAdd)
   this.GetMainElement().appendChild(newOption);
  else
   this.GetMainElement().insertBefore(newOption, this.GetOption(index));
  newOption.innerHTML = itemProperties.texts;
  this.UpdateOptionValues();
  ASPx.Data.ArrayInsert(this.itemsValue, itemProperties.value, index);
  this.RegisterInsertedItem(index, itemProperties); 
  if(index == oldSelectedIndex && index != -1)
   this.SetSelectedIndex(index + 1);
 },
 UpdateOptionValues: function() {
  if(this.APILockCount == 0){
   for(var i = 0; i < this.GetOptionCount(); i++)
    this.GetOption(i).value = i;
  }
 },
 ChangeEnabledAttributes: function(enabled){
  if(!this.isComboBoxList) {
   this.GetMainElement().disabled = !enabled;
   this.ChangeSpecialInputEnabledAttributes(this.GetMainElement(), ASPx.Attr.ChangeEventsMethod(enabled), true);
  }
 },
 OnCallback: function(result) {
  this.ParseCallbackResult(result);
 },
 OnItemDblClick: function(){
  this.RaiseItemDoubleClick();
 },
 LoadItemsFromCallback: function(isToTop, deserializedItems){
  this.BeginUpdate();
  this.LockSynchronizationOnInternalCallback();
  var mainElement = this.GetMainElement();
  for(var i = deserializedItems.length - 1; i >= 0; i--) {
   this.InsertItemInternal(0, deserializedItems[i]);
   if(deserializedItems[i].selected)
    mainElement.options[0].selected = true;
  }
  this.UnlockSynchronizationOnInternalCallback();
  this.EndUpdate();
 },
 EndUpdate: function(){
  ASPxClientListBoxBase.prototype.EndUpdate.call(this);
  this.UpdateOptionValues();
 },
 GetSelectedIndices: function(){
  var selectedIndices = [];
  var mainElement = this.GetMainElement();
  for(var i = 0; i < mainElement.options.length; i++){
   if(mainElement.options[i].selected)
    selectedIndices.push(i);
  }
  return selectedIndices;
 },
 GetSelectedValues: function(){ 
  var selectedValues = [];
  var selectedIndices = this.GetSelectedIndices();
  for(var i = 0; i < selectedIndices.length; i++)
   selectedValues.push(this.GetItemValue(selectedIndices[i]));
  return selectedValues;
 },
 GetSelectedItems: function(){
  var selectedItems = [];
  var selectedIndices = this.GetSelectedIndices();
  for(var i = 0; i < selectedIndices.length; i++)
   selectedItems.push(this.GetItem(selectedIndices[i]));
  return selectedItems;
 },
 SelectAll: function(){
  this.SetAllItemsSelectedValue(true);
 },
 UnselectAll: function(){
  this.SetAllItemsSelectedValue(false);
 },
 SetAllItemsSelectedValue: function(selected){
  var mainElement = this.GetMainElement();
  for(var i = 0; i < mainElement.options.length; i++)
   mainElement.options[i].selected = selected;
 },
 SelectIndices: function(indices){
  this.SetIndicesSelectionState(indices, true);
 },
 UnselectIndices: function(indices){
  this.SetIndicesSelectionState(indices, false);
 },
 SetIndicesSelectionState: function(indices, selected){
  var mainElement = this.GetMainElement();
  for(var i = 0; i < indices.length; i++){
   mainElement.options[indices[i]].selected = selected;
  }
 },
 SelectItems: function(items){
  if(ASPx.IsExists(items))
   this.SetItemsSelectionState(items, true);
  else
   this.SelectAll();
 },
 UnselectItems: function(items){
  if(ASPx.IsExists(items))
   this.SetItemsSelectionState(items, false);
  else
   this.UnselectAll();
 },
 SetItemsSelectionState: function(items, selected){
  var mainElement = this.GetMainElement();
  for(var i = 0; i < items.length; i++){
   mainElement.options[items[i].index].selected = selected;
  }
 },
 SelectValues: function(values){
  this.SetValuesSelectedState(values, true);
 },
 UnselectValues: function(values){
  this.SetValuesSelectedState(values, false);
 },
 SetValuesSelectedState: function(values, selected){
  var mainElement = this.GetMainElement();
  var index;
  for(var i = 0; i < values.length; i++){
   index = this.FindItemIndexByValue(values[i]);
   mainElement.options[index].selected = selected;
  }
 },
 EnsureRequiredNativeAttributesExists: function() {
  var input = this.GetInputElement();
  if(!input.onchange)
   ASPx.Evt.AttachEventToElement(input, "change", function() { ASPx.EValueChanged(this.name); }.aspxBind(this));
 }
});
var AccessibilityHelperListBox = ASPx.CreateClass(ASPx.AccessibilityHelperBase, {
 constructor: function(listBox) {
  this.constructor.prototype.constructor.call(this, listBox);
  this.checkBoxRefocusTimeout = 1000;
  this.firstReadingColumnIndex = this.control.CheckColumnSelectionMode() ? 1 : 0;
  this.Initialize();
 },
 Initialize: function() {
  if(this.control.CheckColumnSelectionMode() && !this.control.IsNativeCheckBoxes())
   this.control.GotFocus.AddHandler(function() { this.SetActionElementFocus(); }.aspxBind(this));
  this.control.GotFocus.AddHandler(function() { this.OnSelectedIndexChanged(this.control.GetSelectedIndex()); }.aspxBind(this));
  this.control.LostFocus.AddHandler(function() { 
   setTimeout(function() { 
    this.changeActivityAttributes(this.getMainElement(), { "aria-activedescendant": "" }); 
   }.aspxBind(this), 200); 
  }.aspxBind(this));
 },
 OnSelectedIndexChanged: function(index) {
  var stateSelected = index != -1 && this.control.GetItem(index) && this.control.GetItem(index).selected;
  var selectedIndex = this.control.GetSelectedIndex();
  if(this.control.CheckColumnSelectionMode() || stateSelected || selectedIndex == -1)
   this.setSelectionAttributes(index, stateSelected);
 },
 getPronounceTimeout: function() {
  if(ASPx.Browser.WebKitFamily && this.control.CheckColumnSelectionMode())
   return 1000;
  return ASPx.AccessibilityHelperBase.prototype.getPronounceTimeout.call(this);
 },
 getHeaderCellCaptionText: function(index) {
  var headerDiv = this.control.GetHeaderDivElement();
  if(!headerDiv) return "";
  var headerTable = headerDiv.firstElementChild;
  return headerTable.rows[0].cells[this.firstReadingColumnIndex + index].textContent;
 },
 isItemCheckBoxFocused: function() {
  for(var i = 0; i < this.control.GetItemCount() ; i++) {
   var internalCheckBox = this.control.GetInternalCheckBox(i);
   if(internalCheckBox && internalCheckBox.focused)
    return true;
  }
  return false;
 },
 isSelectAllCheckBoxFocused: function() {
  return this.control.selectAllCheckBox && this.control.selectAllCheckBox.focused;
 },
 SetActionElementFocus: function() {
  if(this.control.enableFiltering) {
   if(!this.control.HasInternalFilteringTextBoxFocus())
    this.SetFilterPanelFocus();
  }
  else
   this.SetCheckBoxFocus();
 },
 SetCheckBoxFocus: function () {
  var isCheckBoxFocused = this.isItemCheckBoxFocused() || this.isSelectAllCheckBoxFocused();
  if(!isCheckBoxFocused)
   this.ProcessRefocusHandler(function() {
    this.control.SetFocusedIndex(0);
   }.aspxBind(this));
 },
 SetFilterPanelFocus: function() {
  if(this.control.customFilteringEditorID || ASPx.ElementHasCssClass(this.control.filterMainElement, this.control.GetInactiveFilterElementClassName())) {
   if(this.control.showFilterButton)
    this.ProcessRefocusHandler(function() {
     this.control.showFilterButton.Focus(); 
    }.aspxBind(this));
  } else 
    this.ProcessRefocusHandler(function() {
     ASPx.FindFirstChildActionElement(this.control.filterMainElement).focus(); 
    }.aspxBind(this));
 },
 ProcessRefocusHandler: function(handler) {
   setTimeout(function() {
   if(!this.control.focused) return;
   handler();
  }.aspxBind(this), this.checkBoxRefocusTimeout);
 },
 getTextForScreenReader: function(item) {
  var result = "";
  if(!this.control.IsMultiColumn()) {
   result= item.text;
  } else {
   var columnsCount = this.control.columnFieldNames.length;
   var formatString = ASPx.AccessibilitySR.TableItemFormatString;
   for(var i = 0; i < columnsCount; i++)
    result += ASPx.Str.ApplyReplacement(formatString, [["{0}", this.getHeaderCellCaptionText(i)], ["{1}", item.texts[i]]]);
  }
  return result;
 },
 setSelectionAttributes: function(index, stateSelected) {
  if(index == -1) index = 0;
  var item = this.control.GetItem(index);
  if(!item) return;
  var assistText = this.getTextForScreenReader(item);
  var activeItemArgs = {
   "role"    : "option",
   "aria-posinset" : index + 1,
   "aria-setsize"  : this.control.itemTotalCount,
   "aria-selected" : stateSelected
  };
  var inactiveItemArgs = {
   "role"    : "",
   "aria-posinset" : "",
   "aria-setsize"  : "",
   "aria-selected" : ""
  };
  this.PronounceMessage(assistText, activeItemArgs, inactiveItemArgs);
 },
 SetCheckBoxesValidationAttributes: function() {
  if(!this.control.CheckColumnSelectionMode() || !this.control.GetErrorCell()) return;
  var errorTextElement = this.control.ariaExplanatoryTextManager.GetErrorTextElement();
  for (var i = 0; i < this.control.GetItemCount() ; i++) {
   var checkBoxFocusableElement = this.control.GetCheckBoxFocusableElement(i);
   if(checkBoxFocusableElement) {
    ASPx.Attr.SetOrRemoveAttribute(checkBoxFocusableElement, "aria-describedby", !this.control.isValid ? errorTextElement.id : null);
    ASPx.Attr.SetOrRemoveAttribute(checkBoxFocusableElement, "aria-invalid", !this.control.isValid);
   }
  }
 }
});
ASPxClientListBox.Cast = ASPxClientControl.Cast;
var ASPxClientCheckListBase = ASPx.CreateClass(ASPxClientListEdit, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);          
  this.imageProperties = null;
  this.internalButtonCollection = null; 
  this.icbFocusedStyle = [];
  this.items = [];
 },
 SetData: function(data){
  ASPxClientEdit.prototype.SetData.call(this, data);
  if(data.items)
   this.CreateItems(data.items);
 },
 Initialize: function() {
  ASPxClientListEdit.prototype.Initialize.call(this);
  this.UpdateInternalSelectedIndex(); 
 },
 UpdateInternalSelectedIndex: function() {
  var selectedIndexFromServer = this.GetSelectedIndex();
  var stateInput = this.FindStateInputElement();
  if(stateInput) {
   var restoredSelectedIndex = stateInput.value;
   if(restoredSelectedIndex != '' && restoredSelectedIndex != selectedIndexFromServer) {
    this.SetSelectedIndex(selectedIndexFromServer);
    this.SetSelectedIndex(restoredSelectedIndex);
   }
  }
 },
 CreateButtonInternalCollection: function() { 
  this.internalButtonCollection = this.CreateCheckBoxInternalCollection();
  for(var i = 0; i < this.GetItemCount(); i++) {
   var icbInputElement = this.GetItemInput(i);
   var internalButton = this.internalButtonCollection.Add(icbInputElement.id, icbInputElement, this.GetItemElement(i));
   internalButton.CreateFocusDecoration(this.icbFocusedStyle);
   internalButton.SetEnabled(this.GetEnabled());
   internalButton.GetReadOnly = this.GetReadOnly.bind(this);
   internalButton.CheckedChanged.AddHandler(function(s, e) {
    this.OnItemClick(this.GetItemIndexByElement(ASPx.Evt.GetEventSource(e)));
   }.aspxBind(this));
   internalButton.Focus.AddHandler(function(s, e) {
    if(!this.focused)
     this.OnFocus();
   }.bind(this));
   internalButton.LostFocus.AddHandler(function(s, e) { this.OnLostFocus(); }.aspxBind(this));
   this.attachToCellsClick(i);
   this.PrepareInternalButton(internalButton, i);
  }
  this.attachToMainElementMouseDown();
 },
 CreateCheckBoxInternalCollection: function () {
  return new ASPx.CheckBoxInternalCollection(this.imageProperties, false, true, ASPx.CheckEditElementHelper.Instance, undefined,
   this.accessibilityCompliant);
 },
 CheckableElementsExist: function() {
  return !!this.imageProperties;
 },
 SetEnabled: function(enabled){
  ASPxClientListEdit.prototype.SetEnabled.call(this, enabled);
  var stateInput = this.FindStateInputElement();
  if(enabled)
   ASPx.Attr.RemoveAttribute(stateInput, "disabled");
  else
   ASPx.Attr.SetAttribute(stateInput, "disabled", "disabled");
 },
 SetFocus: function() {
  this.UpdateFocus(); 
 },
 UpdateFocus: function() {
 },
 IsElementBelongToInputElement: function(element) {
  return this.GetItemIndexByElement(element) != -1;
 },
 attachToCellsClick: function(index) {
  var element = this.GetItemElement(index);
  ASPx.Evt.AttachEventToElement(element, "click", function(evt) {
   var src = ASPx.Evt.GetEventSource(evt);
   var label = ASPx.CheckEditElementHelper.Instance.GetLabelElement(element);
   var button = this.internalButtonCollection.Get(this.GetItemInput(index).id);
   if(!ASPx.GetIsParent(button.mainElement, src) && src !== label && src.parentElement !== label) {
    ASPx.CheckEditElementHelper.Instance.InvokeClick(button, evt);
   }
  }.aspxBind(this));
 },
 attachToMainElementMouseDown: function() {
  var mainElement = this.GetMainElement();
  ASPx.Evt.AttachEventToElement(mainElement, "mousedown", function() {
   if(!this.enabled || this.readOnly)
    return;
   this.LockFocusEvents();
   setTimeout(function() { this.UnlockFocusEvents(); }.aspxBind(this), 0);
  }.aspxBind(this));
 },
 GetItemIndexByElement: function(element) {
  for(var i = 0; i < this.GetItemCount(); i++) {
   var itemElement = this.GetItemElement(i);
   if(ASPx.GetIsParent(itemElement, element))
    return i;
  }
  return -1;  
 },
 GetItemInput: function(index) {
  return this.GetChildElement("RB" + index + "_I");
 },
 GetItemElement: function(index) {
  return this.GetChildElement("RB" + index);
 },
 GetItemFocusableElement: function(index) {
  return this.accessibilityCompliant ? this.GetChildElement("RB" + index + "_I_D") : this.GetItemInput(index);
 },
 GetAccessibilityActiveElements: function() {
  var accessibilityElements = [];
  for(var i = 0; i < this.GetItemCount(); i++) 
   accessibilityElements.push(this.GetItemFocusableElement(i));
  return accessibilityElements;
 },
 GetItemCount: function() {
  return this.items.length;
 },
 OnItemClick: function(index) {
 },
 OnItemClickReadonly: function() {
  var index = this.GetSelectedIndexInternal();
  this.SelectIndexSilent(index);
 },
 UpdateHiddenInputs: function(index) {
  var stateInput = this.FindStateInputElement();
  if(ASPx.IsExistsElement(stateInput))
   stateInput.value = index;
  var valueInput = this.GetValueInputElement();
  if(ASPx.IsExistsElement(valueInput)) {
   var value = this.GetValue();
   valueInput.value = ASPx.IsExists(value) ? value : " ";
  }
 },
 GetItemValue: function(index){
  if(index > -1 && index < this.items.length) {
   if(typeof(this.items[index].value) == "string" && this.items[index].value == "" && this.convertEmptyStringToNull)
    return null;
   else
    return this.items[index].value;
  }
  return null;
 },
 SetValue: function(value) {
  for(var i = 0; i < this.items.length; i++) {
   if(this.GetItemValue(i) == value) {   
    this.SelectIndexSilent(i);
    return;
   }
  } 
  this.SelectIndexSilent(-1);    
 },
 CreateItems: function(itemsProperties){
  for(var i = 0; i < itemsProperties.length; i++)
   this.CreateItem(i, {
    texts: itemsProperties[i][0],
    value: this.GetDecodeValue(itemsProperties[i][1]),
    imageUrl: itemsProperties[i][2]
   });
 },
 CreateItem: function(index, itemProperties){
  var item = new ASPxClientListEditItem(this, index, itemProperties.texts, itemProperties.value, itemProperties.imageUrl);
  this.items.push(item);
 },
 GetItem: function(index){
  return (0 <= index && index < this.items.length) ? this.items[index] : null;
 },
 ChangeEnabledAttributes: function(enabled){
  if(!this.CheckableElementsExist()) {
   for(var i = 0; i < this.GetItemCount(); i++){
    var element = this.GetItemInput(i);
    if(element){
     this.ChangeItemEnabledAttributes(element, ASPx.Attr.ChangeAttributesMethod(enabled));
     this.ChangeSpecialInputEnabledAttributes(element, ASPx.Attr.ChangeEventsMethod(enabled), true);
     element.disabled = !enabled;
    }
   }
  } else {
   var selectedIndex = this.GetSelectedIndexInternal();
   this.UpdateCheckableElementDecorations(selectedIndex, enabled);
  }
 },
 ChangeEnabledStateItems: function(enabled){
  ASPx.GetStateController().SetElementEnabled(this.GetMainElement(), enabled);
  if(this.isNative){
   for(var i = 0; i < this.GetItemCount(); i++){
    var element = this.GetItemInput(i);
    if(element)
     ASPx.GetStateController().SetElementEnabled(element, enabled);
   }
  }
 },
 ChangeItemEnabledAttributes: function(element, method){
  method(element, "onclick");
 }
});
var ASPxClientRadioButtonList = ASPx.CreateClass(ASPxClientCheckListBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);          
 },
 InlineInitialize: function() {
  if(this.CheckableElementsExist()) 
   this.CreateButtonInternalCollection();
  ASPxClientCheckListBase.prototype.InlineInitialize.call(this);
 },
 Initialize: function() {
  ASPxClientCheckListBase.prototype.Initialize.call(this);
  this.UpdateHiddenInputs(this.GetSelectedIndex());
  this.SetSelectedIndex(this.GetSelectedIndex()); 
 },
 PrepareInternalButton: function(internalRadioButton){
  internalRadioButton.autoSwitchEnabled = false;
 },
 GetInputElement: function() {
  if(this.isNative) {
   var index = this.GetSelectedIndexInternal();
   return this.GetItemInput(index);
  } else 
   return this.GetValueInputElement();
 },
 GetValueInputElement: function() {
  if(this.valueInput == null) {
   var stateInput = this.FindStateInputElement();
   this.valueInput = this.GetHiddenField(null, this.name + "_ValueInput", stateInput.parentNode, stateInput);
  }
  return this.valueInput;
 },
 GetValueInputToValidate: function() {
  return this.GetValueInputElement();
 },
 SelectIndexSilent: function(index) {
  var itemCount = this.GetItemCount();
  var isValidIndex = (-1 <= index && index < itemCount);
  if(isValidIndex) {
   if(this.CheckableElementsExist()) 
    this.UpdateCheckableElementDecorations(index, this.GetEnabled());
   else {
    for(var i = 0; i < itemCount; i++) {
     var element = this.GetItemInput(i);
     if(element)
      element.checked = (i == index);
    }
   }
   this.SetSelectedIndexInternal(index);
   this.UpdateHiddenInputs(index);
  }
 },
 UpdateCheckableElementDecorations: function(selectedIndex, enabled) {
  if(this.CheckableElementsExist()) {
   for(var i = 0; i < this.items.length; i++) {
    var inputElement = this.GetItemInput(i);
    var internalButton = this.internalButtonCollection.Get(inputElement.id);
    internalButton.SetEnabled(enabled);
    internalButton.SetValue(i == selectedIndex ? ASPx.CheckBoxInputKey.Checked : ASPx.CheckBoxInputKey.Unchecked);
   }
  }
 },
 UpdateFocus: function() {
  var index = this.GetSelectedIndexInternal();
  if(index == -1)
   index = 0;
  var itemElement = this.GetItemFocusableElement(index);
  if(itemElement != null && ASPx.GetActiveElement() != itemElement && ASPx.IsEditorFocusable(itemElement)) 
   ASPx.SetFocus(itemElement);
 },
 OnItemClick: function(index) {
  if(this.GetSelectedIndexInternal() != index) {
   this.SelectIndexSilent(index);
   this.RaisePersonalStandardValidation();
   this.OnValueChanged();
  }
  this.UpdateFocus();
 },
 RequireInputElementToValidate: function() {
  return false;
 },
 GetItem: function(index){
  var item = ASPxClientCheckListBase.prototype.GetItem.call(this, index);
  if(item)
   item.selected = index == this.GetSelectedIndexInternal();
  return item;
 }
});
ASPxClientRadioButtonList.Cast = ASPxClientControl.Cast;
var ASPxClientCheckBoxList = ASPx.CreateClass(ASPxClientCheckListBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);          
  this.selectionEventsLockCount = 0;
  this.initializeInputValue = null;
  this.restoredSelectedIndices = null;
 },
 InlineInitialize: function() {
  if(this.CheckableElementsExist()) 
   this.CreateButtonInternalCollection();
  ASPxClientCheckListBase.prototype.InlineInitialize.call(this);
 },
 Initialize: function() {
  this.initializeInputValue = this.GetInputElement().value;
  ASPxClientCheckListBase.prototype.Initialize.call(this);
  this.SaveRestoredIndices();
  this.InitSelection();
 },
 SaveRestoredIndices: function() {
  var value = this.initializeInputValue;
  if(!ASPx.IsExists(value) || value === "")
   return;
  var serializer = this.GetSerializingHelper();
  var itemStringIndices = serializer.DeserializeValues(value);
  var itemIndices = [];
  for(var i = 0; i < itemStringIndices.length; i++) {
   var itemIndex = parseInt(itemStringIndices[i]);
   itemIndices.push(itemIndex);
  }
  this.restoredSelectedIndices = itemIndices;
 },
 InitSelection: function() {
  if(this.restoredSelectedIndices)
   this.UnselectAll();
  var selectedIndices = this.restoredSelectedIndices || this.initSelectedIndices;
  this.SelectIndices(selectedIndices);
  this.CacheValue();
 },
 PrepareInternalButton: function(internalCheckBox, index){
  internalCheckBox.autoSwitchEnabled = true;
  internalCheckBox.SetChecked(this.GetItemSelectionHelper().GetIsItemSelected(index));
 },
 SelectIndexSilent: function(index) {
  var itemCount = this.GetItemCount();
  var isValidIndex = (-1 <= index && index < itemCount);
  if(isValidIndex)
   this.SelectIndices([index]);
 },
 UpdateCheckableElementDecorations: function(selectedIndex, enabled) {
  if(this.CheckableElementsExist()) {
   for(var i = 0; i < this.items.length; i++) {
    var inputElement = this.GetItemInput(i);
    var internalButton = this.internalButtonCollection.Get(inputElement.id);
    internalButton.SetEnabled(enabled);
   }
  }
 },
 SetSelectionDecoration: function(index, selected){ 
  if(this.CheckableElementsExist()){
   var inputElement = this.GetItemInput(index);
   var internalButton = this.internalButtonCollection.Get(inputElement.id);
   internalButton.SetValue(selected ? ASPx.CheckBoxInputKey.Checked : ASPx.CheckBoxInputKey.Unchecked);
  } else {
   var element = this.GetItemInput(index);
   if(element)
    element.checked = (selected); 
  }
 },
 OnItemClick: function(index) {
  this.GetItemSelectionHelper().OnItemClick(index);
 },
 UpdateFocus: function() {
  var index = this.GetItemSelectionHelper().GetFocusedItemIndex();
  if(index == -1)
   index = this.GetSelectedIndexInternal();
  if(index == -1)
   index = 0;
  var itemElement = this.GetItemFocusableElement(index);
  if(itemElement != null && ASPx.GetActiveElement() != itemElement && ASPx.IsEditorFocusable(itemElement)) 
   ASPx.SetFocus(itemElement);
 },
 UpdateInternalState: function(){
  this.UpdateHiddenInputs();
 },
 IsUpdateHiddenInputsLocked: function(){
  return this.GetItemSelectionHelper().IsUpdateInternalSelectionStateLocked();
 },
 UpdateHiddenInputs: function(){
  if(this.IsUpdateHiddenInputsLocked()) 
   return;
  var element = this.FindStateInputElement();
  if(ASPx.IsExistsElement(element)) { 
   var sb = [ ];
   var serialiser = this.GetSerializingHelper();
   var selectedIndices = this.GetSelectedIndices();
   for(var i = 0; i < selectedIndices.length; i++)
    serialiser.SerializeAtomValue(sb, selectedIndices[i]);
   element.value = sb.join("");
  }
 },
 GetSerializingHelper: function(){ 
  if(this.serializingHelper == null)
   this.serializingHelper = new ListBoxBaseItemsSerializingHelper(this);
  return this.serializingHelper;
 },
 SetItemSelectionAppearance: function(index, selected, controller, checkCanChangeSelection){
 },
 LockSelectionEvents: function(){
  this.selectionEventsLockCount++;
 },
 UnlockSelectionEvents: function(){
  this.selectionEventsLockCount--;
 },
 IsSelectionEventsLocked: function(){
  return this.selectionEventsLockCount > 0;
 },
 CacheValue: function(){
  this.cachedValue = this.GetValue();
 },
 IsValueChanged: function(){
  return this.cachedValue != this.GetValue();
 },
 OnItemSelectionChanged: function(index, selected){
  this.SetSelectionDecoration(index, selected);
  if(!this.IsSelectionEventsLocked()) {
   this.SetRaiseSelectedIndexChangedArguments(this.autoPostBack, index, selected);
   var valueChanged = this.IsValueChanged();
   if(valueChanged) {
    this.RaisePersonalStandardValidation();
    this.OnValueChanged();
   } else {
    if(this.RaiseSelectedIndexChanged())
     this.SendPostBackInternal("");
   }
  }
  this.CacheValue();
 },
 SetRaiseSelectedIndexChangedArguments: function(processOnServer, index, selected){
  this.selectedIndexChangedArguments = {
   processOnServer: processOnServer,
   index: index,
   selected: selected
  };
 },
 GetRaiseSelectedIndexChangedArguments: function(){
  if(!this.selectedIndexChangedArguments)
   this.SetRaiseSelectedIndexChangedArguments(false, this.GetSelectedIndex(), true);
  return this.selectedIndexChangedArguments;
 },
 RaiseSelectedIndexChanged: function (processOnServer) {
  this.RaiseValidationInternal();
  var savedArgs = this.GetRaiseSelectedIndexChangedArguments();
  processOnServer = savedArgs.processOnServer || processOnServer;
  if(!this.SelectedIndexChanged.IsEmpty()){
   var args = new ASPxClientListEditItemSelectedChangedEventArgs(savedArgs.index, savedArgs.selected, processOnServer);
   this.SelectedIndexChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 GetItemSelectionHelper: function(){
  if(!this.itemSelectionHelper)
   this.itemSelectionHelper = this.CreateItemSelectionHelper();
  return this.itemSelectionHelper;
 },
 CreateItemSelectionHelper: function(){
  return new CheckBoxListMultiSelectionHelper(this);
 },
 GetItem: function(index){
  var item = ASPxClientCheckListBase.prototype.GetItem.call(this, index);
  item.selected = this.GetItemSelectionHelper().GetIsItemSelected(index);
  return item;
 },
 SetValue: function(value){
  var index = this.FindItemIndexByValue(value);
  this.SetSelectedIndex(index);
 },
 GetSelectedIndexInternal: function(){
  if(!this.isInitialized)
   return ASPxClientCheckListBase.prototype.GetSelectedIndexInternal.call(this);
  return this.GetItemSelectionHelper().GetSelectedIndex();
 },
 SetSelectedIndex: function(index){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SetSelectedIndex(index);
  this.UnlockSelectionEvents();
 },
 GetSelectedIndices: function(){
  return this.GetItemSelectionHelper().GetSelectedIndices();
 },
 GetSelectedValues: function(){ 
  return this.GetItemSelectionHelper().GetSelectedValues();
 },
 GetSelectedItems: function(){
  return this.GetItemSelectionHelper().GetSelectedItems();
 },
 SelectAll: function(){
  this.SelectIndices();
 },
 UnselectAll: function(){
  this.UnselectIndices();
 },
 SelectIndices: function(indices){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectIndices(indices);
  this.UnlockSelectionEvents();
 },
 SelectItems: function(items){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectItems(items);
  this.UnlockSelectionEvents();
 },
 SelectValues: function(values){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().SelectValues(values);
  this.UnlockSelectionEvents();
 },
 UnselectIndices: function(indices){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectIndices(indices);
  this.UnlockSelectionEvents();
 },
 UnselectItems: function(items){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectItems(items);
  this.UnlockSelectionEvents();
 },
 UnselectValues: function(values){
  this.LockSelectionEvents();
  this.GetItemSelectionHelper().UnselectValues(values);
  this.UnlockSelectionEvents();
 }
});
ASPxClientCheckBoxList.Cast = ASPxClientControl.Cast;
var ASPxClientListEditItemSelectedChangedEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(index, isSelected, processOnServer){
  this.constructor.prototype.constructor.call(this, processOnServer);
  this.index = index;
  this.isSelected = isSelected;
 }
});
function aspxLBTSelectStart(evt){
 var shiftPressed = evt.shiftKey;
 var ctrlKey = evt.ctrlKey || evt.metaKey;
 if(shiftPressed || ctrlKey){
  ASPx.Selection.Clear();
  ASPx.Evt.PreventEventAndBubble(evt);
 }
}
function aspxLBIClick(evt){
 if(ASPx.TouchUIHelper.isMouseEventFromScrolling) return;
 var element = ASPx.Evt.GetEventSource(evt);
 while(element != null && element.tagName != "BODY"){
  if(element.tagName == "TR"){
   var table = element.offsetParent;
   if(table && table.ListBoxId){
    var lb = ASPx.GetControlCollection().Get(table.ListBoxId);
    if(lb != null) {
     var retValue;
     if(evt.type == "dblclick") 
      retValue =lb.OnItemDblClick();
     else if(!lb.isComboBoxList || ASPx.Evt.IsLeftButtonPressed(evt)) {
      var itemIndex = lb.GetItemIndexByRow(element);
      retValue = lb.OnItemClick(itemIndex, evt);
     }
     if(typeof(retValue) != "undefined")
      return retValue;
    }
    break;
   }
  }
  element = element.parentNode;
 }
}
function aspxLBScroll(evt){
 var sourceId = ASPx.Evt.GetEventSource(evt).id;
 if(sourceId.slice(-lbDSuffix.length) == lbDSuffix){
  var name = sourceId.slice(0, -2);
  var lb = ASPx.GetControlCollection().Get(name);
  if(lb != null && lb.isInitialized) 
   lb.OnScroll();
 }
}
ASPx.NLBIDClick = function(evt) {
 var element = ASPx.Evt.GetEventSource(evt);
 if(element != null && element.tagName == "SELECT"){
  var lb = ASPx.GetControlCollection().Get(element.id);
  if(lb != null)
   lb.OnItemDblClick();
 }
};
ASPx.ERBLIClick = function(name, index) {
 var list = ASPx.GetControlCollection().Get(name);
 if(list != null) {
  if(list.GetReadOnly())
   return false;
  list.OnItemClick(index);
 }
};
ASPx.ERBLICancel = function(name) {
 var list = ASPx.GetControlCollection().Get(name);
 if(list != null)
  list.OnItemClickReadonly();
};
ASPx.ShowListBoxFilter = function(name) {
 var list = ASPx.GetControlCollection().Get(name);
 if(list != null)
  list.ShowFilterElement();
};
ASPx.HideListBoxFilter = function(name) {
 var list = ASPx.GetControlCollection().Get(name);
 if (list != null)
  list.HideFilterElement();
};
var highlightingOpeningGuid = "680fb6b5-de5f-4af1-b444-2617b6dc5aab";
var highlightingClosingGuid = "ee51e3d2-fb72-45fc-b737-6d3432008053";
ASPx.ListBoxHighlightingHelper = ASPx.CreateClass(null, {
 constructor: function(listBox, tagName) {
  this.listBox = listBox;
  this.tagName = tagName;
  this.highlightingOpeningTag = "<" + tagName + ">";
  this.highlightingClosingTag = "</" + tagName + ">";
  this.highlightingOpeningTagPlaceholder = new RegExp(highlightingOpeningGuid, "g");
  this.highlightingClosingTagPlaceholder = new RegExp(highlightingClosingGuid, "g");
  this.customReplacer = highlightingOpeningGuid + "$&" + highlightingClosingGuid;
 },
 Apply: function(text, isCustom) {
  if(text == "" || !this.listBox.encodeHtml) return;
  if(isCustom)
   this.applyCustom(text);
  else
   this.apply(text, ASPx.ContainsFilteringUtils.SelectContainsTextInElement, false);
 },
 Remove: function(text, isCustom) {
  if(isCustom)
   this.removeCustom(text);
  else
   this.apply(text, ASPx.ContainsFilteringUtils.UnselectContainsTextInElement, true);
 },
 Refresh: function(text, isCustom) {
  if(text == "") return;
  if(isCustom)
   this.applyCustom(text, true);
  else
   this.apply(text, ASPx.ContainsFilteringUtils.ReselectContainsTextInElement, false);
 },
 applyCustom: function(highlighting, refreshing) { 
  var count = this.listBox.GetItemCount();
  var highlightingRegExpxByColumns = this.getCustomHighlightingRegExpsByColumns(highlighting);
  for(var i = 0; i < count; i++) {
   var item = this.listBox.GetItemRow(i);
   if(!item || this.listBox.ItemRowHasTemplate(i)) continue;
   this.applyCustomCore(item, highlightingRegExpxByColumns, refreshing);
  }
 },
 applyCustomCore: function(item, highlightingRegExpxByColumns, refreshing) {
  var elements = this.getTextCellElements(item);
  for(var i = 0, el; el = elements[i]; i++) {
   if(refreshing)
    this.removeCustomFromItem(el);
   this.applyCustomToItem(el, highlightingRegExpxByColumns[i]);
  }
 },
 applyCustomToItem: function(element, regexp) {
  if(!regexp)
   return;
  var currentText = ASPx.Attr.GetAttribute(element, "DXText");
  if(!ASPx.IsExists(currentText)) ASPx.Attr.SetAttribute(element, "DXText", ASPx.GetInnerText(element));
  var oldInnerText = ASPx.GetInnerText(element);
  var newInnerText = oldInnerText.replace(regexp, this.customReplacer);
  newInnerText = ASPx.ContainsFilteringUtils.PrepareElementText(newInnerText)
   .replace(this.highlightingOpeningTagPlaceholder, this.highlightingOpeningTag)
   .replace(this.highlightingClosingTagPlaceholder, this.highlightingClosingTag);
  if(newInnerText !== oldInnerText)
   ASPx.SetInnerHtml(element, newInnerText);
 },
 removeCustomFromItem: function(element) {
  var currentText = ASPx.Attr.GetAttribute(element, "DXText");
  if(ASPx.IsExists(currentText)) {
   currentText = ASPx.ContainsFilteringUtils.PrepareElementText(currentText);
   ASPx.SetInnerHtml(element, currentText === "" ? "&nbsp;" : currentText);
  }
 },
 removeCustom: function() {
  var count = this.listBox.GetItemCount();
  for(var i = 0; i < count; i++) {
   var item = this.listBox.GetItemRow(i);
   if(!item || this.listBox.ItemRowHasTemplate(i)) continue;
   this.removeCustomCore(item);
  }
 },
 removeCustomCore: function(item) {
  var elements = this.getTextCellElements(item);
  for(var i = 0, el; el = elements[i]; i++)
   this.removeCustomFromItem(el);
 },
 getCustomHighlightingRegExpsByColumns: function(highlighting) {
  var columns = this.listBox.IsMultiColumn() ? this.listBox.columnFieldNames : [""];
  return columns.map(function(fieldName) {
   if(typeof (highlighting) === "string" || Array.isArray(highlighting) || highlighting instanceof RegExp)
    return this.arrayToRegEx(highlighting);
   if(typeof (highlighting) === "object")
    return this.arrayToRegEx(highlighting[fieldName]);
   return null;
  }.bind(this));
 },
 arrayToRegEx: function(texts) {
  if(texts instanceof RegExp)
   return texts;
  if(typeof (texts) === "string")
   return this.arrayToRegEx([texts]);
  if(Array.isArray(texts)) {
   texts = texts
    .filter(function(t) { return typeof (t) === "string" && t.length; })
    .sort(function(a, b) { return b.length - a.length; })
    .map(ASPx.Str.EscapeForRegEx);
   if(texts.length)
    return new RegExp("(" + texts.join("|") + ")", "gi");
  }
  return null;
 },
 apply: function(text, func, allColumns) {
  var count = this.listBox.GetItemCount();
  for (var i = 0; i < count; i++) {
   var item = this.listBox.GetItemRow(i);
   if (item && (allColumns || ASPx.GetElementDisplay(item)) && this.canApply(item)) {
    var elements = this.listBox.GetItemSelectableElementsByRow(item);
    this.applyToItem(text, elements, func, allColumns);
   }
  }
 },
 applyToItem: function(text, elements, func, allColumns) {
  var itemValues = this.getItemValues(elements);
  var itemSelection = this.getItemSelection(itemValues, this.listBox.textFormatString, text);
  var firstTextCellIndex = this.getFirstTextCellIndex();
  if (allColumns) {
   for (var i = 0; i < elements.length; i++)
    this.applyToItemCore(func, elements[i], itemSelection[i]);
  } else
   this.applyToTextCells(func, firstTextCellIndex, elements, itemSelection);
 },
 getItemSelection: function (itemValues, textFormatString, text) {
  return ASPx.ContainsFilteringUtils.GetColumnSelectionsForItem(itemValues, textFormatString, text);
 },
 applyToTextCells: function(func, firstTextCellIndex, elements, itemSelection) {
  for(var i = 0; i < itemSelection.length; i++)
   this.applyToItemCore(func, elements[itemSelection[i].index + firstTextCellIndex], itemSelection[i]);
 },
 applyToItemCore: function (func, itemElement, itemSelection) {
  if (!this.listBox.ItemCellHasTextAttr(itemElement))
   func(itemElement, itemSelection, this.tagName);
 },
 getItemValues: function (elements) {
  var result = [];
  for (var i = this.getFirstTextCellIndex() ; i < elements.length; i++)
   result.push(ASPxClientListBox.GetItemCellInnerText(elements[i]));
  return result;
 },
 canApply: function (item) {
  return !this.listBox.ItemRowHasTemplateCore(item);
 },
 getFirstTextCellIndex: function () {
  return this.listBox.GetItemFirstTextCellIndex();
 },
 getTextCellElements: function(item) {
  return this.listBox.GetItemTextCells(item);
 }
});
var ListEditFilterStrategyBase = ASPx.CreateClass(null, {
 OnPaste: function(evt) { },
 OnInput: function() { },
 OnClearButtonClick: function() { },
 OnTextChanged: function() { },
 OnEscape: function() { },
 OnKeyDown: function(evt) { },
 OnAfterEnter: function() { },
 OnSelectedIndexChanged: function() { },
 OnLostFocus: function() { },
 OnCallback: function(result) { },
 OnBeforeDoEndCallback: function() { },
 OnAfterDoEndCallback: function() { },
 OnBeforeCallbackFinally: function() { },
 OnAfterCallbackFinally: function() { },
 OnPerformCallback: function() { },
 Filtering: function() { },
 CancelFiltering: function() { },
 ShouldDiscardCallbackResult: function() { },
 GetCallbackArguments: function() { return ""; },
 CanNavigateByKbd: function() { return true; },
 IsFilterMeetRequirementForMinLength: function (filter) { return true; },
 ResetCallbackState: function() { },
 ClearFilterApplied: function() { },
 OnDropDownHideArea: function() { },
 OnDropDownButtonClick: function() { },
 OnDropDownCloseByDocumentOrWindowEvent: function() { },
 OnApplyChanges: function() { },
 OnCancelChanges: function() { },
 OnUndo: function() { }
});
var ListEditIncrementalFilterStrategyBase = ASPx.CreateClass(ListEditFilterStrategyBase, {
 constructor: function(filterDelay, filterMinLength, isCallbackMode) {
  this.filterTimeoutId = -1;
  this.filterDelay = filterDelay;
  this.filterMinLength = filterMinLength;
  this.isCallbackMode = isCallbackMode;
  this.filter = "";
  this.highlighting = "";
  this.filterInitialized = false;
  this.needEmptyFilterBeforeFiltering = false;
  this.currentCallbackIsFiltration = false;
  this.refiltrationRequired = false;
 },
 GetInputFilterValue: function() { throw "Not Implemented"; },
 GetListBoxControl: function() { throw "Not Implemented"; },
 IsSatisfy: function(text, filter) { throw "Not Implemented"; },
 InCallback: function() { throw "Not Implemented"; },
 IsEnabled: function() { throw "Not Implemented"; },
 SendCallbackCore: function() { throw "Not Implemented"; },
 PreventEndCallbackRising: function() { throw "Not Implemented"; },
 GetSelectedIndex: function() { throw "Not Implemented"; },
 NotifyCollectionChanged: function() { throw "Not Implemented"; },
 OnCallbackCore: function(highlighting, newFilterLength) { throw "Not Implemented"; },
 RaiseItemFilteringEvent: function(item, filter, isFit) { throw "Not Implemented"; },
 RaiseCustomHighlightingEvent: function(filter, highlighting) { throw "Not Implemented"; },
 OnBeforeFilteringOnClient: function(filter) { }, 
 OnAfterFilteringOnClientCore: function (filter, firstSatisfyItemIndex) { throw "Not Implemented"; },
 SupportsFilterCorrection: function() { throw "Not Implemented"; },
 OnFirstSatisfiedItemFound: function(index, text, isTextClearing) { },
 TryProcessFilterLessMinLength: function() { return true; },
 AllowEmptyFilterResults: function() { return true; },
 OnBeforeFiltering: function() { },
 OnAfterFiltering: function() { },
 OnFilteringCancelled: function() { },
 OnTextChanged: function() { },
 OnFilterRollback: function() { },
 CanStartFilterOnInput: function() {
  return this.IsEnabled() && !this.InCallback();
 },
 OnAfterFilteringOnClient: function (filter, satisfyItemIndices) {
  this.GetListBoxControl().RewriteFilteredItemIndices(satisfyItemIndices);
  var firstSatisfyItemIndex = satisfyItemIndices.length > 0 ? satisfyItemIndices[0] : -1;
  this.OnAfterFilteringOnClientCore(filter, firstSatisfyItemIndex);
 },
 ShouldClearFilterBeforeFiltering: function(filter) { return false; },
 OnInput: function() {
  if(this.CanStartFilterOnInput()) {
   this.FilterStopTimer();
   this.FilterStartTimer();
  }
 },
 OnCallback: function(result) {
  this.OnCallbackCore(result[CONSTANTS.CALLBACK_RESULTS.FILTER_CUSTOMHIGHLIGHTING], result[CONSTANTS.CALLBACK_RESULTS.FILTER_LENGTH]);
  this.currentCallbackIsFiltration = false;
 },
 CancelFiltering: function() {
  this.FilterStopTimer();
 },
 Filtering: function(fromApi) {
  this.FilterStopTimer();
  var inputValue = this.GetInputFilterValue();
  this.needEmptyFilterBeforeFiltering = this.ShouldClearFilterBeforeFiltering(inputValue);
  var newFilter = this.needEmptyFilterBeforeFiltering ? "" : inputValue;
  var oldFilter = this.filter;
  if(!this.FilterCompare(newFilter)) {
   this.SetFilter(newFilter);
   if(!this.IsFilterMeetRequirementForMinLength() && this.TryProcessFilterLessMinLength(oldFilter))
    return;
   else {
    this.OnBeforeFiltering();
    if(this.isCallbackMode)
     this.FilteringOnServer();
    else
     this.FilteringOnClient();
    this.OnAfterFiltering();
   }
  }
  else
   this.OnFilteringCancelled(fromApi);
 },
 FilteringOnClient: function() {
  var listBox = this.GetListBoxControl(),
   count = listBox.GetItemCount(),
   filter = this.filter,
   listTable = listBox.GetListTable(),
   visibleItems = [],
   visibleItemFound = false;
  this.DiscardHighlighting();
  if(ASPx.Browser.IE && ASPx.Browser.Version > 9) 
   ASPx.SetElementDisplay(listTable, false);
  while(true) {
   var preparedFilter = ASPx.Str.PrepareStringForFilter(filter);
   listBox.BeforeClientFiltering();
   for(var i = 0; i < count; i++) {
    var item = listBox.GetItem(i);
    var isFit = this.IsSatisfy(item.text, preparedFilter);
    isFit = this.RaiseItemFilteringEvent(item, filter, isFit);
    if(isFit) {
     if(!visibleItemFound) {
      this.OnBeforeFilteringOnClient(filter);
      for(var j = 0; j < i; j++)
       listBox.ApplyFilterToItem(j, false);
      var isTextClearing = filter == "" && this.filter != item.text;
      this.OnFirstSatisfiedItemFound(i, item.text, isTextClearing);
      visibleItemFound = true;
     }
     visibleItems.push(i);
    }
    if(visibleItemFound)
     listBox.ApplyFilterToItem(i, isFit);
   }
   if(visibleItemFound || this.AllowEmptyFilterResults() || !filter)
    break;
   filter = filter.substr(0, filter.length - 1);
  }
  if(!visibleItemFound) {
   this.OnBeforeFilteringOnClient(filter); 
   if(this.AllowEmptyFilterResults()) {
    for(var i = 0; i < count; i++)
     listBox.ApplyFilterToItem(i, false);
   }
  }
  if(ASPx.Browser.IE && ASPx.Browser.Version > 9) 
   ASPx.SetElementDisplay(listTable, true);
  this.OnAfterFilteringOnClient(filter, visibleItems);
  this.SetHighlighting(filter);
  this.OnEndFiltering(visibleItemFound || this.AllowEmptyFilterResults());
 },
 FilteringOnServer: function() {
  if(!this.InCallback()) {
   var listBox = this.GetListBoxControl();
   listBox.ClearItems(); 
   listBox.serverIndexOfFirstItem = 0;
   listBox.SetScrollSpacerVisibility(true, false);
   listBox.SetScrollSpacerVisibility(false, false);
  }
  this.SendFilteringCallback();
 },
 SendFilteringCallback: function(owner) {
  this.currentCallbackIsFiltration = true;
  this.SendCallbackCore();
 },
 OnEndFiltering: function(visibleCollectionChanged) {
  if(visibleCollectionChanged)
   this.NotifyCollectionChanged();
  this.ApplyHighlighting();
 },
 IsFilterTimerActive: function() {
  return this.filterTimeoutId !== -1;
 },
 FilterStopTimer: function() {
  if(this.IsFilterTimerActive()) {
   clearTimeout(this.filterTimeoutId);
   this.filterTimeoutId = -1;
  }
 },
 FilterStartTimer: function() {
  this.filterTimeoutId = setTimeout(function() {
   this.filterTimeoutId = -1;
   this.Filtering();
  }.bind(this), this.filterDelay);
 },
 IsFilterMeetRequirementForMinLength: function(filter) {
  if(typeof (filter) !== "string")
   filter = this.GetInputFilterValue();
  return typeof (filter) === "string" ? filter.length >= this.filterMinLength : true;
 },
 GetCallbackArguments: function() {
  if(this.filter) {
   var callbackPrefix = this.SupportsFilterCorrection() ? CONSTANTS.CALLBACK_PREFIXES.FILTERING_CORRECT : CONSTANTS.CALLBACK_PREFIXES.FILTERING;
   return ASPx.FilteringUtils.FormatCallbackArg(callbackPrefix, this.filter);
  }
  return "";
 },
 OnAfterDoEndCallback: function() {
  if(this.refiltrationRequired) {
   this.refiltrationRequired = false;
   window.setTimeout(this.Filtering.bind(this), 0);
  }
 },
 OnBeforeDoEndCallback: function() {
  if(this.refiltrationRequired)
   this.PreventEndCallbackRising();
 },
 OnSelectedIndexChanged: function() {
  this.ClearFilterApplied();
 },
 SetHighlighting: function(filter, callbackHighlighting) {
  callbackHighlighting = this.ProcessCallbackHighlighting(callbackHighlighting);
  var customHighlighting = this.RaiseCustomHighlightingEvent(filter, callbackHighlighting);
  this.isCustomHighlighting = customHighlighting !== null && customHighlighting !== undefined;
  this.highlighting = this.isCustomHighlighting ? customHighlighting : filter;
 },
 ProcessCallbackHighlighting: function(obj) {
  if(obj === undefined || obj === null)
   return undefined;
  var val = obj.val;
  var regEx = !!obj.regEx;
  if(regEx) {
   if(typeof (val) === "string")
    val = new RegExp(val, "gi");
   if(!Array.isArray(val) && typeof (val) === "object") {
    for(var col in val) {
     if(!val.hasOwnProperty(col)) continue;
     if(typeof (val[col]) === "string")
      val[col] = new RegExp(val[col], "gi");
    }
   }
  }
  return val;
 },
 IsEmptyFilter: function() {
  return !this.filterInitialized || this.filter === "";
 },
 ShouldDiscardCallbackResult: function() {
  var discardCallbackResult = !this.needEmptyFilterBeforeFiltering && !this.IsFilterEqualInputValue() && this.currentCallbackIsFiltration;
  if(discardCallbackResult)
   this.refiltrationRequired = true;
  return discardCallbackResult;
 },
 IsFilterEqualInputValue: function() {
  var currentFilter = this.GetInputFilterValue();
  return this.FilterCompareLower(ASPx.Str.PrepareStringForFilter(currentFilter));
 },
 FilterCompare: function(value) {
  return this.filterInitialized && this.filter === value;
 },
 FilterCompareLower: function(value) {
  if(!this.filterInitialized)
   return false;
  return ASPx.Str.PrepareStringForFilter(this.filter) == value;
 },
 DiscardHighlighting: function() {
  this.GetListBoxControl().highlighting.Remove(this.highlighting, this.isCustomHighlighting);
 },
 ApplyHighlighting: function() {
  this.GetListBoxControl().highlighting.Apply(this.highlighting, this.isCustomHighlighting);
 },
 RefreshHighlighting: function() {
  this.GetListBoxControl().highlighting.Refresh(this.highlighting, this.isCustomHighlighting);
 },
 MakeAllItemsVisible: function() {
  this.GetListBoxControl().MakeAllItemsVisible();
 },
 SetFilter: function(newFilter) {
  this.filter = newFilter;
  this.highlighting = "";
  this.isCustomHighlighting = undefined;
  this.filterInitialized = true;
 },
 ClearFilter: function() {
  this.filter = "";
  this.highlighting = "";
  this.isCustomHighlighting = undefined;
  this.filterInitialized = false;
 },
 ClearFilterApplied: function() {
  this.filterInitialized = false;
 },
 FilteringBackspace: function() {
  throw "Not Implemented";
 },
});
var ListBoxFilterStrategy = ASPx.CreateClass(ListEditIncrementalFilterStrategyBase, {
 constructor: function(listBox) {
  this.constructor.prototype.constructor.call(this, listBox.filteringDelay, listBox.filterMinLength, listBox.isCallbackMode);
  this.listBox = listBox;
 },
 SupportsFilterCorrection: function() {
  return false;
 },
 IsEnabled: function() {
  return this.listBox.GetEnabled();
 },
 GetInputFilterValue: function() {
  return this.listBox.filteringTextBox.GetInputElement().value;
 },
 NotifyCollectionChanged: function() {
  this.listBox.CollectionChanged(true);
 },
 TryProcessFilterLessMinLength: function(oldFilter) {
  this.SetFilter("");
  return !oldFilter;
 },
 IsSatisfy: function(text, filter) {
  return ASPx.Str.PrepareStringForFilter(text).indexOf(filter) !== -1;
 },
 GetListBoxControl: function() {
  return this.listBox;
 },
 OnAfterFilteringOnClientCore: function (filter, firstSatisfyItemIndex) {
  if(firstSatisfyItemIndex !== -1)
   this.listBox.CorrectCellWidthsOnFirstRowItemReplacement(0, firstSatisfyItemIndex);
 },
 OnEndFiltering: function(visibleCollectionChanged) {
  ListEditIncrementalFilterStrategyBase.prototype.OnEndFiltering.call(this, visibleCollectionChanged);
  if(this.listBox.IsMultiColumn())
   this.listBox.CorrectWidth();
  this.listBox.updateSelectAllElementsState();
 },
 SendCallbackCore: function() {
  this.listBox.SendCallback();
 },
 InCallback: function() {
  return this.listBox.InCallback();
 },
 PreventEndCallbackRising: function() {
  this.listBox.preventEndCallbackRising = true;
 },
 GetSelectedIndex: function() {
  return this.listBox.GetSelectedIndex();
 },
 OnCallbackCore: function(highlighting, newFilterLength) {
  if(this.currentCallbackIsFiltration)
   this.SetHighlighting(this.filter, highlighting);
  if(this.filter)
   this.OnEndFiltering();
 },
 FilteringBackspace: function() {
  var textBox = this.listBox.filteringTextBox;
  if(textBox)
   ASPx.StartWithFilteringUtils.RollbackOneSuggestedChar(textBox.GetInputElement());
  this.FilterStartTimer();
 },
 RaiseItemFilteringEvent: function(item, filter, isFit) {
  return this.listBox.RaiseItemFiltering(item, filter, isFit);
 },
 RaiseCustomHighlightingEvent: function(filter, callbackHighlighting) {
  return this.listBox.RaiseCustomHighlighting(filter, callbackHighlighting);
 }
});
ASPx.ListBoxItemsDefaultManager = ListBoxItemsDefaultManager;
ASPx.ListBoxItemsVirtualManager = ListBoxItemsVirtualManager;
ASPx.ListEditIncrementalFilterStrategyBase = ListEditIncrementalFilterStrategyBase;
ASPx.ListBoxFilterStrategy = ListBoxFilterStrategy;
ASPx.ListEditFilterStrategyBase = ListEditFilterStrategyBase;
var ASPxClientListEditItemFilteringEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(item, filter, isFit) {
  this.constructor.prototype.constructor.call(this);
  this.item = item;
  this.isFit = isFit;
  this.filter = filter;
 }
});
var ASPxClientListEditCustomHighlightingEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(filter) {
  this.constructor.prototype.constructor.call(this);
  this.highlighting = null;
  this.filter = filter;
 }
});
ASPx.ListBoxScrollCallbackHelper = ListBoxScrollCallbackHelper;
window.ASPxClientListEdit = ASPxClientListEdit;
window.ASPxClientListEdit.CONSTANTS = CONSTANTS;
window.ASPxClientListEditItem = ASPxClientListEditItem;
window.ASPxClientListBoxItem = ASPxClientListBoxItem;
window.ASPxClientListBoxBase = ASPxClientListBoxBase;
window.ASPxClientListBox = ASPxClientListBox;
window.ASPxClientNativeListBox = ASPxClientNativeListBox;
window.ASPxClientCheckListBase = ASPxClientCheckListBase;
window.ASPxClientRadioButtonList = ASPxClientRadioButtonList;
window.ASPxClientCheckBoxList = ASPxClientCheckBoxList;
window.ASPxClientListEditItemSelectedChangedEventArgs = ASPxClientListEditItemSelectedChangedEventArgs;
window.ASPxClientListEditItemFilteringEventArgs = ASPxClientListEditItemFilteringEventArgs;
window.ASPxClientListEditCustomHighlightingEventArgs = ASPxClientListEditCustomHighlightingEventArgs;
})();

(function() {
var currentSelectedItemCallbackPrefix = "CBSI";
var loadDropDownOnDemandCallbackPrefix = "CBLD";
var listBoxNameSuffix = "_L";
var comboBoxValueInputSuffix = "VI";
var ASPxClientComboBoxBase = ASPx.CreateClass(ASPxClientDropDownEditBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.lbEventLockCount = 0;
  this.receiveGlobalMouseWheel = false;
  this.collectCallbackIDs = false;
  this.callbackIDs = { };
  this.callbackIDsToReset = { };
  this.listBox = null;
  this.lastSuccessValue = "";
  this.islastSuccessValueInit = false;
  this.SelectedIndexChanged = new ASPxClientEvent();
 },
 Initialize: function(){
  this.InitializeListBoxOwnerName();
  ASPxClientDropDownEditBase.prototype.Initialize.call(this);
  this.InitLastSuccessValue();
 },
 InitializeListBoxOwnerName: function(){
  var lb = this.GetListBoxControl();
  if(lb)
   lb.ownerName = this.name;
 },
 InitLastSuccessValue: function(){
  this.SetLastSuccessValue(this.GetValue());
 },
 SetLastSuccessValue: function (value) {
  if(this.convertEmptyStringToNull && value === "")
   value = null;
  this.lastSuccessValue = value;
  this.islastSuccessValueInit = true;
 },
 GetDropDownInnerControlName: function(suffix){
  return "";
 },
 CreateAccessibilityHelper: function() {
  return new AccessibilityHelperComboBox(this);
 },
 GetListBoxControl: function(){
  if(!ASPx.IsExists(this.listBox)){
   var name = this.GetDropDownInnerControlName(listBoxNameSuffix);
   this.listBox = ASPx.GetControlCollection().Get(name);
  }
  if(this.isNative || (this.listBox && !!this.listBox.GetMainElement()))
   return this.listBox;
  return null;
 },
 GetCallbackArguments: function(){
  return this.GetListBoxCallbackArguments();
 },
 GetListBoxCallbackArguments: function(){
  var lb = this.GetListBoxControl();
  return lb.GetCallbackArguments();
 },
 SendCallback: function(onSuccess) {
  var callbackID = this.CreateCallback(this.GetCallbackArguments(), null, onSuccess);
  this.OnCreateCallback(callbackID);
 },
 SendSpecialCallback: function(args, handler) {
  var callbackID = this.CreateCallback(args, null, handler);
  this.OnCreateCallback(callbackID);
 },
 OnCreateCallback: function(callbackID) {
  if(this.collectCallbackIDs)
   this.callbackIDs[callbackID] = true;
  this.UnlockDoEndCallback();
 },
 CanProcessCallbackResult: function(callbackID) {
  var result = !this.collectCallbackIDs || !this.callbackIDsToReset[callbackID];
  delete this.callbackIDs[callbackID];
  delete this.callbackIDsToReset[callbackID];
  if(!result)
   this.LockDoEndCallback();
  return result;
 },
 LockDoEndCallback: function() {
  this.lockDoEndCallback = true;
  this.lockDoEndCallbackTimerId =  window.setTimeout(function() { this.lockDoEndCallback = false; }.bind(this), 200);
 },
 UnlockDoEndCallback: function() {
  this.lockDoEndCallback = false;
  ASPx.Timer.ClearTimer(this.lockDoEndCallbackTimerId);
 },
 IsDoEndCallbackLocked: function() { 
  return !!this.lockDoEndCallback; 
 },
 ResetWaitingCallbacks: function() {
  var ids = Object.keys(this.callbackIDs);
  if(ids.length === 0) return;
  ids.forEach(function(id) { this.callbackIDsToReset[id] = true; }.bind(this));
  this.callbackIDs = { };
  this.requestCount = 0;
  ASPx.GetControlCollection().ResetRequestCount(); 
  this.CancelCallbackInternal();
 },
 SetReadOnlyInternal: function(readOnly) {
  ASPxClientDropDownEditBase.prototype.SetReadOnlyInternal.call(this, readOnly);
  var lb = this.GetListBoxControl();
  if(lb)
   lb.SetReadOnly(readOnly);
 },
 SetText: function(text){
  var lb = this.GetListBoxControl();
  var index = this.GetAdjustedSelectedIndexByText(lb, text);
  var isAllowNullValue = !this.isDropDownListStyle || this.allowNull;
  var isChangingTextInEmpty = index < 0 && !text && this.lastSuccessText !== text;
  if(isAllowNullValue || !isChangingTextInEmpty) {
   this.SelectIndex(index, false);
   this.SetTextBase(text);
   this.SetLastSuccessText(text);
   this.SetLastSuccessValue(index >= 0 ? lb.GetValue() : text);
  }
 },
 GetValue: function(){
  var value = this.islastSuccessValueInit ? this.lastSuccessValue : this.GetValueInternal();
  if(this.convertEmptyStringToNull && value === "")
   value = null;
  return value;
 },
 GetValueInternal: function(){
  var text = this.GetTextInternal();
  var textChanges = text != this.lastSuccessText;
  if(textChanges){
   var lb = this.GetListBoxControl();
   if(lb){
    var index = this.GetAdjustedSelectedIndexByText(lb, text);
    this.SelectIndexSilent(lb, index); 
    if(index != -1)
     return lb.GetValue();
   }
  }
  return ASPxClientDropDownEditBase.prototype.GetValue.call(this);
 },
 GetLastSuccesfullValue: function() {
  return this.GetValue();
 },
 GetSetValueOptimizeHelper: function () {
  this.setValueOptimizeHelper = this.setValueOptimizeHelper || new setValueOptimizeHelper();
  return this.setValueOptimizeHelper;
 },
 SetValue: function (value) {
  this.GetSetValueOptimizeHelper().setValue(this, value);
  if(this.accessibilityCompliant)
   this.GetAccessibilityHelper().SetLabelAttribute(null, null);
 },
 SetValueInternal: function(value) {
  var lb = this.GetListBoxControl();
  if (lb) {
   lb.SetValue(value);
   var item = lb.GetSelectedItem();
   var text = item ? item.text : value;
   this.OnSelectionChangedCore(text, item, false);
   this.UpdateValueInput();
  }
 },
 Clear: function() {
  ASPxClientDropDownEditBase.prototype.Clear.call(this);
  if(!this.GetListBoxControl())
   this.islastSuccessValueInit = false;
 },
 GetFormattedText: function() {
  return this.GetText();
 },
 GetAdjustedSelectedIndexByText: function(lb, text){
  if(!lb)
   return -1;
  var lbSelectedItem = lb.GetSelectedItem();
  if(lbSelectedItem != null && (lbSelectedItem.text == text || !this.isInitialized))
   return lbSelectedItem.index;
  return this.FindItemIndexByText(lb, text);
 },
 FindItemIndexByText: function(lb, text){
  if(lb)
   return lb.FindItemIndexByText(text);
 },
 CollectionChanged: function(){
 },
 HasChanges: function(){
  return false;
 },
 SelectIndex: function(index, initialize){
  var lb = this.GetListBoxControl();
  if(!lb)
   return false;
  var isSelectionChanged = lb.SelectIndexSilentAndMakeVisible(index, initialize);
  var item = lb.GetSelectedItem();
  var text = item != null ? item.text : "";
  if(isSelectionChanged || this.HasChanges())
   this.OnSelectionChangedCore(text, item, false);
  this.UpdateValueInput();
  return isSelectionChanged;
 },
 OnSelectChanged: function(){
  if(this.lbEventLockCount > 0) return;
  var lb = this.GetListBoxControl();
  var item = lb.GetSelectedItem();
  var text = item != null ? item.text : "";
  this.OnSelectionChangedCore(text, item, false);
  this.OnChange();
 },
 OnSelectionChangedCore: function(text, item, canBeRolledBack){
  this.SetTextBase(text);
  this.ShowItemImage(item);
  if(!canBeRolledBack){
   this.SetLastSuccessText(text);
   this.SetLastSuccessValue(item != null ? item.value : text);
  }
  if(this.filterStrategy) {
   if(ASPx.Browser.IE) { 
    var inputElement = this.GetInputElement();
    if(ASPx.GetActiveElement() == inputElement)
     ASPx.Selection.Set(inputElement, inputElement.value.length, inputElement.value.length);
   }
  }
 },
 ShowItemImageByIndex: function(index){
  var item = this.GetItem(index);
  this.ShowItemImage(item);
 },
 ShowCurrentItemImage: function() {
  var selectedItem = this.GetSelectedItem();
  this.ShowItemImage(selectedItem);
 },
 ShowItemImage: function(item){
  var imageUrl = item != null ? item.imageUrl : "";
  this.SetSelectedImage(imageUrl);
 },
 GetDropDownImageElement: function(){
  var itemImageCell = this.GetDropDownItemImageCell();
  if(itemImageCell != null)
   return ASPx.GetNodeByTagName(itemImageCell, "IMG", 0);
  return null;
 },
 SetSelectedImage: function(imageUrl) {
  var imgElement = this.GetDropDownImageElement();
  if(imgElement != null) {
   var imageExists = imageUrl != "";
   imageUrl = imageExists ? imageUrl : ASPx.EmptyImageUrl;
   imgElement.src = imageUrl;
   var itemImageCell = this.GetDropDownItemImageCell();
   if(ASPx.GetElementDisplay(itemImageCell) != imageExists)
    ASPx.SetElementDisplay(itemImageCell, imageExists);
   if(ASPx.Browser.IE) {
    this.AdjustControl();
   }
  }
 },
 OnCallback: function(result) {
 },
 OnChange: function(){
  this.UpdateValueInput();
  this.RaisePersonalStandardValidation();
  this.OnValueChanged();
 },
 UpdateValueInput: function() {
 },
 RaiseValueChangedEvent: function() {
  if(!this.isInitialized) return;
  var processOnServer = ASPxClientTextEdit.prototype.RaiseValueChangedEvent.call(this);
  processOnServer = this.RaiseSelectedIndexChanged(processOnServer);
  return processOnServer;
 },
 RaiseSelectedIndexChanged: function(processOnServer) {
  if(!this.SelectedIndexChanged.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.SelectedIndexChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 GetItemHtmlContent: function(index) {
  var lb = this.GetListBoxControl();
  return lb && lb.GetItemHtmlContent(index);
 },
 AddItem: function(texts, value, imageUrl, htmlContent, cssClass, tooltip) {
  var index = this.GetListBoxControl().AddItem(texts, value, imageUrl, htmlContent, cssClass, tooltip);
  this.CollectionChanged();
  return index;
 },
 InsertItem: function(index, texts, value, imageUrl, htmlContent, cssClass, tooltip){
  this.GetListBoxControl().InsertItem(index, texts, value, imageUrl, htmlContent, cssClass, tooltip);
  this.CollectionChanged();
 },
 RemoveItem: function(index){
  this.GetListBoxControl().RemoveItem(index);
  this.CollectionChanged();
 },
 ClearItems: function(){
  this.GetListBoxControl().ClearItems();
  this.ClearItemsInternal();
 },
 BeginUpdate: function(){
   this.GetListBoxControl().BeginUpdate();
 },
 EndUpdate: function(){
  this.GetListBoxControl().EndUpdate();
  this.CollectionChanged();
 },
 MakeItemVisible: function(index){
 },
 GetItem: function(index){
  var lb = this.GetListBoxControl();
  if(lb)
   return this.GetItemCore(index);
  else
   return null;
 },
 GetItemCore: function(index) {
  return this.GetListBoxControl().GetItem(index);
 },
 FindItemByText: function(text) {
  var lb = this.GetListBoxControl();
  if(lb)
   return lb.FindItemByText(text);
  return null;
 },
 FindItemByValue: function(value){
  var lb = this.GetListBoxControl();
  if(lb)
   return lb.FindItemByValue(value);
  return null;
 },
 GetItemCount: function(){
  var lb = this.GetListBoxControl();
  if(lb)
   return lb.GetItemCount(); 
  return 0;
 },
 GetSelectedIndex: function(){
  var lb = this.GetListBoxControl();
  if(lb)
   return lb.GetSelectedIndex();
  else
   return -1;
 },
 SetSelectedIndex: function(index){
  this.SelectIndex(index, false);
 },
 GetSelectedItem: function(){
  var lb = this.GetListBoxControl();
  var index = lb.GetSelectedIndex();
  return lb.GetItem(index);
 },
 SetSelectedItem: function(item){
  var index = (item != null) ? item.index : -1;
  this.SelectIndex(index, false);
 },
 GetText: function(){
  return this.lastSuccessText;
 },
 PerformCallback: function(arg) {
 },
 ClearItemsInternal: function(){
  this.SetValue(null);
  this.CollectionChanged();
 },
 GetModifyEvent: function() {
  if(this.isNative)
   return this.SelectedIndexChanged;
  else
   return ASPxClientDropDownEditBase.prototype.GetModifyEvent.call(this);
 }
});
var ASPxClientComboBox = ASPx.CreateClass(ASPxClientComboBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.allowMultipleCallbacks = false;
  this.allowNull = false;
  this.isCallbackMode = false;
  this.loadDropDownOnDemand = false;
  this.needToLoadDropDown = false;
  this.isPerformCallback = false;
  this.changeSelectAfterCallback = 0;
  this.incrementalFilteringMode = "Contains";
  this.filterStrategy = null;
  this.filterTimer = ASPx.Browser.WebKitTouchUI ? 300 : 100; 
  this.filterMinLength = 0;
  this.customFiltering = false;
  this.initTextCorrectionRequired = false;
  this.isDropDownListStyle = true;
  this.defaultDropDownHeight = "";
  this.dropDownHeight = "";
  this.dropDownWidth = "";
  this.dropDownRows = 7;
  this.enterKeyPressed = false;
  this.onLoadDropDownOnDemandCallbackFinalizedEventHandler = null;
  this.callBackCoreComplete = false; 
  this.adroidSamsungBugTimeout = 0; 
  this.isNeedToForceFirstShowLoadingPanel = true; 
  this.forceLoadCustomRangeOnDropDown = false;
  this.needToInitPopupWindowOnShow = false;
  this.ItemFiltering = new ASPxClientEvent();
  this.CustomHighlighting = new ASPxClientEvent();
 },
 Initialize: function(){
  this.needToLoadDropDown = this.loadDropDownOnDemand;
  var lb = this.GetListBoxControl();
  this.InitializeListBoxOwnerName();
  this.InitScrollSpacerVisibility();
  this.InitializeFilterStrategy();
  var mainElement = this.GetMainElement();
  var input = this.GetInputElement();    
  var ddbutton = this.GetDropDownButton();
  ASPx.Evt.AttachEventToElement(input, "paste", this.SyncRawValueIfHasTextDecorators.bind(this, true));
  if(this.isDropDownListStyle && (ASPx.Browser.IE || (ASPx.Browser.WindowsPlatform && ASPx.Browser.Safari))) {
   ASPx.Evt.AttachEventToElement(this.GetInputElement(), "blur", function() {
    var inputElementValue = this.GetInputElement().value;
    if(!this.focusEventsLocked && !inputElementValue && !!this.GetText())
     this.OnTextChanged();
   }.aspxBind(this)); 
   if(ASPx.Browser.IE) {
    ASPx.Evt.PreventElementDragAndSelect(mainElement, true, true);
    ASPx.Evt.PreventElementDragAndSelect(input, true, true);
    if(ddbutton)
     ASPx.Evt.PreventElementDragAndSelect(ddbutton, true);
   }
  }
  if(this.isToolbarItem){
   if(ASPx.Browser.IE && ASPx.Browser.Version == 9)
    input.onmousedown = function(evt) { ASPx.Evt.PreventEvent(evt); };
   else {
    mainElement.unselectable="on";
    input.unselectable="on";
    if(input.offsetParent)
     input.offsetParent.unselectable="on";
    if(ddbutton)
     ddbutton.unselectable="on";
    if(lb)
     lb.SetItemRowsUnselectable();
   }
  }
  this.RemoveRaisePSValidationFromListBox();
  this.RedirectStandardValidators();
  if(lb && lb.GetItemCount() > 0)
   this.EnsureListBoxSelectionSynchronized(lb);
  ASPxClientComboBoxBase.prototype.Initialize.call(this);
 },
 InitScrollSpacerVisibility: function() {
  var lb = this.GetListBoxControl();
  if(!lb || lb.GetItemCount() >= lb.callbackPageSize)
   return;
  lb.SetScrollSpacerVisibility(true, false);
  lb.SetScrollSpacerVisibility(false, false);
 },
 InitializeFilterStrategy: function() {
  var fs = this.filterStrategy;
  ASPx.Evt.AttachEventToElement(this.GetInputElement(), "keydown", fs.OnKeyDown.bind(fs));
 },
 CreateFilterStrategy: function() {
  if(this.incrementalFilteringMode == "Contains")
   return new ComboBoxContainsFilterStrategy(this);
  else if(this.incrementalFilteringMode == "StartsWith")
   return new ComboBoxStartsWithFilterStrategy(this);
  else if(this.incrementalFilteringMode == "None")
   return new ComboBoxDisabledFilterStrategy(this);
 },
 shouldStartUserInputTimer: function() {
  return true;
 },
 onInputChangedOnUserInputTimer: function(onRestart) {
  ASPxClientDropDownEditBase.prototype.onInputChangedOnUserInputTimer.call(this);
  if (!onRestart) {
   this.SyncRawValueIfHasTextDecorators();
   this.filterStrategy.OnInput();
  }
 },
 RaiseItemFiltering: function(item, filter, isFit) {
  if(!this.ItemFiltering.IsEmpty()) {
   var args = new ASPxClientListEditItemFilteringEventArgs(item, filter, isFit);
   this.ItemFiltering.FireEvent(this, args);
   isFit = args.isFit;
  }
  return isFit;
 },
 RaiseCustomHighlighting: function(filter, callbackHighlighting) {
  if(!this.CustomHighlighting.IsEmpty()) {
   var args = new ASPxClientListEditCustomHighlightingEventArgs(filter);
   args.highlighting = callbackHighlighting;
   this.CustomHighlighting.FireEvent(this, args);
   return args.highlighting;
  }
  return callbackHighlighting;
 },
 InlineInitialize: function() {
  this.BeforeInlineInitialize();
  this.filterStrategy = this.CreateFilterStrategy();
  ASPxClientComboBoxBase.prototype.InlineInitialize.call(this);
 },
 UseSpecialKeyboardHandling: function() {
  return true;
 },
 IsClearButtonVisibleAuto: function() {
  return this.allowNull && ASPxClientComboBoxBase.prototype.IsClearButtonVisibleAuto.call(this);
 },
 BeforeInlineInitialize: function() {
  this.lastSuccessValue = this.GetDecodeValue(this.lastSuccessValue);
  this.InsureInputValueCorrect();
 },
 InsureInputValueCorrect: function(){ 
  if(this.initTextCorrectionRequired){
   var lb = this.GetListBoxControl();
   if(lb){
    var initSelectedIndex = lb.GetSelectedIndexInternal();
    if(initSelectedIndex >= 0){
     var initSelectedText = lb.GetItem(initSelectedIndex).text;
     var input = this.GetInputElement();
     if(ASPx.IsExists(this.GetRawValue()) && this.GetRawValue() != initSelectedText){
      this.SetRawValue(initSelectedText);
      this.SetInputValue(this.GetDecoratedText(initSelectedText));
     } 
     else if(input.value != initSelectedText)
      this.SetInputValue(initSelectedText);
    }
   }
  }
 },
 ChangeEnabledAttributes: function(enabled){
  ASPxClientComboBoxBase.prototype.ChangeEnabledAttributes.call(this, enabled);
  var changeEventsMethod = ASPx.Attr.ChangeEventsMethod(enabled);
  var mainElement = this.GetMainElement();
  if(mainElement)
   changeEventsMethod(mainElement, ASPx.Evt.GetMouseWheelEventName(), aspxCBMouseWheel);
  var btnElement = this.GetDropDownButton();
  if(btnElement)
   changeEventsMethod(btnElement, "onmousemove", ASPx.CBDDButtonMMove);
 },
 GetDropDownInnerControlName: function(suffix){
  return ASPxClientDropDownEditBase.prototype.GetDropDownInnerControlName.call(this, suffix);
 },
 AdjustControlCore: function() {
  ASPxClientEdit.prototype.AdjustControlCore.call(this);
  this.ResetDropDownSizeCache();
 },
 RemoveRaisePSValidationFromListBox: function() {
  var listBox = this.GetListBoxControl();
  if(listBox)
   listBox.RaisePersonalStandardValidation = function() { };
 },
 RedirectStandardValidators: function() {
  var valueInput = this.GetValueInput();
  if(ASPx.IsExistsElement(valueInput) && valueInput.Validators) {
   for(var i = 0; i < valueInput.Validators.length; i++)
    valueInput.Validators[i].controltovalidate = valueInput.id;
  }
 },
 GetValueInputToValidate: function(){
  return this.GetValueInput();
 },
 SetText: function(text, applyFilter) {
  ASPxClientComboBoxBase.prototype.SetText.call(this, text);
  if(applyFilter)
   this.filterStrategy.Filtering(true);
 },
 SetTextBase: function(text) {
  ASPxClientComboBoxBase.prototype.SetTextBase.call(this, text);
  this.restartCurrentUserInputTimer();
 },
 SetReadOnly: function(readOnly) {
  if(this.isDropDownListStyle && this.incrementalFilteringMode === "None")
   return;
  ASPxClientComboBoxBase.prototype.SetReadOnly.call(this, readOnly);
 },
 GetValueInput: function(){
  return document.getElementById(this.name + "_" + comboBoxValueInputSuffix);
 },
 GetListBoxScrollDivElement: function(){
  return this.GetListBoxControl().GetScrollDivElement();
 },
 RollbackValueInputValue: function(){
  var inputElement = this.GetValueInput();
  if(inputElement)
   inputElement.value = this.lastSuccessValue;
 },
 UpdateValueInput: function() {
  var inputElement = this.GetValueInput();
  if(inputElement) {
   var value = this.GetValue();
   inputElement.value = value != null ? value : "";
  }
 },
 SetInputValue: function(value) {
  var inputElement = this.GetInputElement();
  if(inputElement) {
   inputElement.value = value;
   this.restartCurrentUserInputTimer();
  }
 },
 CollectionChanged: function(filtering){
  this.GetSetValueOptimizeHelper().onItemCollectionChanged();
  var listBox = this.GetListBoxControl();
  listBox.CollectionChanged(filtering);
  var needUpdateDropDownPositionAndSize = listBox.APILockCount == 0 && (this.isShownAtFirst || this.pcIsShowingNow);
  if(needUpdateDropDownPositionAndSize)
   this.UpdateDropDownPositionAndSize();
 },
 UpdateDropDownPositionAndSize: function(){
  this.InitDropDownSize();
  if(this.droppedDown){
   var pc = this.GetPopupControl();
   var element = this.GetMainElement();
   pc.UpdatePositionAtElement(element);
  }
  if(!this.clientVisible)
   this.ResetControlAdjustment();
 },
 GetDropDownHeight: function(){
  if(this.ddHeightCache != ASPx.InvalidDimension)
   return this.ddHeightCache;
  this.EnsureDropDownWidth(); 
  return this.AdjustListBoxHeight();
 },
 GetDropDownWidth: function(){
  return (this.ddWidthCache != ASPx.InvalidDimension && !this.GetIsControlWidthWasChanged()) ? this.ddWidthCache : this.AdjustListBoxWidth();
 },
 EnsureDropDownWidth: function() {
  this.GetDropDownWidth();
 },
 InitDropDownSize: function() {
  if(!this.enabled || this.GetItemCount() == 0) return; 
  var pc = this.GetPopupControl();
  if(pc && this.IsDisplayed() && !this.IsHidden()) {
   var pcwElement = pc.GetCurrentWindowElement();
   if(ASPx.IsExistsElement(pcwElement)){
    var isPcwDisplayed = ASPx.GetElementDisplay(pcwElement);
    if(!isPcwDisplayed)
     pc.SetWindowDisplay(-1, true);
    var listBoxHeight = this.AdjustListBoxHeight();
    var listBoxWidth = this.AdjustListBoxWidth();
    if(listBoxHeight != this.ddHeightCache || listBoxWidth != this.ddWidthCache){
     this.ddHeightCache = listBoxHeight;
     this.ddWidthCache = listBoxWidth;
     pc.SetSize(this.ddWidthCache, this.ddHeightCache);
    }
    if(!isPcwDisplayed)
     pc.SetWindowDisplay(-1, false);
   }
  } else {
   this.needToInitPopupWindowOnShow = true;
  }
 },
 InitMainElementCache: function(){
  this.mainElementWidthCache = this.GetMainElement().clientWidth;
 },
 GetDefaultDropDownHeight: function(listHeight, count){
  if(this.defaultDropDownHeight == ""){
   this.defaultDropDownHeight = ((listHeight / count) * this.dropDownRows) + "px";
  }
  return this.defaultDropDownHeight;
 },
 AdjustListBoxHeight: function () {
  return this.GetListBoxControl().AdjustHeightInDropDown(this.dropDownHeight, this.dropDownRows, this.GetDefaultDropDownHeight.aspxBind(this));
 },
 AdjustListBoxWidth: function () {
  this.InitMainElementCache();
  return this.GetListBoxControl().AdjustWidthInDropDown(this.GetMainElement(), this.isCallbackMode, this.dropDownWidth);
 },
 SelectIndexSilent: function(lb, index, lockScrollingToItem){
  this.lbEventLockCount ++;
  lb.SelectIndexSilentAndMakeVisible(index, lockScrollingToItem);
  this.ShowItemImageByIndex(index);
  this.lbEventLockCount --;
 },
 GetDecoratedText: function(text) {
  var result;
  var lb = this.GetListBoxControl();
  var hasMultiColumnFormattedSelectedItem = this.displayFormat != null &&
              lb && lb.IsMultiColumn() &&
              this.GetSelectedItem() != null;
  if(hasMultiColumnFormattedSelectedItem)
   result = this.GetMultiColumnFormattedSelectedItemText(lb);
  else
   result = ASPxClientComboBoxBase.prototype.GetDecoratedText.call(this, text);
  return result;
 },
 GetMultiColumnFormattedSelectedItemText: function(lb) {
  var selectedItem = this.GetSelectedItem();
  var textColumnCount = this.GetTextColumnCountForTextDecoration(lb, selectedItem);
  var texts = [textColumnCount];
  for(var i = 0; i < textColumnCount; i++)
   texts[i] = selectedItem.GetColumnTextByIndex(i);
  return ASPx.Formatter.Format(this.displayFormat, texts);
 },
 GetTextColumnCountForTextDecoration: function(lb, item) {
  return lb.GetItemTextCellCount();
 },
 CanApplyNullTextDecoration: function() {
  var result;
  if(this.GetListBoxControl() || !this.loadDropDownOnDemand) {
   var value = this.isInitialized ? this.GetRawValue() : this.GetValue();
   var isValueNull = this.convertEmptyStringToNull && value === "" ? true : value === null;
   result = this.GetSelectedIndex() == -1 && isValueNull;
  } else
   result = this.GetCurrentText() === "";
  return result;
 },
 ForceTextChanged: function() {
  if(this.isCallbackMode && this.filterStrategy)
   this.filterStrategy.ClearFilterApplied();
  ASPxClientComboBoxBase.prototype.ForceTextChanged.call(this);
 },
 ShowDropDownArea: function(isRaiseEvent){
  if(this.needToLoadDropDown) {
   this.EnsureDropDownLoaded();
   return;
  }
  if(this.RequireLoadCustomRangeOnDropDown()){
   this.LoadCustomItemsRange();
   return;
  }
  var lb = this.GetListBoxControl();
  if(!lb || (!this.isDropDownModal() && !lb.GetItemCount()))
   return;
  if(!this.filterStrategy.IsFilterMeetRequirementForMinLength() && !this.isDropDownModal()) {
   this.DropDownButtonPop(true); 
   return;
  }
  if(this.needToInitPopupWindowOnShow) {
   this.needToInitPopupWindowOnShow = false;
   this.InitDropDownSize();
  }
  ASPxClientDropDownEditBase.prototype.ShowDropDownArea.call(this, isRaiseEvent);
  this.EnsureListBoxSelectionSynchronized(lb);
  this.EnsureSelectedItemVisibleOnShow(lb);
  lb.CallbackSpaceInit();
  if(this.accessibilityCompliant)
   this.GetAccessibilityHelper().SetExpandedState(true);
  if(!lb.GetItemCount())
   this.onNoResultsFiltering();
  if(!this.filterStrategy.IsFilterMeetRequirementForMinLength())
   this.onProcessFilterLessMinLength();
 },
 ForceShowLoadingPanel: function() {
  if(this.GetItemCount() == 0 && !this.needToLoadDropDown) {
   var lb = this.GetListBoxControl();
   if(lb) {
    var sizes = { width: this.GetWidth(), height: 100 };
    ASPxClientDropDownEditBase.prototype.ShowDropDownArea.call(this, false, sizes);
    lb.SetHeight(sizes.height);
    lb.SetWidth(sizes.width);
   }
  }
 },
 FireFoxRequiresCacheScrollBar: function(){
  return ASPx.Browser.Firefox && ASPx.Browser.Version >= 3.6; 
 },
 BrowserRequiresCacheScrollBar: function(){
  return ASPx.Browser.WebKitFamily || ASPx.Browser.Opera || this.FireFoxRequiresCacheScrollBar(); 
 },
 HideDropDownArea: function(isRaiseEvent){
  if(this.filterStrategy)
   this.filterStrategy.OnDropDownHideArea();
  if(this.BrowserRequiresCacheScrollBar())
   this.CachedScrollTop();
  ASPxClientDropDownEditBase.prototype.HideDropDownArea.call(this, isRaiseEvent);
  if(this.accessibilityCompliant)
   this.GetAccessibilityHelper().SetExpandedState(false);
 },
 EnsureSelectedItemTextSynchronized: function(){
  var selectedItem = this.GetSelectedItem();
  if(!this.CanSynchronizeSelectedItemText(selectedItem))
   return;
  var textUnsynchronized = this.GetText() !== selectedItem.text;
  var textDecorationUnsynchronized = this.HasTextDecorators() && this.CanApplyTextDecorators() && 
   this.GetDecoratedText(selectedItem.text) !== this.GetInputElement().value; 
  if(textUnsynchronized || textDecorationUnsynchronized || !this.IsImageSynchronized(selectedItem)) {
   this.SetTextBase(selectedItem.text);
   this.ShowItemImage(selectedItem);
   this.SetLastSuccessText(selectedItem.text);
   this.UpdateValueInput();
  }
 },
 IsImageSynchronized: function(selectedItem) {
  var ddImageElement = this.GetDropDownImageElement();
  var imageUrl = selectedItem.imageUrl != "" ? selectedItem.imageUrl : ASPx.Url.GetAbsoluteUrl(ASPx.EmptyImageUrl);
  return !ddImageElement || ASPx.ImageUtils.GetImageSrc(ddImageElement) === imageUrl;
 },
 CanSynchronizeSelectedItemText: function(selectedItem) {
  return !!selectedItem;
 },
 EnsureListBoxSelectionSynchronized: function(listBox){
  var rawText = this.GetTextInternal();
  var lbItem = listBox.GetSelectedItem();
  var lbText = lbItem != null ? lbItem.text : "";
  var isTextsExist = rawText != null && lbText != "";
  var needSynchronize = rawText != lbText || !this.isInitialized;
  if(needSynchronize && isTextsExist) {
   this.SynchronizeListBoxSelection(listBox, rawText);
   if(!this.isInitialized && this.IsValueRestoredByBrowser())
    this.SynchronizeListBoxInitSelection();
  }
 },
 SynchronizeListBoxSelection: function(listBox, rawText) {
  var newSelectedIndex = this.GetAdjustedSelectedIndexByText(listBox, rawText);
  listBox.SelectIndexSilent(newSelectedIndex, false);
 },
 SynchronizeListBoxInitSelection: function() {
  setTimeout(function () {
   var inputText = this.GetInputElement().value;
   var selectedItem = this.FindItemByText(inputText);
   if(selectedItem)
    this.SelectIndex(selectedItem.index, true);
  }.aspxBind(this), 0);
 },
 EnsureSelectedItemVisibleOnShow: function(listBox){
  if(this.BrowserRequiresCacheScrollBar()) 
   listBox.RestoreScrollTopFromCache();
  listBox.EnsureSelectedItemVisible();
 },
 CachedScrollTop: function(){
  this.GetListBoxControl().CachedScrollTop();
  if(this.BrowserRequiresCacheScrollBar()){ 
   var scrollDiv = this.GetListBoxScrollDivElement();
   if(scrollDiv != null)
    scrollDiv.scrollTop = 0;
  }
 },
 IsFilterEnabled: function() {
  return this.incrementalFilteringMode != "None";
 },
 ChangeInputEnabled: function(element, enabled, readOnly){
  ASPxClientTextEdit.prototype.ChangeInputEnabled.call(this, element, enabled, readOnly || (this.isDropDownListStyle && !this.IsFilterEnabled()));
 },
 GetCallbackArguments: function(){
  var args = ASPxClientComboBoxBase.prototype.GetCallbackArguments.call(this);
  args += this.filterStrategy.GetCallbackArguments();
  return args;
 },
 ClearEditorValueByClearButtonCore: function() {
  this.enterKeyPressed = false;
  ASPxClientDropDownEditBase.prototype.ClearEditorValueByClearButtonCore.call(this);
  if(!this.IsFilterEnabled() && this.isDropDownListStyle)
   this.HideDropDownArea();
  else
   this.filterStrategy.OnClearButtonClick();
 },
 ResetEditorState: function() {
  ASPxClientComboBoxBase.prototype.ResetEditorState.call(this);
  this.isNeedToForceFirstShowLoadingPanel = true;
  this.filterStrategy.ResetCallbackState();
 },
 IsFilterRollbackRequiredAfterApply: function() {
  var filterRollbackRequired = !this.GetSelectedItem() && !this.focused && this.InCallback();
  return filterRollbackRequired;
 },
 IsNullState: function() {
  return this.GetSelectedIndex() === -1 && ASPxClientComboBoxBase.prototype.IsNullState.call(this);
 },
 OnPost: function(args) {
  if(!args.isCallback && this.isDropDownListStyle && ASPx.GetFocusedElement() == this.GetInputElement())
   this.OnTextChangedInternal();
  ASPxClientComboBoxBase.prototype.OnPost.call(this, args);
 },
 GetLoadingParentElement: function(listBox) {
  return listBox.GetLoadingParentElement();
 },
 ShowLoadingPanel: function() { 
  var lb = this.GetListBoxControl();
  var loadingParentElement = this.GetLoadingParentElement(lb);
  if(!this.loadingPanelElement) {
   var loadingPanel = this.CreateLoadingPanelWithAbsolutePosition(loadingParentElement, loadingParentElement);
   lb.PreventMouseWheelOnElement(loadingPanel); 
  }
 },
 ShowLoadingDiv: function () {
  var lb = this.GetListBoxControl();
  var loadingParentElement = this.GetLoadingParentElement(lb);
  if(!this.loadingDivElement) {
   var loadingDiv = this.CreateLoadingDiv(loadingParentElement);
   lb.PreventMouseWheelOnElement(loadingDiv);
  }
 },
 HideLoadingPanelOnCallback: function(){
  return false;
 },
 OnCallback: function(result, callbackID) {
  if(!this.CanProcessCallbackResult(callbackID) || !this.GetMainElement())
   return;
  this.defaultDropDownHeight = "";
  if(ASPx.Browser.WebKitTouchUI) { 
   if(this.needToLoadDropDown)
    this.OnLoadDropDownOnDemandCallback(result.c);
   window.setTimeout(function() {
    this.OnCallbackCore(result);
    this.DoEndCallback();
   }.aspxBind(this), 300);
  } else
   this.OnCallbackCore(result);
 },
 OnCallbackCore: function(result) {
  if(result.serverMode)
   this.UpdateStateObjectWithObject({serverMode: true});
  if(this.needToLoadDropDown) {
   if(!ASPx.Browser.WebKitTouchUI)
    this.OnLoadDropDownOnDemandCallback(result.c);
  } else if(!this.filterStrategy.ShouldDiscardCallbackResult()) {
   this.OnCallbackBeforeListBox();
   this.OnListBoxCallback(result);
   this.OnCallbackInternal(result);
   this.OnCallbackFinally(true);
  }
  this.callBackCoreComplete = true;
 },
 OnListBoxCallback: function(result) {
  var selectedValue = this.GetValue();
  var selectedText = this.GetText();
  function shouldSelectSilent(value, text) {
   return value === selectedValue || text === selectedText;
  }
  this.GetListBoxControl().OnCallback(result, shouldSelectSilent);
  this.EnsureSelectedItemTextSynchronized();
 },
 OnLoadDropDownOnDemandCallbackFinalized: function() {
  this.DoReInitializeAfterLoadDropDownOnDemand();
  this.HideLoadingPanel();
  this.HideLoadingDiv();
  var isCallbackForShowDropDownArea = !this.onLoadDropDownOnDemandCallbackFinalizedEventHandler;
  if(isCallbackForShowDropDownArea) {
   this.ShowDropDown();
   if(this.isDropDownModal())
    this.onDropDownModalChanged(true);
  }
  else
   this.onLoadDropDownOnDemandCallbackFinalizedEventHandler();
  this.FixButtonState();
  this.initializeDropDown();
 },
 OnCallbackFinalized: function() {
  if(this.needToLoadDropDown)
   this.OnLoadDropDownOnDemandCallbackFinalized();
 },
 OnLoadDropDownOnDemandCallback: function(html) {
  var node = this.GetLoadedDropDownPrevSibling();
  var tempDiv = node.ownerDocument.createElement('div');
  tempDiv.innerHTML = html;
  var len = tempDiv.childNodes.length;
  for(var ind = len - 1; ind >= 0; ind--) {
   ASPx.InsertElementAfter(tempDiv.childNodes.item(ind), node);
  }
 },
 GetLoadedDropDownPrevSibling: function() {
  return this.GetMainElement();
 },
 ProcessCallbackError: function(errorObj, callbackID) {
  if(!this.CanProcessCallbackResult(callbackID))
   return;
  this.callBackCoreComplete = true;
  ASPxClientDropDownEditBase.prototype.ProcessCallbackError.call(this, errorObj);
 },
 DoEndCallback: function(){ 
  if(!this.callBackCoreComplete && ASPx.Browser.WebKitTouchUI || this.IsDoEndCallbackLocked()) {
   this.UnlockDoEndCallback();
   return;
  }
  this.filterStrategy.OnBeforeDoEndCallback();
  ASPxClientDropDownEditBase.prototype.DoEndCallback.call(this);
  this.filterStrategy.OnAfterDoEndCallback();
  this.callBackCoreComplete = false; 
 },
 RaiseEndCallback: function(){
  if(this.preventEndCallbackRising) {
   this.preventEndCallbackRising = false;
   ASPx.GetControlCollection().DecrementRequestCount(); 
  } else {
   ASPxClientDropDownEditBase.prototype.RaiseEndCallback.call(this);
  }
 },
 OnCallbackError: function(result, data) {
  var lb = this.GetListBoxControl();
  if(lb)
   lb.OnCallbackError(result);
  else
   ASPxClientComboBoxBase.prototype.OnCallbackError.call(this, result, data);
  this.OnCallbackFinally(false);
 },
 OnCallbackFinally: function(isSuccessful){
  this.filterStrategy.OnBeforeCallbackFinally();
  this.CollectionChanged();
  this.HideLoadingElements();
  if(this.isNeedToForceFirstShowLoadingPanel)
   this.isNeedToForceFirstShowLoadingPanel = false;
  this.isPerformCallback = false;
  this.changeSelectAfterCallback = 0;
  if(isSuccessful)
   this.filterStrategy.OnAfterCallbackFinally();
 },
 OnCallbackBeforeListBox: function(){
  var lb = this.GetListBoxControl();
  this.changeSelectAfterCallback = lb.changeSelectAfterCallback;
 },
 OnCallbackCorrectSelectedIndex: function(){
  var lb = this.GetListBoxControl();
  if(this.changeSelectAfterCallback != 0)
   this.SetTextInternal(lb.GetSelectedItem().text);
 },
 OnCallbackInternal: function(result){
  this.OnCallbackCorrectSelectedIndex();
  if(this.isPerformCallback) {
   var lb = this.GetListBoxControl();
   if(!lb.GetItemCount()) {
    this.onNoResultsFiltering();
    if(!this.isDropDownModal())
     this.HideDropDownArea(true);
   }
  }
  this.filterStrategy.OnCallback(result);
 },
 DoReInitializeAfterLoadDropDownOnDemand: function() {
  this.InitializeListBoxOwnerName();
  this.needToLoadDropDown = false;
 },
 CancelLoadCustomRangeOnDropDown: function() {
  delete this.customItemsRangeInfo;
 },
 ForceLoadCustomItemsRangeOnDropDown: function(startIndex, valueToSelect) {
  var count = this.GetListBoxControl().callbackPageSize;
  this.customItemsRangeInfo = { startIndex: startIndex, endIndex: startIndex + count - 1, valueToSelect: valueToSelect };
 },
 RequireLoadCustomRangeOnDropDown: function() { return !!this.customItemsRangeInfo; },
 LoadCustomItemsRange: function() {
  if(this.InCallback()) return;
  this.ClearItems();
  this.ShowInputLoadingPanel();
  var startIndex = this.customItemsRangeInfo.startIndex;
  var endIndex = this.customItemsRangeInfo.endIndex;
  var value = this.customItemsRangeInfo.valueToSelect;
  var callbackArgs = this.GetListBoxControl().GetLoadCustomItemsRangeCallbackArguments(startIndex, endIndex, value);
  this.SendSpecialCallback(callbackArgs, function() { this.OnSuccessCustomItemsRangeLoad(); }.aspxBind(this));
 },
 OnSuccessCustomItemsRangeLoad: function() {
  var info = this.customItemsRangeInfo;
  if(!info) return;
  var listBox = this.GetListBoxControl();
  var startIndex = info.startIndex;
  listBox.serverIndexOfFirstItem = startIndex;
  listBox.SetScrollSpacerVisibility(true, startIndex > 0);
  if(ASPx.IsExists(info.valueToSelect))
   this.SetValue(info.valueToSelect);
  this.CancelLoadCustomRangeOnDropDown();
  this.ShowDropDown();
 },
 EnsureDropDownLoaded: function(callbackFunction) {
  if(this.needToLoadDropDown) {
   this.onLoadDropDownOnDemandCallbackFinalizedEventHandler = callbackFunction ? function() {
    callbackFunction();
   } : null;
   var args = this.FormatLoadDropDownOnDemandCallbackArguments();
   this.SendLoadDropDownOnDemandCallback(args);
  }
 },
 IsDropDownButtonClick: function(evt) {
  return ASPx.GetIsParent(this.GetDropDownButton(), ASPx.Evt.GetEventSource(evt));
 },
 OnDropDown: function(evt) {
  var returnValue = ASPxClientDropDownEditBase.prototype.OnDropDown.call(this, evt);
  if(this.IsDropDownButtonClick(evt) && this.IsCanToDropDown()) {
   this.OnDropDownButtonClick(evt);
   return returnValue;
  }
  return true;
 },
 OnDropDownButtonClick: function(evt) {
  if(this.filterStrategy != null)
   this.filterStrategy.OnDropDownButtonClick();     
  this.ForceRefocusEditor(evt);
 },
 SendCallback: function(onSuccess){
  if(!this.pcIsShowingNow)
   this.ShowLoadingElements();
  ASPxClientComboBoxBase.prototype.SendCallback.call(this, onSuccess);
 },
 IsAndroidKeyEventsLocked: function() {
  return ASPx.Browser.AndroidMobilePlatform && this.androidKeyEventsLocked;
 },
 LockAndroidKeyEvents: function() {
  this.androidKeyEventsLocked = true;
 },
 UnlockAndroidKeyEvents: function() {
  this.androidKeyEventsLocked = false;
 },
 CancelChangesOnUndo: function() {
  if(this.isCallbackMode)
   this.SetTextInternal(this.lastSuccessText);
  else
   this.OnCancelChanges();
  this.filterStrategy.OnUndo();
 },
 OnKeyDown: function(evt) {
  if(this.IsCtrlZ(evt)) {
   this.CancelChangesOnUndo();
   return ASPx.Evt.PreventEvent(evt);
  }
  var isClearKey = ASPx.Data.ArrayIndexOf([ASPx.Key.Delete, ASPx.Key.Backspace], evt.keyCode) >= 0;
  if(isClearKey && this.allowNull && (this.IsAllTextSelected() || this.isDropDownListStyle && !this.IsFilterEnabled()))
   this.ClearEditorValueAndForceOnChange();
  else if(this.IsAndroidKeyEventsLocked())
   return ASPx.Evt.PreventEventAndBubble(evt);
  else
   ASPxClientComboBoxBase.prototype.OnKeyDown.call(this, evt);
 },
 OnKeyUp: function(evt) {
  if(this.IsAndroidKeyEventsLocked())
   return ASPx.Evt.PreventEventAndBubble(evt);
  return ASPxClientComboBoxBase.prototype.OnKeyUp.call(this, evt);
 },
 IsAllTextSelected: function() {
  var input = this.GetInputElement();
  var textLength = input.value.length;
  if(textLength === 0)
   return false;
  var selectionInfo = ASPx.Selection.GetExtInfo(input);
  var selectionLength = selectionInfo.endPos - selectionInfo.startPos;
  return selectionLength === textLength;
 },
 SelectNeighbour: function (step){
  if((this.isToolBarItem && !this.droppedDown) || this.GetReadOnly()) return;
  this.SelectNeighbourInternal(step);
 },
 SelectNeighbourInternal: function(step){
  var lb = this.GetListBoxControl();
  if(this.droppedDown)
   this.lbEventLockCount ++;
  lb.SelectNeighbour(step);
  if(this.droppedDown) {
   var selectedItem = lb.GetSelectedItem();
   if (selectedItem) {
    this.OnSelectionChangedCore(selectedItem.text, selectedItem, true);
   }
   this.lbEventLockCount --;
  }
  if(this.accessibilityCompliant)
   this.GetAccessibilityHelper().SetLabelAttribute(null, null);
 },
 GetFocusSelectAction: function() {
  return (this.isToolbarItem || ASPx.Browser.IE && this.refocusWhenInputClicked) ? null : "all";
 },
 OnArrowUp: function(evt){
  if(!this.isInitialized) return true;
  if(this.RequireLoadCustomRangeOnDropDown() && !this.droppedDown) {
   this.LoadCustomItemsRange();
   return;
  }
  var isProcessed = ASPxClientDropDownEditBase.prototype.OnArrowUp.call(this, evt);
  if(!isProcessed && this.filterStrategy.CanNavigateByKbd())
   this.SelectNeighbour(-1);
  return true;
 },
 OnTextChanged: function(){
  if(!this.IsFocusEventsLocked())
   ASPxClientComboBoxBase.prototype.OnTextChanged.call(this);
 },
 OnTextChangedInternal: function() {
  if(!this.forceValueChanged) {
   var preserveFilterInInput = this.InCallback() && this.filterStrategy.currentCallbackIsFiltration;
   if(preserveFilterInInput) return;
  }
  ASPxClientComboBoxBase.prototype.OnTextChangedInternal.call(this);
  if(this.filterStrategy)
   this.filterStrategy.OnTextChanged();
 },
 OnArrowDown: function(evt){
  if(!this.isInitialized) return true;
  if(this.RequireLoadCustomRangeOnDropDown() && !this.droppedDown) {
   this.LoadCustomItemsRange();
   return;
  }
  var isProcessed = ASPxClientDropDownEditBase.prototype.OnArrowDown.call(this, evt);
  if(!isProcessed && this.filterStrategy.CanNavigateByKbd())
   this.SelectNeighbour(1);
  return true;
 },
 OnPageUp: function(){
  if(!this.isInitialized || !this.filterStrategy.CanNavigateByKbd()) return true;
  return this.OnPageButtonDown(false);
 },
 OnPageDown: function(){
  if(!this.isInitialized || !this.filterStrategy.CanNavigateByKbd()) return true;
  return this.OnPageButtonDown(true);
 },
 OnPageButtonDown: function(isDown){
  if(!this.isInitialized) return true;
  var lb = this.GetListBoxControl();
  if(lb){
   var direction = isDown ? 1 : -1;
   this.SelectNeighbour(lb.scrollPageSize * direction);
  }
  return true;
 },
 OnHomeKeyDown: function(evt){
  if(!this.isInitialized) return true;
  return this.OnHomeEndKeyDown(evt, true);
 },
 OnEndKeyDown: function(evt){
  if(!this.isInitialized) return true;
  return this.OnHomeEndKeyDown(evt, false);
 },
 OnHomeEndKeyDown: function(evt, isHome){
  if(!this.isInitialized) return true;
  var input = this.GetValueInput();
  if((input && input.readOnly) || evt.ctrlKey){
   var lb = this.GetListBoxControl();
   var count = lb.GetItemCount();
   this.SelectNeighbour(isHome ? -count : count);
   return true;
  }
  return false;
 },
 OnEscape: function() {
  this.filterStrategy.OnEscape();
  return ASPxClientComboBoxBase.prototype.OnEscape.call(this);
 },
 OnEnter: function(){
  if(!this.isInitialized) return true;
  if(this.isDropDownListStyle) this.enterKeyPressed = true;
  if(this.filterStrategy.IsCloseByEnterLocked()) return;
  this.enterProcessed = this.droppedDown; 
  if(!this.isEnterLocked) { 
   this.OnApplyChangesAndCloseWithEvents();
   this.filterStrategy.OnAfterEnter();
  }
  return this.enterProcessed;
 },
 OnTab: function(evt){
  if(!this.isInitialized) 
   return true;
  if(this.InCallback())
   this.filterStrategy.callbackProcessingStateManager.SetApply();
  else
   this.OnApplyChangesAndCloseWithEvents();
 },
 OnApplyChanges: function(){
  if(!this.focused || (this.isDropDownListStyle && !this.IsFilterEnabled())) return;
  this.OnApplyChangesInternal();
 },
 OnApplyChangesAndCloseWithEvents: function() {
  this.OnApplyChangesInternal();
  this.HideDropDownArea(true);
 },
 OnApplyChangesInternal: function(){
  var inCallback = this.InCallback();
  var lb = this.GetListBoxControl();
  var isChanged = this.HasChanges();
  var isRollback = false;
  if(isChanged || this.filterStrategy.isTotallyMismatchedFilter) {
   this.filterStrategy.isTotallyMismatchedFilter = false;
   this.filterStrategy.needEmptyFilterBeforeFiltering = false;
   var text = this.GetCurrentText();
   if(this.filterStrategy.OnApplyChanges())
    return;
   var adjustedSelectedIndex = this.GetAdjustedSelectedIndexByText(lb, text);
   var isNullState = this.allowNull && !text;
   var rollbackRequired = this.isDropDownListStyle && adjustedSelectedIndex < 0 && !isNullState;
   if(rollbackRequired) {
    var rollbackToItem = lb.GetSelectedItem();
    isRollback = rollbackToItem == null && this.isCallbackMode; 
    if(isRollback) {
     this.RollbackValueInputValue();
     this.RollbackTextInputValue();
    }
    text = rollbackToItem != null ? rollbackToItem.text : this.lastSuccessText;
   } 
   if(!isRollback) {
    var adjustedSelectedItem = this.GetItem(adjustedSelectedIndex);
    var adjustedSelectedItemText = adjustedSelectedItem && adjustedSelectedItem.text;
    text = adjustedSelectedItemText || text;
    var hasChanges = this.HasChanges(text);
    this.SetText(text);
    if(hasChanges)
     this.OnChange();
   }
   else if(!inCallback) {
    this.filterStrategy.OnFilterRollback();
   }
  } 
 },
 GetCurrentText: function(){
  var textDecorated = !this.focused && this.GetRawValue() != null;
  return textDecorated ? this.GetRawValue() : this.GetInputElement().value;
 },
 GetCurrentValue: function(){
  var value = null;
  var selectedItem = this.listBox.GetSelectedItem();
  if(selectedItem && (selectedItem.value !== "" || !this.convertEmptyStringToNull))
   value = selectedItem.value;
  return selectedItem ? value : this.GetValue();
 },
 HasChanges: function(currentText){
  currentText = currentText === undefined ? this.GetCurrentText() : currentText;
  return this.lastSuccessText != currentText || this.lastSuccessValue != this.GetCurrentValue();
 },
 OnButtonClick: function(number){
  if(number != this.dropDownButtonIndex) {
   if(this.droppedDown)
    this.OnApplyChangesAndCloseWithEvents(false);
   else
    ASPxClientComboBoxBase.prototype.OnTextChanged.call(this);
  }
  ASPxClientButtonEditBase.prototype.OnButtonClick.call(this, number);
 },
 OnCancelChanges: function(){
  var isCancelProcessed = ASPxClientDropDownEditBase.prototype.OnCancelChanges.call(this);
  this.filterStrategy.OnCancelChanges();
  var lb = this.GetListBoxControl();
  if(ASPx.IsExists(lb)) {
   var index = this.GetAdjustedSelectedIndexByText(lb, this.lastSuccessText);
   this.SelectIndexSilent(lb, index);
  }
  return isCancelProcessed;
 },
 ShouldCloseOnMCMouseDown: function () {
  return this.GetInputElement().readOnly;
 },
 OnCloseUp: function(evt){
  var evt = ASPx.Evt.GetEvent(evt);
  if(ASPx.Browser.Firefox && evt.type == "mouseup" && ASPx.Evt.GetEventSource(evt).tagName == "DIV") { 
   var scrollDiv = this.GetListBoxControl().GetScrollDivElement();
   var scrollDivID = scrollDiv ? scrollDiv.id : "";
   if(scrollDivID == ASPx.Evt.GetEventSource(evt).id) 
    return;
  }
  ASPxClientDropDownEditBase.prototype.OnCloseUp.call(this, evt);
 },
 OnDDButtonMouseMove: function(evt){
  return (this.droppedDown ? ASPx.Evt.CancelBubble(evt) : true);
 },
 CloseDropDownByDocumentOrWindowEvent: function(causedByWindowResizing) {
  if(!this.InCallback()) {
   this.OnApplyChangesInternal();
   ASPxClientDropDownEditBase.prototype.CloseDropDownByDocumentOrWindowEvent.call(this, causedByWindowResizing);
  }
  this.filterStrategy.OnDropDownCloseByDocumentOrWindowEvent();
 },
 IsCanToDropDown: function() {
  if(this.loadDropDownOnDemand) {
   var lb = this.GetListBoxControl();
   return (!this.needToLoadDropDown && (lb.GetItemCount() || this.isDropDownModal()));
  }
  return ASPxClientDropDownEditBase.prototype.IsCanToDropDown.call(this);
 },
 OnPopupControlShown: function(){
  if(!this.isInitialized) return;
  if(ASPx.Browser.Opera) 
   this.GetListBoxControl().RestoreScrollTopFromCache();
  if(this.lockListBoxClick)
   this.RemoveLockListBoxClick();
  if(this.InCallback()) 
   this.ShowLoadingDivAndPanel();
  ASPxClientDropDownEditBase.prototype.OnPopupControlShown.call(this);
  if(!this.isShownAtFirst) {
   if(this.GetListBoxControl().ResetItemHeightIfRequired()) {
    this.AdjustListBoxHeight();
    this.InitDropDownSize();
   }
   this.isShownAtFirst = true;
  }
 },
 OnLBSelectedIndexChanged: function(){
  if(!this.lockListBoxClick) {
   this.OnSelectChanged();
   this.filterStrategy.OnSelectedIndexChanged();
   if(this.IsNavigationOnKeyPress()){
    if(!this.droppedDown) {
     ASPx.Selection.Set(this.GetInputElement());
    }
   } else if(this.focused) {
    if(ASPx.IsElementVisible(this.GetInputElement())) 
     this.ForceRefocusEditor();
    else {
     this.UnlockFocusEvents(); 
     this.OnLostFocus(); 
    }
   }
  }
 },
 IsNavigationOnKeyPress: function() {
  var lb = this.GetListBoxControl();
  return lb.IsScrollOnKBNavigationLocked();
 },
 OnListBoxItemMouseUp: function(evt){
  if(!this.lockListBoxClick && !this.InCallback()){
   this.OnApplyChangesInternal();
   this.OnCloseUp(evt);
  }
 },
 OnMouseWheel: function(evt){
  if(this.allowMouseWheel && !this.droppedDown && this.filterStrategy.CanNavigateByKbd()) {
   var wheelDelta = ASPx.Evt.GetWheelDelta(evt);
   if(wheelDelta > 0)
    this.SelectNeighbour(-1);
   else  if(wheelDelta < 0)
    this.SelectNeighbour(1);
   return ASPx.Evt.PreventEvent(evt);
  }
 },
 OnOpenAnotherDropDown: function(){
  this.OnApplyChangesAndCloseWithEvents();
 },
 ParseValue: function() {
  var forceValueChanged = !this.IsValueChanging() && this.IsValueChangeForced();
  var newText = this.GetInputElement().value;
  var oldText = this.GetText();
  var isNeedToParseValue = oldText != newText;
  if(isNeedToParseValue || forceValueChanged) {
   this.StartValueChanging();
   if(this.CanTextBeAccepted(newText, oldText) || forceValueChanged){
    if(isNeedToParseValue || newText)
     this.SetText(newText);
    this.OnChange();
   } else
    this.SetTextInternal(oldText);
   this.EndValueChanging();
  }
 },
 CanTextBeAccepted: function(newText, oldText){
  var notAnyTextCanBeAccepted = this.isDropDownListStyle;
  if(notAnyTextCanBeAccepted){
   var lb = this.GetListBoxControl();
   var newTextPresentInItemCollection = this.GetAdjustedSelectedIndexByText(lb, newText) != -1;
   return newTextPresentInItemCollection;
  }
  var wasTextErased = !newText && oldText;
  if((!wasTextErased) && this.nullText && this.CanApplyNullTextDecoration()) {
   return false;
  }
  return true;
 },
 MakeItemVisible: function(index){
  var lb = this.GetListBoxControl();
  lb.MakeItemVisible(index);
 },
 PerformCallback: function(arg, onSuccess) {
  this.isPerformCallback = true;
  this.CancelLoadCustomRangeOnDropDown();
  this.filterStrategy.OnPerformCallback();
  if(this.needToLoadDropDown) {
   var formatCallbackArg = function(prefix, arg) {  
    arg = arg.toString();
    return (ASPx.IsExists(arg) ? prefix + "|" + arg.length + ';' + arg + ';' : "");
   };
   if(arg === undefined || arg == null)
    arg = "";
   var performArgs = formatCallbackArg(ASPxClientListEdit.CONSTANTS.CALLBACK_PREFIXES.CUSTOM, arg);
   this.onLoadDropDownOnDemandCallbackFinalizedEventHandler = function() {
    var selectedItem = this.listBox.GetSelectedItem();
    if(selectedItem != null)
     this.SetTextInternal(selectedItem.text);
    var lb = this.GetListBoxControl();
    if(lb)
     lb.SetCustomCallbackArg(performArgs);
   };
   var loadItemsRangeArgs = formatCallbackArg(ASPxClientListEdit.CONSTANTS.CALLBACK_PREFIXES.LOAD_RANGE_ITEMS, "0:-2");
   var args = this.FormatLoadDropDownOnDemandCallbackArguments(performArgs + loadItemsRangeArgs);
   this.SendLoadDropDownOnDemandCallback(args, onSuccess);
  } else {
   this.ClearItemsInternal();
   this.GetListBoxControl().PerformCallback(arg, onSuccess);
  }
 },
 ClearItemsInternal: function(){
  ASPxClientComboBoxBase.prototype.ClearItemsInternal.call(this);
  var lbScrollDiv = this.GetListBoxScrollDivElement();
  if(lbScrollDiv)
   lbScrollDiv.scrollTop = "0px";
 },
 SendLoadDropDownOnDemandCallback: function(args, handler) {
  this.ShowInputLoadingPanel();
  this.SendSpecialCallback(args, handler);
 },
 ShowInputLoadingPanel: function() {
  var inputElement = this.GetInputElement();
  var inputParentElement = inputElement.parentNode;
  this.CreateLoadingDiv(inputParentElement, inputElement);
  this.CreateLoadingPanelWithAbsolutePosition(inputParentElement, inputElement);
 },
 FormatLoadDropDownOnDemandCallbackArguments: function(args) {
  var internalArgs = ASPx.IsExists(args) ? args.toString() : "";
  var resultArgs = loadDropDownOnDemandCallbackPrefix + "|0;;";
  return resultArgs + internalArgs;
 },
 CorrectCaretPositionInChrome: function() {
  if(!ASPx.Browser.Chrome) return;
  var currentSelection = ASPx.Selection.GetInfo(this.GetInputElement());
  if(currentSelection.startPos === currentSelection.endPos)
   ASPx.Selection.SetCaretPosition(this.GetInputElement(), 0);
 },
 ForceRefocusEditor: function(evt, isNativeFocus) {
  this.CorrectCaretPositionInChrome();
  this.refocusWhenInputClicked = this.IsElementBelongToInputElement(ASPx.Evt.GetEventSource(evt));
  ASPxClientButtonEditBase.prototype.ForceRefocusEditor.call(this, evt, isNativeFocus);
 },
 OnFocus: function () {
  if(this.needToLoadDropDown) {
   var args = this.FormatLoadDropDownOnDemandCallbackArguments();
   this.SendLoadDropDownOnDemandCallback(args);
  } else
   this.FixButtonState();
  ASPxClientDropDownEditBase.prototype.OnFocus.call(this);
 },
 FixButtonState: function() {
  var lb = this.GetListBoxControl();
  if(lb && this.ddButtonPushed) {
   this.DropDownButtonPop(true);
  }
 },
 getDropDownEventTargets: function() {
  return ASPxClientComboBoxBase.prototype.getDropDownEventTargets.call(this).concat([
   this.isDropDownListStyle ? this.getInputCell() : null,
  ]);
 },
 onDropDownModalChanged: function(enabled) {
  ASPxClientComboBoxBase.prototype.onDropDownModalChanged.call(this, enabled);
  if(!enabled) {
   if(!this.GetItemCount() || !this.filterStrategy.IsFilterMeetRequirementForMinLength())
    setTimeout(this.HideDropDownArea.bind(this, true), 0);
   this.showDropDownModalMessageElement(false);
  }
  this.GetListBoxControl().onDropDownModalChanged(enabled);
  this.UpdateDropDownPositionAndSize();
 },
 onProcessFilterLessMinLength: function() {
  if(this.isDropDownModal() && this.droppedDown)
   this.showDropDownModalMessageElement(true, this.isDropDownListStyle ? this.msgFilterMinLength : (this.msgFilterMinLength + "<br />" + this.msgFilterNoResults));
  if(!this.isDropDownModal())
   this.HideDropDownArea(true);
 },
 onNoResultsFiltering: function() {
  if(this.isDropDownModal() && this.droppedDown)
   this.showDropDownModalMessageElement(true, this.msgFilterNoResults);
 },
 onBeforeFiltering: function() {
  if(this.isDropDownModal() && this.droppedDown)
   this.showDropDownModalMessageElement(false);
 },
 showDropDownModalMessageElement: function(visible, message) {
  var listBox = this.GetListBoxControl();
  if(!listBox) 
   return;
  if(visible && !this.dropDownModalMessageElement) {
   this.dropDownModalMessageElement = document.createElement("div");
   this.dropDownModalMessageElement.className = "dxdd-info";
   listBox.GetMainElement().parentNode.insertBefore(this.dropDownModalMessageElement, listBox.GetMainElement());
  }
  else if(visible)
   this.dropDownModalMessageElement.style.display = "";
  else if(!visible && this.dropDownModalMessageElement)
   this.dropDownModalMessageElement.style.display = "none";
  if(visible && message)
   this.dropDownModalMessageElement.innerHTML = message;
  if(this.dropDownModalMessageElement)
   ASPx.SetElementDisplay(listBox.GetMainElement(), !visible);
 },
 onDropDownApplyCommandClick: function() {
  this.OnApplyChangesAndCloseWithEvents();
 },
 onDropDownCloseCommandClick: function() {
  this.OnEscape();
 },
 SetItemHtml: function(index, html) {
  this.GetListBoxControl().SetItemHtml(index, html);
 },
 SetItemTooltip: function(index, tooltip) { this.GetListBoxControl().SetItemTooltip(index, tooltip); },
 SetItemAttribute: function(index, attributeName, attributeValue) { this.GetListBoxControl().SetItemAttribute(index, attributeName, attributeValue); },
 AddItemCssClass: function(index, className) { this.GetListBoxControl().AddItemCssClass(index, className); },
 RemoveItemCssClass: function(index, className) { this.GetListBoxControl().RemoveItemCssClass(index, className); },
 SetItemTextCellHtml: function(itemIndex, textCellIndex, html) { this.GetListBoxControl().SetItemTextCellHtml(itemIndex, textCellIndex, html); },
 SetItemTextCellTooltip: function(itemIndex, textCellIndex, tooltip) { this.GetListBoxControl().SetItemTextCellTooltip(itemIndex, textCellIndex, tooltip); },
 SetItemTextCellAttribute: function(itemIndex, textCellIndex, attributeName, attributeValue) { this.GetListBoxControl().SetItemTextCellAttribute(itemIndex, textCellIndex, attributeName, attributeValue); },
 AddItemTextCellCssClass: function(itemIndex, textCellIndex, className) { this.GetListBoxControl().AddItemTextCellCssClass(itemIndex, textCellIndex, className); },
 RemoveItemTextCellCssClass: function(itemIndex, textCellIndex, className) { this.GetListBoxControl().RemoveItemTextCellCssClass(itemIndex, textCellIndex, className); },
 GetAccessibilityText: function() {
  var helper = this.GetAccessibilityHelper();
  return helper && helper.getListSelectedItemText() || this.GetCurrentText();
 }
});
ASPx.Ident.scripts.ASPxClientComboBox = true;
ASPxClientComboBox.Cast = ASPxClientControl.Cast;
var CallbackProcessingStateManager = function(){
 var states = { 
  Default:   0,
  Rollback:     1,
  Apply:     2,
  ApplyAfterRollback: 3
 };
 var state = states.Default;
 return {
  ResetState: function() {
   state = states.Default;
  },
  IsApply: function() {
   return state == states.Apply;
  },
  IsRollback: function() {
   return state == states.Rollback;
  },
  IsApplyAfterRollback: function() {
   return state == states.ApplyAfterRollback;
  },
  NoFilterPostProcessing: function() {
   return !this.IsApply() && !this.IsApplyAfterRollback() && !this.IsRollback();
  },
  SetRollback: function() {
   if(state == states.Default)
    state = states.Rollback;
  },
  SetApply: function() {
   if(state == states.Default)
    state = states.Apply;
  },
  SetApplyAfterRollback: function() {
   if(state == states.Default || state == states.Apply)
    state = states.ApplyAfterRollback;
  },
  OnCallbackResult: function(filterRollbackRequired) {
   if(state == states.Apply) {
    state = filterRollbackRequired ? states.ApplyAfterRollback : states.Default;
    return;
   }
   if(state == states.Rollback) {
    state = states.ApplyAfterRollback;
    return;
   }
   if(state == states.ApplyAfterRollback) {
    state = states.Default;
    return;
   }
  }
 };
};
var ASPxClientNativeComboBox = ASPx.CreateClass(ASPxClientComboBoxBase, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.initSelectedIndex = -1;
  this.raiseValueChangedOnEnter = false;
 },
 InlineInitialize: function () {
  ASPxClientComboBoxBase.prototype.InlineInitialize.call(this);
  var lb = this.GetListBoxControl();
  if(lb != null) lb.SetMainElement(this.GetMainElement());
  if(this.initSelectedIndex == -1) { 
   this.SelectIndex(this.initSelectedIndex, true);
  }
 },
 FindInputElement: function(){
  return this.GetMainElement();
 }, 
 GetDropDownInnerControlName: function(suffix){
  return this.name + suffix;
 },
 PerformCallback: function(arg) {
  this.GetListBoxControl().PerformCallback(arg);
 },
 GetTextInternal: function(){
  var selectedItem = this.GetSelectedItem();
  return (selectedItem != null) ? selectedItem.text : "";
 },
 HasTextDecorators: function() {
  return false;
 },
 SetText: function (text){
  var lb = this.GetListBoxControl();
  var index = this.FindItemIndexByText(lb, text);
  this.SelectIndex(index, false);
  this.SetLastSuccessText((index > -1) ? text : "");
  this.SetLastSuccessValue((index > -1) ? lb.GetValue() : null);
 },
 GetValue: function(){
  var selectedItem = this.GetSelectedItem();
  return (selectedItem != null) ? selectedItem.value : null;
 },
 SetValue: function(value){
  var lb = this.GetListBoxControl();
  if(lb){
   lb.SetValue(value);
   var item = lb.GetSelectedItem();
   var text = item ? item.text : value;
   this.SetLastSuccessText(item != null ? text : "");
   this.SetLastSuccessValue(item != null ? item.value : null);
  }
 },
 ForceRefocusEditor: function(){
 },
 OnCallback: function(result) {
  this.GetListBoxControl().OnCallback(result);
  if(this.GetItemCount() > 0)
   this.SetSelectedIndex(0);
 },
 OnTextChanged: function() {
  this.OnChange();
 },
 SetTextInternal: function(text){
 },
 SetTextBase: function(text){
 },
 ChangeEnabledAttributes: function(enabled){
  this.GetMainElement().disabled = !enabled;
  this.ChangeSpecialInputEnabledAttributes(this.GetMainElement(), ASPx.Attr.ChangeEventsMethod(enabled), true);
 }
});
var AccessibilityHelperComboBox = ASPx.CreateClass(ASPx.AccessibilityHelperBase, {
 constructor: function(comboBox) {
  this.constructor.prototype.constructor.call(this, comboBox);
  this.currentValue = null;
 },
 SetLabelAttribute: function(text, isItemSelected) {
  this.currentValue = this.control.GetValue();
  var message = text !== null ? this.getLabelText(text, isItemSelected) : this.getListSelectedItemText();
  this.PronounceMessage(message);
 },
 PronounceMessage: function(text) {
  var input = this.getInputElement();
  var expandArg = {"aria-expanded" : this.control.droppedDown };
  ASPx.AccessibilityHelperBase.prototype.PronounceMessage.call(this, text, expandArg, ASPx.CloneObject(expandArg), null, input);
 }, 
 SetExpandedState: function(expanded) {
  if(this.currentValue != this.control.GetValue()) {
   this.SetLabelAttribute(null, null);
  } else {
   var input = this.getInputElement();
   var expandArg =  { "aria-expanded": expanded };
   this.changeActivityAttributes(input, expandArg);
   this.changeActivityAttributes(this.getItem(true), expandArg);
  }
 },
 getLabelText: function(text, isItemSelected) {
  var blankText = ASPx.AccessibilitySR.BlankEditorText;
  if(!text)
   text = blankText;
  var itemsCount = this.getListBoxControl().GetVisibleItemCount();
  var formatString = ASPx.AccessibilitySR.ComboBoxFilteringResultFormatString;
  if(!isItemSelected || itemsCount == 1)
   formatString += ASPx.AccessibilitySR.ComboBoxCurrentTextFormatString;
  return ASPx.Str.ApplyReplacement(formatString, [["{0}", itemsCount],
   ["{1}", (isItemSelected || !this.control.lastSuccessText) ? text : this.control.lastSuccessText],
   ["{2}", this.getInputElement().value || blankText]]);
 },
 getListBoxControl: function() { return this.control.GetListBoxControl(); },
 getInputElement: function() { return this.control.GetInputElement(); },
 getListSelectedItemText: function() {
  var lb = this.getListBoxControl();
  var selectedItem = lb.GetSelectedItem();
  var itemText = "";
  if(!!selectedItem) {
   var formatString = ASPx.AccessibilitySR.ItemPositionFormatString;
   var visibleIndex = this.control.isCallbackMode ? selectedItem.index + 1 : lb.GetIndexVisibleItem(selectedItem);
   var itemPositionText = ASPx.Str.ApplyReplacement(formatString, [["{0}", visibleIndex], ["{1}", lb.GetVisibleItemCount()]]);
   itemText = selectedItem.text + itemPositionText;
  } else {
   var input = this.getInputElement();
   itemText = !!input.value ? input.value : ASPx.AccessibilitySR.BlankEditorText;
  }
  return itemText;
 }
});
function setValueOptimizeHelper() {
 var itemCollectionWasChangedSinceLastSetValue = false;
 function canReSetValue() {
  return itemCollectionWasChangedSinceLastSetValue;
 }
 function onSetValue() {
  itemCollectionWasChangedSinceLastSetValue = false;
 }
 return {
  onItemCollectionChanged: function () {
   itemCollectionWasChangedSinceLastSetValue = true;
  },
  setValue: function (comboBox, newValue, methodName) {
   var item = comboBox.FindItemByValue(newValue);
   var reSetValue = comboBox.GetValue() === newValue;
   if (reSetValue && !canReSetValue() && (!item || item.selected)) return;
   comboBox.SetValueInternal(newValue);
   onSetValue();
  }
 };
}
ASPx.CBDDButtonMMove = function(evt){
 return ASPx.GetDropDownCollection().OnDDButtonMouseMove(evt);
};
function aspxCBMouseWheel(evt){
 var srcElement = ASPx.Evt.GetEventSource(evt);
 var focusedCB = ASPx.GetDropDownCollection().GetFocusedDropDown();
 if(focusedCB != null && ASPx.GetIsParent(focusedCB.GetMainElement(), srcElement))
  return focusedCB.OnMouseWheel(evt);
}
var ComboBoxDisabledFilterStrategy = ASPx.CreateClass(ASPx.ListEditFilterStrategyBase, {
 constructor: function(comboBox) {
  this.constructor.prototype.constructor.call(this, comboBox.filterTimer, comboBox.filterMinLength, comboBox.isCallbackMode);
  this.comboBox = comboBox;
  this.callbackProcessingStateManager = new CallbackProcessingStateManager();
 },
 OnDropDownCloseByDocumentOrWindowEvent: function() {
  if(this.comboBox.InCallback())
   this.callbackProcessingStateManager.SetApply();
 },
 OnAfterCallbackFinally: function() {
  if(this.callbackProcessingStateManager.IsApply() || this.callbackProcessingStateManager.IsApplyAfterRollback()) {
   this.comboBox.OnApplyChangesAndCloseWithEvents();
   this.callbackProcessingStateManager.ResetState();
  }
 },
 IsCloseByEnterLocked: function() { return false; },
});
var ComboBoxIncrementalFilterStrategyBase = ASPx.CreateClass(ASPx.ListEditIncrementalFilterStrategyBase, {
 constructor: function(comboBox) {
  this.constructor.prototype.constructor.call(this, comboBox.filterTimer, comboBox.filterMinLength, comboBox.isCallbackMode);
  this.comboBox = comboBox;
  this.isDropDownListStyle = comboBox.isDropDownListStyle;
  this.callbackProcessingStateManager = new CallbackProcessingStateManager();
  this.isTotallyMismatchedFilter = false;
 },
 OnInput: function() {
  if (!this.comboBox.allowNull && !this.GetInputFilterValue())
   this.ClearFilterApplied();
  ASPx.ListEditIncrementalFilterStrategyBase.prototype.OnInput.call(this);
 },
 OnKeyDown: function(evt) {
  var cbInputElement = this.comboBox.GetInputElement();
  var selInfo = ASPx.Selection.GetInfo(cbInputElement);
  if(selInfo.startPos != selInfo.endPos && evt.keyCode == ASPx.Key.Backspace) {
   var currentText = cbInputElement.value;
   var cutText = currentText.slice(0, selInfo.startPos) + currentText.slice(selInfo.endPos);
   var newFilter = ASPx.Str.PrepareStringForFilter(cutText);
   if(cutText != currentText && this.comboBox.filterStrategy.FilterCompareLower(newFilter)) {
    cbInputElement.value = cutText; 
    ASPx.Selection.SetCaretPosition(cbInputElement, selInfo.startPos);
   }
  }
 },
 OnEscape: function() {
  this.FilterStopTimer();
  if(this.InCallback())
   this.callbackProcessingStateManager.SetRollback();
 },
 OnUndo: function() {
  if(this.isCallbackMode)
   this.Filtering();
  else {
   this.FilteringStopClient();
   this.GetListBoxControl().EnsureSelectedItemVisible();
  }
 },
 OnApplyChanges: function () {
  if (this.IsFilterTimerActive()) {
   this.FilterNowAndApply();
   return true;
  }
  return false;
 },
 OnCancelChanges: function () {
  this.OnFilterRollback();
 },
 OnClearButtonClick: function () {
  if (!this.InCallback()) {
   this.FilteringStop();
   if (this.isCallbackMode)
    this.Filtering();
  }
 },
 OnDropDownCloseByDocumentOrWindowEvent: function() {
  if(this.InCallback())
   this.callbackProcessingStateManager.SetApply();
 },
 PreventEndCallbackRising: function() {
  this.comboBox.preventEndCallbackRising = true;
 },
 OnBeforeCallbackFinally: function() {
  this.currentCallbackIsFiltration = false;
 },
 OnAfterCallbackFinally: function() {
  var filterRollbackRequired = false;
  if(this.callbackProcessingStateManager.IsApply() || this.callbackProcessingStateManager.IsApplyAfterRollback()) {
   this.ApplyAfterFinalFiltrationCallback();
   filterRollbackRequired = this.comboBox.IsFilterRollbackRequiredAfterApply();
  }
  if(this.callbackProcessingStateManager.IsRollback())
   filterRollbackRequired = true;
  this.callbackProcessingStateManager.OnCallbackResult(filterRollbackRequired);
  if(filterRollbackRequired)
   window.setTimeout(this.OnFilterRollback.bind(this), 0);
 },
 OnPerformCallback: function() {
  this.ClearFilter();
 },
 CanNavigateByKbd: function() {
  return this.IsFilterMeetRequirementForMinLength();
 },
 ApplyAfterFinalFiltrationCallback: function() {
  var itemIsSelected = this.TrySelectItemAfterFilter();
  this.comboBox.HideDropDownArea();
  var requiredApplyFailed = this.comboBox.isDropDownListStyle && !itemIsSelected && this.comboBox.focused && this.callbackProcessingStateManager.IsApply();
  if(requiredApplyFailed)
   this.comboBox.ShowDropDownArea(true);
  var needApplyChanges = itemIsSelected || !this.comboBox.focused;
  if(needApplyChanges)
   this.comboBox.OnApplyChangesInternal();
 },
 TrySelectItemAfterFilter: function() {
  var lb = this.GetListBoxControl();
  if(!lb) return false;
  var selectedItem;
  if(this.isDropDownListStyle)
   selectedItem = lb.GetVisibleItemCount() == 1 ? lb.GetItem(0) : null;
  else
   selectedItem = lb.FindItemByText(this.filter);
  if(selectedItem) {
   lb.SelectIndexSilent(selectedItem.index);
   this.comboBox.SetTextInternal(selectedItem.text);
  }
  return !!selectedItem;
 },
 IsEnabled: function() {
  return this.comboBox.GetEnabled();
 },
 Filtering: function(fromApi) {
  ASPx.ListEditIncrementalFilterStrategyBase.prototype.Filtering.call(this, fromApi);
  this.comboBox.EnsureClearButtonVisibility();
 },
 ShouldClearFilterBeforeFiltering: function(filter) {
  return this.TryRollbackLastSuccessText(this.GetInputFilterValue());
 },
 OnBeforeFiltering: function() {
  this.comboBox.onBeforeFiltering();
  this.EnsureDropDownAreaStateBeforeFiltering();
  if(this.isCallbackMode && !this.comboBox.droppedDown && this.comboBox.isNeedToForceFirstShowLoadingPanel)
   this.comboBox.ForceShowLoadingPanel();
 },
 OnAfterFiltering: function() {
  if(!this.isCallbackMode)
   this.ResetCallbackState();
 },
 OnFilteringCancelled: function(filteringFromApi) {
  if(this.comboBox.isCallbackMode) {
   var firstItem = this.GetListBoxControl().GetItem(0);
   if(firstItem && firstItem.selected) {
    this.HighlightTextAfterCallback(firstItem.text);
    this.EnsureDropDownAreaStateBeforeFiltering();
   }
   else if(filteringFromApi)
    this.EnsureDropDownAreaStateBeforeFiltering();
  }
  this.ResetCallbackState();
 },
 OnFilterRollback: function() {
  if(this.InCallback() && this.currentCallbackIsFiltration) 
   return;
  if(this.isCallbackMode && this.filterInitialized) {
   var listBox = this.GetListBoxControl();
   this.callbackProcessingStateManager.SetApplyAfterRollback();
   if(this.comboBox.GetText() != "" && this.comboBox.isDropDownListStyle) {
    listBox.ClearItems();
    this.needEmptyFilterBeforeFiltering = false;
    var currentSelectedItemCbArgs = ASPx.FilteringUtils.FormatCallbackArg(currentSelectedItemCallbackPrefix, "");
    this.comboBox.SendSpecialCallback(currentSelectedItemCbArgs);
   } else
    this.Filtering();
   this.SetFilter(this.comboBox.GetText());
   this.SetHighlighting(this.filter);
   this.ClearFilterApplied();
  }
 },
 NotifyCollectionChanged: function() {
  this.comboBox.CollectionChanged(true);
 },
 TryProcessFilterLessMinLength: function(oldFilter) {
  this.comboBox.onProcessFilterLessMinLength();
  this.ResetCallbackState();
  this.GetListBoxControl().SelectIndexSilent(-1, false);
  return true;
 },
 GetSelectedIndex: function() {
  return this.comboBox.GetSelectedIndex();
 },
 ResetCallbackState: function() {
  this.callbackProcessingStateManager.ResetState();
 },
 HighlightTextAfterCallback: function() { },
 IsCloseByEnterLocked: function() { return false; },
 TryRollbackLastSuccessText: function(filter) {
  if(this.comboBox.allowNull || filter) return false;
  var inpValue = this.comboBox.lastSuccessText;
  var inputElement = this.comboBox.GetInputElement();
  if(this.comboBox.HasTextDecorators()) {
   this.comboBox.SetRawValue(inpValue);
   if(this.comboBox.CanApplyTextDecorators())
    this.comboBox.SetInputValue(this.comboBox.GetDecoratedText(inpValue));
   else
    this.comboBox.SetInputValue(inpValue);
  }
  else if(inputElement.value != inpValue)
   this.comboBox.SetInputValue(inpValue);
  if(this.comboBox.focused)
   ASPx.Selection.Set(inputElement, 0, inputElement.value.length);
  var lb = this.comboBox.GetListBoxControl();
  if(lb) {
   if(this.comboBox.lastSuccessValue != null)
    lb.SetValue(this.comboBox.lastSuccessValue);
   else {
    var index = lb.FindItemIndexByText(this.comboBox.lastSuccessText);
    lb.SelectIndexSilent(index);
   }
  }
  this.comboBox.ShowCurrentItemImage();
  return true;
 },
 EnsureDropDownAreaStateBeforeFiltering: function() {
  var showDropDown = this.CanShowDropDownOnFocus(this.filter);
  if(this.callbackProcessingStateManager.NoFilterPostProcessing() && showDropDown) {
   var lb = this.GetListBoxControl();
   if(lb)
    lb.LockScrollHandler();
   this.EnsureShowDropDownArea();
   if(lb)
    lb.UnlockScrollHandler();
  } else if(!showDropDown)
   this.comboBox.HideDropDownArea();
 },
 EnsureShowDropDownArea: function() {
  if(!this.comboBox.droppedDown && this.comboBox.focused) {
   this.comboBox.CancelLoadCustomRangeOnDropDown();
   this.comboBox.ShowDropDownArea(true);
  }
 },
 CanShowDropDownOnFocus: function(filter) {
  if(filter != "")
   return true;
  return !!this.comboBox.showDropDownOnFocus ? this.comboBox.showDropDownOnFocus !== "Never" : true;
 },
 AllowEmptyFilterResults: function() {
  return !this.comboBox.isDropDownListStyle;
 },
 GetInputFilterValue: function() {
  var rawValue = this.comboBox.GetRawValue();
  return rawValue !== null && rawValue !== undefined ? rawValue : this.comboBox.GetInputElement().value;
 },
 GetListBoxControl: function() {
  return this.comboBox.GetListBoxControl();
 },
 OnBeforeFilteringOnClient: function(filter) {
  var comboBox = this.comboBox;
  if(comboBox.isDropDownListStyle) {
   if(this.GetInputFilterValue() != filter)
    comboBox.SetInputValue(filter);
   if(ASPx.IsExists(comboBox.GetRawValue()))
    comboBox.SetRawValue(filter);
   this.SetFilter(filter);
  }
  this.TryRollbackLastSuccessText(filter);
 },
 OnAfterFilteringOnClientCore: function (filter, firstSatisfyItemIndex) {
  if(firstSatisfyItemIndex !== -1 && this.CanShowDropDownOnFocus(filter))
   this.GetListBoxControl().CorrectCellWidthsOnFirstRowItemReplacement(0, firstSatisfyItemIndex);
  else {
   this.comboBox.onNoResultsFiltering();
   if(!this.comboBox.isDropDownModal())
    this.comboBox.HideDropDownArea(true);
  }
  this.needEmptyFilterBeforeFiltering = false;
 },
 FilteringStop: function() {
  if(!this.isCallbackMode)
   this.FilteringStopClient();
 },
 FilteringStopClient: function() {
  this.MakeAllItemsVisible();
  this.ClearFilter();
  this.DiscardHighlighting();
 },
 MakeAllItemsVisible: function() {
  ASPx.ListEditIncrementalFilterStrategyBase.prototype.MakeAllItemsVisible.call(this);
  this.NotifyCollectionChanged();
 },
 FilterNowAndApply: function() {
  this.callbackProcessingStateManager.SetApply();
  this.Filtering();
  if(!this.comboBox.isCallbackMode)
   this.comboBox.OnApplyChangesInternal();
 },
 InCallback: function() {
  return this.comboBox.InCallback();
 },
 OnCallbackCore: function(highlighting, newFilterLength) {
  if(this.currentCallbackIsFiltration) {
   var lb = this.GetListBoxControl();
   if(!lb.GetItemCount() || !this.CanShowDropDownOnFocus(this.filter)) {
    this.comboBox.onNoResultsFiltering();
    if(!this.comboBox.isDropDownModal())
     this.comboBox.HideDropDownArea(true);
   }
   else {
    this.OnFilterCallbackHighlightAndSelect(highlighting, newFilterLength);
    var isNeedToKeepDropDownVisible = !this.comboBox.isPerformCallback && this.callbackProcessingStateManager.NoFilterPostProcessing();
    if(!this.CanShowDropDownOnFocus(this.filter))
     this.comboBox.HideDropDownArea();
    else if(isNeedToKeepDropDownVisible)
     this.EnsureShowDropDownArea();
    this.OnEndFiltering();
   }
  }
  else
   this.RefreshHighlighting();
 },
 OnFilterCallbackHighlightAndSelect: function(highlighting, newFilterLength) {
  var listBox = this.GetListBoxControl();
  var firstItemText = listBox.GetItem(0).text;
  var isTextClearing = !this.comboBox.allowNull && this.IsEmptyFilter() && firstItemText;
  if(!isTextClearing) {
   var isFilterRollBack = this.CheckForFilterRollback(newFilterLength);
   var isNonFilterChangingCallback = (listBox.GetSelectedItem() == null);
   this.isTotallyMismatchedFilter = this.TryRollbackLastSuccessText(this.filter);
   var isNullState = this.comboBox.allowNull && !this.filter && !listBox.FindItemByText(this.filter);
   if(!this.isTotallyMismatchedFilter && !isNullState)
    this.SetHighlighting(this.filter, highlighting);
   if(!this.isTotallyMismatchedFilter && !isNullState && (isFilterRollBack || isNonFilterChangingCallback))
    this.HighlightTextAfterCallback(firstItemText);
   else
    this.DiscardHighlighting();
  }
  else
   this.TryRollbackLastSuccessText(this.filter);
 },
 CheckForFilterRollback: function(newFilterLength) {
  var filter = ASPx.Str.PrepareStringForFilter(this.filter);
  if(typeof(newFilterLength) === "number" && filter.length > newFilterLength) {
   this.SetFilter(filter.substring(0, newFilterLength));
   this.comboBox.SetInputValue(this.filter);
   return true;
  }
  return false;
 },
 SendCallbackCore: function() {
  this.comboBox.SendCallback();
 },
 SupportsFilterCorrection: function() {
  return this.isDropDownListStyle;
 },
 SetListBoxSuggestionSelection: function() {
  var lb = this.GetListBoxControl();
  var singleItem = lb && lb.GetVisibleItemCount() == 1;
  var canSuggest = this.comboBox.isDropDownListStyle && this.comboBox.droppedDown && singleItem;
  var itemIndex = -1;
  if(canSuggest) {
   itemIndex = lb.GetFirstFilteredItemIndex();
   this.comboBox.SelectIndexSilent(lb, itemIndex);
  }
  if(this.comboBox.accessibilityCompliant)
   this.comboBox.GetAccessibilityHelper().SetLabelAttribute(canSuggest ? lb.GetItem(itemIndex).text : this.GetInputFilterValue(), canSuggest);
 },
 FilteringBackspace: function() {
  var currentText = this.GetInputFilterValue();
  if(currentText.length)
   this.comboBox.SetInputValue(currentText.slice(0, -1));
  this.FilterStartTimer();
 },
 RaiseItemFilteringEvent: function(item, filter, isFit) {
  return this.comboBox.RaiseItemFiltering(item, filter, isFit);
 },
 RaiseCustomHighlightingEvent: function(filter, callbackHighlighting) {
  return this.comboBox.RaiseCustomHighlighting(filter, callbackHighlighting);
 }
});
var ComboBoxContainsFilterStrategy = ASPx.CreateClass(ComboBoxIncrementalFilterStrategyBase, {
 IsSatisfy: function(text, filter) {
  return ASPx.Str.PrepareStringForFilter(text).indexOf(filter) != -1;
 },
 OnDropDownHideArea: function() {
  if(!this.isCallbackMode)
   this.FilteringStopClient();
 },
 OnDropDownButtonClick: function() {
  var lb = this.GetListBoxControl();
  if(lb && lb.GetVisibleItemCount() == 0 && this.isDropDownListStyle)
   this.comboBox.OnCancelChanges();
 },
 OnTextChanged: function() {
  if(!this.comboBox.IsFocusEventsLocked())
   if(!this.comboBox.ChangedByEnterKeyPress())
    this.OnFilterRollback();
 },
 OnBeforeCallbackFinally: function () {
  this.RefreshHighlighting();
  this.SetListBoxSuggestionSelection();
  ComboBoxIncrementalFilterStrategyBase.prototype.OnBeforeCallbackFinally.call(this);
 },
 OnEndFiltering: function(visibleCollectionChanged) {
  ComboBoxIncrementalFilterStrategyBase.prototype.OnEndFiltering.call(this, visibleCollectionChanged);
  this.SetListBoxSuggestionSelection();
 },
 IsCloseByEnterLocked: function() {
  if(this.comboBox.isDropDownListStyle) {
   if(this.IsFilterTimerActive()) return false;
   var lb = this.GetListBoxControl();
   if(lb && lb.GetVisibleItemCount() == 1) return false;
   var selectedItem = this.comboBox.GetSelectedItem();
   if(selectedItem)
    if(this.GetInputFilterValue() == selectedItem.text)
     return false;
   return true;
  }
  return false;
 },
});
var ComboBoxStartsWithFilterStrategy = ASPx.CreateClass(ComboBoxIncrementalFilterStrategyBase, {
 HighlightTextAfterCallback: function(firstItemText) {
  var lb = this.GetListBoxControl();
  this.FilteringHighlightCompletedText(firstItemText);
  if(this.comboBox.accessibilityCompliant)
   this.comboBox.GetAccessibilityHelper().SetLabelAttribute(firstItemText, true);
  if(!this.comboBox.isPerformCallback)
   this.comboBox.SelectIndexSilent(lb, 0);
 },
 OnFirstSatisfiedItemFound: function(index, text, isTextClearing) {
  if(this.needEmptyFilterBeforeFiltering && isTextClearing) return;
  var lb = this.GetListBoxControl();
  if(!isTextClearing)
   this.FilteringHighlightCompletedText(text);
  this.comboBox.SelectIndexSilent(lb, isTextClearing ? -1 : index, true);
 },
 FilteringHighlightCompletedText: function(filterItemText) {
  var input = this.comboBox.GetInputElement();
  ASPx.StartWithFilteringUtils.HighlightSuggestedText(input, filterItemText, this.comboBox,
   this.comboBox.restartCurrentUserInputTimer.bind(this.comboBox));
  if(ASPx.IsExists(this.comboBox.GetRawValue()))
   this.comboBox.SyncRawValueIfHasTextDecorators(false);
 },
 IsSatisfy: function(text, filter) {
  return ASPx.Str.PrepareStringForFilter(text).indexOf(filter) == 0;
 },
 OnDropDownHideArea: function() {
  this.FilteringStop();
 },
 OnEndFiltering: function(visibleCollectionChanged) {
  ComboBoxIncrementalFilterStrategyBase.prototype.OnEndFiltering.call(this, visibleCollectionChanged);
  var selectedItem = this.GetListBoxControl().GetSelectedItem();
  if (selectedItem)
   this.GetListBoxControl().MakeItemVisible(selectedItem.index);
  if(this.comboBox.accessibilityCompliant) {
   this.comboBox.GetAccessibilityHelper().SetLabelAttribute(!!selectedItem ? selectedItem.text : this.GetInputFilterValue(), !!selectedItem);
  }
 },
 OnAfterEnter: function() {
  var inputElement = this.comboBox.GetInputElement();
  ASPx.Selection.SetCaretPosition(inputElement);
 },
 TrySelectItemAfterFilter: function() {
  var lb = this.GetListBoxControl();
  var selectedItem = lb.GetItem(0);
  return !!selectedItem;
 }
});
ASPx.ComboBoxDisabledFilterStrategy = ComboBoxDisabledFilterStrategy;
ASPx.ComboBoxContainsFilterStrategy = ComboBoxContainsFilterStrategy;
ASPx.ComboBoxStartsWithFilterStrategy = ComboBoxStartsWithFilterStrategy;
window.ASPxClientComboBoxBase = ASPxClientComboBoxBase;
window.ASPxClientComboBox = ASPxClientComboBox;
window.ASPxClientNativeComboBox = ASPxClientNativeComboBox;
})();

(function(dx) {
 var Interactions = ASPx.CreateClass(null, {
  onSwipeLeft: function(selector, func) {
  },
  onSwipeRight: function(selector, func) {
  }
 });
 var BootstrapCore = {};
 BootstrapCore.Interactions = new Interactions();
 BootstrapCore.BootstrapMode = 'Bootstrap4';
 BootstrapCore.IsBootstrap3 = BootstrapCore.BootstrapMode == "Bootstrap3";
 BootstrapCore.IsBootstrap4 = BootstrapCore.BootstrapMode == "Bootstrap4";
 BootstrapCore.IsBootstrap5 = BootstrapCore.BootstrapMode == "Bootstrap5";
 BootstrapCore.CheckReferences = '';
 BootstrapCore.zIndexCategories = {
  dropdown: 1000,
  sticky: 1020,
  fixed: 1030,
  modalBackdrop: 1040,
  modal: 1050,
  popover: 1060,
  tooltip: 1070
 };
 var bsCssClass = "dxbs-" + BootstrapCore.BootstrapMode.charAt(BootstrapCore.BootstrapMode.length - 1);
 if(document && document.documentElement)
  ASPx.AddClassNameToElement(document.documentElement, bsCssClass);
 var BootstrapCssSelectors = {};
 BootstrapCssSelectors.Table = "table";
 BootstrapCssSelectors.TableBordered = "table-bordered";
 BootstrapCssSelectors.TableSmall = BootstrapCore.IsBootstrap3 ? "table-condensed" : "table-sm";
 BootstrapCssSelectors.TableActive = BootstrapCore.IsBootstrap3 ? "" : "table-active";
 BootstrapCssSelectors.BackgroundLight = BootstrapCore.IsBootstrap3 ? "" : "bg-light";
 BootstrapCssSelectors.BackgroundPrimary = BootstrapCore.IsBootstrap3 ? "bg-primary" : "bg-primary text-white";
 BootstrapCssSelectors.BackgroundDanger = "bg-danger";
 BootstrapCssSelectors.Hidden = BootstrapCore.IsBootstrap3 ? "hidden" : "d-none";
 BootstrapCssSelectors.Row = "row";
 BootstrapCssSelectors.Column = "col";
 BootstrapCssSelectors.ColumnAuto = BootstrapCore.IsBootstrap3 ? "" : "col-auto";
 BootstrapCssSelectors.Panel = BootstrapCore.IsBootstrap3 ? "panel" : "card";
 BootstrapCssSelectors.PanelDefault = BootstrapCore.IsBootstrap3 ? "panel-default" : "";
 BootstrapCssSelectors.PanelHeading = BootstrapCore.IsBootstrap3 ? "panel-heading" : "card-header";
 BootstrapCssSelectors.PanelTitle = BootstrapCore.IsBootstrap3 ? "panel-title" : "card-title";
 BootstrapCssSelectors.PanelBody = BootstrapCore.IsBootstrap3 ? "panel-body" : "card-body";
 BootstrapCssSelectors.PanelFooter = BootstrapCore.IsBootstrap3 ? "panel-footer" : "card-footer";
 BootstrapCssSelectors.Radio = BootstrapCore.IsBootstrap3 ? "radio" : "form-check";
 BootstrapCssSelectors.CheckBox = BootstrapCore.IsBootstrap3 ? "checkbox" : "form-check";
 BootstrapCssSelectors.InlineCheckBox = BootstrapCore.IsBootstrap3 ? "checkbox-inline" : "form-check form-check-inline";
 BootstrapCssSelectors.CheckBoxLabel = BootstrapCore.IsBootstrap3 ? "" : "form-check-label";
 BootstrapCssSelectors.CheckBoxInput = BootstrapCore.IsBootstrap3 ? "" : "form-check-input";
 BootstrapCssSelectors.CustomCheckBox = BootstrapCore.IsBootstrap3 ? "" : "custom-control custom-checkbox";
 BootstrapCssSelectors.CustomInlineCheckBox = BootstrapCore.IsBootstrap3 ? "" : "custom-control custom-control-inline custom-checkbox";
 BootstrapCssSelectors.CustomRadioButton = BootstrapCore.IsBootstrap3 ? "" : "custom-control custom-radio";
 BootstrapCssSelectors.CustomInlineRadioButton = BootstrapCore.IsBootstrap3 ? "" : "custom-control custom-control-inline custom-radio";
 BootstrapCssSelectors.CustomCheckLabel = BootstrapCore.IsBootstrap3 ? "" : "custom-control-label";
 BootstrapCssSelectors.CustomCheckInput = BootstrapCore.IsBootstrap3 ? "" : "custom-control-input";
 BootstrapCssSelectors.ControlLabel = BootstrapCore.IsBootstrap3 ? "control-label" : "col-form-label";
 BootstrapCssSelectors.FormControlStatic = BootstrapCore.IsBootstrap3 ? "form-control-static" : "form-control-plaintext" ;
 BootstrapCssSelectors.HelpBlock = BootstrapCore.IsBootstrap3 ? "help-block" : "form-text";
 BootstrapCssSelectors.HasError = BootstrapCore.IsBootstrap3 ? "has-error" : "";
 BootstrapCssSelectors.FormControlFeedback = BootstrapCore.IsBootstrap3 ? "form-control-feedback" : "dxbs-feedback";
 BootstrapCssSelectors.InvalidFormControl = BootstrapCore.IsBootstrap3 ? "" : "is-invalid";
 BootstrapCssSelectors.InvalidFeedback = BootstrapCore.IsBootstrap3 ? "" : "invalid-feedback";
 BootstrapCssSelectors.InputGroup = "input-group";
 BootstrapCssSelectors.InputGroupAppendButton = BootstrapCore.IsBootstrap3 ? "input-group-btn" : "input-group-append";
 BootstrapCssSelectors.InputGroupPrependButton = BootstrapCore.IsBootstrap3 ? "input-group-btn" : "input-group-prepend";
 BootstrapCssSelectors.Divider = BootstrapCore.IsBootstrap3 ? "divider" : "dropdown-divider";
 BootstrapCssSelectors.NavItem = BootstrapCore.IsBootstrap3 ? "" : "nav-item";
 BootstrapCssSelectors.NavLink = BootstrapCore.IsBootstrap3 ? "" : "nav-link";
 BootstrapCssSelectors.DropDownMenu = "dropdown-menu";
 BootstrapCssSelectors.DropDownMenuItem = BootstrapCore.IsBootstrap3 ? "" : "dropdown-item";
 BootstrapCssSelectors.ListBoxItemLink = BootstrapCore.IsBootstrap3 ? "list-group-item" : "list-group-item list-group-item-action";
 BootstrapCssSelectors.HiddenLayout = "dxbs-hl";
 BootstrapCssSelectors.Breabcrumb = "breadcrumb";
 BootstrapCssSelectors.BreadcrumbItem = BootstrapCore.IsBootstrap3 ? "" : "breadcrumb-item";
 BootstrapCssSelectors.Toolbar = "btn-toolbar";
 BootstrapCssSelectors.Button = "btn";
 BootstrapCssSelectors.ButtonGroup = "btn-group";
 BootstrapCssSelectors.ButtonGroupVertical = "btn-group-vertical";
 BootstrapCssSelectors.DropDown = "dropdown";
 BootstrapCssSelectors.DropDownToggle = "dropdown-toggle";
 BootstrapCssSelectors.Modal = "modal";
 BootstrapCssSelectors.ModalContent = "modal-content";
 BootstrapCssSelectors.ModalBody = "modal-body";
 BootstrapCssSelectors.ModalHeader = "modal-header";
 BootstrapCssSelectors.ModalTitle = "modal-title";
 BootstrapCssSelectors.ModalFooter = "modal-footer";
 BootstrapCssSelectors.ModalBackdrop = "modal-backdrop " + (BootstrapCore.IsBootstrap3 ? "in" : "show");
 BootstrapCssSelectors.Label = BootstrapCore.IsBootstrap3 ? "label" : "badge";
 BootstrapCssSelectors.Alert = "alert";
 function selectClass() {
  var argsCount = arguments.length;
  if (argsCount === 1 || BootstrapCore.IsBootstrap3)
   return arguments[0];
  if (argsCount === 2 || BootstrapCore.IsBootstrap4)
   return arguments[1];
  return arguments[2];
 }
 BootstrapCssSelectors.Popover = selectClass("popover");
 BootstrapCssSelectors.PopoverArrow = selectClass("arrow", "arrow", "popover-arrow");
 BootstrapCssSelectors.PopoverBody = selectClass("popover-content", "popover-body");
 BootstrapCssSelectors.PopoverHeader = selectClass("popover-title", "popover-header");
 BootstrapCssSelectors.PopoverBottom = selectClass("bottom", "bs-popover-bottom");
 BootstrapCssSelectors.PopoverLeft = selectClass("left", "bs-popover-left");
 BootstrapCssSelectors.PopoverRight = selectClass("right", "bs-popover-right");
 BootstrapCssSelectors.PopoverTop = selectClass("top", "bs-popover-top");
 BootstrapCssSelectors.Tooltip = selectClass("tooltip");
 BootstrapCssSelectors.TooltipArrow = selectClass("tooltip-arrow", "arrow", "tooltip-arrow");
 BootstrapCssSelectors.TooltipContent = selectClass("tooltip-inner");
 BootstrapCssSelectors.TooltipBottom = selectClass("bottom", "bs-tooltip-bottom");
 BootstrapCssSelectors.TooltipLeft = selectClass("left", "bs-tooltip-left");
 BootstrapCssSelectors.TooltipRigth = selectClass("right", "bs-tooltip-right");
 BootstrapCssSelectors.TooltipTop = selectClass("top", "bs-tooltip-top");
 BootstrapCssSelectors.Border = selectClass("dxbs-border", "border");
 BootstrapCssSelectors.TableHeadLight = selectClass("", "thead-light");
 BootstrapCssSelectors.PanelHeadingTabs = selectClass("panel-heading-tabs", "card-header-tabs");
 BootstrapCssSelectors.TextCenter = "text-center";
 BootstrapCssSelectors.TextRight = selectClass("text-right", "text-right", "text-end");
 BootstrapCssSelectors.MarginStart = selectClass("", "ml", "ms");
 BootstrapCssSelectors.MarginEnd = selectClass("", "mr", "me");
 BootstrapCssSelectors.Badge = selectClass("badge");
 BootstrapCssSelectors.BadgePill = selectClass("", "badge-pill");
 BootstrapCssSelectors.BadgePrimary = selectClass("", "badge-primary", "bg-primary");
 BootstrapCssSelectors.BadgeSecondary = selectClass("", "badge-secondary", "bg-secondary");
 BootstrapCssSelectors.BadgeSuccess = selectClass("", "badge-success", "bg-success");
 BootstrapCssSelectors.BadgeDanger = selectClass("", "badge-danger", "bg-danger");
 BootstrapCssSelectors.BadgeWarning = selectClass("", "badge-warning", "bg-warning");
 BootstrapCssSelectors.BadgeInfo = selectClass("", "badge-info", "bg-info");
 BootstrapCssSelectors.BadgeLight = selectClass("", "badge-light", "bg-light");
 BootstrapCssSelectors.BadgeDark = selectClass("", "badge-dark", "bg-dark");
 BootstrapCssSelectors.TextPrimary = selectClass("text-primary");
 BootstrapCssSelectors.TextSecondary = selectClass("", "text-secondary");
 BootstrapCssSelectors.TextSuccess = selectClass("text-success");
 BootstrapCssSelectors.TextDanger = selectClass("text-danger");
 BootstrapCssSelectors.TextWarning = selectClass("text-warning");
 BootstrapCssSelectors.TextInfo = selectClass("text-info");
 BootstrapCssSelectors.TextLight = selectClass("", "text-light");
 BootstrapCssSelectors.TextDark = selectClass("", "text-dark");
 BootstrapCssSelectors.ButtonPrimary = selectClass("btn-primary");
 BootstrapCssSelectors.ButtonSecondary = selectClass("", "btn-secondary");
 BootstrapCssSelectors.ButtonSuccess = selectClass("btn-success");
 BootstrapCssSelectors.ButtonDanger = selectClass("btn-danger");
 BootstrapCssSelectors.ButtonWarning = selectClass("btn-warning");
 BootstrapCssSelectors.ButtonInfo = selectClass("btn-info");
 BootstrapCssSelectors.ButtonLight = selectClass("", "btn-light");
 BootstrapCssSelectors.ButtonDark = selectClass("", "btn-dark");
 BootstrapCssSelectors.ButtonLink = selectClass("btn-link");
 BootstrapCssSelectors.ButtonOutlineSecondary = selectClass("", "btn-outline-secondary");
 var mediaQueryScreenSizesCache = {};
 function createCssRuleForScreenSizeMediaQuery(cssVarName, fallbackWidth, cssRule) {
  var cache = mediaQueryScreenSizesCache;
  var minWidth = cache[cssVarName] || (cache[cssVarName] = (ASPx.GetCurrentStyle(document.body).getPropertyValue(cssVarName) || fallbackWidth));
  if(minWidth) {
   var styleSheet = ASPx.GetCurrentStyleSheet();
   if(styleSheet)
    styleSheet.insertRule("@media (min-width: " + minWidth + ") {\n" + cssRule + "\n}\n", styleSheet.cssRules.length);
  }
 }
 BootstrapCore.createCssRuleForLargeScreen = function(cssRule) {
  createCssRuleForScreenSizeMediaQuery("--breakpoint-lg", "992px", cssRule);
 };
 function getTableCellStyleRuleCssText(cellElement, addBorders, addPaddings) {
  var cellStyleProperties = [];
  if(addBorders) {
   cellStyleProperties = cellStyleProperties.concat([
    "border", "border-left", "border-top", "border-right", "border-bottom",
    "border-left-width", "border-left-style", "border-left-color",
    "border-top-width", "border-top-style", "border-top-color",
    "border-right-width", "border-right-style", "border-right-color",
    "border-bottom-width", "border-bottom-style", "border-bottom-color"
   ]);
  }
  if(addPaddings)
   cellStyleProperties = cellStyleProperties.concat(["padding", "padding-left", "padding-top", "padding-right", "padding-bottom"]);
  return getStyleRuleCssText(ASPx.GetCurrentStyle(cellElement), cellStyleProperties);
 }
 function getStyleRuleCssText(currentStyle, styleProperties) {
  var rules = [];
  if(currentStyle) {
   for(var i = 0; i < styleProperties.length; i++) {
    var stylePropertyValue = ASPx.Str.Trim(currentStyle.getPropertyValue(styleProperties[i])) + "";
    if(stylePropertyValue)
     rules.push(styleProperties[i] + ": " + stylePropertyValue);
   }
  }
  return rules.join(";");
 }
 function updateTableCellStyleSheetRule(tableClassName, styleSheet, cssText, isHeaderCell, forceAdd) {
  if(!cssText || !cssText.length)
   return;
  var selector = "." + tableClassName + " tr > " + (isHeaderCell ? "th" : "td");
  updateStyleSheetRule(styleSheet, selector, cssText, forceAdd);
 }
 function updateStyleSheetRule(styleSheet, selector, cssText, forceAdd) {
  if(!forceAdd) {
   var rule = ASPx.GetStyleSheetRules(selector.substring(1));
   if(rule)
    rule.style.cssText = cssText;
   else
    forceAdd = true;
  }
  if(forceAdd)
   ASPx.AddStyleSheetRule(styleSheet, selector, cssText);
 }
 BootstrapCore.updateTableCellStyleSheetRules = function(forceAdd) {
  if(BootstrapCore.IsBootstrap3) {
   var styleSheet = ASPx.GetCurrentStyleSheet();
   if(styleSheet) {
    var container = createTestElement();
    var tableElement = document.createElement("table");
    var tableBody = document.createElement("tbody");
    tableElement.appendChild(tableBody);
    container.appendChild(tableElement);
    var row = document.createElement("tr");
    var cell = document.createElement("td");
    row.appendChild(cell);
    tableBody.appendChild(row);
    var rowWithHeaderCell = document.createElement("tr");
    var headerCell = document.createElement("th");
    rowWithHeaderCell.appendChild(headerCell);
    tableBody.appendChild(rowWithHeaderCell);
    document.body.appendChild(container);
    var tableClassName = BootstrapCssSelectors.Table;
    var tableBorderedClassName = BootstrapCssSelectors.TableBordered;
    var tableSmallClassName = BootstrapCssSelectors.TableSmall;
    tableElement.className = tableClassName;
    updateTableCellStyleSheetRule(tableClassName, styleSheet, getTableCellStyleRuleCssText(cell, true, true), true, forceAdd);
    updateTableCellStyleSheetRule(tableClassName, styleSheet, getTableCellStyleRuleCssText(headerCell, true, true), false, forceAdd);
    cell.className = "active";
    var tableActiveCssClass = "dxbs-table-active";
    var tableActiveCssText = getStyleRuleCssText(ASPx.GetCurrentStyle(cell), ["background-color"]);
    updateStyleSheetRule(styleSheet, "." + tableActiveCssClass, tableActiveCssText, forceAdd);
    cell.className = "";
    tableElement.className = tableBorderedClassName;
    updateTableCellStyleSheetRule(tableBorderedClassName, styleSheet, getTableCellStyleRuleCssText(cell, true, false), true, forceAdd);
    updateTableCellStyleSheetRule(tableBorderedClassName, styleSheet, getTableCellStyleRuleCssText(headerCell, true, false), false, forceAdd);
    tableElement.className = tableSmallClassName;
    updateTableCellStyleSheetRule(tableSmallClassName, styleSheet, getTableCellStyleRuleCssText(cell, false, true), true, forceAdd);
    updateTableCellStyleSheetRule(tableSmallClassName, styleSheet, getTableCellStyleRuleCssText(headerCell, false, true), false, forceAdd);
    document.body.removeChild(container);
   }
  }
 };
 var existingColors = {};
 BootstrapCore.createColorItemsRules = function () {
  var colorElements = document.querySelectorAll("[data-color]");
  var cssText = "";
  for (var i = 0; i < colorElements.length; i++) {
   var colorElement = colorElements[i];
   var colorValue = ASPx.Attr.GetAttribute(colorElement, "data-color");
   if(existingColors[colorValue])
    continue;
   existingColors[colorValue] = true;
   cssText += "[data-color=\"" + colorValue + "\"],\n[data-item-color=\"" + colorValue + "\"]:before { background-color: " + colorValue + "; }\n";
  }
  if (cssText)
   BootstrapCore.createStylesBlock(cssText, "colors" + ASPx.CreateGuid());
 };
 BootstrapCore.createColorRule = function(c) {
  if(existingColors[c])
   return;
  existingColors[c] = true;
  ASPx.AddStyleSheetRule(ASPx.GetCurrentStyleSheet(), "[data-color=\"" + c + "\"],\n[data-item-color=\"" + c + "\"]:before", "background-color: " + c + ";");
 };
 BootstrapCore.getActualBgColor = function (el) {
  var color = ASPx.GetCurrentStyle(el).backgroundColor;
  var c = ASPx.Color.ColorToHexadecimal(color, true);
  if(c.a < 1) {
   var bgColor = ASPx.GetCurrentStyle(el.parentNode).backgroundColor;
   var bg;
   while(el.parentNode && el.parentNode.nodeType == 1 && (bg = ASPx.Color.ColorToHexadecimal(bgColor, true)).a === 0)
    bgColor = ASPx.GetCurrentStyle(el = el.parentNode).backgroundColor;
   c.r = Math.round(((1 - c.a) * bg.r) + (c.a * c.r));
   c.g = Math.round(((1 - c.a) * bg.g) + (c.a * c.g));
   c.b = Math.round(((1 - c.a) * bg.b) + (c.a * c.b));
  }
  return "rgb(" + c.r + "," + c.g + "," + c.b + ")";
 };
 var createdStylesBlockKeys = {};
 BootstrapCore.removeStylesBlock = function(key) {
  var stylesBlock = document.getElementById(key + "_styles");
  if(stylesBlock)
   ASPx.RemoveElement(stylesBlock);
 };
 BootstrapCore.createStylesBlock = function(cssText, key, container) {
  key = key + "_styles";
  var styleElement = null;
  if(key) {
   if(createdStylesBlockKeys[key]) {
    styleElement = document.getElementById(key);
    if(styleElement)
     ASPx.RemoveElement(styleElement);
   }
   createdStylesBlockKeys[key] = true;
  }
  styleElement = document.createElement("STYLE");
  styleElement.appendChild(document.createTextNode(cssText));
  if(container === undefined)
   container = ASPx.GetHeadElementOrCreateIfNotExist(document);
  container.appendChild(styleElement);
  styleElement.id = key;
 };
 BootstrapCore.initializeAccentColorRelatedSelectors = function(forceAddCssRule) {
  var linkEl = document.createElement("A");
  linkEl.href = ASPx.AccessibilityEmptyUrl;
  linkEl.className = ASPx.BootstrapCssSelectors.HiddenLayout;
  ASPx.DOM.ChangeDOM(function () {
   document.body.appendChild(linkEl);
   ASPx.DOM.CalculateStyles(function () {
    var accentColor = ASPx.Color.ColorToHexadecimal(ASPx.GetCurrentStyle(linkEl).color);
    ASPx.DOM.ChangeDOM(function() {
     updateStyleSheetRule(ASPx.GetCurrentStyleSheet(), ".dx-accent-color", "color: " + accentColor, forceAddCssRule);
     ASPx.RemoveElement(linkEl);
    });
   });
  });
 };
 function createBootstrapStateItemClass() {
  var stateClass = ASPx.CreateClass(ASPx.StateItem, {
   Clone: function() {
    return new stateClass(this.name, this.classNames, this.cssTexts, this.postfixes,
     this.imageObjs, this.imagePostfixes, this.kind, this.disableApplyingStyleToLink);
   },
   Apply: function(element) {
    this.changeState(element, true);
   },
   Cancel: function(element) {
    this.changeState(element, false);
   },
   changeState: function(element, condition) {
    if(!this.enabled) return;
    var elements = this.GetElements(element);
    for(var i = 0; i < elements.length; i++) {
     if(elements[i])
      this.changeClassName(elements[i], this.GetResultClassName(i), condition);
    }
   },
   changeClassName: function(el, className, condition) {
    if (!!className)
     ASPx.DOM.ToggleCssClass(el, className, condition);
   },
   ForceRedrawAppearance: function() { }
  });
  return stateClass;
 }
 var bootstrapStateItemClass;
 BootstrapCore.AddStateItems = function(callback) {
  ASPx.GetStateController().withCustomStateItemType(bootstrapStateItemClass || (bootstrapStateItemClass = createBootstrapStateItemClass()), callback);
 };
 ASPx.BootstrapCore = BootstrapCore;
 ASPx.BootstrapCssSelectors = BootstrapCssSelectors;
 ASPx.BuildBSCssClass = function() {
  return ASPx.Data.CollectionToArray(arguments)
   .map(function (c) { return BootstrapCssSelectors[c] || c; }).join(" ");
 };
 ASPx.CreatePatchedClass = function(baseClass, properties, patch) {
  var patchedBaseClass = ASPx.CreateClass(baseClass, patch);
  return ASPx.CreateClass(patchedBaseClass, properties || {});
 };
 if(BootstrapCore.CheckReferences)
  ASPx.attachToReady(detectBootstrapFramework);
 function detectBootstrapFramework() {
  var testElement = createTestElement();
  testElement.className = "input-group ms-1";
  document.body.appendChild(testElement);
  var style = ASPx.GetCurrentStyle(testElement);
  var exists = true;
  if (BootstrapCore.BootstrapMode === "Bootstrap3") {
   exists = style.display.indexOf("table") > -1;
  }
  else if (BootstrapCore.BootstrapMode === "Bootstrap4") {
   exists = style.display.indexOf("flex") > -1 &&
      style["margin-left"].indexOf("0") > -1;
  }
  else if (BootstrapCore.BootstrapMode === "Bootstrap5") {
   exists = style.display.indexOf("flex") > -1 &&
      style["margin-left"].indexOf("0") === -1;
  }
  document.body.removeChild(testElement);
  if (!exists) {
   var version = parseInt(ASPx.BootstrapCore.BootstrapMode.substr(9));
   console.error("Bootstrap " + version + " required by DevExpress Bootstrap controls is not linked to the page. Add a bootstrap.css link to the page for the controls to work properly.");
  }
 }
 function createTestElement() {
  var testElement = document.createElement("div");
  testElement.style.position = "absolute";
  testElement.style.top = ASPx.InvalidPosition + "px";
  testElement.style.left = ASPx.InvalidPosition + "px";
  return testElement;
 }
 ASPx.attachToLoad(function() {
  ASPx.BootstrapCore.updateTableCellStyleSheetRules(true);
  ASPx.BootstrapCore.initializeAccentColorRelatedSelectors(true);
 });
})(dx || (dx = {}));

(function(dx) {
 (function (env) {
  var baseClass = env.CreateClass({
   constructor: function (args) {
    Object.defineProperty(this, '__dx__', { value: args, enumerable: false, configurable: false, writable: false });
    if(!args[1].getInstance)
     Object.defineProperty(args[1], 'getInstance', { value: args[2], enumerable: true, configurable: false, writable: false });
   },
   getType: function () { return this.__dx__[1]; },
   clone: function (env) { return create(this.__dx__[0], env, env ? null : this.getType()); }
  });
  function create(setupEnv, envObj, type, ret) {
   type = type || (type = env.CreateClass(baseClass, setupEnv(envObj || env)));
   return ret = new type([setupEnv, type, function () { return ret; }]);
  }
  env.CreateSingleton = create;
 })(ASPx);
 var BootstrapEventManager = {};
 var globalContainersStorage = {};
 function getEventAttachFunc(owner, key) {
  var cs = globalContainersStorage[owner.name];
  if(!cs || cs.checkSum !== owner.checkSum)
   cs = globalContainersStorage[owner.name] = { checkSum: (owner.checkSum = ASPx.CreateGuid()), c: {} };
  return cs.c[key] || (cs.c[key] = createEventHandlerContainer(
   owner.getEventContainers || function() { return [document.getElementById(owner.name)]; }, key));
 }
 function createEventHandlerContainer(getEventContainers, eventName) {
  var elements = getEventContainers();
  var queue = [], i = 0, order = [queue];
  function addToHierarchy(el, handler) {
   var foundQueue = queue;
   var detachIndex = foundQueue.length;
   foundQueue.push({ target: el, handler: handler });
   return function() { foundQueue.splice(detachIndex, 1); };
  }
  function handleEvent(e) {
   if(e.cancelBubble) return;
   var srcEl = ASPx.Evt.GetEventSource(e);
   for(var i = 0; !e.cancelBubble && i < order.length; i++) {
    var q = order[i];
    if(q && q.length) {
     for(var j = 0; !e.cancelBubble && j < q.length; j++) {
      if(ASPx.GetIsParent(q[j].target, srcEl)) {
       q[j].handler(e);
       break;
      }
     }
    }
   }
  }
  for(var i = 0; i < elements.length; i++) {
   ASPx.Evt.AttachEventToElement(elements[i], eventName, handleEvent);
  }
  return addToHierarchy;
 }
 BootstrapEventManager.attachEventToElement = function(owner, element, eventName, handler) {
  var detacherBagRef = element._detacherBagRef || (element._detacherBagRef = {});
  detacherBagRef[eventName] = getEventAttachFunc(owner, eventName)(element, handler);
 };
 BootstrapEventManager.detachEventFromElement = function(element, eventName, handler) {
  var detacherBagRef = element._detacherBagRef || (element._detacherBagRef = {});
  if(detacherBagRef[eventName])
   detacherBagRef[eventName]();
 };
 BootstrapEventManager.EventsHub = ASPx.CreateSingleton(function (ASPx) {
  var eventListenersAttachedToDOM = false, eventListenersBuffer = [], handleOnEventBubbling = true, emptyEventListener = { attach: function () { }, detach: function () { } };
  function ensureEventListenersActive() {
   if (eventListenersAttachedToDOM === true)
    return;
   eventListenersBuffer.forEach(function (f) { f(); });
   eventListenersBuffer = null;
   eventListenersAttachedToDOM = true;
  }
  function getEventListener(eventName, targetGetter) {
   targetGetter = targetGetter || function () { return document; };
   if (eventName === "mouseover" && ASPx.Browser.MobileUI)
    return emptyEventListener;
   var listeners = [];
   function getDepth(root, el) { return el !== root ? getDepth(root, el.parentNode) + 1 : 0; }
   function attachListenersToDOM() {
    ASPx.Evt.AttachEventToElement(targetGetter(), eventName, function (evt) {
     var evtSrc = ASPx.Evt.GetEventSource(evt);
     function invokeHandlerForListener(listener) { listener.handler(listener.el, evt, evtSrc, eventName); }
     function createListenerInfo(listener) {
      var p = ASPx.GetParentBySelector(evtSrc, listener.targetSelector);
      if (!p && !(listener.fallbackSelector && ASPx.ElementMatchesSelector(evtSrc, listener.fallbackSelector)))
       return null;
      return { isFallback: !p, handler: p ? listener.handler : listener.fallbackHandler, el: p || evtSrc, depth: p ? getDepth(p, evtSrc) : 0 };
     }
     function processRelatedListeners(relatedListeners, isFallback) {
      relatedListeners.filter(function (rl) { return rl.isFallback === isFallback; }).sort(function (a, b) { return a.depth < b.depth; }).forEach(invokeHandlerForListener);
     }
     var relatedListeners = listeners.map(createListenerInfo).filter(function (rl) { return !!rl; });
     processRelatedListeners(relatedListeners, false);
     processRelatedListeners(relatedListeners, true);
    }, handleOnEventBubbling);
   }
   function attach(eventListenerInfo) {
    var targetSelector, handler, fallbackSelector, fallbackHandler;
    for (var k in eventListenerInfo) {
     if (eventListenerInfo.hasOwnProperty(k)) {
      if (k === "*") {
       fallbackSelector = k;
       fallbackHandler = eventListenerInfo[k];
      } else {
       targetSelector = k;
       handler = eventListenerInfo[k];
      }
     }
    }
    listeners.push({ targetSelector: targetSelector, handler: handler, fallbackSelector: fallbackSelector, fallbackHandler: fallbackHandler, owner: eventListenerInfo });
   }
   function detach(eventListenerInfo) {
    listeners = listeners.filter(function (l) { return l.owner !== eventListenerInfo; });
   }
   eventListenersBuffer.push(attachListenersToDOM);
   return {
    attach: attach,
    detach: detach
   };
  }
  return {
   getEventListener: getEventListener,
   ensureEventListenersActive: ensureEventListenersActive
  };
 });
 ASPx.BootstrapEventManager = BootstrapEventManager;
 var BootstrapPopupManager = {};
 var visiblePopups;
 var popupInfo = function(elements, onHide){
  this.elements = elements;
  this.onHide = onHide;
 };
 BootstrapPopupManager.registerVisiblePopup = function(elements, onHide){
  if(!visiblePopups)
   visiblePopups = [];
  if(!ASPx.Ident.IsArray(elements))
   elements = [elements];
  visiblePopups.push(new popupInfo(elements, onHide));
  showPopup(elements);
 };
 BootstrapPopupManager.correctPopupPositionForClientWindow = function(elements, hAlign, hOffset, vAlign, vOffset) {
  correctPopupForClientWindow(ASPx.Ident.IsArray(elements) ? elements : [elements], hAlign, hOffset, vAlign, vOffset);
 };
 BootstrapPopupManager.unregisterVisiblePopup = function(elements){
  if(visiblePopups && visiblePopups.length && elements && elements.length) {
   var popupInfo = this.findPopupInfo(elements);
   if(popupInfo) {
    hidePopup(popupInfo.elements);
    ASPx.Data.ArrayRemove(visiblePopups, popupInfo);
    if(popupInfo.onHide)
     popupInfo.onHide();
   }
  }
 };
 BootstrapPopupManager.findPopupInfo = function(elements){ 
  for(var i = 0; i < visiblePopups.length; i++){
   if(ASPx.Data.ArrayEqual(visiblePopups[i].elements, elements))
    return visiblePopups[i];
  }
  return null;
 };
 BootstrapPopupManager.isPopupVisible = function(elements){ 
  return visiblePopups && visiblePopups.length && elements && elements.length && this.findPopupInfo(elements);
 };
 function showPopup(elements) {
  var originElement = getOriginElement(elements);
  var popupElement = getPopupElement(elements);
  var x = ASPx.GetAbsoluteX(originElement);
  var y = ASPx.GetAbsoluteY(originElement) + originElement.offsetHeight;
  ASPx.SetAbsoluteX(popupElement, x);
  ASPx.SetAbsoluteY(popupElement, y);
  ASPx.SetElementDisplay(popupElement, true);
 }
 function correctPopupForClientWindow(elements, hAlign, hOffset, vAlign, vOffset) {
  var originElement = getOriginElement(elements);
  var popupElement = getPopupElement(elements);
  ASPx.SetAbsoluteX(popupElement, correctPopupPositionToClientScreen(popupElement, originElement, true, hAlign, hOffset));
  ASPx.SetAbsoluteY(popupElement, correctPopupPositionToClientScreen(popupElement, originElement, false, vAlign, vOffset));
 }
 function hidePopup(elements){
  var popupElement = getPopupElement(elements);
  if(popupElement)
   ASPx.SetElementDisplay(popupElement, false);
 }
 function getPopupElement(elements){
  return elements && elements.length > 0 ? elements[0] : null;
 }
 function getOriginElement(elements){
  return elements && elements.length > 1 ? elements[1] : null;
 }
 function correctPopupPositionToClientScreen(popupElement, originElement, isX, align, offset) {
  var startPos = ASPx.InvalidPosition; 
  var startPosInit = isX ? ASPx.GetAbsoluteX(popupElement) : ASPx.GetAbsoluteY(popupElement);
  var popupPosition = isX ? ASPx.PopupUtils.GetPopupAbsoluteX(popupElement, originElement, align, offset, startPos, startPosInit, false, true)
   : ASPx.PopupUtils.GetPopupAbsoluteY(popupElement, originElement, align, offset, startPos, startPosInit, true, false);
  return popupPosition.position;
 }
 ASPx.Evt.AttachEventToDocument("mousedown", function(evt) {
  if(!visiblePopups || !visiblePopups.length) return;
  var eventSource = ASPx.Evt.GetEventSource(evt);
  if(typeof(ASPx.GetDropDownCollection) != "undefined") {
   var dropDownCollection = ASPx.GetDropDownCollection();
   var dropDownControl = dropDownCollection.GetDroppedDropDown();
   if(dropDownControl != null) {
    var modalWrapperElement = dropDownControl.GetMainElement().querySelector(".dxbs-ddmodal");
    var isEventFromModalWrapper = ASPx.GetIsParent(modalWrapperElement, eventSource);
    var isEventFromDropDownWindow = ASPx.GetIsParent(dropDownControl.GetDropDownWindow(), eventSource);
    if(!(isEventFromModalWrapper || isEventFromDropDownWindow)) {
     var isEventFromDropDownControl = !dropDownCollection.IsEventNotFromControlSelf(evt, dropDownControl);
     if(isEventFromDropDownControl)
      return;
    }
    var isEventOutFromModalDialog = isEventFromModalWrapper && !isEventFromDropDownWindow;
    if(isEventOutFromModalDialog) {
     dropDownControl.CloseDropDownByDocumentOrWindowEvent(false);
     return;
    }
   }
  }
  for(var i = visiblePopups.length - 1; i >= 0; i--) {
   var needHidePopup = true;
   var popupElements = visiblePopups[i].elements;
   for(var j = 0; j < popupElements.length; j++) {
    if(ASPx.GetIsParent(popupElements[j], eventSource))
     needHidePopup = false;
   }
   if(needHidePopup)
    BootstrapPopupManager.unregisterVisiblePopup(popupElements);
  }
 });
 BootstrapPopupManager.PopupZIndex = 500;
 BootstrapPopupManager.PopupModalZIndex = 1100;
 BootstrapPopupManager.PopupType = "bspopup";
 BootstrapPopupManager.PopupModalType = "modalbspopup";
 ASPx.BootstrapPopupManager = BootstrapPopupManager;
 var defaultDecorationStyles = { };
 var BootstrapEditorStyleDecoration = ASPx.CreateClass(ASPx.TextEditorStyleDecoration, {
  constructor: function(editor) {
   this.constructor.prototype.constructor.call(this, editor);
   if(editor.cssClasses && editor.cssClasses.nt)
    this.innerStyles["N"] = editor.cssClasses.nt;
  },
  InitializeNullTextClassName: function() {
   if(this.HasDecoration("N"))
    this.nullTextClassName = this.innerStyles["N"];
  },
  IsTimeEditDecorated: function() {
   return ASPx.Ident.IsASPxClientTimeEdit && ASPx.Ident.IsASPxClientTimeEdit(this.editor);
  },
  HasDecoration: function(key) {
   var editor = this.editor;
   var validationEnabled = editor.customValidationEnabled;
   var hasNullTextDecoration = key == "N" && (!!editor.nullText || this.IsTimeEditDecorated());
   var hasInvalidDecoration = key == "I" && validationEnabled;
   var hasFocusedDecoration = editor.needFocusedStyleDecoration && (key == "F" || key == "FI" && validationEnabled);
   var hasDecoration = hasNullTextDecoration || hasInvalidDecoration || hasFocusedDecoration;
   if(hasDecoration) { 
    var needUpdateDefaultDecoration = !defaultDecorationStyles[key] || !defaultDecorationStyles[key].isValid;
    if(needUpdateDefaultDecoration)
     BootstrapEditorStyleDecoration.UpdateDefaultDecorationStyles([key]);
    if(!this.innerStyles[key] && defaultDecorationStyles[key])
     this.innerStyles[key] = defaultDecorationStyles[key].className;
   }
   return hasDecoration;
  },
  CanApplyNullTextStyleToElement: function(element) {
   var needApplyNullTextClassName = this.editor.focused && this.IsTimeEditDecorated();
   return !needApplyNullTextClassName
    ? this.IsInputElement(element) && this.editor.GetInputElement() == element
    : false;
  },
  CanApplyFocusedStyleToElement: function(element) {
   var tabIndex = parseInt(ASPx.Attr.GetAttribute(element, "tabindex"));
   return !this.IsInputElement(element) 
    ? !isNaN(tabIndex) && tabIndex >= 0 || ASPx.ElementContainsCssClass(element, "form-control")
    : false;
  },
  CanApplyInvalidStyleToElement: function(element) {
   var editor = this.editor;
   var isEditorInputElement = editor.GetInputElement() == element
    || editor.GetPasswordNullTextInputElement && editor.GetPasswordNullTextInputElement() == element;
   var isFormControlElement = isEditorInputElement || ASPx.ElementContainsCssClass(element, "form-control");
   var isCheckInputElement = ASPx.ElementContainsCssClass(element, "form-check-input")
    || ASPx.ElementContainsCssClass(element, "custom-control-input");
   return (isFormControlElement || isCheckInputElement) != ASPx.BootstrapCore.IsBootstrap3;
  },
  ApplyFocusedStyle: function(element, inner) {
   var focusedInvalidStyleApplied = !this.editor.GetIsValid() && this.editor.focused && this.editor.customValidationEnabled;
   if(!focusedInvalidStyleApplied && this.CanApplyFocusedStyleToElement(element))
    ASPx.TextEditorStyleDecoration.prototype.ApplyFocusedStyle.call(this, element, true);
  },
  ApplyFocusedInvalidStyle: function(element) {
   if(this.CanApplyFocusedStyleToElement(element) && this.HasDecoration("FI"))
    this.ApplyDecoration("FI", element, true, this.editor.focused && !this.editor.GetIsValid());
  },
  ApplyInvalidStyle: function(element, inner) {
   if(this.CanApplyInvalidStyleToElement(element))
    ASPx.TextEditorStyleDecoration.prototype.ApplyInvalidStyle.call(this, element, true);
   this.ApplyFocusedInvalidStyle(element);
  },
  ApplyNullTextStyle: function(element, inner) {
   if(this.CanApplyNullTextStyleToElement(element))
    ASPx.TextEditorStyleDecoration.prototype.ApplyNullTextStyle.call(this, element, true);
  },
  ApplyNullTextClassName: function(active) {
   var nullTextClassName = this.GetNullTextClassName();
   var inputElement = this.editor.GetInputElement();
   if(active)
    ASPx.AddClassNameToElement(inputElement, nullTextClassName);
   else
    ASPx.RemoveClassNameFromElement(inputElement, nullTextClassName);
  },
  Update: function() {
   if(this.IsUpdateLocked())
    return;
   var mainElement = this.editor.GetMainElement();
   for(var i = 0; i < this.postfixList.length; i++) {
    var postfix = this.postfixList[i];
    var elements = postfix.length ? mainElement.querySelectorAll(postfix) : [ mainElement ];
    for(var j = 0; j < elements.length; j++)
     if(elements[j])
      this.ApplyStyles(elements[j], true);
   }
  },
  IsInputElement: function(element) {
   var tagName = element.tagName.toUpperCase();
   return tagName == "TEXTAREA" || tagName == "INPUT" || tagName == "SELECT";
  }
 });
 BootstrapEditorStyleDecoration.UpdateDefaultDecorationStyles = function(keys) {
  var container = document.createElement("DIV");
  ASPx.Attr.SetAttribute(container,
   "style", "overflow:hidden;position:fixed;z-index:10000;top:0;left:0;opacity:0;");
  document.body.appendChild(container);
  var inputElement = document.createElement("INPUT");
  inputElement.type = "text";
  ASPx.Attr.SetAttribute(inputElement,
   "style", "transition:none!important;-webkit-transition:none!important;-o-transition:none!important;");
  container.appendChild(inputElement);
  resetDefaultDecorationStyles(keys);
  if(!keys || !keys.length)
   keys = ["N", "I", "F", "FI"];
  for(var key, i = 0; key = keys[i]; i++)
   updateDefaultStyleDecoration(key, inputElement, container);
  document.body.removeChild(container);
 };
 function resetDefaultDecorationStyles(keys) {
  if(!keys || !keys.length)
   keys = ASPx.GetObjectKeys(defaultDecorationStyles);
  for(var key, i = 0; key = keys[i]; i++) {
   if(defaultDecorationStyles[key])
    defaultDecorationStyles[key].isValid = false;
  }
 }
 function updateDefaultStyleDecoration(key, input, inputContainer) {
  var defaultNullTextClassName = "text-muted";
  var defaultInvalidClassName = ASPx.BootstrapCore.IsBootstrap3 ? ASPx.BootstrapCssSelectors.HasError : ASPx.BootstrapCssSelectors.InvalidFormControl;
  switch(key) {
   case "N":
    if(ASPx.BootstrapCore.IsBootstrap3) {
     ASPx.SetClassName(input, defaultNullTextClassName);
     setDefaultStyleDecoration(key, "", getDecorationStyleRuleCssText(ASPx.GetCurrentStyle(input), ["color", "opacity", "text-shadow"]));
    }
    else
     setDefaultStyleDecoration(key, defaultNullTextClassName);
    break;
   case "I":
    setDefaultStyleDecoration(key, defaultInvalidClassName);
    break;
   case "F":
   case "FI":
    if(document.hasFocus()) {
     ASPx.SetClassName(input, "form-control");
     if(key == "FI")
      ASPx.AddClassNameToElement(ASPx.BootstrapCore.IsBootstrap3 ? inputContainer : input, defaultInvalidClassName);
     setDefaultStyleDecoration(key, "", getEditorFocusedStyleRuleCssText(input));
    }
    break;
   default:
    break;
  }
 }
 function setDefaultStyleDecoration(key, cssClass, cssText) {
  if(defaultDecorationStyles[key]) {
   if(cssClass)
    defaultDecorationStyles[key].className = cssClass;
   else {
    var rule = ASPx.GetStyleSheetRules(defaultDecorationStyles[key].className);
    if(rule)
     rule.style.cssText = ASPx.CreateImportantCssText(cssText);
   }
   defaultDecorationStyles[key].isValid = true;
  }
  else {
   if(!cssClass && cssText)
    cssClass = ASPx.Str.Trim(ASPx.CreateImportantStyleRule(ASPx.GetCurrentStyleSheet(), cssText));
   defaultDecorationStyles[key] = createDefaultStyleDecoration(cssClass);
  }
 }
 function createDefaultStyleDecoration(cssClass) {
  return { className: cssClass, isValid: true };
 }
 function getEditorFocusedStyleRuleCssText(inputElement) {
  var focusedElement = ASPx.GetFocusedElement();
  inputElement.focus();
  var focusedStyle = ASPx.GetCurrentStyle(inputElement);
  var cssText = getDecorationStyleRuleCssText(focusedStyle, [
   "border-top-width", "border-top-style", "border-top-color",
   "border-left-width", "border-left-style", "border-left-color",
   "border-bottom-width", "border-bottom-style", "border-bottom-color",
   "border-right-width", "border-right-style", "border-right-color",
   "outline-width", "outline-style", "outline-color", "outline-offset",
   "box-shadow", "-webkit-box-shadow"
  ]);
  inputElement.blur();
  if(focusedElement)
   ASPx.SetFocus(focusedElement);
  return cssText;
 }
 function getDecorationStyleRuleCssText(currentStyle, styleProperties) {
  var rules = [ ];
  for(var i = 0; i < styleProperties.length; i++) {
   var stylePropertyValue = ASPx.Str.Trim(currentStyle.getPropertyValue(styleProperties[i])) + "";
   if(stylePropertyValue)
    rules.push(styleProperties[i] + ": " + stylePropertyValue);
  }
  return rules.join(";");
 }
 ASPx.BootstrapEditorStyleDecoration = BootstrapEditorStyleDecoration;
 var styleUpdateListeners = [];
 BootstrapClientUtils = {};
 BootstrapClientUtils.UpdateDefaultStyles = function() {
  ASPx.BootstrapEditorStyleDecoration.UpdateDefaultDecorationStyles();
  ASPx.BootstrapCore.updateTableCellStyleSheetRules();
  ASPx.BootstrapCore.initializeAccentColorRelatedSelectors();
  for(var i = 0; i < styleUpdateListeners.length; i++)
   styleUpdateListeners[i].beginStyleUpdate();
  for(var i = 0; i < styleUpdateListeners.length; i++)
   styleUpdateListeners[i].updateStyle();
  for(var i = 0; i < styleUpdateListeners.length; i++)
   styleUpdateListeners[i].endStyleUpdate();
 };
 BootstrapClientUtils.attachToUpdateDefaultStylesRequest = function(styleUpdateListener) {
  styleUpdateListeners.push(styleUpdateListener);
 };
 BootstrapClientUtils.detachUpdateDefaultStylesRequestListener = function(styleUpdateListener) {
  ASPx.Data.ArrayRemove(styleUpdateListeners, styleUpdateListener);
 };
 var BootstrapEditFeedbackRenderHelper = ASPx.CreateClass(null, {
  constructor: function(editor) {
   this.editor = editor;
  },
  getErrorImage: function() {
   var editorElement = this.editor.GetMainElement();
   return editorElement && editorElement.querySelector("[data-error-image]");
  },
  getClearButton: function() {
   var editorElement = this.editor.GetMainElement();
   return editorElement && editorElement.querySelector(BootstrapEditFeedbackRenderHelper.FeedbackSelector + " > .dxbs-clear-btn");
  },
  getErrorTextElement: function() {
   var editorElement = this.editor.GetMainElement();
   return editorElement && editorElement.querySelector(".dxbs-edit-error-text");
  },
  setElementVisible: function(element, value) {
   if(element && ASPx.ElementHasCssClass(element, ASPx.BootstrapCssSelectors.Hidden) == value) {
    var action = value ? ASPx.RemoveClassNameFromElement : ASPx.AddClassNameToElement;
    action(element, ASPx.BootstrapCssSelectors.Hidden);
    this.updateInputRightPadding();
   }
  },
  setClearButtonVisible: function(value) {
   var clearButton = this.getClearButton();
   if(!clearButton)
    return;
   if(this.editor.clearButtonDisplayMode === 'Always' && ASPx.Attr.GetAttribute(clearButton, "role") == "button")
    this.editor.SetAccessibilityAnchorEnabled(clearButton, value);
   this.setElementVisible(clearButton, value);
  },
  setErrorControlVisible: function(value) {
   var errorTextElement = this.getErrorTextElement();
   if(errorTextElement)
    this.setElementVisible(errorTextElement, value);
   if(this.editor.errorDisplayMode == "i")
    this.setErrorImageVisible(value);
  },
  setErrorImageVisible: function(value) {
   var errorImage = this.getErrorImage();
   if(errorImage) {
    if(!this.getErrorTextElement() && !ASPx.BootstrapCore.IsBootstrap3) {
     var feedbackControl = this.editor.GetMainElement().querySelector(BootstrapEditFeedbackRenderHelper.FeedbackSelector);
     var action = value ? ASPx.AddClassNameToElement : ASPx.RemoveClassNameFromElement;
     action(feedbackControl || errorImage, ASPx.BootstrapCssSelectors.InvalidFeedback);
    }
    this.setElementVisible(errorImage, value);
    if(!value) {
     ASPx.Attr.RemoveAttribute(errorImage, "title");
     ASPx.Attr.RemoveAttribute(errorImage, "data-error-tooltip");
    }
    else
     this.updateErrorText();
   }
  },
  updateErrorText: function() {
   var errorText = this.editor.HtmlEncode(this.editor.errorText);
   var errorTextElement = this.getErrorTextElement();
   if(errorTextElement) {
    var textNode = ASPx.GetNormalizedTextNode(errorTextElement);
    if(textNode) {
     textNode.nodeValue = errorText;
     return;
    }
   }
   var errorImage = this.getErrorImage();
   if(errorImage) {
    ASPx.Attr.SetAttribute(errorImage, "title", errorText);
    if(ASPx.Browser.TouchUI) {
     var x = ASPx.GetAbsolutePositionX(errorImage);
     var docWidth = ASPx.Browser.WebKitTouchUI ? window.innerWidth : ASPx.GetDocumentClientWidth();       
     var availableWidth = this.editor.isASPxClientCheckEdit ? docWidth - x - errorImage.offsetWidth : x;
     if(availableWidth > 0) {
      var fontSize = ASPx.GetCurrentStyle(errorImage).fontSize;
      ASPx.Attr.SetAttribute(errorImage, "data-error-tooltip", this.formatErrorText(errorText, availableWidth, fontSize));
     }
    }
   }
  },
  formatErrorText: function(errorText, availableWidth, fontSize) {
   var errorTextSize = ASPx.GetSizeOfText(errorText, {
    fontFamily: '"Helvetica Neue", Helvetica, Arial, sans-serif',
    fontSize: 'calc(0.75 * ' + fontSize + ')',
    fontWeight: "normal",
    letterSpacing: "normal",
    lineHeight: "2"
   }).width + 1.2 * ASPx.PxToInt(fontSize);
   if(errorTextSize > availableWidth) {
    var availableCharCount = Math.floor(errorText.length * availableWidth / errorTextSize);
    if(availableCharCount) {
     var errorTextRows = [];
     while(errorText && errorText.length) {
      var textRow = errorText.substr(0, availableCharCount);
      var spacesAtStart = /(^\s+)\S/.exec(textRow);
      if(spacesAtStart)
       textRow = errorText.substr(0, availableCharCount + spacesAtStart[1].length);
      var spacesAtEnd = /(\s+)\S{1,4}$/.exec(textRow);
      if(spacesAtEnd && spacesAtEnd.index)
       textRow = errorText.slice(0, spacesAtEnd.index + spacesAtEnd[1].length);
      errorTextRows.push(ASPx.Str.TrimStart(textRow));
      errorText = errorText.replace(textRow, "");
     }
     errorText = errorTextRows.join("\n");
    }
   }
   return errorText;
  },
  updateInputRightPadding: function() {
   if(this.editor.isASPxClientTextEdit) {
    var feedbackControl = this.editor.GetMainElement().querySelector(BootstrapEditFeedbackRenderHelper.FeedbackSelector);
    if(feedbackControl) {
     var feedbackWidth = feedbackControl.offsetWidth;
     var formControl = this.editor.GetFormControlElement ? this.editor.GetFormControlElement() : this.editor.GetInputElement();
     formControl.style["padding-right"] = feedbackWidth ? feedbackWidth + "px" : "";
     if(this.editor.UpdateDropDownOnFeedbackChanged)
      this.editor.UpdateDropDownOnFeedbackChanged();
    }
   }
  }
 });
 BootstrapEditFeedbackRenderHelper.FeedbackSelector = "." + ASPx.BootstrapCssSelectors.FormControlFeedback;
 ASPx.BootstrapEditFeedbackRenderHelper = BootstrapEditFeedbackRenderHelper;
 var BootstrapTextEditHelpText = ASPx.CreateClass(null, {
  constructor: function(editor, helpText, animationEnabled, isPopupDisplayMode) {
   this.editor = editor;
   this.isPopupDisplayMode = isPopupDisplayMode;
   this.animationEnabled = animationEnabled;
   this.createHelpTextElement(helpText);
  },
  createHelpTextElement: function(helpText) {
   var helpTextElement = document.createElement("SPAN");
   ASPx.SetClassName(helpTextElement, ASPx.BootstrapCssSelectors.HelpBlock);
   ASPx.Security.setInnerHtml(helpTextElement, helpText, ASPx.Security.DataType.Trusted);
   ASPx.InsertElementAfter(helpTextElement, this.editor.GetHelpTextElementPrevSibling());
   if(this.isPopupDisplayMode) {
    var parentNode = helpTextElement.parentNode;
    if(parentNode) {
     var parentStyle = ASPx.GetCurrentStyle(parentNode);
     if(parentStyle.position != "relative")
      parentNode.style.position = "relative";
    }
    ASPx.AddClassNameToElement(helpTextElement, "dxbs-popup-help-text mark");
    ASPx.SetElementDisplay(helpTextElement, false);
   }
   else {
    ASPx.SetElementDisplay(helpTextElement, this.editor.clientVisible);
    if(!ASPx.BootstrapCore.IsBootstrap3)
     ASPx.AddClassNameToElement(helpTextElement, "text-muted");
   }
   this.helpTextElement = helpTextElement;
  },
  show: function() {
   if(this.isPopupDisplayMode)
    this.showPopup();
   else
    ASPx.SetElementDisplay(this.helpTextElement, true);
  },
  hide: function() {
   if(this.isPopupDisplayMode)
    this.hidePopup();
   else
    ASPx.SetElementDisplay(this.helpTextElement, false);
  },
  showPopup: function() {
   ASPx.SetElementDisplay(this.helpTextElement, true);
   if(this.animationEnabled)
    ASPx.AnimationHelper.fadeIn(this.helpTextElement);
   else
    ASPx.AnimationHelper.setOpacity(this.helpTextElement, 1);
  },
  hidePopup: function() {
   var onHidePopupComplete = function() {
    ASPx.SetElementDisplay(this.helpTextElement, false);
   }.aspxBind(this);
   if(this.animationEnabled)
    ASPx.AnimationHelper.fadeOut(this.helpTextElement, onHidePopupComplete);
   else {
    ASPx.AnimationHelper.setOpacity(this.helpTextElement, 0);
    onHidePopupComplete();
   }    
  }
 });
 ASPx.BootstrapTextEditHelpText = BootstrapTextEditHelpText;
 var BootstrapCheckBoxInternal = ASPx.CreateClass(null, {
  constructor: function(mainElement, allowGrayed, allowGrayedByClick, storeValueInInput, inputName) {
   this.mainElement = mainElement;
   this.allowGrayed = allowGrayed;
   this.allowGrayedByClick = allowGrayedByClick;
   this.storeValueInInput = storeValueInInput;
   if(this.storeValueInInput)
    this.stateInput = this.createStateInput(inputName);
   this.mainInput = this.findMainInput();
   this.initializeSiblingLabelElement();
   this.initializeIndeterminateState();
   this.CheckedChanged = new ASPxClientEvent();
   this.Focus = new ASPxClientEvent();
   this.LostFocus = new ASPxClientEvent();
   this.attachHtmlEvents();
   this.updateState();
  },
  SetValue: function(value) { 
   this.setValueCore(value);
  },
  GetValue: function() {
   return this.getValueCore();
  },
  GetChecked: function() {
   return this.getValueCore() === true;
  },
  SetChecked: function(checked) {
   this.setValueCore(!!checked);
  },
  SetEnabled: function(enabled) {
   this.setEnabledCore(enabled);
  },
  GetEnabled: function() {
   return this.getEnabledCore();
  },
  GetReadOnly: function() {
   return false;
  },
  attachHtmlEvents: function() {
   var isMSBrowser = ASPx.Browser.IE || ASPx.Browser.Edge;
   ASPx.Evt.AttachEventToElement(this.mainInput, "change", function(evt) {
    if(this.allowGrayed && this.allowGrayedByClick && isMSBrowser) {
     ASPx.Evt.PreventEvent(evt);
     return false;
    }
    if(!this.correctNextValue())
     this.updateState();
    this.CheckedChanged.FireEvent(this, evt);
   }.bind(this));
   ASPx.Evt.AttachEventToElement(this.mainInput, "focus", function(evt) {
    this.Focus.FireEvent(this, null);
   }.bind(this));
   ASPx.Evt.AttachEventToElement(this.mainInput, "blur", function(evt) {
    this.LostFocus.FireEvent(this, null);
   }.bind(this));
   ASPx.Evt.AttachEventToElement(this.mainInput, "click", function(evt) {
    if (this.GetReadOnly()) {
     ASPx.Evt.PreventEvent(evt);
     return false;
    }
    if(this.allowGrayed && isMSBrowser) {
     var raiseCheckedChanged = false;
     if(this.allowGrayedByClick && this.lastValue) {
      this.setValueCore(false);
      raiseCheckedChanged = true;
     } 
     else if(this.correctNextValue()) {
      this.updateState();
      raiseCheckedChanged = true;
     }
     if(raiseCheckedChanged)
      this.CheckedChanged.FireEvent(this, evt);
    }
   }.bind(this));
  },
  invokeClick: function() {
   if(this.mainInput){
    this.mainInput.focus();
    this.mainInput.click();
   }
  },
  correctNextValue: function() {
   if(!this.allowGrayed)
    return;
   if(this.allowGrayedByClick && this.lastValue === false){
    this.setValueCore(null);
    return true;
   }
   if(this.lastValue === null) {
    this.setValueCore(true);
    return true;
   }
  },
  findMainInput: function() {
   return this.mainElement.querySelectorAll("[type=checkbox]")[0] || this.mainElement.querySelectorAll("[type=radio]")[0];
  },
  createStateInput: function (inputName) {
   var input = ASPx.CreateHiddenField(inputName, this.mainElement.id + "_S");
   this.mainElement.appendChild(input);
   return input;
  },
  initializeIndeterminateState: function() {
   if(ASPx.Attr.GetAttribute(this.mainInput, "data-value") === "indeterminate") {
    ASPx.Attr.RemoveAttribute(this.mainInput, "data-value");
    this.mainInput.indeterminate = true;
   }
  },
  initializeSiblingLabelElement: function() {
   if(this.mainInput && this.mainInput.id) {
    var siblingLabel = this.mainElement.querySelectorAll("[type=checkbox]+label, label+[type=checkbox], [type=radio]+label, label+[type=radio]")[0];
    if(siblingLabel)
     ASPx.Attr.SetAttribute(siblingLabel, "for", this.mainInput.id);
   }
  },
  setValueCore: function(value) {
   if(value === true || value === ASPx.CheckBoxInputKey.Checked) {
    this.mainInput.checked = true;
    this.mainInput.indeterminate = false;
    this.updateState(true);
   }
   else if(value === false || value === ASPx.CheckBoxInputKey.Unchecked) {
    this.mainInput.checked = false;
    this.mainInput.indeterminate = false;
    this.updateState(false);
   }
   else if(value === null || value === ASPx.CheckBoxInputKey.Indeterminate) {
    this.mainInput.indeterminate = true;
    this.updateState(null);
   }
  },
  getValueCore: function() {
   var mainInput = this.mainInput;
   if(mainInput.indeterminate)
    return null;
   return mainInput.checked;
  },
  setEnabledCore: function(enabled) {
   if(enabled) {
    ASPx.RemoveClassNameFromElement(this.mainElement, "disabled");
    ASPx.Attr.RemoveAttribute(this.mainInput, "disabled");
    if(this.stateInput)
     ASPx.Attr.RemoveAttribute(this.stateInput, "disabled");
   }
   else {
    ASPx.AddClassNameToElement(this.mainElement, "disabled");
    ASPx.Attr.SetAttribute(this.mainInput, "disabled", "disabled");
    if(this.stateInput)
     ASPx.Attr.SetAttribute(this.stateInput, "disabled", "disabled");
   }
  },
  getEnabledCore: function() {
   return !ASPx.Attr.GetAttribute(this.mainInput, "disabled");
  },
  updateState: function(value) {
   value = value === undefined ? this.getValueCore() : value;
   this.lastValue = value;
   var stateInput = this.stateInput;
   if(stateInput) {
    if(value === true)
     stateInput.value = ASPx.CheckBoxInputKey.Checked;
    else if(value === false)
     stateInput.value = ASPx.CheckBoxInputKey.Unchecked;
    else
     stateInput.value = ASPx.CheckBoxInputKey.Indeterminate;
   }
  }
 });
 var BootstrapCheckBoxInternalCollection = ASPx.CreateClass(ASPx.CollectionBase, {
  constructor: function(allowGrayed, allowGrayedByClick, storeValueInInput) {
   this.constructor.prototype.constructor.call(this);
   this.allowGrayed = !!allowGrayed;
   this.allowGrayedByClick = !!allowGrayedByClick;
   this.storeValueInInput = !!storeValueInInput;
  },
  Add: function(key, mainElement) {
   this.Remove(key);
   var checkBox = this.createInternalCheckBox(key, mainElement);
   ASPx.CollectionBase.prototype.Add.call(this, key, checkBox);
   return checkBox;
  },
  createInternalCheckBox: function(key, mainElement) {
   return new BootstrapCheckBoxInternal(mainElement, this.allowGrayed, this.allowGrayedByClick, this.storeValueInInput);
  }
 });
 ASPx.BootstrapCheckBoxInternal = BootstrapCheckBoxInternal;
 ASPx.BootstrapCheckBoxInternalCollection = BootstrapCheckBoxInternalCollection;
 var BootstrapLoadingPanelManager = {};
 var loadingPanels = {};
 var loadingDivs = {};
 BootstrapLoadingPanelManager.getLoadingPanel = function(name, settings, inline) {
  if(!settings) return null;
  var lpID = name + "_LP";
  if(!loadingPanels[lpID]){
   var lp = document.createElement("DIV");
   lp.id = lpID;
   ASPx.SetClassName(lp, ASPx.Str.Trim([
    "dxbs-lp" + (inline ? " dxbs-lp-inline" : ""),
    ASPx.HiddenChangable, ASPx.BootstrapCssSelectors.Panel, ASPx.BootstrapCssSelectors.PanelDefault
   ].join(" ")));
   var lpBody = document.createElement("DIV");
   ASPx.SetClassName(lpBody, ASPx.BootstrapCssSelectors.PanelBody);
   if(settings.showImage !== false) {
    var lpImg = document.createElement("SPAN");
    var imgCssClass = settings.imageCssClass ? settings.imageCssClass : "dxbs-icon dxbs-icon-refresh";
    ASPx.SetClassName(lpImg, "image " + imgCssClass);
    lpBody.appendChild(lpImg);
   }
   if(settings.text !== "") {
    var breakHtml = "";
    var textHtml = "<span>" + (settings.text || "Loading&hellip;") + "</span>";
    if(settings.imagePosition && (settings.imagePosition === "Top" || settings.imagePosition === "Bottom")) 
     breakHtml = "<br />";
    if(settings.imagePosition && (settings.imagePosition === "Right" || settings.imagePosition === "Bottom"))
     ASPx.Security.setInnerHtml(lpBody, textHtml + breakHtml + lpBody.innerHTML, ASPx.Security.DataType.Trusted);
    else
     ASPx.Security.setInnerHtml(lpBody, lpBody.innerHTML + breakHtml + textHtml, ASPx.Security.DataType.Trusted);
   }
   lp.appendChild(lpBody);
   loadingPanels[lpID] = lp;
  }
  return loadingPanels[lpID];
 };
 BootstrapLoadingPanelManager.getLoadingDiv = function(name, settings){
  if(!settings || settings.fade === false) return null;
  var ldID = name + "_LD";
  if(!loadingDivs[ldID]){
   var ld = document.createElement("DIV");
   ld.id = ldID;
   ASPx.SetClassName(ld, "dxbs-ld " + ASPx.HiddenChangable);
   loadingDivs[ldID] = ld;
  }
  return loadingDivs[ldID];
 };
 ASPx.BootstrapLoadingPanelManager = BootstrapLoadingPanelManager;
 var BootstrapOverlayManager = {};
 BootstrapOverlayManager.createOverlay = function(name, settings) {
  var overlay = document.createElement("DIV");
  overlay.id = name + "_OV";
  ASPx.SetClassName(overlay, ASPx.BootstrapCssSelectors.ModalBackdrop + " dxbs-modal-back" + (settings.cssClass ? " " + settings.cssClass : ""));
  return overlay;
 };
 ASPx.BootstrapOverlayManager = BootstrapOverlayManager;
 var BootstrapBadgeManager = ASPx.CreateClass(ASPx.BadgeManagerBase, {
  getBadgeClassName: function() {
   return ASPx.BootstrapCssSelectors.Badge;
  },
  getBadgeIconDefaultClassName: function() {
   return "image";
  },
  createBadgeForButton: function(button, toLeftSide) {
   var badge = this.createBadge();
   if(!ASPx.BootstrapCore.IsBootstrap3) {
    ASPx.AddClassNameToElement(badge, ASPx.BootstrapCssSelectors.BadgePill);
    if (ASPx.ElementHasCssClass(button, ASPx.BootstrapCssSelectors.ButtonDanger)) {
     ASPx.AddClassNameToElement(badge, ASPx.BootstrapCssSelectors.BadgeLight);
     ASPx.AddClassNameToElement(badge, ASPx.BootstrapCssSelectors.TextDanger);
    }
    else if(ASPx.ElementHasCssClass(button, ASPx.BootstrapCssSelectors.ButtonSecondary) || ASPx.ElementHasCssClass(button, ASPx.BootstrapCssSelectors.ButtonOutlineSecondary))
     ASPx.AddClassNameToElement(badge, ASPx.BootstrapCssSelectors.BadgeDark);
    else if(ASPx.ElementHasCssClass(button, ASPx.BootstrapCssSelectors.ButtonLink))
     ASPx.AddClassNameToElement(badge, ASPx.BootstrapCssSelectors.BadgePrimary);
    else
     ASPx.AddClassNameToElement(badge, ASPx.BootstrapCssSelectors.TextPrimary);
   }
   if(toLeftSide)
    button.insertBefore(badge, button.childNodes[0]);
   else
    button.appendChild(badge);
   return badge;
  },
  updateToolbarItemBadge: function(item, count) {
   var button = item.menu.IsEnabledAdaptivity() ? item.itemViewModel.getElement() : item.menu.GetItemContentElement(item.indexPath);
   var badge = this.findBadge(button);
   if(!badge)
    badge = this.createBadgeForButton(button);
   if(badge)
    this.setBadgeText(badge, count > 0 ? count : "");
  }
 });
 ASPx.BootstrapBadgeManager = new BootstrapBadgeManager();
 var BASE64_CHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
 var getBase64Char = function(index) {
  return BASE64_CHARS.charAt(index);
 };
 var getIndexOfBase64Char = function(char) {
  return BASE64_CHARS.indexOf(char);
 };
 var codeArrayToString = function(codes) {
  return codes.map(function(code) { return String.fromCharCode(code); }).join("");
 };
 var base64_encode = function(input) {
  var result = "";
  if (!$.isArray(input))
   input = stringToByteArray(String(input));
  for (var i = 0; i < input.length; i += 3) {
   var octet1 = input[i],
    octet2 = input[i + 1],
    octet3 = input[i + 2];
   result += $.map([octet1 >> 2, (3 & octet1) << 4 | octet2 >> 4, isNaN(octet2) ? 64 : (15 & octet2) << 2 | octet3 >> 6, isNaN(octet3) ? 64 : 63 & octet3], getBase64Char).join("");
  }
  return result;
 };
 var base64_decode = function(input) {
  var result = "";
  input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
  for (var i = 0; i < input.length; i += 4) {
   var bytes = [];
   var octet1 = getIndexOfBase64Char(input.charAt(i)),
    octet2 = getIndexOfBase64Char(input.charAt(i + 1)),
    octet3 = getIndexOfBase64Char(input.charAt(i + 2)),
    octet4 = getIndexOfBase64Char(input.charAt(i + 3));
   bytes.push((octet1 << 2) | (octet2 >> 4));
   if(octet3 != 64)
    bytes.push(((octet2 & 15) << 4) | (octet3 >> 2));
   if(octet4 != 64)
    bytes.push(((octet3 & 3) << 6) | octet4);
   result += codeArrayToString(bytes);
  }
  return decodeText(result);
 };
 var stringToByteArray = function(str) { 
  var bytes = [];
  var code = 0;
  for (var i = 0; i < str.length; i++) {
   code = str.charCodeAt(i);
   if (code < 128) {
    bytes.push(code);
   } else {
    if (code < 2048) {
     bytes.push(192 + (code >> 6), 128 + (63 & code));
    } else {
     if (code < 65536) {
      bytes.push(224 + (code >> 12), 128 + (code >> 6 & 63), 128 + (63 & code));
     } else {
      if (code < 2097152) {
       bytes.push(240 + (code >> 18), 128 + (code >> 12 & 63), 128 + (code >> 6 & 63), 128 + (63 & code));
      }
     }
    }
   }
  }
  return bytes;
 };
 var decodeText = function(codeText) {
  var bytes = [];
  var code = 0, 
   code2 = 0,
   code3 = 0;
  for (var i = 0; i < codeText.length; i++) {
   code = codeText.charCodeAt(i);
   if (code < 128) {
    bytes.push(code);
   } else {
    i += 1;
    code2 = codeText.charCodeAt(i);
    if((code > 191) && (code < 224)) {
     bytes.push(((code & 31) << 6) | (code2 & 63));
    } else {
     i += 1;
     code3 = codeText.charCodeAt(i);
     bytes.push(((code & 15) << 12) | ((code2 & 63) << 6) | (code3 & 63));
    }
   }
  }
  return codeArrayToString(bytes);
 };
 ASPx.Base64 = {};
 ASPx.Base64.Encode = base64_encode;
 ASPx.Base64.Decode = base64_decode;
 dx.BootstrapClientUtils = BootstrapClientUtils;
 ASPx.BootstrapDockManager = ASPx.CreateSingleton(function(ASPx) {
  var showCssClass = "show",
   matrixRegex = "\\s*matrix\\(\\s*" + ([0, 0, 0, 0, 0, 0].map(function() { return "(\\-?\\d+\\.?\\d*)"; }).join(",\\s*")) + "\\)\\s*";
  function parseTranslateInfo(styles) {
   var m = new RegExp(matrixRegex).exec(styles.transform);
   return m ? { left: parseInt(m[5]), top: parseInt(m[6]) } : { left: 0, top: 0 };
  }
  function getBoundingBox(x, y, w, h) { return { left: x, top: y, right: x + w, bottom: y + h, width: w, height: h }; }
  function getSafeBoundingBox(element, roundLT, roundRB) {
   var box = element.getBoundingClientRect();
   var safeBox = { left: roundLT(box.left), top: roundLT(box.top), right: roundRB(box.right), bottom: roundRB(box.bottom) };
   safeBox.width = safeBox.right - safeBox.left;
   safeBox.height = safeBox.bottom - safeBox.top;
   return safeBox;
  }
  function getOuterBoundingBox(element) {
   return getSafeBoundingBox(element, Math.floor, Math.ceil);
  }
  function getInnerBoundingBox(element) {
   return getSafeBoundingBox(element, Math.ceil, Math.floor);
  }
  var DockPoint = ASPx.CreateClass(null, {
   constructor: function (key, info) {
    this.key = key;
    this.info = info;
   },
   checkMargin: function () { return true; },
   allowScroll: function () { return this.info.size === "height"; },
   canApplyToElement: function(element) { return ASPx.GetClassName(element).indexOf("dxbs-align-" + this.key) > -1; },
   getRange: function (dockInfo) {
    var c1 = this.getTargetBox(dockInfo)[this.info.to];
    var c2 = c1 + this.info.sizeM * (dockInfo.elementBox[this.info.size] + (this.checkMargin() ? dockInfo.margin : 0));
    return { 
     from: Math.min(c1, c2), 
     to: Math.max(c1, c2), 
     windowOverflow: 0
    };
   },
   getTargetBox: function (dockInfo) { return null; },
   validate: function (range, windowInfo) {
    var windowSize = windowInfo[this.info.size];
    range.windowOverflow = Math.abs(Math.min(0, range.from - windowSize.from) + Math.min(0, windowSize.to - range.to));
    range.validTo = Math.min(range.to, windowSize.to);
    range.validFrom = Math.max(range.from, windowSize.from);
    return range.windowOverflow === 0;
   },
   applyRange: function (range, dockInfo) {
    dockInfo.appliedModifierKeys[this.info.size] = this.key;
    var side = this.info.size === "width" ? "left" : "top";
    var style = dockInfo.styles;
    var from = range.from;
    if (this.allowScroll() && range.windowOverflow > 0) {
     if (!dockInfo.limitBox.scroll.width) {
      dockInfo.limitBox.scroll.width = true;
      dockInfo.limitBox.width.to -= ASPx.GetVerticalScrollBarWidth();
     }
     if (dockInfo.isScrollable) {
      style["max-height"] = dockInfo.height - range.windowOverflow + "px";
      dockInfo.width += ASPx.GetVerticalScrollBarWidth();
      dockInfo.elementBox.width += ASPx.GetVerticalScrollBarWidth();
      from = range.validFrom;
     }
    }
    style.width = dockInfo.width + "px";
    if(this.checkMargin())
     from += Math.max(0, this.info.sizeM) * dockInfo.margin;
    dockInfo.elementBox[side] += from;
    style["transform"] = 
     "matrix(1, 0, 0, 1, " + dockInfo.elementBox.left + ", " + dockInfo.elementBox.top + ")";
   },
   dockElementToTarget: function (dockInfo) {
    var range1 = this.getRange(dockInfo);
    if (!this.dockElementToTargetInternal(range1, dockInfo))
     this.applyRange(range1, dockInfo);
   },
   dockElementToTargetInternal: function (range1, dockInfo) { }
  });
  var OuterDockPoint = ASPx.CreateClass(DockPoint, {
   constructor: function (name, info, oppositePointName) {
    this.constructor.prototype.constructor.apply(this, arguments);
    this.oppositePointName = oppositePointName || null;
   },
   getTargetBox: function (dockInfo) { return dockInfo.targetBox.outer; },
   getOppositePoint: function () {
    return this._oppositePoint || (this._oppositePoint = dockPoints.filter(function (d) {
     return d.key === this.oppositePointName;
    }.bind(this))[0]);
   },
   dockElementToTargetInternal: function (range1, dockInfo) {
    if (this.validate(range1, dockInfo.limitBox))
     this.applyRange(range1, dockInfo);
    else {
     var oppositePoint = this.getOppositePoint();
     var range2 = oppositePoint.getRange(dockInfo);
     if (oppositePoint.validate(range2, dockInfo.limitBox) || range2.windowOverflow < range1.windowOverflow)
      oppositePoint.applyRange(range2, dockInfo);
     else
      return false;
    }
    return true;
   }
  });
  var InnerDockPoint = ASPx.CreateClass(DockPoint, {
   checkMargin: function () { return false; },
   getTargetBox: function (dockInfo) { return dockInfo.targetBox.inner; },
   dockElementToTargetInternal: function (range1, dockInfo) {
    this.validate(range1, dockInfo.limitBox);
    return false;
   },
   validate: function (range, windowInfo) {
    var toOverflow = Math.min(range.from, Math.max(0, range.to - windowInfo[this.info.size].to));
    if (toOverflow > 0) {
     range.from -= toOverflow;
     range.to -= toOverflow;
    }
    return DockPoint.prototype.validate.call(this, range, windowInfo);
   }
  });
  var dockPoints = [
   new OuterDockPoint("above", { to: "top", from: "bottom", size: "height", sizeM: -1 }, "below"),
   new OuterDockPoint("below", { to: "bottom", from: "top", size: "height", sizeM: 1 }, "above"),
   new InnerDockPoint("top-sides", { to: "top", from: "top", size: "height", sizeM: 1 }),
   new InnerDockPoint("bottom-sides", { to: "bottom", from: "bottom", size: "height", sizeM: -1 }),
   new OuterDockPoint("outside-left", { to: "left", from: "right", size: "width", sizeM: -1 }, "outside-right"),
   new OuterDockPoint("outside-right", { to: "right", from: "left", size: "width", sizeM: 1 }, "outside-left"),
   new InnerDockPoint("left-sides", { to: "left", from: "left", size: "width", sizeM: 1 }),
   new InnerDockPoint("right-sides", { to: "right", from: "right", size: "width", sizeM: -1 })
  ];
  var defaultHorizontalItemDockPoints = [dockPoints[1], dockPoints[6]],
   defaultVerticalItemDockPoints = [dockPoints[2], dockPoints[5]];
  function getElementPopupInfo(element, targetElement, isVertical, settings) {
   var elementStyle = ASPx.GetCurrentStyle(element);
   var box = getOuterBoundingBox(element);
   var docEl = element.ownerDocument.documentElement;
   var result = {
    isScrollable: ASPx.ElementHasCssClass(element, "dxbs-scrollable"),
    specifiedOffsetModifiers: dockPoints.filter(function (m) { return m.canApplyToElement(element); }),
    margin: ASPx.PxToInt(elementStyle.marginTop),
    width: settings ? Math.max(settings.width, Math.ceil(element.offsetWidth)) : Math.ceil(element.offsetWidth),
    height: Math.ceil(element.offsetHeight),
    appliedModifierKeys: { height: null, width: null }
   };
   var styles = parseTranslateInfo(elementStyle);
   result.elementBox = getBoundingBox(styles.left - box.left, styles.top - box.top, box.width, box.height); 
   result.targetBox = { outer: getOuterBoundingBox(targetElement), inner: getInnerBoundingBox(targetElement) };
   result.limitBox = {
    scroll: { width: docEl.clientWidth < window.innerWidth, height: docEl.clientHeight < window.innerHeight },
    width: { from: 0, to: docEl.clientWidth },
    height: { from: 0, to: docEl.clientHeight }
   };
   result.styles = {};
   var highPriorityModifiersData = ASPx.Attr.GetAttribute(element, "data-popup-align") || settings && settings.align;
   if (highPriorityModifiersData) {
    var highPriorityModifiers = highPriorityModifiersData.split(/\s+/);
    result.offsetModifiers = dockPoints.filter(function (m) {
     return highPriorityModifiers.some(function (k) { return m.key === k; });
    });
   } else
    result.offsetModifiers = result.specifiedOffsetModifiers.filter(function (m) { return !isVertical; });
   if (result.offsetModifiers.length === 0)
    result.offsetModifiers = isVertical ? defaultVerticalItemDockPoints : defaultHorizontalItemDockPoints;
   return result;
  }
  function hide(element) {
   if (ASPx.ElementHasCssClass(element, showCssClass)) {
    if (element.isDockedElementHidden)
     delete element.isDockedElementHidden;
    ASPx.DOM.ClearStyles(element);
    ASPx.DOM.ToggleCssClass(element, showCssClass, false);
   } else if (element.isDockedElementHidden)
    delete element.isDockedElementHidden;
  }
  function show(element, targetElement, isVertical) {
   ASPx.DOM.ClearStyles(element);
   ASPx.DOM.ToggleCssClass(element, showCssClass, true);
   preparePosition(element, targetElement, isVertical, null, function () { });
  }
  function preparePosition(element, targetElement, isVertical, settings, onShow) {
   ASPx.DOM.CalculateStyles(function () {
    var dockInfo = getElementPopupInfo(element, targetElement, isVertical, settings);
    for (var i = 0; i < dockInfo.offsetModifiers.length; i++)
     dockInfo.offsetModifiers[i].dockElementToTarget(dockInfo);
    ASPx.DOM.ChangeDOM(function () { onShow(dockInfo); });
    ASPx.DOM.SetStyles(element, dockInfo.styles);
   }.bind(this));
  }
  return {
   getElementPopupInfo: getElementPopupInfo,
   hide: hide,
   show: show,
   preparePosition: preparePosition
  };
 });
 ASPx.DOM = ASPx.CreateSingleton(function (ASPx) {
  var FrameContext = ASPx.CreateClass(null, {
   constructor: function (requestFrame) {
    this.requestFrame = requestFrame;
    this.cache = [[]];
    this.isInFrame = false;
    this.isWaiting = false;
   },
   getBuffer: function (order) {
    if (!order) order = 0;
    if (this.cache.length <= order) this.cache[order] = [];
    return this.cache[order];
   },
   execute: function (callback, order) {
    if (!this.isInFrame)
     return false;
    var buffer = this.cache[order || 0];
    if (buffer === null)
     callback(requestFrameId);
    else
     (buffer = this.getBuffer(order)).push(callback);
    return true;
   },
   runAll: function () {
    this.isWaiting = false;
    this.isInFrame = true;
    for (var i = 0; i < this.cache.length; i++) {
     var buffer = this.cache[i];
     if (buffer) {
      this.cache[i] = null;
      while (buffer.length)
       buffer.shift()(requestFrameId);
     }
    }
    this.waitNextFrame();
   },
   waitNextFrame: function () {
    this.cache = [[]];
    this.isInFrame = false;
    this.isWaiting = false;
   },
   requestExecution: function (callback, order) {
    if (!this.execute(callback, order)) {
     this.getBuffer(order).push(callback);
     if (this.isWaiting === false) {
      this.isWaiting = true;
      this.requestFrame(this.runAll.bind(this));
     }
    }
   }
  });
  var requestFrameId = null;
  function requestAnimationFrame(callback) { return requestFrameId = ASPx.RequestAnimationFrame(callback); }
  function createAccumulator(requestFrame) {
   var context = new FrameContext(requestFrame);
   return context.requestExecution.bind(context);
  }
  var changeDom = createAccumulator(requestAnimationFrame);
  var calculateStyles = createAccumulator(function (callback) { changeDom(function () { setTimeout(callback); }); });
  var observers = [], minimumIntervalBetweenChecks = 50;
  function itemObserver(element, callback, width) {
   return function () {
    if (element.compareDocumentPosition(document.body) & Node.DOCUMENT_POSITION_DISCONNECTED)
     return false;
    var currentStyle = ASPx.GetCurrentStyle(element);
    if (currentStyle.width === "auto")
     return true;
    var w = ASPx.PxToInt(currentStyle.width) - ASPx.GetLeftRightBordersAndPaddingsSummaryValue(element);
    if (width !== w)
     callback(width = w);
    return true;
   };
  }
  function subscribeElementContentWidth(el, callback) {
   if (observers.length === 0) {
    observers.push(itemObserver(el, callback, -1));
    calculateStyles(updateTrackedElements);
   } else
    observers.push(itemObserver(el, callback, -1));
  }
  function elementSizeObserver(element, callback, size) {
   return function() {
    if(element.compareDocumentPosition(document.body) & Node.DOCUMENT_POSITION_DISCONNECTED)
     return false;
    var currentStyle = ASPx.GetCurrentStyle(element);
    if(currentStyle.width === "auto")
     return true;
    var elementWidth = ASPx.PxToInt(currentStyle.width) - ASPx.GetLeftRightBordersAndPaddingsSummaryValue(element);
    var elementHeight = ASPx.PxToInt(currentStyle.height) - ASPx.GetTopBottomBordersAndPaddingsSummaryValue(element);
    if(size.width !== elementWidth || size.height !== elementHeight) {
     size.width = elementWidth;
     size.height = elementHeight;
     callback(size);
    }
    return true;
   };
  }
  function subscribeElementContentSize(element, callback) {
   if(observers.length === 0) {
    observers.push(elementSizeObserver(element, callback, { width: -1, height: -1 }));
    calculateStyles(updateTrackedElements);
   } else
    observers.push(elementSizeObserver(element, callback, { width: -1, height: -1 }));
  }
  function updateTrackedElements() {
   observers = observers.filter(function (observer) { return observer(); });
   if (observers.length > 0) {
    setTimeout(function () {
     calculateStyles(updateTrackedElements);
    }, minimumIntervalBetweenChecks);
   }
  }
  function applyStyles(element, styles) {
   var stylesArr = [];
   for (var property in styles) {
    if (styles.hasOwnProperty(property))
     stylesArr.push({ attr: property, value: styles[property] });
   }
   if (stylesArr.length === 1) {
    element.style[stylesArr[0].attr] = stylesArr[0].value;
   } else {
    var cssText = "";
    if (element.style.cssText) {
     var oldStylesArr = element.style.cssText.split(';').map(function (nvp) { return nvp.trim().split(':'); });
     for (var i = 0; i < oldStylesArr.length; i++) {
      var oldStyleArr = oldStylesArr[i];
      if (oldStyleArr.length === 2 && styles[oldStyleArr[0]] === undefined)
       cssText += oldStyleArr[0] + ":" + oldStyleArr[1].trim() + ";";
     }
    }
    for (var i = 0; i < stylesArr.length; i++) {
     var style = stylesArr[i];
     if (style.value !== "")
      cssText += style.attr + ":" + style.value + ";";
    }
    ASPx.Attr.SetOrRemoveAttribute(element, "style", cssText);
   }
  }
  function applyStateToElement(element, state) {
   if (state.inlineStyles === null)
    ASPx.Attr.RemoveAttribute(element, "style");
   else
    applyStyles(element, state.inlineStyles);
   for (var attrName in state.attributes) {
    if (state.attributes.hasOwnProperty(attrName))
     ASPx.Attr.SetOrRemoveAttribute(element, attrName, state.attributes[attrName]);
   }
   var allCssClasses = ASPx.GetClassNameList(state);
   if (allCssClasses) {
    var toggleInfo = state.cssClassToggleInfo;
    var cssClasses = allCssClasses.filter(function (c) { return toggleInfo[c] !== false; });
    for (var c in toggleInfo) {
     if (toggleInfo.hasOwnProperty(c) && toggleInfo[c] && cssClasses.indexOf(c) === -1)
      cssClasses.push(c);
    }
    var cssClass = cssClasses.join(" ");
    if (cssClass)
     ASPx.SetClassName(element, cssClass);
    else
     ASPx.Attr.RemoveAttribute(element, "class");
   }
  }
  function createElementState(element) {
   return { inlineStyles: {}, cssClassToggleInfo: {}, className: ASPx.GetClassName(element), attributes: {} };
  }
  function updateElementState(elementOrCollection, callback) {
   if (elementOrCollection.length !== undefined) {
    for (var i = 0; i < elementOrCollection.length; i++)
     updateElementState(elementOrCollection[i], callback);
    return;
   }
   var element = elementOrCollection;
   if (!element._dxCurrentFrameElementStateInfo) {
    callback(element._dxCurrentFrameElementStateInfo = createElementState(element));
    changeDom(function () {
     applyStateToElement(element, element._dxCurrentFrameElementStateInfo);
     element._dxCurrentFrameElementStateInfo = null;
    }, 1);
   } else
    callback(element._dxCurrentFrameElementStateInfo);
  }
  function setStyles(el, styles) {
   updateElementState(el, function (state) {
    if (state.inlineStyles === null)
     state.inlineStyles = styles;
    else {
     for (var i in styles) {
      if (styles.hasOwnProperty(i))
       state.inlineStyles[i] = styles[i];
     }
    }
   });
  }
  function clearStyles(el) {
   updateElementState(el, function (state) {
    state.inlineStyles = null;
   });
  }
  function toggleCssClass(el, cssClass, condition) {
   updateElementState(el, function (state) {
    state.cssClassToggleInfo[cssClass] = condition;
   });
  }
  function setCssClassName(el, className) {
   updateElementState(el, function (state) {
    state.cssClassToggleInfo = {};
    state.className = className;
   });
  }
  function updateAttribute(el, attrName, attrValue) {
   updateElementState(el, function (state) {
    state.attributes[attrName] = attrValue;
   });
  }
  function nextChangeDOM(callback) {
   changeDom(callback, 2);
  }
  return {
   ChangeDOM: changeDom,
   NextChangeDOM: nextChangeDOM,
   CalculateStyles: calculateStyles,
   SubscribeElementContentWidth: subscribeElementContentWidth,
   SubscribeElementContentSize: subscribeElementContentSize,
   SetStyles: setStyles,
   ClearStyles: clearStyles,
   ToggleCssClass: toggleCssClass,
   SetCssClassName: setCssClassName,
   UpdateAttribute: updateAttribute
  };
 });
 ASPx.DefaultDisplayNoneSelectors = ASPx.DefaultDisplayNoneSelectors.concat([
  ASPx.BootstrapCssSelectors.Modal,
  ASPx.BootstrapCssSelectors.DropDownMenu,
  "dxbs-dropdown-area",
  ASPx.BootstrapCssSelectors.HiddenLayout
 ]);
 ASPx.ProcessStyleSheetRules(".dropdown-item", function(name, style, rule) {
  if(name.indexOf(":hover") > -1 && style.backgroundColor) {
   var cssText = "background-color: " + style.backgroundColor + ";";
   if(style.color)
    cssText += "color: " + style.color + "; ";
   ASPx.AddStyleSheetRule(rule.parentStyleSheet, ".dxbs-item-hover", cssText);
   return true;
  }
 });
})(dx || (dx = {}));

(function(dx) {
 var BootstrapClientComboBox = ASPx.CreateClass(ASPxClientComboBox, {
  constructor: function(name) {
   this.constructor.prototype.constructor.call(this, name);
   this.needAdjustControlsInDropDownWindow = false;
   this.dropDownAutoWidth = true;
   this.feedbackRenderHelper = new ASPx.BootstrapEditFeedbackRenderHelper(this);
  },
  InlineInitialize: function() {
   var valueInputID = this.name + "_VI";
   var input = ASPx.CreateHiddenField(valueInputID, valueInputID);
   var mainElement = this.GetMainElement();
   mainElement.parentNode.insertBefore(input, mainElement.nextSibling);
   this.RequireStyleDecoration();
   ASPxClientComboBox.prototype.InlineInitialize.call(this);
   this.UpdateValueInput();
   this.feedbackRenderHelper.updateInputRightPadding();
   if(ASPx.Browser.TouchUI && !this.GetIsValid())
    this.UpdateErrorText();
  },
  InitializeEvents: function() {
   ASPxClientComboBox.prototype.InitializeEvents.call(this);
   var inputElement = this.GetInputElement();
   if(inputElement) {
    ASPx.Evt.AttachEventToElement(inputElement, "change", function() { ASPx.ETextChanged(this.name); }.bind(this));
    ASPx.Evt.AttachEventToElement(inputElement, "mousedown", function(evt) { ASPx.DDMC_MD(this.name, evt); }.bind(this));
   }
   var buttonElements = this.GetCustomButtonCollection();
   for(var i = 0; i < buttonElements.length; i++) 
    this.InitializeButtonEvents(buttonElements[i], i);
   var clearButton = this.GetClearButton();
   if(clearButton) {
    ASPx.Evt.AttachEventToElement(clearButton, "mousedown", function(evt) { ASPx.BEClear(this.name, evt); }.bind(this));
    if(this.IsAccessibleButton(clearButton))
     this.InitAccessibilityAnchorEvents(clearButton);
   }
   if(ASPx.Browser.MacOSMobilePlatform) {
    var errorImage = this.GetErrorImage();
    if(errorImage)
     ASPx.Evt.AttachEventToElement(errorImage, "touchstart", function() { });
   }
   if(this.ddmBP !== undefined)
    this.initializeDropDownCommandButtons();
  },
  InitializeButtonEvents: function(element, number){
   ASPx.Evt.AttachEventToElement(element, "click", function() {
    this.OnButtonClick(number);
   }.bind(this));
   if(this.IsAccessibleButton(element))
    this.InitAccessibilityAnchorEvents(element);
  },
  InitDropDownSize: function() {
   if(!this.enabled || this.GetItemCount() == 0) return;
   var dropDownWindow = this.GetDropDownWindow();
   if(this.IsDisplayed() && dropDownWindow && ASPx.IsExistsElement(dropDownWindow)) {
    var isDropDownWindowDisplayed = this.GetDropDownWindowDisplay();
    if(!isDropDownWindowDisplayed)
     ASPx.SetElementDisplay(dropDownWindow, true);
    this.AdjustListBoxHeight();
    this.AdjustListBoxWidth();
    if(!isDropDownWindowDisplayed)
     ASPx.SetElementDisplay(dropDownWindow, false);
   }
  },
  AdjustListBoxWidth: function() {
   var isAdjustDropDownWidthRequired = this.dropDownAutoWidth && !this.GetListBoxControl().IsCorrectWidthRequired();
   if(isAdjustDropDownWidthRequired) {
    var dropDownArea = this.getDropDownArea();
    if(dropDownArea)
     dropDownArea.style.width = this.getPopupOriginElement().offsetWidth + "px";
   }
   this.GetListBoxControl().CorrectWidth();
  },
  createDropDownCommandButtonClientInstance: function(pc, cmd) {
   var buttonElement = this.GetMainElement().querySelector("[data-toggle=dropdown-" + cmd.toLowerCase() + "]");
   if(buttonElement) {
    var clientInstance = new dx.BootstrapClientButton(this.name + "_" + cmd);
    clientInstance.mainElement = buttonElement;
    return clientInstance;
   }
   return null;
  },
  GetLoadedDropDownPrevSibling: function() {
   return this.GetDropDownButton() || this.GetInputContainerElement();
  },
  GetLoadingOffsetElement: function(listBox) {
   return listBox ? listBox.GetLoadingOffsetElement() : this.GetInputContainerElement();
  },
  GetLoadingPanelElement: function() {
   var loadingPanel = ASPx.BootstrapLoadingPanelManager.getLoadingPanel(this.name, this.loadingPanel);
   ASPx.SetStyles(loadingPanel, { left: 0 });
   return loadingPanel;
  },
  GetLoadingDiv: function() {
   return ASPx.BootstrapLoadingPanelManager.getLoadingDiv(this.name, this.loadingPanel);
  },
  CreateLoadingPanelWithAbsolutePosition: function(parentElement, offsetElement) {
   offsetElement = this.GetLoadingOffsetElement(this.GetListBoxControl());
   ASPxClientComboBox.prototype.CreateLoadingPanelWithAbsolutePosition.call(this, parentElement, offsetElement);
  },
  CreateLoadingDiv: function(parentElement, offsetElement) {
   offsetElement = this.GetLoadingOffsetElement(this.GetListBoxControl());
   ASPxClientComboBox.prototype.CreateLoadingDiv.call(this, parentElement, offsetElement);
  },
  ForceShowLoadingPanel: function() {
   if(this.GetItemCount() == 0 && !this.needToLoadDropDown) {
    var lb = this.GetListBoxControl();
    if(lb) {
     this.ShowDropDownAreaCore(false);
     this.AdjustListBoxWidth();
     lb.SetHeight(100);
    }
   }
  },
  NeedEnsureClearButtonVisibilityOnKeyDown: function() {
   return this.IsAccessibleButton(this.GetClearButton());
  },
  GetAccessibilityFocusedButtonClassName: function() {
   return "";
  },
  IsAccessibleButton: function(button) {
   return !!button && (button.tagName.toUpperCase() == "BUTTON" || ASPx.Attr.GetAttribute(button, "role") == "button");
  },
  GetButtonByAccessibilityAnchor: function(anchorElement) {
   return anchorElement;
  },
  GetAccessibilityAnchor: function(buttonElement) {
   return buttonElement;
  },
  SetAccessibilityAnchorEnabled: function(buttonElement, enabled) {
   if(buttonElement.tagName.toUpperCase() == "BUTTON")
    return;
   ASPxClientComboBox.prototype.SetAccessibilityAnchorEnabled.call(this, buttonElement, enabled);
  },
  EmulateButtonMouseEvent: function(sourceElement) {
   ASPx.Evt.EmulateMouseClick(sourceElement);
  },
  RaiseStandardOnChange: function() {
   var element = this.GetInputElement();
   if(element)
    ASPx.Evt.DispatchEvent(element, "change", true, false);
   else
    ASPxClientComboBox.prototype.RaiseStandardOnChange.call(this);
  },
  SetButtonVisible: function(number, value) {
   if(number == -100) {
    this.feedbackRenderHelper.setClearButtonVisible(value);
    return;
   }
   var inputGroupButton = ASPxClientComboBox.prototype.GetButton.call(this, number);
   if(inputGroupButton)
    ASPx.SetElementDisplay(inputGroupButton, value);
   ASPxClientComboBox.prototype.SetButtonVisible.call(this, number, value);
  },
  ChangeEnabledAttributes: function(enabled) {
   ASPxClientComboBox.prototype.ChangeEnabledAttributes.call(this, enabled);
   var clearButton = this.GetClearButton();
   if(clearButton)
    this.ChangeButtonEnabledAttributes(clearButton, this.GetChangeButtonEnabledAttributesMethod(enabled));
  },
  GetChangeButtonEnabledAttributesMethod: function(enabled) {
   return enabled ? ASPx.RemoveClassNameFromElement : ASPx.AddClassNameToElement;
  },
  ChangeButtonEnabledAttributes: function(element, method) {
   var buttonContainer = this.GetButtonContainerElement(element);
   if(buttonContainer && ASPx.ElementContainsCssClass(buttonContainer, "disabled"))
    return;
   method(element, "disabled");
  },
  GetControlCell: function() {
   return this.GetInputContainerElement();
  },
  EnsureControlCellStylesLoaded: function() { },
  ClearControlCellStyles: function() { },
  RestoreControlCellStyles: function() { },
  GetElementRequiredForErrorFrame: function() {
   return this.GetInputContainerElement();
  },
  GetErrorImage: function() {
   return this.feedbackRenderHelper.getErrorImage();
  },
  UpdateErrorText: function() {
   this.feedbackRenderHelper.updateErrorText();
  },
  ChangeErrorCellVisibility: function(visible, useVisibilityAttribute) {
   this.feedbackRenderHelper.setErrorControlVisible(visible);
  },
  GetTextColumnCountForTextDecoration: function(lb, item) {
   return item.texts.length;
  },
  PopulateStyleDecorationPostfixes: function() {
   var inputContainerSelector = this.GetInputContainerSelector();
   this.styleDecoration.AddPostfix("");
   this.styleDecoration.AddPostfix(inputContainerSelector);
   this.styleDecoration.AddPostfix(inputContainerSelector + " .form-control");
  },
  GetInputContainerSelector: function() {
   var selector = "";
   if(!!this.GetInputGroupElement())
    selector = ".input-group";
   else {
    var invalidSelectors = ASPx.Data.GetDistinctArray([DROPDOWN_AREA_SELECTOR,
     "." + ASPx.BootstrapCssSelectors.InputGroupAppendButton, "." + ASPx.BootstrapCssSelectors.InputGroupPrependButton]);
    selector = "div";
    for(var i = 0; i < invalidSelectors.length; i++)
     selector += ":not(" + invalidSelectors[i] + ")";
   }
   return selector;
  },
  CreateStyleDecoration: function() {
   return new ASPx.BootstrapEditorStyleDecoration(this);
  },
  GetPopupControl: function() {
   return null;
  },
  GetDropDownDivContainer: function() {
   return null;
  },
  GetDropDownItemImageCell: function() {
   return null;
  },
  GetHideContentCssClassName: function() {
   return ASPx.BootstrapCssSelectors.Hidden;
  },
  GetHoverElementToShowClearButton: function() {
   return this.GetInputGroupElement() || this.GetInputContainerElement();
  },
  GetInputGroupElement: function() {
   var mainElement = this.GetMainElement();
   return mainElement && mainElement.querySelector(".input-group");
  },
  GetInputContainerElement: function() {
   var container = this.GetMainElement().querySelector(INPUT_CONTAINER_SELECTOR);
   if(container == null) {
    var inputElement = this.GetInputElement();
    if(inputElement)
     container = inputElement.parentNode;
   }
   return container;
  },
  GetModalElement: function() {
   return ASPx.GetChildByClassName(this.GetMainElement(), MODAL_CLASS);
  },
  GetModalElementBackground: function() {
   return ASPx.GetChildByClassName(this.GetMainElement(), MODAL_BACKGROUND_CLASS);
  },
  GetModalInputContainerElement: function() {
   var modalElement = this.GetModalElement();
   return modalElement ? modalElement.querySelector("." + MODAL_INPUT_CONTAINER_CLASS) : null;
  },
  getInputCell: function() {
   return this.GetInputElement();
  },
  GetButtonContainerElement: function(buttonElement) {
   return ASPx.GetParent(buttonElement, function(element) {
    return ASPx.ElementContainsCssClass(element, ASPx.BootstrapCssSelectors.InputGroupAppendButton) ||
     ASPx.ElementContainsCssClass(element, ASPx.BootstrapCssSelectors.InputGroupPrependButton);
   });
  },
  GetCaptionCell: function() {
   return ASPx.CacheHelper.GetCachedElement(this, "captionElement",
    function() {
     var mainElement = this.GetMainElement();
     return mainElement && mainElement.querySelector(".dxbs-edit-caption");
    }
   );
  },
  getCaptionTextNode: function() {
   return ASPx.GetNormalizedTextNode(this.GetCaptionCell());
  },
  getCaptionRelatedCellCount: function() {
   return undefined;
  },
  GetDropDownButton: function() {
   var inputGroupElement = this.GetInputGroupElement();
   return inputGroupElement && inputGroupElement.querySelector(DROPDOWN_SELECTOR);
  },
  GetClearButton: function() {
   return this.feedbackRenderHelper.getClearButton();
  },
  GetButton: function(number) {
   switch(number) {
    case this.dropDownButtonIndex:
     return this.GetDropDownButton();
    case -100: 
     return this.GetClearButton();
    default:
     var inputGroupButton = ASPxClientComboBox.prototype.GetButton.call(this, number);
     return inputGroupButton && (inputGroupButton.querySelector(".dxbs-edit-btn") || inputGroupButton.querySelector(".btn") || inputGroupButton);
   }
  },
  GetDropDownInnerControlName: function(suffix) {
   return this.name + suffix;
  },
  ChangeEnabledStateItems: function(enabled) { },
  AdjustControls: function() { },
  AdjustDropDownWindow: function() { },
  GetDropDownIsWindowElement: function(id, pcPostfix) {
   return null;
  },
  GetElementIsDropDownParent: function(element) {
   return ASPx.ElementHasCssClass(element, "dxbs-dropdown-edit") && ASPx.Attr.IsExistsAttribute(element, "id") 
    ? ASPx.GetDropDownCollection().Get(ASPx.Attr.GetAttribute(element, "id")) : null;
  },
  GetDropDownWindow: function() {
   return this.getDropDownArea();
  },
  OnBrowserWindowResizeInternal: function(e) {
   this.UpdateDropDownPosition();
  },
  EnableStyleControllerForDDButton: function() { },
  DisableStyleControllerForDDButton: function() { },
  OnMainCellMouseDown: function(evt) {
   if(!ASPx.ElementHasCssClass(this.GetInputElement().parentNode, MODAL_INPUT_CONTAINER_CLASS))
    ASPxClientComboBox.prototype.OnMainCellMouseDown.call(this, evt);
  },
  OnDropDown: function(evt) {
   if(!ASPx.ElementHasCssClass(this.GetInputElement().parentNode, MODAL_INPUT_CONTAINER_CLASS))
    ASPxClientComboBox.prototype.OnDropDown.call(this, evt);
  },
  getDropDownArea: function() {
   var mainElement = this.GetMainElement();
   return mainElement ? mainElement.querySelector(DROPDOWN_AREA_SELECTOR) : null;
  },
  getPopupOriginElement: function() {
   return this.GetInputGroupElement() || this.GetInputContainerElement();
  },
  getPopupElements: function() {
   return [this.getDropDownArea(), this.getPopupOriginElement()];
  },
  GetDropDownWindowDisplay: function() {
   var dropDownWindow = this.GetDropDownWindow();
   return dropDownWindow ? ASPx.GetElementDisplay(dropDownWindow) : false;
  },
  ShowDropDownArea: function(isRaiseEvent, forceSize) {
   if(this.needToLoadDropDown) {
    this.EnsureDropDownLoaded();
    return;
   }
   if(this.RequireLoadCustomRangeOnDropDown()) {
    this.LoadCustomItemsRange();
    return;
   }
   var lb = this.GetListBoxControl();
   if(!lb || lb.GetItemCount() == 0)
    return;
   if(!this.filterStrategy.IsFilterMeetRequirementForMinLength() && !this.isDropDownModal()) {
    this.DropDownButtonPop(true);
    return;
   }
   this.ShowDropDownAreaCore(isRaiseEvent, forceSize);
   this.EnsureListBoxSelectionSynchronized(lb);
   this.EnsureSelectedItemVisibleOnShow(lb);
   lb.CallbackSpaceInit();
   if(this.accessibilityCompliant)
    this.accessibilityHelper.SetExpandedState(true);
  },
  ShowDropDownAreaCore: function(isRaiseEvent, forceSize) {
   this.SetPCIsShowingNow(true);
   ASPx.GetDropDownCollection().RegisterDroppedDownControl(this, this.GetDropDownParents());
   if(!this.droppedDown)
    this.SetLockListBoxClick();
   this.lockClosing = true;
   this.RaiseDropDownEventRequired = isRaiseEvent;
   this.SetModalElementVisibility(true);
   if(this.isDropDownModalRequired())
    this.SetModalInputVisible(true);
   ASPx.BootstrapPopupManager.registerVisiblePopup(this.getPopupElements(), function() {
    this.SetModalElementVisibility(false);
    this.SetModalInputVisible(false);
   }.aspxBind(this));
   ASPx.Attr.Aria.SetExpanded(this.GetDropDownButton(), true);
   this.UpdateDropDownPosition();
   this.OnPopupControlShown();
   this.droppedDown = true;
   this.lockClosing = false;
  },
  HideDropDownArea: function(isRaiseEvent) {
   if(this.filterStrategy)
    this.filterStrategy.OnDropDownHideArea();
   if(this.BrowserRequiresCacheScrollBar())
    this.CachedScrollTop();
   if(this.lockClosing || !this.droppedDown || !this.RaiseQueryCloseUp())
    return;
   this.DropDownButtonPop();
   ASPx.GetDropDownCollection().UnregisterDroppedDownControl(this);
   ASPx.BootstrapPopupManager.unregisterVisiblePopup(this.getPopupElements());
   ASPx.Attr.Aria.SetExpanded(this.GetDropDownButton(), false);
   if(isRaiseEvent)
    this.RaiseCloseUp();
   this.droppedDown = false;
   if(this.accessibilityCompliant)
    this.accessibilityHelper.SetExpandedState(false);
  },
  UpdateDropDownPosition: function() {
   if(this.GetDropDownWindowDisplay()) {
    this.InitDropDownSize();
    this.UpdateDropDownPositionCore();
   }
  },
  UpdateDropDownPositionCore: function() {
   var needPositionCorrection = true;
   var modalElement = this.GetModalElement();
   if(modalElement && this.ddmBP) {
    var currentModeIsModal = ASPx.ElementHasCssClass(modalElement, ASPx.BootstrapCssSelectors.Modal);
    this.ToggleModalMode(this.isDropDownModalRequired());
    var modeChanged = currentModeIsModal != ASPx.ElementHasCssClass(modalElement, ASPx.BootstrapCssSelectors.Modal);
    if(modeChanged) {
     ASPx.SetElementDisplay(modalElement, true);
     this.SetModalInputVisible(!currentModeIsModal);
    }
    needPositionCorrection &= currentModeIsModal == modeChanged;
   }
   if(needPositionCorrection)
    ASPx.BootstrapPopupManager.correctPopupPositionForClientWindow(this.getPopupElements(), "LeftSides", 0, "Below", -ASPx.GetClientTop(this.getPopupOriginElement()));
  },
  UpdateDropDownPositionAndSize: function() {
   if(this.filterStrategy && this.filterStrategy.filterInitialized || !!this.dxgvBatchAddedValue)
    this.UpdateDropDownPosition();
  },
  UpdateDropDownOnFeedbackChanged: function() {
   if(this.GetDropDownWindowDisplay()) {
    this.AdjustListBoxWidth();
    this.UpdateDropDownPositionCore();
   }
  },
  SetModalElementVisibility: function(visible) {
   var modalElement = this.GetModalElement();
   if(modalElement) {
    ASPx.SetElementDisplay(modalElement, visible);
    var background = this.GetModalElementBackground();
    (visible ? ASPx.AddClassNameToElement : ASPx.RemoveClassNameFromElement)(background, "show");
    var listElement = modalElement.querySelector(".dxbs-listbox." + ASPx.BootstrapCssSelectors.DropDownMenu);
    (visible ? ASPx.AddClassNameToElement : ASPx.RemoveClassNameFromElement)(listElement, "show");
   }
  },
  ToggleModalMode: function(enabled) {
   ASPx.ToggleClassNameToElement(this.GetModalElement(), ASPx.BootstrapCssSelectors.Modal, enabled);
   ASPx.ToggleClassNameToElement(this.GetModalElementBackground(), "show", enabled);
  },
  SetModalInputVisible: function(visible) {
   var modalElement = this.GetModalElement();
   if(!modalElement)
    return;
   if(this.ddmInput) {
    var inputElement = this.GetInputElement();
    var inputContainer = this.GetInputContainerElement();
    if(visible) {
     var modalInputContainer = this.GetModalInputContainerElement();
     modalInputContainer.appendChild(inputElement);
     if(this.focusedNullTextElement)
      modalInputContainer.appendChild(this.focusedNullTextElement);
     ASPx.AddClassNameToElement(inputContainer, "form-control");
     this.initializeDropDownModalClearButton(modalInputContainer);
     if(this.dropDownModalClearButton)
      this.EnsureClearButtonVisibility();
     this.ensureDropDownModalInputVisibility(modalInputContainer);
    }
    else if(this.isDropDownModalRequired()) {
     ASPx.RemoveClassNameFromElement(inputContainer, "form-control");
     inputContainer.insertBefore(inputElement, inputContainer.firstChild);
     if(this.focusedNullTextElement)
      inputContainer.appendChild(this.focusedNullTextElement);
    }
   }
  },
  ensureDropDownModalInputVisibility: function(inputContainer) {
   if(!inputContainer && this.ddmInput)
    inputContainer = this.GetModalInputContainerElement();
   if(inputContainer)
    ASPx.ToggleClassNameToElement(inputContainer, ASPx.BootstrapCssSelectors.Hidden, this.GetReadOnly() || !this.GetEnabled());
  },
  getDropDownModalClearButtonSelector: function() {
   return MODAL_INPUT_CLEARBUTTON_SELECTOR;
  },
  helpTextInitialize: function() {
   if(this.helpText)
    this.helpTextObj = new ASPx.BootstrapTextEditHelpText(this, this.helpText, this.enableHelpTextPopupAnimation, this.hasPopupHelpText());
  },
  GetHelpTextElementPrevSibling: function() {
   var errorTextElement = this.feedbackRenderHelper.getErrorTextElement();
   return errorTextElement || this.GetInputGroupElement() || this.GetInputContainerElement();
  },
  getFocusedNullTextElementClassName: function() {
   return "dxbs-null-text text-muted" + (this.cssClasses.nt ? " " + this.cssClasses.nt : "");
  },
  GetItemBadgeText: function(index) { return this.GetListBoxControl().GetItemBadgeText(index); },
  SetItemBadgeText: function(index, text) { this.GetListBoxControl().SetItemBadgeText(index, text); },
  GetItemBadgeIconCssClass: function(index) { return this.GetListBoxControl().GetItemBadgeIconCssClass(index); },
  SetItemBadgeIconCssClass: function(index, cssClass) { this.GetListBoxControl().SetItemBadgeIconCssClass(index, cssClass); }
 });
 var DROPDOWN_SELECTOR = "[data-toggle=dropdown-show]",
  DROPDOWN_AREA_SELECTOR = ".dxbs-dropdown-area",
  INPUT_CONTAINER_SELECTOR = ".dxbs-input-cntr",
  MODAL_INPUT_CONTAINER_CLASS = "dxbs-modal-input-cntr",
  MODAL_INPUT_CLEARBUTTON_SELECTOR = ".dxbs-modal-clear-btn",
  MODAL_CLASS = "dxbs-ddmodal",
  MODAL_BACKGROUND_CLASS = "dxbs-ddmodal-back";
 dx.BootstrapClientComboBox = BootstrapClientComboBox;
})(dx || (dx = {}));

(function () {
ASPx.StateItemsExist = false;
ASPx.FocusedItemKind = "FocusedStateItem";
ASPx.HoverItemKind = "HoverStateItem";
ASPx.PressedItemKind = "PressedStateItem";
ASPx.SelectedItemKind = "SelectedStateItem";
ASPx.DisabledItemKind = "DisabledStateItem";
ASPx.ReadOnlyItemKind = "ReadOnlyStateItem";
ASPx.CachedStatePrefix = "cached";
ASPxStateItem = ASPx.CreateClass(null, {
 constructor: function(name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, kind, disableApplyingStyleToLink){
  this.name = name;
  this.classNames = classNames;
  this.customClassNames = [];
  this.resultClassNames = [];
  this.cssTexts = cssTexts;
  this.postfixes = postfixes;
  this.imageObjs = imageObjs;
  this.imagePostfixes = imagePostfixes;
  this.kind = kind;
  this.classNamePostfix = kind.substr(0, 1).toLowerCase();
  this.enabled = true;
  this.needRefreshBetweenElements = false;
  this.elements = null;
  this.images = null;
  this.links = [];
  this.linkColor = null;
  this.linkTextDecoration = null;
  this.disableApplyingStyleToLink = !!disableApplyingStyleToLink; 
 },
 GetCssText: function(index){
  if(ASPx.IsExists(this.cssTexts[index]))
   return this.cssTexts[index];
  return this.cssTexts[0];
 },
 CreateStyleRule: function(index){
  if(this.GetCssText(index) == "") return "";
  var styleSheet = ASPx.GetCurrentStyleSheet();
  if(styleSheet)
   return ASPx.CreateImportantStyleRule(styleSheet, this.GetCssText(index), this.classNamePostfix);  
  return ""; 
 },
 GetClassName: function(index){
  if(ASPx.IsExists(this.classNames[index]))
   return this.classNames[index];
  return this.classNames[0];
 },
 GetResultClassName: function(index){
  if(!ASPx.IsExists(this.resultClassNames[index])) {
   if(!ASPx.IsExists(this.customClassNames[index]))
    this.customClassNames[index] = this.CreateStyleRule(index);
   if(this.GetClassName(index) != "" && this.customClassNames[index] != "")
    this.resultClassNames[index] = this.GetClassName(index) + " " + this.customClassNames[index];
   else if(this.GetClassName(index) != "")
    this.resultClassNames[index] = this.GetClassName(index);
   else if(this.customClassNames[index] != "")
    this.resultClassNames[index] = this.customClassNames[index];
   else
    this.resultClassNames[index] = "";
  }
  return this.resultClassNames[index];
 },
 GetElements: function(element){
  if(!this.elements || !ASPx.IsValidElements(this.elements)){
   if(this.postfixes && this.postfixes.length > 0){
    this.elements = [ ];
    var parentNode = element.parentNode;
    if(parentNode){
     for(var i = 0; i < this.postfixes.length; i++){
      var id = this.name + this.postfixes[i];
      this.elements[i] = ASPx.GetChildById(parentNode, id);
      if(!this.elements[i])
       this.elements[i] = ASPx.GetElementById(id);
     }
    }
   }
   else
    this.elements = [element];
  }
  return this.elements;
 },
 GetImages: function(element){
  if(!this.images || !ASPx.IsValidElements(this.images)){
   this.images = [ ];
   if(this.imagePostfixes && this.imagePostfixes.length > 0){
    var elements = this.GetElements(element);
    for(var i = 0; i < this.imagePostfixes.length; i++){
     var id = this.name + this.imagePostfixes[i];
     for(var j = 0; j < elements.length; j++){
      if(!elements[j]) continue;
      if(elements[j].id == id)
       this.images[i] = elements[j];
      else
       this.images[i] = ASPx.GetChildById(elements[j], id);
      if(this.images[i])
       break;
     }
    }
   }
  }
  return this.images;
 },
 Apply: function(element){
  if(!this.enabled) return;
  try{
   this.ApplyStyle(element);
   if(this.imageObjs && this.imageObjs.length > 0)
    this.ApplyImage(element);
   if(ASPx.Browser.IE && ASPx.Browser.MajorVersion >= 11 && ASPx.Browser.PlaformMajorVersion < 10)
    this.ForceRedrawAppearance(element);
  }
  catch(e){
  }
 },
 ApplyStyle: function(element){
  var elements = this.GetElements(element);
  for(var i = 0; i < elements.length; i++){
   if(!elements[i]) continue;
   if(this.GetResultClassName(i) != "") {
    var className = elements[i].className.replace(this.GetResultClassName(i), "");
    elements[i].className = ASPx.Str.Trim(className) + " " + this.GetResultClassName(i);
   }
   if(!ASPx.Browser.Opera || ASPx.Browser.Version >= 9)
    this.ApplyStyleToLinks(elements, i);
  }
 },
 ApplyStyleToLinks: function(elements, index){
  if(this.disableApplyingStyleToLink)
   return;
  if(!ASPx.IsValidElements(this.links[index]))
   this.links[index] = ASPx.GetNodesByTagName(elements[index], "A");
  for(var i = 0; i < this.links[index].length; i++)
   this.ApplyStyleToLinkElement(this.links[index][i], index);
 },
 ApplyStyleToLinkElement: function(link, index){
  if(this.GetLinkColor(index) != "")
   ASPx.Attr.ChangeAttributeExtended(link.style, "color", link, "saved" + this.kind + "Color", this.GetLinkColor(index));
  if(this.GetLinkTextDecoration(index) != "")
   ASPx.Attr.ChangeAttributeExtended(link.style, "textDecoration", link, "saved" + this.kind + "TextDecoration", this.GetLinkTextDecoration(index));
 },
 ApplyImage: function(element){
  var images = this.GetImages(element);
  for(var i = 0; i < images.length; i++){
   if(!images[i] || !this.imageObjs[i]) continue;
   var useSpriteImage = typeof(this.imageObjs[i]) != "string";
   var newUrl = "", newCssClass = "", newBackground = "";
   if(useSpriteImage){
    newUrl = ASPx.EmptyImageUrl;           
    if(this.imageObjs[i].spriteCssClass) 
     newCssClass = this.imageObjs[i].spriteCssClass;
    if(this.imageObjs[i].spriteBackground)
     newBackground = this.imageObjs[i].spriteBackground;
   }
   else{
    newUrl = this.imageObjs[i];
    if(ASPx.Attr.IsExistsAttribute(images[i].style, "background"))   
     newBackground = " ";
   }
   if(newUrl != "")
    ASPx.Attr.ChangeAttributeExtended(images[i], "src", images[i], "saved" + this.kind + "Src", newUrl);
   if(newCssClass != "")
    this.ApplyImageClassName(images[i], newCssClass);
   if(newBackground != ""){
    if(ASPx.Browser.WebKitFamily) {
     var savedBackground = ASPx.Attr.GetAttribute(images[i].style, "background");
     if(!useSpriteImage)
      savedBackground += " " + images[i].style["backgroundPosition"];
     ASPx.Attr.SetAttribute(images[i], "saved" + this.kind + "Background", savedBackground);
     ASPx.Attr.SetAttribute(images[i].style, "background", newBackground);
    }
    else
     ASPx.Attr.ChangeAttributeExtended(images[i].style, "background", images[i], "saved" + this.kind + "Background", newBackground);
   }     
  }
 },
 ApplyImageClassName: function(element, newClassName){
  if(ASPx.Attr.GetAttribute(element, "saved" + this.kind + "ClassName"))
   this.CancelImageClassName(element);
  var className = element.className;
  ASPx.Attr.SetAttribute(element, "saved" + this.kind + "ClassName", className);
  element.className = className + " " + newClassName;
 },
 Cancel: function(element){
  if(!this.enabled) return;
  try{  
   if(this.imageObjs && this.imageObjs.length > 0)
    this.CancelImage(element);
   this.CancelStyle(element);
  }
  catch(e){
  }
 },
 CancelStyle: function(element){
  var elements = this.GetElements(element);
  for(var i = 0; i < elements.length; i++){
   if(!elements[i]) continue;
   if(this.GetResultClassName(i) != "") {
    var className = ASPx.Str.Trim(elements[i].className.replace(this.GetResultClassName(i), ""));
    elements[i].className = className;
   }
   if(!ASPx.Browser.Opera || ASPx.Browser.Version >= 9)
    this.CancelStyleFromLinks(elements, i);
  }
 },
 CancelStyleFromLinks: function(elements, index){
  if(this.disableApplyingStyleToLink)
   return;
  if(!ASPx.IsValidElements(this.links[index]))
   this.links[index] = ASPx.GetNodesByTagName(elements[index], "A");
  for(var i = 0; i < this.links[index].length; i++)
   this.CancelStyleFromLinkElement(this.links[index][i], index);
 },
 CancelStyleFromLinkElement: function(link, index){
  if(this.GetLinkColor(index) != "")
   ASPx.Attr.RestoreAttributeExtended(link.style, "color", link, "saved" + this.kind + "Color");
  if(this.GetLinkTextDecoration(index) != "")
   ASPx.Attr.RestoreAttributeExtended(link.style, "textDecoration", link, "saved" + this.kind + "TextDecoration");
 },
 CancelImage: function(element){
  var images = this.GetImages(element);
  for(var i = 0; i < images.length; i++){
   if(!images[i] || !this.imageObjs[i]) continue;
   ASPx.Attr.RestoreAttributeExtended(images[i], "src", images[i], "saved" + this.kind + "Src");
   this.CancelImageClassName(images[i]);
   ASPx.Attr.RestoreAttributeExtended(images[i].style, "background", images[i], "saved" + this.kind + "Background");
  }
 },
 CancelImageClassName: function(element){
  var savedClassName = ASPx.Attr.GetAttribute(element, "saved" + this.kind + "ClassName");
  if(ASPx.IsExists(savedClassName)) {
   element.className = savedClassName;
   ASPx.Attr.RemoveAttribute(element, "saved" + this.kind + "ClassName");
  }
 },
 Clone: function(){
  return new ASPxStateItem(this.name, this.classNames, this.cssTexts, this.postfixes, 
   this.imageObjs, this.imagePostfixes, this.kind, this.disableApplyingStyleToLink);
 },
 IsChildElement: function(element){
  if(element != null){
   var elements = this.GetElements(element);
   for(var i = 0; i < elements.length; i++){
    if(!elements[i]) continue;
    if(ASPx.GetIsParent(elements[i], element)) 
     return true;
   }
  }
  return false;
 },
 ForceRedrawAppearance: function(element) {
  if(!aspxGetStateController().IsForceRedrawAppearanceLocked()) {
   var value = element.style.opacity;
   element.style.opacity = "0.7777";
   var dummy = element.offsetWidth;
   element.style.opacity = value;
  }
 },
 GetLinkColor: function(index){
  if(!ASPx.IsExists(this.linkColor)){
   var rule = ASPx.GetStyleSheetRules(this.customClassNames[index]);
   this.linkColor = rule ? rule.style.color : null;
   if(!ASPx.IsExists(this.linkColor)){
    var rule = ASPx.GetStyleSheetRules(this.GetClassName(index));
    this.linkColor = rule ? rule.style.color : null;
   }
   if(this.linkColor == null) 
    this.linkColor = "";
  }
  return this.linkColor;
 },
 GetLinkTextDecoration: function(index){
  if(!ASPx.IsExists(this.linkTextDecoration)){
   var rule = ASPx.GetStyleSheetRules(this.customClassNames[index]);
   this.linkTextDecoration = rule ? rule.style.textDecoration : null;
   if(!ASPx.IsExists(this.linkTextDecoration)){
    var rule = ASPx.GetStyleSheetRules(this.GetClassName(index));
    this.linkTextDecoration = rule ? rule.style.textDecoration : null;
   }
   if(this.linkTextDecoration == null) 
    this.linkTextDecoration = "";
  }
  return this.linkTextDecoration;
 }
});
ASPxClientStateEventArgs = ASPx.CreateClass(null, {
 constructor: function(item, element){
  this.item = item;
  this.element = element;
  this.toElement = null;
  this.fromElement = null;
  this.htmlEvent = null;
 }
});
ASPxStateController = ASPx.CreateClass(null, {
 constructor: function(){
  this.focusedItems = { };
  this.hoverItems = { };
  this.pressedItems = { };
  this.selectedItems = { };
  this.disabledItems = {};
  this.readOnlyItems = {};
  this.disabledScheme = {};
  this.currentFocusedElement = null;
  this.currentFocusedItemName = null;
  this.currentHoverElement = null;
  this.currentHoverItemName = null;
  this.currentPressedElement = null;
  this.currentPressedItemName = null;
  this.savedCurrentPressedElement = null;
  this.savedCurrentMouseMoveSrcElement = null;
  this.forceRedrawAppearanceLockCount = 0;
  this.stateItemType = ASPxStateItem;
  this.AfterSetFocusedState = new ASPxClientEvent();
  this.AfterClearFocusedState = new ASPxClientEvent();
  this.AfterSetHoverState = new ASPxClientEvent();
  this.AfterClearHoverState = new ASPxClientEvent();
  this.AfterSetPressedState = new ASPxClientEvent();
  this.AfterClearPressedState = new ASPxClientEvent();
  this.AfterDisabled = new ASPxClientEvent();
  this.AfterEnabled = new ASPxClientEvent();
  this.BeforeSetFocusedState = new ASPxClientEvent();
  this.BeforeClearFocusedState = new ASPxClientEvent();
  this.BeforeSetHoverState = new ASPxClientEvent();
  this.BeforeClearHoverState = new ASPxClientEvent();
  this.BeforeSetPressedState = new ASPxClientEvent();
  this.BeforeClearPressedState = new ASPxClientEvent();
  this.BeforeDisabled = new ASPxClientEvent();
  this.BeforeEnabled = new ASPxClientEvent();
  this.FocusedItemKeyDown = new ASPxClientEvent();
 }, 
 AddHoverItem: function(name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, disableApplyingStyleToLink){
  this.AddItem(this.hoverItems, name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, ASPx.HoverItemKind, disableApplyingStyleToLink);
  this.AddItem(this.focusedItems, name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, ASPx.FocusedItemKind, disableApplyingStyleToLink);
 },
 AddPressedItem: function(name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, disableApplyingStyleToLink){
  this.AddItem(this.pressedItems, name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, ASPx.PressedItemKind, disableApplyingStyleToLink);
 },
 AddSelectedItem: function(name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, disableApplyingStyleToLink){
  this.AddItem(this.selectedItems, name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, ASPx.SelectedItemKind, disableApplyingStyleToLink);
 },
 AddDisabledItem: function (name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, disableApplyingStyleToLink, rootId) {
  this.AddItem(this.disabledItems, name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes,
   ASPx.DisabledItemKind, disableApplyingStyleToLink, this.addIdToDisabledItemScheme, rootId);
 },
 AddReadOnlyItem: function(name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, disableApplyingStyleToLink) {
  this.AddItem(this.readOnlyItems, name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, ASPx.ReadOnlyItemKind, disableApplyingStyleToLink);
 },
 addIdToDisabledItemScheme: function(rootId, childId) {
  if (!rootId)
   return;
  if (!this.disabledScheme[rootId])
   this.disabledScheme[rootId] = [rootId];
  if (childId && (rootId != childId) && ASPx.Data.ArrayIndexOf(this.disabledScheme[rootId], childId) == -1)
   this.disabledScheme[rootId].push(childId);
 },
 removeIdFromDisabledItemScheme: function(rootId, childId) {
  if (!rootId || !this.disabledScheme[rootId])
   return;
  ASPx.Data.ArrayRemove(this.disabledScheme[rootId], childId);
  if (this.disabledScheme[rootId].length == 0)
   delete this.disabledScheme[rootId];
 },
 AddItem: function (items, name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, kind, disableApplyingStyleToLink, onAdd, rootId) {
  var type = this.getStateItemType();
  var stateItem = new type(name, classNames, cssTexts, postfixes, imageObjs, imagePostfixes, kind, disableApplyingStyleToLink);
  if (postfixes && postfixes.length > 0) {
   for (var i = 0; i < postfixes.length; i++) {
    items[name + postfixes[i]] = stateItem;
    if (onAdd)
     onAdd.call(this, rootId, name + postfixes[i]);
   }
  }
  else {
   if (onAdd)
    onAdd.call(this, rootId, name);
   items[name] = stateItem;
  }
  ASPx.StateItemsExist = true;
 },
 getStateItemType: function () { return this.stateItemType; },
 withCustomStateItemType: function (newType, callback) {
  this.stateItemType = newType;
  callback(this);
  this.stateItemType = ASPxStateItem;
 },
 RemoveHoverItem: function(name, postfixes){
  this.RemoveItem(this.hoverItems, name, postfixes);
  this.RemoveItem(this.focusedItems, name, postfixes);
 },
 RemovePressedItem: function(name, postfixes){
  this.RemoveItem(this.pressedItems, name, postfixes);
 },
 RemoveSelectedItem: function(name, postfixes){
  this.RemoveItem(this.selectedItems, name, postfixes);
 },
 RemoveDisabledItem: function (name, postfixes, rootId) {
  this.RemoveItem(this.disabledItems, name, postfixes, this.removeIdFromDisabledItemScheme, rootId);
 },
 RemoveReadOnlyItem: function(name, postfixes) {
  this.RemoveItem(this.readOnlyItems, name, postfixes);
 },
 RemoveItem: function (items, name, postfixes, onRemove, rootId) {
  if (postfixes && postfixes.length > 0) {
   for (var i = 0; i < postfixes.length; i++) {
    delete items[name + postfixes[i]];
    if (onRemove)
     onRemove.call(this, rootId, name + postfixes[i]);
   }
  }
  else {
   delete items[name];
   if (onRemove)
    onRemove.call(this, rootId, name);
  }
 },
 RemoveDisposedItems: function(){
  this.RemoveDisposedItemsByType(this.hoverItems);
  this.RemoveDisposedItemsByType(this.pressedItems);
  this.RemoveDisposedItemsByType(this.focusedItems);
  this.RemoveDisposedItemsByType(this.selectedItems);
  this.RemoveDisposedItemsByType(this.disabledItems);
  this.RemoveDisposedItemsByType(this.disabledScheme);
  this.RemoveDisposedItemsByType(this.readOnlyItems);
 },
 RemoveDisposedItemsByType: function(items){
  for(var key in items) {
   if(items.hasOwnProperty(key)) {
    var item = items[key];
    var element = document.getElementById(key);
    if(!element || !ASPx.IsValidElement(element))
     delete items[key];
    try {
     if(item && item.elements) {
      for(var i = 0; i < item.elements.length; i++) {
       if(!ASPx.IsValidElements(item.links[i]))
        item.links[i] = null;
      }
     }
    }
    catch(e) {
    }
   }
  }
 },
 GetFocusedElement: function(srcElement){
  return this.GetItemElement(srcElement, this.focusedItems, ASPx.FocusedItemKind);
 },
 GetHoverElement: function(srcElement){
  return this.GetItemElement(srcElement, this.hoverItems, ASPx.HoverItemKind);
 },
 GetPressedElement: function(srcElement){
  return this.GetItemElement(srcElement, this.pressedItems, ASPx.PressedItemKind);
 },
 GetSelectedElement: function(srcElement){
  return this.GetItemElement(srcElement, this.selectedItems, ASPx.SelectedItemKind);
 },
 GetDisabledElement: function(srcElement){
  return this.GetItemElement(srcElement, this.disabledItems, ASPx.DisabledItemKind);
 },
 GetReadOnlyElement: function(srcElement) {
  return this.GetItemElement(srcElement, this.readOnlyItems, ASPx.ReadOnlyItemKind);
 },
 GetItemElement: function(srcElement, items, kind){
  if(srcElement && srcElement[ASPx.CachedStatePrefix + kind]){
   var cachedElement = srcElement[ASPx.CachedStatePrefix + kind];
   if(cachedElement != ASPx.EmptyObject)
    return cachedElement;
   return null;
  }
  var element = srcElement;
  while(element != null) {
   var item = items[element.id];
   if(item){
    this.CacheItemElement(srcElement, kind, element);
    element[kind] = item;
    return element;
   }
   element = element.parentNode;
  }
  this.CacheItemElement(srcElement, kind, ASPx.EmptyObject);
  return null;
 },
 CacheItemElement: function(srcElement, kind, value){
  if(srcElement && !srcElement[ASPx.CachedStatePrefix + kind])
   srcElement[ASPx.CachedStatePrefix + kind] = value;
 },
 DoSetFocusedState: function(element, fromElement){
  var item = element[ASPx.FocusedItemKind];
  if(item){
   var args = new ASPxClientStateEventArgs(item, element);
   args.fromElement = fromElement;
   this.BeforeSetFocusedState.FireEvent(this, args);
   item.Apply(element);
   this.AfterSetFocusedState.FireEvent(this, args);
  }
 },
 DoClearFocusedState: function(element, toElement){
  var item = element[ASPx.FocusedItemKind];
  if(item){
   var args = new ASPxClientStateEventArgs(item, element);
   args.toElement = toElement;
   this.BeforeClearFocusedState.FireEvent(this, args);
   item.Cancel(element);
   this.AfterClearFocusedState.FireEvent(this, args);
  }
 },
 DoSetHoverState: function(element, fromElement){
  var item = element[ASPx.HoverItemKind];
  if(item){
   var args = new ASPxClientStateEventArgs(item, element);
   args.fromElement = fromElement;
   this.BeforeSetHoverState.FireEvent(this, args);
   item.Apply(element);
   this.AfterSetHoverState.FireEvent(this, args);
  }
 },
 DoClearHoverState: function(element, toElement){
  var item = element[ASPx.HoverItemKind];
  if(item){
   var args = new ASPxClientStateEventArgs(item, element);
   args.toElement = toElement;
   this.BeforeClearHoverState.FireEvent(this, args);
   item.Cancel(element);
   this.AfterClearHoverState.FireEvent(this, args);
  }
 },
 DoSetPressedState: function(element){
  var item = element[ASPx.PressedItemKind];
  if(item){
   var args = new ASPxClientStateEventArgs(item, element);
   this.BeforeSetPressedState.FireEvent(this, args);
   item.Apply(element);
   this.AfterSetPressedState.FireEvent(this, args);
  }
 },
 DoClearPressedState: function(element){
  var item = element[ASPx.PressedItemKind];
  if(item){
   var args = new ASPxClientStateEventArgs(item, element);
   this.BeforeClearPressedState.FireEvent(this, args);
   item.Cancel(element);
   this.AfterClearPressedState.FireEvent(this, args);
  }
 },
 SetCurrentFocusedElement: function(element){
  if(this.currentFocusedElement && !ASPx.IsValidElement(this.currentFocusedElement)){
   this.currentFocusedElement = null;
   this.currentFocusedItemName = "";
  }
  if(this.currentFocusedElement != element){
   var oldCurrentFocusedElement = this.currentFocusedElement;
   var item = (element != null) ? element[ASPx.FocusedItemKind] : null;
   var itemName = (item != null) ? item.name : "";
   if(this.currentFocusedItemName != itemName){
    if(this.currentHoverItemName != "")
     this.SetCurrentHoverElement(null);
    if(this.currentFocusedElement != null)
     this.DoClearFocusedState(this.currentFocusedElement, element);
    this.currentFocusedElement = element;
    item = (element != null) ? element[ASPx.FocusedItemKind] : null;
    this.currentFocusedItemName = (item != null) ? item.name : "";
    if(this.currentFocusedElement != null)
     this.DoSetFocusedState(this.currentFocusedElement, oldCurrentFocusedElement);
   }
  }
 },
 GetCurrentHoverElement: function() {
  return this.currentHoverElement;
 },
 SetCurrentHoverElement: function(element){
  if(this.currentHoverElement && !ASPx.IsValidElement(this.currentHoverElement)){
   this.currentHoverElement = null;
   this.currentHoverItemName = "";
  }
  var item = (element != null) ? element[ASPx.HoverItemKind] : null;
  if(item && !item.enabled) { 
   element = this.GetItemElement(element.parentNode, this.hoverItems, ASPx.HoverItemKind);
   item = (element != null) ? element[ASPx.HoverItemKind] : null;
  }
  if(this.currentHoverElement != element){
   var oldCurrentHoverElement = this.currentHoverElement,
    itemName = (item != null) ? item.name : "";
   if(this.currentHoverItemName != itemName || (item != null && item.needRefreshBetweenElements)){
    if(this.currentHoverElement != null)
     this.DoClearHoverState(this.currentHoverElement, element);
    item = (element != null) ? element[ASPx.HoverItemKind] : null;
    if(item == null || item.enabled){
     this.currentHoverElement = element;
     this.currentHoverItemName = (item != null) ? item.name : "";
     if(this.currentHoverElement != null)
      this.DoSetHoverState(this.currentHoverElement, oldCurrentHoverElement);
    }
   }
  }
 },
 SetCurrentPressedElement: function(element){
  if(this.currentPressedElement && !ASPx.IsValidElement(this.currentPressedElement)){
   this.currentPressedElement = null;
   this.currentPressedItemName = "";
  }
  if(this.currentPressedElement != element){
   if(this.currentPressedElement != null)
    this.DoClearPressedState(this.currentPressedElement);
   var item = (element != null) ? element[ASPx.PressedItemKind] : null;
   if(item == null || item.enabled){
    this.currentPressedElement = element;
    this.currentPressedItemName = (item != null) ? item.name : "";
    if(this.currentPressedElement != null)
     this.DoSetPressedState(this.currentPressedElement);
   }
  }
 },
 SetCurrentFocusedElementBySrcElement: function(srcElement){
  var element = this.GetFocusedElement(srcElement);
  this.SetCurrentFocusedElement(element);
 },
 SetCurrentHoverElementBySrcElement: function(srcElement){
  var element = this.GetHoverElement(srcElement);
  this.SetCurrentHoverElement(element);
 },
 SetCurrentPressedElementBySrcElement: function(srcElement){
  var element = this.GetPressedElement(srcElement);
  this.SetCurrentPressedElement(element);
 },
 SetPressedElement: function (element) {
  this.SetCurrentHoverElement(null);
  this.SetCurrentPressedElementBySrcElement(element);
  this.savedCurrentPressedElement = this.currentPressedElement;
 },
 SelectElement: function (element) {
  var item = element[ASPx.SelectedItemKind];
  if(item)
   item.Apply(element);
 }, 
 SelectElementBySrcElement: function(srcElement){
  var element = this.GetSelectedElement(srcElement);
  if(element != null) this.SelectElement(element);
 }, 
 DeselectElement: function(element){
  var item = element[ASPx.SelectedItemKind];
  if(item)
   item.Cancel(element);
 }, 
 DeselectElementBySrcElement: function(srcElement){
  var element = this.GetSelectedElement(srcElement);
  if(element != null) this.DeselectElement(element);
 },
 SetElementEnabled: function(element, enable){
  if(enable)
   this.EnableElement(element);
  else
   this.DisableElement(element);
 },
 SetElementReadOnly: function(element, readOnly) {
  var element = this.GetReadOnlyElement(element);
  if (element != null) {
   var item = element[ASPx.ReadOnlyItemKind];
   if(item) {
    if(readOnly) {
     if(item.name == this.currentPressedItemName)
      this.SetCurrentPressedElement(null);
     if(item.name == this.currentHoverItemName)
      this.SetCurrentHoverElement(null);
    }
    if(readOnly)
     item.Apply(element);
    else
     item.Cancel(element);
   }
  }
 },
 SetElementWithChildNodesEnabled: function (parentName, enabled) {
  var procFunct = (enabled ? this.EnableElement : this.DisableElement);
  var childItems = this.disabledScheme[parentName];
  if (childItems && childItems.length > 0)
   for (var i = 0; i < childItems.length; i++) {
    procFunct.call(this, document.getElementById(childItems[i]));
   }
 },
 DisableElement: function (element) {
  var element = this.GetDisabledElement(element);
  if(element != null) {
   var item = element[ASPx.DisabledItemKind];
   if(item){
    var args = new ASPxClientStateEventArgs(item, element);
    this.BeforeDisabled.FireEvent(this, args);
    if(item.name == this.currentPressedItemName)
     this.SetCurrentPressedElement(null);
    if(item.name == this.currentHoverItemName)
     this.SetCurrentHoverElement(null);
    item.Apply(element);
    this.SetMouseStateItemsEnabled(item.name, item.postfixes, false);
    this.AfterDisabled.FireEvent(this, args);
   }
  }
 }, 
 EnableElement: function(element){
  var element = this.GetDisabledElement(element);
  if(element != null) {
   var item = element[ASPx.DisabledItemKind];
   if(item){
    var args = new ASPxClientStateEventArgs(item, element);
    this.BeforeEnabled.FireEvent(this, args);
    item.Cancel(element);
    this.SetMouseStateItemsEnabled(item.name, item.postfixes, true);
    this.AfterEnabled.FireEvent(this, args);
   }
  }
 }, 
 SetMouseStateItemsEnabled: function(name, postfixes, enabled){   
  if(postfixes && postfixes.length > 0){
   for(var i = 0; i < postfixes.length; i ++){
    this.SetItemsEnabled(this.hoverItems, name + postfixes[i], enabled);
    this.SetItemsEnabled(this.pressedItems, name + postfixes[i], enabled);
    this.SetItemsEnabled(this.focusedItems, name + postfixes[i], enabled);
   }
  }
  else{
   this.SetItemsEnabled(this.hoverItems, name, enabled);
   this.SetItemsEnabled(this.pressedItems, name, enabled);
   this.SetItemsEnabled(this.focusedItems, name, enabled);
  }  
 },
 SetItemsEnabled: function(items, name, enabled){   
  if(items[name])
   items[name].enabled = enabled;
 },
 OnFocusMove: function(evt){
  var element = ASPx.Evt.GetEventSource(evt);
  aspxGetStateController().SetCurrentFocusedElementBySrcElement(element);
 },
 OnMouseMove: function(evt, checkElementChanged){
  var srcElement = ASPx.Evt.GetEventSource(evt);
  if(checkElementChanged && srcElement == this.savedCurrentMouseMoveSrcElement) return;
  this.savedCurrentMouseMoveSrcElement = srcElement;
  if(ASPx.Browser.IE && !ASPx.Evt.IsLeftButtonPressed(evt) && this.savedCurrentPressedElement != null)
   this.ClearSavedCurrentPressedElement();
  if(this.savedCurrentPressedElement == null)
   this.SetCurrentHoverElementBySrcElement(srcElement);
  else{
   var element = this.GetPressedElement(srcElement);
   if(element != this.currentPressedElement){
    if(element == this.savedCurrentPressedElement)
     this.SetCurrentPressedElement(this.savedCurrentPressedElement);
    else
     this.SetCurrentPressedElement(null);
   }
  }
 },
 OnMouseDown: function(evt){
  if(!ASPx.Evt.IsLeftButtonPressed(evt)) return;
  var srcElement = ASPx.Evt.GetEventSource(evt);
  this.OnMouseDownOnElement(srcElement);
 },
 OnMouseDownOnElement: function (element) {
  if(this.GetPressedElement(element) == null) return;
  this.SetPressedElement(element);
 },
 OnMouseUp: function(evt){
  var srcElement = ASPx.Evt.GetEventSource(evt);
  this.OnMouseUpOnElement(srcElement);
 },
 OnMouseUpOnElement: function(element){
  if(this.savedCurrentPressedElement == null) return;
  this.ClearSavedCurrentPressedElement();
  this.SetCurrentHoverElementBySrcElement(element);
 },
 OnMouseOver: function(evt){
  var element = ASPx.Evt.GetEventSource(evt);
  if(element && element.tagName == "IFRAME")
   this.OnMouseMove(evt, true);
 },
 OnKeyDown: function(evt){
  var element = this.GetFocusedElement(ASPx.Evt.GetEventSource(evt));
  if(element != null && element == this.currentFocusedElement) {
   var item = element[ASPx.FocusedItemKind];
   if(item){
    var args = new ASPxClientStateEventArgs(item, element);
    args.htmlEvent = evt;
    this.FocusedItemKeyDown.FireEvent(this, args);
   }
  }
 },
 OnKeyUpOnElement: function(evt) {
  if(this.savedCurrentPressedElement != null && ASPx.Evt.IsActionKeyPressed(evt))
   this.ClearSavedCurrentPressedElement();
 },
 OnSelectStart: function(evt){
  if(this.savedCurrentPressedElement) {
   ASPx.Selection.Clear();
   return false;
  }
 },
 ClearSavedCurrentPressedElement: function() {
  this.savedCurrentPressedElement = null;
  this.SetCurrentPressedElement(null);
 },
 ClearCache: function(srcElement, kind) {
  if(srcElement[ASPx.CachedStatePrefix + kind])
   srcElement[ASPx.CachedStatePrefix + kind] = null;
 },
 ClearElementCache: function(srcElement) {
  this.ClearCache(srcElement, ASPx.FocusedItemKind);
  this.ClearCache(srcElement, ASPx.HoverItemKind);
  this.ClearCache(srcElement, ASPx.PressedItemKind);
  this.ClearCache(srcElement, ASPx.SelectedItemKind);
  this.ClearCache(srcElement, ASPx.DisabledItemKind);
 },
 ClearElementCacheInContainer: function(container) {
  var elements = ASPx.GetNodes(container);
  elements.push(container);
  ASPx.Data.ForEach(elements, this.ClearElementCache.bind(this));
 },
 LockForceRedrawAppearance: function() {
  this.forceRedrawAppearanceLockCount++;
 },
 UnlockForceRedrawAppearance: function() {
  this.forceRedrawAppearanceLockCount--;
 },
 IsForceRedrawAppearanceLocked: function() {
  return this.forceRedrawAppearanceLockCount > 0;
 },
 GetHoverItem: function(srcElement) {
  var element = this.GetHoverElement(srcElement);
  return (element != null) ? element[ASPx.HoverItemKind] : null;
 }
});
var stateController = null;
function aspxGetStateController(){
 if(stateController == null)
  stateController = new ASPxStateController();
 return stateController;
}
function aspxAddStateItems(method, namePrefix, classes, disableApplyingStyleToLink){
 for(var i = 0; i < classes.length; i ++){
  for(var j = 0; j < classes[i][2].length; j ++) {
   var name = namePrefix;
   if(classes[i][2][j])
    name += "_" + classes[i][2][j];
   var postfixes = classes[i][3] || null;
   var imageObjs = (classes[i][4] && classes[i][4][j]) || null;
   var imagePostfixes = classes[i][5] || null;
   method.call(aspxGetStateController(), name, classes[i][0], classes[i][1], postfixes, imageObjs, imagePostfixes, disableApplyingStyleToLink, namePrefix);
  }
 }
}
ASPx.AddHoverItems = function(namePrefix, classes, disableApplyingStyleToLink){
 aspxAddStateItems(aspxGetStateController().AddHoverItem, namePrefix, classes, disableApplyingStyleToLink);
};
ASPx.AddPressedItems = function(namePrefix, classes, disableApplyingStyleToLink){
 aspxAddStateItems(aspxGetStateController().AddPressedItem, namePrefix, classes, disableApplyingStyleToLink);
};
ASPx.AddSelectedItems = function(namePrefix, classes, disableApplyingStyleToLink){
 aspxAddStateItems(aspxGetStateController().AddSelectedItem, namePrefix, classes, disableApplyingStyleToLink);
};
ASPx.AddDisabledItems = function(namePrefix, classes, disableApplyingStyleToLink){
 aspxAddStateItems(aspxGetStateController().AddDisabledItem, namePrefix, classes, disableApplyingStyleToLink);
};
ASPx.AddReadOnlyItems = function(namePrefix, classes, disableApplyingStyleToLink) {
 aspxAddStateItems(aspxGetStateController().AddReadOnlyItem, namePrefix, classes, disableApplyingStyleToLink);
};
function aspxRemoveStateItems(method, namePrefix, classes){
 for(var i = 0; i < classes.length; i ++){
  for(var j = 0; j < classes[i][0].length; j ++) {
   var name = namePrefix;
   if(classes[i][0][j])
    name += "_" + classes[i][0][j];
   method.call(aspxGetStateController(), name, classes[i][1], namePrefix);
  }
 }
}
ASPx.RemoveHoverItems = function(namePrefix, classes){
 aspxRemoveStateItems(aspxGetStateController().RemoveHoverItem, namePrefix, classes);
};
ASPx.RemovePressedItems = function(namePrefix, classes){
 aspxRemoveStateItems(aspxGetStateController().RemovePressedItem, namePrefix, classes);
};
ASPx.RemoveSelectedItems = function(namePrefix, classes){
 aspxRemoveStateItems(aspxGetStateController().RemoveSelectedItem, namePrefix, classes);
};
ASPx.RemoveDisabledItems = function(namePrefix, classes){
 aspxRemoveStateItems(aspxGetStateController().RemoveDisabledItem, namePrefix, classes);
};
ASPx.RemoveReadOnlyItems = function(namePrefix, classes) {
 aspxRemoveStateItems(aspxGetStateController().RemoveReadOnlyItem, namePrefix, classes);
};
ASPx.AddAfterClearFocusedState = function(handler){
 aspxGetStateController().AfterClearFocusedState.AddHandler(handler);
};
ASPx.AddAfterSetFocusedState = function(handler){
 aspxGetStateController().AfterSetFocusedState.AddHandler(handler);
};
ASPx.AddAfterClearHoverState = function(handler){
 aspxGetStateController().AfterClearHoverState.AddHandler(handler);
};
ASPx.AddAfterSetHoverState = function(handler){
 aspxGetStateController().AfterSetHoverState.AddHandler(handler);
};
ASPx.AddAfterClearPressedState = function(handler){
 aspxGetStateController().AfterClearPressedState.AddHandler(handler);
};
ASPx.AddAfterSetPressedState = function(handler){
 aspxGetStateController().AfterSetPressedState.AddHandler(handler);
};
ASPx.AddAfterDisabled = function(handler){
 aspxGetStateController().AfterDisabled.AddHandler(handler);
};
ASPx.AddAfterEnabled = function(handler){
 aspxGetStateController().AfterEnabled.AddHandler(handler);
};
ASPx.AddBeforeClearFocusedState = function(handler){
 aspxGetStateController().BeforeClearFocusedState.AddHandler(handler);
};
ASPx.AddBeforeSetFocusedState = function(handler){
 aspxGetStateController().BeforeSetFocusedState.AddHandler(handler);
};
ASPx.AddBeforeClearHoverState = function(handler){
 aspxGetStateController().BeforeClearHoverState.AddHandler(handler);
};
ASPx.AddBeforeSetHoverState = function(handler){
 aspxGetStateController().BeforeSetHoverState.AddHandler(handler);
};
ASPx.AddBeforeClearPressedState = function(handler){
 aspxGetStateController().BeforeClearPressedState.AddHandler(handler);
};
ASPx.AddBeforeSetPressedState = function(handler){
 aspxGetStateController().BeforeSetPressedState.AddHandler(handler);
};
ASPx.AddBeforeDisabled = function(handler){
 aspxGetStateController().BeforeDisabled.AddHandler(handler);
};
ASPx.AddBeforeEnabled = function(handler){
 aspxGetStateController().BeforeEnabled.AddHandler(handler);
};
ASPx.AddFocusedItemKeyDown = function(handler){
 aspxGetStateController().FocusedItemKeyDown.AddHandler(handler);
};
ASPx.SetHoverState = function(element){
 aspxGetStateController().SetCurrentHoverElementBySrcElement(element);
};
ASPx.ClearHoverState = function(evt){
 aspxGetStateController().SetCurrentHoverElementBySrcElement(null);
};
ASPx.UpdateHoverState = function(evt){
 aspxGetStateController().OnMouseMove(evt, false);
};
ASPx.SetFocusedState = function(element){
 aspxGetStateController().SetCurrentFocusedElementBySrcElement(element);
};
ASPx.ClearFocusedState = function(evt){
 aspxGetStateController().SetCurrentFocusedElementBySrcElement(null);
};
ASPx.UpdateFocusedState = function(evt){
 aspxGetStateController().OnFocusMove(evt);
};
ASPx.AccessibilityMarkerClass = "dxalink";
ASPx.AssignAccessibilityEventsToChildrenLinks = function(container, clearFocusedStateOnMouseOut){
 var links = ASPx.GetNodesByPartialClassName(container, ASPx.AccessibilityMarkerClass);
 for(var i = 0; i < links.length; i++)
  ASPx.AssignAccessibilityEventsToLink(links[i], clearFocusedStateOnMouseOut);
};
ASPx.AssignAccessibilityEventsToLink = function(link, clearFocusedStateOnMouseOut) {
 if(!ASPx.ElementContainsCssClass(link, ASPx.AccessibilityMarkerClass))
  return;
 ASPx.AssignAccessibilityEventsToLinkCore(link, clearFocusedStateOnMouseOut);
};
ASPx.AssignAccessibilityEventsToLinkCore = function (link, clearFocusedStateOnMouseOut) {
 ASPx.Evt.AttachEventToElement(link, "focus", function (e) { ASPx.UpdateFocusedState(e); });
 var clearFocusedStateHandler = function (e) { ASPx.ClearFocusedState(e); };
 ASPx.Evt.AttachEventToElement(link, "blur", clearFocusedStateHandler);
 if(clearFocusedStateOnMouseOut)
  ASPx.Evt.AttachEventToElement(link, "mouseout", clearFocusedStateHandler);
};
ASPx.Evt.AttachEventToDocument("mousemove", function(evt) {
 if(ASPx.classesScriptParsed && ASPx.StateItemsExist)
  aspxGetStateController().OnMouseMove(evt, true);
});
ASPx.Evt.AttachEventToDocument(ASPx.TouchUIHelper.touchMouseDownEventName, function(evt) {
 if(ASPx.classesScriptParsed && ASPx.StateItemsExist)
  aspxGetStateController().OnMouseDown(evt);
});
ASPx.Evt.AttachEventToDocument(ASPx.TouchUIHelper.touchMouseUpEventName, function(evt) {
 if(ASPx.classesScriptParsed && ASPx.StateItemsExist)
  aspxGetStateController().OnMouseUp(evt);
});
ASPx.Evt.AttachEventToDocument("mouseover", function(evt) {
 if(ASPx.classesScriptParsed && ASPx.StateItemsExist)
  aspxGetStateController().OnMouseOver(evt);
});
ASPx.Evt.AttachEventToDocument("keydown", function(evt) {
 if(ASPx.classesScriptParsed && ASPx.StateItemsExist)
  aspxGetStateController().OnKeyDown(evt);
});
ASPx.Evt.AttachEventToDocument("selectstart", function(evt) {
 if(ASPx.classesScriptParsed && ASPx.StateItemsExist)
  return aspxGetStateController().OnSelectStart(evt);
});
ASPx.GetStateController = aspxGetStateController;
ASPx.StateItem = ASPxStateItem;
})();
(function(dx) {
 var BootstrapClientListBoxItem = ASPx.CreateClass(ASPxClientListBoxItem, {
  constructor: function(listEditBase, index, texts, value, imageUrl, selected, cellStyles, cellCssClasses, cellTooltips,
   cellAttributes, htmlContents, style, cssClass, tooltip, attributes, htmlContent, badge) {
   this.constructor.prototype.constructor.call(this, listEditBase, index, texts, value, imageUrl,
    selected, cellStyles, cellCssClasses, cellTooltips, cellAttributes, htmlContents, style, cssClass, tooltip, attributes, htmlContent);
   this.iconCssClass = this.imageUrl;
   this.badge = badge;
  },
  GetFieldText: function(fieldIndexOrName) {
   return this.GetColumnText(fieldIndexOrName);
  }
 });
 var BSLISTBOX_CLASS = "dxbs-listbox",
  SELECTED_CLASS = "active",
  DISABLED_CLASS = "disabled",
  TABLE_ROW_SELECTED_CLASS = "table-active",
  TABLE_ROW_WITH_CHECK_CLASS = "dxbs-check-row",
  CHECKBOX_COL_CLASS = "dxbs-check-col",
  HIDDEN_ROW_CLASS = "dxbs-hidden-row",
  EXTRA_ROW_CLASS = "dxbs-extra-row",
  TEMPLATED_ROW_CLASS = "dxbs-templated-row",
  LAST_ROW_CLASS = "dxbs-last-data-row",
  DROPDOWN_ITEM_LINK_CLASS = ASPx.BootstrapCssSelectors.DropDownMenuItem,
  ITEM_LINK_CLASS = ASPx.BootstrapCssSelectors.ListBoxItemLink,
  CHECKBOX_CONTAINER_CLASS = ASPx.BootstrapCssSelectors.CheckBox,
  ITEM_CLASS = "list-group-item",
  ITEM_CHECKBOX_CLASS = ITEM_CLASS + " " + CHECKBOX_CONTAINER_CLASS,
  DROPDOWN_ITEM_CHECKBOX_CLASS = ASPx.BootstrapCore.IsBootstrap3 ? ITEM_CHECKBOX_CLASS : DROPDOWN_ITEM_LINK_CLASS + " " + CHECKBOX_CONTAINER_CLASS,
  ITEM_CHECKBOX_LABEL_CLASS = ASPx.BootstrapCssSelectors.CheckBoxLabel,
  ITEM_CHECKBOX_INPUT_CLASS = ASPx.BootstrapCssSelectors.CheckBoxInput,
  ITEM_IMAGE_CLASS = "image",
  ITEM_BADGE_CLASS = ASPx.BootstrapCssSelectors.Badge,
  DIVIDER_ITEM_CLASS = ASPx.BootstrapCssSelectors.Divider,
  STANDALONE_CLASS = "form-control",
  INACTIVE_FILTER_CLASS = "collapsed",
  ANIMATED_FILTER_CLASS = "animated",
  lbIIdSuffix = "LBI",
  lbILdSuffix = "LBL",
  lbICdSuffix = "LBC",
  lbSelectAllCbIdSuffix = "LBSACB",
  CONTENT_TABLE_ID_SUFFIX = "_ContentTable";
 var BootstrapListBoxItemsManager = ASPx.CreateClass(ASPx.ListBoxItemsDefaultManager, {
  HasSampleItemStateItems: function() {
   return false;
  },
  AddItemStateItems: function(controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, index) {
   var name = this.listBox.name + "_" + lbIIdSuffix + index;
   if(clearCache)
    this.listBox.ClearStateItemCache(controller, name, itemCellsIdSuffixes);
   controller.AddSelectedItem(name, [SELECTED_CLASS], this.listBox.selectedCssArray, itemCellsIdSuffixes, null, null, true);
   controller.AddDisabledItem(name, [DISABLED_CLASS], this.listBox.disabledCssArray, itemCellsIdSuffixes, null, null, true);
  },
  RemoveItemStateItems: function(controller, itemCellsIdSuffixes, index) {
   var name = this.listBox.name + "_" + lbIIdSuffix + index;
   this.listBox.ClearStateItemCache(controller, name, itemCellsIdSuffixes);
   controller.RemoveSelectedItem(name, itemCellsIdSuffixes);
   controller.RemoveDisabledItem(name, itemCellsIdSuffixes);
  },
  GetListTableRows: function() {
   return this.listBox.GetItemElements();
  },
  GetItemElement: function(index) {
   return this.listBox.GetItemElements()[index];
  },
  GetItemRow: function(index) {
   return this.GetItemElement(index);
  },
  GetFirstVisibleItemRow: function() {
   var firstVisibleItemIndex = this.GetFirstVisibleItem();
   return this.GetItemElement(this.ConvertItemIndexToRowIndex(firstVisibleItemIndex));
  },
  GetItem: function(index) {
   var itemElement = this.GetItemElement(index);
   if(!itemElement)
    return null;
   var image = this.listBox.imageCellExists ? itemElement.querySelector("." + ITEM_IMAGE_CLASS) : null;
   var iconCssClass = image == null ? "" : ASPx.Str.Trim(ASPx.GetClassName(image).replace(ITEM_IMAGE_CLASS, ""));
   var itemValue = this.listBox.itemsValue[index] !== undefined ? this.listBox.itemsValue[index] : null;
   return new BootstrapClientListBoxItem(this.listBox, index, this.listBox.GetItemRowTexts(itemElement), itemValue, iconCssClass, this.listBox.GetIsItemSelected(index));
  },
  GetItemIndexByRow: function(itemRow) {
   return this.listBox.GetItemIndexByElement(itemRow);
  },
  GetItemCount: function() {
   return this.listBox.GetItemElements().length;
  },
  GetVisibleItemCount: function() {
   return this.listBox.GetVisibleItemElements().length;
  },
  GetItemTopOffsetCore: function(index) {
   return this.listBox.GetElementTopOffset(this.GetItemElement(index));
  },
  GetFirstVisibleItem: function() {
   var itemCount = this.GetItemCount();
   for(var i = 0; i < itemCount; i++) {
    var itemElement = this.GetItemElement(i);
    if(itemElement && ASPx.GetElementDisplay(itemElement))
     return i;
   }
   return -1;
  },
  ConvertItemIndexToRowIndex: function(itemIndex) {
   return itemIndex;
  },
  InitializeInternalCheckBoxCollection: function () { },
  CreateNewItemRow: function(index) {
   return this.listBox.CreateNewItem();
  },
  ClearItemsCore: function() {
   var itemElements = this.listBox.GetItemElements();
   for(var i = itemElements.length - 1; i >= 0; i--)
    ASPx.RemoveElement(itemElements[i]);
  },
  SetItemBadgeText: function(index, text) { },
  SetItemBadgeIconCssClass: function(index, cssClass) { }
 });
 var BootstrapListBoxItemsVirtualManager = ASPx.CreateClass(ASPx.ListBoxItemsVirtualManager, {
  InitializeItemRows: function() {
   var renderHelper = this.listBox.listBoxRenderHelper;
   var itemsContainer = renderHelper.GetItemsContainer();
   var virtualScrollTopSpacer = renderHelper.CreateNewItemElement();
   virtualScrollTopSpacer.setAttribute("id", this.listBox.name + "VirtualScrollTopSpacer");
   virtualScrollTopSpacer.setAttribute("data-type", "spacer");
   itemsContainer.insertBefore(virtualScrollTopSpacer, itemsContainer.childNodes[0]);
   var virtualScrollBottomSpacer = renderHelper.CreateNewItemElement();
   virtualScrollBottomSpacer.setAttribute("id", this.listBox.name + "VirtualScrollBottomSpacer");
   virtualScrollBottomSpacer.setAttribute("data-type", "spacer");
   itemsContainer.appendChild(virtualScrollBottomSpacer);
   var scrollDiv = renderHelper.GetScrollDivElement();
   ASPx.Evt.AttachEventToElement(scrollDiv, "scroll", this.RecreateItemRows.bind(this));
  },
  HasSampleItemStateItems: function() {
   return false;
  },
  AddItemStateItems: function(controller, clearCache, itemCellsIdSuffixes, hoverItemOnly, index) {
   if(index == -1)
    return;
   var name = this.listBox.name + "_" + lbIIdSuffix + index;
   if(clearCache)
    this.listBox.ClearStateItemCache(controller, name, itemCellsIdSuffixes);
   if(!hoverItemOnly) {
    controller.AddSelectedItem(name, [SELECTED_CLASS], this.listBox.selectedCssArray, itemCellsIdSuffixes, null, null, true);
    controller.AddDisabledItem(name, [DISABLED_CLASS], this.listBox.disabledCssArray, itemCellsIdSuffixes, null, null, true);
   }
  },
  RemoveItemStateItems: function(controller, itemCellsIdSuffixes, index) {
   var name = this.listBox.name + "_" + lbIIdSuffix + index;
   this.listBox.ClearStateItemCache(controller, name, itemCellsIdSuffixes);
   controller.RemoveSelectedItem(name, itemCellsIdSuffixes);
   controller.RemoveDisabledItem(name, itemCellsIdSuffixes);
  },
  UseVirtualItemWidth: function() {
   return false;
  },
  GetItemsWidth: function() {
   return this.listTable.offsetWidth;
  },
  EnsureVirtualScrollItemHeight: function() {
   var defaultItemHeight = this.GetDefaultItemHeight();
   ASPx.ListBoxItemsVirtualManager.prototype.EnsureVirtualScrollItemHeight.call(this);
   if(this.GetDefaultItemHeight() != defaultItemHeight)
    this.listBox.CorrectHeight();
  },
  UpdateScrollTableContainerHeight: function() {
   this.UpdateVirtualScrollBottomSpacerHeight(this.virtualScrollVisibleItemIndices);
  },
  UpdateVirtualScrollSpacerHeight: function(visibleIndices) {
   ASPx.ListBoxItemsVirtualManager.prototype.UpdateVirtualScrollSpacerHeight.call(this, visibleIndices);
   this.UpdateVirtualScrollSpacerVisibility(this.GetVirtualScrollTopSpacer());
   this.UpdateVirtualScrollBottomSpacerHeight(visibleIndices);
  },
  UpdateVirtualScrollBottomSpacerHeight: function(visibleIndices) {
   var bottomSpacerElement = document.getElementById(this.listBox.name + "VirtualScrollBottomSpacer");
   if(bottomSpacerElement && this.virtualScrollItemHeight !== undefined) {
    var filteredItemsHeight = this.filteredItemIndices.length * this.virtualScrollItemHeight;
    var virtualBottomSpacerHeight = filteredItemsHeight;
    var previousItemsHeight = (visibleIndices.length > 0 && this.filteredItemIndices.length > 0
     ? ASPx.Data.ArrayIndexOf(this.filteredItemIndices, visibleIndices[0]) : 0) * this.virtualScrollItemHeight;
    virtualBottomSpacerHeight -= previousItemsHeight;
    var visibleItemsHeight = visibleIndices.length * this.virtualScrollItemHeight;
    var visibleItemsHeightDiff = (isNaN(this.itemHeightDiff) ? 0 : this.itemHeightDiff) * visibleIndices.length;
    virtualBottomSpacerHeight -= visibleItemsHeight + visibleItemsHeightDiff;
    virtualBottomSpacerHeight -= this.listBox.GetTopScrollSpacerHeight() + this.listBox.GetBottomScrollSpacerHeight();
    if(!isNaN(virtualBottomSpacerHeight)) {
     if (virtualBottomSpacerHeight < 0)
      virtualBottomSpacerHeight = 0;
     ASPx.SetStyles(bottomSpacerElement, { height: virtualBottomSpacerHeight });
     this.UpdateVirtualScrollSpacerVisibility(bottomSpacerElement);
    }
   }
  },
  UpdateVirtualScrollSpacerVisibility: function(spacerElement) {
   var height = parseInt(spacerElement.style.height);
   var isDisplayed = !isNaN(height) && height > 0;
   if(ASPx.GetElementDisplay(spacerElement) != isDisplayed)
    ASPx.SetElementDisplay(spacerElement, isDisplayed);
  },
  GetListTableRows: function() {
   return this.listBox.GetItemElements();
  },
  GetItemElement: function(index) {
   if(index > -1) {
    var itemElements = this.listBox.GetItemElements();
    return itemElements && itemElements.length ? itemElements[index] : null;
   }
   return null;
  },
  GetItemRow: function(index) {
   return this.GetItemElement(this.ConvertItemIndexToRowIndex(index));
  },
  GetFirstVisibleItemRow: function() {
   var firstVisibleItemIndex = this.GetFirstVisibleItem();
   return this.GetItemElement(this.ConvertItemIndexToRowIndex(firstVisibleItemIndex));
  },
  GetItem: function(index) {
   if(index < 0 || index >= this.GetItemCount())
    return null;
   var deserializedItem = this.deserializedItems[index];
   var itemTexts = this.AdjustItemTexts(deserializedItem);
   var result = new BootstrapClientListBoxItem(this.listBox, index, itemTexts, deserializedItem.value,
    deserializedItem.imageUrl, this.listBox.GetIsItemSelected(index));
   result.insertOrderIndex = deserializedItem.insertOrderIndex;
   return result;
  },
  GetItemsHeight: function() {
   var itemsHeight = ASPx.ListBoxItemsVirtualManager.prototype.GetItemsHeight.call(this);
   return itemsHeight + ASPx.GetTopBottomBordersAndPaddingsSummaryValue(this.listBox.GetListTable());
  },
  GetVisibleItemCount: function() {
   return this.filteredItemIndices.length;
  },
  GetItemTopOffsetCore: function(index) {
   return this.listBox.GetElementTopOffset(this.GetItemRow(index));
  },
  GetFirstVisibleItem: function() {
   var itemCount = this.GetItemCount();
   for(var i = 0; i < itemCount; i++) {
    var itemElement = this.GetItemElement(i);
    if(itemElement && itemElement.itemIndex >= 0)
     return itemElement.itemIndex;
   }
   return -1;
  },
  GetScrollDivChildElementHeight: function() {
   var itemsHeight = 0;
   var itemElements = this.listBox.GetItemElements();
   for(var i = 0; i < itemElements.length; i++)
    itemsHeight += itemElements[i].offsetHeight + ASPx.GetTopBottomMargins(itemElements[i]);
   var bottomSpacerElement = document.getElementById(this.listBox.name + "VirtualScrollBottomSpacer");
   var spacersHeight = this.listBox.GetTopSpacersHeight() + this.listBox.GetBottomScrollSpacerHeight() + bottomSpacerElement.clientHeight;
   return itemsHeight + spacersHeight;
  },
  ConvertItemIndexToRowIndex: function(itemIndex) {
   var result = ASPx.Data.ArrayIndexOf(this.listBox.GetItemElements(), itemIndex, function(element) { return element.itemIndex === itemIndex; });
   return result;
  },
  GetFirstRenderedItem: function() {
   if(this.GetItemCount() > 0) {
    var itemElements = this.listBox.GetItemElements();
    for(var i = 0; i < itemElements.length; i++)
     if(itemElements[i].itemIndex !== undefined)
      return this.GetItem(itemElements[i].itemIndex);
   }
   return null;
  },
  GetLastRenderedItem: function() {
   var itemElements = this.listBox.GetItemElements();
   for(var i = itemElements.length - 1; i >= 0; i--)
    if(itemElements[i].itemIndex !== undefined)
     return this.GetItem(itemElements[i].itemIndex);
   return null;
  },
  GetRenderedItemRange: function () {
   var itemElements = this.listBox.GetItemElements();
   return {
    startIndex: itemElements.length > 0 ? this.GetFirstRenderedItem().index : -1,
    endIndex: itemElements.length > 0 ? this.GetLastRenderedItem().index : -1
   };
  },
  RemoveItemCore: function(index) {
   ASPx.ListBoxItemsVirtualManager.prototype.RemoveItemCore.call(this, index);
   this.listBox.DropCachedItemElements();
  },
  CreateNewItemRow: function(index) {
   var newItemElement = this.listBox.CreateNewItem();
   newItemElement.itemIndex = index;
   return newItemElement;
  },
  ClearItemsCore: function() {
   var itemElements = this.listBox.GetItemElements();
   for(var i = itemElements.length - 1; i >= 0; i--)
    ASPx.RemoveElement(itemElements[i]);
  },
  SetItemBadgeText: function(index, text) { 
   var item = this.deserializedItems[index];
   if(item) {
    if(!item.badge)
     item.badge = { text: text };
    else
     item.badge.text = text;
   }
  },
  SetItemBadgeIconCssClass: function(index, cssClass) { 
   var item = this.deserializedItems[index];
   if(item) {
    if(!item.badge)
     item.badge = { iconCssClass: cssClass };
    else
     item.badge.iconCssClass = cssClass;
   }
  },
  RecreateItemRowsByVisibleIndices: function (newVisibleIndices, keepTopSpacerHeight) {
   ASPx.ListBoxItemsVirtualManager.prototype.RecreateItemRowsByVisibleIndices.call(this, newVisibleIndices, keepTopSpacerHeight);
   this.listBox.listBoxRenderHelper.UpdateVisibleItemsLastRowCssClass();
  }
 });
 var BootstrapListBoxScrollCallbackHelper = ASPx.CreateClass(ASPx.ListBoxScrollCallbackHelper, {
  constructor: function(listBoxControl) {
   this.constructor.prototype.constructor.call(this, listBoxControl);
  },
  GetListHeight: function () {
   var itemElements = this.listBoxControl.GetItemElements();
   var listHeight = 0;
   for(var i = 0; i < itemElements.length; i++)
    listHeight += itemElements[i].clientHeight;
   return listHeight;
  }
 });
 var BootstrapListBoxRenderHelper = ASPx.CreateClass(null, {
  constructor: function(listBox) {
   this.listBox = listBox;
  },
  GetListElement: function() { return null; },
  GetItemsContainer: function() { return null; },
  GetRowElements: function() { return null; },
  GetScrollDivElement: function() { return null; },
  GetItemSelectableElementsByRow: function(row) { return null; },
  CreateNewItemElement: function() { return null; },
  CreateNewItemCheckBoxContainer: function() { return null; },
  GetListTableHeight: function() { return 0; },
  GetRowsExtraHeight: function() { return 0; },
  AddItemContent: function(itemElement, itemProperties) { },
  AddItemStateItems: function(name) { },
  UpdateVisibleItemsLastRowCssClass: function() { },
  SetItemTabIndexAttribute: function(item) { },
  ReplaceItemHtmlContent: function (itemRow, html) { },
  SetItemHtmlContent: function (itemRow, html) { },
  CreateItemWithHtmlContent: function (newItemElement, itemProperties) { },
  UpdateItemStateAfterSetHtml: function (index) { },
  GetItemTextCell: function (itemIndex, textCellIndex) { return null; },
  SetItemTextCellHtml: function (itemIndex, textCellIndex, html) { },
  GetItemTextGivenContents: function (itemProperties) { return ""; },
  GetItemCellsIdPostfixes: function () { return []; },
  GetRowElementsCore: function(itemTagName) {
   var itemsContainer = this.GetItemsContainer();
   return itemsContainer ? ASPx.GetChildNodesByQuerySelector(itemsContainer, itemTagName + ":not(.separator):not(." + DIVIDER_ITEM_CLASS + "):not([data-type='spacer'])") : [];
  },
  GetItemHtmlContent: function(text) {
   text = this.listBox.FormatText(text);
   if(!ASPx.IsExists(text))
    text = "";
   if(this.listBox.encodeHtml)
    text = ASPx.Str.EncodeHtml(text);
   return this.listBox.ProtectWhitespaceSerieses(text);
  },
  CreateNewItemCheckBoxContainerCore: function(containerTagName, containerCssClass) {
   var checkBoxContainer = document.createElement(containerTagName);
   if(containerCssClass)
    ASPx.SetClassName(checkBoxContainer, containerCssClass);
   var checkBoxInput = document.createElement("INPUT");
   checkBoxInput.type = "checkbox";
   if(ITEM_CHECKBOX_INPUT_CLASS)
    ASPx.SetClassName(checkBoxInput, ITEM_CHECKBOX_INPUT_CLASS);
   checkBoxContainer.appendChild(checkBoxInput);
   return checkBoxContainer;
  }
 });
 var BootstrapListBoxListRenderHelper = ASPx.CreateClass(BootstrapListBoxRenderHelper, {
  constructor: function(listBox) {
   this.constructor.prototype.constructor.call(this, listBox);
  },
  GetListElement: function() {
   var mainElement = this.listBox.GetMainElement();
   return mainElement && mainElement.querySelector("UL") || null;
  },
  GetItemsContainer: function() { return this.GetListElement(); },
  GetRowElements: function() { return this.GetRowElementsCore("li"); },
  GetScrollDivElement: function() { return this.GetListElement(); },
  CreateNewItemElement: function() {
   return document.createElement("LI");
  },
  AddItemContent: function(itemElement, itemProperties) {
   var htmlContent = this.GetItemTextGivenContents(itemProperties);
   var internalElement = document.createElement(this.listBox.GetItemInternalElementTagName());
   itemElement.appendChild(internalElement);
   var textElement = document.createElement("SPAN");
   ASPx.Security.setInnerHtml(textElement, htmlContent, ASPx.Security.DataType.Trusted);
   var checkBoxLabel = null;
   if(this.listBox.GetIsCheckColumnExists()) {
    if(ASPx.BootstrapCore.IsBootstrap3) {
     ASPx.SetClassName(internalElement, this.listBox.GetItemCheckBoxClassName());
     checkBoxLabel = this.CreateNewItemCheckBoxContainer();
     internalElement.appendChild(checkBoxLabel);
    } else {
     ASPx.SetClassName(internalElement, ITEM_CLASS);
     var formCheckElement = document.createElement("div");
     ASPx.SetClassName(formCheckElement, CHECKBOX_CONTAINER_CLASS);
     internalElement.appendChild(formCheckElement);
     var checkBoxInput = document.createElement("INPUT");
     checkBoxInput.type = "checkbox";
     ASPx.SetClassName(checkBoxInput, ITEM_CHECKBOX_INPUT_CLASS);
     formCheckElement.appendChild(checkBoxInput);
     checkBoxLabel = document.createElement("LABEL");
     ASPx.SetClassName(checkBoxLabel, ITEM_CHECKBOX_LABEL_CLASS);
     formCheckElement.appendChild(checkBoxLabel);
    }
    checkBoxLabel.appendChild(textElement);
   }
   else {
    var linkCssClasses = [];
    if(!this.listBox.IsDropDown())
     linkCssClasses.push(ITEM_LINK_CLASS);
    else if(DROPDOWN_ITEM_LINK_CLASS)
     linkCssClasses.push(DROPDOWN_ITEM_LINK_CLASS);
    if(this.cssClasses && this.listBox.cssClasses.lbi)
     linkCssClasses.push(this.listBox.cssClasses.lbi);
    if(linkCssClasses.length)
     ASPx.SetClassName(internalElement, linkCssClasses.join(" "));
    internalElement.appendChild(textElement);
   }
   if(itemProperties) {
    if(this.listBox.isComboBoxList && this.listBox.IsMultiColumn()) {
     var needTextsDataAttribute = this.listBox.ownerControl && this.listBox.ownerControl.displayFormat != null
      || itemProperties.texts.join("; ") != this.listBox.FormatText(itemProperties.texts);
     if(needTextsDataAttribute)
      this.listBox.SetTextsDataAttribute(itemElement, itemProperties.texts);
    }
    this.listBox.PrepareItem(checkBoxLabel || internalElement, itemProperties);
    var badgeInfo = itemProperties.badge;
    if(badgeInfo) {
     var badge = ASPx.BootstrapBadgeManager.createBadge(badgeInfo.text, badgeInfo.iconCssClass);
     if(badgeInfo.cssClass && badgeInfo.cssClass.length)
      ASPx.AddClassNameToElement(badge, badgeInfo.cssClass);
     internalElement.appendChild(badge);
    }
   }
  },
  AddItemStateItems: function(name) {
   var itemCellsIdSuffixes = this.GetItemCellsIdPostfixes();
   var controller = ASPx.GetStateController();
   controller.AddSelectedItem(name, [SELECTED_CLASS], this.listBox.selectedCssArray, itemCellsIdSuffixes, null, null, true);
   controller.AddDisabledItem(name, [DISABLED_CLASS], this.listBox.disabledCssArray, itemCellsIdSuffixes, null, null, true);
  },
  GetItemCellsIdPostfixes: function() {
   var idPostfixes = [];
   var firstRenderedItem = this.listBox.itemsManager.GetFirstRenderedItem();
   var hasItemTemplate = firstRenderedItem ? this.listBox.ItemRowHasTemplate(firstRenderedItem.index) : false;
   var isBootstrap3DropDownMenuItem = !this.listBox.IsStandAlone() && ASPx.BootstrapCore.IsBootstrap3;
   var hasCheckColumn = this.listBox.GetIsCheckColumnExists();
   if(hasCheckColumn)
    idPostfixes.push(lbICdSuffix);
   else {
    if(hasItemTemplate || isBootstrap3DropDownMenuItem)
     idPostfixes.push('');
    if(!hasItemTemplate)
     idPostfixes.push(lbILdSuffix);
   }
   return idPostfixes;
  },
  CreateNewItemCheckBoxContainer: function() {
   return this.CreateNewItemCheckBoxContainerCore("LABEL", ITEM_CHECKBOX_LABEL_CLASS);
  },
  GetItemSelectableElementsByRow: function(row) {
   return ASPx.GetChildElementNodesByPredicate(this.listBox.GetItemContentElement(row),
    function(child) { return !ASPx.ElementContainsCssClass(child, ITEM_BADGE_CLASS); });
  },
  GetListTableHeight: function() {
   var result = 0;
   var itemElements = this.listBox.GetItemElements();
   for (var i = 0; i < itemElements.length; i++)
    result += itemElements[i].offsetHeight + ASPx.GetTopBottomMargins(itemElements[i]);
   result += ASPx.GetTopBottomBordersAndPaddingsSummaryValue(this.listBox.GetListTable());
   return result;
  },
  CreateItemWithHtmlContent: function (newItemElement, itemProperties) {
   if (this.listBox.GetIsCheckColumnExists()) {
    var internalElement = document.createElement(this.listBox.GetItemInternalElementTagName());
    ASPx.SetClassName(internalElement, this.listBox.GetItemCheckBoxClassName());
    newItemElement.appendChild(internalElement);
    ASPx.Security.setInnerHtml(internalElement, itemProperties.htmlContent, ASPx.Security.DataType.Trusted);
    var checkBoxLabel = this.CreateNewItemCheckBoxContainer();
    checkBoxLabel.innerHTML += "&nbsp;";
    internalElement.insertBefore(checkBoxLabel, internalElement.childNodes[0]);
    this.listBox.EnsureStartupScriptsInContainer(internalElement);
   }
   else
    this.ReplaceItemHtmlContent(newItemElement, itemProperties.htmlContent);
   this.listBox.SetTextsDataAttribute(newItemElement, itemProperties.texts);
   ASPx.AddClassNameToElement(newItemElement, TEMPLATED_ROW_CLASS);
  },
  ReplaceItemHtmlContent: function (itemRow, html) {
   if (this.listBox.IsDropDown())
    ASPx.AddClassNameToElement(itemRow, DROPDOWN_ITEM_LINK_CLASS);
   else
    ASPx.AddClassNameToElement(itemRow, ITEM_CLASS);
   ASPx.Security.setInnerHtml(itemRow, html, ASPx.Security.DataType.Trusted);
   this.listBox.EnsureStartupScriptsInContainer(itemRow);
  },
  SetItemHtmlContent: function (itemRow, html) {
   if (this.listBox.GetIsCheckColumnExists()) {
    var checkboxContainer = ASPx.GetChildByPartialClassName(itemRow, CHECKBOX_CONTAINER_CLASS);
    var checkboxLabel = ASPx.GetChildByTagName(checkboxContainer, "LABEL", 0);
    var checkboxInput = checkboxLabel.querySelector('input[type="checkbox"]');
    while (checkboxInput.nextSibling)
     checkboxLabel.removeChild(checkboxInput.nextSibling);
    checkboxLabel.innerHTML += "&nbsp;";
    while (checkboxLabel.nextSibling)
     checkboxContainer.removeChild(checkboxLabel.nextSibling);
    checkboxContainer.innerHTML += html;
    this.listBox.EnsureStartupScriptsInContainer(checkboxContainer);
   }
   else
    this.ReplaceItemHtmlContent(itemRow, html);
  },
  UpdateItemStateAfterSetHtml: function (index) {
   var itemRow = this.listBox.GetItemRow(index);
   ASPx.AddClassNameToElement(itemRow, TEMPLATED_ROW_CLASS);
   var controller = ASPx.GetStateController();
   controller.AddSelectedItem(itemRow.id, [SELECTED_CLASS], this.listBox.selectedCssArray, null, null, null, true);
  },
  GetItemTextCell: function (itemIndex, textCellIndex) {
   return this.listBox.GetItemFirstTextCell(itemIndex);
  },
  SetItemTextCellHtml: function (itemIndex, textCellIndex, html) {
   this.listBox.hasDecoratedItems = true;
   this.listBox.itemsManager.SetItemTextCellHtml(itemIndex, textCellIndex, html);
   var itemText = this.GetItemTextGivenContents(this.listBox.itemsManager.deserializedItems[itemIndex]);
   this.listBox.ProcessItemTextCell(itemIndex, textCellIndex, function (textCell) {
    var itemTexts = this.listBox.GetItem(itemIndex).texts;
    var itemRow = ASPx.GetParentByTagName(textCell, "LI");
    if (this.listBox.GetIsCheckColumnExists() && textCell == itemRow)
     this.listBox.SetItemHtmlContent(itemRow, itemText);
    else {
     ASPx.Security.setInnerHtml(textCell, itemText, ASPx.Security.DataType.Trusted);
     this.listBox.EnsureStartupScriptsInContainer(textCell);
    }
    if (!this.listBox.ItemRowHasSerializedTextsAttr(itemRow)) {
     if (typeof (itemTexts) == "string")
      itemTexts = [itemTexts];
     this.listBox.SetTextsDataAttribute(itemRow, itemTexts);
    }
    ASPx.AddClassNameToElement(itemRow, TEMPLATED_ROW_CLASS);
    this.listBox.itemsManager.OnDecoratedItemsRendering();
   }.aspxBind(this));
  },
  GetItemTextGivenContents: function (itemProperties) {
   var texts = itemProperties.texts;
   if (itemProperties.htmlContents)
    for (var i = 0; i < itemProperties.htmlContents.length; i++) {
     var index = itemProperties.htmlContents[i].index;
     texts[index] = itemProperties.htmlContents[i].value;
    }
   return this.GetItemHtmlContent(texts);
  }
 });
 var BootstrapListBoxTableRenderHelper = ASPx.CreateClass(BootstrapListBoxRenderHelper, {
  constructor: function(listBox) {
   this.constructor.prototype.constructor.call(this, listBox);
  },
  GetListElement: function() { return this.listBox.GetChildElement(CONTENT_TABLE_ID_SUFFIX); },
  GetItemsContainer: function() {
   var listElement = this.GetListElement();
   return listElement && listElement.querySelector("tbody");
  },
  GetRowElements: function() { return this.GetRowElementsCore("tr"); },
  GetScrollDivElement: function() {
   var listElement = this.GetListElement();
   return listElement && listElement.parentNode || null;
  },
  CreateNewItemElement: function() {
   var cellsCount = this.listBox.columnFieldNames.length;
   if(this.listBox.GetIsCheckColumnExists())
    cellsCount++;
   var tableRow = document.createElement("TR");
   for (var i = 0; i < cellsCount; i++) {
    var tableCell = document.createElement('TD');
    tableRow.appendChild(tableCell);
   }
   return tableRow;
  },
  AddItemContent: function(itemElement, itemProperties) {
   if(this.listBox.GetIsCheckColumnExists()) {
    checkBoxContainer = this.CreateNewItemCheckBoxContainer();
    var checkCol = itemElement.cells[0];
    ASPx.SetClassName(checkCol, CHECKBOX_COL_CLASS);
    checkCol.appendChild(checkBoxContainer);
   }
   var fieldsCount = this.listBox.columnFieldNames.length || 1;
   for(var i = 0; i < fieldsCount; i++){
    var cellIndex = this.GetCellIndex(i);
    var htmlContent = this.listBox.GetCellInfo(i, itemProperties.htmlContents);
    var text = htmlContent ? htmlContent : this.GetItemHtmlContent(itemProperties.texts[i]);
    ASPx.Security.setInnerHtml(itemElement.cells[cellIndex], text, ASPx.Security.DataType.Trusted);
   }
  },
  AddItemStateItems: function(name) {
   var controller = ASPx.GetStateController();
   var selectedClass = TABLE_ROW_SELECTED_CLASS;
   if(this.listBox.GetIsCheckColumnExists())
    selectedClass += " " + TABLE_ROW_WITH_CHECK_CLASS;
   controller.AddSelectedItem(name, [selectedClass], this.listBox.selectedCssArray, null, null, null, true);
  },
  CreateNewItemCheckBoxContainer: function() {
   if(!ASPx.BootstrapCore.IsBootstrap3)
    return this.CreateNewItemCheckBoxContainerCore("DIV", CHECKBOX_CONTAINER_CLASS);
   var divContainer = document.createElement("DIV");
   ASPx.SetClassName(divContainer, CHECKBOX_CONTAINER_CLASS);
   divContainer.appendChild(this.CreateNewItemCheckBoxContainerCore("LABEL", ""));
   return divContainer;
  },
  GetCellIndex: function(itemIndex) {
   if(this.listBox.GetIsCheckColumnExists())
    return itemIndex + 1;
   return itemIndex;
  },
  GetItemSelectableElementsByRow: function(row) {
   return row.cells;
  },
  UpdateVisibleItemsLastRowCssClass: function () {
   if (this.listBox.IsStandAlone())
    return;
   var visibleItems = this.listBox.GetItemElements();
   if (!visibleItems.length)
    return;
   var lastVisibleItemIndex = visibleItems.length - 1;
   if (lastVisibleItemIndex > 0) {
    for (var i = 0; i < lastVisibleItemIndex; i++) {
     ASPx.RemoveClassNameFromElement(visibleItems[i], LAST_ROW_CLASS);
    }
   }
   ASPx.AddClassNameToElement(visibleItems[lastVisibleItemIndex], LAST_ROW_CLASS);
  },
  SetItemTabIndexAttribute: function(item) {
   if(this.listBox.IsStandAlone() && !this.listBox.GetIsCheckColumnExists())
    ASPx.Attr.SetAttribute(item, "tabindex", 0);
  },
  GetListTableHeight: function() {
   return this.listBox.GetListTable().offsetHeight;
  },
  GetRowsExtraHeight: function() { return 1; },
  SetItemHtmlContent: function (itemRow, html) {
   var redundantCells = ASPx.Data.CollectionToArray(itemRow.cells)
    .slice(this.listBox.GetItemFirstTextCellIndex(), itemRow.cells.length - 1);
   redundantCells.forEach(function (cell) { itemRow.removeChild(cell); });
   var itemHtmlContainerCell = itemRow.cells[itemRow.cells.length - 1];
   var headerCellsCount = this.listBox.GetHeaderTableElement().rows[0].cells.length;
   var visibleDataColumnCount = this.listBox.GetIsCheckColumnExists() ? headerCellsCount - 1 : headerCellsCount;
   itemHtmlContainerCell.colSpan = visibleDataColumnCount;
   ASPx.Security.setInnerHtml(itemHtmlContainerCell, html, ASPx.Security.DataType.Trusted);
  },
  CreateItemWithHtmlContent: function (newItemElement, itemProperties) {
   if (this.listBox.GetIsCheckColumnExists()) {
    checkBoxContainer = this.CreateNewItemCheckBoxContainer();
    var checkCol = newItemElement.cells[0];
    ASPx.SetClassName(checkCol, CHECKBOX_COL_CLASS);
    checkCol.appendChild(checkBoxContainer);
   }
   this.SetItemHtmlContent(newItemElement, itemProperties.htmlContent);
   this.listBox.SetTextsDataAttribute(newItemElement, itemProperties.texts);
  },
  GetItemTextCell: function (itemIndex, textCellIndex) {
   var rowElement = this.listBox.GetItemRow(itemIndex);
   if (rowElement == null)
    return null;
   return rowElement.cells[this.listBox.GetItemFirstTextCellIndex() + textCellIndex];
  },
  GetItemCellsIdPostfixes: function() {
   return [""];
  },
  SetItemTextCellHtml: function (itemIndex, textCellIndex, html) {
   this.listBox.hasDecoratedItems = true;
   this.listBox.itemsManager.SetItemTextCellHtml(itemIndex, textCellIndex, html);
   this.listBox.ProcessItemTextCell(itemIndex, textCellIndex, function (textCell) {
    if (!this.listBox.ItemCellHasTextAttr(textCell))
     this.listBox.SetItemCellTextDataAttribute(textCell, this.listBox.GetItem(itemIndex).texts[textCellIndex]);
    this.listBox.SetItemTextCellHtmlContent(textCell, html);
    this.listBox.itemsManager.OnDecoratedItemsRendering();
   }.aspxBind(this));
  }
 });
 var BootstrapClientListBox = ASPx.CreateClass(ASPxClientListBox, {
  constructor: function(name) {
   this.constructor.prototype.constructor.call(this, name);
   this.heightInitialized = false;
   this.isSyncEnabled = false;
   this.itemClickHandler = function(evt) {
    if(ASPx.Evt.IsLeftButtonPressed(evt) || !this.isComboBoxList)
     return this.OnListBoxItemClick(evt);
   }.bind(this);
   this.itemKeyUpHandler = function(evt) {
    if(evt.keyCode === ASPx.Key.Enter)
     return this.OnListBoxItemClick(evt);
   }.bind(this);
   this.itemDblClickHandler = function() { this.OnItemDblClick(); }.bind(this);
   this.feedbackRenderHelper = new ASPx.BootstrapEditFeedbackRenderHelper(this);
   this.listBoxRenderHelper = this.IsEnableMultiColumn() ? new BootstrapListBoxTableRenderHelper(this) : new BootstrapListBoxListRenderHelper(this);
   if(ASPx.Browser.TouchUI && !this.GetIsValid())
    this.UpdateErrorText();
  },
  CreateHighlightingHelper: function() {
   return new ASPx.BootstrapListBoxHighlightingHelper(this, "mark");
  },
  OnListBoxItemClick: function(evt) {
   return this.OnItemClick(this.GetItemIndexByElement(ASPx.Evt.GetEventSource(evt)), evt);
  },
  InlineInitialize: function() {
   this.CreateValueInput();
   var itemsContainer = this.listBoxRenderHelper.GetItemsContainer();
   if(this.isCallbackMode && this.GetEnabled()) {
    var topSpacerElement = this.listBoxRenderHelper.CreateNewItemElement();
    topSpacerElement.setAttribute("id", this.name + "_TS");
    topSpacerElement.setAttribute("data-type", "spacer");
    itemsContainer.insertBefore(topSpacerElement, itemsContainer.childNodes[0]);
    var bottomSpacerElement = this.listBoxRenderHelper.CreateNewItemElement();
    bottomSpacerElement.setAttribute("id", this.name + "_BS");
    bottomSpacerElement.setAttribute("data-type", "spacer");
    itemsContainer.appendChild(bottomSpacerElement);
   }
   var isStandAlone = this.IsStandAlone();
   this.needFocusedStyleDecoration = isStandAlone && this.enableFiltering;
   if(isStandAlone)
    this.RequireStyleDecoration();
   ASPxClientListBox.prototype.InlineInitialize.call(this);
  },
  CreateValueInput: function(){
   var input = ASPx.CreateHiddenField(this.uniqueID, this.name + "_VI");
   var listElement = this.GetListElement();
   var captionElement = this.GetCaptionCell();
   listElement.parentNode.insertBefore(input, (captionElement && captionElement === listElement.nextSibling 
    ? captionElement : listElement).nextSibling);
  },
  CreateItemsManager: function() {
   if(this.HasVirtualScrolling()) {
    var manager = new BootstrapListBoxItemsVirtualManager(this);
    manager.InitializeItems(this.itemsInfo, this.itemsValue);
    delete this.itemsInfo;
    return manager;
   }
   return new BootstrapListBoxItemsManager(this);
  },
  EnsureSelectAllCheckElement: function() {
   this.CreateSelectAllCheckBox();
   var selectAllCheckBoxInput = this.GetSelectAllCheckBoxFocusableElement();
   var changeEventMethod = ASPx.Attr.ChangeEventsMethod(this.GetEnabled());
   this.ChangeSpecialInputEnabledAttributes(selectAllCheckBoxInput, changeEventMethod, true);
  },
  CreateSelectAllCheckBox: function() {
   var selectAllCheckBoxElement = this.GetChildElement(lbSelectAllCbIdSuffix);
   this.selectAllCheckBox = new ASPx.BootstrapCheckBoxInternal(selectAllCheckBoxElement, true, false, true, this.uniqueID + "$" + lbSelectAllCbIdSuffix);
   this.selectAllCheckBox.mainInput.id = selectAllCheckBoxElement.id + "_I";
   if(!ASPx.BootstrapCore.IsBootstrap3)
    this.selectAllCheckBox.initializeSiblingLabelElement();
   this.selectAllCheckBox.SetEnabled(this.GetEnabled());
   this.selectAllCheckBox.GetReadOnly = this.GetReadOnly.bind(this);
   this.selectAllCheckBox.CheckedChanged.AddHandler(this.onSelectAll.aspxBind(this));
   if(ASPx.Browser.WebKitFamily)
    ASPx.Evt.AttachEventToElement(this.selectAllCheckBox.mainElement.parentNode, "selectstart", ASPx.Evt.PreventEventAndBubble);
  },
  CreateScrollHelper: function (loadOnDemandRequired) {
   if(loadOnDemandRequired)
    return new BootstrapListBoxScrollCallbackHelper(this);
   return ASPxClientListBox.prototype.CreateScrollHelper.call(this, loadOnDemandRequired);
  },
  GetSelectAllClickableElement: function() {
   return this.selectAllMainElement;
  },
  GetSelectAllCheckBoxFocusableElement: function() {
   return this.selectAllCheckBox.mainInput;
  },
  InitializeEvents: function() {
   ASPxClientListBox.prototype.InitializeEvents.call(this);
   if(ASPx.Browser.MacOSMobilePlatform) {
    var errorImage = this.GetErrorImage();
    if(errorImage)
     ASPx.Evt.AttachEventToElement(errorImage, "touchstart", function() { });
   }
  },
  BeforeAdjustHeightInDropDown: function () { },
  NeedUnfocusableScrollDivElement: function() {
   return false;
  },
  NeedToHandleCellWidth: function() {
   return false;
  },
  PopulateStyleDecorationPostfixes: function() {
   this.styleDecoration.AddPostfix("");
   if(ASPx.BootstrapCore.IsBootstrap4)
    this.styleDecoration.AddPostfix(".form-control");
  },
  CreateStyleDecoration: function() {
   return new ASPx.BootstrapEditorStyleDecoration(this);
  },
  ChangeListTableEvents: function(listTable, method) {
   var itemElements = this.GetItemElements();
   for(var i = 0; i < itemElements.length; i++)
    this.ChangeItemEvents(itemElements[i], method);
  },
  ChangeItemEvents: function(itemElement, method) {
   method(itemElement, this.isComboBoxList ? "mouseup" : "click", this.itemClickHandler);
   method(itemElement, "keyup", this.itemKeyUpHandler);
   if(!this.isComboBoxList) {
    method(itemElement, "dblclick", this.itemDblClickHandler);
    var textControl = ASPx.GetTextNode(itemElement, 0);
    if(textControl) {
     if(ASPx.Browser.IE)
      ASPx.Evt.AttachEventToElement(textControl, "mouseup", ASPx.Selection.Clear);
     ASPx.Evt.PreventElementDragAndSelect(textControl, false);
    }
   }
   if(this.MultiSelectionMode()) {
    this.AttachSelectStartHandlerToElement(itemElement);
    var link = ASPx.GetChildByTagName(itemElement, "A");
    if(link) {
     ASPx.Evt.AttachEventToElement(link,
      "click", function(evt) {
       var shiftPressed = evt.shiftKey;
       var ctrlKey = evt.ctrlKey || evt.metaKey;
       if(shiftPressed || ctrlKey)
        ASPx.Evt.PreventEvent(evt);
      });
    }
   }
   if(this.GetIsCheckColumnExists()) {
    var labelElement = this.GetItemContentElement(itemElement);
    if(labelElement) {
     ASPx.Evt.AttachEventToElement(labelElement,
      "click", function(evt) {
       if(ASPx.Evt.GetEventSource(evt).type !== "checkbox")
        return ASPx.Evt.PreventEvent(evt);
      });
    }
   }
  },
  ChangeEnabledAttributes: function(enabled){
   ASPxClientListBox.prototype.ChangeEnabledAttributes.call(this, enabled);
   if(!this.isComboBoxList) {
    var changeMethod = enabled ? ASPx.Attr.RestoreTabIndexAttribute : ASPx.Attr.SaveTabIndexAttributeAndReset;
    changeMethod(this.GetListElement());
   }
  },
  GetLoadingPanelElement: function(){
   return ASPx.BootstrapLoadingPanelManager.getLoadingPanel(this.name, this.loadingPanel);
  },
  GetLoadingDiv: function(){
   return ASPx.BootstrapLoadingPanelManager.getLoadingDiv(this.name, this.loadingPanel);
  },
  FindInputElement: function() {
   if(this.isComboBoxList)
    return  ASPxClientListBox.prototype.FindInputElement.call(this);
   if(ASPx.ElementHasCssClass(this.GetMainElement(), BSLISTBOX_CLASS))
    return this.GetMainElement();
   return this.GetMainElement().querySelector("." + BSLISTBOX_CLASS);
  },
  GetControlCell: function() {
   return this.GetListElement();
  },
  EnsureControlCellStylesLoaded: function() { },
  ClearControlCellStyles: function() { },
  RestoreControlCellStyles: function() { },
  GetElementRequiredForErrorFrame: function() {
   return this.GetMainElement();
  },
  GetErrorImage: function() {
   return this.feedbackRenderHelper.getErrorImage();
  },
  UpdateErrorText: function() {
   this.feedbackRenderHelper.updateErrorText();
  },
  ChangeErrorCellVisibility: function(visible, useVisibilityAttribute) {
   this.feedbackRenderHelper.setErrorControlVisible(visible);
  },
  AdjustControlCore: function() {
   this.RemoveShowHideFilterCssRules();
   if(this.isInitialized && this.heightInitialized)
    this.CorrectSize();
   else
    this.InitializeHeight();
   this.itemsManager.Adjust();
   this.EnsureSelectedItemVisible();
   this.AdjustFilterElements();
  },
  AdjustFilterElements: function() {
   if(this.showFilterButton) {
    this.UpdateFilterButtonHeight();
    this.UpdateShowHideFilterElementCssRules();
   }
  },
  IsVisible: function() {
   return this.isComboBoxList ? this.IsMainElementVisible() : ASPxClientListBox.prototype.IsVisible.call(this);
  },
  IsDisplayedElement: function(element) {
   while(element && element.tagName != "BODY") {
    if(!ASPx.GetElementDisplay(element)) {
     if(ASPx.ElementHasCssClass(element, ASPx.BootstrapCssSelectors.DropDownMenu) && !ASPx.ElementHasCssClass(element, "show"))
      return false;
    }
    element = element.parentNode;
   }
   return true;
  },
  IsEnableMultiColumn: function () {
   var mainElement = this.GetMainElement();
   return !mainElement.querySelector("UL");
  },
  IsMainElementVisible: function() {
   var element = this.GetMainElement();
   return element && ASPx.IsElementVisible(element, true);
  },
  IsCorrectWidthRequired: function () {
   return this.IsEnableMultiColumn();
  },
  CorrectHeight: function() {
   if(this.IsMainElementVisible() && this.IsStandAlone()) {
    var visibleRowElements = this.GetVisibleRowElements();
    var visibleRows = visibleRowElements.length;
    var listElement = this.GetListElement();
    if(this.rows) {
     var defaultRowHeight = this.itemsManager.GetDefaultItemHeight();
     var rowsHeight = 0;
     if(visibleRows) {
      var lastRow = visibleRowElements[this.rows - 1];
      if(lastRow) {
       var itemCurrentStyle = ASPx.GetCurrentStyle(lastRow);
       rowsHeight = (this.GetElementTopOffset(lastRow) - this.GetTopSpacersHeight()) + lastRow.offsetHeight + ASPx.PxToInt(itemCurrentStyle.marginBottom);
       var listCurrentStyle = ASPx.GetCurrentStyle(listElement);
       if(listCurrentStyle.borderBottomStyle != "none")
        rowsHeight += ASPx.PxToFloat(listCurrentStyle.borderBottomWidth);
      }
      else if(!this.heightInitialized)
       rowsHeight = (defaultRowHeight == 0 ? (this.GetListTableHeight() / visibleRows) : defaultRowHeight) * this.rows;
     }
     else if(defaultRowHeight)
      rowsHeight = defaultRowHeight * this.rows + ASPx.GetTopBottomBordersAndPaddingsSummaryValue(listElement);
     else if(!this.heightInitialized) {
      var sampleItem = this.CreateNewItem();
      this.CreateNewItemInternalElement(sampleItem, "&nbsp;");
      if(sampleItem) {
       listElement.insertBefore(sampleItem, listElement.childNodes[0]);
       rowsHeight = (sampleItem.offsetHeight + ASPx.GetTopBottomMargins(sampleItem)) * this.rows +
        ASPx.GetTopBottomBordersAndPaddingsSummaryValue(listElement);
       listElement.removeChild(sampleItem);
      }
     }
     if(rowsHeight) {
      var scrollElement = this.listBoxRenderHelper.GetScrollDivElement();
      rowsHeight = (rowsHeight + this.listBoxRenderHelper.GetRowsExtraHeight()) + "px";
      if(scrollElement.style.height != rowsHeight)
       scrollElement.style.height = rowsHeight;
     }
    }
   }
  },
  InitializeHeight: function() {
   if(this.heightInitialized)
    return;
   var itemsContainer = this.listBoxRenderHelper.GetItemsContainer();
   var hiddenParents = [];
   var needVisibleListElement = this.IsStandAlone();
   if(needVisibleListElement) {
    var element = itemsContainer;
    var testParentFunc = function(parent) { return !ASPx.GetElementDisplay(parent); };
    while(element && element.tagName != "BODY") {
     var hiddenParentElement = ASPx.GetParent(element, testParentFunc);
     if(hiddenParentElement)
      hiddenParents.push({ element: hiddenParentElement, display: hiddenParentElement.style.display });
     element = !!hiddenParentElement ? hiddenParentElement.parentNode : null;
    }
    hiddenParents.forEach(function(hiddenParent) {
     var element = hiddenParent.element;
     if(hiddenParent.display.length)
      ASPx.SetElementDisplay(element, "");
     element.style.cssText = ASPx.CreateImportantCssText("display: block") + element.style.cssText;
    });
   }
   this.CorrectHeight();
   var hiddenRows = ASPx.GetChildNodesByClassName(itemsContainer, HIDDEN_ROW_CLASS);
   hiddenRows.forEach(function(row) { ASPx.RemoveClassNameFromElement(row, HIDDEN_ROW_CLASS); });
   var extraRows = ASPx.GetChildNodesByClassName(itemsContainer, EXTRA_ROW_CLASS);
   extraRows.forEach(function(extraRow) { itemsContainer.removeChild(extraRow); });
   if(hiddenParents.length) {
    this.EnsureSelectedItemVisible();
    hiddenParents.forEach(function(hiddenParent) {
     if(hiddenParent.display.length)
      ASPx.SetElementDisplay(hiddenParent.element, "");
     ASPx.SetElementDisplay(hiddenParent.element, hiddenParent.display);
    });
   }
   this.heightInitialized = true;
  },
  InitializeItemsAttributes: function() {
   var itemElements = this.GetItemElements();
   for(var i = 0; i < itemElements.length; i++)
    this.InitializeItemAttributes(itemElements[i], i);
  },
  InitializeItemAttributes: function(item, index) {
   item.id = this.CreateItemClientId(index);
   var link = ASPx.GetChildByTagName(item, "A");
   if(link != null) {
    link.id = item.id + lbILdSuffix;
    if(link.href === "")
     link.href = ASPx.AccessibilityEmptyUrl;
   }
   if(this.GetIsCheckColumnExists()) {
    var checkboxContainerClass = this.IsEnableMultiColumn() ? CHECKBOX_CONTAINER_CLASS : ITEM_CLASS;
    var checkboxContainer = ASPx.NodeListToArray(item.querySelectorAll('div'),
     function(element) {return ASPx.ElementHasCssClass(element, checkboxContainerClass);}
    )[0];
    if(checkboxContainer)
     checkboxContainer.id = item.id + lbICdSuffix;
    var input = checkboxContainer.querySelector('input[type="checkbox"]');
    this.ChangeNativeCheckEnabledAttributes(input, ASPx.Attr.ChangeEventsMethod(this.GetEnabled()));
    this.ChangeSpecialInputEnabledAttributes(input, ASPx.Attr.ChangeEventsMethod(this.GetEnabled()));
   }
   this.listBoxRenderHelper.SetItemTabIndexAttribute(item);
  },
  InitializePageSize: function() {
   var divElement = this.GetScrollDivElement();
   var items = this.GetItemElements();
   if(divElement && items.length > 0)
    this.scrollPageSize = Math.round(divElement.clientHeight / items[0].offsetHeight) - 1;
  },
  SetProtectionFromFlick_inFF: function(changeVisibility, changeDisplay) {  },
  ResetProtectionFromFlick_inFF: function() {  },
  CreateItem: function(index, itemProperties) {
   return new BootstrapClientListBoxItem(this, index, itemProperties.texts || [itemProperties.text], itemProperties.value, itemProperties.imageUrl,
    itemProperties.selected, itemProperties.cellStyles, itemProperties.cellCssClasses, itemProperties.cellTooltips, itemProperties.cellAttributes, itemProperties.htmlContents,
    itemProperties.style, itemProperties.cssClass, itemProperties.tooltip, itemProperties.attributes, itemProperties.htmlContent, itemProperties.badge);
  },
  CreateNewItem: function() {
   var itemElement = this.CreateNewItemElement();
   var cssClasses = [];
   if(this.cssClasses && this.cssClasses.lbi)
    cssClasses.push(this.cssClasses.lbi);
   if(cssClasses.length)
    ASPx.SetClassName(itemElement, cssClasses.join(" "));
   return itemElement;
  },
  CreateNewItemElement: function() {
   return this.listBoxRenderHelper.CreateNewItemElement();
  },
  CreateNewItemInternalElement: function(itemElement, itemProperties) {
   this.listBoxRenderHelper.AddItemContent(itemElement, itemProperties);
  },
  GetItemRowTexts: function(row) {
   var serializedTexts = this.GetTextsDataAttribute(row);
   var texts = [];
   if(ASPx.IsExists(serializedTexts))
    texts = JSON.parse(serializedTexts);
   else {
    var innerText = ASPxClientListBox.GetItemCellInnerText(this.GetItemFirstTextCellCore(row));
    texts = this.IsMultiColumn() ? innerText.split("; ") : innerText;
   }
   return texts;
  },
  ItemRowHasTemplateCore: function(itemRow) {
   return ASPx.ElementHasCssClass(itemRow, TEMPLATED_ROW_CLASS) && ASPxClientListBox.prototype.ItemRowHasTemplateCore.call(this, itemRow);
  },
  GetListTableRowBeforeNewItemRow: function(newItemIndex, listTable) {
   var listTableRows = this.GetItemElements();
   var lastRenderedItem = this.itemsManager.GetLastRenderedItem();
   if(!lastRenderedItem || lastRenderedItem.index < newItemIndex) {
    var lastItemRow = lastRenderedItem ? this.GetItemRow(lastRenderedItem.index) : null;
    var lastListTableRow = listTableRows[listTableRows.length - 1];
    if(lastItemRow)
     return lastItemRow === lastListTableRow ? null : lastItemRow.nextSibling;
    return null;
   }
   for(var i = 0; i < listTableRows.length; i++)
    if(this.GetItemIndexByRow(listTableRows[i]) >= newItemIndex)
     return listTableRows[i];
   return null;
  },
  InsertItemRow: function(index, itemProperties) {
   var newItemElement = this.itemsManager.CreateNewItemRow(index);
   var itemsContainer = this.listBoxRenderHelper.GetItemsContainer();
   var rowBeforeNewItemRow = this.GetListTableRowBeforeNewItemRow(index, itemsContainer);
   if(rowBeforeNewItemRow)
    itemsContainer.insertBefore(newItemElement, rowBeforeNewItemRow);
   else {
    var bottomSpacer = this.GetScrollSpacerElement(false) || document.getElementById(this.name + "VirtualScrollBottomSpacer");
    if(bottomSpacer)
     itemsContainer.insertBefore(newItemElement, bottomSpacer);
    else
     itemsContainer.appendChild(newItemElement);
   }
   if(!itemProperties.htmlContent)
    this.CreateNewItemInternalElement(newItemElement, itemProperties);
   else
    this.listBoxRenderHelper.CreateItemWithHtmlContent(newItemElement, itemProperties);
   var newIndex = this.GetItemIndexByInsertionOrder(index);
   this.InitializeItemAttributes(newItemElement, newIndex);
   this.listBoxRenderHelper.AddItemStateItems(newItemElement.id);
   this.AssignDecorationSettingsToElement(newItemElement, itemProperties.style, itemProperties.cssClass, itemProperties.tooltip);
   this.ChangeItemEvents(newItemElement, ASPx.Evt.AttachEventToElement);
  },
  RemoveItemRow: function(index) {
   var row = this.GetItemRow(index);
   if(ASPx.IsExistsElement(row)) {
    if(index > -1) {
     var firstCell = this.GetItemElement(index);
     if(firstCell) {
      var firstCellId = firstCell.id;
      var itemId = firstCellId.match(/LBI\d+/) && firstCellId.match(/LBI\d+/)[0];
      this.RemoveStateControllerClasses(itemId);
     }
    }
    row.parentNode.removeChild(row);
   }
  },
  OnItemInserted: function(index) {
   this.DropCachedItemElements();
   ASPxClientListBox.prototype.OnItemInserted.call(this, index);
  },
  OnItemRemoved: function(index) {
   if(!this.HasVirtualScrolling())
    this.DropCachedItemElements();
   ASPxClientListBox.prototype.OnItemRemoved.call(this, index);
  },
  PrepareItem: function(newItemRow, itemProperties) {
   var i = 0;
   if(this.GetIsCheckColumnExists())
    i++;
   if(this.imageCellExists) {
    this.PrepareItemImage(newItemRow, i, itemProperties.imageUrl);
    i++;
   }
  },
  PrepareItemImage: function(newItemRow, imageCellIndex, imageUrl) {
   var imageElement = newItemRow.querySelector("." + ITEM_IMAGE_CLASS);
   if(!imageElement) {
    imageElement = document.createElement("SPAN");
    newItemRow.insertBefore(imageElement, newItemRow.childNodes[imageCellIndex]);
   }
   ASPx.SetClassName(imageElement, ITEM_IMAGE_CLASS);
   if(imageUrl && imageUrl.length)
    ASPx.AddClassNameToElement(imageElement, imageUrl);
  },
  PrepareItemTextCell: function(cell, text, style, cssClass, tooltip, htmlContent) { },
  SetItemTextCellHtml: function(itemIndex, textCellIndex, html) {
   this.listBoxRenderHelper.SetItemTextCellHtml(itemIndex, textCellIndex, html);
  },
  SetItemHtml: function(index, html) {
   this.hasDecoratedItems = true;
   this.itemsManager.SetItemHtml(index, html);
   this.ProcessItemRow(index, function(itemRow) {
    var itemTexts = this.GetItem(index).texts;
    this.SetItemHtmlContent(itemRow, html);
    if(!this.ItemRowHasSerializedTextsAttr(itemRow)) {
     if(typeof(itemTexts) == "string")
      itemTexts = [ itemTexts ];
     this.SetTextsDataAttribute(itemRow, itemTexts);
    }
    this.itemsManager.OnDecoratedItemsRendering();
    this.listBoxRenderHelper.UpdateItemStateAfterSetHtml(index);
   }.bind(this));
  },
  SetItemHtmlContent: function(itemRow, html) {
   this.listBoxRenderHelper.SetItemHtmlContent(itemRow, html);
  },
  GetItemBadgeText: function(index) {
   var itemElement = this.GetItemElement(index);
   return itemElement ? ASPx.BootstrapBadgeManager.getBadgeText(this.GetItemBadgeContainer(itemElement)) : "";
  },
  SetItemBadgeText: function(index, text) {
   this.ProcessItemRow(index, function(itemRow) {
    var badgeContainer = this.GetItemBadgeContainer(itemRow);
    if(!badgeContainer)
     return;
    var badgeText = this.HtmlEncode(text);
    var badge = ASPx.BootstrapBadgeManager.findBadge(badgeContainer);
    if(badge)
     ASPx.BootstrapBadgeManager.setBadgeText(badge, badgeText);
    else
     badgeContainer.appendChild(ASPx.BootstrapBadgeManager.createBadge(badgeText));
    this.itemsManager.SetItemBadgeText(index, badgeText);
   }.aspxBind(this));
  },
  GetItemBadgeIconCssClass: function(index) {
   var itemElement = this.GetItemElement(index);
   return itemElement ? ASPx.BootstrapBadgeManager.getBadgeIconCssClass(this.GetItemBadgeContainer(itemElement)) : "";
  },
  SetItemBadgeIconCssClass: function(index, cssClass) {
   this.ProcessItemRow(index, function(itemRow) {
    var badgeContainer = this.GetItemBadgeContainer(itemRow);
    if(!badgeContainer)
     return;
    var badge = ASPx.BootstrapBadgeManager.findBadge(badgeContainer);
    if(badge)
     ASPx.BootstrapBadgeManager.setBadgeIconCssClass(badge, cssClass);
    else
     badgeContainer.appendChild(ASPx.BootstrapBadgeManager.createBadge("", cssClass));
    this.itemsManager.SetItemBadgeIconCssClass(index, cssClass);
   }.aspxBind(this));
  },
  DropCachedItemElements: function() {
   if(!!this.cache)
    ASPx.CacheHelper.DropCachedValue(this, "itemElements");
  },
  GetItemElements: function() {
   var getItemElements = function() {
    return this.GetRowElements().filter(function(element) { return !ASPx.ElementHasCssClass(element, EXTRA_ROW_CLASS); });
   }.aspxBind(this);
   return this.HasVirtualScrolling() ? getItemElements() : ASPx.CacheHelper.GetCachedElements(this, "itemElements", getItemElements);
  },
  GetRowElements: function() {
   return this.listBoxRenderHelper.GetRowElements();
  },
  GetVisibleRowElements: function() {
   return this.GetRowElements().filter(function(element) { return ASPx.GetElementDisplay(element); });
  },
  GetItemIndexByElement: function(element) {
   var itemElements = this.GetItemElements();
   for(var i = 0; i < itemElements.length; i++) {
    var itemElement = itemElements[i];
    if(ASPx.GetIsParent(itemElement, element))
     return itemElement.itemIndex !== undefined ? itemElement.itemIndex : i;
   }
   return -1;
  },
  GetVisibleItemElements: function() {
   return this.GetItemElements().filter(function(element) { return ASPx.GetElementDisplay(element); });
  },
  GetIndexVisibleItem: function(item) {
   var itemElements = this.GetItemElements();
   var visibleItemCount = 0;
   for(var i = 0; i < count; i++) {
    if(ASPx.GetElementDisplay(itemElements[i], true))
     visibleItemCount++;
    var curItem = this.GetItem(i);
    if(item.value === curItem.value && item.text === curItem.text)
     break;
   }
   return visibleItemCount;
  },
  GetItemCellCount: function() {
   var cellCount = 1;
   if(this.GetIsCheckColumnExists())
    cellCount++;
   if(this.imageCellExists)
    cellCount++;
   return cellCount;
  },
  CopyCellWidths: function(sourceRowIndex, destinationRowIndex){ },
  GetItemFirstTextCell: function(index) {
   var row = this.GetItemRow(index);
   return row ? this.GetItemFirstTextCellCore(row) : null;
  },
  GetItemFirstTextCellCore: function(itemRow) {
   if(this.GetIsCheckColumnExists() && this.ItemRowHasTemplateCore(itemRow)) {
    var internalElement = ASPx.GetChildByTagName(itemRow, this.GetItemInternalElementTagName(), 0);
    if(internalElement)
     return internalElement;
   }
   var selectableElements = this.GetItemSelectableElementsByRow(itemRow);
   if(selectableElements && selectableElements.length) {
    var firstTextCell = selectableElements[this.GetItemFirstTextCellIndex()];
    if(firstTextCell)
     return firstTextCell;
   }
   return itemRow;
  },
  GetItemTextCell: function(itemIndex, textCellIndex) {
   return this.listBoxRenderHelper.GetItemTextCell(itemIndex, textCellIndex);
  },
  GetElementTopOffset: function(element) {
   var topOffset = 0;
   if(element) {
    topOffset = element.offsetTop;
    if(element.offsetParent) {
     var offsetParent = ASPx.FindOffsetParent(element);
     if(offsetParent.tagName != "BODY" && element.offsetParent !== offsetParent)
      topOffset -= offsetParent.offsetTop;
    }
   }
   return topOffset;
  },
  GetItemSelectableElementsByRow: function(row) {
   return this.listBoxRenderHelper.GetItemSelectableElementsByRow(row);
  },
  GetItemBadgeContainer: function(itemElement) {
   return this.GetIsCheckColumnExists()
    ? ASPx.GetChildByPartialClassName(itemElement, CHECKBOX_CONTAINER_CLASS)
    : this.GetItemContentElement(itemElement);
  },
  GetItemInternalElementTagName: function() {
   return this.GetIsCheckColumnExists() ? "DIV" : "A";
  },
  GetItemContentElement: function(itemElement) {
   var internalElement = ASPx.GetChildByTagName(itemElement, this.GetItemInternalElementTagName(), 0);
   if(this.GetIsCheckColumnExists())
    if(ASPx.BootstrapCore.IsBootstrap3)
     return ASPx.GetChildByTagName(internalElement, "LABEL", 0);
    else
     return ASPx.GetChildByClassName(internalElement, CHECKBOX_CONTAINER_CLASS, 0);
   return internalElement;
  },
  GetScrollDivElement: function() {
   return this.listBoxRenderHelper.GetScrollDivElement();
  },
  GetLoadingParentElement: function() {
   var listElement = this.GetListElement();
   return this.isComboBoxList && ASPx.GetElementDisplay(listElement) ? listElement.parentNode : listElement;
  },
  GetLoadingOffsetElement: function() {
   return this.GetListElement();
  },
  GetListTableHeight: function() {
   return this.listBoxRenderHelper.GetListTableHeight();
  },
  GetRequiredScrollSpacerHeight: function() {
   return this.GetScrollDivElement().clientHeight - 1;
  },
  CallbackSpaceInit: function(isInitialization) {
   if(this.isCallbackMode) {
    var scrollDivElement = this.GetScrollDivElement();
    var needMakeScrollDivVisible = !isInitialization && !ASPx.GetElementDisplay(scrollDivElement);
    if(needMakeScrollDivVisible)
     ASPx.SetElementDisplay(scrollDivElement, true);
    var scrollDivHeight = scrollDivElement.style.height;
    var scrollDivClientHeight = scrollDivElement.clientHeight;
    var needSetScrollDivHeight = this.IsStandAlone() && scrollDivClientHeight && (!scrollDivHeight.length || scrollDivHeight === "unset");
    ASPxClientListBox.prototype.CallbackSpaceInit.call(this, isInitialization);
    if(isInitialization || this.isComboBoxList)
     ASPx.Evt.AttachEventToElement(scrollDivElement, "scroll", this.OnScroll.bind(this));
    if(needSetScrollDivHeight) {
     this.LockScrollHandler();
     scrollDivElement.style.height = scrollDivClientHeight + "px";
     this.EnsureSelectedItemVisible();
     this.UnlockScrollHandler();
    }
    if(needMakeScrollDivVisible)
     ASPx.SetElementDisplay(scrollDivElement, false);
   }
  },
  GetListElement: function() {
   return this.listBoxRenderHelper.GetListElement();
  },
  GetListTableCore: function() {
   return this.GetListElement();
  },
  GetCaptionCell: function() {
   return ASPx.CacheHelper.GetCachedElement(this, "captionElement",
    function() {
     var editCaptionCssClass = "dxbs-edit-caption";
     var mainElement = this.GetMainElement();
     if(!mainElement)
      return null;
     var captionElement = mainElement.querySelector("." + editCaptionCssClass);
     if(!captionElement && mainElement === this.GetListElement()) {
      if(mainElement.previousSibling && ASPx.ElementHasCssClass(mainElement.previousSibling, editCaptionCssClass))
       captionElement = mainElement.previousSibling;
      else if(mainElement.nextSibling && ASPx.ElementHasCssClass(mainElement.nextSibling, editCaptionCssClass))
       captionElement = mainElement.nextSibling;
     }
     return captionElement;
    }
   );
  },
  getCaptionTextNode: function() {
   return ASPx.GetNormalizedTextNode(this.GetCaptionCell());
  },
  getCaptionRelatedCellCount: function() {
   return undefined;
  },
  IsNativeCheckBoxes: function() {
   return true;
  },
  GetItemCheckBoxInput: function(index) {
   var row = this.GetItemRow(index);
   return row ? row.querySelector('input[type="checkbox"]') : null;
  },
  GetItemCheckBoxClassName: function() {
   var cssClasses = [];
   cssClasses.push(this.IsDropDown() ? DROPDOWN_ITEM_CHECKBOX_CLASS : ITEM_CHECKBOX_CLASS);
   if(this.cssClasses && this.cssClasses.lbc)
    cssClasses.push(this.cssClasses.lbc);
   return cssClasses.join(" ");
  },
  IsSelectAllCheckBoxClicked: function(eventSource) {
   return this.selectAllCheckBox && ASPx.GetIsParent(this.selectAllCheckBox.mainElement, eventSource);
  },
  IsNativeSelectAllCheckBoxClicked: function(eventSource) {
   return false;
  },
  getSelectAllCheckElementState: function() {
   if(this.selectAllCheckBox) {
    var value = this.selectAllCheckBox.GetValue();
    if(value === true)
     return ASPx.CheckBoxCheckState.Checked;
    if(value === false)
     return ASPx.CheckBoxCheckState.Unchecked;
    if(value === null)
     return ASPx.CheckBoxCheckState.Indeterminate;
   }
   return null;
  },
  updateSelectAllCheckElementState: function(checkState) {
   if(ASPx.Browser.IE && ASPx.BootstrapCore.IsBootstrap3) 
    window.setTimeout(this.updateSelectAllCheckElementStateInternal.bind(this, checkState), 0);
   else
    this.updateSelectAllCheckElementStateInternal(checkState);
  },
  updateSelectAllCheckElementStateInternal: function(checkState) {
   if(this.selectAllCheckBox) {
    if(checkState === ASPx.CheckBoxCheckState.Checked)
     this.selectAllCheckBox.SetValue(true);
    else if(checkState === ASPx.CheckBoxCheckState.Unchecked)
     this.selectAllCheckBox.SetValue(false);
    else
     this.selectAllCheckBox.SetValue(null);
   }
  },
  SetVisible: function(visible) {
   if(this.clientVisible != visible && this.GetMainElement() === this.GetListElement())
    ASPx.SetElementDisplay(this.GetCaptionCell(), visible);
   ASPxClientListBox.prototype.SetVisible.call(this, visible);
  },
  IsStandAlone: function() {
   if (this.isComboBoxList)
    return false;
   return ASPx.ElementHasCssClass(this.GetMainElement(), STANDALONE_CLASS) || !!this.GetMainElement().querySelector("." + BSLISTBOX_CLASS + "." + STANDALONE_CLASS);
  },
  IsDropDown: function() {
   return ASPx.ElementHasCssClass(this.GetMainElement(), ASPx.BootstrapCssSelectors.DropDownMenu);
  },
  IsElementBelongToInputElement: function(element) {
   return this.isComboBoxList ? ASPxClientListBox.prototype.IsElementBelongToInputElement.call(this, element) : this.IsEditorElement(element);
  },
  UpdateShowHideFilterElementCssRules: function() {
   var animatedClassName = this.GetAnimatedFilterElementClassName();
   var isFilterAnimated = ASPx.ElementHasCssClass(this.filterMainElement, animatedClassName);
   this.ToggleFilterMainElementClassName(animatedClassName, false);
   ASPxClientListBox.prototype.UpdateShowHideFilterElementCssRules.call(this);
   this.ToggleFilterMainElementClassName(animatedClassName, isFilterAnimated);
  },
  GetFilterMainElementHeight: function() {
   if(!this.filterMainElementHeight) {
    var isFilterInactive = ASPx.ElementHasCssClass(this.filterMainElement, this.GetInactiveFilterElementClassName());
    if(isFilterInactive) {
     this.filterMainElement.style.position = "absolute";
     this.filterMainElement.style.visibility = "hidden";
    }
    this.ToggleFilterMainElementClassName("calculating", true);
    this.filterMainElementHeight = this.filteringTextBox.GetMainElement().offsetHeight + ASPx.GetTopBottomBordersAndPaddingsSummaryValue(this.filterMainElement);
    this.ToggleFilterMainElementClassName("calculating", false);
    if(isFilterInactive) {
     this.filterMainElement.style.position = "";
     this.filterMainElement.style.visibility = "";
    }
   }
   return this.filterMainElementHeight;
  },
  ToggleFilterMainElementClassName: function(className, contains) {
   ASPx.ToggleClassNameToElement(this.filterMainElement, className, contains);
  },
  GetInactiveFilterElementClassName: function() {
   return INACTIVE_FILTER_CLASS;
  },
  GetAnimatedFilterElementClassName: function() {
   return ANIMATED_FILTER_CLASS;
  },
  GetCompactViewFilterAdjacentScrollDivSelector: function() {
   return "*[class*=\"dxbs-list-filter\"]:not(.collapsed) + *[class*=\"dxbs-list-selectall\"] + .list-group";
  },
  GetCompactViewInactiveFilterAdjacentScrollDivSelector: function() {
   return ".dxbs-list-filter.collapsed + *[class*=\"dxbs-list-selectall\"] + .list-group";
  },
  GetItemCellsIdPostfixes: function() {
   return this.listBoxRenderHelper.GetItemCellsIdPostfixes();
  },
  CreateFixWidthRow: function() { }
 });
 var CHECKLIST_ITEM_INPUT_SELECTOR = "." + ASPx.BootstrapCssSelectors.CheckBoxInput + ",." + ASPx.BootstrapCssSelectors.CustomCheckInput;
 var BootstrapClientCheckBoxList = ASPx.CreateClass(ASPxClientCheckBoxList, {
  constructor: function (name) {
   this.constructor.prototype.constructor.call(this, name);
   this.formLayoutElement = null;
   this.feedbackRenderHelper = new ASPx.BootstrapEditFeedbackRenderHelper(this);
  },
  InlineInitialize: function() {
   this.RequireStyleDecoration();
   ASPxClientCheckBoxList.prototype.InlineInitialize.call(this);
   if(ASPx.Browser.TouchUI && !this.GetIsValid())
    this.UpdateErrorText();
  },
  GetItemInput: function(index) {
   var itemElement = this.GetItemElement(index);
   return itemElement ? itemElement.querySelector('input[type="checkbox"]') : itemElement;
  },
  GetItemElement: function (index) {
   return ASPx.GetElementById(this.name + "_RB" + index);
  },
  GetItemFocusableElement: function (index) {
   return this.accessibilityCompliant ? this.GetChildElement("RB" + index + "_I_D") : this.GetItemInput(index);
  },
  GetFormLayoutElement: function () {
   if (!this.formLayoutElement)
    this.formLayoutElement = ASPx.GetChildByClassName(this.GetMainElement(), "dxbs-fl");
   return this.formLayoutElement;
  },
  CreateCheckBoxInternalCollection: function() {
   return new ASPx.BootstrapCheckBoxInternalCollection(true, false, true);
  },
  CreateButtonInternalCollection: function() { 
   this.internalButtonCollection = this.CreateCheckBoxInternalCollection();
   var internalButtonInputNamePrefix = this.uniqueID + "$RB";
   var instance = this;
   var checkedChangedHandler = function(s, e) { instance.OnItemClick(instance.GetItemIndexByElement(ASPx.Evt.GetEventSource(e))); };
   var focusHandler = function(s, e) { instance.OnFocus(); };
   var lostFocusHandler = function(s, e) { instance.OnLostFocus(); };
   for (var i = 0; i < this.GetItemCount() ; i++) {
    var itemElement = this.GetItemElement(i);
    var icbInputElement = this.GetItemInput(i);
    icbInputElement.id = itemElement.id + "_I";
    var internalButton = this.internalButtonCollection.Add(icbInputElement.id, itemElement);
    internalButton.stateInput.name = internalButtonInputNamePrefix + i;
    internalButton.SetEnabled(this.GetEnabled());
    internalButton.GetReadOnly = this.GetReadOnly.bind(this);
    internalButton.CheckedChanged.AddHandler(checkedChangedHandler);
    internalButton.Focus.AddHandler(focusHandler);
    internalButton.LostFocus.AddHandler(lostFocusHandler);
    this.attachToCellsClick(i);
    this.PrepareInternalButton(internalButton, i);
   }
   this.attachToMainElementMouseDown();
  },
  CheckableElementsExist: function() {
   return true;
  },
  GetItemIndexByElement: function (element) {
   for (var i = 0; i < this.GetItemCount() ; i++) {
    var itemElement = this.GetItemElement(i);
    if (ASPx.GetIsParent(itemElement, element))
     return i;
   }
   return -1;
  },
  SetSelectionDecoration: function (index, selected) { 
   if (this.CheckableElementsExist()) {
    var inputElement = this.GetItemInput(index);
    if(inputElement) {
     var internalButton = this.internalButtonCollection.Get(inputElement.id);
     internalButton.SetValue(selected);
    }
   } else {
    var element = this.GetItemInput(index);
    if (element)
     element.checked = (selected);
   }
  },
  PopulateStyleDecorationPostfixes: function() {
   this.styleDecoration.AddPostfix("");
   if(ASPx.BootstrapCore.IsBootstrap4)
    this.styleDecoration.AddPostfix(CHECKLIST_ITEM_INPUT_SELECTOR);
  },
  CreateStyleDecoration: function() {
   return new ASPx.BootstrapEditorStyleDecoration(this);
  },
  GetCaptionCell: function() {
   return ASPx.CacheHelper.GetCachedElement(this, "captionElement",
    function() {
     var editCaptionCssClass = "dxbs-edit-caption";
     var mainElement = this.GetMainElement();
     var captionElement = mainElement && mainElement.querySelector("." + editCaptionCssClass);
     return captionElement;
    }
   );
  },
  getCaptionTextNode: function() {
   return ASPx.GetNormalizedTextNode(this.GetCaptionCell());
  },
  getCaptionRelatedCellCount: function() {
   return undefined;
  },
  GetControlCell: function() {
   return this.GetMainElement();
  },
  EnsureControlCellStylesLoaded: function() { },
  ClearControlCellStyles: function() { },
  RestoreControlCellStyles: function() { },
  GetElementRequiredForErrorFrame: function () {
   return this.GetMainElement();
  },
  GetErrorImage: function() {
   return this.feedbackRenderHelper.getErrorImage();
  },
  UpdateErrorText: function() {
   this.feedbackRenderHelper.updateErrorText();
  },
  ChangeErrorCellVisibility: function(visible, useVisibilityAttribute) {
   this.feedbackRenderHelper.setErrorControlVisible(visible);
  }
 });
 var BootstrapClientRadioButtonList = ASPx.CreateClass(ASPxClientRadioButtonList, {
  constructor: function (name) {
   this.constructor.prototype.constructor.call(this, name);
   this.formLayoutElement = null;
   this.feedbackRenderHelper = new ASPx.BootstrapEditFeedbackRenderHelper(this);
  },
  InlineInitialize: function() {
   this.RequireStyleDecoration();
   ASPxClientRadioButtonList.prototype.InlineInitialize.call(this);
   for(var i = 0; i < this.GetItemCount(); i++) {
    var radioButton = this.GetItemRadioButton(i);
    if(radioButton)
     radioButton.groupName = this.uniqueID;
   }
   if(ASPx.Browser.TouchUI && !this.GetIsValid())
    this.UpdateErrorText();
  },
  GetItemInput: function(index) {
   var itemElement = this.GetItemElement(index);
   return itemElement ? itemElement.querySelector('input[type="radio"]') : itemElement;
  },
  GetItemElement: function (index) {
   return ASPx.GetElementById(this.name + "_RB" + index);
  },
  GetItemRadioButton: function(index) {
   return ASPx.GetControlCollection().Get(this.name + "_RB" + index);
  }, 
  GetItemFocusableElement: function (index) {
   return this.accessibilityCompliant ? this.GetChildElement("RB" + index + "_I_D") : this.GetItemInput(index);
  },
  GetFormLayoutElement: function () {
   if (!this.formLayoutElement)
    this.formLayoutElement = ASPx.GetChildByClassName(this.GetMainElement(), "dxbs-fl");
   return this.formLayoutElement;
  },
  CreateCheckBoxInternalCollection: function() {
   return new ASPx.BootstrapCheckBoxInternalCollection(true, false, true);
  },
  CreateButtonInternalCollection: function() { 
   this.internalButtonCollection = this.CreateCheckBoxInternalCollection();
   var internalButtonInputNamePrefix = this.uniqueID + "$RB";
   var instance = this;
   var checkedChangedHandler = function(s, e) { instance.OnItemClick(instance.GetItemIndexByElement(ASPx.Evt.GetEventSource(e))); };
   var focusHandler = function(s, e) { instance.OnFocus(); };
   var lostFocusHandler = function(s, e) { instance.OnLostFocus(); };
   for(var i = 0; i < this.GetItemCount() ; i++) {
    var itemElement = this.GetItemElement(i);
    var icbInputElement = this.GetItemInput(i);
    icbInputElement.id = itemElement.id + "_I";
    var internalButton = this.internalButtonCollection.Add(icbInputElement.id, itemElement);
    internalButton.stateInput.name = internalButtonInputNamePrefix + i;
    internalButton.SetEnabled(this.GetEnabled());
    internalButton.GetReadOnly = this.GetReadOnly.bind(this);
    internalButton.CheckedChanged.AddHandler(checkedChangedHandler);
    internalButton.Focus.AddHandler(focusHandler);
    internalButton.LostFocus.AddHandler(lostFocusHandler);
    this.attachToCellsClick(i);
    this.PrepareInternalButton(internalButton, i);
   }
   this.attachToMainElementMouseDown();
  },
  CheckableElementsExist: function() {
   return true;
  },
  GetItemIndexByElement: function (element) {
   for (var i = 0; i < this.GetItemCount() ; i++) {
    var itemElement = this.GetItemElement(i);
    if (ASPx.GetIsParent(itemElement, element))
     return i;
   }
   return -1;
  },
  UpdateCheckableElementDecorations: function (selectedIndex, enabled) {
   if (this.CheckableElementsExist()) {
    for (var i = 0; i < this.items.length; i++) {
     var inputElement = this.GetItemInput(i);
     var internalButton = this.internalButtonCollection.Get(inputElement.id);
     internalButton.SetEnabled(enabled);
     internalButton.SetValue(i == selectedIndex);
    }
   }
  },
  PopulateStyleDecorationPostfixes: function() {
   this.styleDecoration.AddPostfix("");
   if(ASPx.BootstrapCore.IsBootstrap4)
    this.styleDecoration.AddPostfix(CHECKLIST_ITEM_INPUT_SELECTOR);
  },
  CreateStyleDecoration: function() {
   return new ASPx.BootstrapEditorStyleDecoration(this);
  },
  GetCaptionCell: function() {
   return ASPx.CacheHelper.GetCachedElement(this, "captionElement",
    function() {
     var editCaptionCssClass = "dxbs-edit-caption";
     var mainElement = this.GetMainElement();
     var captionElement = mainElement && mainElement.querySelector("." + editCaptionCssClass);
     return captionElement;
    }
   );
  },
  getCaptionTextNode: function() {
   return ASPx.GetNormalizedTextNode(this.GetCaptionCell());
  },
  getCaptionRelatedCellCount: function() {
   return undefined;
  },
  GetControlCell: function() {
   return this.GetMainElement();
  },
  EnsureControlCellStylesLoaded: function() { },
  ClearControlCellStyles: function() { },
  RestoreControlCellStyles: function() { },
  GetElementRequiredForErrorFrame: function() {
   return this.GetMainElement();
  },
  GetErrorImage: function() {
   return this.feedbackRenderHelper.getErrorImage();
  },
  UpdateErrorText: function() {
   this.feedbackRenderHelper.updateErrorText();
  },
  ChangeErrorCellVisibility: function(visible, useVisibilityAttribute) {
   this.feedbackRenderHelper.setErrorControlVisible(visible);
  }
 });
 ASPx.BootstrapListBoxHighlightingHelper = ASPx.CreateClass(ASPx.ListBoxHighlightingHelper, {
  applyToTextCells: function (func, firstTextCellIndex, elements, itemSelection) {
   for(var i = 0; i < itemSelection.length; i++){
    var element = this.listBox.IsEnableMultiColumn() ? elements[itemSelection[i].index + firstTextCellIndex] : elements[firstTextCellIndex];
    this.applyToItemCore(func, element, itemSelection[i]);
   }
  },
  getItemSelection: function(itemValues, textFormatString, text) {
   var itemSelectionBase = ASPx.ListBoxHighlightingHelper.prototype.getItemSelection.call(this, itemValues, textFormatString, text);
   if (this.listBox.IsEnableMultiColumn())
    return itemSelectionBase;
   var formattedText = this.listBox.FormatText(itemValues);
   var itemSelection = [];
   for(var i = 0; i < itemSelectionBase.length; i++) {
    var selectionIndex = itemSelectionBase[i].index;
    var selectionLength = itemSelectionBase[i].length;
    var highlightedText = itemValues[selectionIndex].substr(itemSelectionBase[i].startIndex, selectionLength);
    var selectionStartIndex = ASPx.Str.PrepareStringForFilter(formattedText).indexOf(ASPx.Str.PrepareStringForFilter(highlightedText));
    var selection = new ASPx.ContainsFilteringUtils.ColumnSelectionStruct(selectionIndex, selectionStartIndex, selectionLength);
    itemSelection.push(selection);
   }
   return itemSelection;
  }
 });
 dx.BootstrapClientListBoxItem = BootstrapClientListBoxItem;
 dx.BootstrapClientListBox = BootstrapClientListBox;
 dx.BootstrapClientCheckBoxList = BootstrapClientCheckBoxList;
 dx.BootstrapClientRadioButtonList = BootstrapClientRadioButtonList;
})(dx || (dx = {}));

(function() {
var ASPxClientButton = ASPx.CreateClass(ASPxClientControl, {
 constructor: function(name) {
  this.constructor.prototype.constructor.call(this, name);
  this.isASPxClientButton = true;
  this.allowFocus = true;
  this.autoPostBackFunction = null;
  this.causesValidation = true;
  this.checked = false;
  this.clickLocked = false;
  this.groupName = "";
  this.focusElementSelected = false;
  this.pressed = false;
  this.useSubmitBehavior = true;
  this.validationGroup = "";
  this.validationContainerID = null;
  this.validateInvisibleEditors = false;
  this.originalWidth = null;
  this.originalHeight = null;
  this.needUpdateBounds = true;
  this.isTextEmpty = false;
  this.isImage = false;
  this.CheckedChanged = new ASPxClientEvent();
  this.GotFocus = new ASPxClientEvent();
  this.LostFocus = new ASPxClientEvent();
  this.Click = new ASPxClientEvent();
 },
 InlineInitialize: function() {
  var mainElement = this.GetMainElement();
  this.originalWidth = mainElement.style.width;
  this.originalHeight = mainElement.style.height;
  ASPxClientControl.prototype.InlineInitialize.call(this);
  this.InitializeElementIDs();
  this.InitializeEvents();
  this.InitializeEnabled();
  this.InitializeChecked();
  if(this.IsLink())
   this.InitializeLink();
  this.PreventButtonImageDragging();
  this.EnsureBoundsAdjusted();
 },
 InitializeElementIDs: function(){
  var mainElement = this.GetMainElement();
  var contentElement = ASPx.GetNodeByTagName(mainElement, "DIV", 0);
  if(contentElement) contentElement.id = this.name + "_CD";
  var imageElement = ASPx.GetNodeByTagName(mainElement, "IMG", 0);
  if(imageElement) imageElement.id = this.name + "Img";
 },
 InitializeEnabled: function(){
  this.SetEnabledInternal(this.clientEnabled, true);
 },
 InitializeChecked: function(){
  this.SetCheckedInternal(this.checked, true);
 },
 InitializeLink: function(){
  var mainElement = this.GetMainElement();
  if(this.enabled)
   mainElement.href = "javascript:;";
  if(!this.allowFocus)
   mainElement.style.outline = 0;
  if(!this.isImage && !this.GetTextContainer())
   mainElement.style.fontSize = "0pt";
 },
 InitializeEvents: function(){
  if(!this.isNative && !this.IsLink()) {
   var element = this.GetInternalButton();
   if(element)
    element.onfocus = null;
   var textControl = this.GetTextControl();
   if(textControl) {
    if(ASPx.Browser.IE)
     ASPx.Evt.AttachEventToElement(textControl, "mouseup", ASPx.Selection.Clear);
    ASPx.Evt.PreventElementDragAndSelect(textControl, false);
   }    
  }
  this.onClick = function(evt) {
   var processOnServer = ASPx.BClick(this.name, evt);
   if(!processOnServer)
    ASPx.Evt.PreventEvent(evt);
   return processOnServer;
  }.aspxBind(this);
  this.onImageMoseDown = function() { var el = ASPx.GetFocusedElement(); if(el) el.blur(); };
  this.onGotFocus = function() { this.OnFocus(); }.aspxBind(this);
  this.onLostFocus = function() { this.OnLostFocus(); }.aspxBind(this);
  this.onKeyUp = function(evt) { this.OnKeyUp(evt); }.aspxBind(this);
  this.onKeyDown = function(evt) { this.OnKeyDown(evt); }.aspxBind(this); 
  if(!this.isNative && !this.IsLink())
   this.InitializeNativeHandlers();
 },
 InitializeNativeHandlers: function() {
  this.AttachNativeHandlerToMainElement("focus", "SetFocus");
  this.AttachNativeHandlerToMainElement("click", "DoClick");
 },
 EnsureBoundsAdjusted: function() {
  var mainElement = this.GetMainElement();
  this.needUpdateBounds = ASPx.GetCurrentStyle(mainElement).display === "block";
  if(this.needUpdateBounds) 
   mainElement.className = mainElement.className.replace("dxbTSys", "");
 },
 AdjustControlCore: function () {
  if(this.isNative || this.IsLink()) return;
  var buttonImage = this.GetButtonImage();  
  if(buttonImage && buttonImage.offsetHeight === 0 && buttonImage.offsetWidth === 0)
   buttonImage.onload = function() { this.UpdateSize(); }.aspxBind(this);
  else
   this.UpdateSize();
  this.UpdateVerticalAlign();
 },
 UpdateSize: function() {
  if(this.needUpdateBounds) {
   this.UpdateWidth();
   this.UpdateHeight();
  } else
   this.CorrectWrappedText(this.GetContentDiv, "Text", true);
 },
 UpdateVerticalAlign: function() {
  var contentElement = this.GetContentDiv();
  var verticalAlign = this.GetMainElement().style.verticalAlign;
  if(ASPx.IsExistsElement(contentElement) && verticalAlign)
   contentElement.style.verticalAlign = verticalAlign;
 },
 UpdateHeight: function(){
  if(this.isNative || this.IsLink() || this.originalHeight === null || ASPx.IsPercentageSize(this.originalHeight)) return;
  var height;
  var mainElement = this.GetMainElement();
  var contentDiv = this.GetContentDiv();
  var borderAndPadding = ASPx.GetTopBottomBordersAndPaddingsSummaryValue(mainElement);
  var contentHasExcessiveHeight = contentDiv.offsetHeight > mainElement.offsetHeight - borderAndPadding;
  var needSetAutoHeight = !this.originalHeight || (ASPx.Browser.Safari && contentHasExcessiveHeight);
  if(needSetAutoHeight) {
   mainElement.style.height = "";
   height = mainElement.offsetHeight - borderAndPadding;
  }
  else
   height = (ASPx.PxToInt(this.originalHeight) - borderAndPadding);
  if(height){
   mainElement.style.height = height + "px";
   if(contentDiv && contentDiv.offsetHeight > 0){
    var contentDivCurrentStyle = ASPx.GetCurrentStyle(contentDiv);
    var paddingTop = parseInt(contentDivCurrentStyle.paddingTop) || 0;
    var paddingBottom = parseInt(contentDivCurrentStyle.paddingBottom) || 0;
    var clientHeightDiff = height - contentDiv.offsetHeight;
    var verticalAlign = ASPx.GetCurrentStyle(mainElement).verticalAlign;
    if(verticalAlign == "top")
     paddingBottom = paddingBottom + clientHeightDiff;
    else if(verticalAlign == "bottom")
     paddingTop = paddingTop + clientHeightDiff;
    else {
     var halfClientHeightDiff = Math.floor(clientHeightDiff / 2);
     paddingTop = paddingTop + halfClientHeightDiff;
     paddingBottom = paddingBottom + (clientHeightDiff - halfClientHeightDiff);
    }
    contentDiv.style.paddingTop = (paddingTop > 0 ? paddingTop : 0) + "px";
    contentDiv.style.paddingBottom = (paddingBottom > 0 ? paddingBottom : 0) + "px";
   }
  }
 },
 UpdateWidth: function(){
  if(this.isNative || this.IsLink() || this.originalWidth === null) return;
  if(!ASPx.IsPercentageSize(this.originalWidth)) {
   var mainElement = this.GetMainElement();
   var borderAndPadding = ASPx.GetLeftRightBordersAndPaddingsSummaryValue(mainElement);
   if(this.originalWidth && ASPx.IsTextWrapped(this.GetTextContainer()))
    mainElement.style.width = (ASPx.PxToInt(this.originalWidth) - borderAndPadding) + "px";
   else
    mainElement.style.width = "auto";
   var width = mainElement.offsetWidth - borderAndPadding;
   if(this.originalWidth && width < ASPx.PxToInt(this.originalWidth) - borderAndPadding) 
    width = ASPx.PxToInt(this.originalWidth) - borderAndPadding;
   if(width)
    mainElement.style.width = (width > 0 ? width : 0)  + "px";
  }
  this.CorrectWrappedText(this.GetContentDiv, "Text", true);
 },
 GetAdjustedSizes: function() {
  var sizes = ASPxClientControl.prototype.GetAdjustedSizes.call(this);
  var image = this.GetButtonImage();
  if(image) {
   sizes.imageWidth = image.offsetWidth;
   sizes.imageHeight = image.offsetHeight;
  }
  return sizes;
 },
 PreventButtonImageDragging: function() {
  ASPx.Evt.PreventImageDragging(this.GetButtonImage());
 },
 AttachNativeHandlerToMainElement: function(handlerName, correspondingMethodName) {
  var mainElement = this.GetMainElement();
  if(!ASPx.IsExistsElement(mainElement))
   return;
  mainElement[handlerName] = function() { _aspxBCallButtonMethod(this.name, correspondingMethodName); }.aspxBind(this);
 },
 GetContentDiv: function(){
  return this.GetChildElement("CD");
 },       
 GetButtonImage: function(){
  return ASPx.CacheHelper.GetCachedElement(this, "buttonImage", 
   function() { 
    return ASPx.GetNodeByTagName(this.GetMainElement(), "IMG", 0); 
   });
 },
 GetInternalButton: function() {
  return ASPx.CacheHelper.GetCachedElement(this, "internalButton", 
   function() { 
    return this.isNative || this.IsLink() ? this.GetMainElement() : ASPx.GetNodeByTagName(this.GetMainElement(), "INPUT", 0);
   });
 },
 GetTextContainer: function() {
  return ASPx.CacheHelper.GetCachedElement(this, "textContainer", 
   function() { 
    if(this.isNative)
     return this.GetMainElement();
    else{
     var textElement = this.IsLink() ? this.GetMainElement() : this.GetContentDiv();
     return this.accessibilityCompliant ? ASPx.GetElementById(this.name + "_BTC") : ASPx.GetNodeByTagName(textElement, "SPAN", 0);
    }
   });
 },
 GetTextControl: function(){
  return ASPx.CacheHelper.GetCachedElement(this, "textControl", 
   function() { 
    var element = ASPx.GetParentByTagName(this.GetContentDiv(), "DIV");
    if(!ASPx.IsExistsElement(element) || (element.id == this.name))
     element = this.GetContentDiv();
    return element;
   });
 },
 IsLink: function(){
  if (this.GetMainElement())
   return this.GetMainElement().tagName === "A";
  return false;
 },   
 IsHovered: function(){
  var hoverElement = this.GetMainElement();
  return ASPx.GetStateController().currentHoverItemName == hoverElement.id;
 },   
 SetEnabledInternal: function(enabled, initialization) {
  if(!this.enabled)
   return;
  if(!initialization || !enabled)
   this.ChangeEnabledStateItems(enabled);
  this.ChangeEnabledAttributes(enabled);
 },
 ChangeEnabledAttributes: function(enabled) {
  var element = this.GetInternalButton();
  if(element) {
   if(this.IsLink()){
    var method = ASPx.Attr.ChangeAttributesMethod(enabled);
    var link = this.GetMainElement();
    method(link, "href");
    if(this.accessibilityCompliant)
     ASPx.Attr.SetOrRemoveAttribute(link, ASPx.Attr.GetTabIndexAttributeName(), enabled ? null : "0");
   } else {
    if(this.accessibilityCompliant)
     ASPx.Attr.Aria.SetOrRemoveDisabled(element, !enabled);
    else
     element.disabled = !enabled;
   }
  }
  this.ChangeEnabledEventsAttributes(ASPx.Attr.ChangeEventsMethod(enabled));
  var isFocusable = enabled || this.accessibilityCompliant;
  this.ChangeEnabledFocusEvents(ASPx.Attr.ChangeEventsMethod(isFocusable));
 },
 ChangeEnabledEventsAttributes: function(method) {
  var element = this.GetMainElement();
  method(element, "click", this.onClick);
  if(this.allowFocus){
   if(!this.isNative && !this.IsLink()) {
    element = this.GetInternalButton();
    if(element) {
     method(element, "keyup", this.onKeyUp);
     method(element, "blur", this.onKeyUp);
     method(element, "keydown", this.onKeyDown);
    }
   }
   if(ASPx.Browser.Firefox){
    var image = this.GetButtonImage();
    if(image)
     method(image, "mousedown", this.onImageMoseDown); 
   }
  }
 },
 ChangeEnabledFocusEvents: function(method) {
  if(!this.allowFocus)
   return;
  var element = !this.isNative && !this.IsLink() ? this.GetInternalButton() : this.GetMainElement();
  if(element) {
   method(element, "focus", this.onGotFocus);
   method(element, "blur", this.onLostFocus);
  }
 },
 ChangeEnabledStateItems: function(enabled){
  if(this.isNative) return;
  ASPx.GetStateController().SetElementEnabled(this.GetMainElement(), enabled);
  this.UpdateFocusedStyle();
 },
 RequiredPreventDoublePostback: function(){
  return ASPx.Browser.Firefox && !this.isNative; 
 },
 OnFocus: function() {
  if(!this.allowFocus)
   return false;
  this.focused = true;
  if(this.isInitialized)
   this.RaiseFocus();
  this.UpdateFocusedStyle();
 },  
 OnLostFocus: function() {
  if(!this.allowFocus)
   return false;
  this.focused = false;
  if(this.isInitialized)
   this.RaiseLostFocus();
  this.UpdateFocusedStyle();
 },
 CauseValidation: function() {
  if(this.causesValidation && ASPx.Ident.scripts.ASPxClientEdit)
   return this.validationContainerID != null ?
    ASPxClientEdit.ValidateEditorsInContainerById(this.validationContainerID, this.validationGroup, this.validateInvisibleEditors) :
    ASPxClientEdit.ValidateGroup(this.validationGroup, this.validateInvisibleEditors);
  else
   return true;
 },
 OnClick: function(evt) {
  if(this.clickLocked) return true;
  if(this.checked && this.groupName != "" && this.GetCheckedGroupList().length > 1) return;
  this.SetFocus();
  var isValid = this.CauseValidation();
  var processOnServer = this.autoPostBack;
  if(this.groupName != "") {
   if(this.GetCheckedGroupList().length == 1)
    this.SetCheckedInternal(!this.checked, false);
   else {
    this.SetCheckedInternal(true, false);
    this.ClearButtonGroupChecked(true);
   }
   processOnServer = this.RaiseCheckedChanged();
   if(processOnServer && isValid)
    this.SendPostBack("CheckedChanged");
  }
  var params = this.RaiseClick();
  if(evt && params.cancelEventAndBubble)
   ASPx.Evt.PreventEventAndBubble(evt);
  if(params.processOnServer && isValid)
   return this.ProcessClick();
  return false;
 },
 ProcessClick: function() {
  var requiredPreventDoublePostback = this.RequiredPreventDoublePostback();
  var postponePostback = ASPx.Browser.AndroidMobilePlatform; 
  if(requiredPreventDoublePostback || postponePostback)
   window.setTimeout(function() { _aspxBCallButtonMethod(this.name, "SendPostBack", "Click"); }.aspxBind(this), 0); 
  else
   this.SendPostBack("Click");
  return !requiredPreventDoublePostback;
 },
 OnKeyUp: function(evt) {
  if(!this.pressed)
   return;
  this.pressed = false;
  ASPx.GetStateController().OnKeyUpOnElement(evt);
 },
 OnKeyDown: function(evt) {
  if(evt.keyCode == ASPx.Key.Enter || evt.keyCode == ASPx.Key.Space)
   this.SetPressed();
 },
 GetCheckedGroupList: function(){
  var result = [ ];
  ASPx.GetControlCollection().ForEachControl(function(control) {
   if(ASPx.Ident.IsASPxClientButton(control) && (control.groupName == this.groupName) && !control.IsDOMDisposed())
    result.push(control);
  }, this);
  return result;
 },
 ClearButtonGroupChecked: function(raiseCheckedChanged){
  var list = this.GetCheckedGroupList();
  for(var i = 0; i < list.length; i ++){
   if(list[i] != this && list[i].checked) {
    list[i].SetCheckedInternal(false, false);
    if(raiseCheckedChanged)
     list[i].RaiseCheckedChanged();
   }
  }
 },
 ApplyCheckedStyle: function(){
  var stateController = ASPx.GetStateController();
  if(this.IsHovered()) 
   stateController.SetCurrentHoverElement(null);  
  stateController.SelectElementBySrcElement(this.GetMainElement());
 }, 
 ApplyUncheckedStyle: function(){
  var stateController = ASPx.GetStateController();
  if(this.IsHovered()) 
   stateController.SetCurrentHoverElement(null);
  stateController.DeselectElementBySrcElement(this.GetMainElement());
 },  
 SetCheckedInternal: function(checked, initialization){
  if(initialization && checked || (this.checked != checked)){
   this.checked = checked;
   if(checked)
    this.ApplyCheckedStyle();
   else
    this.ApplyUncheckedStyle();
  }
 },
 UpdateStateObject: function(){
  if(this.groupName != "")
   this.UpdateStateObjectWithObject({ checked: this.checked });
 },
 GetStateHiddenFieldName: function() {
  return this.uniqueID + "$State";
 },
 ApplyPressedStyle: function(){
  ASPx.GetStateController().OnMouseDownOnElement(this.GetMainElement());
 },
 ApplyUnpressedStyle: function(){ 
  ASPx.GetStateController().OnMouseUpOnElement(this.GetMainElement());
 },
 SetPressed: function(){
  this.pressed = true;
  this.ApplyPressedStyle();
 }, 
 SetUnpressed: function(){
  this.pressed = false;
  this.ApplyUnpressedStyle();
 },
 SetFocus: function(){
  if(!this.allowFocus || this.focused)
   return;
  var element = this.GetInternalButton();
  if(element) {
   var hiddenInternalButtonRequiresVisibilityToGetFocused = ASPx.Browser.WebKitFamily  && !this.isNative  && !this.IsLink();
   if(hiddenInternalButtonRequiresVisibilityToGetFocused)
    ASPxClientButton.MakeHiddenElementFocusable(element);
   if(ASPx.IsFocusable(element) && ASPx.GetActiveElement() != element)
    element.focus();
   if(hiddenInternalButtonRequiresVisibilityToGetFocused)
    ASPxClientButton.RestoreHiddenElementAppearance(element);
  }
 },
 ApplyFocusedStyle: function(){
  if(this.focusElementSelected) return;
  if(typeof(ASPx.GetStateController) != "undefined")
   ASPx.GetStateController().SelectElementBySrcElement(this.GetContentDiv());
  this.focusElementSelected = true;
 },
 ApplyUnfocusedStyle: function(){ 
  if(!this.focusElementSelected) return;
  if(typeof(ASPx.GetStateController) != "undefined")
   ASPx.GetStateController().DeselectElementBySrcElement(this.GetContentDiv());
  this.focusElementSelected = false;
 },
 UpdateFocusedStyle: function(){
  if(this.isNative || this.IsLink()) return;
  var isFocusable = this.enabled && this.allowFocus && this.focused && (this.clientEnabled || this.accessibilityCompliant);
  if(isFocusable)
   this.ApplyFocusedStyle();
  else
   this.ApplyUnfocusedStyle();
 },
 SendPostBack: function(postBackArg){
  if(!this.enabled || !this.clientEnabled)
   return;
  var arg = postBackArg || "";
  if(this.autoPostBackFunction)
   this.autoPostBackFunction(arg);
  else if(!this.useSubmitBehavior || this.IsLink())
   ASPxClientControl.prototype.SendPostBack.call(this, arg);
  if(this.useSubmitBehavior && !this.isNative) 
   this.ClickInternalButton();
 },
 ClickInternalButton: function(){
  var element = this.GetInternalButton();
  if(element) {
   this.clickLocked = true;
   if(ASPx.Browser.NetscapeFamily)
    this.CreateUniqueIDCarrier(); 
   var postHandler = ASPx.GetPostHandler();
   postHandler.SetLastSubmitElementName(element.name);
   ASPx.Evt.DoElementClick(element);
   postHandler.SetLastSubmitElementName(null);
   if(ASPx.Browser.NetscapeFamily)
    this.RemoveUniqueIDCarrier(); 
   this.clickLocked = false;
  }
 },
 CreateUniqueIDCarrier: function() {
  var name = this.uniqueID;
  var id = this.GetUniqueIDCarrierID();
  var field = ASPx.CreateHiddenField(name, id);
  var form = this.GetParentForm();
  if(form) form.appendChild(field);
 },
 RemoveUniqueIDCarrier: function() {
  var field = document.getElementById(this.GetUniqueIDCarrierID());
  if(field)
   field.parentNode.removeChild(field);
 },
 GetUniqueIDCarrierID: function() {
  return this.uniqueID + "_UIDC";
 },
 DoClick: function(){
  if(!this.enabled || !this.clientEnabled)
   return;
  var button = (this.isNative || this.IsLink()) ? this.GetMainElement() : this.GetInternalButton();
  if(button)
   ASPx.Evt.DoElementClick(button);
  else 
   this.OnClick();   
 },
 GetChecked: function(){
  return this.checked;
 },
 SetChecked: function(checked){
  this.SetCheckedInternal(checked, false);
  this.ClearButtonGroupChecked(false);
 },
 GetText: function(){
  if(!this.isTextEmpty)
   return this.isNative ? this.GetTextContainer().value : this.GetTextContainer().innerHTML;
  return "";
 },
 SetText: function(text){
  this.isTextEmpty = (text == null || text == "");
  var textContainer = this.GetTextContainer();
  if(textContainer){
   if(this.isNative)
    textContainer.value = (text != null) ? text : "";
   else {
    var value = this.isTextEmpty ? "&nbsp;" : text;
      textContainer.innerHTML = value;
    var element = this.GetInternalButton();
    if(element)
     element.value = value;
    if(this.clientVisible && ASPx.Browser.IE && ASPx.Browser.Version >= 9) 
     ASPx.SetElementDisplay(this.GetMainElement(), true);
   }
   this.UpdateSize();
  }
 },
 GetImageUrl: function(){
  var img = this.GetButtonImage();
  return img ?  img.src : "";
 },
 SetImageUrl: function(url){
  var img = this.GetButtonImage();
  if(img) {
   img.src = url;
   this.UpdateSize();
  }
 },
 SetEnabled: function(enabled){
  if(this.clientEnabled != enabled) {
   if(!enabled && this.focused)
    this.OnLostFocus();
   this.clientEnabled = enabled;
   this.SetEnabledInternal(enabled, false);
  }
 },
 GetEnabled: function(){
  return this.enabled && this.clientEnabled;
 },
 Focus: function(){
  this.SetFocus();
 },
 RaiseCheckedChanged: function(){
  var processOnServer = this.autoPostBack || this.IsServerEventAssigned("CheckedChanged");
  if(!this.CheckedChanged.IsEmpty()){
   var args = new ASPxClientProcessingModeEventArgs(processOnServer);
   this.CheckedChanged.FireEvent(this, args);
   processOnServer = args.processOnServer;
  }
  return processOnServer;
 },
 RaiseFocus: function(){
  if(!this.GotFocus.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.GotFocus.FireEvent(this, args);
  }
 },
 RaiseLostFocus: function(){
  if(!this.LostFocus.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.LostFocus.FireEvent(this, args);
  }
 },
 RaiseClick: function() {
  var processOnServer = this.autoPostBack || this.IsServerEventAssigned("Click");
  var cancelEventAndBubble = false;
  if(!this.Click.IsEmpty()) {
   var args = new ASPxClientButtonClickEventArgs(processOnServer, cancelEventAndBubble);
   this.Click.FireEvent(this, args);
   cancelEventAndBubble = args.cancelEventAndBubble;
   processOnServer = args.processOnServer;
  }
  return {
   processOnServer: processOnServer,
   cancelEventAndBubble: cancelEventAndBubble
  };
 }
});
ASPxClientButton.Cast = ASPxClientControl.Cast;
var ASPxClientButtonClickEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(processOnServer, cancelEventAndBubble) {
  this.constructor.prototype.constructor.call(this, processOnServer);
  this.cancelEventAndBubble = cancelEventAndBubble;
 }
});
ASPxClientButton.MakeHiddenElementFocusable = function(element) {
 element.__dxHiddenElementState = {
  parentDisplay: element.parentNode.style.display,
  height: element.style.height,
  width: element.style.width
 };
 element.parentNode.style.display = "block";
 element.style.height = "1px";
 element.style.width = "1px";
};
ASPxClientButton.RestoreHiddenElementAppearance = function(element) {
 var state = element.__dxHiddenElementState;
 element.parentNode.style.display = state.parentDisplay;
 element.style.height = state.height;
 element.style.width = state.width;
 delete element.__dxHiddenElementState;
};
ASPx.Ident.IsASPxClientButton = function(obj) {
 return !!obj.isASPxClientButton;
};
function _aspxBCallButtonMethod(name, methodName, arg) {
 var button = ASPx.GetControlCollection().Get(name); 
 if(button != null)
  button[methodName](arg);
}
ASPx.BClick = function(name, evt) {
 var button = ASPx.GetControlCollection().Get(name); 
 if(button != null)
  return button.OnClick(evt);
};
window.ASPxClientButton = ASPxClientButton;
})();

(function(dx) {
 var BootstrapClientButton = ASPx.CreateClass(ASPxClientButton, {
  constructor: function(name) {
   this.constructor.prototype.constructor.call(this, name);
  },
  InitializeNativeHandlers: function() { },
  InitializeElementIDs: function() { },
  InitializeLink: function() { },
  UpdateSize: function() { },
  UpdateHeight: function() { },
  UpdateWidth: function() { },
  AdjustControlCore: function() { },
  ApplyCheckedStyle: function() {
   var btn = this.GetInternalButton();
   ASPx.AddClassNameToElement(btn, "active");
   ASPx.Attr.SetAttribute(btn, "aria-pressed", true);
  },
  ApplyUncheckedStyle: function() {
   var btn = this.GetInternalButton();
   ASPx.RemoveClassNameFromElement(btn, "active");
   ASPx.Attr.SetAttribute(btn, "aria-pressed", false);
  },
  ApplyPressedStyle: function() { },
  ApplyUnpressedStyle: function() { },
  ApplyFocusedStyle: function() { },
  ApplyUnfocusedStyle: function() { },
  ChangeEnabledStateItems: function(enabled) { },
  SetFocus: function () {
   if (!this.allowFocus || this.focused)
    return;
   this.focused = true;
   var element = this.GetInternalButton();
   if (element) {      
    if (ASPx.IsFocusable(element) && ASPx.GetActiveElement() != element)
     element.focus();
   }
  },
  ClickInternalButton: function() { },
  GetContentDiv: function() {
   return null;
  },
  GetInternalButton: function() {
   return this.GetMainElement();
  },
  GetButtonImage: function() {
   return null;
  },
  GetTextContainer: function() {
   var buttonElement = this.GetMainElement();
   var textNode = ASPx.GetNormalizedTextNode(buttonElement);
   return textNode ? textNode.parentNode : buttonElement;
  },
  GetTextControl: function() {
   return null;
  },
  GetBadgeControl: function() {
   return ASPx.BootstrapBadgeManager.findBadge(this.GetMainElement());
  },
  RequiredPreventDoublePostback: function() {
   return false;
  },
  GetText: function() {
   if(!this.isTextEmpty)
    return this.GetMainElement().value;
   return "";
  },
  SetText: function(text) {
   var buttonText = this.HtmlEncode(text);
   var buttonElement = this.GetMainElement();
   buttonElement.value = (buttonText != null) ? buttonText : "";
   var textNode = ASPx.GetNormalizedTextNode(buttonElement);
   if(textNode && textNode.parentNode == buttonElement)
    textNode.nodeValue = buttonText;
   else {
    textNode = document.createTextNode(buttonText);
    var badgeControl = this.GetBadgeControl();
    if(badgeControl)
     buttonElement.insertBefore(textNode, badgeControl);
    else
     buttonElement.appendChild(textNode);
   }
  },
  GetBadgeText: function() {
   return ASPx.BootstrapBadgeManager.getBadgeText(this.GetMainElement());
  },
  SetBadgeText: function(text) {
   var badgeText = this.HtmlEncode(text);
   var badgeControl = this.GetBadgeControl();
   if(badgeControl)
    ASPx.BootstrapBadgeManager.setBadgeText(badgeControl, badgeText);
   else
    this.GetMainElement().appendChild(ASPx.BootstrapBadgeManager.createBadge(badgeText));
  },
  GetBadgeIconCssClass: function() {
   return ASPx.BootstrapBadgeManager.getBadgeIconCssClass(this.GetMainElement());
  },
  SetBadgeIconCssClass: function(cssClass) {
   var badgeControl = this.GetBadgeControl();
   if(badgeControl)
    ASPx.BootstrapBadgeManager.setBadgeIconCssClass(badgeControl, cssClass);
   else
    this.GetMainElement().appendChild(ASPx.BootstrapBadgeManager.createBadge("", cssClass));
  }
 });
 dx.BootstrapClientButton = BootstrapClientButton;
})(dx || (dx = {}));
(function(dx) {
 var BootstrapClientCallbackPanel = ASPx.CreateClass(ASPxClientControl, {
  constructor: function(name) {
   this.constructor.prototype.constructor.call(this, name);
   this.hideContentOnCallback = true;
   this.isLoadingPanelTextEmpty = false;
   this.touchUIScroller = null;
  },
  Initialize: function(){
   ASPxClientControl.prototype.Initialize.call(this);
   this.touchUIScroller = ASPx.TouchUIHelper.makeScrollableIfRequired(this.GetMainElement());
  },
  OnCallback: function(result) {
   ASPx.Security.setInnerHtml(this.getContentElement(), result, ASPx.Security.DataType.Trusted);
   if(this.touchUIScroller)
    this.touchUIScroller.ChangeElement(this.getContentElement());
  },
  ShowLoadingPanel: function() {
   var element = this.getContentElement();
   var mainElement = (element.tagName == "TD") ? this.GetMainElement() : element;
   if(!this.hideContentOnCallback)
    this.CreateLoadingPanelWithAbsolutePosition(this.GetMainElement().parentNode, mainElement);
   else
    this.CreateLoadingPanelInsideContainer(element, true, true, false);
  },
  ShowLoadingDiv: function() {
   this.CreateLoadingDiv(this.GetMainElement().parentNode, this.getContentElement());
  },
  GetCallbackAnimationElement: function() {
   return this.getContentElement();
  },
  PerformCallback: function(parameter, onSuccess) {
   this.CreateCallback(parameter, null, null, onSuccess);
  },
  CreateCallback: function(arg, command, callbackInfo, handler) {
   this.ShowLoadingElements();
   ASPxClientControl.prototype.CreateCallback.call(this, arg, command, handler);
  },
  GetLoadingPanelElement: function() {
   return ASPx.BootstrapLoadingPanelManager.getLoadingPanel(this.name, this.loadingPanel);
  },
  GetLoadingDiv: function() {
   return ASPx.BootstrapLoadingPanelManager.getLoadingDiv(this.name, this.loadingPanel);
  },
  GetContentHtml: function(){
   return this.getContentElement().innerHTML;
  },
  SetContentHtml: function(html, useAnimation) {
   ASPx.Security.setInnerHtml(this.getContentElement(), html, ASPx.Security.DataType.Trusted);
   if(this.touchUIScroller)
    this.touchUIScroller.ChangeElement(this.getContentElement());
   if(useAnimation && typeof (ASPx.AnimationHelper) != "undefined")
    ASPx.AnimationHelper.fadeIn(this.getContentElement());
  },
  getContentElement: function() {
   return this.GetMainElement();
  }
 });
 dx.BootstrapClientCallbackPanel = BootstrapClientCallbackPanel;
})(dx || (dx = {}));
(function () {
var ASPxClientHiddenField = ASPx.CreateClass(ASPxClientControl, {
 constructor: function (name) {
  this.constructor.prototype.constructor.call(this, name);
  this.syncWithServer = true;
  this.properties = {};
  this.typeInfoTable = {};
  this.typeNameTable = [];
 },
 IsDOMDisposed: function() { 
  return this.syncWithServer ? !ASPx.IsExistsElement(this.GetStateHiddenField()) : false;
 },
 UpdateStateObject: function () {
  if(!this.syncWithServer) 
   return;
  var serializedData = ASPx.GetHiddenFieldSerializer().Serialize(this);
  this.UpdateStateObjectWithObject({ data: serializedData });
 },
 GetStateHiddenField: function() {
  return ASPx.GetElementById(this.uniqueID);
 },
 EscapeSpecialCharacters: function (str) {
  str = str.replace(/\\/g, "\\\\");
  var specialChars = {};
  for(var i = 0; i < str.length; i++) {
   var char = str.charAt(i);
   var charCode = char.charCodeAt(0);
   if(charCode < 32) {
    var hexCharCode = charCode.toString(16);
    specialChars[char] = "\\u" + "0000".substr(0, 4 - hexCharCode.length) + hexCharCode;
   }
  }
  for(var ch in specialChars)
   if(specialChars.hasOwnProperty(ch))
    str = str.replace(new RegExp(ch, "g"), specialChars[ch]);
  return str;
 },
 PerformCallback: function (parameter) {
  this.CreateCallback(parameter);
 },
 OnCallback: function (result) {
  var callbackMarkupContainer = this.GetCallbackMarkupContainer();
  ASPx.SetInnerHtml(callbackMarkupContainer, result);
 },
 GetCallbackMarkupContainer: function () {
  var callbackMarkupContainer = ASPx.GetElementById(this.GetCallbackMarkupContainerID());
  if(!callbackMarkupContainer) {
   callbackMarkupContainer = this.CreateCallbackMarkupContainer();
   document.body.appendChild(callbackMarkupContainer);
  }
  return callbackMarkupContainer;
 },
 GetCallbackMarkupContainerID: function () {
  return this.name + ASPxClientHiddenField.CallbackMarkupContainerIDSuffix;
 },
 CreateCallbackMarkupContainer: function () {
  var callbackMarkupContainer = document.createElement("DIV");
  ASPx.SetElementDisplay(callbackMarkupContainer, false);
  callbackMarkupContainer.id = this.GetCallbackMarkupContainerID();
  return callbackMarkupContainer;
 },
 Add: function (propertyName, propertyValue) {
  var existentPropertyValue = this.Get(propertyName);
  if(typeof (existentPropertyValue) == "undefined")
   this.Set(propertyName, propertyValue);
  else
   ASPx.ShowErrorAlert("A property with the name '" + propertyName + "' has already been added.");
 },
 Get: function (propertyName) {
  var safeName = this.GetTopLevelPropertySafeName(propertyName);
  return this.properties[safeName];
 },
 Set: function (propertyName, propertyValue) {
  ASPxClientHiddenField.AssertKeyIsValid(propertyName);
  var safeName = this.GetTopLevelPropertySafeName(propertyName);
  if(typeof (propertyValue) == "undefined")
   this.Remove(propertyName);
  else
   this.properties[safeName] = propertyValue;
 },
 Remove: function (propertyName) {
  var safeName = this.GetTopLevelPropertySafeName(propertyName);
  delete this.properties[safeName];
  TypeInfoHelper.RemoveTypeInfoBranch(this.typeInfoTable, safeName);
 },
 Clear: function () {
  this.properties = {};
  this.typeInfoTable = {};
  this.typeNameTable = [];
 },
 Contains: function (propertyName) {
  var safeTopLevelPropertyName = this.GetTopLevelPropertySafeName(propertyName);
  for(var key in this.properties) {
   if(key == safeTopLevelPropertyName)
    return true;
  }
  return false;
 },
 GetTopLevelPropertySafeName: function (propertyName) {
  return ASPxClientHiddenField.TopLevelKeyPrefix + propertyName;
 }
});
ASPxClientHiddenField.AssertKeyIsValid = function(key) {
 if(!key)
  ASPx.ShowErrorAlert("HiddenField: It is not allowed to insert values with empty property names");
};
ASPxClientHiddenField.Cast = ASPxClientControl.Cast;
ASPxClientHiddenField.InputElementIDSuffix = "_I";
ASPxClientHiddenField.CallbackMarkupContainerIDSuffix = "_D";
ASPxClientHiddenField.TopLevelKeyPrefix = "dxp";
var TypeInfoHelper = ASPx.CreateClass(null, {
 constructor: function () {
  this.minUnknownTypeIndex = 1024;
  this.clientTypeConstructors = [
   null,
   Number,
   String,
   Date,
   Boolean,
   RegExp,
   Array,
   Object,
   Function
  ];
  this.clientTypeConstructorIndices = {};
  for(var i = 1; i < this.clientTypeConstructors.length; i++)
   this.clientTypeConstructorIndices[this.clientTypeConstructors[i]] = i;
 },
 EnsureTypeInfoTableCompliant: function (value, typeInfoTable, typeInfoKey) {
  if(typeInfoKey == "")
   return;
  var typeCode = typeInfoTable[typeInfoKey];
  if(typeof (typeCode) == "undefined")
   typeCode = this.GetArrayItemTypeCode(typeInfoTable, typeInfoKey);
  if(typeof (typeCode) != "undefined") {
   if(!this.IsValueTypeInfoCompliant(value, typeCode))
    TypeInfoHelper.RemoveTypeInfoBranch(typeInfoTable, typeInfoKey);
   else
    return;
  }
  typeCode = this.CreateTypeCode(value);
  if(typeof (typeCode) != "undefined")
   typeInfoTable[typeInfoKey] = typeCode;
  else
   delete typeInfoTable[typeInfoKey];
 },
 GetArrayItemTypeCode: function (typeInfoTable, typeInfoKey) {
  var separator = "|";
  var index = typeInfoKey.lastIndexOf(separator);
  if(index < 0)
   return;
  itemTypeKey = typeInfoKey.substr(0, index) + "_itemType";
  var typeCode = typeInfoTable[itemTypeKey];
  if(typeof (typeCode) != "undefined")
   typeInfoTable[typeInfoKey] = typeCode;
  return typeCode;
 },
 IsAtomValue: function (value, typeCode) {
  return typeCode == 0 || !(this.IsListValue(value, typeCode) || this.IsDictionaryValue(value, typeCode));
 },
 IsListValue: function (value, typeCode) {
  return this.IsKnownTypeCode(typeCode) ? this.GetConstructor(typeCode) === Array : value.constructor === Array;
 },
 IsDictionaryValue: function (value, typeCode) {
  return this.IsKnownTypeCode(typeCode) ? this.GetConstructor(typeCode) === Object : value.constructor === Object;
 },
 GetArrayTypeCode: function () {
  return this.clientTypeConstructorIndices[Array] << 1;
 },
 GetStringTypeCode: function () {
  return this.clientTypeConstructorIndices[String] << 1;
 },
 IsStringTypeCode: function (typeCode) {
  return typeCode == this.GetStringTypeCode();
 },
 IsValueTypeInfoCompliant: function (value, typeCode) {
  if(this.IsKnownTypeCode(typeCode))
   return value != null ? value.constructor === this.GetConstructor(typeCode) : this.IsNullable(typeCode);
  else
   return value == null || value.constructor === Array || value.constructor === Object;
 },
 CreateTypeCode: function (value) {
  if(value == null)
   return 1; 
  var clientTypeIndex = this.clientTypeConstructorIndices[value.constructor];
  var lowerBit = Number(
   clientTypeIndex == this.clientTypeConstructorIndices[RegExp] ||
   clientTypeIndex == this.clientTypeConstructorIndices[Array] ||
   clientTypeIndex == this.clientTypeConstructorIndices[Object]
  );
  return typeof (clientTypeIndex) != "undefined" ? ((clientTypeIndex << 1) + lowerBit) : void (0);
 },
 IsNullable: function (typeCode) {
  return (typeCode & 1) > 0;
 },
 GetConstructor: function (typeCode) {
  return this.clientTypeConstructors[(typeCode >>> 1) & 7];
 },
 IsKnownTypeCode: function (typeCode) {
  return typeCode < this.minUnknownTypeIndex;
 }
});
TypeInfoHelper.RemoveTypeInfoBranch = function (typeInfoTable, typeInfoKeyPrefix) {
 for(var key in typeInfoTable) {
  if(key.indexOf(typeInfoKeyPrefix) == 0)
   delete typeInfoTable[key];
 }
};
var HiddenFieldSerializer = ASPx.CreateClass(null, {
 constructor: function () {
  this.typeInfoHelper = new TypeInfoHelper();
  this.separator = "|";
  this.sentinel = "#";
  this.charCodes = this.CreateCharCodeList(["a", "z", "0", "9", "_", "$"]);
 },
 Serialize: function (hiddenField) {
  var sb = [];
  this.SerializeCore(hiddenField.typeNameTable, "", sb, null, null, null, false);
  this.SerializeCore(hiddenField.properties, "", sb, hiddenField.typeInfoTable, hiddenField.typeNameTable, ASPxClientHiddenField.TopLevelKeyPrefix, true);
  return sb.join("");
 },
 SerializeCore: function (value, pathInPropertiesTree, serializedData, typeInfoTable, typeNameTable, keyNamePrefix, validateKeys) {
  var metaTablesDefined = typeInfoTable != null && typeNameTable != null;
  var typeCode = null;
  if(metaTablesDefined) {
   this.typeInfoHelper.EnsureTypeInfoTableCompliant(value, typeInfoTable, pathInPropertiesTree);
   typeCode = typeInfoTable[pathInPropertiesTree];
  } else {
   typeCode = value.constructor === Array ?
    this.typeInfoHelper.GetArrayTypeCode() : this.typeInfoHelper.GetStringTypeCode();
  }
  if(typeof (typeCode) != "undefined")
   serializedData.push(typeCode);
  serializedData.push(this.separator);
  if(typeof (typeCode) == "undefined" || this.typeInfoHelper.IsDictionaryValue(value, typeCode)) {
   for(var key in value) {
    if(value.hasOwnProperty(key)) {
     var serializableKey = key;
     if(keyNamePrefix.length > 0)
      serializableKey = serializableKey.slice(keyNamePrefix.length);
     if(validateKeys)
      ASPxClientHiddenField.AssertKeyIsValid(serializableKey);
     serializedData.push(serializableKey);
     serializedData.push(this.separator);
     this.SerializeCore(value[key], pathInPropertiesTree.length > 0 ? (pathInPropertiesTree + this.separator + key) : key,
      serializedData, typeInfoTable, typeNameTable, "", validateKeys);
    }
   }
   serializedData.push(this.sentinel);
  } else if(this.typeInfoHelper.IsListValue(value, typeCode)) {
   for(var i = 0; i < value.length; i++)
    this.SerializeCore(value[i], pathInPropertiesTree.length > 0 ? (pathInPropertiesTree + this.separator + i) : i,
     serializedData, typeInfoTable, typeNameTable, "", validateKeys);
   serializedData.push(this.sentinel);
  } else if(this.typeInfoHelper.IsAtomValue(value, typeCode))
   this.SerializeAtomValue(value, serializedData, typeCode);
 },
 SerializeAtomValue: function (value, sb, typeCode) {
  var valueStr = this.SerializeAtomValueCore(value, typeCode);
  sb.push(valueStr.length.toString());
  sb.push(this.separator);
  sb.push(valueStr);
 },
 SerializeAtomValueCore: function (value, typeCode) {
  var isString = this.typeInfoHelper.IsStringTypeCode(typeCode);
  if(value == null)
   return isString ? "0" : "";
  else {
   if(isString) {
    return "1" + value.replace(/\r/g, ""); 
   } else {
    var ctor = value.constructor;
    if(ctor === String )
     return value;
    else if(ctor === Boolean)
     return value ? "1" : "0";
    else if(ctor === Number)
     return value.toString();
    else if(ctor === Date)
     return String(ASPx.DateUtils.ToLocalTime(value).valueOf());
    else if(ctor === RegExp) {
     var options = "";
     if(value.ignoreCase)
      options += "i";
     if(value.multiline)
      options += "m";
     return options + "," + value.source;
    }
   }
  }
  ASPx.ShowErrorAlert("Unable to serialize value " + value.toString() + " (Constructor: " + value.constructor.toString() + ").");
 },
 CreateCharCodeList: function (chars) {
  var charCodes = {};
  for(var i = 0; i < chars.length; i++) {
   var ch = chars[i];
   charCodes[ch] = ch.charCodeAt(0);
  }
  return charCodes;
 },
 IsLowercaseLetterCharCode: function (charCode) {
  return charCode >= this.charCodes["a"] && charCode <= this.charCodes["z"];
 }
});
var hiddenFieldSerializer;
ASPx.GetHiddenFieldSerializer = function() {
 if(!hiddenFieldSerializer)
  hiddenFieldSerializer = new HiddenFieldSerializer();
 return hiddenFieldSerializer;
};
ASPx.TypeInfoHelper = TypeInfoHelper;
window.ASPxClientHiddenField = ASPxClientHiddenField;
})();

},1);
